/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/base/common/path","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(ne){for(var e=[],a=0,A=ne.length;a<A;a++)e[a]=ye[ne[a]];return e};define(ye[61],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(D,P){const E=Object.create(null);for(const k of D){const L=P(k);let T=E[L];T||(T=E[L]=[]),T.push(k)}return E}e.groupBy=a;function A(D,P){const E=[],k=[];for(const L of D)P.has(L)||E.push(L);for(const L of P)D.has(L)||k.push(L);return{removed:E,added:k}}e.diffSets=A;function l(D,P){const E=[],k=[];for(const[L,T]of D)P.has(L)||E.push(T);for(const[L,T]of P)D.has(L)||k.push(T);return{removed:E,added:k}}e.diffMaps=l;class R{constructor(){this.a=new Map}add(P,E){let k=this.a.get(P);k||(k=new Set,this.a.set(P,k)),k.add(E)}delete(P,E){const k=this.a.get(P);!k||(k.delete(E),k.size===0&&this.a.delete(P))}forEach(P,E){const k=this.a.get(P);!k||k.forEach(E)}}e.SetMap=R}),define(ye[62],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(D){return(P,E,k)=>{let L=null,T=null;if(typeof k.value=="function"?(L="value",T=k.value):typeof k.get=="function"&&(L="get",T=k.get),!T)throw new Error("not supported");k[L]=D(T,E)}}function A(D,P,E){let k=null,L=null;if(typeof E.value=="function"?(k="value",L=E.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",L=E.get),!L)throw new Error("not supported");const T=`$memoize$${P}`;E[k]=function(...v){return this.hasOwnProperty(T)||Object.defineProperty(this,T,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[T]}}e.memoize=A;function l(D,P,E){return a((k,L)=>{const T=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...I){this[v]||(this[v]=E?E():void 0),clearTimeout(this[T]),P&&(this[v]=P(this[v],...I),I=[this[v]]),this[T]=setTimeout(()=>{k.apply(this,I),this[v]=E?E():void 0},D)}})}e.debounce=l;function R(D,P,E){return a((k,L)=>{const T=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,I=`$throttle$lastRun$${L}`,y=`$throttle$pending$${L}`;return function(...f){if(this[v]||(this[v]=E?E():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...f)),this[y])return;const h=this[I]+D;h<=Date.now()?(this[I]=Date.now(),k.apply(this,[this[v]]),this[v]=E?E():void 0):(this[y]=!0,this[T]=setTimeout(()=>{this[y]=!1,this[I]=Date.now(),k.apply(this,[this[v]]),this[v]=E?E():void 0},h-Date.now()))}})}e.throttle=R}),define(ye[11],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?C.isErrorNoTelemetry(o)?new C(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.ErrorHandler=a,e.errorHandler=new a;function A(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=A;function l(i){if(!i||typeof i!="object")return!1;const o=i;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(i){k(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=R;function D(i){k(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=D;function P(i){if(i instanceof Error){const{name:o,message:s}=i,c=i.stacktrace||i.stack;return{$isError:!0,name:o,message:s,stack:c,noTelemetry:C.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=P;const E="Canceled";function k(i){return i instanceof L?!0:i instanceof Error&&i.name===E&&i.message===E}e.isCancellationError=k;class L extends Error{constructor(){super(E),this.name=this.message}}e.CancellationError=L;function T(){const i=new Error(E);return i.name=i.message,i}e.canceled=T;function v(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=v;function I(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=I;function y(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function f(i){const o=new Error(`${i} has been disposed`);return o.name="DISPOSED",o}e.disposed=f;function h(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=h;class d extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.NotImplementedError=d;class g extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.NotSupportedError=g;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class C extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof C)return o;const s=new C;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class p extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[15],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(oe,ae=0){return oe[oe.length-(1+ae)]}e.tail=A;function l(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=l;function R(oe,ae,fe=(ee,ue)=>ee===ue){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let ee=0,ue=oe.length;ee<ue;ee++)if(!fe(oe[ee],ae[ee]))return!1;return!0}e.equals=R;function D(oe,ae){const fe=oe.length-1;ae<fe&&(oe[ae]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=D;function P(oe,ae,fe){return E(oe.length,ee=>fe(oe[ee],ae))}e.binarySearch=P;function E(oe,ae){let fe=0,ee=oe-1;for(;fe<=ee;){const ue=(fe+ee)/2|0,se=ae(ue);if(se<0)fe=ue+1;else if(se>0)ee=ue-1;else return ue}return-(fe+1)}e.binarySearch2=E;function k(oe,ae){let fe=0,ee=oe.length;if(ee===0)return 0;for(;fe<ee;){const ue=Math.floor((fe+ee)/2);ae(oe[ue])?ee=ue:fe=ue+1}return fe}e.findFirstInSorted=k;function L(oe,ae,fe){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const ee=ae[Math.floor(ae.length*Math.random())],ue=[],se=[],N=[];for(const W of ae){const K=fe(W,ee);K<0?ue.push(W):K>0?se.push(W):N.push(W)}return oe<ue.length?L(oe,ue,fe):oe<ue.length+N.length?N[0]:L(oe-(ue.length+N.length),se,fe)}e.quickSelect=L;function T(oe,ae){const fe=[];let ee;for(const ue of oe.slice(0).sort(ae))!ee||ae(ee[0],ue)!==0?(ee=[ue],fe.push(ee)):ee.push(ue);return fe}e.groupBy=T;function v(oe,ae,fe){const ee=[];function ue(W,K,Y){if(K===0&&Y.length===0)return;const he=ee[ee.length-1];he&&he.start+he.deleteCount===W?(he.deleteCount+=K,he.toInsert.push(...Y)):ee.push({start:W,deleteCount:K,toInsert:Y})}let se=0,N=0;for(;;){if(se===oe.length){ue(se,0,ae.slice(N));break}if(N===ae.length){ue(se,oe.length-se,[]);break}const W=oe[se],K=ae[N],Y=fe(W,K);Y===0?(se+=1,N+=1):Y<0?(ue(se,1,[]),se+=1):Y>0&&(ue(se,0,[K]),N+=1)}return ee}e.sortedDiff=v;function I(oe,ae,fe){const ee=v(oe,ae,fe),ue=[],se=[];for(const N of ee)ue.push(...oe.slice(N.start,N.start+N.deleteCount)),se.push(...N.toInsert);return{removed:ue,added:se}}e.delta=I;function y(oe,ae,fe){if(fe===0)return[];const ee=oe.slice(0,fe).sort(ae);return h(oe,ae,ee,fe,oe.length),ee}e.top=y;function f(oe,ae,fe,ee,ue){return fe===0?Promise.resolve([]):new Promise((se,N)=>{(async()=>{const W=oe.length,K=oe.slice(0,fe).sort(ae);for(let Y=fe,he=Math.min(fe+ee,W);Y<W;Y=he,he=Math.min(he+ee,W)){if(Y>fe&&await new Promise(we=>setTimeout(we)),ue&&ue.isCancellationRequested)throw new a.CancellationError;h(oe,ae,K,Y,he)}return K})().then(se,N)})}e.topAsync=f;function h(oe,ae,fe,ee,ue){for(const se=fe.length;ee<ue;ee++){const N=oe[ee];if(ae(N,fe[se-1])<0){fe.pop();const W=k(fe,K=>ae(N,K)<0);fe.splice(W,0,N)}}}function d(oe){return oe.filter(ae=>!!ae)}e.coalesce=d;function g(oe){let ae=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ae]=oe[fe],ae+=1);oe.length=ae}e.coalesceInPlace=g;function b(oe,ae,fe){oe.splice(fe,0,oe.splice(ae,1)[0])}e.move=b;function C(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=C;function p(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=p;function i(oe,ae=fe=>fe){const fe=new Set;return oe.filter(ee=>{const ue=ae(ee);return fe.has(ue)?!1:(fe.add(ue),!0)})}e.distinct=i;function o(oe){const ae=new Set;return fe=>{const ee=oe(fe);return ae.has(ee)?!1:(ae.add(ee),!0)}}e.uniqueFilter=o;function s(oe,ae){const fe=c(oe,ae);if(fe!==-1)return oe[fe]}e.findLast=s;function c(oe,ae){for(let fe=oe.length-1;fe>=0;fe--){const ee=oe[fe];if(ae(ee))return fe}return-1}e.lastIndex=c;function r(oe,ae){return oe.length>0?oe[0]:ae}e.firstOrDefault=r;function m(oe,ae){return oe.length>0?oe[oe.length-1]:ae}e.lastOrDefault=m;function n(oe,ae,fe=(ee,ue)=>ee===ue){let ee=0;for(let ue=0,se=Math.min(oe.length,ae.length);ue<se&&fe(oe[ue],ae[ue]);ue++)ee++;return ee}e.commonPrefixLength=n;function t(oe){return[].concat(...oe)}e.flatten=t;function u(oe,ae){let fe=typeof ae=="number"?oe:0;typeof ae=="number"?fe=oe:(fe=0,ae=oe);const ee=[];if(fe<=ae)for(let ue=fe;ue<ae;ue++)ee.push(ue);else for(let ue=fe;ue>ae;ue--)ee.push(ue);return ee}e.range=u;function w(oe,ae,fe){return oe.reduce((ee,ue)=>(ee[ae(ue)]=fe?fe(ue):ue,ee),Object.create(null))}e.index=w;function S(oe,ae){return oe.push(ae),()=>F(oe,ae)}e.insert=S;function F(oe,ae){const fe=oe.indexOf(ae);if(fe>-1)return oe.splice(fe,1),ae}e.remove=F;function x(oe,ae,fe){const ee=oe.slice(0,ae),ue=oe.slice(ae);return ee.concat(fe,ue)}e.arrayInsert=x;function V(oe,ae){let fe;if(typeof ae=="number"){let ee=ae;fe=()=>{const ue=Math.sin(ee++)*179426549;return ue-Math.floor(ue)}}else fe=Math.random;for(let ee=oe.length-1;ee>0;ee-=1){const ue=Math.floor(fe()*(ee+1)),se=oe[ee];oe[ee]=oe[ue],oe[ue]=se}}e.shuffle=V;function M(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.unshift(ae))}e.pushToStart=M;function B(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.push(ae))}e.pushToEnd=B;function O(oe,ae){for(const fe of ae)oe.push(fe)}e.pushMany=O;function U(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}e.mapArrayOrNot=U;function $(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=$;function j(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=j;function le(oe,ae){for(const fe of oe){const ee=ae(fe);if(ee!==void 0)return ee}}e.mapFind=le;function J(oe,ae,fe){const ee=Q(oe,ae),ue=oe.length,se=fe.length;oe.length=ue+se;for(let N=ue-1;N>=ee;N--)oe[N+se]=oe[N];for(let N=0;N<se;N++)oe[N+ee]=fe[N]}e.insertInto=J;function q(oe,ae,fe,ee){const ue=Q(oe,ae),se=oe.splice(ue,fe);return J(oe,ue,ee),se}e.splice=q;function Q(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var Z;(function(oe){function ae(ue){return ue<0}oe.isLessThan=ae;function fe(ue){return ue>0}oe.isGreaterThan=fe;function ee(ue){return ue===0}oe.isNeitherLessOrGreaterThan=ee,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function te(oe,ae){return(fe,ee)=>ae(oe(fe),oe(ee))}e.compareBy=te;function X(...oe){return(ae,fe)=>{for(const ee of oe){const ue=ee(ae,fe);if(!Z.isNeitherLessOrGreaterThan(ue))return ue}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const _=(oe,ae)=>oe-ae;e.numberComparator=_;function ie(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const ue=oe[ee];ae(ue,fe)>0&&(fe=ue)}return fe}e.findMaxBy=ie;function pe(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const ue=oe[ee];ae(ue,fe)>=0&&(fe=ue)}return fe}e.findLastMaxBy=pe;function ve(oe,ae){return ie(oe,(fe,ee)=>-ae(fe,ee))}e.findMinBy=ve;class ke{constructor(ae){this.f=ae,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let fe=this.c;for(;fe<this.f.length&&ae(this.f[fe]);)fe++;const ee=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,ee}takeFromEndWhile(ae){let fe=this.d;for(;fe>=0&&ae(this.f[fe]);)fe--;const ee=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ae=this.f[this.c];return this.c++,ae}removeLast(){const ae=this.f[this.d];return this.d--,ae}takeCount(ae){const fe=this.f.slice(this.c,this.c+ae);return this.c+=ae,fe}}e.ArrayQueue=ke;class Oe{constructor(ae){this.iterate=ae}forEach(ae){this.iterate(fe=>(ae(fe),!0))}toArray(){const ae=[];return this.iterate(fe=>(ae.push(fe),!0)),ae}filter(ae){return new Oe(fe=>this.iterate(ee=>ae(ee)?fe(ee):!0))}map(ae){return new Oe(fe=>this.iterate(ee=>fe(ae(ee))))}some(ae){let fe=!1;return this.iterate(ee=>(fe=ae(ee),!fe)),fe}findFirst(ae){let fe;return this.iterate(ee=>ae(ee)?(fe=ee,!1):!0),fe}findLast(ae){let fe;return this.iterate(ee=>(ae(ee)&&(fe=ee),!0)),fe}findLastMaxBy(ae){let fe,ee=!0;return this.iterate(ue=>((ee||Z.isGreaterThan(ae(ue,fe)))&&(ee=!1,fe=ue),!0)),fe}}Oe.empty=new Oe(oe=>{}),e.CallbackIterable=Oe}),define(ye[50],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(E,k){if(!E)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=A;function l(E,k="Unreachable"){throw new Error(k)}e.assertNever=l;function R(E){if(!E)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function D(E){if(!E()){debugger;E(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function P(E,k){let L=0;for(;L<E.length-1;){const T=E[L],v=E[L+1];if(!k(T,v))return!1;L++}return!0}e.checkAdjacentItems=P}),define(ye[63],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(A){const l=this;let R=!1,D;return function(){return R||(R=!0,D=A.apply(l,arguments)),D}}e.once=a}),define(ye[101],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[64],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(A){function l(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}A.is=l;const R=Object.freeze([]);function D(){return R}A.empty=D;function*P(C){yield C}A.single=P;function E(C){return l(C)?C:P(C)}A.wrap=E;function k(C){return C||R}A.from=k;function L(C){return!C||C[Symbol.iterator]().next().done===!0}A.isEmpty=L;function T(C){return C[Symbol.iterator]().next().value}A.first=T;function v(C,p){for(const i of C)if(p(i))return!0;return!1}A.some=v;function I(C,p){for(const i of C)if(p(i))return i}A.find=I;function*y(C,p){for(const i of C)p(i)&&(yield i)}A.filter=y;function*f(C,p){let i=0;for(const o of C)yield p(o,i++)}A.map=f;function*h(...C){for(const p of C)for(const i of p)yield i}A.concat=h;function d(C,p,i){let o=i;for(const s of C)o=p(o,s);return o}A.reduce=d;function*g(C,p,i=C.length){for(p<0&&(p+=C.length),i<0?i+=C.length:i>C.length&&(i=C.length);p<i;p++)yield C[p]}A.slice=g;function b(C,p=Number.POSITIVE_INFINITY){const i=[];if(p===0)return[i,C];const o=C[Symbol.iterator]();for(let s=0;s<p;s++){const c=o.next();if(c.done)return[i,A.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return o}}]}A.consume=b})(a=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,o=!1){let s=0;const c=i.length;let r="",m=0,n=16,t=0;function u(B){let O=0,U=0;for(;O<B;){const $=i.charCodeAt(s);if($>=48&&$<=57)U=U*16+$-48;else if($>=65&&$<=70)U=U*16+$-65+10;else if($>=97&&$<=102)U=U*16+$-97+10;else break;s++,O++}return O<B&&(U=-1),U}function w(B){s=B,r="",m=0,n=16,t=0}function S(){const B=s;if(i.charCodeAt(s)===48)s++;else for(s++;s<i.length&&k(i.charCodeAt(s));)s++;if(s<i.length&&i.charCodeAt(s)===46)if(s++,s<i.length&&k(i.charCodeAt(s)))for(s++;s<i.length&&k(i.charCodeAt(s));)s++;else return t=3,i.substring(B,s);let O=s;if(s<i.length&&(i.charCodeAt(s)===69||i.charCodeAt(s)===101))if(s++,(s<i.length&&i.charCodeAt(s)===43||i.charCodeAt(s)===45)&&s++,s<i.length&&k(i.charCodeAt(s))){for(s++;s<i.length&&k(i.charCodeAt(s));)s++;O=s}else t=3;return i.substring(B,O)}function F(){let B="",O=s;for(;;){if(s>=c){B+=i.substring(O,s),t=2;break}const U=i.charCodeAt(s);if(U===34){B+=i.substring(O,s),s++;break}if(U===92){if(B+=i.substring(O,s),s++,s>=c){t=2;break}switch(i.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=u(4);j>=0?B+=String.fromCharCode(j):t=4;break}default:t=5}O=s;continue}if(U>=0&&U<=31)if(E(U)){B+=i.substring(O,s),t=2;break}else t=6;s++}return B}function x(){if(r="",t=0,m=s,s>=c)return m=c,n=17;let B=i.charCodeAt(s);if(P(B)){do s++,r+=String.fromCharCode(B),B=i.charCodeAt(s);while(P(B));return n=15}if(E(B))return s++,r+=String.fromCharCode(B),B===13&&i.charCodeAt(s)===10&&(s++,r+=`
`),n=14;switch(B){case 123:return s++,n=1;case 125:return s++,n=2;case 91:return s++,n=3;case 93:return s++,n=4;case 58:return s++,n=6;case 44:return s++,n=5;case 34:return s++,r=F(),n=10;case 47:{const O=s-1;if(i.charCodeAt(s+1)===47){for(s+=2;s<c&&!E(i.charCodeAt(s));)s++;return r=i.substring(O,s),n=12}if(i.charCodeAt(s+1)===42){s+=2;const U=c-1;let $=!1;for(;s<U;){if(i.charCodeAt(s)===42&&i.charCodeAt(s+1)===47){s+=2,$=!0;break}s++}return $||(s++,t=1),r=i.substring(O,s),n=13}return r+=String.fromCharCode(B),s++,n=16}case 45:if(r+=String.fromCharCode(B),s++,s===c||!k(i.charCodeAt(s)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=S(),n=11;default:for(;s<c&&V(B);)s++,B=i.charCodeAt(s);if(m!==s){switch(r=i.substring(m,s),r){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return r+=String.fromCharCode(B),s++,n=16}}function V(B){if(P(B)||E(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:w,getPosition:()=>s,scan:o?M:x,getToken:()=>n,getTokenValue:()=>r,getTokenOffset:()=>m,getTokenLength:()=>s-m,getTokenError:()=>t}}e.createScanner=D;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function T(i,o){const s=[],c=new Object;let r;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(u,w,S,F){m.value=u,m.offset=w,m.length=S,m.type=F,m.colonOffset=void 0,r=m}try{b(i,{onObjectBegin:(u,w)=>{if(o<=u)throw c;r=void 0,n=o>u,s.push("")},onObjectProperty:(u,w,S)=>{if(o<w||(t(u,w,S,"property"),s[s.length-1]=u,o<=w+S))throw c},onObjectEnd:(u,w)=>{if(o<=u)throw c;r=void 0,s.pop()},onArrayBegin:(u,w)=>{if(o<=u)throw c;r=void 0,s.push(0)},onArrayEnd:(u,w)=>{if(o<=u)throw c;r=void 0,s.pop()},onLiteralValue:(u,w,S)=>{if(o<w||(t(u,w,S,p(u)),o<=w+S))throw c},onSeparator:(u,w,S)=>{if(o<=w)throw c;if(u===":"&&r&&r.type==="property")r.colonOffset=w,n=!1,r=void 0;else if(u===","){const F=s[s.length-1];typeof F=="number"?s[s.length-1]=F+1:(n=!0,s[s.length-1]=""),r=void 0}}})}catch(u){if(u!==c)throw u}return{path:s,previousNode:r,isAtPropertyKey:n,matches:u=>{let w=0;for(let S=0;w<u.length&&S<s.length;S++)if(u[w]===s[S]||u[w]==="*")w++;else if(u[w]!=="**")return!1;return w===u.length}}}e.getLocation=T;function v(i,o=[],s=R.DEFAULT){let c=null,r=[];const m=[];function n(u){Array.isArray(r)?r.push(u):c!==null&&(r[c]=u)}return b(i,{onObjectBegin:()=>{const u={};n(u),m.push(r),r=u,c=null},onObjectProperty:u=>{c=u},onObjectEnd:()=>{r=m.pop()},onArrayBegin:()=>{const u=[];n(u),m.push(r),r=u,c=null},onArrayEnd:()=>{r=m.pop()},onLiteralValue:n,onError:(u,w,S)=>{o.push({error:u,offset:w,length:S})}},s),r[0]}e.parse=v;function I(i,o=[],s=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(u){c.type==="property"&&(c.length=u-c.offset,c=c.parent)}function m(u){return c.children.push(u),u}b(i,{onObjectBegin:u=>{c=m({type:"object",offset:u,length:-1,parent:c,children:[]})},onObjectProperty:(u,w,S)=>{c=m({type:"property",offset:w,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:u,offset:w,length:S,parent:c})},onObjectEnd:(u,w)=>{c.length=u+w-c.offset,c=c.parent,r(u+w)},onArrayBegin:(u,w)=>{c=m({type:"array",offset:u,length:-1,parent:c,children:[]})},onArrayEnd:(u,w)=>{c.length=u+w-c.offset,c=c.parent,r(u+w)},onLiteralValue:(u,w,S)=>{m({type:p(u),offset:w,length:S,parent:c,value:u}),r(w+S)},onSeparator:(u,w,S)=>{c.type==="property"&&(u===":"?c.colonOffset=w:u===","&&r(w))},onError:(u,w,S)=>{o.push({error:u,offset:w,length:S})}},s);const t=c.children[0];return t&&delete t.parent,t}e.parseTree=I;function y(i,o){if(!i)return;let s=i;for(const c of o)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const m of s.children)if(Array.isArray(m.children)&&m.children[0].value===c){s=m.children[1],r=!0;break}if(!r)return}else{const r=c;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=y;function f(i){if(!i.parent||!i.parent.children)return[];const o=f(i.parent);if(i.parent.type==="property"){const s=i.parent.children[0].value;o.push(s)}else if(i.parent.type==="array"){const s=i.parent.children.indexOf(i);s!==-1&&o.push(s)}return o}e.getNodePath=f;function h(i){switch(i.type){case"array":return i.children.map(h);case"object":{const o=Object.create(null);for(const s of i.children){const c=s.children[1];c&&(o[s.children[0].value]=h(c))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=h;function d(i,o,s=!1){return o>=i.offset&&o<i.offset+i.length||s&&o===i.offset+i.length}e.contains=d;function g(i,o,s=!1){if(d(i,o,s)){const c=i.children;if(Array.isArray(c))for(let r=0;r<c.length&&c[r].offset<=o;r++){const m=g(c[r],o,s);if(m)return m}return i}}e.findNodeAtOffset=g;function b(i,o,s=R.DEFAULT){const c=D(i,!1);function r(te){return te?()=>te(c.getTokenOffset(),c.getTokenLength()):()=>!0}function m(te){return te?X=>te(X,c.getTokenOffset(),c.getTokenLength()):()=>!0}const n=r(o.onObjectBegin),t=m(o.onObjectProperty),u=r(o.onObjectEnd),w=r(o.onArrayBegin),S=r(o.onArrayEnd),F=m(o.onLiteralValue),x=m(o.onSeparator),V=r(o.onComment),M=m(o.onError),B=s&&s.disallowComments,O=s&&s.allowTrailingComma;function U(){for(;;){const te=c.scan();switch(c.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:B||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(te){case 12:case 13:B?$(10):V();break;case 16:$(1);break;case 15:case 14:break;default:return te}}}function $(te,X=[],_=[]){if(M(te),X.length+_.length>0){let ie=c.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){U();break}else if(_.indexOf(ie)!==-1)break;ie=U()}}}function j(te){const X=c.getTokenValue();return te?F(X):t(X),U(),!0}function le(){switch(c.getToken()){case 11:{let te=0;try{te=JSON.parse(c.getTokenValue()),typeof te!="number"&&($(2),te=0)}catch{$(2)}F(te);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function J(){return c.getToken()!==10?($(3,[],[2,5]),!1):(j(!1),c.getToken()===6?(x(":"),U(),Z()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function q(){n(),U();let te=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(te||$(4,[],[]),x(","),U(),c.getToken()===2&&O)break}else te&&$(6,[],[]);J()||$(4,[],[2,5]),te=!0}return u(),c.getToken()!==2?$(7,[2],[]):U(),!0}function Q(){w(),U();let te=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(te||$(4,[],[]),x(","),U(),c.getToken()===4&&O)break}else te&&$(6,[],[]);Z()||$(4,[],[4,5]),te=!0}return S(),c.getToken()!==4?$(8,[4],[]):U(),!0}function Z(){switch(c.getToken()){case 3:return Q();case 1:return q();case 10:return j(!0);default:return le()}}return U(),c.getToken()===17?s.allowEmptyContent?!0:($(4,[],[]),!1):Z()?(c.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function C(i,o){const s=D(i),c=[];let r,m=0,n;do switch(n=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:m!==n&&c.push(i.substring(m,n)),o!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,o)),m=s.getPosition();break}while(r!==17);return c.join("")}e.stripComments=C;function p(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(ye[65],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(ye[6],De([1,0,63,64]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function D(m){R=m}if(e.setDisposableTracker=D,l){const m="__is_disposable_tracked__";D(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[m]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsDisposed(n){if(n&&n!==g.None)try{n[m]=!0}catch{}}markAsSingleton(n){}})}function P(m){return R?.trackDisposable(m),m}function E(m){R?.markAsDisposed(m)}function k(m,n){R?.setParent(m,n)}function L(m,n){if(!!R)for(const t of m)R.setParent(t,n)}function T(m){return R?.markAsSingleton(m),m}e.markAsSingleton=T;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function I(m){if(A.Iterable.is(m)){const n=[];for(const t of m)if(t)try{t.dispose()}catch(u){n.push(u)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=I;function y(m){for(const n of m)v(n)&&n.dispose();return[]}e.disposeIfDisposable=y;function f(...m){const n=h(()=>I(m));return L(m,n),n}e.combinedDisposable=f;function h(m){const n=P({dispose:(0,a.once)(()=>{E(n),m()})});return n}e.toDisposable=h;class d{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(E(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{I(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return k(n,this),this.f?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}d.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=d;class g{constructor(){this.q=new d,P(this),k(this.q,this)}dispose(){E(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class b{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&k(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&k(n,null),n}}e.MutableDisposable=b;class C{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=C;class p{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,E(this))},this}}e.SafeDisposable=p;class i{constructor(){this.a=new Map}acquire(n,...t){let u=this.a.get(n);u||(u={counter:0,object:this.b(n,...t)},this.a.set(n,u));const{object:w}=u,S=(0,a.once)(()=>{--u.counter===0&&(this.c(n,u.object),this.a.delete(n))});return u.counter++,{object:w,dispose:S}}}e.ReferenceCollection=i;class o{constructor(n){this.a=n}async acquire(n,...t){const u=this.a.acquire(n,...t);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(w){throw u.dispose(),w}}}e.AsyncReferenceCollection=o;class s{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=s;function c(m){const n=new d;try{m(n)}finally{n.dispose()}}e.disposeOnReturn=c;class r{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{I(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,t,u=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),u||this.a.get(n)?.dispose(),this.a.set(n,t)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=r}),define(ye[66],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class A{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const D=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=D}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,D){const P=new a(R);if(this.a===a.Undefined)this.a=P,this.b=P;else if(D){const k=this.b;this.b=P,P.prev=k,k.next=P}else{const k=this.a;this.a=P,P.next=k,k.prev=P}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(P))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=A}),define(ye[28],De([1,0]),function(ne,e){"use strict";var a,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(y,f,h){let d=y.get(f);return d===void 0&&(d=h,y.set(f,d)),d}e.getOrSet=R;function D(y){const f=[];return y.forEach((h,d)=>{f.push(`${d} => ${h}`)}),`Map(${y.size}) {${f.join(", ")}}`}e.mapToString=D;function P(y){const f=[];return y.forEach(h=>{f.push(h)}),`Set(${y.size}) {${f.join(", ")}}`}e.setToString=P;class E{constructor(f,h){this.uri=f,this.value=h}}class k{constructor(f,h){this[a]="ResourceMap",f instanceof k?(this.b=new Map(f.b),this.c=h??k.a):(this.b=new Map,this.c=f??k.a)}set(f,h){return this.b.set(this.c(f),new E(f,h)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,h){typeof h<"u"&&(f=f.bind(h));for(const[d,g]of this.b)f(g.value,g.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}k.a=y=>y.toString(),e.ResourceMap=k;class L{constructor(f,h){this[A]="ResourceSet",!f||typeof f=="function"?this.a=new k(f):(this.a=new k(h),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,h){this.a.forEach((d,g)=>f.call(h,g,g,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var T;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(T=e.Touch||(e.Touch={}));class v{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,h=0){const d=this.a.get(f);if(!!d)return h!==0&&this.j(d,h),d.value}set(f,h,d=0){let g=this.a.get(f);if(g)g.value=h,d!==0&&this.j(g,d);else{switch(g={key:f,value:h,next:void 0,previous:void 0},d){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(f,g),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const h=this.a.get(f);if(!!h)return this.a.delete(f),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,h){const d=this.e;let g=this.b;for(;g;){if(h?f.bind(h)(g.value,g.key,this):f(g.value,g.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const f=this,h=this.e;let d=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.key,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return g}values(){const f=this,h=this.e;let d=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:d.value,done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return g}entries(){const f=this,h=this.e;let d=this.b;const g={[Symbol.iterator](){return g},next(){if(f.e!==h)throw new Error("LinkedMap got modified during iteration.");if(d){const b={value:[d.key,d.value],done:!1};return d=d.next,b}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let h=this.b,d=this.size;for(;h&&d>f;)this.a.delete(h.key),h=h.next,d--;this.b=h,this.d=d,h&&(h.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const h=f.next,d=f.previous;if(!h||!d)throw new Error("Invalid list");h.previous=d,d.next=h}f.next=void 0,f.previous=void 0,this.e++}j(f,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(f===this.b)return;const d=f.next,g=f.previous;f===this.c?(g.next=void 0,this.c=g):(d.previous=g,g.next=d),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(h===2){if(f===this.c)return;const d=f.next,g=f.previous;f===this.b?(d.previous=void 0,this.b=d):(d.previous=g,g.next=d),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((h,d)=>{f.push([d,h])}),f}fromJSON(f){this.clear();for(const[h,d]of f)this.set(h,d)}}e.LinkedMap=v;class I extends v{constructor(f,h=1){super(),this.k=f,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,h=2){return super.get(f,h)}peek(f){return super.get(f,0)}set(f,h){return super.set(f,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=I}),function(ne,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(ne=typeof globalThis<"u"?globalThis:ne||self,e(ne.marked={}))}(this,function(ne){"use strict";function e(oe,ae){for(var fe=0;fe<ae.length;fe++){var ee=ae[fe];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(oe,ee.key,ee)}}function a(oe,ae,fe){return ae&&e(oe.prototype,ae),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function A(oe,ae){if(!!oe){if(typeof oe=="string")return l(oe,ae);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return l(oe,ae)}}function l(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var fe=0,ee=new Array(ae);fe<ae;fe++)ee[fe]=oe[fe];return ee}function R(oe,ae){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=A(oe))||ae&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var ee=0;return function(){return ee>=oe.length?{done:!0}:{done:!1,value:oe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function P(oe){ne.defaults=oe}var E=/[&<>"']/,k=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,T=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(ae){return v[ae]};function y(oe,ae){if(ae){if(E.test(oe))return oe.replace(k,I)}else if(L.test(oe))return oe.replace(T,I);return oe}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(oe){return oe.replace(f,function(ae,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var d=/(^|[^\[])\^/g;function g(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var fe={replace:function(ue,se){return se=se.source||se,se=se.replace(d,"$1"),oe=oe.replace(ue,se),fe},getRegex:function(){return new RegExp(oe,ae)}};return fe}var b=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(oe,ae,fe){if(oe){var ee;try{ee=decodeURIComponent(h(fe)).replace(b,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ae&&!C.test(fe)&&(fe=r(ae,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},o=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(oe,ae){i[" "+oe]||(o.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=u(oe,"/",!0)),oe=i[" "+oe];var fe=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?fe?ae:oe.replace(s,"$1")+ae:ae.charAt(0)==="/"?fe?ae:oe.replace(c,"$1")+ae:oe+ae}var m={exec:function(){}};function n(oe){for(var ae=1,fe,ee;ae<arguments.length;ae++){fe=arguments[ae];for(ee in fe)Object.prototype.hasOwnProperty.call(fe,ee)&&(oe[ee]=fe[ee])}return oe}function t(oe,ae){var fe=oe.replace(/\|/g,function(se,N,W){for(var K=!1,Y=N;--Y>=0&&W[Y]==="\\";)K=!K;return K?"|":" |"}),ee=fe.split(/ \|/),ue=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ae)ee.splice(ae);else for(;ee.length<ae;)ee.push("");for(;ue<ee.length;ue++)ee[ue]=ee[ue].trim().replace(/\\\|/g,"|");return ee}function u(oe,ae,fe){var ee=oe.length;if(ee===0)return"";for(var ue=0;ue<ee;){var se=oe.charAt(ee-ue-1);if(se===ae&&!fe)ue++;else if(se!==ae&&fe)ue++;else break}return oe.slice(0,ee-ue)}function w(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var fe=oe.length,ee=0,ue=0;ue<fe;ue++)if(oe[ue]==="\\")ue++;else if(oe[ue]===ae[0])ee++;else if(oe[ue]===ae[1]&&(ee--,ee<0))return ue;return-1}function S(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(oe,ae){if(ae<1)return"";for(var fe="";ae>1;)ae&1&&(fe+=oe),ae>>=1,oe+=oe;return fe+oe}function x(oe,ae,fe,ee){var ue=ae.href,se=ae.title?y(ae.title):null,N=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){ee.state.inLink=!0;var W={type:"link",raw:fe,href:ue,title:se,text:N,tokens:ee.inlineTokens(N)};return ee.state.inLink=!1,W}return{type:"image",raw:fe,href:ue,title:se,text:y(N)}}function V(oe,ae){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ae;var ee=fe[1];return ae.split(`
`).map(function(ue){var se=ue.match(/^\s+/);if(se===null)return ue;var N=se[0];return N.length>=ee.length?ue.slice(ee.length):ue}).join(`
`)}var M=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.space=function(ee){var ue=this.rules.block.newline.exec(ee);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ae.code=function(ee){var ue=this.rules.block.code.exec(ee);if(ue){var se=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?se:u(se,`
`)}}},ae.fences=function(ee){var ue=this.rules.block.fences.exec(ee);if(ue){var se=ue[0],N=V(se,ue[3]||"");return{type:"code",raw:se,lang:ue[2]?ue[2].trim():ue[2],text:N}}},ae.heading=function(ee){var ue=this.rules.block.heading.exec(ee);if(ue){var se=ue[2].trim();if(/#$/.test(se)){var N=u(se,"#");(this.options.pedantic||!N||/ $/.test(N))&&(se=N.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:se,tokens:this.lexer.inline(se)}}},ae.hr=function(ee){var ue=this.rules.block.hr.exec(ee);if(ue)return{type:"hr",raw:ue[0]}},ae.blockquote=function(ee){var ue=this.rules.block.blockquote.exec(ee);if(ue){var se=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},ae.list=function(ee){var ue=this.rules.block.list.exec(ee);if(ue){var se,N,W,K,Y,he,we,Ae,be,Ce,Te,Ve,xe=ue[1].trim(),et=xe.length>1,Qe={type:"list",raw:"",ordered:et,start:et?+xe.slice(0,-1):"",loose:!1,items:[]};xe=et?"\\d{1,9}\\"+xe.slice(-1):"\\"+xe,this.options.pedantic&&(xe=et?xe:"[*+-]");for(var nt=new RegExp("^( {0,3}"+xe+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(Ve=!1,!(!(ue=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(se=ue[0],ee=ee.substring(se.length),Ae=ue[2].split(`
`,1)[0],be=ee.split(`
`,1)[0],this.options.pedantic?(K=2,Te=Ae.trimLeft()):(K=ue[2].search(/[^ ]/),K=K>4?1:K,Te=Ae.slice(K),K+=ue[1].length),he=!1,!Ae&&/^ *$/.test(be)&&(se+=be+`
`,ee=ee.substring(be.length+1),Ve=!0),!Ve)for(var st=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,K-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,K-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,K-1)+"}#");ee&&(Ce=ee.split(`
`,1)[0],Ae=Ce,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Ae)||rt.test(Ae)||st.test(Ae)||ht.test(ee)));){if(Ae.search(/[^ ]/)>=K||!Ae.trim())Te+=`
`+Ae.slice(K);else if(!he)Te+=`
`+Ae;else break;!he&&!Ae.trim()&&(he=!0),se+=Ce+`
`,ee=ee.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(se)&&(we=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(Te),N&&(W=N[0]!=="[ ] ",Te=Te.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:se,task:!!N,checked:W,loose:!1,text:Te}),Qe.raw+=se}Qe.items[Qe.items.length-1].raw=se.trimRight(),Qe.items[Qe.items.length-1].text=Te.trimRight(),Qe.raw=Qe.raw.trimRight();var ce=Qe.items.length;for(Y=0;Y<ce;Y++){this.lexer.state.top=!1,Qe.items[Y].tokens=this.lexer.blockTokens(Qe.items[Y].text,[]);var z=Qe.items[Y].tokens.filter(function(Ie){return Ie.type==="space"}),de=z.every(function(Ie){for(var Le=Ie.raw.split(""),$e=0,Ke=R(Le),Ze;!(Ze=Ke()).done;){var pt=Ze.value;if(pt===`
`&&($e+=1),$e>1)return!0}return!1});!Qe.loose&&z.length&&de&&(Qe.loose=!0,Qe.items[Y].loose=!0)}return Qe}},ae.html=function(ee){var ue=this.rules.block.html.exec(ee);if(ue){var se={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(ue[0]):y(ue[0]);se.type="paragraph",se.text=N,se.tokens=this.lexer.inline(N)}return se}},ae.def=function(ee){var ue=this.rules.block.def.exec(ee);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var se=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:ue[0],href:ue[2],title:ue[3]}}},ae.table=function(ee){var ue=this.rules.block.table.exec(ee);if(ue){var se={type:"table",header:t(ue[1]).map(function(we){return{text:we}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=ue[0];var N=se.align.length,W,K,Y,he;for(W=0;W<N;W++)/^ *-+: *$/.test(se.align[W])?se.align[W]="right":/^ *:-+: *$/.test(se.align[W])?se.align[W]="center":/^ *:-+ *$/.test(se.align[W])?se.align[W]="left":se.align[W]=null;for(N=se.rows.length,W=0;W<N;W++)se.rows[W]=t(se.rows[W],se.header.length).map(function(we){return{text:we}});for(N=se.header.length,K=0;K<N;K++)se.header[K].tokens=this.lexer.inline(se.header[K].text);for(N=se.rows.length,K=0;K<N;K++)for(he=se.rows[K],Y=0;Y<he.length;Y++)he[Y].tokens=this.lexer.inline(he[Y].text);return se}}},ae.lheading=function(ee){var ue=this.rules.block.lheading.exec(ee);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ae.paragraph=function(ee){var ue=this.rules.block.paragraph.exec(ee);if(ue){var se=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:se,tokens:this.lexer.inline(se)}}},ae.text=function(ee){var ue=this.rules.block.text.exec(ee);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ae.escape=function(ee){var ue=this.rules.inline.escape.exec(ee);if(ue)return{type:"escape",raw:ue[0],text:y(ue[1])}},ae.tag=function(ee){var ue=this.rules.inline.tag.exec(ee);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):y(ue[0]):ue[0]}},ae.link=function(ee){var ue=this.rules.inline.link.exec(ee);if(ue){var se=ue[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var N=u(se.slice(0,-1),"\\");if((se.length-N.length)%2===0)return}else{var W=w(ue[2],"()");if(W>-1){var K=ue[0].indexOf("!")===0?5:4,Y=K+ue[1].length+W;ue[2]=ue[2].substring(0,W),ue[0]=ue[0].substring(0,Y).trim(),ue[3]=""}}var he=ue[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(he);Ae&&(he=Ae[1],we=Ae[3])}else we=ue[3]?ue[3].slice(1,-1):"";return he=he.trim(),/^</.test(he)&&(this.options.pedantic&&!/>$/.test(se)?he=he.slice(1):he=he.slice(1,-1)),x(ue,{href:he&&he.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ae.reflink=function(ee,ue){var se;if((se=this.rules.inline.reflink.exec(ee))||(se=this.rules.inline.nolink.exec(ee))){var N=(se[2]||se[1]).replace(/\s+/g," ");if(N=ue[N.toLowerCase()],!N||!N.href){var W=se[0].charAt(0);return{type:"text",raw:W,text:W}}return x(se,N,se[0],this.lexer)}},ae.emStrong=function(ee,ue,se){se===void 0&&(se="");var N=this.rules.inline.emStrong.lDelim.exec(ee);if(!!N&&!(N[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var W=N[1]||N[2]||"";if(!W||W&&(se===""||this.rules.inline.punctuation.exec(se))){var K=N[0].length-1,Y,he,we=K,Ae=0,be=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,ue=ue.slice(-1*ee.length+K);(N=be.exec(ue))!=null;)if(Y=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!Y){if(he=Y.length,N[3]||N[4]){we+=he;continue}else if((N[5]||N[6])&&K%3&&!((K+he)%3)){Ae+=he;continue}if(we-=he,!(we>0)){if(he=Math.min(he,he+we+Ae),Math.min(K,he)%2){var Ce=ee.slice(1,K+N.index+he);return{type:"em",raw:ee.slice(0,K+N.index+he+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var Te=ee.slice(2,K+N.index+he-1);return{type:"strong",raw:ee.slice(0,K+N.index+he+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}}}}},ae.codespan=function(ee){var ue=this.rules.inline.code.exec(ee);if(ue){var se=ue[2].replace(/\n/g," "),N=/[^ ]/.test(se),W=/^ /.test(se)&&/ $/.test(se);return N&&W&&(se=se.substring(1,se.length-1)),se=y(se,!0),{type:"codespan",raw:ue[0],text:se}}},ae.br=function(ee){var ue=this.rules.inline.br.exec(ee);if(ue)return{type:"br",raw:ue[0]}},ae.del=function(ee){var ue=this.rules.inline.del.exec(ee);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ae.autolink=function(ee,ue){var se=this.rules.inline.autolink.exec(ee);if(se){var N,W;return se[2]==="@"?(N=y(this.options.mangle?ue(se[1]):se[1]),W="mailto:"+N):(N=y(se[1]),W=N),{type:"link",raw:se[0],text:N,href:W,tokens:[{type:"text",raw:N,text:N}]}}},ae.url=function(ee,ue){var se;if(se=this.rules.inline.url.exec(ee)){var N,W;if(se[2]==="@")N=y(this.options.mangle?ue(se[0]):se[0]),W="mailto:"+N;else{var K;do K=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(K!==se[0]);N=y(se[0]),se[1]==="www."?W="http://"+N:W=N}return{type:"link",raw:se[0],text:N,href:W,tokens:[{type:"text",raw:N,text:N}]}}},ae.inlineText=function(ee,ue){var se=this.rules.inline.text.exec(ee);if(se){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):y(se[0]):se[0]:N=y(this.options.smartypants?ue(se[0]):se[0]),{type:"text",raw:se[0],text:N}}},oe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=n({},B),B.gfm=n({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=n({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=g(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=g(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=g(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=g(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=g(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=g(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=g(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=g(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=g(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=g(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=n({},O),O.pedantic=n({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=n({},O.normal,{escape:g(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=g(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=n({},O.gfm,{br:g(O.br).replace("{2,}","*").getRegex(),text:g(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function $(oe){var ae="",fe,ee,ue=oe.length;for(fe=0;fe<ue;fe++)ee=oe.charCodeAt(fe),Math.random()>.5&&(ee="x"+ee.toString(16)),ae+="&#"+ee+";";return ae}var j=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ne.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:B.normal,inline:O.normal};this.options.pedantic?(ee.block=B.pedantic,ee.inline=O.pedantic):this.options.gfm&&(ee.block=B.gfm,this.options.breaks?ee.inline=O.breaks:ee.inline=O.gfm),this.tokenizer.rules=ee}oe.lex=function(ee,ue){var se=new oe(ue);return se.lex(ee)},oe.lexInline=function(ee,ue){var se=new oe(ue);return se.inlineTokens(ee)};var ae=oe.prototype;return ae.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ae.blockTokens=function(ee,ue){var se=this;ue===void 0&&(ue=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(we,Ae,be){return Ae+"    ".repeat(be.length)});for(var N,W,K,Y;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(N=we.call({lexer:se},ee,ue))?(ee=ee.substring(N.raw.length),ue.push(N),!0):!1}))){if(N=this.tokenizer.space(ee)){ee=ee.substring(N.raw.length),N.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(N);continue}if(N=this.tokenizer.code(ee)){ee=ee.substring(N.raw.length),W=ue[ue.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=W.text):ue.push(N);continue}if(N=this.tokenizer.fences(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.heading(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.hr(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.blockquote(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.list(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.html(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.def(ee)){ee=ee.substring(N.raw.length),W=ue[ue.length-1],W&&(W.type==="paragraph"||W.type==="text")?(W.raw+=`
`+N.raw,W.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=W.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.lheading(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=ee.slice(1),be=void 0;se.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Ae),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(K=ee.substring(0,we+1))}(),this.state.top&&(N=this.tokenizer.paragraph(K))){W=ue[ue.length-1],Y&&W.type==="paragraph"?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ue.push(N),Y=K.length!==ee.length,ee=ee.substring(N.raw.length);continue}if(N=this.tokenizer.text(ee)){ee=ee.substring(N.raw.length),W=ue[ue.length-1],W&&W.type==="text"?(W.raw+=`
`+N.raw,W.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=W.text):ue.push(N);continue}if(ee){var he="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(he);break}else throw new Error(he)}}return this.state.top=!0,ue},ae.inline=function(ee,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:ee,tokens:ue}),ue},ae.inlineTokens=function(ee,ue){var se=this;ue===void 0&&(ue=[]);var N,W,K,Y=ee,he,we,Ae;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(he=this.tokenizer.rules.inline.reflinkSearch.exec(Y))!=null;)be.includes(he[0].slice(he[0].lastIndexOf("[")+1,-1))&&(Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(he=this.tokenizer.rules.inline.blockSkip.exec(Y))!=null;)Y=Y.slice(0,he.index)+"["+F("a",he[0].length-2)+"]"+Y.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(he=this.tokenizer.rules.inline.escapedEmSt.exec(Y))!=null;)Y=Y.slice(0,he.index)+"++"+Y.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Te){return(N=Te.call({lexer:se},ee,ue))?(ee=ee.substring(N.raw.length),ue.push(N),!0):!1}))){if(N=this.tokenizer.escape(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.tag(ee)){ee=ee.substring(N.raw.length),W=ue[ue.length-1],W&&N.type==="text"&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):ue.push(N);continue}if(N=this.tokenizer.link(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(N.raw.length),W=ue[ue.length-1],W&&N.type==="text"&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):ue.push(N);continue}if(N=this.tokenizer.emStrong(ee,Y,Ae)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.codespan(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.br(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.del(ee)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(N=this.tokenizer.autolink(ee,$)){ee=ee.substring(N.raw.length),ue.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(ee,$))){ee=ee.substring(N.raw.length),ue.push(N);continue}if(K=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Te=1/0,Ve=ee.slice(1),xe=void 0;se.options.extensions.startInline.forEach(function(et){xe=et.call({lexer:this},Ve),typeof xe=="number"&&xe>=0&&(Te=Math.min(Te,xe))}),Te<1/0&&Te>=0&&(K=ee.substring(0,Te+1))}(),N=this.tokenizer.inlineText(K,U)){ee=ee.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(Ae=N.raw.slice(-1)),we=!0,W=ue[ue.length-1],W&&W.type==="text"?(W.raw+=N.raw,W.text+=N.text):ue.push(N);continue}if(ee){var Ce="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ue},a(oe,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),oe}(),le=function(){function oe(fe){this.options=fe||ne.defaults}var ae=oe.prototype;return ae.code=function(ee,ue,se){var N=(ue||"").match(/\S*/)[0];if(this.options.highlight){var W=this.options.highlight(ee,N);W!=null&&W!==ee&&(se=!0,ee=W)}return ee=ee.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+y(N,!0)+'">'+(se?ee:y(ee,!0))+`</code></pre>
`:"<pre><code>"+(se?ee:y(ee,!0))+`</code></pre>
`},ae.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ae.html=function(ee){return ee},ae.heading=function(ee,ue,se,N){if(this.options.headerIds){var W=this.options.headerPrefix+N.slug(se);return"<h"+ue+' id="'+W+'">'+ee+"</h"+ue+`>
`}return"<h"+ue+">"+ee+"</h"+ue+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(ee,ue,se){var N=ue?"ol":"ul",W=ue&&se!==1?' start="'+se+'"':"";return"<"+N+W+`>
`+ee+"</"+N+`>
`},ae.listitem=function(ee){return"<li>"+ee+`</li>
`},ae.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(ee){return"<p>"+ee+`</p>
`},ae.table=function(ee,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ue+`</table>
`},ae.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ae.tablecell=function(ee,ue){var se=ue.header?"th":"td",N=ue.align?"<"+se+' align="'+ue.align+'">':"<"+se+">";return N+ee+("</"+se+`>
`)},ae.strong=function(ee){return"<strong>"+ee+"</strong>"},ae.em=function(ee){return"<em>"+ee+"</em>"},ae.codespan=function(ee){return"<code>"+ee+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(ee){return"<del>"+ee+"</del>"},ae.link=function(ee,ue,se){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return se;var N='<a href="'+y(ee)+'"';return ue&&(N+=' title="'+ue+'"'),N+=">"+se+"</a>",N},ae.image=function(ee,ue,se){if(ee=p(this.options.sanitize,this.options.baseUrl,ee),ee===null)return se;var N='<img src="'+ee+'" alt="'+se+'"';return ue&&(N+=' title="'+ue+'"'),N+=this.options.xhtml?"/>":">",N},ae.text=function(ee){return ee},oe}(),J=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(ee){return ee},ae.em=function(ee){return ee},ae.codespan=function(ee){return ee},ae.del=function(ee){return ee},ae.html=function(ee){return ee},ae.text=function(ee){return ee},ae.link=function(ee,ue,se){return""+se},ae.image=function(ee,ue,se){return""+se},ae.br=function(){return""},oe}(),q=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(ee,ue){var se=ee,N=0;if(this.seen.hasOwnProperty(se)){N=this.seen[ee];do N++,se=ee+"-"+N;while(this.seen.hasOwnProperty(se))}return ue||(this.seen[ee]=N,this.seen[se]=0),se},ae.slug=function(ee,ue){ue===void 0&&(ue={});var se=this.serialize(ee);return this.getNextSafeSlug(se,ue.dryrun)},oe}(),Q=function(){function oe(fe){this.options=fe||ne.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new q}oe.parse=function(ee,ue){var se=new oe(ue);return se.parse(ee)},oe.parseInline=function(ee,ue){var se=new oe(ue);return se.parseInline(ee)};var ae=oe.prototype;return ae.parse=function(ee,ue){ue===void 0&&(ue=!0);var se="",N,W,K,Y,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce=ee.length;for(N=0;N<ce;N++){if(Te=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(rt=this.options.extensions.renderers[Te.type].call({parser:this},Te),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Te.type))){se+=rt||"";continue}switch(Te.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(Te.tokens),Te.depth,h(this.parseInline(Te.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(Te.text,Te.lang,Te.escaped);continue}case"table":{for(be="",Ae="",Y=Te.header.length,W=0;W<Y;W++)Ae+=this.renderer.tablecell(this.parseInline(Te.header[W].tokens),{header:!0,align:Te.align[W]});for(be+=this.renderer.tablerow(Ae),Ce="",Y=Te.rows.length,W=0;W<Y;W++){for(we=Te.rows[W],Ae="",he=we.length,K=0;K<he;K++)Ae+=this.renderer.tablecell(this.parseInline(we[K].tokens),{header:!1,align:Te.align[K]});Ce+=this.renderer.tablerow(Ae)}se+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(Te.tokens),se+=this.renderer.blockquote(Ce);continue}case"list":{for(Ve=Te.ordered,xe=Te.start,et=Te.loose,Y=Te.items.length,Ce="",W=0;W<Y;W++)nt=Te.items[W],st=nt.checked,ht=nt.task,Qe="",nt.task&&(Ue=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Ue+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Ue+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Ue}):Qe+=Ue),Qe+=this.parse(nt.tokens,et),Ce+=this.renderer.listitem(Qe,ht,st);se+=this.renderer.list(Ce,Ve,xe);continue}case"html":{se+=this.renderer.html(Te.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(Te.tokens));continue}case"text":{for(Ce=Te.tokens?this.parseInline(Te.tokens):Te.text;N+1<ce&&ee[N+1].type==="text";)Te=ee[++N],Ce+=`
`+(Te.tokens?this.parseInline(Te.tokens):Te.text);se+=ue?this.renderer.paragraph(Ce):Ce;continue}default:{var z='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(z);return}else throw new Error(z)}}}return se},ae.parseInline=function(ee,ue){ue=ue||this.renderer;var se="",N,W,K,Y=ee.length;for(N=0;N<Y;N++){if(W=ee[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[W.type]&&(K=this.options.extensions.renderers[W.type].call({parser:this},W),K!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(W.type))){se+=K||"";continue}switch(W.type){case"escape":{se+=ue.text(W.text);break}case"html":{se+=ue.html(W.text);break}case"link":{se+=ue.link(W.href,W.title,this.parseInline(W.tokens,ue));break}case"image":{se+=ue.image(W.href,W.title,W.text);break}case"strong":{se+=ue.strong(this.parseInline(W.tokens,ue));break}case"em":{se+=ue.em(this.parseInline(W.tokens,ue));break}case"codespan":{se+=ue.codespan(W.text);break}case"br":{se+=ue.br();break}case"del":{se+=ue.del(this.parseInline(W.tokens,ue));break}case"text":{se+=ue.text(W.text);break}default:{var he='Token with "'+W.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return se},oe}();function Z(oe,ae,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(fe=ae,ae=null),ae=n({},Z.defaults,ae||{}),S(ae),fe){var ee=ae.highlight,ue;try{ue=j.lex(oe,ae)}catch(Y){return fe(Y)}var se=function(he){var we;if(!he)try{ae.walkTokens&&Z.walkTokens(ue,ae.walkTokens),we=Q.parse(ue,ae)}catch(Ae){he=Ae}return ae.highlight=ee,he?fe(he):fe(null,we)};if(!ee||ee.length<3||(delete ae.highlight,!ue.length))return se();var N=0;Z.walkTokens(ue,function(Y){Y.type==="code"&&(N++,setTimeout(function(){ee(Y.text,Y.lang,function(he,we){if(he)return se(he);we!=null&&we!==Y.text&&(Y.text=we,Y.escaped=!0),N--,N===0&&se()})},0))}),N===0&&se();return}function W(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+y(Y.message+"",!0)+"</pre>";throw Y}try{var K=j.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(K,ae.walkTokens)).then(function(){return Q.parse(K,ae)}).catch(W);Z.walkTokens(K,ae.walkTokens)}return Q.parse(K,ae)}catch(Y){W(Y)}}Z.options=Z.setOptions=function(oe){return n(Z.defaults,oe),P(Z.defaults),Z},Z.getDefaults=D,Z.defaults=ne.defaults,Z.use=function(){for(var oe=arguments.length,ae=new Array(oe),fe=0;fe<oe;fe++)ae[fe]=arguments[fe];var ee=n.apply(void 0,[{}].concat(ae)),ue=Z.defaults.extensions||{renderers:{},childTokens:{}},se;ae.forEach(function(N){if(N.extensions&&(se=!0,N.extensions.forEach(function(K){if(!K.name)throw new Error("extension name required");if(K.renderer){var Y=ue.renderers?ue.renderers[K.name]:null;Y?ue.renderers[K.name]=function(){for(var he=arguments.length,we=new Array(he),Ae=0;Ae<he;Ae++)we[Ae]=arguments[Ae];var be=K.renderer.apply(this,we);return be===!1&&(be=Y.apply(this,we)),be}:ue.renderers[K.name]=K.renderer}if(K.tokenizer){if(!K.level||K.level!=="block"&&K.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[K.level]?ue[K.level].unshift(K.tokenizer):ue[K.level]=[K.tokenizer],K.start&&(K.level==="block"?ue.startBlock?ue.startBlock.push(K.start):ue.startBlock=[K.start]:K.level==="inline"&&(ue.startInline?ue.startInline.push(K.start):ue.startInline=[K.start]))}K.childTokens&&(ue.childTokens[K.name]=K.childTokens)})),N.renderer&&function(){var K=Z.defaults.renderer||new le,Y=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.renderer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.renderer)Y(he);ee.renderer=K}(),N.tokenizer&&function(){var K=Z.defaults.tokenizer||new M,Y=function(Ae){var be=K[Ae];K[Ae]=function(){for(var Ce=arguments.length,Te=new Array(Ce),Ve=0;Ve<Ce;Ve++)Te[Ve]=arguments[Ve];var xe=N.tokenizer[Ae].apply(K,Te);return xe===!1&&(xe=be.apply(K,Te)),xe}};for(var he in N.tokenizer)Y(he);ee.tokenizer=K}(),N.walkTokens){var W=Z.defaults.walkTokens;ee.walkTokens=function(K){var Y=[];return Y.push(N.walkTokens.call(this,K)),W&&(Y=Y.concat(W.call(this,K))),Y}}se&&(ee.extensions=ue),Z.setOptions(ee)})},Z.walkTokens=function(oe,ae){for(var fe=[],ee=function(){var W=se.value;switch(fe=fe.concat(ae.call(Z,W)),W.type){case"table":{for(var K=R(W.header),Y;!(Y=K()).done;){var he=Y.value;fe=fe.concat(Z.walkTokens(he.tokens,ae))}for(var we=R(W.rows),Ae;!(Ae=we()).done;)for(var be=Ae.value,Ce=R(be),Te;!(Te=Ce()).done;){var Ve=Te.value;fe=fe.concat(Z.walkTokens(Ve.tokens,ae))}break}case"list":{fe=fe.concat(Z.walkTokens(W.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[W.type]?Z.defaults.extensions.childTokens[W.type].forEach(function(xe){fe=fe.concat(Z.walkTokens(W[xe],ae))}):W.tokens&&(fe=fe.concat(Z.walkTokens(W.tokens,ae)))}},ue=R(oe),se;!(se=ue()).done;)ee();return fe},Z.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=n({},Z.defaults,ae||{}),S(ae);try{var fe=j.lexInline(oe,ae);return ae.walkTokens&&Z.walkTokens(fe,ae.walkTokens),Q.parseInline(fe,ae)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+y(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=Q,Z.parser=Q.parse,Z.Renderer=le,Z.TextRenderer=J,Z.Lexer=j,Z.lexer=j.lex,Z.Tokenizer=M,Z.Slugger=q,Z.parse=Z;var te=Z.options,X=Z.setOptions,_=Z.use,ie=Z.walkTokens,pe=Z.parseInline,ve=Z,ke=Q.parse,Oe=j.lex;ne.Lexer=j,ne.Parser=Q,ne.Renderer=le,ne.Slugger=q,ne.TextRenderer=J,ne.Tokenizer=M,ne.getDefaults=D,ne.lexer=Oe,ne.marked=Z,ne.options=te,ne.parse=ve,ne.parseInline=pe,ne.parser=ke,ne.setOptions=X,ne.use=_,ne.walkTokens=ie,Object.defineProperty(ne,"__esModule",{value:!0})}),define(ye[85],De([1,0,28]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new a.LRUCache(1e4);function l(k){return E(k,"NFC",A)}e.normalizeNFC=l;const R=new a.LRUCache(1e4);function D(k){return E(k,"NFD",R)}e.normalizeNFD=D;const P=/[^\u0000-\u0080]/;function E(k,L,T){if(!k)return k;const v=T.get(k);if(v)return v;let I;return P.test(k)?I=k.normalize(L):I=k,T.set(k,I),I}e.removeAccents=function(){const k=/[\u0300-\u036f]/g;return function(L){return D(L).replace(k,"")}}()}),define(ye[102],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(P,E,k){return Math.min(Math.max(P,E),k)}e.clamp=a;function A(P,E){return(E+P%E)%E}e.rot=A;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class R{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class D{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const k=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function ne(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function D(E){R.push(E,Date.now())}function P(){const E=[];for(let k=0;k<R.length;k+=2)E.push({name:R[k],startTime:R[k+1]});return E}return{mark:D,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(l+D.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function a(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=a(A))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var A in a)(typeof exports=="object"?exports:ne)[A]=a[A]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function a(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return ne[A].call(l.exports,l,l.exports,a),l.l=!0,l.exports}return a.m=ne,a.c=e,a.d=function(A,l,R){a.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:R})},a.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},a.t=function(A,l){if(1&l&&(A=a(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var D in A)a.d(R,D,function(P){return A[P]}.bind(null,D));return R},a.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return a.d(l,"a",l),l},a.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},a.p="",a(a.s=0)}([function(ne,e,a){(function(A){var l;e=ne.exports=_,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],E=e.src=[],k=0,L=k++;E[L]="0|[1-9]\\d*";var T=k++;E[T]="[0-9]+";var v=k++;E[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=k++;E[I]="("+E[L]+")\\.("+E[L]+")\\.("+E[L]+")";var y=k++;E[y]="("+E[T]+")\\.("+E[T]+")\\.("+E[T]+")";var f=k++;E[f]="(?:"+E[L]+"|"+E[v]+")";var h=k++;E[h]="(?:"+E[T]+"|"+E[v]+")";var d=k++;E[d]="(?:-("+E[f]+"(?:\\."+E[f]+")*))";var g=k++;E[g]="(?:-?("+E[h]+"(?:\\."+E[h]+")*))";var b=k++;E[b]="[0-9A-Za-z-]+";var C=k++;E[C]="(?:\\+("+E[b]+"(?:\\."+E[b]+")*))";var p=k++,i="v?"+E[I]+E[d]+"?"+E[C]+"?";E[p]="^"+i+"$";var o="[v=\\s]*"+E[y]+E[g]+"?"+E[C]+"?",s=k++;E[s]="^"+o+"$";var c=k++;E[c]="((?:<|>)?=?)";var r=k++;E[r]=E[T]+"|x|X|\\*";var m=k++;E[m]=E[L]+"|x|X|\\*";var n=k++;E[n]="[v=\\s]*("+E[m]+")(?:\\.("+E[m]+")(?:\\.("+E[m]+")(?:"+E[d]+")?"+E[C]+"?)?)?";var t=k++;E[t]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[g]+")?"+E[C]+"?)?)?";var u=k++;E[u]="^"+E[c]+"\\s*"+E[n]+"$";var w=k++;E[w]="^"+E[c]+"\\s*"+E[t]+"$";var S=k++;E[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=k++;E[F]="(?:~>?)";var x=k++;E[x]="(\\s*)"+E[F]+"\\s+",P[x]=new RegExp(E[x],"g");var V=k++;E[V]="^"+E[F]+E[n]+"$";var M=k++;E[M]="^"+E[F]+E[t]+"$";var B=k++;E[B]="(?:\\^)";var O=k++;E[O]="(\\s*)"+E[B]+"\\s+",P[O]=new RegExp(E[O],"g");var U=k++;E[U]="^"+E[B]+E[n]+"$";var $=k++;E[$]="^"+E[B]+E[t]+"$";var j=k++;E[j]="^"+E[c]+"\\s*("+o+")$|^$";var le=k++;E[le]="^"+E[c]+"\\s*("+i+")$|^$";var J=k++;E[J]="(\\s*)"+E[c]+"\\s*("+o+"|"+E[n]+")",P[J]=new RegExp(E[J],"g");var q=k++;E[q]="^\\s*("+E[n]+")\\s+-\\s+("+E[n]+")\\s*$";var Q=k++;E[Q]="^\\s*("+E[t]+")\\s+-\\s+("+E[t]+")\\s*$";var Z=k++;E[Z]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)l(te,E[te]),P[te]||(P[te]=new RegExp(E[te]));function X(be,Ce){if(be instanceof _)return be;if(typeof be!="string"||be.length>R||!(Ce?P[s]:P[p]).test(be))return null;try{return new _(be,Ce)}catch{return null}}function _(be,Ce){if(be instanceof _){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof _))return new _(be,Ce);l("SemVer",be,Ce),this.loose=Ce;var Te=be.trim().match(Ce?P[s]:P[p]);if(!Te)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+Te[1],this.minor=+Te[2],this.patch=+Te[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Te[4]?this.prerelease=Te[4].split(".").map(function(Ve){if(/^[0-9]+$/.test(Ve)){var xe=+Ve;if(xe>=0&&xe<D)return xe}return Ve}):this.prerelease=[],this.build=Te[5]?Te[5].split("."):[],this.format()}e.parse=X,e.valid=function(be,Ce){var Te=X(be,Ce);return Te?Te.version:null},e.clean=function(be,Ce){var Te=X(be.trim().replace(/^[=v]+/,""),Ce);return Te?Te.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(be){return l("SemVer.compare",this.version,this.loose,be),be instanceof _||(be=new _(be,this.loose)),this.compareMain(be)||this.comparePre(be)},_.prototype.compareMain=function(be){return be instanceof _||(be=new _(be,this.loose)),pe(this.major,be.major)||pe(this.minor,be.minor)||pe(this.patch,be.patch)},_.prototype.comparePre=function(be){if(be instanceof _||(be=new _(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var Te=this.prerelease[Ce],Ve=be.prerelease[Ce];if(l("prerelease compare",Ce,Te,Ve),Te===void 0&&Ve===void 0)return 0;if(Ve===void 0)return 1;if(Te===void 0)return-1;if(Te!==Ve)return pe(Te,Ve)}while(++Ce)},_.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Te=this.prerelease.length;--Te>=0;)typeof this.prerelease[Te]=="number"&&(this.prerelease[Te]++,Te=-2);Te===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,Te,Ve){typeof Te=="string"&&(Ve=Te,Te=void 0);try{return new _(be,Te).inc(Ce,Ve).version}catch{return null}},e.diff=function(be,Ce){if(oe(be,Ce))return null;var Te=X(be),Ve=X(Ce);if(Te.prerelease.length||Ve.prerelease.length){for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return"pre"+xe;return"prerelease"}for(var xe in Te)if((xe==="major"||xe==="minor"||xe==="patch")&&Te[xe]!==Ve[xe])return xe},e.compareIdentifiers=pe;var ie=/^[0-9]+$/;function pe(be,Ce){var Te=ie.test(be),Ve=ie.test(Ce);return Te&&Ve&&(be=+be,Ce=+Ce),Te&&!Ve?-1:Ve&&!Te?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,Te){return new _(be,Te).compare(new _(Ce,Te))}function ke(be,Ce,Te){return ve(be,Ce,Te)>0}function Oe(be,Ce,Te){return ve(be,Ce,Te)<0}function oe(be,Ce,Te){return ve(be,Ce,Te)===0}function ae(be,Ce,Te){return ve(be,Ce,Te)!==0}function fe(be,Ce,Te){return ve(be,Ce,Te)>=0}function ee(be,Ce,Te){return ve(be,Ce,Te)<=0}function ue(be,Ce,Te,Ve){var xe;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be===Te;break;case"!==":typeof be=="object"&&(be=be.version),typeof Te=="object"&&(Te=Te.version),xe=be!==Te;break;case"":case"=":case"==":xe=oe(be,Te,Ve);break;case"!=":xe=ae(be,Te,Ve);break;case">":xe=ke(be,Te,Ve);break;case">=":xe=fe(be,Te,Ve);break;case"<":xe=Oe(be,Te,Ve);break;case"<=":xe=ee(be,Te,Ve);break;default:throw new TypeError("Invalid operator: "+Ce)}return xe}function se(be,Ce){if(be instanceof se){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof se))return new se(be,Ce);l("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===N?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(be,Ce){return pe(Ce,be)},e.major=function(be,Ce){return new _(be,Ce).major},e.minor=function(be,Ce){return new _(be,Ce).minor},e.patch=function(be,Ce){return new _(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,Te){return ve(Ce,be,Te)},e.sort=function(be,Ce){return be.sort(function(Te,Ve){return e.compare(Te,Ve,Ce)})},e.rsort=function(be,Ce){return be.sort(function(Te,Ve){return e.rcompare(Te,Ve,Ce)})},e.gt=ke,e.lt=Oe,e.eq=oe,e.neq=ae,e.gte=fe,e.lte=ee,e.cmp=ue,e.Comparator=se;var N={};function W(be,Ce){if(be instanceof W)return be.loose===Ce?be:new W(be.raw,Ce);if(be instanceof se)return new W(be.value,Ce);if(!(this instanceof W))return new W(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(Te){return this.parseRange(Te.trim())},this).filter(function(Te){return Te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function K(be){return!be||be.toLowerCase()==="x"||be==="*"}function Y(be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce){return((Ce=K(Te)?"":K(Ve)?">="+Te+".0.0":K(xe)?">="+Te+"."+Ve+".0":">="+Ce)+" "+(nt=K(st)?"":K(ht)?"<"+(+st+1)+".0.0":K(Ue)?"<"+st+"."+(+ht+1)+".0":rt?"<="+st+"."+ht+"."+Ue+"-"+rt:"<="+nt)).trim()}function he(be,Ce){for(var Te=0;Te<be.length;Te++)if(!be[Te].test(Ce))return!1;if(Ce.prerelease.length){for(Te=0;Te<be.length;Te++)if(l(be[Te].semver),be[Te].semver!==N&&be[Te].semver.prerelease.length>0){var Ve=be[Te].semver;if(Ve.major===Ce.major&&Ve.minor===Ce.minor&&Ve.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,Te){try{Ce=new W(Ce,Te)}catch{return!1}return Ce.test(be)}function Ae(be,Ce,Te,Ve){var xe,et,Qe,nt,st;switch(be=new _(be,Ve),Ce=new W(Ce,Ve),Te){case">":xe=ke,et=ee,Qe=Oe,nt=">",st=">=";break;case"<":xe=Oe,et=fe,Qe=ke,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,Ve))return!1;for(var ht=0;ht<Ce.set.length;++ht){var Ue=Ce.set[ht],rt=null,ce=null;if(Ue.forEach(function(z){z.semver===N&&(z=new se(">=0.0.0")),rt=rt||z,ce=ce||z,xe(z.semver,rt.semver,Ve)?rt=z:Qe(z.semver,ce.semver,Ve)&&(ce=z)}),rt.operator===nt||rt.operator===st||(!ce.operator||ce.operator===nt)&&et(be,ce.semver)||ce.operator===st&&Qe(be,ce.semver))return!1}return!0}se.prototype.parse=function(be){var Ce=this.loose?P[j]:P[le],Te=be.match(Ce);if(!Te)throw new TypeError("Invalid comparator: "+be);this.operator=Te[1],this.operator==="="&&(this.operator=""),Te[2]?this.semver=new _(Te[2],this.loose):this.semver=N},se.prototype.toString=function(){return this.value},se.prototype.test=function(be){return l("Comparator.test",be,this.loose),this.semver===N||(typeof be=="string"&&(be=new _(be,this.loose)),ue(be,this.operator,this.semver,this.loose))},se.prototype.intersects=function(be,Ce){if(!(be instanceof se))throw new TypeError("a Comparator is required");var Te;if(this.operator==="")return Te=new W(be.value,Ce),we(this.value,Te,Ce);if(be.operator==="")return Te=new W(this.value,Ce),we(be.semver,Te,Ce);var Ve=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),xe=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),et=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),nt=ue(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),st=ue(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return Ve||xe||et&&Qe||nt||st},e.Range=W,W.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},W.prototype.toString=function(){return this.range},W.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),l("range",be,Ce);var Te=Ce?P[Q]:P[q];be=be.replace(Te,Y),l("hyphen replace",be),be=be.replace(P[J],"$1$2$3"),l("comparator trim",be,P[J]),be=(be=(be=be.replace(P[x],"$1~")).replace(P[O],"$1^")).split(/\s+/).join(" ");var Ve=Ce?P[j]:P[le],xe=be.split(" ").map(function(et){return function(Qe,nt){return l("comp",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){l("caret",rt,ce);var z=ce?P[$]:P[U];return rt.replace(z,function(de,Ie,Le,$e,Ke){var Ze;return l("caret",rt,de,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":Ke?(l("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+Ke+" <"+(+Ie+1)+".0.0"):(l("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+Le+"."+(+$e+1):">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+$e+" <"+(+Ie+1)+".0.0"),l("caret return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),l("caret",Qe),Qe=function(st,ht){return st.trim().split(/\s+/).map(function(Ue){return function(rt,ce){var z=ce?P[M]:P[V];return rt.replace(z,function(de,Ie,Le,$e,Ke){var Ze;return l("tilde",rt,de,Ie,Le,$e,Ke),K(Ie)?Ze="":K(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":K($e)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":Ke?(l("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),Ze=">="+Ie+"."+Le+"."+$e+Ke+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+$e+" <"+Ie+"."+(+Le+1)+".0",l("tilde return",Ze),Ze})}(Ue,ht)}).join(" ")}(Qe,nt),l("tildes",Qe),Qe=function(st,ht){return l("replaceXRanges",st,ht),st.split(/\s+/).map(function(Ue){return function(rt,ce){rt=rt.trim();var z=ce?P[w]:P[u];return rt.replace(z,function(de,Ie,Le,$e,Ke,Ze){l("xRange",rt,de,Ie,Le,$e,Ke,Ze);var pt=K(Le),gt=pt||K($e),ct=gt||K(Ke);return Ie==="="&&ct&&(Ie=""),pt?de=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&ct?(gt&&($e=0),ct&&(Ke=0),Ie===">"?(Ie=">=",gt?(Le=+Le+1,$e=0,Ke=0):ct&&($e=+$e+1,Ke=0)):Ie==="<="&&(Ie="<",gt?Le=+Le+1:$e=+$e+1),de=Ie+Le+"."+$e+"."+Ke):gt?de=">="+Le+".0.0 <"+(+Le+1)+".0.0":ct&&(de=">="+Le+"."+$e+".0 <"+Le+"."+(+$e+1)+".0"),l("xRange return",de),de})}(Ue,ht)}).join(" ")}(Qe,nt),l("xrange",Qe),Qe=function(st,ht){return l("replaceStars",st,ht),st.trim().replace(P[Z],"")}(Qe,nt),l("stars",Qe),Qe}(et,Ce)}).join(" ").split(/\s+/);return this.loose&&(xe=xe.filter(function(et){return!!et.match(Ve)})),xe=xe.map(function(et){return new se(et,Ce)})},W.prototype.intersects=function(be,Ce){if(!(be instanceof W))throw new TypeError("a Range is required");return this.set.some(function(Te){return Te.every(function(Ve){return be.set.some(function(xe){return xe.every(function(et){return Ve.intersects(et,Ce)})})})})},e.toComparators=function(be,Ce){return new W(be,Ce).set.map(function(Te){return Te.map(function(Ve){return Ve.value}).join(" ").trim().split(" ")})},W.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new _(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(he(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new W(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==-1||(xe=new _(Ve=Qe,Te)))}),Ve},e.minSatisfying=function(be,Ce,Te){var Ve=null,xe=null;try{var et=new W(Ce,Te)}catch{return null}return be.forEach(function(Qe){et.test(Qe)&&(Ve&&xe.compare(Qe)!==1||(xe=new _(Ve=Qe,Te)))}),Ve},e.validRange=function(be,Ce){try{return new W(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,Te){return Ae(be,Ce,"<",Te)},e.gtr=function(be,Ce,Te){return Ae(be,Ce,">",Te)},e.outside=Ae,e.prerelease=function(be,Ce){var Te=X(be,Ce);return Te&&Te.prerelease.length?Te.prerelease:null},e.intersects=function(be,Ce,Te){return be=new W(be,Te),Ce=new W(Ce,Te),be.intersects(Ce)},e.coerce=function(be){if(be instanceof _)return be;if(typeof be!="string")return null;var Ce=be.match(P[S]);return Ce==null?null:X((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(ne,e){var a,A,l=ne.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function P(h){if(a===setTimeout)return setTimeout(h,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(h,0);try{return a(h,0)}catch{try{return a.call(null,h,0)}catch{return a.call(this,h,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{A=typeof clearTimeout=="function"?clearTimeout:D}catch{A=D}})();var E,k=[],L=!1,T=-1;function v(){L&&E&&(L=!1,E.length?k=E.concat(k):T=-1,k.length&&I())}function I(){if(!L){var h=P(v);L=!0;for(var d=k.length;d;){for(E=k,k=[];++T<d;)E&&E[T].run();T=-1,d=k.length}E=null,L=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===D||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(h)}}function y(h,d){this.fun=h,this.array=d}function f(){}l.nextTick=function(h){var d=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)d[g-1]=arguments[g];k.push(new y(h,d)),k.length!==1||L||P(I)},y.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=f,l.addListener=f,l.once=f,l.off=f,l.removeListener=f,l.removeAllListeners=f,l.emit=f,l.prependListener=f,l.prependOnceListener=f,l.listeners=function(h){return[]},l.binding=function(h){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(h){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ye[103],De([1,0,11,6]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(C){const p=C;return p?typeof p.read=="function":!1}e.isReadable=l;function R(C){const p=C;return p?[p.on,p.pause,p.resume,p.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function D(C){const p=C;return p?R(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(C,p){return new E(C,p)}e.newWriteableStream=P;class E{constructor(p,i){this.e=p,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(p){if(!this.a.destroyed){if(this.a.flowing)this.g(p);else if(this.b.data.push(p),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(p){this.a.destroyed||(this.a.flowing?this.h(p):this.b.error.push(p))}end(p){this.a.destroyed||(typeof p<"u"&&this.write(p),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(p){this.c.data.slice(0).forEach(i=>i(p))}h(p){this.c.error.length===0?(0,a.onUnexpectedError)(p):this.c.error.slice(0).forEach(i=>i(p))}i(){this.c.end.slice(0).forEach(p=>p())}on(p,i){if(!this.a.destroyed)switch(p){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(p,i){if(this.a.destroyed)return;let o;switch(p){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(i);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const p=this.e(this.b.data);this.g(p),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const p of this.b.error)this.h(p);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(C,p){const i=[];let o;for(;(o=C.read())!==null;)i.push(o);return p(i)}e.consumeReadable=k;function L(C,p,i){const o=[];let s;for(;(s=C.read())!==null&&o.length<i;)o.push(s);return s===null&&o.length>0?p(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const c=s;return s=void 0,c}return C.read()}}}e.peekReadable=L;function T(C,p){return new Promise((i,o)=>{const s=[];v(C,{onData:c=>{p&&s.push(c)},onError:c=>{p?o(c):i(void 0)},onEnd:()=>{i(p?p(s):void 0)}})})}e.consumeStream=T;function v(C,p){let i=!1;return C.on("error",o=>{i||p.onError(o)}),C.on("end",()=>{i||p.onEnd()}),C.on("data",o=>{i||p.onData(o)}),(0,A.toDisposable)(()=>i=!0)}e.listenStream=v;function I(C,p){return new Promise((i,o)=>{const s=new A.DisposableStore,c=[],r=t=>{if(c.push(t),c.length>p)return s.dispose(),C.pause(),i({stream:C,buffer:c,ended:!1})},m=t=>o(t),n=()=>i({stream:C,buffer:c,ended:!0});s.add((0,A.toDisposable)(()=>C.removeListener("error",m))),C.on("error",m),s.add((0,A.toDisposable)(()=>C.removeListener("end",n))),C.on("end",n),s.add((0,A.toDisposable)(()=>C.removeListener("data",r))),C.on("data",r)})}e.peekStream=I;function y(C,p){const i=P(p);return i.end(C),i}e.toStream=y;function f(){const C=P(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=f;function h(C){let p=!1;return{read:()=>p?null:(p=!0,C)}}e.toReadable=h;function d(C,p,i){const o=P(i);return v(C,{onData:s=>o.write(p.data(s)),onError:s=>o.error(p.error?p.error(s):s),onEnd:()=>o.end()}),o}e.transform=d;function g(C,p,i){let o=!1;return{read:()=>{const s=p.read();return o?s:(o=!0,s!==null?i([C,s]):C)}}}e.prefixedReadable=g;function b(C,p,i){let o=!1;const s=P(i);return v(p,{onData:c=>o?s.write(c):(o=!0,s.write(i([C,c]))),onError:c=>s.error(c),onEnd:()=>{o||(o=!0,s.write(C)),s.end()}}),s}e.prefixedStream=b}),define(ye[22],De([1,0,103]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let l,R;class D{static alloc(t){return A?new D(Buffer.allocUnsafe(t)):new D(new Uint8Array(t))}static wrap(t){return A&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new D(t)}static fromString(t,u){return!(u?.dontUseNodeBuffer||!1)&&A?new D(Buffer.from(t)):(l||(l=new TextEncoder),new D(l.encode(t)))}static fromByteArray(t){const u=D.alloc(t.length);for(let w=0,S=t.length;w<S;w++)u.buffer[w]=t[w];return u}static concat(t,u){if(typeof u>"u"){u=0;for(let F=0,x=t.length;F<x;F++)u+=t[F].byteLength}const w=D.alloc(u);let S=0;for(let F=0,x=t.length;F<x;F++){const V=t[F];w.set(V,S),S+=V.byteLength}return w}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=D.alloc(this.byteLength);return t.set(this),t}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,u){return new D(this.buffer.subarray(t,u))}set(t,u){if(t instanceof D)this.buffer.set(t.buffer,u);else if(t instanceof Uint8Array)this.buffer.set(t,u);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),u);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return k(this.buffer,t)}writeUInt32BE(t,u){L(this.buffer,t,u)}readUInt32LE(t){return T(this.buffer,t)}writeUInt32LE(t,u){v(this.buffer,t,u)}readUInt8(t){return I(this.buffer,t)}writeUInt8(t,u){y(this.buffer,t,u)}}e.VSBuffer=D;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=P;function E(n,t,u){n[u+0]=t&255,t=t>>>8,n[u+1]=t&255}e.writeUInt16LE=E;function k(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=k;function L(n,t,u){n[u+3]=t,t=t>>>8,n[u+2]=t,t=t>>>8,n[u+1]=t,t=t>>>8,n[u]=t}e.writeUInt32BE=L;function T(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=T;function v(n,t,u){n[u+0]=t&255,t=t>>>8,n[u+1]=t&255,t=t>>>8,n[u+2]=t&255,t=t>>>8,n[u+3]=t&255}e.writeUInt32LE=v;function I(n,t){return n[t]}e.readUInt8=I;function y(n,t,u){n[u]=t}e.writeUInt8=y;function f(n){return a.consumeReadable(n,t=>D.concat(t))}e.readableToBuffer=f;function h(n){return a.toReadable(n)}e.bufferToReadable=h;function d(n){return a.consumeStream(n,t=>D.concat(t))}e.streamToBuffer=d;async function g(n){return n.ended?D.concat(n.buffer):D.concat([...n.buffer,await d(n.stream)])}e.bufferedStreamToBuffer=g;function b(n){return a.toStream(n,t=>D.concat(t))}e.bufferToStream=b;function C(n){return a.transform(n,{data:t=>typeof t=="string"?D.fromString(t):D.wrap(t)},t=>D.concat(t))}e.streamToBufferReadableStream=C;function p(n){return a.newWriteableStream(t=>D.concat(t),n)}e.newWriteableBufferStream=p;function i(n,t){return a.prefixedReadable(n,t,u=>D.concat(u))}e.prefixedBufferReadable=i;function o(n,t){return a.prefixedStream(n,t,u=>D.concat(u))}e.prefixedBufferStream=o;function s(n){let t=0,u=0,w=0;const S=new Uint8Array(Math.floor(n.length/4*3)),F=V=>{switch(u){case 3:S[w++]=t|V,u=0;break;case 2:S[w++]=t|V>>>2,t=V<<6,u=3;break;case 1:S[w++]=t|V>>>4,t=V<<4,u=2;break;default:t=V<<2,u=1}};for(let V=0;V<n.length;V++){const M=n.charCodeAt(V);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const x=w;for(;u>0;)F(0);return D.wrap(S).slice(0,x)}e.decodeBase64=s;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:n},t=!0,u=!1){const w=u?r:c;let S="";const F=n.byteLength%3;let x=0;for(;x<n.byteLength-F;x+=3){const V=n[x+0],M=n[x+1],B=n[x+2];S+=w[V>>>2],S+=w[(V<<4|M>>>4)&63],S+=w[(M<<2|B>>>6)&63],S+=w[B&63]}if(F===1){const V=n[x+0];S+=w[V>>>2],S+=w[V<<4&63],t&&(S+="==")}else if(F===2){const V=n[x+0],M=n[x+1];S+=w[V>>>2],S+=w[(V<<4|M>>>4)&63],S+=w[M<<2&63],t&&(S+="=")}return S}e.encodeBase64=m}),define(ye[148],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[9],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(o){return typeof o=="string"}e.isString=a;function A(o){return Array.isArray(o)&&o.every(s=>a(s))}e.isStringArray=A;function l(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=l;function R(o){const s=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof s}e.isTypedArray=R;function D(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=D;function P(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=P;function E(o){return o===!0||o===!1}e.isBoolean=E;function k(o){return typeof o>"u"}e.isUndefined=k;function L(o){return!T(o)}e.isDefined=L;function T(o){return k(o)||o===null}e.isUndefinedOrNull=T;function v(o,s){if(!o)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.assertType=v;function I(o){if(T(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=I;function y(...o){const s=[];for(let c=0;c<o.length;c++){const r=o[c];if(T(r))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);s.push(r)}return s}e.assertAllDefined=y;const f=Object.prototype.hasOwnProperty;function h(o){if(!l(o))return!1;for(const s in o)if(f.call(o,s))return!1;return!0}e.isEmptyObject=h;function d(o){return typeof o=="function"}e.isFunction=d;function g(...o){return o.length>0&&o.every(d)}e.areFunctions=g;function b(o,s){const c=Math.min(o.length,s.length);for(let r=0;r<c;r++)C(o[r],s[r])}e.validateConstraints=b;function C(o,s){if(a(s)){if(typeof o!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(d(s)){try{if(o instanceof s)return}catch{}if(!T(o)&&o.constructor===s||s.length===1&&s.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=C;function p(o){return o===null?void 0:o}e.withNullAsUndefined=p;function i(o){return typeof o>"u"?null:o}e.withUndefinedAsNull=i}),define(ye[67],De([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(P,E){if((0,a.isString)(E)){const k=A[E];if(k===void 0)throw new Error(`${P} references an unknown codicon: ${E}`);E=k}return A[P]=E,{id:P}}function R(){return A}e.getCodiconFontCharacters=R;function D(){return Object.values(e.Codicon)}e.getAllCodicons=D,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ye[23],De([1,0,9]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([b,C])=>{g[b]=C&&typeof C=="object"?A(C):C}),g}e.deepClone=A;function l(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const b=g.shift();Object.freeze(b);for(const C in b)if(R.call(b,C)){const p=b[C];typeof p=="object"&&!Object.isFrozen(p)&&!(0,a.isTypedArray)(p)&&g.push(p)}}return d}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function D(d,g){return P(d,g,new Set)}e.cloneAndChange=D;function P(d,g,b){if((0,a.isUndefinedOrNull)(d))return d;const C=g(d);if(typeof C<"u")return C;if(Array.isArray(d)){const p=[];for(const i of d)p.push(P(i,g,b));return p}if((0,a.isObject)(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const p={};for(const i in d)R.call(d,i)&&(p[i]=P(d[i],g,b));return b.delete(d),p}return d}function E(d,g,b=!0){return(0,a.isObject)(d)?((0,a.isObject)(g)&&Object.keys(g).forEach(C=>{C in d?b&&((0,a.isObject)(d[C])&&(0,a.isObject)(g[C])?E(d[C],g[C],b):d[C]=g[C]):d[C]=g[C]}),d):g}e.mixin=E;function k(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let b,C;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(b=0;b<d.length;b++)if(!k(d[b],g[b]))return!1}else{const p=[];for(C in d)p.push(C);p.sort();const i=[];for(C in g)i.push(C);if(i.sort(),!k(p,i))return!1;for(b=0;b<p.length;b++)if(!k(d[p[b]],g[p[b]]))return!1}return!0}e.equals=k;function L(d){const g=new Set;return JSON.stringify(d,(b,C)=>{if((0,a.isObject)(C)||Array.isArray(C)){if(g.has(C))return"[Circular]";g.add(C)}return C})}e.safeStringify=L;function T(d,g){const b=Object.create(null);return!d||!g||Object.keys(g).forEach(p=>{const i=d[p],o=g[p];k(i,o)||(b[p]=o)}),b}e.distinct=T;function v(d,g){const b=g.toLowerCase(),C=Object.keys(d).find(p=>p.toLowerCase()===b);return C?d[C]:d[g]}e.getCaseInsensitive=v;function I(d,g){const b=Object.create(null);for(const[C,p]of Object.entries(d))g(C,p)&&(b[C]=p);return b}e.filter=I;function y(d){let g=[],b=Object.getPrototypeOf(d);for(;Object.prototype!==b;)g=g.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return g}e.getAllPropertyNames=y;function f(d){const g=[];for(const b of y(d))typeof d[b]=="function"&&g.push(b);return g}e.getAllMethodNames=f;function h(d,g){const b=p=>function(){const i=Array.prototype.slice.call(arguments,0);return g(p,i)},C={};for(const p of d)C[p]=b(p);return C}e.createProxyObject=h}),define(ye[51],De([1,0,67]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(D){function P(E){return E&&typeof E=="object"&&typeof E.id=="string"}D.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function l(D){return{id:D}}e.themeColorFromId=l;var R;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function E(g){const b=P.exec(g.id);if(!b)return E(a.Codicon.error);const[,C,p]=b,i=["codicon","codicon-"+C];return p&&i.push("codicon-modifier-"+p.substring(1)),i}D.asClassNameArray=E;function k(g){return E(g).join(" ")}D.asClassName=k;function L(g){return"."+E(g).join(".")}D.asCSSSelector=L;function T(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}D.isThemeIcon=T;const v=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function I(g){const b=v.exec(g);if(!b)return;const[,C]=b;return{id:C}}D.fromString=I;function y(g){return{id:g}}D.fromId=y;function f(g,b){let C=g.id;const p=C.lastIndexOf("~");return p!==-1&&(C=C.substring(0,p)),b&&(C=`${C}~${b}`),{id:C}}D.modify=f;function h(g){const b=g.id.lastIndexOf("~");if(b!==-1)return g.id.substring(b+1)}D.getModifier=h;function d(g,b){return g.id===b.id&&g.color?.id===b.color?.id}D.isEqual=d})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[104],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function A(R){return R<0?0:R>255?255:R|0}e.toUint8=A;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(ye[30],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return a.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let E=0;E<P.length;E++)P[E]=Math.floor(Math.random()*256);return P};const R=new Uint8Array(16),D=[];for(let P=0;P<256;P++)D.push(P.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let E=0,k="";return k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k+="-",k+=D[R[E++]],k+=D[R[E++]],k+="-",k+=D[R[E++]],k+=D[R[E++]],k+="-",k+=D[R[E++]],k+=D[R[E++]],k+="-",k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k+=D[R[E++]],k}}()}),define(ye[149],De([1,0,15,30]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=l;function R(P,E,k){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:E,data:k}),value:void 0}}e.createFileDataTransferItem=R;class D{constructor(){this.a=new Map}get size(){return this.a.size}has(E){return this.a.has(this.b(E))}get(E){return this.a.get(this.b(E))?.[0]}append(E,k){const L=this.a.get(E);L?L.push(k):this.a.set(this.b(E),[k])}replace(E,k){this.a.set(this.b(E),[k])}delete(E){this.a.delete(this.b(E))}*entries(){for(const[E,k]of this.a.entries())for(const L of k)yield[E,L]}values(){return Array.from(this.a.values()).flat()}forEach(E){for(const[k,L]of this.entries())E(L,k)}b(E){return E.toLowerCase()}}e.VSDataTransfer=D,e.UriList=Object.freeze({create:P=>(0,a.distinct)(P.map(E=>E.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(E=>!E.startsWith("#"))})}),define(ye[105],De([1,0,104]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class A{constructor(P){const E=(0,a.toUint8)(P);this.c=E,this.a=A.d(E),this.b=new Map}static d(P){const E=new Uint8Array(256);return E.fill(P),E}set(P,E){const k=(0,a.toUint8)(E);P>=0&&P<256?this.a[P]=k:this.b.set(P,k)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=A;var l;(function(D){D[D.False=0]="False",D[D.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new A(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[52],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new a(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return a.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return a.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return a.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const D=l.lineNumber|0,P=R.lineNumber|0;if(D===P){const E=l.column|0,k=R.column|0;return E-k}return D-P}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new a(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=a}),define(ye[32],De([1,0,52]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(R,D,P,E){R>P||R===P&&D>E?(this.startLineNumber=P,this.startColumn=E,this.endLineNumber=R,this.endColumn=D):(this.startLineNumber=R,this.startColumn=D,this.endLineNumber=P,this.endColumn=E)}isEmpty(){return A.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return A.containsPosition(this,R)}static containsPosition(R,D){return!(D.lineNumber<R.startLineNumber||D.lineNumber>R.endLineNumber||D.lineNumber===R.startLineNumber&&D.column<R.startColumn||D.lineNumber===R.endLineNumber&&D.column>R.endColumn)}static strictContainsPosition(R,D){return!(D.lineNumber<R.startLineNumber||D.lineNumber>R.endLineNumber||D.lineNumber===R.startLineNumber&&D.column<=R.startColumn||D.lineNumber===R.endLineNumber&&D.column>=R.endColumn)}containsRange(R){return A.containsRange(this,R)}static containsRange(R,D){return!(D.startLineNumber<R.startLineNumber||D.endLineNumber<R.startLineNumber||D.startLineNumber>R.endLineNumber||D.endLineNumber>R.endLineNumber||D.startLineNumber===R.startLineNumber&&D.startColumn<R.startColumn||D.endLineNumber===R.endLineNumber&&D.endColumn>R.endColumn)}strictContainsRange(R){return A.strictContainsRange(this,R)}static strictContainsRange(R,D){return!(D.startLineNumber<R.startLineNumber||D.endLineNumber<R.startLineNumber||D.startLineNumber>R.endLineNumber||D.endLineNumber>R.endLineNumber||D.startLineNumber===R.startLineNumber&&D.startColumn<=R.startColumn||D.endLineNumber===R.endLineNumber&&D.endColumn>=R.endColumn)}plusRange(R){return A.plusRange(this,R)}static plusRange(R,D){let P,E,k,L;return D.startLineNumber<R.startLineNumber?(P=D.startLineNumber,E=D.startColumn):D.startLineNumber===R.startLineNumber?(P=D.startLineNumber,E=Math.min(D.startColumn,R.startColumn)):(P=R.startLineNumber,E=R.startColumn),D.endLineNumber>R.endLineNumber?(k=D.endLineNumber,L=D.endColumn):D.endLineNumber===R.endLineNumber?(k=D.endLineNumber,L=Math.max(D.endColumn,R.endColumn)):(k=R.endLineNumber,L=R.endColumn),new A(P,E,k,L)}intersectRanges(R){return A.intersectRanges(this,R)}static intersectRanges(R,D){let P=R.startLineNumber,E=R.startColumn,k=R.endLineNumber,L=R.endColumn;const T=D.startLineNumber,v=D.startColumn,I=D.endLineNumber,y=D.endColumn;return P<T?(P=T,E=v):P===T&&(E=Math.max(E,v)),k>I?(k=I,L=y):k===I&&(L=Math.min(L,y)),P>k||P===k&&E>L?null:new A(P,E,k,L)}equalsRange(R){return A.equalsRange(this,R)}static equalsRange(R,D){return!R&&!D?!0:!!R&&!!D&&R.startLineNumber===D.startLineNumber&&R.startColumn===D.startColumn&&R.endLineNumber===D.endLineNumber&&R.endColumn===D.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,D){return new A(this.startLineNumber,this.startColumn,R,D)}setStartPosition(R,D){return new A(R,D,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(R){return new A(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(R){return new A(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new A(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,D=R){return new A(R.lineNumber,R.column,D.lineNumber,D.column)}static lift(R){return R?new A(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,D){return!(R.endLineNumber<D.startLineNumber||R.endLineNumber===D.startLineNumber&&R.endColumn<D.startColumn||D.endLineNumber<R.startLineNumber||D.endLineNumber===R.startLineNumber&&D.endColumn<R.startColumn)}static areIntersecting(R,D){return!(R.endLineNumber<D.startLineNumber||R.endLineNumber===D.startLineNumber&&R.endColumn<=D.startColumn||D.endLineNumber<R.startLineNumber||D.endLineNumber===R.startLineNumber&&D.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,D){if(R&&D){const k=R.startLineNumber|0,L=D.startLineNumber|0;if(k===L){const T=R.startColumn|0,v=D.startColumn|0;if(T===v){const I=R.endLineNumber|0,y=D.endLineNumber|0;if(I===y){const f=R.endColumn|0,h=D.endColumn|0;return f-h}return I-y}return T-v}return k-L}return(R?1:0)-(D?1:0)}static compareRangesUsingEnds(R,D){return R.endLineNumber===D.endLineNumber?R.endColumn===D.endColumn?R.startLineNumber===D.startLineNumber?R.startColumn-D.startColumn:R.startLineNumber-D.startLineNumber:R.endColumn-D.endColumn:R.endLineNumber-D.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=A}),define(ye[150],De([1,0,52,32]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(D){D[D.LTR=0]="LTR",D[D.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class R extends A.Range{constructor(P,E,k,L){super(P,E,k,L),this.selectionStartLineNumber=P,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return R.selectionsEqual(this,P)}static selectionsEqual(P,E){return P.selectionStartLineNumber===E.selectionStartLineNumber&&P.selectionStartColumn===E.selectionStartColumn&&P.positionLineNumber===E.positionLineNumber&&P.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,E){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,P,E):new R(P,E,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,E){return this.getDirection()===0?new R(P,E,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,P,E)}static fromPositions(P,E=P){return new R(P.lineNumber,P.column,E.lineNumber,E.column)}static fromRange(P,E){return E===0?new R(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new R(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new R(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,E){if(P&&!E||!P&&E)return!1;if(!P&&!E)return!0;if(P.length!==E.length)return!1;for(let k=0,L=P.length;k<L;k++)if(!this.selectionsEqual(P[k],E[k]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,E,k,L,T){return T===0?new R(P,E,k,L):new R(k,L,P,E)}}e.Selection=R}),define(ye[151],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[152],De([1,0,105]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var A;(function(D){D[D.Regular=0]="Regular",D[D.Whitespace=1]="Whitespace",D[D.WordSeparator=2]="WordSeparator"})(A=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends a.CharacterClassifier{constructor(P){super(0);for(let E=0,k=P.length;E<k;E++)this.set(P.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(D){const P={};return E=>(P.hasOwnProperty(E)||(P[E]=D(E)),P[E])}e.getMapForWordSeparators=R(D=>new l(D))}),define(ye[106],De([1,0,64,6,66]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(T=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const I of e.USUAL_WORD_SEPARATORS)T.indexOf(I)>=0||(v+="\\"+I);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function D(T){let v=e.DEFAULT_WORD_REGEXP;if(T&&T instanceof RegExp)if(T.global)v=T;else{let I="g";T.ignoreCase&&(I+="i"),T.multiline&&(I+="m"),T.unicode&&(I+="u"),v=new RegExp(T.source,I)}return v.lastIndex=0,v}e.ensureValidWordDefinition=D;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(T){const v=P.unshift(T);return(0,A.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=E;function k(T,v,I,y,f){if(f||(f=a.Iterable.first(P)),I.length>f.maxLen){let C=T-f.maxLen/2;return C<0?C=0:y+=C,I=I.substring(C,T+f.maxLen/2),k(T,v,I,y,f)}const h=Date.now(),d=T-1-y;let g=-1,b=null;for(let C=1;!(Date.now()-h>=f.timeBudget);C++){const p=d-f.windowSize*C;v.lastIndex=Math.max(0,p);const i=L(v,I,d,g);if(!i&&b||(b=i,p<=0))break;g=p}if(b){const C={word:b[0],startColumn:y+1+b.index,endColumn:y+1+b.index+b[0].length};return v.lastIndex=0,C}return null}e.getWordAtText=k;function L(T,v,I,y){let f;for(;f=T.exec(v);){const h=f.index||0;if(h<=I&&T.lastIndex>=I)return f;if(y>0&&h>y)return null}return null}}),define(ye[153],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class A{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let E=0,k=P.notIn.length;E<k;E++)switch(P.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,E){if(P.getTokenCount()===0)return!0;const k=P.findTokenIndexAtOffset(E-2),L=P.getStandardTokenType(k);return this.isOK(L)}g(P,E){for(let k=P;k<=E;k++){const L=String.fromCharCode(k);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=A;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of P)R(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),R(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),R(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),R(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&R(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=l;function R(D,P,E){D.has(P)?D.get(P).push(E):D.set(P,[E])}}),define(ye[154],De([1,0,105]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var A;(function(I){I[I.Invalid=0]="Invalid",I[I.Start=1]="Start",I[I.H=2]="H",I[I.HT=3]="HT",I[I.HTT=4]="HTT",I[I.HTTP=5]="HTTP",I[I.F=6]="F",I[I.FI=7]="FI",I[I.FIL=8]="FIL",I[I.BeforeColon=9]="BeforeColon",I[I.AfterColon=10]="AfterColon",I[I.AlmostThere=11]="AlmostThere",I[I.End=12]="End",I[I.Accept=13]="Accept",I[I.LastKnownState=14]="LastKnownState"})(A=e.State||(e.State={}));class l{constructor(y,f,h){const d=new Uint8Array(y*f);for(let g=0,b=y*f;g<b;g++)d[g]=h;this.a=d,this.rows=y,this.cols=f}get(y,f){return this.a[y*this.cols+f]}set(y,f,h){this.a[y*this.cols+f]=h}}class R{constructor(y){let f=0,h=0;for(let g=0,b=y.length;g<b;g++){const[C,p,i]=y[g];p>f&&(f=p),C>h&&(h=C),i>h&&(h=i)}f++,h++;const d=new l(h,f,0);for(let g=0,b=y.length;g<b;g++){const[C,p,i]=y[g];d.set(C,p,i)}this.a=d,this.b=f}nextState(y,f){return f<0||f>=this.b?0:this.a.get(y,f)}}e.StateMachine=R;let D=null;function P(){return D===null&&(D=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),D}var E;(function(I){I[I.None=0]="None",I[I.ForceTermination=1]="ForceTermination",I[I.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function L(){if(k===null){k=new a.CharacterClassifier(0);const I=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<I.length;f++)k.set(I.charCodeAt(f),1);const y=".;:";for(let f=0;f<y.length;f++)k.set(y.charCodeAt(f),2)}return k}class T{static a(y,f,h,d,g){let b=g-1;do{const C=f.charCodeAt(b);if(y.get(C)!==2)break;b--}while(b>d);if(d>0){const C=f.charCodeAt(d-1),p=f.charCodeAt(b);(C===40&&p===41||C===91&&p===93||C===123&&p===125)&&b--}return{range:{startLineNumber:h,startColumn:d+1,endLineNumber:h,endColumn:b+2},url:f.substring(d,b+1)}}static computeLinks(y,f=P()){const h=L(),d=[];for(let g=1,b=y.getLineCount();g<=b;g++){const C=y.getLineContent(g),p=C.length;let i=0,o=0,s=0,c=1,r=!1,m=!1,n=!1,t=!1;for(;i<p;){let u=!1;const w=C.charCodeAt(i);if(c===13){let S;switch(w){case 40:r=!0,S=0;break;case 41:S=r?0:1;break;case 91:n=!0,m=!0,S=0;break;case 93:n=!1,S=m?0:1;break;case 123:t=!0,S=0;break;case 125:S=t?0:1;break;case 39:case 34:case 96:s===w?S=1:s===39||s===34||s===96?S=0:S=1;break;case 42:S=s===42?1:0;break;case 124:S=s===124?1:0;break;case 32:S=n?0:1;break;default:S=h.get(w)}S===1&&(d.push(T.a(h,C,g,o,i)),u=!0)}else if(c===12){let S;w===91?(m=!0,S=0):S=h.get(w),S===1?u=!0:c=13}else c=f.nextState(c,w),c===0&&(u=!0);u&&(c=1,r=!1,m=!1,t=!1,o=i+1,s=w),i++}c===13&&d.push(T.a(h,C,g,o,p))}return d}}e.LinkComputer=T;function v(I){return!I||typeof I.getLineCount!="function"||typeof I.getLineContent!="function"?[]:T.computeLinks(I)}e.computeLinks=v}),define(ye[107],De([1,0,23]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var A;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(A=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var D;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var P;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(P=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var E;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(E=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class L{constructor(C,p){this._findMatchBrand=void 0,this.range=C,this.matches=p}}e.FindMatch=L;var T;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(T=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var I;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(I=e.PositionAffinity||(e.PositionAffinity={}));var y;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(y=e.ModelConstants||(e.ModelConstants={}));class f{constructor(C,p,i,o,s,c){this.identifier=C,this.range=p,this.text=i,this.forceMoveMarkers=o,this.isAutoWhitespaceEdit=s,this._isTracked=c}}e.ValidAnnotatedEditOperation=f;class h{constructor(C,p,i){this.regex=C,this.wordSeparators=p,this.simpleSearch=i}}e.SearchData=h;class d{constructor(C,p,i){this.reverseEdits=C,this.changes=p,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=d;function g(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=g}),define(ye[155],De([1,0,15,104]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,k){E=(0,A.toUint32)(E);const L=this.a,T=this.b,v=k.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E),E+v),this.a.set(k,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}setValue(E,k){return E=(0,A.toUint32)(E),k=(0,A.toUint32)(k),this.a[E]===k?!1:(this.a[E]=k,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,k){E=(0,A.toUint32)(E),k=(0,A.toUint32)(k);const L=this.a,T=this.b;if(E>=L.length)return!1;const v=L.length-E;return k>=v&&(k=v),k===0?!1:(this.a=new Uint32Array(L.length-k),this.a.set(L.subarray(0,E),0),this.a.set(L.subarray(E+k),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(T.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,A.toUint32)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),E>=this.a.length&&(E=this.a.length-1);for(let L=k;L<=E;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let k=0,L=this.a.length-1,T=0,v=0,I=0;for(;k<=L;)if(T=k+(L-k)/2|0,v=this.b[T],I=v-this.a[T],E<I)L=T-1;else if(E>=v)k=T+1;else break;return new D(T,E-I)}}e.PrefixSumComputer=l;class R{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const k=this.e[E],L=k>0?this.d[k-1]:0;return new D(k,E-L)}removeValues(E,k){this.a.splice(E,k),this.f(E)}insertValues(E,k){this.a=(0,a.arrayInsert)(this.a,E,k),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,k=this.a.length;E<k;E++){const L=this.a[E],T=E>0?this.d[E-1]:0;this.d[E]=T+L;for(let v=0;v<L;v++)this.e[T+v]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,k){this.a[E]!==k&&(this.a[E]=k,this.f(E))}}e.ConstantTimePrefixSumComputer=R;class D{constructor(E,k){this.index=E,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=k}}e.PrefixSumIndexOfResult=D}),define(ye[156],De([17,18]),function(ne,e){return ne.create("vs/base/common/actions",e)}),define(ye[157],De([17,18]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ye[158],De([1,0,157]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,R=l*24,D=R*7,P=R*30,E=R*365;function k(T,v,I,y){typeof T!="number"&&(T=T.getTime());const f=Math.round((new Date().getTime()-T)/1e3);if(f<-30)return(0,a.localize)(0,null,k(new Date().getTime()+f*1e3,!1));if(!y&&f<30)return(0,a.localize)(1,null);let h;return f<A?(h=f,v?h===1?I?(0,a.localize)(2,null,h):(0,a.localize)(3,null,h):I?(0,a.localize)(4,null,h):(0,a.localize)(5,null,h):h===1?I?(0,a.localize)(6,null,h):(0,a.localize)(7,null,h):I?(0,a.localize)(8,null,h):(0,a.localize)(9,null,h)):f<l?(h=Math.floor(f/A),v?h===1?I?(0,a.localize)(10,null,h):(0,a.localize)(11,null,h):I?(0,a.localize)(12,null,h):(0,a.localize)(13,null,h):h===1?I?(0,a.localize)(14,null,h):(0,a.localize)(15,null,h):I?(0,a.localize)(16,null,h):(0,a.localize)(17,null,h)):f<R?(h=Math.floor(f/l),v?h===1?I?(0,a.localize)(18,null,h):(0,a.localize)(19,null,h):I?(0,a.localize)(20,null,h):(0,a.localize)(21,null,h):h===1?I?(0,a.localize)(22,null,h):(0,a.localize)(23,null,h):I?(0,a.localize)(24,null,h):(0,a.localize)(25,null,h)):f<D?(h=Math.floor(f/R),v?h===1?(0,a.localize)(26,null,h):(0,a.localize)(27,null,h):h===1?(0,a.localize)(28,null,h):(0,a.localize)(29,null,h)):f<P?(h=Math.floor(f/D),v?h===1?I?(0,a.localize)(30,null,h):(0,a.localize)(31,null,h):I?(0,a.localize)(32,null,h):(0,a.localize)(33,null,h):h===1?I?(0,a.localize)(34,null,h):(0,a.localize)(35,null,h):I?(0,a.localize)(36,null,h):(0,a.localize)(37,null,h)):f<E?(h=Math.floor(f/P),v?h===1?I?(0,a.localize)(38,null,h):(0,a.localize)(39,null,h):I?(0,a.localize)(40,null,h):(0,a.localize)(41,null,h):h===1?I?(0,a.localize)(42,null,h):(0,a.localize)(43,null,h):I?(0,a.localize)(44,null,h):(0,a.localize)(45,null,h)):(h=Math.floor(f/E),v?h===1?I?(0,a.localize)(46,null,h):(0,a.localize)(47,null,h):I?(0,a.localize)(48,null,h):(0,a.localize)(49,null,h):h===1?I?(0,a.localize)(50,null,h):(0,a.localize)(51,null,h):I?(0,a.localize)(52,null,h):(0,a.localize)(53,null,h))}e.fromNow=k;function L(T){return T.getFullYear()+"-"+String(T.getMonth()+1).padStart(2,"0")+"-"+String(T.getDate()).padStart(2,"0")+"T"+String(T.getHours()).padStart(2,"0")+":"+String(T.getMinutes()).padStart(2,"0")+":"+String(T.getSeconds()).padStart(2,"0")+"."+(T.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[159],De([17,18]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,9,159]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(T,v){return v&&(T.stack||T.stacktrace)?l.localize(0,null,P(T),D(T.stack)||D(T.stacktrace)):P(T)}function D(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?l.localize(1,null,T.message):T.message||l.localize(2,null)}function E(T=null,v=!1){if(!T)return l.localize(3,null);if(Array.isArray(T)){const I=a.coalesce(T),y=E(I[0],v);return I.length>1?l.localize(4,null,y,I.length):y}if(A.isString(T))return T;if(T.detail){const I=T.detail;if(I.error)return R(I.error,v);if(I.exception)return R(I.exception,v)}return T.stack?R(T,v):T.message?T.message:l.localize(5,null)}e.toErrorMessage=E;function k(T){const v=T;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=k;function L(T,v){let I;return typeof T=="string"?I=new Error(T):I=T,I.actions=v,I}e.createErrorWithActions=L}),define(ye[160],De([17,18]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ye[12],De([1,0,160]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let A=!1,l=!1,R=!1,D=!1,P=!1,E=!1,k=!1,L=!1,T=!1,v=!1,I,y=e.LANGUAGE_DEFAULT,f,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?d=e.globals.vscode.process:typeof process<"u"&&(d=process);const g=typeof d?.versions?.electron=="string",b=g&&d?.type==="renderer";if(typeof navigator=="object"&&!b)h=navigator.userAgent,A=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,L=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,v=h?.indexOf("Mobi")>=0,E=!0,I=a.getConfiguredDefaultLocale(a.localize(0,null))||e.LANGUAGE_DEFAULT,y=I;else if(typeof d=="object"){A=d.platform==="win32",l=d.platform==="darwin",R=d.platform==="linux",D=R&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,k=g,T=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const n=d.env.VSCODE_NLS_CONFIG;if(n)try{const t=JSON.parse(n),u=t.availableLanguages["*"];I=t.locale,y=u||e.LANGUAGE_DEFAULT,f=t._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var C;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(C=e.Platform||(e.Platform={}));function p(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let i=0;l?i=1:A?i=3:R&&(i=2),e.isWindows=A,e.isMacintosh=l,e.isLinux=R,e.isLinuxSnap=D,e.isNative=P,e.isElectron=k,e.isWeb=E,e.isWebWorker=E&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=T,e.platform=i,e.userAgent=h,e.language=y;var o;(function(n){function t(){return e.language}n.value=t;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=u;function w(){return e.language==="en"}n.isDefault=w})(o=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let w=0,S=n.length;w<S;w++){const F=n[w];if(F.id===u.data.vscodeScheduleAsyncWork){n.splice(w,1),F.callback();return}}});let t=0;return u=>{const w=++t;n.push({id:w,callback:u}),e.globals.postMessage({vscodeScheduleAsyncWork:w},"*")}}return n=>setTimeout(n)})();var s;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||L?2:A?1:3;let c=!0,r=!1;function m(){if(!r){r=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,c=new Uint16Array(n.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=m,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const l=a.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(ye[10],De([1,0,36]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,R=90,D=122,P=46,E=47,k=92,L=58,T=63;class v extends Error{constructor(o,s,c){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const m=o.indexOf(".")!==-1?"property":"argument";let n=`The "${o}" ${m} ${r} of type ${s}`;n+=`. Received type ${typeof c}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function I(i,o){if(i===null||typeof i!="object")throw new v(o,"Object",i)}function y(i,o){if(typeof i!="string")throw new v(o,"string",i)}const f=a.platform==="win32";function h(i){return i===E||i===k}function d(i){return i===E}function g(i){return i>=A&&i<=R||i>=l&&i<=D}function b(i,o,s,c){let r="",m=0,n=-1,t=0,u=0;for(let w=0;w<=i.length;++w){if(w<i.length)u=i.charCodeAt(w);else{if(c(u))break;u=E}if(c(u)){if(!(n===w-1||t===1))if(t===2){if(r.length<2||m!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const S=r.lastIndexOf(s);S===-1?(r="",m=0):(r=r.slice(0,S),m=r.length-1-r.lastIndexOf(s)),n=w,t=0;continue}else if(r.length!==0){r="",m=0,n=w,t=0;continue}}o&&(r+=r.length>0?`${s}..`:"..",m=2)}else r.length>0?r+=`${s}${i.slice(n+1,w)}`:r=i.slice(n+1,w),m=w-n-1;n=w,t=0}else u===P&&t!==-1?++t:t=-1}return r}function C(i,o){I(o,"pathObject");const s=o.dir||o.root,c=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${c}`:`${s}${i}${c}`:c}e.win32={resolve(...i){let o="",s="",c=!1;for(let r=i.length-1;r>=-1;r--){let m;if(r>=0){if(m=i[r],y(m,"path"),m.length===0)continue}else o.length===0?m=a.cwd():(m=a.env[`=${o}`]||a.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==o.toLowerCase()&&m.charCodeAt(2)===k)&&(m=`${o}\\`));const n=m.length;let t=0,u="",w=!1;const S=m.charCodeAt(0);if(n===1)h(S)&&(t=1,w=!0);else if(h(S))if(w=!0,h(m.charCodeAt(1))){let F=2,x=F;for(;F<n&&!h(m.charCodeAt(F));)F++;if(F<n&&F!==x){const V=m.slice(x,F);for(x=F;F<n&&h(m.charCodeAt(F));)F++;if(F<n&&F!==x){for(x=F;F<n&&!h(m.charCodeAt(F));)F++;(F===n||F!==x)&&(u=`\\\\${V}\\${m.slice(x,F)}`,t=F)}}}else t=1;else g(S)&&m.charCodeAt(1)===L&&(u=m.slice(0,2),t=2,n>2&&h(m.charCodeAt(2))&&(w=!0,t=3));if(u.length>0)if(o.length>0){if(u.toLowerCase()!==o.toLowerCase())continue}else o=u;if(c){if(o.length>0)break}else if(s=`${m.slice(t)}\\${s}`,c=w,w&&o.length>0)break}return s=b(s,!c,"\\",h),c?`${o}\\${s}`:`${o}${s}`||"."},normalize(i){y(i,"path");const o=i.length;if(o===0)return".";let s=0,c,r=!1;const m=i.charCodeAt(0);if(o===1)return d(m)?"\\":i;if(h(m))if(r=!0,h(i.charCodeAt(1))){let t=2,u=t;for(;t<o&&!h(i.charCodeAt(t));)t++;if(t<o&&t!==u){const w=i.slice(u,t);for(u=t;t<o&&h(i.charCodeAt(t));)t++;if(t<o&&t!==u){for(u=t;t<o&&!h(i.charCodeAt(t));)t++;if(t===o)return`\\\\${w}\\${i.slice(u)}\\`;t!==u&&(c=`\\\\${w}\\${i.slice(u,t)}`,s=t)}}}else s=1;else g(m)&&i.charCodeAt(1)===L&&(c=i.slice(0,2),s=2,o>2&&h(i.charCodeAt(2))&&(r=!0,s=3));let n=s<o?b(i.slice(s),!r,"\\",h):"";return n.length===0&&!r&&(n="."),n.length>0&&h(i.charCodeAt(o-1))&&(n+="\\"),c===void 0?r?`\\${n}`:n:r?`${c}\\${n}`:`${c}${n}`},isAbsolute(i){y(i,"path");const o=i.length;if(o===0)return!1;const s=i.charCodeAt(0);return h(s)||o>2&&g(s)&&i.charCodeAt(1)===L&&h(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,s;for(let m=0;m<i.length;++m){const n=i[m];y(n,"path"),n.length>0&&(o===void 0?o=s=n:o+=`\\${n}`)}if(o===void 0)return".";let c=!0,r=0;if(typeof s=="string"&&h(s.charCodeAt(0))){++r;const m=s.length;m>1&&h(s.charCodeAt(1))&&(++r,m>2&&(h(s.charCodeAt(2))?++r:c=!1))}if(c){for(;r<o.length&&h(o.charCodeAt(r));)r++;r>=2&&(o=`\\${o.slice(r)}`)}return e.win32.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o)return"";const s=e.win32.resolve(i),c=e.win32.resolve(o);if(s===c||(i=s.toLowerCase(),o=c.toLowerCase(),i===o))return"";let r=0;for(;r<i.length&&i.charCodeAt(r)===k;)r++;let m=i.length;for(;m-1>r&&i.charCodeAt(m-1)===k;)m--;const n=m-r;let t=0;for(;t<o.length&&o.charCodeAt(t)===k;)t++;let u=o.length;for(;u-1>t&&o.charCodeAt(u-1)===k;)u--;const w=u-t,S=n<w?n:w;let F=-1,x=0;for(;x<S;x++){const M=i.charCodeAt(r+x);if(M!==o.charCodeAt(t+x))break;M===k&&(F=x)}if(x!==S){if(F===-1)return c}else{if(w>S){if(o.charCodeAt(t+x)===k)return c.slice(t+x+1);if(x===2)return c.slice(t+x)}n>S&&(i.charCodeAt(r+x)===k?F=x:x===2&&(F=3)),F===-1&&(F=0)}let V="";for(x=r+F+1;x<=m;++x)(x===m||i.charCodeAt(x)===k)&&(V+=V.length===0?"..":"\\..");return t+=F,V.length>0?`${V}${c.slice(t,u)}`:(c.charCodeAt(t)===k&&++t,c.slice(t,u))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.win32.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===k){if(o.charCodeAt(1)===k){const s=o.charCodeAt(2);if(s!==T&&s!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(g(o.charCodeAt(0))&&o.charCodeAt(1)===L&&o.charCodeAt(2)===k)return`\\\\?\\${o}`;return i},dirname(i){y(i,"path");const o=i.length;if(o===0)return".";let s=-1,c=0;const r=i.charCodeAt(0);if(o===1)return h(r)?i:".";if(h(r)){if(s=c=1,h(i.charCodeAt(1))){let t=2,u=t;for(;t<o&&!h(i.charCodeAt(t));)t++;if(t<o&&t!==u){for(u=t;t<o&&h(i.charCodeAt(t));)t++;if(t<o&&t!==u){for(u=t;t<o&&!h(i.charCodeAt(t));)t++;if(t===o)return i;t!==u&&(s=c=t+1)}}}}else g(r)&&i.charCodeAt(1)===L&&(s=o>2&&h(i.charCodeAt(2))?3:2,c=s);let m=-1,n=!0;for(let t=o-1;t>=c;--t)if(h(i.charCodeAt(t))){if(!n){m=t;break}}else n=!1;if(m===-1){if(s===-1)return".";m=s}return i.slice(0,m)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let s=0,c=-1,r=!0,m;if(i.length>=2&&g(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(s=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=s;--m){const u=i.charCodeAt(m);if(h(u)){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(u===o.charCodeAt(n)?--n===-1&&(c=m):(n=-1,c=t))}return s===c?c=t:c===-1&&(c=i.length),i.slice(s,c)}for(m=i.length-1;m>=s;--m)if(h(i.charCodeAt(m))){if(!r){s=m+1;break}}else c===-1&&(r=!1,c=m+1);return c===-1?"":i.slice(s,c)},extname(i){y(i,"path");let o=0,s=-1,c=0,r=-1,m=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&g(i.charCodeAt(0))&&(o=c=2);for(let t=i.length-1;t>=o;--t){const u=i.charCodeAt(t);if(h(u)){if(!m){c=t+1;break}continue}r===-1&&(m=!1,r=t+1),u===P?s===-1?s=t:n!==1&&(n=1):s!==-1&&(n=-1)}return s===-1||r===-1||n===0||n===1&&s===r-1&&s===c+1?"":i.slice(s,r)},format:C.bind(null,"\\"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.length;let c=0,r=i.charCodeAt(0);if(s===1)return h(r)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(h(r)){if(c=1,h(i.charCodeAt(1))){let F=2,x=F;for(;F<s&&!h(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&h(i.charCodeAt(F));)F++;if(F<s&&F!==x){for(x=F;F<s&&!h(i.charCodeAt(F));)F++;F===s?c=F:F!==x&&(c=F+1)}}}}else if(g(r)&&i.charCodeAt(1)===L){if(s<=2)return o.root=o.dir=i,o;if(c=2,h(i.charCodeAt(2))){if(s===3)return o.root=o.dir=i,o;c=3}}c>0&&(o.root=i.slice(0,c));let m=-1,n=c,t=-1,u=!0,w=i.length-1,S=0;for(;w>=c;--w){if(r=i.charCodeAt(w),h(r)){if(!u){n=w+1;break}continue}t===-1&&(u=!1,t=w+1),r===P?m===-1?m=w:S!==1&&(S=1):m!==-1&&(S=-1)}return t!==-1&&(m===-1||S===0||S===1&&m===t-1&&m===n+1?o.base=o.name=i.slice(n,t):(o.name=i.slice(n,m),o.base=i.slice(n,t),o.ext=i.slice(m,t))),n>0&&n!==c?o.dir=i.slice(0,n-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const p=(()=>{if(f){const i=/\\/g;return()=>{const o=a.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let o="",s=!1;for(let c=i.length-1;c>=-1&&!s;c--){const r=c>=0?i[c]:p();y(r,"path"),r.length!==0&&(o=`${r}/${o}`,s=r.charCodeAt(0)===E)}return o=b(o,!s,"/",d),s?`/${o}`:o.length>0?o:"."},normalize(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===E,s=i.charCodeAt(i.length-1)===E;return i=b(i,!o,"/",d),i.length===0?o?"/":s?"./":".":(s&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return y(i,"path"),i.length>0&&i.charCodeAt(0)===E},join(...i){if(i.length===0)return".";let o;for(let s=0;s<i.length;++s){const c=i[s];y(c,"path"),c.length>0&&(o===void 0?o=c:o+=`/${c}`)}return o===void 0?".":e.posix.normalize(o)},relative(i,o){if(y(i,"from"),y(o,"to"),i===o||(i=e.posix.resolve(i),o=e.posix.resolve(o),i===o))return"";const s=1,c=i.length,r=c-s,m=1,n=o.length-m,t=r<n?r:n;let u=-1,w=0;for(;w<t;w++){const F=i.charCodeAt(s+w);if(F!==o.charCodeAt(m+w))break;F===E&&(u=w)}if(w===t)if(n>t){if(o.charCodeAt(m+w)===E)return o.slice(m+w+1);if(w===0)return o.slice(m+w)}else r>t&&(i.charCodeAt(s+w)===E?u=w:w===0&&(u=0));let S="";for(w=s+u+1;w<=c;++w)(w===c||i.charCodeAt(w)===E)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(m+u)}`},toNamespacedPath(i){return i},dirname(i){if(y(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===E;let s=-1,c=!0;for(let r=i.length-1;r>=1;--r)if(i.charCodeAt(r)===E){if(!c){s=r;break}}else c=!1;return s===-1?o?"/":".":o&&s===1?"//":i.slice(0,s)},basename(i,o){o!==void 0&&y(o,"ext"),y(i,"path");let s=0,c=-1,r=!0,m;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let n=o.length-1,t=-1;for(m=i.length-1;m>=0;--m){const u=i.charCodeAt(m);if(u===E){if(!r){s=m+1;break}}else t===-1&&(r=!1,t=m+1),n>=0&&(u===o.charCodeAt(n)?--n===-1&&(c=m):(n=-1,c=t))}return s===c?c=t:c===-1&&(c=i.length),i.slice(s,c)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===E){if(!r){s=m+1;break}}else c===-1&&(r=!1,c=m+1);return c===-1?"":i.slice(s,c)},extname(i){y(i,"path");let o=-1,s=0,c=-1,r=!0,m=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===E){if(!r){s=n+1;break}continue}c===-1&&(r=!1,c=n+1),t===P?o===-1?o=n:m!==1&&(m=1):o!==-1&&(m=-1)}return o===-1||c===-1||m===0||m===1&&o===c-1&&o===s+1?"":i.slice(o,c)},format:C.bind(null,"/"),parse(i){y(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const s=i.charCodeAt(0)===E;let c;s?(o.root="/",c=1):c=0;let r=-1,m=0,n=-1,t=!0,u=i.length-1,w=0;for(;u>=c;--u){const S=i.charCodeAt(u);if(S===E){if(!t){m=u+1;break}continue}n===-1&&(t=!1,n=u+1),S===P?r===-1?r=u:w!==1&&(w=1):r!==-1&&(w=-1)}if(n!==-1){const S=m===0&&s?1:m;r===-1||w===0||w===1&&r===n-1&&r===m+1?o.base=o.name=i.slice(S,n):(o.name=i.slice(S,r),o.base=i.slice(S,n),o.ext=i.slice(r,n))}return m>0?o.dir=i.slice(0,m-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[108],De([1,0,65,10]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new a.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(t,u,w=!1){const S=t||"",F=u||"",x=l.value.collator.compare(S,F);return l.value.collatorIsNumeric&&x===0&&S!==F?S<F?-1:1:x}e.compareFileNames=P;function E(t,u){const w=R.value.collator;return t=t||"",u=u||"",C(w,t,u)}e.compareFileNamesDefault=E;function k(t,u){const w=R.value.collator;return t=t||"",u=u||"",s(t,u)||C(w,t,u)}e.compareFileNamesUpper=k;function L(t,u){const w=R.value.collator;return t=t||"",u=u||"",o(t,u)||C(w,t,u)}e.compareFileNamesLower=L;function T(t,u){return t=t||"",u=u||"",t===u?0:t<u?-1:1}e.compareFileNamesUnicode=T;function v(t,u){const[w,S]=g(t),[F,x]=g(u);let V=l.value.collator.compare(S,x);if(V===0){if(l.value.collatorIsNumeric&&S!==x)return S<x?-1:1;if(V=l.value.collator.compare(w,F),l.value.collatorIsNumeric&&V===0&&w!==F)return w<F?-1:1}return V}e.compareFileExtensions=v;function I(t,u){t=t||"",u=u||"";const w=b(t),S=b(u),F=R.value.collator,x=D.value.collator;return C(x,w,S)||C(F,t,u)}e.compareFileExtensionsDefault=I;function y(t,u){t=t||"",u=u||"";const w=b(t),S=b(u),F=R.value.collator,x=D.value.collator;return C(x,w,S)||s(t,u)||C(F,t,u)}e.compareFileExtensionsUpper=y;function f(t,u){t=t||"",u=u||"";const w=b(t),S=b(u),F=R.value.collator,x=D.value.collator;return C(x,w,S)||o(t,u)||C(F,t,u)}e.compareFileExtensionsLower=f;function h(t,u){t=t||"",u=u||"";const w=b(t).toLowerCase(),S=b(u).toLowerCase();return w!==S?w<S?-1:1:t!==u?t<u?-1:1:0}e.compareFileExtensionsUnicode=h;const d=/^(.*?)(\.([^.]*))?$/;function g(t,u=!1){const w=t?d.exec(t):[];let S=[w&&w[1]||"",w&&w[3]||""];return u&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function b(t){const u=t?d.exec(t):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function C(t,u,w){const S=t.compare(u,w);return S!==0?S:u.length!==w.length?u.length<w.length?-1:1:0}function p(t){const u=t.charAt(0);return u.toLocaleUpperCase()!==u}function i(t){const u=t.charAt(0);return u.toLocaleLowerCase()!==u}function o(t,u){return p(t)&&i(u)?-1:i(t)&&p(u)?1:0}function s(t,u){return i(t)&&p(u)?-1:p(t)&&i(u)?1:0}function c(t,u,w=!1){return w||(t=t&&t.toLowerCase(),u=u&&u.toLowerCase()),t===u?0:t<u?-1:1}function r(t,u,w=!1){const S=t.split(A.sep),F=u.split(A.sep),x=S.length-1,V=F.length-1;let M,B;for(let O=0;;O++){if(M=x===O,B=V===O,M&&B)return P(S[O],F[O],w);if(M)return-1;if(B)return 1;const U=c(S[O],F[O],w);if(U!==0)return U}}e.comparePaths=r;function m(t,u,w){const S=t.toLowerCase(),F=u.toLowerCase(),x=n(t,u,w);if(x)return x;const V=S.endsWith(w),M=F.endsWith(w);if(V!==M)return V?-1:1;const B=P(S,F);return B!==0?B:S.localeCompare(F)}e.compareAnything=m;function n(t,u,w){const S=t.toLowerCase(),F=u.toLowerCase(),x=S.startsWith(w),V=F.startsWith(w);if(x!==V)return x?-1:1;if(x&&V){if(S.length<F.length)return-1;if(S.length>F.length)return 1}return 0}e.compareByPrefix=n}),define(ye[86],De([1,0,10]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const T=(0,a.extname)(L),v=A[T.toLowerCase()];return v!==void 0?v:D(L)}e.getMediaOrTextMime=R;function D(L){const T=(0,a.extname)(L);return l[T.toLowerCase()]}e.getMediaMime=D;function P(L){for(const T in l)if(l[T]===L)return T}e.getExtensionForMimeType=P;const E=/^(.+)\/(.+?)(;.+)?$/;function k(L,T){const v=E.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:T?void 0:L}e.normalizeMimeType=k}),define(ye[109],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(P,...E){const k=E.reduce((v,I)=>(v[I]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!k[v]).forEach(v=>{for(let I=0;I<L.length;I++)if(v.search(L[I])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=R;function D(P){!P||(delete P.DEBUG,a.isMacintosh&&delete P.DYLD_LIBRARY_PATH,a.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(ye[43],De([1,0,12]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=a.globals.performance&&typeof a.globals.performance.now=="function";class l{static create(D=!0){return new l(D)}constructor(D){this.a=A&&D,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ye[3],De([1,0,11,63,6,66,43]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,E=!1;var k;(function(m){m.None=()=>l.Disposable.None;function n(ve){if(E){const{onDidAddListener:ke}=ve,Oe=y.create();let oe=0;ve.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),ke?.()}}}function t(ve,ke){return O(ve,()=>{},0,void 0,void 0,ke)}m.defer=t;function u(ve){return(ke,Oe=null,oe)=>{let ae=!1,fe;return fe=ve(ee=>{if(!ae)return fe?fe.dispose():ae=!0,ke.call(Oe,ee)},null,oe),ae&&fe.dispose(),fe}}m.once=u;function w(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(ee=>oe.call(ae,ke(ee)),null,fe),Oe)}m.map=w;function S(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(ee=>{ke(ee),oe.call(ae,ee)},null,fe),Oe)}m.forEach=S;function F(ve,ke,Oe){return B((oe,ae=null,fe)=>ve(ee=>ke(ee)&&oe.call(ae,ee),null,fe),Oe)}m.filter=F;function x(ve){return ve}m.signal=x;function V(...ve){return(ke,Oe=null,oe)=>(0,l.combinedDisposable)(...ve.map(ae=>ae(fe=>ke.call(Oe,fe),null,oe)))}m.any=V;function M(ve,ke,Oe,oe){let ae=Oe;return w(ve,fe=>(ae=ke(ae,fe),ae),oe)}m.reduce=M;function B(ve,ke){let Oe;const oe={onWillAddFirstListener(){Oe=ve(ae.fire,ae)},onDidRemoveLastListener(){Oe?.dispose()}};ke||n(oe);const ae=new h(oe);return ke?.add(ae),ae.event}function O(ve,ke,Oe=100,oe=!1,ae,fe){let ee,ue,se,N=0;const W={leakWarningThreshold:ae,onWillAddFirstListener(){ee=ve(Y=>{N++,ue=ke(ue,Y),oe&&!se&&(K.fire(ue),ue=void 0);const he=()=>{const we=ue;ue=void 0,se=void 0,(!oe||N>1)&&K.fire(we),N=0};typeof Oe=="number"?(clearTimeout(se),se=setTimeout(he,Oe)):se===void 0&&(se=0,queueMicrotask(he))})},onDidRemoveLastListener(){ee.dispose()}};fe||n(W);const K=new h(W);return fe?.add(K),K.event}m.debounce=O;function U(ve,ke=0,Oe){return m.debounce(ve,(oe,ae)=>oe?(oe.push(ae),oe):[ae],ke,void 0,void 0,Oe)}m.accumulate=U;function $(ve,ke=(oe,ae)=>oe===ae,Oe){let oe=!0,ae;return F(ve,fe=>{const ee=oe||!ke(fe,ae);return oe=!1,ae=fe,ee},Oe)}m.latch=$;function j(ve,ke,Oe){return[m.filter(ve,ke,Oe),m.filter(ve,oe=>!ke(oe),Oe)]}m.split=j;function le(ve,ke=!1,Oe=[]){let oe=Oe.slice(),ae=ve(ue=>{oe?oe.push(ue):ee.fire(ue)});const fe=()=>{oe?.forEach(ue=>ee.fire(ue)),oe=null},ee=new h({onWillAddFirstListener(){ae||(ae=ve(ue=>ee.fire(ue)))},onDidAddFirstListener(){oe&&(ke?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ee.event}m.buffer=le;class J{constructor(ke){this.event=ke,this.c=new l.DisposableStore}map(ke){return new J(w(this.event,ke,this.c))}forEach(ke){return new J(S(this.event,ke,this.c))}filter(ke){return new J(F(this.event,ke,this.c))}reduce(ke,Oe){return new J(M(this.event,ke,Oe,this.c))}latch(){return new J($(this.event,void 0,this.c))}debounce(ke,Oe=100,oe=!1,ae){return new J(O(this.event,ke,Oe,oe,ae,this.c))}on(ke,Oe,oe){return this.event(ke,Oe,oe)}once(ke,Oe,oe){return u(this.event)(ke,Oe,oe)}dispose(){this.c.dispose()}}function q(ve){return new J(ve)}m.chain=q;function Q(ve,ke,Oe=oe=>oe){const oe=(...ue)=>ee.fire(Oe(...ue)),ae=()=>ve.on(ke,oe),fe=()=>ve.removeListener(ke,oe),ee=new h({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}m.fromNodeEventEmitter=Q;function Z(ve,ke,Oe=oe=>oe){const oe=(...ue)=>ee.fire(Oe(...ue)),ae=()=>ve.addEventListener(ke,oe),fe=()=>ve.removeEventListener(ke,oe),ee=new h({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}m.fromDOMEventEmitter=Z;function te(ve){return new Promise(ke=>u(ve)(ke))}m.toPromise=te;function X(ve,ke){return ke(void 0),ve(Oe=>ke(Oe))}m.runAndSubscribe=X;function _(ve,ke){let Oe=null;function oe(fe){Oe?.dispose(),Oe=new l.DisposableStore,ke(fe,Oe)}oe(void 0);const ae=ve(fe=>oe(fe));return(0,l.toDisposable)(()=>{ae.dispose(),Oe?.dispose()})}m.runAndSubscribeWithStore=_;class ie{constructor(ke,Oe){this.obs=ke,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{ke.addObserver(this)},onDidRemoveLastListener:()=>{ke.removeObserver(this)}};Oe||n(oe),this.emitter=new h(oe),Oe&&Oe.add(this.emitter)}beginUpdate(ke){this.c++}handleChange(ke,Oe){this.d=!0}endUpdate(ke){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function pe(ve,ke){return new ie(ve,ke).emitter.event}m.fromObservable=pe})(k=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new D.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}L.all=new Set,L.c=0,e.EventProfiling=L;let T=-1;function v(m){const n=T;return T=m,{dispose(){T=n}}}e.setGlobalLeakWarningThreshold=v;class I{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this.d=0}dispose(){this.c?.clear()}check(n,t){const u=this.threshold;if(u<=0||t<u)return;this.c||(this.c=new Map);const w=this.c.get(n.value)||0;if(this.c.set(n.value,w+1),this.d-=1,this.d<=0){this.d=u*.5;let S,F=0;for(const[x,V]of this.c)(!S||F<V)&&(S=x,F=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${F}):`),console.warn(S)}return()=>{const S=this.c.get(n.value)||0;this.c.set(n.value,S-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,t,u){this.callback=n,this.callbackThis=t,this.stack=u,this.subscription=new l.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class h{constructor(n){this.j=!1,this.d=n,this.f=T>0||this.d?.leakWarningThreshold?new I(this.d?.leakWarningThreshold??T):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const n=Array.from(this.q);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,t,u)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const w=this.q.isEmpty();w&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let S,F;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(F=y.create(),S=this.f.check(F,this.q.size+1)),P&&(F=F??y.create());const x=new f(n,t,F),V=this.q.push(x);w&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,t);const M=x.subscription.set(()=>{S?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return u instanceof l.DisposableStore?u.add(M):Array.isArray(u)&&u.push(M),M}),this.l}fire(n){if(this.q){this.m||(this.m=new g);for(const t of this.q)this.m.push(this,t,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=h;class d{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,t,u){this.c.push(new b(n,t,u))}clear(n){const t=new R.LinkedList;for(const u of this.c)u.emitter!==n&&t.push(u);this.c=t}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(t){(0,a.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=d;class g extends d{clear(n){this.c.clear()}}class b{constructor(n,t,u){this.emitter=n,this.listener=t,this.event=u}}class C extends h{async fireAsync(n,t,u){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const w of this.q)this.c.push([w,n]);for(;this.c.size>0&&!t.isCancellationRequested;){const[w,S]=this.c.shift(),F=[],x={...S,token:t,waitUntil:V=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");u&&(V=u(V,w.callback)),F.push(V)}};try{w.invoke(x)}catch(V){(0,a.onUnexpectedError)(V);continue}Object.freeze(F),await Promise.allSettled(F).then(V=>{for(const M of V)M.status==="rejected"&&(0,a.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=C;class p extends h{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=p;class i extends p{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class o extends h{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=o;class s{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const t={event:n,listener:null};this.f.push(t),this.d&&this.j(t);const u=()=>{this.d&&this.k(t);const w=this.f.indexOf(t);this.f.splice(w,1)};return(0,l.toDisposable)((0,A.once)(u))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(t=>this.c.fire(t))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=s;class c{constructor(){this.c=[]}wrapEvent(n){return(t,u,w)=>n(S=>{const F=this.c[this.c.length-1];F?F.push(()=>t.call(u,S)):t.call(u,S)},void 0,w)}bufferEvents(n){const t=[];this.c.push(t);const u=n();return this.c.pop(),t.forEach(w=>w()),u}}e.EventBufferer=c;class r{constructor(){this.c=!1,this.d=k.None,this.f=l.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=r}),define(ye[161],De([1,0,3,6,156]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends A.Disposable{constructor(v,I="",y="",f=!0,h){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=I,this.u=y,this.w=f,this.C=h}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,I){this.C&&await this.C(v)}}e.Action=R;class D extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(v,I){if(!v.enabled)return;this.f.fire({action:v});let y;try{await this.runAction(v,I)}catch(f){y=f}this.h.fire({action:v,error:y})}async runAction(v,I){await v.run(I)}}e.ActionRunner=D;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let I=[];for(const y of v)y.length&&(I.length?I=[...I,new P,...y]:I=y);return I}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class E{get actions(){return this.a}constructor(v,I,y,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=I,this.class=f,this.a=y}async run(){}}e.SubmenuAction=E;class k extends R{constructor(){super(k.ID,l.localize(0,null),void 0,!1)}}k.ID="vs.actions.empty",e.EmptySubmenuAction=k;function L(T){return{id:T.id,label:T.label,class:void 0,enabled:T.enabled??!0,checked:T.checked??!1,run:async()=>T.run(),tooltip:T.label}}e.toAction=L}),define(ye[21],De([1,0,3]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,E){const k=setTimeout(P.bind(E),0);return{dispose(){clearTimeout(k)}}});var l;(function(P){function E(k){return k===P.None||k===P.Cancelled||k instanceof R?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}P.isCancellationToken=E,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(E){this.a=void 0,this.b=void 0,this.b=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=l.Cancelled}dispose(E=!1){E&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=D}),define(ye[162],De([1,0,21]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new a.CancellationTokenSource,E=this.b(P.token);return this.a={promise:E,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const E=JSON.stringify(P);return this.b!==E&&(this.b=E,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class R{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const E=this.b(P);return this.a.set(P,E),E}}e.CachedFunction=R}),define(ye[8],De([1,0,162,65]),function(ne,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(z){return!z||typeof z!="string"?!0:z.trim().length===0}e.isFalsyOrWhitespace=R;const D=/{(\d+)}/g;function P(z,...de){return de.length===0?z:z.replace(D,function(Ie,Le){const $e=parseInt(Le,10);return isNaN($e)||$e<0||$e>=de.length?Ie:de[$e]})}e.format=P;const E=/{([^}]+)}/g;function k(z,de){return z.replace(E,(Ie,Le)=>de[Le]??Ie)}e.format2=k;function L(z){return z.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=L;function T(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=T;function v(z,de){let Ie=0;const Le=de.charCodeAt(0);for(let $e=z.length-1;$e>=0;$e--)z.charCodeAt($e)===Le&&Ie++;return Ie}e.count=v;function I(z,de,Ie="\u2026"){return z.length<=de?z:`${z.substr(0,de)}${Ie}`}e.truncate=I;function y(z,de=" "){const Ie=f(z,de);return h(Ie,de)}e.trim=y;function f(z,de){if(!z||!de)return z;const Ie=de.length;if(Ie===0||z.length===0)return z;let Le=0;for(;z.indexOf(de,Le)===Le;)Le=Le+Ie;return z.substring(Le)}e.ltrim=f;function h(z,de){if(!z||!de)return z;const Ie=de.length,Le=z.length;if(Ie===0||Le===0)return z;let $e=Le,Ke=-1;for(;Ke=z.lastIndexOf(de,$e-1),!(Ke===-1||Ke+Ie!==$e);){if(Ke===0)return"";$e=Ke}return z.substring(0,$e)}e.rtrim=h;function d(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(z){return z.replace(/\*/g,"")}e.stripWildcards=g;function b(z,de,Ie={}){if(!z)throw new Error("Cannot create regex from empty string");de||(z=T(z)),Ie.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp(z,Le)}e.createRegExp=b;function C(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function p(z){return!!z.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=p;function i(z){return(z.global?"g":"")+(z.ignoreCase?"i":"")+(z.multiline?"m":"")+(z.unicode?"u":"")}e.regExpFlags=i;function o(z){return z.split(/\r\n|\r|\n/)}e.splitLines=o;function s(z){for(let de=0,Ie=z.length;de<Ie;de++){const Le=z.charCodeAt(de);if(Le!==32&&Le!==9)return de}return-1}e.firstNonWhitespaceIndex=s;function c(z,de=0,Ie=z.length){for(let Le=de;Le<Ie;Le++){const $e=z.charCodeAt(Le);if($e!==32&&$e!==9)return z.substring(de,Le)}return z.substring(de,Ie)}e.getLeadingWhitespace=c;function r(z,de=z.length-1){for(let Ie=de;Ie>=0;Ie--){const Le=z.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=r;function m(z,de,Ie){const Le=[];let $e=0;for(const Ke of z.matchAll(de)){if(Le.push(z.slice($e,Ke.index)),Ke.index===void 0)throw new Error("match.index should be defined");$e=Ke.index+Ke[0].length,Le.push(Ie(Ke[0],...Ke.slice(1),Ke.index,z,Ke.groups))}return Le.push(z.slice($e)),Promise.all(Le).then(Ke=>Ke.join(""))}e.replaceAsync=m;function n(z,de){return z<de?-1:z>de?1:0}e.compare=n;function t(z,de,Ie=0,Le=z.length,$e=0,Ke=de.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){const gt=z.charCodeAt(Ie),ct=de.charCodeAt($e);if(gt<ct)return-1;if(gt>ct)return 1}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstring=t;function u(z,de){return w(z,de,0,z.length,0,de.length)}e.compareIgnoreCase=u;function w(z,de,Ie=0,Le=z.length,$e=0,Ke=de.length){for(;Ie<Le&&$e<Ke;Ie++,$e++){let gt=z.charCodeAt(Ie),ct=de.charCodeAt($e);if(gt===ct)continue;if(gt>=128||ct>=128)return t(z.toLowerCase(),de.toLowerCase(),Ie,Le,$e,Ke);F(gt)&&(gt-=32),F(ct)&&(ct-=32);const Et=gt-ct;if(Et!==0)return Et}const Ze=Le-Ie,pt=Ke-$e;return Ze<pt?-1:Ze>pt?1:0}e.compareSubstringIgnoreCase=w;function S(z){return z>=48&&z<=57}e.isAsciiDigit=S;function F(z){return z>=97&&z<=122}e.isLowerAsciiLetter=F;function x(z){return z>=65&&z<=90}e.isUpperAsciiLetter=x;function V(z,de){return z.length===de.length&&w(z,de)===0}e.equalsIgnoreCase=V;function M(z,de){const Ie=de.length;return de.length>z.length?!1:w(z,de,0,Ie)===0}e.startsWithIgnoreCase=M;function B(z,de){const Ie=Math.min(z.length,de.length);let Le;for(Le=0;Le<Ie;Le++)if(z.charCodeAt(Le)!==de.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=B;function O(z,de){const Ie=Math.min(z.length,de.length);let Le;const $e=z.length-1,Ke=de.length-1;for(Le=0;Le<Ie;Le++)if(z.charCodeAt($e-Le)!==de.charCodeAt(Ke-Le))return Le;return Ie}e.commonSuffixLength=O;function U(z){return 55296<=z&&z<=56319}e.isHighSurrogate=U;function $(z){return 56320<=z&&z<=57343}e.isLowSurrogate=$;function j(z,de){return(z-55296<<10)+(de-56320)+65536}e.computeCodePoint=j;function le(z,de,Ie){const Le=z.charCodeAt(Ie);if(U(Le)&&Ie+1<de){const $e=z.charCodeAt(Ie+1);if($($e))return j(Le,$e)}return Le}e.getNextCodePoint=le;function J(z,de){const Ie=z.charCodeAt(de-1);if($(Ie)&&de>1){const Le=z.charCodeAt(de-2);if(U(Le))return j(Le,Ie)}return Ie}class q{get offset(){return this.e}constructor(de,Ie=0){this.c=de,this.d=de.length,this.e=Ie}setOffset(de){this.e=de}prevCodePoint(){const de=J(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=le(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.CodePointIterator=q;class Q{get offset(){return this.c.offset}constructor(de,Ie=0){this.c=new q(de,Ie)}nextGraphemeLength(){const de=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=de.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Ke=Ie.offset,Ze=de.getGraphemeBreakType(Ie.nextCodePoint());if(Ve($e,Ze)){Ie.setOffset(Ke);break}$e=Ze}return Ie.offset-Le}prevGraphemeLength(){const de=et.getInstance(),Ie=this.c,Le=Ie.offset;let $e=de.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Ke=Ie.offset,Ze=de.getGraphemeBreakType(Ie.prevCodePoint());if(Ve(Ze,$e)){Ie.setOffset(Ke);break}$e=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Q;function Z(z,de){return new Q(z,de).nextGraphemeLength()}e.nextCharLength=Z;function te(z,de){return new Q(z,de).prevGraphemeLength()}e.prevCharLength=te;function X(z,de){de>0&&$(z.charCodeAt(de))&&de--;const Ie=de+Z(z,de);return[Ie-te(z,Ie),Ie]}e.getCharContainingOffset=X;function _(z){const de=new Q(z);let Ie=0;for(;!de.eol();)Ie++,de.nextGraphemeLength();return Ie}e.charCount=_;let ie;function pe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve(z){return ie||(ie=pe()),ie.test(z)}e.containsRTL=ve;const ke=/^[\t\n\r\x20-\x7E]*$/;function Oe(z){return ke.test(z)}e.isBasicASCII=Oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe(z){return e.UNUSUAL_LINE_TERMINATORS.test(z)}e.containsUnusualLineTerminators=oe;function ae(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}e.isFullWidthCharacter=ae;function fe(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}e.isEmojiImprecise=fe;function ee(z,de){if(z.length<de)return z;const Ie=/\b/g;let Le=0;for(;Ie.test(z)&&!(z.length-Ie.lastIndex<de);)Le=Ie.lastIndex,Ie.lastIndex+=1;return z.substring(Le).replace(/^\s/,"")}e.lcut=ee;const ue=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,N=/\x1b\[0?m/g;function W(z){return z&&(z=z.replace(ue,""),z=z.replace(se,""),z=z.replace(N,"")),z}e.removeAnsiEscapeCodes=W,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function K(z){return!!(z&&z.length>0&&z.charCodeAt(0)===65279)}e.startsWithUTF8BOM=K;function Y(z){return K(z)?z.substr(1):z}e.stripUTF8BOM=Y;function he(z,de){if(!z||!de||z.length<de.length)return!1;const Ie=de.length,Le=z.toLowerCase();let $e=0,Ke=-1;for(;$e<Ie;){const Ze=Le.indexOf(de[$e],Ke+1);if(Ze<0)return!1;Ke=Ze,$e++}return!0}e.fuzzyContains=he;function we(z,de=!1){return z?(de&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}e.containsUppercaseCharacter=we;function Ae(z){return z.charAt(0).toUpperCase()+z.slice(1)}e.uppercaseFirstLetter=Ae;function be(z,de=1){if(de===0)return"";let Ie=-1;do Ie=z.indexOf(`
`,Ie+1),de--;while(de>0&&Ie>=0);return Ie===-1?z:(z[Ie-1]==="\r"&&Ie--,z.substr(0,Ie))}e.getNLines=be;function Ce(z){return z=z%(2*26),z<26?String.fromCharCode(97+z):String.fromCharCode(65+z-26)}e.singleLetterHash=Ce;function Te(z){return et.getInstance().getGraphemeBreakType(z)}e.getGraphemeBreakType=Te;function Ve(z,de){return z===0?de!==5&&de!==7:z===2&&de===3?!1:z===4||z===2||z===3||de===4||de===2||de===3?!0:!(z===8&&(de===8||de===9||de===11||de===12)||(z===11||z===9)&&(de===9||de===10)||(z===12||z===10)&&de===10||de===5||de===13||de===7||z===1||z===13&&de===14||z===6&&de===6)}var xe;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=Qe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const Ie=this.d,Le=Ie.length/3;let $e=1;for(;$e<=Le;)if(de<Ie[3*$e])$e=2*$e;else if(de>Ie[3*$e+1])$e=2*$e+1;else return Ie[3*$e+2];return 0}}et.c=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt(z,de){if(z===0)return 0;const Ie=st(z,de);if(Ie!==void 0)return Ie;const Le=new q(de,z);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st(z,de){const Ie=new q(de,z);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let $e=Ie.offset;return $e>0&&Ie.prevCodePoint()===8205&&($e=Ie.offset),$e}function ht(z){return 127995<=z&&z<=127999}var Ue;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={})),e.noBreakWhitespace="\xA0";class rt{static getInstance(de){return rt.d.get(Array.from(de))}static getLocales(){return rt.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=rt,rt.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),rt.d=new a.LRUCachedFunction(z=>{function de(ct){const Et=new Map;for(let tt=0;tt<ct.length;tt+=2)Et.set(ct[tt],ct[tt+1]);return Et}function Ie(ct,Et){const tt=new Map(ct);for(const[ft,At]of Et)tt.set(ft,At);return tt}function Le(ct,Et){if(!ct)return Et;const tt=new Map;for(const[ft,At]of ct)Et.has(ft)&&tt.set(ft,At);return tt}const $e=l.c.value;let Ke=z.filter(ct=>!ct.startsWith("_")&&ct in $e);Ke.length===0&&(Ke=["_default"]);let Ze;for(const ct of Ke){const Et=de($e[ct]);Ze=Le(Ze,Et)}const pt=de($e._common),gt=Ie(pt,Ze);return new rt(gt)}),rt.e=new A.Lazy(()=>Object.keys(rt.c.value).filter(z=>!z.startsWith("_"))),e.AmbiguousCharacters=rt;class ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ce.c())),this.d}static isInvisibleCharacter(de){return ce.e().has(de)}static get codePoints(){return ce.e()}}ce.d=void 0,e.InvisibleCharacters=ce}),define(ye[33],De([1,0,10,12,8,9]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function P(r){return r.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=P;function E(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function k(r,m=a.posix.sep){if(!r)return"";const n=r.length,t=r.charCodeAt(0);if(D(t)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let w=3;const S=w;for(;w<n&&!D(r.charCodeAt(w));w++);if(S!==w&&!D(r.charCodeAt(w+1))){for(w+=1;w<n;w++)if(D(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,m)}}return m}else if(d(t)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+m:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<n;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=k;function L(r){if(!A.isWindows||!r||r.length<5)return!1;let m=r.charCodeAt(0);if(m!==92||(m=r.charCodeAt(1),m!==92))return!1;let n=2;const t=n;for(;n<r.length&&(m=r.charCodeAt(n),m!==92);n++);return!(t===n||(m=r.charCodeAt(n+1),isNaN(m)||m===92))}e.isUNC=L;const T=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(r,m=A.isWindows){const n=m?T:v;return!(!r||r.length===0||/^\s+$/.test(r)||(n.lastIndex=0,n.test(r))||m&&I.test(r)||r==="."||r===".."||m&&r[r.length-1]==="."||m&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=y;function f(r,m,n){const t=r===m;return!n||t?t:!r||!m?!1:(0,l.equalsIgnoreCase)(r,m)}e.isEqual=f;function h(r,m,n,t=a.sep){if(r===m)return!0;if(!r||!m||m.length>r.length)return!1;if(n){if(!(0,l.startsWithIgnoreCase)(r,m))return!1;if(m.length===r.length)return!0;let w=m.length;return m.charAt(m.length-1)===t&&w--,r.charAt(w)===t}return m.charAt(m.length-1)!==t&&(m+=t),r.indexOf(m)===0}e.isEqualOrParent=h;function d(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=d;function g(r,m){return A.isWindows&&r.endsWith(":")&&(r+=a.sep),(0,a.isAbsolute)(r)||(r=(0,a.join)(m,r)),r=(0,a.normalize)(r),A.isWindows?(r=(0,l.rtrim)(r,a.sep),r.endsWith(":")&&(r+=a.sep)):(r=(0,l.rtrim)(r,a.sep),r||(r=a.sep)),r}e.sanitizeFilePath=g;function b(r){const m=(0,a.normalize)(r);return A.isWindows?r.length>3?!1:C(m)&&(r.length===2||m.charCodeAt(2)===92):m===a.posix.sep}e.isRootOrDriveLetter=b;function C(r,m=A.isWindows){return m?d(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function p(r){return C(r)?r[0]:void 0}e.getDriveLetter=p;function i(r,m,n){return m.length>r.length?-1:r===m?0:(n&&(r=r.toLowerCase(),m=m.toLowerCase()),r.indexOf(m))}e.indexOfPath=i;function o(r){const m=r.split(":");let n,t,u;for(const w of m){const S=Number(w);(0,R.isNumber)(S)?t===void 0?t=S:u===void 0&&(u=S):n=n?[n,w].join(":"):w}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:u!==void 0?u:t!==void 0?1:void 0}}e.parseLineAndColumnAware=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function c(r,m,n=8){let t="";for(let w=0;w<n;w++)t+=s.charAt(Math.floor(Math.random()*s.length));let u;return m?u=`${m}-${t}`:u=t,r?(0,a.join)(r,u):u}e.randomPath=c}),define(ye[110],De([1,0,28,8]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...se){return function(N,W){for(let K=0,Y=se.length;K<Y;K++){const he=se[K](N,W);if(he)return he}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(se,N,W){if(!W||W.length<N.length)return null;let K;return se?K=A.startsWithIgnoreCase(W,N):K=W.indexOf(N)===0,K?N.length>0?[{start:0,end:N.length}]:[]:null}function D(se,N){const W=N.toLowerCase().indexOf(se.toLowerCase());return W===-1?null:[{start:W,end:W+se.length}]}e.matchesContiguousSubString=D;function P(se,N){return E(se.toLowerCase(),N.toLowerCase(),0,0)}e.matchesSubString=P;function E(se,N,W,K){if(W===se.length)return[];if(K===N.length)return null;if(se[W]===N[K]){let Y=null;return(Y=E(se,N,W+1,K+1))?d({start:K,end:K+1},Y):null}return E(se,N,W,K+1)}function k(se){return 97<=se&&se<=122}function L(se){return 65<=se&&se<=90}e.isUpper=L;function T(se){return 48<=se&&se<=57}function v(se){return se===32||se===9||se===10||se===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>I.add(se.charCodeAt(0)));function y(se){return v(se)||I.has(se)}function f(se,N){return se===N||y(se)&&y(N)}function h(se){return k(se)||L(se)||T(se)}function d(se,N){return N.length===0?N=[se]:se.end===N[0].start?N[0].start=se.start:N.unshift(se),N}function g(se,N){for(let W=N;W<se.length;W++){const K=se.charCodeAt(W);if(L(K)||T(K)||W>0&&!h(se.charCodeAt(W-1)))return W}return se.length}function b(se,N,W,K){if(W===se.length)return[];if(K===N.length)return null;if(se[W]!==N[K].toLowerCase())return null;{let Y=null,he=K+1;for(Y=b(se,N,W+1,K+1);!Y&&(he=g(N,he))<N.length;)Y=b(se,N,W+1,he),he++;return Y===null?null:d({start:K,end:K+1},Y)}}function C(se){let N=0,W=0,K=0,Y=0,he=0;for(let Te=0;Te<se.length;Te++)he=se.charCodeAt(Te),L(he)&&N++,k(he)&&W++,h(he)&&K++,T(he)&&Y++;const we=N/se.length,Ae=W/se.length,be=K/se.length,Ce=Y/se.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:be,numericPercent:Ce}}function p(se){const{upperPercent:N,lowerPercent:W}=se;return W===0&&N>.6}function i(se){const{upperPercent:N,lowerPercent:W,alphaPercent:K,numericPercent:Y}=se;return W>.2&&N<.8&&K>.6&&Y<.2}function o(se){let N=0,W=0,K=0,Y=0;for(let he=0;he<se.length;he++)K=se.charCodeAt(he),L(K)&&N++,k(K)&&W++,v(K)&&Y++;return(N===0||W===0)&&Y===0?se.length<=30:N<=5}function s(se,N){if(!N||(N=N.trim(),N.length===0)||!o(se)||N.length>60)return null;const W=C(N);if(!i(W)){if(!p(W))return null;N=N.toLowerCase()}let K=null,Y=0;for(se=se.toLowerCase();Y<N.length&&(K=b(se,N,0,Y))===null;)Y=g(N,Y+1);return K}e.matchesCamelCase=s;function c(se,N,W=!1){if(!N||N.length===0)return null;let K=null,Y=0;for(se=se.toLowerCase(),N=N.toLowerCase();Y<N.length&&(K=r(se,N,0,Y,W))===null;)Y=m(N,Y+1);return K}e.matchesWords=c;function r(se,N,W,K,Y){if(W===se.length)return[];if(K===N.length)return null;if(f(se.charCodeAt(W),N.charCodeAt(K))){let he=null,we=K+1;if(he=r(se,N,W+1,K+1,Y),!Y)for(;!he&&(we=m(N,we))<N.length;)he=r(se,N,W+1,we,Y),we++;return he?se.charCodeAt(W)!==N.charCodeAt(K)?he:d({start:K,end:K+1},he):null}else return null}function m(se,N){for(let W=N;W<se.length;W++)if(y(se.charCodeAt(W))||W>0&&y(se.charCodeAt(W-1)))return W;return se.length}const n=l(e.matchesPrefix,s,D),t=l(e.matchesPrefix,s,P),u=new a.LRUCache(1e4);function w(se,N,W=!1){if(typeof se!="string"||typeof N!="string")return null;let K=u.get(se);K||(K=new RegExp(A.convertSimple2RegExpPattern(se),"i"),u.set(se,K));const Y=K.exec(N);return Y?[{start:Y.index,end:Y.index+Y[0].length}]:W?t(se,N):n(se,N)}e.matchesFuzzy=w;function S(se,N){const W=ke(se,se.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return W?x(W):null}e.matchesFuzzy2=S;function F(se,N,W,K,Y,he){const we=Math.min(13,se.length);for(;W<we;W++){const Ae=ke(se,N,W,K,Y,he,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,he]}e.anyScore=F;function x(se){if(typeof se>"u")return[];const N=[],W=se[1];for(let K=se.length-1;K>1;K--){const Y=se[K]+W,he=N[N.length-1];he&&he.end===Y?he.end=Y+1:N.push({start:Y,end:Y+1})}return N}e.createMatches=x;const V=128;function M(){const se=[],N=[];for(let W=0;W<=V;W++)N[W]=0;for(let W=0;W<=V;W++)se.push(N.slice(0));return se}function B(se){const N=[];for(let W=0;W<=se;W++)N[W]=0;return N}const O=B(2*V),U=B(2*V),$=M(),j=M(),le=M(),J=!1;function q(se,N,W,K,Y){function he(Ae,be,Ce=" "){for(;Ae.length<be;)Ae=Ce+Ae;return Ae}let we=` |   |${K.split("").map(Ae=>he(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=W;Ae++)Ae===0?we+=" |":we+=`${N[Ae-1]}|`,we+=se[Ae].slice(0,Y+1).map(be=>he(be.toString(),3)).join("|")+`
`;return we}function Q(se,N,W,K){se=se.substr(N),W=W.substr(K),console.log(q(j,se,se.length,W,W.length)),console.log(q(le,se,se.length,W,W.length)),console.log(q($,se,se.length,W,W.length))}function Z(se,N){if(N<0||N>=se.length)return!1;const W=se.codePointAt(N);switch(W){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(W)}}function te(se,N){if(N<0||N>=se.length)return!1;switch(se.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function X(se,N,W){return N[se]!==W[se]}function _(se,N,W,K,Y,he,we=!1){for(;N<W&&Y<he;)se[N]===K[Y]&&(we&&(O[N]=Y),N+=1),Y+=1;return N===W}e.isPatternInWord=_;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var pe;(function(se){se.Default=[-100,0];function N(W){return!W||W.length===2&&W[0]===-100&&W[1]===0}se.isDefault=N})(pe=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(N,W){this.firstMatchCanBeWeak=N,this.boostFullMatch=W}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function ke(se,N,W,K,Y,he,we=ve.default){const Ae=se.length>V?V:se.length,be=K.length>V?V:K.length;if(W>=Ae||he>=be||Ae-W>be-he||!_(N,W,Ae,Y,he,be,!0))return;Oe(Ae,be,W,he,N,Y);let Ce=1,Te=1,Ve=W,xe=he;const et=[!1];for(Ce=1,Ve=W;Ve<Ae;Ce++,Ve++){const Ue=O[Ve],rt=U[Ve],ce=Ve+1<Ae?U[Ve+1]:be;for(Te=Ue-he+1,xe=Ue;xe<ce;Te++,xe++){let z=Number.MIN_SAFE_INTEGER,de=!1;xe<=rt&&(z=oe(se,N,Ve,W,K,Y,xe,be,he,$[Ce-1][Te-1]===0,et));let Ie=0;z!==Number.MAX_SAFE_INTEGER&&(de=!0,Ie=z+j[Ce-1][Te-1]);const Le=xe>Ue,$e=Le?j[Ce][Te-1]+($[Ce][Te-1]>0?-5:0):0,Ke=xe>Ue+1&&$[Ce][Te-1]>0,Ze=Ke?j[Ce][Te-2]+($[Ce][Te-2]>0?-5:0):0;if(Ke&&(!Le||Ze>=$e)&&(!de||Ze>=Ie))j[Ce][Te]=Ze,le[Ce][Te]=3,$[Ce][Te]=0;else if(Le&&(!de||$e>=Ie))j[Ce][Te]=$e,le[Ce][Te]=2,$[Ce][Te]=0;else if(de)j[Ce][Te]=Ie,le[Ce][Te]=1,$[Ce][Te]=$[Ce-1][Te-1]+1;else throw new Error("not possible")}}if(J&&Q(se,W,K,he),!et[0]&&!we.firstMatchCanBeWeak)return;Ce--,Te--;const Qe=[j[Ce][Te],he];let nt=0,st=0;for(;Ce>=1;){let Ue=Te;do{const rt=le[Ce][Ue];if(rt===3)Ue=Ue-2;else if(rt===2)Ue=Ue-1;else break}while(Ue>=1);nt>1&&N[W+Ce-1]===Y[he+Te-1]&&!X(Ue+he-1,K,Y)&&nt+1>$[Ce][Ue]&&(Ue=Te),Ue===Te?nt++:nt=1,st||(st=Ue),Ce--,Te=Ue-1,Qe.push(Te)}be===Ae&&we.boostFullMatch&&(Qe[0]+=2);const ht=st-Ae;return Qe[0]-=ht,Qe}e.fuzzyScore=ke;function Oe(se,N,W,K,Y,he){let we=se-1,Ae=N-1;for(;we>=W&&Ae>=K;)Y[we]===he[Ae]&&(U[we]=Ae,we--),Ae--}function oe(se,N,W,K,Y,he,we,Ae,be,Ce,Te){if(N[W]!==he[we])return Number.MIN_SAFE_INTEGER;let Ve=1,xe=!1;return we===W-K?Ve=se[W]===Y[we]?7:5:X(we,Y,he)&&(we===0||!X(we-1,Y,he))?(Ve=se[W]===Y[we]?7:5,xe=!0):Z(he,we)&&(we===0||!Z(he,we-1))?Ve=5:(Z(he,we-1)||te(he,we-1))&&(Ve=5,xe=!0),Ve>1&&W===K&&(Te[0]=!0),xe||(xe=X(we,Y,he)||Z(he,we-1)||te(he,we-1)),W===K?we>be&&(Ve-=xe?3:5):Ce?Ve+=xe?2:0:Ve+=xe?0:1,we+1===Ae&&(Ve-=xe?3:5),Ve}function ae(se,N,W,K,Y,he,we){return ee(se,N,W,K,Y,he,!0,we)}e.fuzzyScoreGracefulAggressive=ae;function fe(se,N,W,K,Y,he,we){return ee(se,N,W,K,Y,he,!1,we)}e.fuzzyScoreGraceful=fe;function ee(se,N,W,K,Y,he,we,Ae){let be=ke(se,N,W,K,Y,he,Ae);if(be&&!we)return be;if(se.length>=3){const Ce=Math.min(7,se.length-1);for(let Te=W+1;Te<Ce;Te++){const Ve=ue(se,Te);if(Ve){const xe=ke(Ve,Ve.toLowerCase(),W,K,Y,he,Ae);xe&&(xe[0]-=3,(!be||xe[0]>be[0])&&(be=xe))}}}return be}function ue(se,N){if(N+1>=se.length)return;const W=se[N],K=se[N+1];if(W!==K)return se.slice(0,N)+K+W+se.slice(N+2)}}),define(ye[87],De([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(d){return l(d,0)}e.hash=A;function l(d,g){switch(typeof d){case"object":return d===null?R(349,g):Array.isArray(d)?E(d,g):k(d,g);case"string":return P(d,g);case"boolean":return D(d,g);case"number":return R(d,g);case"undefined":return R(937,g);default:return R(617,g)}}e.doHash=l;function R(d,g){return(g<<5)-g+d|0}e.numberHash=R;function D(d,g){return R(d?433:863,g)}function P(d,g){g=R(149417,g);for(let b=0,C=d.length;b<C;b++)g=R(d.charCodeAt(b),g);return g}e.stringHash=P;function E(d,g){return g=R(104579,g),d.reduce((b,C)=>l(C,b),g)}function k(d,g){return g=R(181387,g),Object.keys(d).sort().reduce((b,C)=>(b=P(C,b),l(d[C],b)),g)}class L{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=l(g,this.g),this.g}}e.Hasher=L;var T;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(T||(T={}));function v(d,g,b=32){const C=b-g,p=~((1<<C)-1);return(d<<g|(p&d)>>>C)>>>0}function I(d,g=0,b=d.byteLength,C=0){for(let p=0;p<b;p++)d[g+p]=C}function y(d,g,b="0"){for(;d.length<g;)d=b+d;return d}function f(d,g=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((d>>>0).toString(16),g/4)}e.toHexString=f;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const b=g.length;if(b===0)return;const C=this.p;let p=this.r,i=this.u,o,s;for(i!==0?(o=i,s=-1,i=0):(o=g.charCodeAt(0),s=0);;){let c=o;if(a.isHighSurrogate(o))if(s+1<b){const r=g.charCodeAt(s+1);a.isLowSurrogate(r)?(s++,c=a.computeCodePoint(o,r)):c=65533}else{i=o;break}else a.isLowSurrogate(o)&&(c=65533);if(p=this.w(C,p,c),s++,s<b)o=g.charCodeAt(s);else break}this.r=p,this.u=i}w(g,b,C){return C<128?g[b++]=C:C<2048?(g[b++]=192|(C&1984)>>>6,g[b++]=128|(C&63)>>>0):C<65536?(g[b++]=224|(C&61440)>>>12,g[b++]=128|(C&4032)>>>6,g[b++]=128|(C&63)>>>0):(g[b++]=240|(C&1835008)>>>18,g[b++]=128|(C&258048)>>>12,g[b++]=128|(C&4032)>>>6,g[b++]=128|(C&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=h.g,b=this.q;for(let n=0;n<64;n+=4)g.setUint32(n,b.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)g.setUint32(n,v(g.getUint32(n-12,!1)^g.getUint32(n-32,!1)^g.getUint32(n-56,!1)^g.getUint32(n-64,!1),1),!1);let C=this.h,p=this.l,i=this.m,o=this.n,s=this.o,c,r,m;for(let n=0;n<80;n++)n<20?(c=p&i|~p&o,r=1518500249):n<40?(c=p^i^o,r=1859775393):n<60?(c=p&i|p&o|i&o,r=2400959708):(c=p^i^o,r=3395469782),m=v(C,5)+c+s+r+g.getUint32(n*4,!1)&4294967295,s=o,o=i,i=v(p,30),p=C,C=m;this.h=this.h+C&4294967295,this.l=this.l+p&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}h.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=h}),define(ye[111],De([1,0,108,110,87,10,12,8]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,k=[E,[]];function L($,j,le,J){if(!$||!j)return k;const q=$.length,Q=j.length;if(q<Q)return k;const Z=$.toLowerCase();return T(j,le,Q,$,Z,q,J)}e.scoreFuzzy=L;function T($,j,le,J,q,Q,Z){const te=[],X=[];for(let ve=0;ve<le;ve++){const ke=ve*Q,Oe=ke-Q,oe=ve>0,ae=$[ve],fe=j[ve];for(let ee=0;ee<Q;ee++){const ue=ee>0,se=ke+ee,N=se-1,W=Oe+ee-1,K=ue?te[N]:0,Y=oe&&ue?te[W]:0,he=oe&&ue?X[W]:0;let we;!Y&&oe?we=0:we=v(ae,fe,J,q,ee,he),we&&Y+we>=K&&(Z||oe||q.startsWith(j,ee))?(X[se]=he+1,te[se]=Y+we):(X[se]=E,te[se]=K)}}const _=[];let ie=le-1,pe=Q-1;for(;ie>=0&&pe>=0;){const ve=ie*Q+pe;X[ve]===E||(_.push(pe),ie--),pe--}return[te[le*Q-1],_.reverse()]}function v($,j,le,J,q,Q){let Z=0;if(!I(j,J[q]))return Z;if(Z+=1,Q>0&&(Z+=Q*5),$===le[q]&&(Z+=1),q===0)Z+=8;else{const te=y(le.charCodeAt(q-1));te?Z+=te:(0,A.isUpper)(le.charCodeAt(q))&&Q===0&&(Z+=2)}return Z}function I($,j){return $===j?!0:$==="/"||$==="\\"?j==="/"||j==="\\":!1}function y($){switch($){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function h($,j,le=0,J=0){const q=j;return q.values&&q.values.length>1?d($,q.values,le,J):g($,j,le,J)}e.scoreFuzzy2=h;function d($,j,le,J){let q=0;const Q=[];for(const Z of j){const[te,X]=g($,Z,le,J);if(typeof te!="number")return f;q+=te,Q.push(...X)}return[q,t(Q)]}function g($,j,le,J){const q=(0,A.fuzzyScore)(j.original,j.originalLowercase,le,$,$.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?[q[0],(0,A.createMatches)(q)]:f}const b=Object.freeze({score:0}),C=1<<18,p=1<<17,i=1<<16;function o($,j,le,J){const q=J.values?J.values:[J];return(0,l.hash)({[J.normalized]:{values:q.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:$,description:j,allowNonContiguousMatches:le}})}function s($,j,le,J,q){if(!$||!j.normalized)return b;const Q=J.getItemLabel($);if(!Q)return b;const Z=J.getItemDescription($),te=o(Q,Z,le,j),X=q[te];if(X)return X;const _=c(Q,Z,J.getItemPath($),j,le);return q[te]=_,_}e.scoreItemFuzzy=s;function c($,j,le,J,q){const Q=!le||!J.containsPathSeparator;return le&&(D.isLinux?J.pathNormalized===le:(0,P.equalsIgnoreCase)(J.pathNormalized,le))?{score:C,labelMatch:[{start:0,end:$.length}],descriptionMatch:j?[{start:0,end:j.length}]:void 0}:J.values&&J.values.length>1?r($,j,le,J.values,Q,q):m($,j,le,J,Q,q)}function r($,j,le,J,q,Q){let Z=0;const te=[],X=[];for(const _ of J){const{score:ie,labelMatch:pe,descriptionMatch:ve}=m($,j,le,_,q,Q);if(ie===E)return b;Z+=ie,pe&&te.push(...pe),ve&&X.push(...ve)}return{score:Z,labelMatch:t(te),descriptionMatch:t(X)}}function m($,j,le,J,q,Q){if(q||!j){const[Z,te]=L($,J.normalized,J.normalizedLowercase,Q&&!J.expectContiguousMatch);if(Z){const X=(0,A.matchesPrefix)(J.normalized,$);let _;return X?(_=p,_+=Math.round(J.normalized.length/$.length*100)):_=i,{score:_+Z,labelMatch:X||n(te)}}}if(j){let Z=j;le&&(Z=`${j}${R.sep}`);const te=Z.length,X=`${Z}${$}`,[_,ie]=L(X,J.normalized,J.normalizedLowercase,Q&&!J.expectContiguousMatch);if(_){const pe=n(ie),ve=[],ke=[];return pe.forEach(Oe=>{Oe.start<te&&Oe.end>te?(ve.push({start:0,end:Oe.end-te}),ke.push({start:Oe.start,end:te})):Oe.start>=te?ve.push({start:Oe.start-te,end:Oe.end-te}):ke.push(Oe)}),{score:_,labelMatch:ve,descriptionMatch:ke}}}return b}function n($){const j=[];if(!$)return j;let le;for(const J of $)le&&le.end===J?le.end+=1:(le={start:J,end:J+1},j.push(le));return j}function t($){const j=$.sort((q,Q)=>q.start-Q.start),le=[];let J;for(const q of j)!J||!u(J,q)?(J=q,le.push(q)):(J.start=Math.min(J.start,q.start),J.end=Math.max(J.end,q.end));return le}function u($,j){return!($.end<j.start||j.end<$.start)}function w($,j,le,J,q,Q){const Z=s($,le,J,q,Q),te=s(j,le,J,q,Q),X=Z.score,_=te.score;if((X===C||_===C)&&X!==_)return X===C?-1:1;if(X>i||_>i){if(X!==_)return X>_?-1:1;if(X<p&&_<p){const ae=F(Z.labelMatch,te.labelMatch);if(ae!==0)return ae}const Oe=q.getItemLabel($)||"",oe=q.getItemLabel(j)||"";if(Oe.length!==oe.length)return Oe.length-oe.length}if(X!==_)return X>_?-1:1;const ie=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,pe=Array.isArray(te.labelMatch)&&te.labelMatch.length>0;if(ie&&!pe)return-1;if(pe&&!ie)return 1;const ve=S($,Z,q),ke=S(j,te,q);return ve&&ke&&ve!==ke?ke>ve?-1:1:x($,j,le,q)}e.compareItemsByFuzzyScore=w;function S($,j,le){let J=-1,q=-1;if(j.descriptionMatch&&j.descriptionMatch.length?J=j.descriptionMatch[0].start:j.labelMatch&&j.labelMatch.length&&(J=j.labelMatch[0].start),j.labelMatch&&j.labelMatch.length){if(q=j.labelMatch[j.labelMatch.length-1].end,j.descriptionMatch&&j.descriptionMatch.length){const Q=le.getItemDescription($);Q&&(q+=Q.length)}}else j.descriptionMatch&&j.descriptionMatch.length&&(q=j.descriptionMatch[j.descriptionMatch.length-1].end);return q-J}function F($,j){if(!$&&!j||(!$||!$.length)&&(!j||!j.length))return 0;if(!j||!j.length)return-1;if(!$||!$.length)return 1;const le=$[0].start,q=$[$.length-1].end-le,Q=j[0].start,te=j[j.length-1].end-Q;return q===te?0:te<q?1:-1}function x($,j,le,J){const q=J.getItemLabel($)||"",Q=J.getItemLabel(j)||"",Z=J.getItemDescription($),te=J.getItemDescription(j),X=q.length+(Z?Z.length:0),_=Q.length+(te?te.length:0);if(X!==_)return X-_;const ie=J.getItemPath($),pe=J.getItemPath(j);return ie&&pe&&ie.length!==pe.length?ie.length-pe.length:q!==Q?(0,a.compareAnything)(q,Q,le.normalized):Z&&te&&Z!==te?(0,a.compareAnything)(Z,te,le.normalized):ie&&pe&&ie!==pe?(0,a.compareAnything)(ie,pe,le.normalized):0}function V($){return $.startsWith('"')&&$.endsWith('"')}const M=" ";function B($){typeof $!="string"&&($="");const j=$.toLowerCase(),{pathNormalized:le,normalized:J,normalizedLowercase:q}=O($),Q=le.indexOf(R.sep)>=0,Z=V($);let te;const X=$.split(M);if(X.length>1)for(const _ of X){const ie=V(_),{pathNormalized:pe,normalized:ve,normalizedLowercase:ke}=O(_);ve&&(te||(te=[]),te.push({original:_,originalLowercase:_.toLowerCase(),pathNormalized:pe,normalized:ve,normalizedLowercase:ke,expectContiguousMatch:ie}))}return{original:$,originalLowercase:j,pathNormalized:le,normalized:J,normalizedLowercase:q,values:te,containsPathSeparator:Q,expectContiguousMatch:Z}}e.prepareQuery=B;function O($){let j;D.isWindows?j=$.replace(/\//g,R.sep):j=$.replace(/\\/g,R.sep);const le=(0,P.stripWildcards)(j).replace(/\s|"/g,"");return{pathNormalized:j,normalized:le,normalizedLowercase:le.toLowerCase()}}function U($){return Array.isArray($)?B($.map(j=>j.original).join(M)):B($.original)}e.pieceToQuery=U}),define(ye[163],De([1,0,110,8,51]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",D=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${D.source}`,"g");function E(d){return d.replace(P,(g,b)=>b?g:`\\${g}`)}e.escapeIcons=E;const k=new RegExp(`\\\\${D.source}`,"g");function L(d){return d.replace(k,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=L;const T=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function v(d){return d.indexOf(R)===-1?d:d.replace(T,(g,b,C,p)=>C?g:b||p||"")}e.stripIcons=v;function I(d){return d?d.replace(/\$\((.*?)\)/g,(g,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=I;const y=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(d){y.lastIndex=0;let g="";const b=[];let C=0;for(;;){const p=y.lastIndex,i=y.exec(d),o=d.substring(p,i?.index);if(o.length>0){g+=o;for(let s=0;s<o.length;s++)b.push(C)}if(!i)break;C+=i[0].length}return{text:g,iconOffsets:b}}e.parseLabelWithIcons=f;function h(d,g,b=!1){const{text:C,iconOffsets:p}=g;if(!p||p.length===0)return(0,a.matchesFuzzy)(d,C,b);const i=(0,A.ltrim)(C," "),o=C.length-i.length,s=(0,a.matchesFuzzy)(d,i,b);if(s)for(const c of s){const r=p[c.start+o]+o;c.start+=r,c.end+=r}return s}e.matchesFuzzyIconAware=h}),define(ye[37],De([1,0,8]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const R="error",D="warning",P="warn",E="info",k="ignore";function L(v){return v?a.equalsIgnoreCase(R,v)?l.Error:a.equalsIgnoreCase(D,v)||a.equalsIgnoreCase(P,v)?l.Warning:a.equalsIgnoreCase(E,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=L;function T(v){switch(v){case l.Error:return R;case l.Warning:return D;case l.Info:return E;default:return k}}l.toString=T}(A||(A={})),e.default=A}),define(ye[68],De([1,0,15,8]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(I){return this.b=I,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(I){const y=I.charCodeAt(0),f=this.b.charCodeAt(this.c);return y-f}value(){return this.b[this.c]}}e.StringIterator=l;class R{constructor(I=!0){this.e=I}reset(I){return this.b=I,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let I=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(I)this.c++;else break;else I=!1;return this}cmp(I){return this.e?(0,A.compareSubstring)(I,this.b,0,I.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class D{constructor(I=!0,y=!0){this.f=I,this.g=y}reset(I){this.d=0,this.e=0,this.b=I,this.c=I.length;for(let y=I.length-1;y>=0;y--,this.c--){const f=this.b.charCodeAt(y);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let I=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(I)this.d++;else break;else I=!1}return this}cmp(I){return this.g?(0,A.compareSubstring)(I,this.b,0,I.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(I,this.b,0,I.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=D;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class E{constructor(I,y){this.f=I,this.g=y,this.d=[],this.e=0}reset(I){return this.c=I,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(I)),this.b.reset(I.path),this.b.value()&&this.d.push(3)),this.g(I)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(I){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(I,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(I,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(I);if(this.d[this.e]===4)return(0,A.compare)(I,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(I,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=E;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const I=this.right;return this.right=I.left,I.left=this,this.updateHeight(),I.updateHeight(),I}rotateRight(){const I=this.left;return this.left=I.right,I.right=this,this.updateHeight(),I.updateHeight(),I}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class T{static forUris(I=()=>!1,y=()=>!1){return new T(new E(I,y))}static forPaths(I=!1){return new T(new D(void 0,!I))}static forStrings(){return new T(new l)}static forConfigKeys(){return new T(new R)}constructor(I){this.b=I}clear(){this.c=void 0}fill(I,y){if(y){const f=y.slice(0);(0,a.shuffle)(f);for(const h of f)this.set(h,I)}else{const f=I.slice(0);(0,a.shuffle)(f);for(const h of f)this.set(h[0],h[1])}}set(I,y){const f=this.b.reset(I);let h;this.c||(this.c=new k,this.c.segment=f.value());const d=[];for(h=this.c;;){const b=f.cmp(h.segment);if(b>0)h.left||(h.left=new k,h.left.segment=f.value()),d.push([-1,h]),h=h.left;else if(b<0)h.right||(h.right=new k,h.right.segment=f.value()),d.push([1,h]),h=h.right;else if(f.hasNext())f.next(),h.mid||(h.mid=new k,h.mid.segment=f.value()),d.push([0,h]),h=h.mid;else break}const g=h.value;h.value=y,h.key=I;for(let b=d.length-1;b>=0;b--){const C=d[b][1];C.updateHeight();const p=C.balanceFactor();if(p<-1||p>1){const i=d[b][0],o=d[b+1][0];if(i===1&&o===1)d[b][1]=C.rotateLeft();else if(i===-1&&o===-1)d[b][1]=C.rotateRight();else if(i===1&&o===-1)C.right=d[b+1][1]=d[b+1][1].rotateRight(),d[b][1]=C.rotateLeft();else if(i===-1&&o===1)C.left=d[b+1][1]=d[b+1][1].rotateLeft(),d[b][1]=C.rotateRight();else throw new Error;if(b>0)switch(d[b-1][0]){case-1:d[b-1][1].left=d[b][1];break;case 1:d[b-1][1].right=d[b][1];break;case 0:d[b-1][1].mid=d[b][1];break}else this.c=d[0][1]}}return g}get(I){return this.d(I)?.value}d(I){const y=this.b.reset(I);let f=this.c;for(;f;){const h=y.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else break}return f}has(I){const y=this.d(I);return!(y?.value===void 0&&y?.mid===void 0)}delete(I){return this.e(I,!1)}deleteSuperstr(I){return this.e(I,!0)}e(I,y){const f=this.b.reset(I),h=[];let d=this.c;for(;d;){const g=f.cmp(d.segment);if(g>0)h.push([-1,d]),d=d.left;else if(g<0)h.push([1,d]),d=d.right;else if(f.hasNext())f.next(),h.push([0,d]),d=d.mid;else break}if(!!d){if(y?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const g=this.f(d.right);if(g.key){const{key:b,value:C,segment:p}=g;this.e(g.key,!1),d.key=b,d.value=C,d.segment=p}}else{const g=d.left??d.right;if(h.length>0){const[b,C]=h[h.length-1];switch(b){case-1:C.left=g;break;case 0:C.mid=g;break;case 1:C.right=g;break}}else this.c=g}for(let g=h.length-1;g>=0;g--){const b=h[g][1];b.updateHeight();const C=b.balanceFactor();if(C>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),h[g][1]=b.rotateLeft()):C<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),h[g][1]=b.rotateRight()),g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this.c=h[0][1]}}}f(I){for(;I.left;)I=I.left;return I}findSubstr(I){const y=this.b.reset(I);let f=this.c,h;for(;f;){const d=y.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(y.hasNext())y.next(),h=f.value||h,f=f.mid;else break}return f&&f.value||h}findSuperstr(I){return this.g(I,!1)}g(I,y){const f=this.b.reset(I);let h=this.c;for(;h;){const d=f.cmp(h.segment);if(d>0)h=h.left;else if(d<0)h=h.right;else if(f.hasNext())f.next(),h=h.mid;else return h.mid?this.h(h.mid):y?h.value:void 0}}hasElementOrSubtree(I){return this.g(I,!0)!==void 0}forEach(I){for(const[y,f]of this)I(f,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(I){const y=[];return this.j(I,y),y[Symbol.iterator]()}j(I,y){!I||(I.left&&this.j(I.left,y),I.value&&y.push([I.key,I.value]),I.mid&&this.j(I.mid,y),I.right&&this.j(I.right,y))}_isBalanced(){const I=y=>{if(!y)return!0;const f=y.balanceFactor();return f<-1||f>1?!1:I(y.left)&&I(y.right)};return I(this.c)}}e.TernarySearchTree=T}),define(ye[2],De([1,0,10,12]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function P(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!l.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!R.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(s,c){return!s&&!c?"file":s}function k(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==T&&(c=T+c):c=T;break}return c}const L="",T="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class I{static isUri(c){return c instanceof I?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,r,m,n,t,u=!1){typeof c=="object"?(this.scheme=c.scheme||L,this.authority=c.authority||L,this.path=c.path||L,this.query=c.query||L,this.fragment=c.fragment||L):(this.scheme=E(c,u),this.authority=r||L,this.path=k(this.scheme,m||L),this.query=n||L,this.fragment=t||L,P(this,u))}get fsPath(){return b(this,!1)}with(c){if(!c)return this;let{scheme:r,authority:m,path:n,query:t,fragment:u}=c;return r===void 0?r=this.scheme:r===null&&(r=L),m===void 0?m=this.authority:m===null&&(m=L),n===void 0?n=this.path:n===null&&(n=L),t===void 0?t=this.query:t===null&&(t=L),u===void 0?u=this.fragment:u===null&&(u=L),r===this.scheme&&m===this.authority&&n===this.path&&t===this.query&&u===this.fragment?this:new f(r,m,n,t,u)}static parse(c,r=!1){const m=v.exec(c);return m?new f(m[2]||L,o(m[4]||L),o(m[5]||L),o(m[7]||L),o(m[9]||L),r):new f(L,L,L,L,L)}static file(c){let r=L;if(A.isWindows&&(c=c.replace(/\\/g,T)),c[0]===T&&c[1]===T){const m=c.indexOf(T,2);m===-1?(r=c.substring(2),c=T):(r=c.substring(2,m),c=c.substring(m)||T)}return new f("file",r,c,L,L)}static from(c){const r=new f(c.scheme,c.authority,c.path,c.query,c.fragment);return P(r,!0),r}static joinPath(c,...r){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return A.isWindows&&c.scheme==="file"?m=I.file(a.win32.join(b(c,!0),...r)).path:m=a.posix.join(c.path,...r),c.with({path:m})}toString(c=!1){return C(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof I)return c;{const r=new f(c);return r._formatted=c.external,r._fsPath=c._sep===y?c.fsPath:null,r}}else return c}}e.URI=I;const y=A.isWindows?1:void 0;class f extends I{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(c=!1){return c?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=y),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,c,r){let m,n=-1;for(let t=0;t<s.length;t++){const u=s.charCodeAt(t);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||c&&u===47||r&&u===91||r&&u===93||r&&u===58)n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m!==void 0&&(m+=s.charAt(t));else{m===void 0&&(m=s.substr(0,t));const w=h[u];w!==void 0?(n!==-1&&(m+=encodeURIComponent(s.substring(n,t)),n=-1),m+=w):n===-1&&(n=t)}}return n!==-1&&(m+=encodeURIComponent(s.substring(n))),m!==void 0?m:s}function g(s){let c;for(let r=0;r<s.length;r++){const m=s.charCodeAt(r);m===35||m===63?(c===void 0&&(c=s.substr(0,r)),c+=h[m]):c!==void 0&&(c+=s[r])}return c!==void 0?c:s}function b(s,c){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=b;function C(s,c){const r=c?g:d;let m="",{scheme:n,authority:t,path:u,query:w,fragment:S}=s;if(n&&(m+=n,m+=":"),(t||n==="file")&&(m+=T,m+=T),t){let F=t.indexOf("@");if(F!==-1){const x=t.substr(0,F);t=t.substr(F+1),F=x.lastIndexOf(":"),F===-1?m+=r(x,!1,!1):(m+=r(x.substr(0,F),!1,!1),m+=":",m+=r(x.substr(F+1),!1,!0)),m+="@"}t=t.toLowerCase(),F=t.lastIndexOf(":"),F===-1?m+=r(t,!1,!0):(m+=r(t.substr(0,F),!1,!0),m+=t.substr(F))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const F=u.charCodeAt(1);F>=65&&F<=90&&(u=`/${String.fromCharCode(F+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const F=u.charCodeAt(0);F>=65&&F<=90&&(u=`${String.fromCharCode(F+32)}:${u.substr(2)}`)}m+=r(u,!0,!1)}return w&&(m+="?",m+=r(w,!1,!1)),S&&(m+="#",m+=c?S:d(S,!1,!1)),m}function p(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+p(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,c=>p(c)):s}}),define(ye[69],De([1,0,22,8,2]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(k){return JSON.stringify(k,P)}e.stringify=R;function D(k){let L=JSON.parse(k);return L=E(L),L}e.parse=D;function P(k,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,A.regExpFlags)(L)}:L}function E(k,L=0){if(!k||L>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return l.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof a.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let T=0;T<k.length;++T)k[T]=E(k[T],L+1);else for(const T in k)Object.hasOwnProperty.call(k,T)&&(k[T]=E(k[T],L+1))}return k}e.revive=E}),define(ye[16],De([1,0,11,12,2]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.vscodeUserData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls",k.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,T,v){this.a[L]=T,this.b[L]=v}setConnectionToken(L,T){this.c[L]=T}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(h){return a.onUnexpectedError(h),L}const T=L.authority;let v=this.a[T];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const I=this.b[T],y=this.c[T];let f=`path=${encodeURIComponent(L.path)}`;return typeof y=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),l.URI.from({scheme:A.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${I}`,path:this.f,query:f})}}e.RemoteAuthorities=new D,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(L){const T=this.b(L,ne);return this.uriToBrowserUri(T)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${R.vscodeFileResource}://${P.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||P.a,query:null,fragment:null}):L}asFileUri(L){const T=this.b(L,ne);return this.uriToFileUri(T)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==P.a?L.authority:null,query:null,fragment:null}):L}b(L,T){return l.URI.isUri(L)?L:l.URI.parse(T.toUrl(L))}}P.a="vscode-app",e.FileAccess=new P;var E;(function(k){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);k.CoopAndCoep=Object.freeze(L.get("3"));const T="vscode-coi";function v(y){let f;typeof y=="string"?f=new URL(y).searchParams:y instanceof URL?f=y.searchParams:l.URI.isUri(y)&&(f=new URL(y.toString(!0)).searchParams);const h=f?.get(T);if(!!h)return L.get(h)}k.getHeadersFromQuery=v;function I(y,f,h){if(!globalThis.crossOriginIsolated)return;const d=f&&h?"3":h?"2":"1";y instanceof URLSearchParams?y.set(T,d):y[T]=d}k.addSearchParam=I})(E=e.COI||(e.COI={}))}),define(ye[24],De([1,0,33,16,10,12,8,2]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(I){return(0,P.uriToFsPath)(I,!0)}e.originalFSPath=E;class k{constructor(y){this.a=y}compare(y,f,h=!1){return y===f?0:(0,D.compare)(this.getComparisonKey(y,h),this.getComparisonKey(f,h))}isEqual(y,f,h=!1){return y===f?!0:!y||!f?!1:this.getComparisonKey(y,h)===this.getComparisonKey(f,h)}getComparisonKey(y,f=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,f,h=!1){if(y.scheme===f.scheme){if(y.scheme===A.Schemas.file)return a.isEqualOrParent(E(y),E(f),this.a(y))&&y.query===f.query&&(h||y.fragment===f.fragment);if((0,e.isEqualAuthority)(y.authority,f.authority))return a.isEqualOrParent(y.path,f.path,this.a(y),"/")&&y.query===f.query&&(h||y.fragment===f.fragment)}return!1}joinPath(y,...f){return P.URI.joinPath(y,...f)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return l.posix.basename(y.path)}extname(y){return l.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let f;return y.scheme===A.Schemas.file?f=P.URI.file(l.dirname(E(y))).path:(f=l.posix.dirname(y.path),y.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),f="/")),y.with({path:f})}normalizePath(y){if(!y.path.length)return y;let f;return y.scheme===A.Schemas.file?f=P.URI.file(l.normalize(E(y))).path:f=l.posix.normalize(y.path),y.with({path:f})}relativePath(y,f){if(y.scheme!==f.scheme||!(0,e.isEqualAuthority)(y.authority,f.authority))return;if(y.scheme===A.Schemas.file){const g=l.relative(E(y),E(f));return R.isWindows?a.toSlashes(g):g}let h=y.path||"/";const d=f.path||"/";if(this.a(y)){let g=0;for(const b=Math.min(h.length,d.length);g<b&&!(h.charCodeAt(g)!==d.charCodeAt(g)&&h.charAt(g).toLowerCase()!==d.charAt(g).toLowerCase());g++);h=d.substr(0,g)+h.substr(g)}return l.posix.relative(h,d)}resolvePath(y,f){if(y.scheme===A.Schemas.file){const h=P.URI.file(l.resolve(E(y),f));return y.with({authority:h.authority,path:h.path})}return f=a.toPosixPath(f),y.with({path:l.posix.resolve(y.path,f)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,f){return y===f||y!==void 0&&f!==void 0&&(0,D.equalsIgnoreCase)(y,f)}hasTrailingPathSeparator(y,f=l.sep){if(y.scheme===A.Schemas.file){const h=E(y);return h.length>a.getRoot(h).length&&h[h.length-1]===f}else{const h=y.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,f=l.sep){return(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,f=l.sep){let h=!1;if(y.scheme===A.Schemas.file){const d=E(y);h=d!==void 0&&d.length===a.getRoot(d).length&&d[d.length-1]===f}else{f="/";const d=y.path;h=d.length===1&&d.charCodeAt(d.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(y,f)?y.with({path:y.path+"/"}):y}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(I=>I.scheme===A.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new k(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(I,y){const f=[];for(let h=0;h<I.length;h++){const d=y(I[h]);I.some((g,b)=>b===h?!1:(0,e.isEqualOrParent)(d,y(g)))||f.push(I[h])}return f}e.distinctParents=L;var T;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function y(f){const h=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[C,p]=b.split(":");C&&p&&h.set(C,p)});const g=f.path.substring(0,f.path.indexOf(";"));return g&&h.set(I.META_DATA_MIME,g),h}I.parseMetaData=y})(T=e.DataUri||(e.DataUri={}));function v(I,y,f){if(y){let h=I.path;return h&&h[0]!==l.posix.sep&&(h=l.posix.sep+h),I.with({scheme:f,authority:y,path:h})}return I.with({scheme:f})}e.toLocalResource=v}),define(ye[19],De([1,0,21,11,3,6,24,12,148]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(_){return!!_&&typeof _.then=="function"}e.isThenable=k;function L(_){const ie=new a.CancellationTokenSource,pe=_(ie.token),ve=new Promise((ke,Oe)=>{const oe=ie.token.onCancellationRequested(()=>{oe.dispose(),ie.dispose(),Oe(new A.CancellationError)});Promise.resolve(pe).then(ae=>{oe.dispose(),ie.dispose(),ke(ae)},ae=>{oe.dispose(),ie.dispose(),Oe(ae)})});return new class{cancel(){ie.cancel()}then(ke,Oe){return ve.then(ke,Oe)}catch(ke){return this.then(void 0,ke)}finally(ke){return ve.finally(ke)}}}e.createCancelablePromise=L;function T(_,ie,pe){return new Promise((ve,ke)=>{const Oe=ie.onCancellationRequested(()=>{Oe.dispose(),ve(pe)});_.then(ve,ke).finally(()=>Oe.dispose())})}e.raceCancellation=T;function v(_,ie){return new Promise((pe,ve)=>{const ke=ie.onCancellationRequested(()=>{ke.dispose(),ve(new A.CancellationError)});_.then(pe,ve).finally(()=>ke.dispose())})}e.raceCancellationError=v;async function I(_){let ie=-1;const pe=_.map((ke,Oe)=>ke.then(oe=>(ie=Oe,oe))),ve=await Promise.race(pe);return _.forEach((ke,Oe)=>{Oe!==ie&&ke.cancel()}),ve}e.raceCancellablePromises=I;function y(_,ie,pe){let ve;const ke=setTimeout(()=>{ve?.(void 0),pe?.()},ie);return Promise.race([_.finally(()=>clearTimeout(ke)),new Promise(Oe=>ve=Oe)])}e.raceTimeout=y;function f(_){return new Promise((ie,pe)=>{const ve=_();k(ve)?ve.then(ie,pe):ie(ve)})}e.asPromise=f;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(ie){if(this.a){if(this.d=ie,!this.b){const pe=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(pe,pe).then(ve)})}return new Promise((pe,ve)=>{this.b.then(pe,ve)})}return this.a=ie(),new Promise((pe,ve)=>{this.a.then(ke=>{this.a=null,pe(ke)},ke=>{this.a=null,ve(ke)})})}}e.Throttler=h;class d{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.Sequencer=d;class g{constructor(){this.a=new Map}queue(ie,pe){const ke=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(pe).finally(()=>{this.a.get(ie)===ke&&this.a.delete(ie)});return this.a.set(ie,ke),ke}}e.SequencerByKey=g;const b=(_,ie)=>{let pe=!0;const ve=setTimeout(()=>{pe=!1,ie()},_);return{isTriggered:()=>pe,dispose:()=>{clearTimeout(ve),pe=!1}}},C=_=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,_())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class p{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,pe=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((ke,Oe)=>{this.d=ke,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const ke=this.g;return this.g=null,ke()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=pe===E.MicrotaskDelay?C(ve):b(pe,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class i{constructor(ie){this.a=new p(ie),this.b=new h}trigger(ie,pe){return this.a.trigger(()=>this.b.queue(ie),pe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class o{constructor(){this.a=!1,this.b=new Promise((ie,pe)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=o;class s extends o{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function c(_,ie){return ie?new Promise((pe,ve)=>{const ke=setTimeout(()=>{Oe.dispose(),pe()},_),Oe=ie.onCancellationRequested(()=>{clearTimeout(ke),Oe.dispose(),ve(new A.CancellationError)})}):L(pe=>c(_,pe))}e.timeout=c;function r(_,ie=0){const pe=setTimeout(_,ie);return(0,R.toDisposable)(()=>clearTimeout(pe))}e.disposableTimeout=r;function m(_){const ie=[];let pe=0;const ve=_.length;function ke(){return pe<ve?_[pe++]():null}function Oe(oe){oe!=null&&ie.push(oe);const ae=ke();return ae?ae.then(Oe):Promise.resolve(ie)}return Promise.resolve(null).then(Oe)}e.sequence=m;function n(_,ie=ve=>!!ve,pe=null){let ve=0;const ke=_.length,Oe=()=>{if(ve>=ke)return Promise.resolve(pe);const oe=_[ve++];return Promise.resolve(oe()).then(fe=>ie(fe)?Promise.resolve(fe):Oe())};return Oe()}e.first=n;function t(_,ie=ve=>!!ve,pe=null){if(_.length===0)return Promise.resolve(pe);let ve=_.length;const ke=()=>{ve=-1;for(const Oe of _)Oe.cancel?.()};return new Promise((Oe,oe)=>{for(const ae of _)ae.then(fe=>{--ve>=0&&ie(fe)?(ke(),Oe(fe)):ve===0&&Oe(pe)}).catch(fe=>{--ve>=0&&(ke(),oe(fe))})})}e.firstParallel=t;class u{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((pe,ve)=>{this.f.push({factory:ie,c:pe,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const pe=ie.factory();pe.then(ie.c,ie.e),pe.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class w extends u{constructor(){super(1)}}e.Queue=w;class S{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ie=new J;return this.b.add(ie),ie.p}d(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,pe=D.extUri){const ve=pe.getComparisonKey(ie);let ke=this.a.get(ve);return ke||(ke=new w,l.Event.once(ke.onDrained)(()=>{ke?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,ke)),ke}f(){!this.d()||this.g()}g(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.g()}}e.ResourceQueue=S;class F{constructor(ie,pe){this.a=-1,typeof ie=="function"&&typeof pe=="number"&&this.setIfNotSet(ie,pe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},pe)}setIfNotSet(ie,pe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},pe))}}e.TimeoutTimer=F;class x{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ie,pe){this.cancel(),this.a=setInterval(()=>{ie()},pe)}}e.IntervalTimer=x;class V{constructor(ie,pe){this.b=-1,this.a=ie,this.d=pe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class M{constructor(ie,pe){pe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${pe}ms is not a multiple of 1000ms.`),this.a=ie,this.b=pe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class B extends V{constructor(ie,pe){super(ie,pe),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class O extends R.Disposable{constructor(ie,pe){super(),this.g=ie,this.h=pe,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const pe of ie)this.a.push(pe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=_=>{(0,P.setTimeout0)(()=>{if(ie)return;const pe=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.runWhenIdle=(_,ie)=>{const pe=requestIdleCallback(_,typeof ie=="number"?{timeout:ie}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(pe))}}}}();class U{constructor(ie){this.d=!1,this.a=()=>{try{this.f=ie()}catch(pe){this.g=pe}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=U;async function $(_,ie,pe){let ve;for(let ke=0;ke<pe;ke++)try{return await _()}catch(Oe){ve=Oe,await c(ie)}throw ve}e.retry=$;class j{hasPending(ie){return this.a?typeof ie=="number"?this.a.taskId===ie:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ie,pe,ve){return this.a={taskId:ie,cancel:()=>ve?.(),promise:pe},pe.then(()=>this.d(ie),()=>this.d(ie)),pe}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}setNext(ie){if(this.b)this.b.run=ie;else{let pe,ve;const ke=new Promise((Oe,oe)=>{pe=Oe,ve=oe});this.b={run:ie,promise:ke,promiseResolve:pe,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class le{constructor(ie,pe=()=>Date.now()){this.d=ie,this.f=pe,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.IntervalCounter=le;class J{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ie,pe)=>{this.a=ie,this.b=pe})}complete(ie){return new Promise(pe=>{this.a(ie),this.f=!0,pe()})}error(ie){return new Promise(pe=>{this.b(ie),this.d=!0,pe()})}cancel(){new Promise(ie=>{this.b(new A.CancellationError),this.d=!0,ie()})}}e.DeferredPromise=J;var q;(function(_){async function ie(ve){let ke;const Oe=await Promise.all(ve.map(oe=>oe.then(ae=>ae,ae=>{ke||(ke=ae)})));if(typeof ke<"u")throw ke;return Oe}_.settled=ie;function pe(ve){return new Promise(async(ke,Oe)=>{try{await ve(ke,Oe)}catch(oe){Oe(oe)}})}_.withAsyncBody=pe})(q=e.Promises||(e.Promises={}));var Q;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(Q||(Q={}));class Z{static fromArray(ie){return new Z(pe=>{pe.emitMany(ie)})}static fromPromise(ie){return new Z(async pe=>{pe.emitMany(await ie)})}static fromPromises(ie){return new Z(async pe=>{await Promise.all(ie.map(async ve=>pe.emitOne(await ve)))})}static merge(ie){return new Z(async pe=>{await Promise.all(ie.map(async ve=>{for await(const ke of ve)pe.emitOne(ke)}))})}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const pe={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(ie(pe)),this.j()}catch(ve){this.k(ve)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,pe){return new Z(async ve=>{for await(const ke of ie)ve.emitOne(pe(ke))})}map(ie){return Z.map(this,ie)}static filter(ie,pe){return new Z(async ve=>{for await(const ke of ie)pe(ke)&&ve.emitOne(ke)})}filter(ie){return Z.filter(this,ie)}static coalesce(ie){return Z.filter(ie,pe=>!!pe)}coalesce(){return Z.coalesce(this)}static async toPromise(ie){const pe=[];for await(const ve of ie)pe.push(ve);return pe}toPromise(){return Z.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}Z.EMPTY=Z.fromArray([]),e.AsyncIterableObject=Z;class te extends Z{constructor(ie,pe){super(pe),this.l=ie}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=te;function X(_){const ie=new a.CancellationTokenSource,pe=_(ie.token);return new te(ie,async ve=>{const ke=ie.token.onCancellationRequested(()=>{ke.dispose(),ie.dispose(),ve.reject(new A.CancellationError)});try{for await(const Oe of pe){if(ie.token.isCancellationRequested)return;ve.emitOne(Oe)}ke.dispose(),ie.dispose()}catch(Oe){ke.dispose(),ie.dispose(),ve.reject(Oe)}})}e.createCancelableAsyncIterable=X}),define(ye[38],De([1,0,15,19,33,28,10,12,8]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",T="[^/\\\\]",v=/\//g;function I(le,J){switch(le){case 0:return"";case 1:return`${T}*?`;default:return`(?:${L}|${T}+${L}${J?`|${L}${T}+`:""})*?`}}function y(le,J){if(!le)return[];const q=[];let Q=!1,Z=!1,te="";for(const X of le){switch(X){case J:if(!Q&&!Z){q.push(te),te="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}te+=X}return te&&q.push(te),q}e.splitGlobAware=y;function f(le){if(!le)return"";let J="";const q=y(le,e.GLOB_SPLIT);if(q.every(Q=>Q===e.GLOBSTAR))J=".*";else{let Q=!1;q.forEach((Z,te)=>{if(Z===e.GLOBSTAR){if(Q)return;J+=I(2,te===q.length-1)}else{let X=!1,_="",ie=!1,pe="";for(const ve of Z){if(ve!=="}"&&X){_+=ve;continue}if(ie&&(ve!=="]"||!pe)){let ke;ve==="-"?ke=ve:(ve==="^"||ve==="!")&&!pe?ke="^":ve===e.GLOB_SPLIT?ke="":ke=(0,E.escapeRegExpCharacters)(ve),pe+=ke;continue}switch(ve){case"{":X=!0;continue;case"[":ie=!0;continue;case"}":{J+=`(?:${y(_,",").map(oe=>f(oe)).join("|")})`,X=!1,_="";break}case"]":{J+="["+pe+"]",ie=!1,pe="";break}case"?":J+=T;continue;case"*":J+=I(1);continue;default:J+=(0,E.escapeRegExpCharacters)(ve)}}te<q.length-1&&(q[te+1]!==e.GLOBSTAR||te+2<q.length)&&(J+=L)}Q=Z===e.GLOBSTAR})}return J}const h=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),o=function(){return!1},s=function(){return null};function c(le,J){if(!le)return s;let q;typeof le!="string"?q=le.pattern:q=le,q=q.trim();const Q=`${q}_${!!J.trimForExclusions}`;let Z=i.get(Q);if(Z)return r(Z,le);let te;return h.test(q)?Z=n(q.substr(4),q):(te=d.exec(m(q,J)))?Z=t(te[1],q):(J.trimForExclusions?b:g).test(q)?Z=u(q,J):(te=C.exec(m(q,J)))?Z=w(te[1].substr(1),q,!0):(te=p.exec(m(q,J)))?Z=w(te[1],q,!1):Z=S(q),i.set(Q,Z),r(Z,le)}function r(le,J){if(typeof J=="string")return le;const q=function(Q,Z){return(0,l.isEqualOrParent)(Q,J.base,!P.isLinux)?le((0,E.ltrim)(Q.substr(J.base.length),D.sep),Z):null};return q.allBasenames=le.allBasenames,q.allPaths=le.allPaths,q.basenames=le.basenames,q.patterns=le.patterns,q}function m(le,J){return J.trimForExclusions&&le.endsWith("/**")?le.substr(0,le.length-2):le}function n(le,J){return function(q,Q){return typeof q=="string"&&q.endsWith(le)?J:null}}function t(le,J){const q=`/${le}`,Q=`\\${le}`,Z=function(X,_){return typeof X!="string"?null:_?_===le?J:null:X===le||X.endsWith(q)||X.endsWith(Q)?J:null},te=[le];return Z.basenames=te,Z.patterns=[J],Z.allBasenames=te,Z}function u(le,J){const q=$(le.slice(1,-1).split(",").map(_=>c(_,J)).filter(_=>_!==s),le),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const Z=function(_,ie){for(let pe=0,ve=q.length;pe<ve;pe++)if(q[pe](_,ie))return le;return null},te=q.find(_=>!!_.allBasenames);te&&(Z.allBasenames=te.allBasenames);const X=q.reduce((_,ie)=>ie.allPaths?_.concat(ie.allPaths):_,[]);return X.length&&(Z.allPaths=X),Z}function w(le,J,q){const Q=D.sep===D.posix.sep,Z=Q?le:le.replace(v,D.sep),te=D.sep+Z,X=D.posix.sep+le;let _;return q?_=function(ie,pe){return typeof ie=="string"&&(ie===Z||ie.endsWith(te)||!Q&&(ie===le||ie.endsWith(X)))?J:null}:_=function(ie,pe){return typeof ie=="string"&&(ie===Z||!Q&&ie===le)?J:null},_.allPaths=[(q?"*/":"./")+le],_}function S(le){try{const J=new RegExp(`^${f(le)}$`);return function(q){return J.lastIndex=0,typeof q=="string"&&J.test(q)?le:null}}catch{return s}}function F(le,J,q){return!le||typeof J!="string"?!1:x(le)(J,void 0,q)}e.match=F;function x(le,J={}){if(!le)return o;if(typeof le=="string"||V(le)){const q=c(le,J);if(q===s)return o;const Q=function(Z,te){return!!q(Z,te)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return O(le,J)}e.parse=x;function V(le){const J=le;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.isRelativePattern=V;function M(le){return le.allBasenames||[]}e.getBasenameTerms=M;function B(le){return le.allPaths||[]}e.getPathTerms=B;function O(le,J){const q=$(Object.getOwnPropertyNames(le).map(_=>U(_,le[_],J)).filter(_=>_!==s)),Q=q.length;if(!Q)return s;if(!q.some(_=>!!_.requiresSiblings)){if(Q===1)return q[0];const _=function(ve,ke){let Oe;for(let oe=0,ae=q.length;oe<ae;oe++){const fe=q[oe](ve,ke);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(Oe||(Oe=[]),Oe.push(fe))}return Oe?(async()=>{for(const oe of Oe){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},ie=q.find(ve=>!!ve.allBasenames);ie&&(_.allBasenames=ie.allBasenames);const pe=q.reduce((ve,ke)=>ke.allPaths?ve.concat(ke.allPaths):ve,[]);return pe.length&&(_.allPaths=pe),_}const Z=function(_,ie,pe){let ve,ke;for(let Oe=0,oe=q.length;Oe<oe;Oe++){const ae=q[Oe];ae.requiresSiblings&&pe&&(ie||(ie=(0,D.basename)(_)),ve||(ve=ie.substr(0,ie.length-(0,D.extname)(_).length)));const fe=ae(_,ie,ve,pe);if(typeof fe=="string")return fe;(0,A.isThenable)(fe)&&(ke||(ke=[]),ke.push(fe))}return ke?(async()=>{for(const Oe of ke){const oe=await Oe;if(typeof oe=="string")return oe}return null})():null},te=q.find(_=>!!_.allBasenames);te&&(Z.allBasenames=te.allBasenames);const X=q.reduce((_,ie)=>ie.allPaths?_.concat(ie.allPaths):_,[]);return X.length&&(Z.allPaths=X),Z}function U(le,J,q){if(J===!1)return s;const Q=c(le,q);if(Q===s)return s;if(typeof J=="boolean")return Q;if(J){const Z=J.when;if(typeof Z=="string"){const te=(X,_,ie,pe)=>{if(!pe||!Q(X,_))return null;const ve=Z.replace("$(basename)",()=>ie),ke=pe(ve);return(0,A.isThenable)(ke)?ke.then(Oe=>Oe?le:null):ke?le:null};return te.requiresSiblings=!0,te}}return Q}function $(le,J){const q=le.filter(_=>!!_.basenames);if(q.length<2)return le;const Q=q.reduce((_,ie)=>{const pe=ie.basenames;return pe?_.concat(pe):_},[]);let Z;if(J){Z=[];for(let _=0,ie=Q.length;_<ie;_++)Z.push(J)}else Z=q.reduce((_,ie)=>{const pe=ie.patterns;return pe?_.concat(pe):_},[]);const te=function(_,ie){if(typeof _!="string")return null;if(!ie){let ve;for(ve=_.length;ve>0;ve--){const ke=_.charCodeAt(ve-1);if(ke===47||ke===92)break}ie=_.substr(ve)}const pe=Q.indexOf(ie);return pe!==-1?Z[pe]:null};te.basenames=Q,te.patterns=Z,te.allBasenames=Q;const X=le.filter(_=>!_.basenames);return X.push(te),X}function j(le,J){return(0,a.equals)(le,J,(q,Q)=>typeof q=="string"&&typeof Q=="string"?q===Q:typeof q!="string"&&typeof Q!="string"?q.base===Q.base&&q.pattern===Q.pattern:!1)}e.patternsEquals=j}),define(ye[112],De([1,0,11,163,24,8,2]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(d="",g=!1){if(this.value=d,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(d,g=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(d):d).replace(/([ \t]+)/g,(b,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,g){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(d,g,b){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(d),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(d,g){const b=new RegExp((0,R.escapeRegExpCharacters)(g),"g");return d.replace(b,(C,p)=>d.charAt(p-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=E;function k(h){return L(h)?!h.value:Array.isArray(h)?h.every(k):!0}e.isEmptyMarkdownString=k;function L(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function T(h,d){return h===d?!0:!h||!d?!1:h.value===d.value&&h.isTrusted===d.isTrusted&&h.supportThemeIcons===d.supportThemeIcons&&h.supportHtml===d.supportHtml&&(h.baseUri===d.baseUri||!!h.baseUri&&!!d.baseUri&&(0,l.isEqual)(D.URI.from(h.baseUri),D.URI.from(d.baseUri)))}e.markdownStringEqual=T;function v(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function I(h){return h.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function y(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=y;function f(h){const d=[],g=h.split("|").map(C=>C.trim());h=g[0];const b=g[1];if(b){const C=/height=(\d+)/.exec(b),p=/width=(\d+)/.exec(b),i=C?C[1]:"",o=p?p[1]:"",s=isFinite(parseInt(o)),c=isFinite(parseInt(i));s&&d.push(`width="${o}"`),c&&d.push(`height="${i}"`)}return{href:h,dimensions:d}}e.parseHrefAndDimensions=f}),define(ye[113],De([1,0,15,33,10,12,24,8]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(s,c){const{os:r,tildify:m,relative:n}=c;if(n){const w=k(s,n,r);if(typeof w=="string")return w}let t=s.fsPath;if(r===1&&!R.isWindows?t=t.replace(/\//g,"\\"):r!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),r!==1&&m?.userHome){const w=m.userHome.fsPath;let S;s.scheme!==m.userHome.scheme&&s.path.startsWith(l.posix.sep)?S=m.userHome.with({path:s.path}).fsPath:S=s.fsPath,t=v(S,w,r)}return(r===1?l.win32:l.posix).normalize(L(t,r===1))}e.getPathLabel=E;function k(s,c,r){const m=r===1?l.win32:l.posix,n=r===3?D.extUri:D.extUriIgnorePathCase,t=c.getWorkspace(),u=(0,a.firstOrDefault)(t.folders);if(!u)return;s.scheme!==u.uri.scheme&&s.path.startsWith(l.posix.sep)&&(s=u.uri.with({path:s.path}));const w=c.getWorkspaceFolder(s);if(!w)return;let S;if(n.isEqual(w.uri,s)?S="":S=n.relativePath(w.uri,s)??"",S&&(S=m.normalize(S)),t.folders.length>1&&!c.noPrefix){const F=w.name?w.name:n.basenameOrAuthority(w.uri);S=S?`${F} \u2022 ${S}`:F}return S}function L(s,c=R.isWindows){return(0,A.hasDriveLetter)(s,c)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=L;let T=Object.create(null);function v(s,c,r=R.OS){if(r===1||!s||!c)return s;let m=T.original===c?T.normalized:void 0;m||(m=c,R.isWindows&&(m=(0,A.toSlashes)(m)),m=`${(0,P.rtrim)(m,l.posix.sep)}${l.posix.sep}`,T={original:c,normalized:m});let n=s;return R.isWindows&&(n=(0,A.toSlashes)(n)),(r===3?n.startsWith(m):(0,P.startsWithIgnoreCase)(n,m))?`~/${n.substr(m.length)}`:s}e.tildify=v;function I(s,c){return s.replace(/^~($|\/|\\)/,`${c}$1`)}e.untildify=I;const y="\u2026",f="\\\\",h="~";function d(s,c=l.sep){const r=new Array(s.length);let m=!1;for(let n=0;n<s.length;n++){const t=s[n];if(t===""){r[n]=`.${c}`;continue}if(!t){r[n]=t;continue}m=!0;let u="",w=t;w.indexOf(f)===0?(u=w.substr(0,w.indexOf(f)+f.length),w=w.substr(w.indexOf(f)+f.length)):w.indexOf(c)===0?(u=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(h)===0&&(u=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length));const S=w.split(c);for(let F=1;m&&F<=S.length;F++)for(let x=S.length-F;m&&x>=0;x--){m=!1;let V=S.slice(x,x+F).join(c);for(let M=0;!m&&M<s.length;M++)if(M!==n&&s[M]&&s[M].indexOf(V)>-1){const B=x+F===S.length,O=x>0&&s[M].indexOf(c)>-1?c+V:V,U=s[M].endsWith(O);m=!B||U}if(!m){let M="";(S[0].endsWith(":")||u!=="")&&(x===1&&(x=0,F++,V=S[0]+c+V),x>0&&(M=S[0]+c),M=u+M),x>0&&(M=M+y+c),M=M+V,x+F<S.length&&(M=M+c+y),r[n]=M}}m&&(r[n]=t)}return r}e.shorten=d;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function b(s,c=Object.create(null)){const r=[];let m=!1,n="";for(const t of s)if(t==="$"||m&&t==="{")n&&r.push({value:n,type:g.TEXT}),n="",m=!0;else if(t==="}"&&m){const u=c[n];if(typeof u=="string")u.length&&r.push({value:u,type:g.VARIABLE});else if(u){const w=r[r.length-1];(!w||w.type!==g.SEPARATOR)&&r.push({value:u.label,type:g.SEPARATOR})}n="",m=!1}else n+=t;return n&&!m&&r.push({value:n,type:g.TEXT}),r.filter((t,u)=>{if(t.type===g.SEPARATOR){const w=r[u-1],S=r[u+1];return[w,S].every(F=>F&&(F.type===g.VARIABLE||F.type===g.TEXT)&&F.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function C(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):s.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function p(s,c){return R.isMacintosh||c?s.replace(/\(&&\w\)|&&/g,""):R.isWindows?s.replace(/&&|&/g,r=>r==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=p;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function o(s){const c=s.indexOf("/")!==-1?l.posix:l.win32,r=c.basename(s),m=c.dirname(s);return r.length?{name:r,parentPath:m}:{name:m,parentPath:""}}e.splitName=o}),define(ye[114],De([1,0,22,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(T){return T.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const I=this.a.transformIncoming(v);return I===v?v:l(A.URI.from(I))}transformOutgoing(v){const I=this.a.transformOutgoing(v);return I===v?v:l(A.URI.from(I))}transformOutgoingURI(v){const I=this.a.transformOutgoing(v);return I===v?v:A.URI.from(I)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(T){return T}transformOutgoing(T){return T}transformOutgoingURI(T){return T}transformOutgoingScheme(T){return T}};function D(T,v,I){if(!T||I>200)return null;if(typeof T=="object"){if(T instanceof A.URI)return v.transformOutgoing(T);for(const y in T)if(Object.hasOwnProperty.call(T,y)){const f=D(T[y],v,I+1);f!==null&&(T[y]=f)}}return null}function P(T,v){const I=D(T,v,0);return I===null?T:I}e.transformOutgoingURIs=P;function E(T,v,I,y){if(!T||y>200)return null;if(typeof T=="object"){if(T.$mid===1)return I?A.URI.revive(v.transformIncoming(T)):v.transformIncoming(T);if(T instanceof a.VSBuffer)return null;for(const f in T)if(Object.hasOwnProperty.call(T,f)){const h=E(T[f],v,I,y+1);h!==null&&(T[f]=h)}}return null}function k(T,v){const I=E(T,v,!1,0);return I===null?T:I}e.transformIncomingURIs=k;function L(T,v){const I=E(T,v,!0,0);return I===null?T:I}e.transformAndReviveIncomingURIs=L}),define(ye[29],De([1,0,70,88,318,19,33,85,10,12,24,2]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function I(O,U=v.UNLINK){if((0,D.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return U===v.UNLINK?f(O):y(O)}async function y(O){try{const U=(0,D.randomPath)((0,A.tmpdir)());try{await a.promises.rename(O,U)}catch($){return $.code==="ENOENT"?void 0:f(O)}f(U).catch($=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function f(O){return(0,l.promisify)(a.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function h(O){if((0,D.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function d(O,U){return C(await(U?g(O):(0,l.promisify)(a.readdir)(O)))}async function g(O){try{return await(0,l.promisify)(a.readdir)(O,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const U=[],$=await d(O);for(const j of $){let le=!1,J=!1,q=!1;try{const Q=await e.Promises.lstat((0,E.join)(O,j));le=Q.isFile(),J=Q.isDirectory(),q=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}U.push({name:j,isFile:()=>le,isDirectory:()=>J,isSymbolicLink:()=>q})}return U}function b(O){return C(a.readdirSync(O))}e.readdirSync=b;function C(O){return O.map(U=>typeof U=="string"?k.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=k.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function p(O){const U=await d(O),$=[];for(const j of U)await o.existsDirectory((0,E.join)(O,j))&&$.push(j);return $}function i(O,U=1e3){return new Promise($=>{let j=!1;const le=setInterval(()=>{j||(j=!0,a.access(O,J=>{j=!1,J&&(clearInterval(le),$(void 0))}))},U)})}e.whenDeleted=i;var o;(function(O){async function U(le){let J;try{if(J=await e.Promises.lstat(le),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(le),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(k.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(le)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw Q}throw q}}O.stat=U;async function $(le){try{const{stat:J,symbolicLink:q}=await O.stat(le);return J.isFile()&&q?.dangling!==!0}catch{}return!1}O.existsFile=$;async function j(le){try{const{stat:J,symbolicLink:q}=await O.stat(le);return J.isDirectory()&&q?.dangling!==!0}catch{}return!1}O.existsDirectory=j})(o=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new R.ResourceQueue;function c(O,U,$){return s.queueFor(T.URI.file(O),L.extUriBiasedIgnorePathCase).queue(()=>{const j=u($);return new Promise((le,J)=>n(O,U,j,q=>q?J(q):le()))})}let r=!0;function m(O){r=O}e.configureFlushOnWrite=m;function n(O,U,$,j){if(!r)return a.writeFile(O,U,{mode:$.mode,flag:$.flag},j);a.open(O,$.flag,$.mode,(le,J)=>{if(le)return j(le);a.writeFile(J,U,q=>{if(q)return a.close(J,()=>j(q));a.fdatasync(J,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),m(!1)),a.close(J,Z=>j(Z))))})})}function t(O,U,$){const j=u($);if(!r)return a.writeFileSync(O,U,{mode:j.mode,flag:j.flag});const le=a.openSync(O,j.flag,j.mode);try{a.writeFileSync(le,U);try{a.fdatasyncSync(le)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),m(!1)}}finally{a.closeSync(le)}}e.writeFileSync=t;function u(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function w(O,U){if(O!==U)try{await e.Promises.rename(O,U)}catch($){if(O.toLowerCase()!==U.toLowerCase()&&$.code==="EXDEV"||O.endsWith("."))await S(O,U,{preserveSymlinks:!1}),await I(O,v.MOVE);else throw $}}async function S(O,U,$){return x(O,U,{root:{source:O,target:U},options:$,handledSourcePaths:new Set})}const F=511;async function x(O,U,$){if($.handledSourcePaths.has(O))return;$.handledSourcePaths.add(O);const{stat:j,symbolicLink:le}=await o.stat(O);if(le){if($.options.preserveSymlinks)try{return await B(O,U,$)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(le.dangling)return}return j.isDirectory()?V(O,U,j.mode&F,$):M(O,U,j.mode&F)}async function V(O,U,$,j){await e.Promises.mkdir(U,{recursive:!0,mode:$});const le=await d(O);for(const J of le)await x((0,E.join)(O,J),(0,E.join)(U,J),j)}async function M(O,U,$){await e.Promises.copyFile(O,U),await e.Promises.chmod(U,$)}async function B(O,U,$){let j=await e.Promises.readlink(O);(0,D.isEqualOrParent)(j,$.root.source,!k.isLinux)&&(j=(0,E.join)($.root.target,j.substr($.root.source.length+1))),await e.Promises.symlink(j,U)}e.Promises=new class{get access(){return(0,l.promisify)(a.access)}get stat(){return(0,l.promisify)(a.stat)}get lstat(){return(0,l.promisify)(a.lstat)}get utimes(){return(0,l.promisify)(a.utimes)}get read(){return(O,U,$,j,le)=>new Promise((J,q)=>{a.read(O,U,$,j,le,(Q,Z,te)=>Q?q(Q):J({bytesRead:Z,buffer:te}))})}get readFile(){return(0,l.promisify)(a.readFile)}get write(){return(O,U,$,j,le)=>new Promise((J,q)=>{a.write(O,U,$,j,le,(Q,Z,te)=>Q?q(Q):J({bytesWritten:Z,buffer:te}))})}get appendFile(){return(0,l.promisify)(a.appendFile)}get fdatasync(){return(0,l.promisify)(a.fdatasync)}get truncate(){return(0,l.promisify)(a.truncate)}get rename(){return(0,l.promisify)(a.rename)}get copyFile(){return(0,l.promisify)(a.copyFile)}get open(){return(0,l.promisify)(a.open)}get close(){return(0,l.promisify)(a.close)}get symlink(){return(0,l.promisify)(a.symlink)}get readlink(){return(0,l.promisify)(a.readlink)}get chmod(){return(0,l.promisify)(a.chmod)}get mkdir(){return(0,l.promisify)(a.mkdir)}get unlink(){return(0,l.promisify)(a.unlink)}get rmdir(){return(0,l.promisify)(a.rmdir)}get realpath(){return(0,l.promisify)(a.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return p}get writeFile(){return c}get rm(){return I}get move(){return w}get copy(){return S}}}),define(ye[115],De([1,0,70,10,12,8,29]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(l.isLinux)return v;const I=(0,A.dirname)(v);if(v===I)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const h=(0,D.readdirSync)(I).filter(d=>d.toLowerCase()===y);if(h.length===1){const d=P(I);if(d)return(0,A.join)(d,h[0])}else if(h.length>1){const d=h.indexOf(y);if(d>=0){const g=P(I);if(g)return(0,A.join)(g,h[d])}}}catch{}return null}e.realcaseSync=P;async function E(v){if(l.isLinux)return v;const I=(0,A.dirname)(v);if(v===I)return v;const y=((0,A.basename)(v)||v).toLowerCase();try{const h=(await D.Promises.readdir(I)).filter(d=>d.toLowerCase()===y);if(h.length===1){const d=await E(I);if(d)return(0,A.join)(d,h[0])}else if(h.length>1){const d=h.indexOf(y);if(d>=0){const g=await E(I);if(g)return(0,A.join)(g,h[d])}}}catch{}return null}e.realcase=E;async function k(v){try{return await D.Promises.realpath(v)}catch{const y=T(v);return await D.Promises.access(y,a.constants.R_OK),y}}e.realpath=k;function L(v){try{return a.realpathSync(v)}catch{const y=T(v);return a.accessSync(y,a.constants.R_OK),y}}e.realpathSync=L;function T(v){return(0,R.rtrim)((0,A.normalize)(v),A.sep)}}),define(ye[116],De([1,0,10,12,36,109,9,29]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function E(T=l.env){return T.comspec||"cmd.exe"}e.getWindowsShell=E;function k(T){let v=[],I=!1;const y=function(f){if(I){v.push(f);return}(!T.send(f,d=>{if(d&&console.error(d),I=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(b=>y(b))}})||A.isWindows)&&(I=!0)};return{send:y}}e.createQueuedSender=k;var L;(function(T){async function v(I,y,f){if(a.isAbsolute(I))return I;if(y===void 0&&(y=l.cwd()),a.dirname(I)!=="."||(f===void 0&&D.isString(l.env.PATH)&&(f=l.env.PATH.split(a.delimiter)),f===void 0||f.length===0))return a.join(y,I);async function d(g){if(await P.Promises.exists(g)){let b;try{b=await P.Promises.stat(g)}catch(C){C.message.startsWith("EACCES")&&(b=await P.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(const g of f){let b;if(a.isAbsolute(g)?b=a.join(g,I):b=a.join(y,g,I),await d(b))return b;let C=b+".com";if(await d(C)||(C=b+".exe",await d(C)))return C}return a.join(y,I)}T.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(ne,e,a,A){var l=arguments.length,R=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,a):A,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,e,a,A);else for(var P=ne.length-1;P>=0;P--)(D=ne[P])&&(R=(l<3?D(R):l>3?D(e,a,R):D(e,a))||R);return l>3&&R&&Object.defineProperty(e,a,R),R};define(ye[117],De([1,0,15,19,22,21,62,11,3,6,69,8,9]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(I||(I={}));function y(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(f||(f={}));function h(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(d||(d={}));function g(J){let q=0;for(let Q=0;;Q+=7){const Z=J.read(1);if(q|=(Z.buffer[0]&127)<<Q,!(Z.buffer[0]&128))return q}}const b=s(0);function C(J,q){if(q===0){J.write(b);return}let Q=0;for(let te=q;te!==0;te=te>>>7)Q++;const Z=l.VSBuffer.alloc(Q);for(let te=0;q!==0;te++)Z.buffer[te]=q&127,q=q>>>7,q>0&&(Z.buffer[te]|=128);J.write(Z)}class p{constructor(q){this.b=q,this.a=0}read(q){const Q=this.b.slice(this.a,this.a+q);return this.a+=Q.byteLength,Q}}e.BufferReader=p;class i{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(q){this.a.push(q)}}e.BufferWriter=i;var o;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(o||(o={}));function s(J){const q=l.VSBuffer.alloc(1);return q.writeUInt8(J,0),q}const c={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},r=typeof Buffer<"u";function m(J,q){if(typeof q>"u")J.write(c.Undefined);else if(typeof q=="string"){const Q=l.VSBuffer.fromString(q);J.write(c.String),C(J,Q.byteLength),J.write(Q)}else if(r&&Buffer.isBuffer(q)){const Q=l.VSBuffer.wrap(q);J.write(c.Buffer),C(J,Q.byteLength),J.write(Q)}else if(q instanceof l.VSBuffer)J.write(c.VSBuffer),C(J,q.byteLength),J.write(q);else if(Array.isArray(q)){J.write(c.Array),C(J,q.length);for(const Q of q)m(J,Q)}else if(typeof q=="number"&&(q|0)===q)J.write(c.Uint),C(J,q);else{const Q=l.VSBuffer.fromString(JSON.stringify(q));J.write(c.Object),C(J,Q.byteLength),J.write(Q)}}e.serialize=m;function n(J){switch(J.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return J.read(g(J)).toString();case o.Buffer:return J.read(g(J)).buffer;case o.VSBuffer:return J.read(g(J));case o.Array:{const Q=g(J),Z=[];for(let te=0;te<Q;te++)Z.push(n(J));return Z}case o.Object:return JSON.parse(J.read(g(J)).toString());case o.Int:return g(J)}}e.deserialize=n;class t{constructor(q,Q,Z=null,te=1e3){this.h=q,this.j=Q,this.k=Z,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(q,Q){this.b.set(q,Q),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const Q=this.o([q.type]);this.k?.logOutgoing(Q,0,1,h(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([q.type,q.id],q.data);this.k?.logOutgoing(Q,q.id,1,h(q.type),q.data);return}}}o(q,Q=void 0){const Z=new i;return m(Z,q),m(Z,Q),this.p(Z.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const Q=new p(q),Z=n(Q),te=n(Q),X=Z[0];switch(X){case 100:return this.k?.logIncoming(q.byteLength,Z[1],1,`${y(X)}: ${Z[2]}.${Z[3]}`,te),this.s({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 102:return this.k?.logIncoming(q.byteLength,Z[1],1,`${y(X)}: ${Z[2]}.${Z[3]}`,te),this.t({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:te});case 101:return this.k?.logIncoming(q.byteLength,Z[1],1,`${y(X)}`),this.u({type:X,id:Z[1]});case 103:return this.k?.logIncoming(q.byteLength,Z[1],1,`${y(X)}`),this.u({type:X,id:Z[1]})}}s(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const Z=new R.CancellationTokenSource;let te;try{te=Q.call(this.j,q.name,q.arg,Z.token)}catch(ie){te=Promise.reject(ie)}const X=q.id;te.then(ie=>{this.m({id:X,data:ie,type:201}),this.d.delete(q.id)},ie=>{ie instanceof Error?this.m({id:X,data:{message:ie.message,name:ie.name,stack:ie.stack?ie.stack.split?ie.stack.split(`
`):ie.stack:void 0},type:202}):this.m({id:X,data:ie,type:203}),this.d.delete(q.id)});const _=(0,k.toDisposable)(()=>Z.cancel());this.d.set(q.id,_)}t(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const Z=q.id,X=Q.listen(this.j,q.name,q.arg)(_=>this.m({id:Z,data:_,type:204}));this.d.set(q.id,X)}u(q){const Q=this.d.get(q.id);Q&&(Q.dispose(),this.d.delete(q.id))}v(q){let Q=this.g.get(q.channelName);Q||(Q=[],this.g.set(q.channelName,Q));const Z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:q,timeoutTimer:Z})}w(q){const Q=this.g.get(q);if(Q){for(const Z of Q)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var u;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class w{constructor(q,Q=null){this.l=q,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=Q}getChannel(q){const Q=this;return{call(Z,te,X){return Q.a?Promise.reject(new P.CancellationError):Q.m(q,Z,te,X)},listen(Z,te){return Q.a?E.Event.None:Q.o(q,Z,te)}}}m(q,Q,Z,te=R.CancellationToken.None){const X=this.g++,ie={id:X,type:100,channelName:q,name:Q,arg:Z};if(te.isCancellationRequested)return Promise.reject(new P.CancellationError);let pe;return new Promise((ke,Oe)=>{if(te.isCancellationRequested)return Oe(new P.CancellationError);const oe=()=>{const ue=se=>{switch(se.type){case 201:this.f.delete(X),ke(se.data);break;case 202:{this.f.delete(X);const N=new Error(se.data.message);N.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,N.name=se.data.name,Oe(N);break}case 203:this.f.delete(X),Oe(se.data);break}};this.f.set(X,ue),this.p(ie)};let ae=null;this.b===d.Idle?oe():(ae=(0,A.createCancelablePromise)(ue=>this.u()),ae.then(()=>{ae=null,oe()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.p({id:X,type:101}),Oe(new P.CancellationError)},ee=te.onCancellationRequested(fe);pe=(0,k.combinedDisposable)((0,k.toDisposable)(fe),ee),this.d.add(pe)}).finally(()=>{this.d.delete(pe)})}o(q,Q,Z){const te=this.g++,_={id:te,type:102,channelName:q,name:Q,arg:Z};let ie=null;const pe=new E.Emitter({onWillAddFirstListener:()=>{ie=(0,A.createCancelablePromise)(ke=>this.u()),ie.then(()=>{ie=null,this.d.add(pe),this.p(_)})},onDidRemoveLastListener:()=>{ie?(ie.cancel(),ie=null):(this.d.delete(pe),this.p({id:te,type:103}))}}),ve=ke=>pe.fire(ke.data);return this.f.set(te,ve),pe.event}p(q){switch(q.type){case 100:case 102:{const Q=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Q,q.id,0,`${y(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.q([q.type,q.id]);this.j?.logOutgoing(Q,q.id,0,y(q.type));return}}}q(q,Q=void 0){const Z=new i;return m(Z,q),m(Z,Q),this.r(Z.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const Q=new p(q),Z=n(Q),te=n(Q),X=Z[0];switch(X){case 200:return this.j?.logIncoming(q.byteLength,0,0,h(X)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,Z[1],0,h(X),te),this.t({type:Z[0],id:Z[1],data:te})}}t(q){if(q.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.dispose)(this.d.values()),this.d.clear()}}qe([D.memoize],w.prototype,"onDidInitializePromise",null),e.ChannelClient=w;class S{get connections(){const q=[];return this.f.forEach(Q=>q.push(Q)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new E.Emitter,this.onDidAddConnection=this.g.event,this.h=new E.Emitter,this.onDidRemoveConnection=this.h.event,q(({protocol:Q,onDidClientDisconnect:Z})=>{E.Event.once(Q.onMessage)(X=>{const _=new p(X),ie=n(_),pe=new t(Q,ie),ve=new w(Q);this.a.forEach((Oe,oe)=>pe.registerChannel(oe,Oe));const ke={channelServer:pe,channelClient:ve,ctx:ie};this.f.add(ke),this.g.fire(ke),Z(()=>{pe.dispose(),ve.dispose(),this.f.delete(ke),this.h.fire(ke)})})})}getChannel(q,Q){const Z=this;return{call(te,X,_){let ie;if((0,v.isFunction)(Q)){const ve=(0,a.getRandomElement)(Z.connections.filter(Q));ie=ve?Promise.resolve(ve):E.Event.toPromise(E.Event.filter(Z.onDidAddConnection,Q))}else ie=Q.routeCall(Z,te,X);const pe=ie.then(ve=>ve.channelClient.getChannel(q));return x(pe).call(te,X,_)},listen(te,X){if((0,v.isFunction)(Q))return Z.j(q,Q,te,X);const _=Q.routeEvent(Z,te,X).then(ie=>ie.channelClient.getChannel(q));return x(_).listen(te,X)}}}j(q,Q,Z,te){const X=this;let _=new k.DisposableStore;const ie=new E.Emitter({onWillAddFirstListener:()=>{_=new k.DisposableStore;const pe=new E.EventMultiplexer,ve=new Map,ke=oe=>{const fe=oe.channelClient.getChannel(q).listen(Z,te),ee=pe.add(fe);ve.set(oe,ee)},Oe=oe=>{const ae=ve.get(oe);!ae||(ae.dispose(),ve.delete(oe))};X.connections.filter(Q).forEach(ke),E.Event.filter(X.onDidAddConnection,Q)(ke,void 0,_),X.onDidRemoveConnection(Oe,void 0,_),pe.event(ie.fire,ie,_),_.add(pe)},onDidRemoveLastListener:()=>{_.dispose()}});return ie.event}registerChannel(q,Q){this.a.set(q,Q),this.f.forEach(Z=>{Z.channelServer.registerChannel(q,Q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=S;class F{constructor(q,Q,Z=null){const te=new i;m(te,Q),q.send(te.buffer),this.a=new w(q,Z),this.d=new t(q,Q,Z)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Q){this.d.registerChannel(q,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=F;function x(J){return{call(q,Q,Z){return J.then(te=>te.call(q,Q,Z))},listen(q,Q){const Z=new E.Relay;return J.then(te=>Z.input=te.listen(q,Q)),Z.event}}}e.getDelayedChannel=x;function V(J){let q=!1;return{call(Q,Z,te){return q?J.call(Q,Z,te):(0,A.timeout)(0).then(()=>q=!0).then(()=>J.call(Q,Z,te))},listen(Q,Z){if(q)return J.listen(Q,Z);const te=new E.Relay;return(0,A.timeout)(0).then(()=>q=!0).then(()=>te.input=J.listen(Q,Z)),te.event}}}e.getNextTickChannel=V;class M{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Q of q.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await E.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.StaticRouter=M;var B;(function(J){function q(X,_){const ie=X,pe=_&&_.disableMarshalling,ve=new Map;for(const ke in ie)Z(ke)&&ve.set(ke,E.Event.buffer(ie[ke],!0));return new class{listen(ke,Oe,oe){const ae=ve.get(Oe);if(ae)return ae;if(te(Oe)){const fe=ie[Oe];if(typeof fe=="function")return fe.call(ie,oe)}throw new Error(`Event not found: ${Oe}`)}call(ke,Oe,oe){const ae=ie[Oe];if(typeof ae=="function"){if(!pe&&Array.isArray(oe))for(let fe=0;fe<oe.length;fe++)oe[fe]=(0,L.revive)(oe[fe]);return ae.apply(ie,oe)}throw new Error(`Method not found: ${Oe}`)}}}J.fromService=q;function Q(X,_){const ie=_&&_.disableMarshalling;return new Proxy({},{get(pe,ve){if(typeof ve=="string")return _?.properties?.has(ve)?_.properties.get(ve):te(ve)?function(ke){return X.listen(ve,ke)}:Z(ve)?X.listen(ve):async function(...ke){let Oe;_&&!(0,v.isUndefinedOrNull)(_.context)?Oe=[_.context,...ke]:Oe=ke;const oe=await X.call(ve,Oe);return ie?oe:(0,L.revive)(oe)};throw new Error(`Property not found: ${String(ve)}`)}})}J.toService=Q;function Z(X){return X[0]==="o"&&X[1]==="n"&&T.isUpperAsciiLetter(X.charCodeAt(2))}function te(X){return/^onDynamic/.test(X)&&T.isUpperAsciiLetter(X.charCodeAt(9))}})(B=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const q=J.toString();if(q!=="[object Object]")return q}return J}function $(J){return Array.isArray(J)?J.map(U):U(J)}function j(J,q,Q,Z,te,X,_){_=$(_);const ie=O[te],pe=ie[Z%ie.length];let ve=[`%c[${J}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${pe}`];/\($/.test(X)?(ve=ve.concat(_),ve.push(")")):ve.push(_),console.log.apply(console,ve)}class le{constructor(q,Q){this.d=q,this.f=Q,this.a=0,this.b=0}logOutgoing(q,Q,Z,te,X){this.b+=q,j(this.d,this.b,q,Q,Z,te,X)}logIncoming(q,Q,Z,te,X){this.a+=q,j(this.f,this.a,q,Q,Z,te,X)}}e.IPCLogger=le}),define(ye[118],De([1,0,19,22,3,6,117]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(w){w.Created="created",w.Read="read",w.Write="write",w.Open="open",w.Error="error",w.Close="close",w.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",w.NodeEndReceived="nodeEndReceived",w.NodeEndSent="nodeEndSent",w.NodeDrainBegin="nodeDrainBegin",w.NodeDrainEnd="nodeDrainEnd",w.zlibInflateError="zlibInflateError",w.zlibInflateData="zlibInflateData",w.zlibInflateInitialWrite="zlibInflateInitialWrite",w.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",w.zlibInflateWrite="zlibInflateWrite",w.zlibInflateFlushFired="zlibInflateFlushFired",w.zlibDeflateError="zlibDeflateError",w.zlibDeflateData="zlibDeflateData",w.zlibDeflateWrite="zlibDeflateWrite",w.zlibDeflateFlushFired="zlibDeflateFlushFired",w.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",w.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",w.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",w.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",w.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",w.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",w.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",w.ProtocolHeaderRead="protocolHeaderRead",w.ProtocolMessageRead="protocolMessageRead",w.ProtocolHeaderWrite="protocolHeaderWrite",w.ProtocolMessageWrite="protocolMessageWrite",w.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var E;(function(w){w.enableDiagnostics=!1,w.records=[];const S=new WeakMap;let F=0;function x(M,B){if(!S.has(M)){const O=String(++F);S.set(M,O)}return S.get(M)}function V(M,B,O,U){if(!w.enableDiagnostics)return;const $=x(M,B);if(U instanceof A.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const j=A.VSBuffer.alloc(U.byteLength);j.set(U),w.records.push({timestamp:Date.now(),id:$,label:B,type:O,buff:j})}else w.records.push({timestamp:Date.now(),id:$,label:B,type:O,data:U})}w.traceSocketEvent=V})(E=e.SocketDiagnostics||(e.SocketDiagnostics={}));var k;(function(w){w[w.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",w[w.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function T(){return L||(L=A.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(S){this.a.push(S),this.b+=S.byteLength}read(S){return this.c(S,!0)}peek(S){return this.c(S,!1)}c(S,F){if(S===0)return T();if(S>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===S){const B=this.a[0];return F&&(this.a.shift(),this.b-=S),B}if(this.a[0].byteLength>S){const B=this.a[0].slice(0,S);return F&&(this.a[0]=this.a[0].slice(S),this.b-=S),B}const x=A.VSBuffer.alloc(S);let V=0,M=0;for(;S>0;){const B=this.a[M];if(B.byteLength>S){const O=B.slice(0,S);x.set(O,V),V+=S,F&&(this.a[M]=B.slice(S),this.b-=S),S-=S}else x.set(B,V),V+=B.byteLength,F?(this.a.shift(),this.b-=B.byteLength):M++,S-=B.byteLength}return x}}e.ChunkStream=v;var I;(function(w){w[w.None=0]="None",w[w.Regular=1]="Regular",w[w.Control=2]="Control",w[w.Ack=3]="Ack",w[w.Disconnect=5]="Disconnect",w[w.ReplayRequest=6]="ReplayRequest",w[w.Pause=7]="Pause",w[w.Resume=8]="Resume",w[w.KeepAlive=9]="KeepAlive",w[w.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",w[w.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(I||(I={}));function y(w){switch(w){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(w){w[w.HeaderLength=13]="HeaderLength",w[w.AcknowledgeTime=2e3]="AcknowledgeTime",w[w.TimeoutTime=2e4]="TimeoutTime",w[w.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",w[w.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",w[w.KeepAliveSendTime=5e3]="KeepAliveSendTime",w[w.LatencySampleTime=6e4]="LatencySampleTime",w[w.LatencySampleCount=5]="LatencySampleCount",w[w.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",w[w.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(S,F,x,V){this.type=S,this.id=F,this.ack=x,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends R.Disposable{constructor(S){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=S,this.b=!1,this.c=new v,this.B(this.a.onData(F=>this.acceptChunk(F))),this.lastReadTime=Date.now()}acceptChunk(S){if(!(!S||S.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(S);this.c.byteLength>=this.g.readLen;){const F=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=F.readUInt32BE(9),this.g.messageType=F.readUInt8(0),this.g.id=F.readUInt32BE(1),this.g.ack=F.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const x=this.g.messageType,V=this.g.id,M=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",F),this.f.fire(new h(x,V,M,F)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(S){this.k=null,this.a=!1,this.b=!1,this.c=S,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(S){if(this.a)return;S.writtenTime=Date.now(),this.lastWriteTime=Date.now();const F=A.VSBuffer.alloc(13);F.writeUInt8(S.type,0),F.writeUInt32BE(S.id,1),F.writeUInt32BE(S.ack,5),F.writeUInt32BE(S.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(S.type),id:S.id,ack:S.ack,messageSize:S.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",S.data),this.j(F,S.data)}g(S,F){const x=this.f===0;return this.d.push(S,F),this.f+=S.byteLength+F.byteLength,x}h(){const S=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,S}j(S,F){this.g(S,F)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const S=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:S.byteLength}),this.c.write(S)}}class b extends R.Disposable{constructor(S){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=S,this.b=this.B(new g(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(F=>{F.type===1&&this.f.fire(F.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(S){this.b.write(new h(1,0,0,S))}}e.Protocol=b;class C extends D.IPCClient{static fromSocket(S,F){return new C(new b(S),F)}get onDidDispose(){return this.b.onDidDispose}constructor(S,F,x=null){super(S,F,x),this.b=S}dispose(){super.dispose();const S=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),S.end()}}e.Client=C;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(S){this.b?this.d.length>0?this.d.push(S):this.a.fire(S):this.d.push(S)}flushBuffer(){this.d=[]}}e.BufferedEmitter=p;class i{constructor(S){this.data=S,this.next=null}}class o{constructor(){this.a=null,this.b=null}length(){let S=0,F=this.a;for(;F;)F=F.next,S++;return S}peek(){return this.a?this.a.data:null}toArray(){const S=[];let F=0,x=this.a;for(;x;)S[F++]=x.data,x=x.next;return S}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(S){const F=new i(S);if(!this.a){this.a=F,this.b=F;return}this.b.next=F,this.b=F}}class s{static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const S=Date.now();for(let F=0;F<s.a;F++)this.c[F]=S-1e3*F;setInterval(()=>{for(let F=s.a;F>=1;F--)this.c[F]=this.c[F-1];this.c[0]=Date.now()},1e3)}d(){const S=Date.now(),F=(1+s.a)*1e3;let x=0;for(let V=0;V<s.a;V++)S-this.c[V]<=F&&x++;return 1-x/s.a}hasHighLoad(){return this.d()>=.5}}s.a=10,s.b=null;var c;(function(w){w[w.Good=0]="Good",w[w.Poor=1]="Poor"})(c=e.ConnectionHealth||(e.ConnectionHealth={}));function r(w){switch(w){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=r;class m{constructor(S){this.connectionHealth=S}}e.ConnectionHealthChangedEvent=m;class n{constructor(S,F){this.roundTripTime=S,this.recentHighRoundTripCount=F}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this.c-this.d}constructor(S){this.x=new p,this.onControlMessage=this.x.event,this.y=new p,this.onMessage=this.y.event,this.z=new p,this.onDidDispose=this.z.event,this.A=new p,this.onSocketClose=this.A.event,this.B=new p,this.onSocketTimeout=this.B.event,this.C=new p,this.onHighRoundTripTime=this.C.event,this.D=new p,this.onDidChangeConnectionHealth=this.D.event,this.u=S.loadEstimator??s.getInstance(),this.v=S.measureRoundTripTime??!1,this.w=S.sendKeepAlive??!0,this.a=!1,this.b=new o,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=S.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(F=>this.E(F))),this.t.add(this.o.onClose(F=>this.A.fire(F))),this.r=this.t.add(new u),this.t.add(this.r.onSendLatencyRequest(F=>this.J(F))),this.t.add(this.r.onHighRoundTripTime(F=>this.C.fire(F))),this.t.add(this.r.onDidChangeConnectionHealth(F=>this.D.fire(F))),this.v&&this.r.start(),S.initialChunk&&this.q.acceptChunk(S.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const S=new h(5,0,0,T());this.p.write(S),this.p.flush()}sendPause(){const S=new h(7,0,0,T());this.p.write(S)}sendResume(){const S=new h(8,0,0,T());this.p.write(S)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(S,F){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=S,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(x=>this.E(x))),this.t.add(this.o.onClose(x=>this.A.fire(x))),this.r=this.t.add(new u),this.t.add(this.r.onSendLatencyRequest(x=>this.J(x))),this.t.add(this.r.onHighRoundTripTime(x=>this.C.fire(x))),this.t.add(this.r.onDidChangeConnectionHealth(x=>this.D.fire(x))),this.q.acceptChunk(F)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const S=new h(3,0,this.h,T());this.p.write(S);const F=this.b.toArray();for(let x=0,V=F.length;x<V;x++)this.p.write(F[x]);this.G()}acceptDisconnect(){this.z.fire()}E(S){if(S.ack>this.d){this.d=S.ack;do{const F=this.b.peek();if(F&&F.id<=S.ack)this.b.pop();else break}while(!0)}switch(S.type){case 0:break;case 1:{if(S.id>this.g)if(S.id!==this.g+1){const F=Date.now();F-this.m>1e4&&(this.m=F,this.p.write(new h(6,0,0,T())))}else this.g=S.id,this.j=Date.now(),this.F(),this.y.fire(S.data);break}case 2:{this.x.fire(S.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const F=this.b.toArray();for(let x=0,V=F.length;x<V;x++)this.p.write(F[x]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(S.data);break}case 11:{this.r.handleResponse(S.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(S){const F=++this.c;this.h=this.g;const x=new h(1,F,this.h,S);this.b.push(x),this.a||(this.p.write(x),this.G())}sendControl(S){const F=new h(2,0,0,S);this.p.write(F)}F(){if(this.g<=this.h||this.k)return;const S=Date.now()-this.j;if(S>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-S+5)}G(){if(this.c<=this.d||this.f||this.a)return;const S=this.b.peek(),F=Date.now()-S.writtenTime,x=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(F>=2e4&&x>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:F,timeSinceLastReceivedSomeData:x});return}const M=Math.max(2e4-F,2e4-x,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},M)}H(){if(this.g<=this.h)return;this.h=this.g;const S=new h(3,0,this.h,T());this.p.write(S)}I(){this.h=this.g;const S=new h(9,0,this.h,T());this.p.write(S)}J(S){this.h=this.g;const F=new h(10,0,this.h,S);this.p.write(F)}K(S){this.h=this.g;const F=new h(11,0,this.h,S);this.p.write(F)}}e.PersistentProtocol=t;class u extends R.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},S=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const S=++this.h,F=A.VSBuffer.alloc(4);F.writeUInt32BE(S,0),this.a.fire(F)},6e4)}handleResponse(S){if(S.byteLength!==4)return;const F=S.readUInt32BE(0);if(this.g<=0||F!==this.h)return;const x=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=x;const M=this.l,B=this.j.filter(O=>O>=1e3).length;this.l=B>=3?1:0,x>1e3&&this.b.fire(new n(x,B)),M!==this.l&&this.c.fire(this.l)}}}),define(ye[119],De([1,0,22,11,3,6,10,12,30,117,118]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function T(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,t){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this.f=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=u=>{if(this.traceSocketEvent("error",{code:u?.code,message:u?.message}),u){if(u.code==="EPIPE")return;(0,A.onUnexpectedError)(u)}},this.socket.on("error",this.a),this.b=u=>{this.traceSocketEvent("close",{hadError:u}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const t=u=>{this.traceSocketEvent("read",u),n(a.VSBuffer.wrap(u))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=u=>{n({type:0,hadError:u,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,A.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=v;var I;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var y;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(y||(y={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,u,w){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:u?.byteLength||0,recordInflateBytes:w}),this.a=this.B(new h(this,t,u,w,this.f,(S,F)=>this.k(S,F))),this.B(this.a.onError(S=>{console.error(S),(0,A.onUnexpectedError)(S),this.g.fire({type:0,hadError:!0,error:S})})),this.b=new L.ChunkStream,this.B(this.socket.onData(S=>this.l(S))),this.B(this.socket.onClose(S=>this.g.fire(S)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let u=2;n.byteLength<126?u+=0:n.byteLength<2**16?u+=2:u+=8;const w=a.VSBuffer.alloc(u);if(t?w.writeUInt8(194,0):w.writeUInt8(130,0),n.byteLength<126)w.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){w.writeUInt8(126,1);let S=1;w.writeUInt8(n.byteLength>>>8&255,++S),w.writeUInt8(n.byteLength>>>0&255,++S)}else{w.writeUInt8(127,1);let S=1;w.writeUInt8(0,++S),w.writeUInt8(0,++S),w.writeUInt8(0,++S),w.writeUInt8(0,++S),w.writeUInt8(n.byteLength>>>24&255,++S),w.writeUInt8(n.byteLength>>>16&255,++S),w.writeUInt8(n.byteLength>>>8&255,++S),w.writeUInt8(n.byteLength>>>0&255,++S)}this.socket.write(a.VSBuffer.concat([w,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),u=t.readUInt8(0),w=(u&128)>>>7,S=(u&64)>>>6,F=t.readUInt8(1),x=(F&128)>>>7,V=F&127;this.j.state=2,this.j.readLen=2+(x?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=w,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(S)),this.j.firstFrameOfMessage=Boolean(w),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),u=t.readUInt8(1),w=(u&128)>>>7;let S=u&127,F=1;S===126?S=t.readUInt8(++F)*2**8+t.readUInt8(++F):S===127&&(S=t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*0+t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F));let x=0;w&&(x=t.readUInt8(++F)*2**24+t.readUInt8(++F)*2**16+t.readUInt8(++F)*2**8+t.readUInt8(++F)),this.j.state=3,this.j.readLen=S,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class h extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,t,u,w,S,F){super(),this.k=n,this.l=S,this.m=F,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,t?(this.b=this.B(new d(this.k,w,u,{windowBits:15})),this.f=this.B(new g(this.k,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const t=await this.r(this.f,n);this.m(t,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,t){return new Promise((u,w)=>{n.write(t),n.flush(S=>u(S))})}acceptFrame(n,t,u){this.h.push({data:n,isCompressed:t,isLastFrameOfMessage:u}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const t=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(t)}else this.l.fire(n.data)}this.s=!1}}u(n,t,u){return new Promise((w,S)=>{n.write(t),u&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(F=>w(F))})}}class d extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,t,u,w){super(),this.h=n,this.j=t,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=T().zlib.createInflateRaw(w),this.b.on("error",S=>{this.h.traceSocketEvent("zlibInflateError",{message:S?.message,code:S?.code}),this.a.fire(S)}),this.b.on("data",S=>{this.h.traceSocketEvent("zlibInflateData",S),this.g.push(a.VSBuffer.wrap(S))}),u&&(this.h.traceSocketEvent("zlibInflateInitialWrite",u.buffer),this.b.write(u.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=a.VSBuffer.concat(this.g);this.g.length=0,n(t)})}}class g extends R.Disposable{constructor(n,t){super(),this.g=n,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=T().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",u=>{this.g.traceSocketEvent("zlibDeflateError",{message:u?.message,code:u?.code}),this.a.fire(u)}),this.b.on("data",u=>{this.g.traceSocketEvent("zlibDeflateData",u),this.f.push(a.VSBuffer.wrap(u))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=a.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function b(m,n){if(n===0)return;const t=m.byteLength>>>2;for(let V=0;V<t;V++){const M=m.readUInt32BE(V*4);m.writeUInt32BE(M^n,V*4)}const u=t*4,w=m.byteLength-u,S=n>>>24&255,F=n>>>16&255,x=n>>>8&255;w>=1&&m.writeUInt8(m.readUInt8(u)^S,u),w>=2&&m.writeUInt8(m.readUInt8(u+1)^F,u+1),w>=3&&m.writeUInt8(m.readUInt8(u+2)^x,u+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const C={[2]:107,[1]:103};function p(){const m=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):n=(0,D.join)(T().os.tmpdir(),`vscode-ipc-${m}.sock`),o(n),n}e.createRandomIPCHandle=p;function i(m,n,t){const u=T().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${t}-${n}-sock`;let w;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?w=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${t}-${n}.sock`):w=(0,D.join)(m,`${t}-${n}.sock`),o(w),w}e.createStaticIPCHandle=i;function o(m){const n=C[P.platform];typeof n=="number"&&m.length>=n&&console.warn(`WARNING: IPC handle "${m}" is longer than ${n} chars, try a shorter --user-data-dir`)}class s extends k.IPCServer{static b(n){const t=l.Event.fromNodeEventEmitter(n,"connection");return l.Event.map(t,u=>({protocol:new L.Protocol(new v(u,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(u,"close"))}))}constructor(n){super(s.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=s;function c(m){return new Promise((n,t)=>{const u=T().net.createServer();u.on("error",t),u.listen(m,()=>{u.removeListener("error",t),n(new s(u))})})}e.serve=c;function r(m,n){return new Promise((t,u)=>{const w=T().net.createConnection(m,()=>{w.removeListener("error",u),t(L.Client.fromSocket(new v(w,`ipc-client${n}`),n))});w.once("error",u)})}e.connect=r}),define(ye[164],De([1,0,38,10]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,D,P,E,k,L){if(Array.isArray(R)){let T=0;for(const v of R){const I=l(v,D,P,E,k,L);if(I===10)return I;I>T&&(T=I)}return T}else{if(typeof R=="string")return E?R==="*"?5:R===P?10:0:0;if(R){const{language:T,pattern:v,scheme:I,hasAccessToAllModels:y,notebookType:f}=R;if(!E&&!y)return 0;f&&k&&(D=k);let h=0;if(I)if(I===D.scheme)h=10;else if(I==="*")h=5;else return 0;if(T)if(T===P)h=10;else if(T==="*")h=Math.max(h,5);else return 0;if(f)if(f===L)h=10;else if(f==="*"&&L!==void 0)h=Math.max(h,5);else return 0;if(v){let d;if(typeof v=="string"?d=v:d={...v,base:(0,A.normalize)(v.base)},d===D.fsPath||(0,a.match)(d,D.fsPath))h=10;else return 0}return h}else return 0}}e.score=l}),define(ye[165],De([1,0,8,52,155]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(P,E,k,L){this.c=P,this.d=E,this.f=k,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(P){P.eol&&P.eol!==this.f&&(this.f=P.eol,this.h=null);const E=P.changes;for(const k of E)this.n(k.range),this.o(new A.Position(k.range.startLineNumber,k.range.startColumn),k.text);this.g=P.versionId,this.j=null}k(){if(!this.h){const P=this.f.length,E=this.d.length,k=new Uint32Array(E);for(let L=0;L<E;L++)k[L]=this.d[L].length+P;this.h=new l.PrefixSumComputer(k)}}l(P,E){this.d[P]=E,this.h&&this.h.setValue(P,this.d[P].length+this.f.length)}n(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.startLineNumber-1].substring(P.endColumn-1));return}this.l(P.startLineNumber-1,this.d[P.startLineNumber-1].substring(0,P.startColumn-1)+this.d[P.endLineNumber-1].substring(P.endColumn-1)),this.d.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.h&&this.h.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}o(P,E){if(E.length===0)return;const k=(0,a.splitLines)(E);if(k.length===1){this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]+this.d[P.lineNumber-1].substring(P.column-1));return}k[k.length-1]+=this.d[P.lineNumber-1].substring(P.column-1),this.l(P.lineNumber-1,this.d[P.lineNumber-1].substring(0,P.column-1)+k[0]);const L=new Uint32Array(k.length-1);for(let T=1;T<k.length;T++)this.d.splice(P.lineNumber+T-1,0,k[T]),L[T-1]=k[T].length+this.f.length;this.h&&this.h.insertValues(P.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[166],De([1,0,8,152,52,32,107]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class E{constructor(g,b,C,p){this.searchString=g,this.isRegex=b,this.matchCase=C,this.wordSeparators=p}parseSearchRequest(){if(this.searchString==="")return null;let g;this.isRegex?g=k(this.searchString):g=this.searchString.indexOf(`
`)>=0;let b=null;try{b=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:g,global:!0,unicode:!0})}catch{return null}if(!b)return null;let C=!this.isRegex&&!g;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new D.SearchData(b,this.wordSeparators?(0,A.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=E;function k(d){if(!d||d.length===0)return!1;for(let g=0,b=d.length;g<b;g++){const C=d.charCodeAt(g);if(C===10)return!0;if(C===92){if(g++,g>=b)break;const p=d.charCodeAt(g);if(p===110||p===114||p===87)return!0}}return!1}e.isMultilineRegexSource=k;function L(d,g,b){if(!b)return new D.FindMatch(d,null);const C=[];for(let p=0,i=g.length;p<i;p++)C[p]=g[p];return new D.FindMatch(d,C)}e.createFindMatch=L;class T{constructor(g){const b=[];let C=0;for(let p=0,i=g.length;p<i;p++)g.charCodeAt(p)===10&&(b[C++]=p);this.a=b}findLineFeedCountBeforeOffset(g){const b=this.a;let C=0,p=b.length-1;if(p===-1||g<=b[0])return 0;for(;C<p;){const i=C+((p-C)/2>>0);b[i]>=g?p=i-1:b[i+1]>=g?(C=i,p=i):C=i+1}return C+1}}class v{static findMatches(g,b,C,p,i){const o=b.parseSearchRequest();return o?o.regex.multiline?this.b(g,C,new h(o.wordSeparators,o.regex),p,i):this.c(g,C,o,p,i):[]}static a(g,b,C,p,i,o){let s,c=0;p?(c=p.findLineFeedCountBeforeOffset(i),s=b+i+c):s=b+i;let r;if(p){const u=p.findLineFeedCountBeforeOffset(i+o.length)-c;r=s+o.length+u}else r=s+o.length;const m=g.getPositionAt(s),n=g.getPositionAt(r);return new R.Range(m.lineNumber,m.column,n.lineNumber,n.column)}static b(g,b,C,p,i){const o=g.getOffsetAt(b.getStartPosition()),s=g.getValueInRange(b,1),c=g.getEOL()===`\r
`?new T(s):null,r=[];let m=0,n;for(C.reset(0);n=C.next(s);)if(r[m++]=L(this.a(g,o,s,c,n.index,n[0]),n,p),m>=i)return r;return r}static c(g,b,C,p,i){const o=[];let s=0;if(b.startLineNumber===b.endLineNumber){const r=g.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return s=this.d(C,r,b.startLineNumber,b.startColumn-1,s,o,p,i),o}const c=g.getLineContent(b.startLineNumber).substring(b.startColumn-1);s=this.d(C,c,b.startLineNumber,b.startColumn-1,s,o,p,i);for(let r=b.startLineNumber+1;r<b.endLineNumber&&s<i;r++)s=this.d(C,g.getLineContent(r),r,0,s,o,p,i);if(s<i){const r=g.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);s=this.d(C,r,b.endLineNumber,0,s,o,p,i)}return o}static d(g,b,C,p,i,o,s,c){const r=g.wordSeparators;if(!s&&g.simpleSearch){const t=g.simpleSearch,u=t.length,w=b.length;let S=-u;for(;(S=b.indexOf(t,S+u))!==-1;)if((!r||f(r,b,w,S,u))&&(o[i++]=new D.FindMatch(new R.Range(C,S+1+p,C,S+1+u+p),null),i>=c))return i;return i}const m=new h(g.wordSeparators,g.regex);let n;m.reset(0);do if(n=m.next(b),n&&(o[i++]=L(new R.Range(C,n.index+1+p,C,n.index+1+n[0].length+p),n,s),i>=c))return i;while(n);return i}static findNextMatch(g,b,C,p){const i=b.parseSearchRequest();if(!i)return null;const o=new h(i.wordSeparators,i.regex);return i.regex.multiline?this.e(g,C,o,p):this.f(g,C,o,p)}static e(g,b,C,p){const i=new l.Position(b.lineNumber,1),o=g.getOffsetAt(i),s=g.getLineCount(),c=g.getValueInRange(new R.Range(i.lineNumber,i.column,s,g.getLineMaxColumn(s)),1),r=g.getEOL()===`\r
`?new T(c):null;C.reset(b.column-1);const m=C.next(c);return m?L(this.a(g,o,c,r,m.index,m[0]),m,p):b.lineNumber!==1||b.column!==1?this.e(g,new l.Position(1,1),C,p):null}static f(g,b,C,p){const i=g.getLineCount(),o=b.lineNumber,s=g.getLineContent(o),c=this.g(C,s,o,b.column,p);if(c)return c;for(let r=1;r<=i;r++){const m=(o+r-1)%i,n=g.getLineContent(m+1),t=this.g(C,n,m+1,1,p);if(t)return t}return null}static g(g,b,C,p,i){g.reset(p-1);const o=g.next(b);return o?L(new R.Range(C,o.index+1,C,o.index+1+o[0].length),o,i):null}static findPreviousMatch(g,b,C,p){const i=b.parseSearchRequest();if(!i)return null;const o=new h(i.wordSeparators,i.regex);return i.regex.multiline?this.h(g,C,o,p):this.j(g,C,o,p)}static h(g,b,C,p){const i=this.b(g,new R.Range(1,1,b.lineNumber,b.column),C,p,10*P);if(i.length>0)return i[i.length-1];const o=g.getLineCount();return b.lineNumber!==o||b.column!==g.getLineMaxColumn(o)?this.h(g,new l.Position(o,g.getLineMaxColumn(o)),C,p):null}static j(g,b,C,p){const i=g.getLineCount(),o=b.lineNumber,s=g.getLineContent(o).substring(0,b.column-1),c=this.k(C,s,o,p);if(c)return c;for(let r=1;r<=i;r++){const m=(i+o-r-1)%i,n=g.getLineContent(m+1),t=this.k(C,n,m+1,p);if(t)return t}return null}static k(g,b,C,p){let i=null,o;for(g.reset(0);o=g.next(b);)i=L(new R.Range(C,o.index+1,C,o.index+1+o[0].length),o,p);return i}}e.TextModelSearch=v;function I(d,g,b,C,p){if(C===0)return!0;const i=g.charCodeAt(C-1);if(d.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(C);if(d.get(o)!==0)return!0}return!1}function y(d,g,b,C,p){if(C+p===b)return!0;const i=g.charCodeAt(C+p);if(d.get(i)!==0||i===13||i===10)return!0;if(p>0){const o=g.charCodeAt(C+p-1);if(d.get(o)!==0)return!0}return!1}function f(d,g,b,C,p){return I(d,g,b,C,p)&&y(d,g,b,C,p)}e.isValidMatch=f;class h{constructor(g,b){this._wordSeparators=g,this.a=b,this.b=-1,this.c=0}reset(g){this.a.lastIndex=g,this.b=-1,this.c=0}next(g){const b=g.length;let C;do{if(this.b+this.c===b||(C=this.a.exec(g),!C))return null;const p=C.index,i=C[0].length;if(p===this.b&&i===this.c){if(i===0){a.getNextCodePoint(g,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=p,this.c=i,!this._wordSeparators||f(this._wordSeparators,g,b,p,i))return C}while(C);return null}}e.Searcher=h}),define(ye[120],De([1,0,22,12]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(T){T[T.Full=1]="Full",T[T.Delta=2]="Delta"})(l||(l={}));function R(T){for(let v=0,I=T.length;v<I;v+=4){const y=T[v+0],f=T[v+1],h=T[v+2],d=T[v+3];T[v+0]=d,T[v+1]=h,T[v+2]=f,T[v+3]=y}}function D(T){const v=new Uint8Array(T.buffer,T.byteOffset,T.length*4);return A.isLittleEndian()||R(v),a.VSBuffer.wrap(v)}function P(T){const v=T.buffer;if(A.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const I=new Uint8Array(v.byteLength);return I.set(v),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function E(T){const v=new Uint32Array(k(T));let I=0;if(v[I++]=T.id,T.type==="full")v[I++]=1,v[I++]=T.data.length,v.set(T.data,I),I+=T.data.length;else{v[I++]=2,v[I++]=T.deltas.length;for(const y of T.deltas)v[I++]=y.start,v[I++]=y.deleteCount,y.data?(v[I++]=y.data.length,v.set(y.data,I),I+=y.data.length):v[I++]=0}return D(v)}e.encodeSemanticTokensDto=E;function k(T){let v=0;if(v+=1+1,T.type==="full")v+=1+T.data.length;else{v+=1,v+=(1+1+1)*T.deltas.length;for(const I of T.deltas)I.data&&(v+=I.data.length)}return v}function L(T){const v=P(T);let I=0;const y=v[I++];if(v[I++]===1){const g=v[I++],b=v.subarray(I,I+g);return I+=g,{id:y,type:"full",data:b}}const h=v[I++],d=[];for(let g=0;g<h;g++){const b=v[I++],C=v[I++],p=v[I++];let i;p>0&&(i=v.subarray(I,I+p),I+=p),d[g]={start:b,deleteCount:C,data:i}}return{id:y,type:"delta",deltas:d}}e.decodeSemanticTokensDto=L}),define(ye[167],De([1,0,3,6]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,E){return this.a.set(P,E),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===E&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,E){this.b.get(P)?.dispose();const k=new R(this,P,E);return this.b.set(P,k),(0,A.toDisposable)(()=>{const L=this.b.get(P);!L||L!==k||(this.b.delete(P),L.dispose())})}async getOrCreate(P){const E=this.get(P);if(E)return E;const k=this.b.get(P);return!k||k.isResolved?null:(await k.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const k=this.b.get(P);return!!(!k||k.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class R extends A.Disposable{get isResolved(){return this.c}constructor(P,E,k){super(),this.f=P,this.g=E,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[71],De([1,0,67,2,32,167]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class D{constructor(u,w,S){this._tokenBrand=void 0,this.offset=u,this.type=w,this.language=S}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=D;class P{constructor(u,w){this._tokenizationResultBrand=void 0,this.tokens=u,this.endState=w}}e.TokenizationResult=P;class E{constructor(u,w){this._encodedTokenizationResultBrand=void 0,this.tokens=u,this.endState=w}}e.EncodedTokenizationResult=E;var k;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(k=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(t){const u=new Map;u.set(0,a.Codicon.symbolMethod),u.set(1,a.Codicon.symbolFunction),u.set(2,a.Codicon.symbolConstructor),u.set(3,a.Codicon.symbolField),u.set(4,a.Codicon.symbolVariable),u.set(5,a.Codicon.symbolClass),u.set(6,a.Codicon.symbolStruct),u.set(7,a.Codicon.symbolInterface),u.set(8,a.Codicon.symbolModule),u.set(9,a.Codicon.symbolProperty),u.set(10,a.Codicon.symbolEvent),u.set(11,a.Codicon.symbolOperator),u.set(12,a.Codicon.symbolUnit),u.set(13,a.Codicon.symbolValue),u.set(15,a.Codicon.symbolEnum),u.set(14,a.Codicon.symbolConstant),u.set(15,a.Codicon.symbolEnum),u.set(16,a.Codicon.symbolEnumMember),u.set(17,a.Codicon.symbolKeyword),u.set(27,a.Codicon.symbolSnippet),u.set(18,a.Codicon.symbolText),u.set(19,a.Codicon.symbolColor),u.set(20,a.Codicon.symbolFile),u.set(21,a.Codicon.symbolReference),u.set(22,a.Codicon.symbolCustomColor),u.set(23,a.Codicon.symbolFolder),u.set(24,a.Codicon.symbolTypeParameter),u.set(25,a.Codicon.account),u.set(26,a.Codicon.issues);function w(x){let V=u.get(x);return V||(console.info("No codicon found for CompletionItemKind "+x),V=a.Codicon.symbolProperty),V}t.toIcon=w;const S=new Map;S.set("method",0),S.set("function",1),S.set("constructor",2),S.set("field",3),S.set("variable",4),S.set("class",5),S.set("struct",6),S.set("interface",7),S.set("module",8),S.set("property",9),S.set("event",10),S.set("operator",11),S.set("unit",12),S.set("value",13),S.set("constant",14),S.set("enum",15),S.set("enum-member",16),S.set("enumMember",16),S.set("keyword",17),S.set("snippet",27),S.set("text",18),S.set("color",19),S.set("file",20),S.set("reference",21),S.set("customcolor",22),S.set("folder",23),S.set("type-parameter",24),S.set("typeParameter",24),S.set("account",25),S.set("issue",26);function F(x,V){let M=S.get(x);return typeof M>"u"&&!V&&(M=9),M}t.fromString=F})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var T;(function(t){t[t.Deprecated=1]="Deprecated"})(T=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var I;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(I=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var h;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(h=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(t){return t&&A.URI.isUri(t.uri)&&l.Range.isIRange(t.range)&&(l.Range.isIRange(t.originSelectionRange)||l.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=g;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var C;(function(t){t[t.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));var p;(function(t){const u=new Map;u.set(0,a.Codicon.symbolFile),u.set(1,a.Codicon.symbolModule),u.set(2,a.Codicon.symbolNamespace),u.set(3,a.Codicon.symbolPackage),u.set(4,a.Codicon.symbolClass),u.set(5,a.Codicon.symbolMethod),u.set(6,a.Codicon.symbolProperty),u.set(7,a.Codicon.symbolField),u.set(8,a.Codicon.symbolConstructor),u.set(9,a.Codicon.symbolEnum),u.set(10,a.Codicon.symbolInterface),u.set(11,a.Codicon.symbolFunction),u.set(12,a.Codicon.symbolVariable),u.set(13,a.Codicon.symbolConstant),u.set(14,a.Codicon.symbolString),u.set(15,a.Codicon.symbolNumber),u.set(16,a.Codicon.symbolBoolean),u.set(17,a.Codicon.symbolArray),u.set(18,a.Codicon.symbolObject),u.set(19,a.Codicon.symbolKey),u.set(20,a.Codicon.symbolNull),u.set(21,a.Codicon.symbolEnumMember),u.set(22,a.Codicon.symbolStruct),u.set(23,a.Codicon.symbolEvent),u.set(24,a.Codicon.symbolOperator),u.set(25,a.Codicon.symbolTypeParameter);function w(S){let F=u.get(S);return F||(console.info("No codicon found for SymbolKind "+S),F=a.Codicon.symbolProperty),F}t.toIcon=w})(p=e.SymbolKinds||(e.SymbolKinds={}));class i{static fromValue(u){switch(u){case"comment":return i.Comment;case"imports":return i.Imports;case"region":return i.Region}return new i(u)}constructor(u){this.value=u}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var o;(function(t){function u(w){return!w||typeof w!="object"?!1:typeof w.id=="string"&&typeof w.title=="string"}t.is=u})(o=e.Command||(e.Command={}));var s;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(c=e.CommentThreadState||(e.CommentThreadState={}));var r;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(r=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[168],De([17,18]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,168,12,106,15,23,151]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(z){this.c=z}hasChanged(z){return this.c[z]}}e.ConfigurationChangedEvent=k;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class T{constructor(z,de,Ie,Le){this.id=z,this.name=de,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,de){return I(z,de)}compute(z,de,Ie){return Ie}}class v{constructor(z,de){this.newValue=z,this.didChange=de}}e.ApplyUpdateResult=v;function I(ce,z){if(typeof ce!="object"||typeof z!="object"||!ce||!z)return new v(z,ce!==z);if(Array.isArray(ce)||Array.isArray(z)){const Ie=Array.isArray(ce)&&Array.isArray(z)&&R.equals(ce,z);return new v(z,!Ie)}let de=!1;for(const Ie in z)if(z.hasOwnProperty(Ie)){const Le=I(ce[Ie],z[Ie]);Le.didChange&&(ce[Ie]=Le.newValue,de=!0)}return new v(ce,de)}class y{constructor(z){this.schema=void 0,this.id=z,this.name="_never_",this.defaultValue=void 0}applyUpdate(z,de){return I(z,de)}validate(z){return this.defaultValue}}class f{constructor(z,de,Ie,Le){this.id=z,this.name=de,this.defaultValue=Ie,this.schema=Le}applyUpdate(z,de){return I(z,de)}validate(z){return typeof z>"u"?this.defaultValue:z}compute(z,de,Ie){return Ie}}function h(ce,z){return typeof ce>"u"?z:ce==="false"?!1:Boolean(ce)}e.boolean=h;class d extends f{constructor(z,de,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super(z,de,Ie,Le)}validate(z){return h(z,this.defaultValue)}}function g(ce,z,de,Ie){if(typeof ce>"u")return z;let Le=parseInt(ce,10);return isNaN(Le)?z:(Le=Math.max(de,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=g;class b extends f{static clampedInt(z,de,Ie,Le){return g(z,de,Ie,Le)}constructor(z,de,Ie,Le,$e,Ke=void 0){typeof Ke<"u"&&(Ke.type="integer",Ke.default=Ie,Ke.minimum=Le,Ke.maximum=$e),super(z,de,Ie,Ke),this.minimum=Le,this.maximum=$e}validate(z){return b.clampedInt(z,this.defaultValue,this.minimum,this.maximum)}}class C extends f{static clamp(z,de,Ie){return z<de?de:z>Ie?Ie:z}static float(z,de){if(typeof z=="number")return z;if(typeof z>"u")return de;const Ie=parseFloat(z);return isNaN(Ie)?de:Ie}constructor(z,de,Ie,Le,$e){typeof $e<"u"&&($e.type="number",$e.default=Ie),super(z,de,Ie,$e),this.validationFn=Le}validate(z){return this.validationFn(C.float(z,this.defaultValue))}}class p extends f{static string(z,de){return typeof z!="string"?de:z}constructor(z,de,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super(z,de,Ie,Le)}validate(z){return p.string(z,this.defaultValue)}}function i(ce,z,de){return typeof ce!="string"||de.indexOf(ce)===-1?z:ce}e.stringSet=i;class o extends f{constructor(z,de,Ie,Le,$e=void 0){typeof $e<"u"&&($e.type="string",$e.enum=Le,$e.default=Ie),super(z,de,Ie,$e),this.c=Le}validate(z){return i(z,this.defaultValue,this.c)}}class s extends T{constructor(z,de,Ie,Le,$e,Ke,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=$e,Ze.default=Le),super(z,de,Ie,Ze),this.c=$e,this.d=Ke}validate(z){return typeof z!="string"?this.defaultValue:this.c.indexOf(z)===-1?this.defaultValue:this.d(z)}}function c(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends T{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(z){switch(z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(z,de,Ie){return Ie===0?z.accessibilitySupport:Ie}}class m extends T{constructor(){const z={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",z,{"editor.comments.insertSpace":{type:"boolean",default:z.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:z.ignoreEmptyLines,description:a.localize(5,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{insertSpace:h(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ce){switch(ce){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function S(ce){switch(ce){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class F extends y{constructor(){super(135)}compute(z,de,Ie){const Le=["monaco-editor"];return de.get(36)&&Le.push(de.get(36)),z.extraEditorClassName&&Le.push(z.extraEditorClassName),de.get(70)==="default"?Le.push("mouse-default"):de.get(70)==="copy"&&Le.push("mouse-copy"),de.get(105)&&Le.push("showUnused"),de.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class x extends d{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(z,de,Ie){return Ie&&z.emptySelectionClipboard}}class V extends T{constructor(){const z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",z,{"editor.find.cursorMoveOnType":{type:"boolean",default:z.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:z.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:z.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:z.globalFindClipboard,description:a.localize(16,null),included:A.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:z.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:z.loop,description:a.localize(18,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{cursorMoveOnType:h(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof z.seedSearchStringFromSelection=="boolean"?z.seedSearchStringFromSelection?"always":"never":i(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof z.autoFindInSelection=="boolean"?z.autoFindInSelection?"always":"never":i(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(de.loop,this.defaultValue.loop)}}}class M extends T{constructor(){super(48,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?M.OFF:z==="true"?M.ON:z:Boolean(z)?M.ON:M.OFF}}M.OFF='"liga" off, "calt" off',M.ON='"liga" on, "calt" on',e.EditorFontLigatures=M;class B extends T{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(z){return typeof z>"u"?this.defaultValue:typeof z=="string"?z==="false"?B.OFF:z==="true"?B.TRANSLATE:z:Boolean(z)?B.TRANSLATE:B.OFF}compute(z,de,Ie){return z.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class O extends y{constructor(){super(47)}compute(z,de,Ie){return z.fontInfo}}class U extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(z){const de=C.float(z,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(de,6,100)}compute(z,de,Ie){return z.fontInfo.fontSize}}class $ extends T{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.d,maximum:$.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(z){return z==="normal"||z==="bold"?z:String(b.clampedInt(z,e.EDITOR_FONT_DEFAULTS.fontWeight,$.d,$.e))}}$.c=["normal","bold","100","200","300","400","500","600","700","800","900"],$.d=1,$.e=1e3;class j extends T{constructor(){const z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:z.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",z,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...de},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...de},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...de},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:z.alternativeDefinitionCommand,enum:Ie,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:z.alternativeTypeDefinitionCommand,enum:Ie,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:z.alternativeDeclarationCommand,enum:Ie,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:z.alternativeImplementationCommand,enum:Ie,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:z.alternativeReferenceCommand,enum:Ie,description:a.localize(41,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{multiple:i(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??i(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??i(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??i(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??i(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??i(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends T{constructor(){const z={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",z,{"editor.hover.enabled":{type:"boolean",default:z.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:z.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:z.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:z.above,description:a.localize(45,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),delay:b.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:h(de.sticky,this.defaultValue.sticky),above:h(de.above,this.defaultValue.above)}}}var J;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(J=e.RenderMinimap||(e.RenderMinimap={}));class q extends y{constructor(){super(138)}compute(z,de,Ie){return q.computeLayout(de,{memory:z.memory,outerWidth:z.outerWidth,outerHeight:z.outerHeight,isDominatedByLongLines:z.isDominatedByLongLines,lineHeight:z.fontInfo.lineHeight,viewLineCount:z.viewLineCount,lineNumbersDigitCount:z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:z.fontInfo.maxDigitWidth,pixelRatio:z.pixelRatio})}static computeContainedMinimapLineCount(z){const de=z.height/z.lineHeight,Ie=Math.floor(z.paddingTop/z.lineHeight);let Le=Math.floor(z.paddingBottom/z.lineHeight);z.scrollBeyondLastLine&&(Le=Math.max(Le,de-1));const $e=(Ie+z.viewLineCount+Le)/(z.pixelRatio*z.height),Ke=Math.floor(z.viewLineCount/$e);return{typicalViewportLineCount:de,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:$e,minimapLineCount:Ke}}static c(z,de){const Ie=z.outerWidth,Le=z.outerHeight,$e=z.pixelRatio;if(!z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const Ke=de.stableMinimapLayoutInput,Ze=Ke&&z.outerHeight===Ke.outerHeight&&z.lineHeight===Ke.lineHeight&&z.typicalHalfwidthCharacterWidth===Ke.typicalHalfwidthCharacterWidth&&z.pixelRatio===Ke.pixelRatio&&z.scrollBeyondLastLine===Ke.scrollBeyondLastLine&&z.paddingTop===Ke.paddingTop&&z.paddingBottom===Ke.paddingBottom&&z.minimap.enabled===Ke.minimap.enabled&&z.minimap.side===Ke.minimap.side&&z.minimap.size===Ke.minimap.size&&z.minimap.showSlider===Ke.minimap.showSlider&&z.minimap.renderCharacters===Ke.minimap.renderCharacters&&z.minimap.maxColumn===Ke.minimap.maxColumn&&z.minimap.scale===Ke.minimap.scale&&z.verticalScrollbarWidth===Ke.verticalScrollbarWidth&&z.isViewportWrapping===Ke.isViewportWrapping,pt=z.lineHeight,gt=z.typicalHalfwidthCharacterWidth,ct=z.scrollBeyondLastLine,Et=z.minimap.renderCharacters;let tt=$e>=2?Math.round(z.minimap.scale*2):z.minimap.scale;const ft=z.minimap.maxColumn,At=z.minimap.size,Kt=z.minimap.side,Rt=z.verticalScrollbarWidth,mt=z.viewLineCount,Tt=z.remainingWidth,$t=z.isViewportWrapping,Nt=Et?2:3;let Xe=Math.floor($e*Le);const Mt=Xe/$e;let Ut=!1,Wt=!1,bt=Nt*tt,Re=tt/$e,Ne=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:lt,extraLinesBeyondLastLine:Pt,desiredRatio:St,minimapLineCount:yt}=q.computeContainedMinimapLineCount({viewLineCount:mt,scrollBeyondLastLine:ct,paddingTop:z.paddingTop,paddingBottom:z.paddingBottom,height:Le,lineHeight:pt,pixelRatio:$e});if(mt/yt>1)Ut=!0,Wt=!0,tt=1,bt=1,Re=tt/$e;else{let Dt=!1,Ct=tt+1;if(At==="fit"){const qt=Math.ceil((lt+mt+Pt)*bt);$t&&Ze&&Tt<=de.stableFitRemainingWidth?(Dt=!0,Ct=de.stableFitMaxMinimapScale):Dt=qt>Xe}if(At==="fill"||Dt){Ut=!0;const qt=tt;bt=Math.min(pt*$e,Math.max(1,Math.floor(1/St))),$t&&Ze&&Tt<=de.stableFitRemainingWidth&&(Ct=de.stableFitMaxMinimapScale),tt=Math.min(Ct,Math.max(1,Math.floor(bt/Nt))),tt>qt&&(Ne=Math.min(2,tt/qt)),Re=tt/$e/Ne,Xe=Math.ceil(Math.max(it,lt+mt+Pt)*bt),$t?(de.stableMinimapLayoutInput=z,de.stableFitRemainingWidth=Tt,de.stableFitMaxMinimapScale=tt):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Se=Math.floor(ft*Re),re=Math.min(Se,Math.max(0,Math.floor((Tt-Rt-2)*Re/(gt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor($e*re);const He=Fe/$e;Fe=Math.floor(Fe*Ne);const Ye=Et?1:2,je=Kt==="left"?0:Ie-re-Rt;return{renderMinimap:Ye,minimapLeft:je,minimapWidth:re,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Wt,minimapScale:tt,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:Xe,minimapCanvasOuterWidth:He,minimapCanvasOuterHeight:Mt}}static computeLayout(z,de){const Ie=de.outerWidth|0,Le=de.outerHeight|0,$e=de.lineHeight|0,Ke=de.lineNumbersDigitCount|0,Ze=de.typicalHalfwidthCharacterWidth,pt=de.maxDigitWidth,gt=de.pixelRatio,ct=de.viewLineCount,Et=z.get(130),tt=Et==="inherit"?z.get(129):Et,ft=tt==="inherit"?z.get(125):tt,At=z.get(128),Kt=de.isDominatedByLongLines,Rt=z.get(54),mt=z.get(64).renderType!==0,Tt=z.get(65),$t=z.get(99),Nt=z.get(80),Xe=z.get(69),Mt=z.get(97),Ut=Mt.verticalScrollbarSize,Wt=Mt.verticalHasArrows,bt=Mt.arrowSize,Re=Mt.horizontalScrollbarSize,Ne=z.get(40),Se=z.get(104)!=="never";let re=z.get(62);Ne&&Se&&(re+=16);let Fe=0;if(mt){const wt=Math.max(Ke,Tt);Fe=Math.round(wt*pt)}let He=0;Rt&&(He=$e);let Ye=0,je=Ye+He,it=je+Fe,lt=it+re;const Pt=Ie-He-Fe-re;let St=!1,yt=!1,kt=-1;tt==="inherit"&&Kt?(St=!0,yt=!0):ft==="on"||ft==="bounded"?yt=!0:ft==="wordWrapColumn"&&(kt=At);const Dt=q.c({outerWidth:Ie,outerHeight:Le,lineHeight:$e,typicalHalfwidthCharacterWidth:Ze,pixelRatio:gt,scrollBeyondLastLine:$t,paddingTop:Nt.top,paddingBottom:Nt.bottom,minimap:Xe,verticalScrollbarWidth:Ut,viewLineCount:ct,remainingWidth:Pt,isViewportWrapping:yt},de.memory||new L);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Ye+=Dt.minimapWidth,je+=Dt.minimapWidth,it+=Dt.minimapWidth,lt+=Dt.minimapWidth);const Ct=Pt-Dt.minimapWidth,qt=Math.max(1,Math.floor((Ct-Ut-2)/Ze)),_t=Wt?bt:0;return yt&&(kt=Math.max(1,qt),ft==="bounded"&&(kt=Math.min(kt,At))),{width:Ie,height:Le,glyphMarginLeft:Ye,glyphMarginWidth:He,lineNumbersLeft:je,lineNumbersWidth:Fe,decorationsLeft:it,decorationsWidth:re,contentLeft:lt,contentWidth:Ct,minimap:Dt,viewportColumn:qt,isWordWrapMinified:St,isViewportWrapping:yt,wrappingColumn:kt,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:Re,overviewRuler:{top:_t,width:Ut,height:Le-2*_t,right:0}}}}e.EditorLayoutInfoComputer=q;class Q extends T{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(z){return i(z,"simple",["simple","advanced"])}compute(z,de,Ie){return de.get(2)===2?"advanced":Ie}}class Z extends T{constructor(){const z={enabled:!0};super(61,"lightbulb",z,{"editor.lightbulb.enabled":{type:"boolean",default:z.enabled,description:a.localize(49,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:h(z.enabled,this.defaultValue.enabled)}}}class te extends T{constructor(){const z={enabled:!1,maxLineCount:5};super(109,"stickyScroll",z,{"editor.stickyScroll.enabled":{type:"boolean",default:z.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:z.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(de.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends T{constructor(){const z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",z,{"editor.inlayHints.enabled":{type:"string",default:z.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,A.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:z.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:z.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:z.padding,description:a.localize(59,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return typeof de.enabled=="boolean"&&(de.enabled=de.enabled?"on":"off"),{enabled:i(de.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(de.fontFamily,this.defaultValue.fontFamily),padding:h(de.padding,this.defaultValue.padding)}}}class _ extends T{constructor(){super(62,"lineDecorationsWidth",10)}validate(z){return typeof z=="string"&&/^\d+(\.\d+)?ch$/.test(z)?-parseFloat(z.substring(0,z.length-2)):b.clampedInt(z,this.defaultValue,0,1e3)}compute(z,de,Ie){return Ie<0?b.clampedInt(-Ie*z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class ie extends C{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,z=>C.clamp(z,0,150),{markdownDescription:a.localize(60,null)})}compute(z,de,Ie){return z.fontInfo.lineHeight}}class pe extends T{constructor(){const z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",z,{"editor.minimap.enabled":{type:"boolean",default:z.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:z.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:z.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:z.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:z.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:z.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:z.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:z.maxColumn,description:a.localize(71,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),autohide:h(de.autohide,this.defaultValue.autohide),size:i(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(de.side,this.defaultValue.side,["right","left"]),showSlider:i(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(de.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(de.scale,1,1,3),maxColumn:b.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(ce){return ce==="ctrlCmd"?A.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ke extends T{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{top:b.clampedInt(de.top,0,0,1e3),bottom:b.clampedInt(de.bottom,0,0,1e3)}}}class Oe extends T{constructor(){const z={enabled:!0,cycle:!0};super(81,"parameterHints",z,{"editor.parameterHints.enabled":{type:"boolean",default:z.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:z.cycle,description:a.localize(75,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),cycle:h(de.cycle,this.defaultValue.cycle)}}}class oe extends y{constructor(){super(136)}compute(z,de,Ie){return z.pixelRatio}}class ae extends T{constructor(){const z={other:"on",comments:"off",strings:"off"},de=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:de,default:z.strings,description:a.localize(79,null)},comments:{anyOf:de,default:z.comments,description:a.localize(80,null)},other:{anyOf:de,default:z.other,description:a.localize(81,null)}},default:z,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=z}validate(z){if(typeof z=="boolean"){const gt=z?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!z||typeof z!="object")return this.defaultValue;const{other:de,comments:Ie,strings:Le}=z,$e=["on","inline","off"];let Ke,Ze,pt;return typeof de=="boolean"?Ke=de?"on":"off":Ke=i(de,this.defaultValue.other,$e),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,$e),typeof Le=="boolean"?pt=Le?"on":"off":pt=i(Le,this.defaultValue.strings,$e),{other:Ke,comments:Ze,strings:pt}}}var fe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends T{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(z){let de=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof z<"u"&&(typeof z=="function"?(de=4,Ie=z):z==="interval"?de=3:z==="relative"?de=2:z==="on"?de=1:de=0),{renderType:de,renderFn:Ie}}}function ue(ce){const z=ce.get(92);return z==="editable"?ce.get(86):z!=="on"}e.filterValidationDecorations=ue;class se extends T{constructor(){const z=[],de={type:"number",description:a.localize(88,null)};super(96,"rulers",z,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:z,description:a.localize(90,null)})}validate(z){if(Array.isArray(z)){const de=[];for(const Ie of z)if(typeof Ie=="number")de.push({column:b.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;de.push({column:b.clampedInt(Le.column,0,0,1e4),color:Le.color})}return de.sort((Ie,Le)=>Ie.column-Le.column),de}return this.defaultValue}}function N(ce,z){if(typeof ce!="string")return z;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends T{constructor(){const z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:z.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:z.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:z.scrollByPage,description:a.localize(101,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z,Ie=b.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=b.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(de.vertical,this.defaultValue.vertical),horizontal:N(de.horizontal,this.defaultValue.horizontal),useShadows:h(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:b.clampedInt(de.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:b.clampedInt(de.verticalSliderSize,Le,0,1e3),scrollByPage:h(de.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends T{constructor(){const z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:z.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:z.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:z.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:z.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:z.allowedLocales,description:a.localize(108,null)}})}applyUpdate(z,de){let Ie=!1;de.allowedCharacters&&z&&(D.equals(z.allowedCharacters,de.allowedCharacters)||(z={...z,allowedCharacters:de.allowedCharacters},Ie=!0)),de.allowedLocales&&z&&(D.equals(z.allowedLocales,de.allowedLocales)||(z={...z,allowedLocales:de.allowedLocales},Ie=!0));const Le=super.applyUpdate(z,de);return Ie?new v(Le.newValue,!0):Le}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{nonBasicASCII:Ae(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(z.allowedLocales,this.defaultValue.allowedLocales)}}c(z,de){if(typeof z!="object"||!z)return de;const Ie={};for(const[Le,$e]of Object.entries(z))$e===!0&&(Ie[Le]=!0);return Ie}}class Y extends T{constructor(){const z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",z,{"editor.inlineSuggest.enabled":{type:"boolean",default:z.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:z.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),mode:i(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(de.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class he extends T{constructor(){const z={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:z.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:z.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{enabled:h(de.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(de.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends T{constructor(){const z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:z.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:z.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:z.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:z.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:z.highlightActiveIndentation,description:a.localize(128,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{bracketPairs:Ae(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ce,z,de){const Ie=de.indexOf(ce);return Ie===-1?z:de[Ie]}class be extends T{constructor(){const z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:z.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:z.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:z.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:z.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:z.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:z.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:z.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:z.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:z.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:z.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(z){if(!z||typeof z!="object")return this.defaultValue;const de=z;return{insertMode:i(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(de.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(de.showIcons,this.defaultValue.showIcons),showStatusBar:h(de.showStatusBar,this.defaultValue.showStatusBar),preview:h(de.preview,this.defaultValue.preview),previewMode:i(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(de.showMethods,this.defaultValue.showMethods),showFunctions:h(de.showFunctions,this.defaultValue.showFunctions),showConstructors:h(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(de.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(de.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(de.showFields,this.defaultValue.showFields),showVariables:h(de.showVariables,this.defaultValue.showVariables),showClasses:h(de.showClasses,this.defaultValue.showClasses),showStructs:h(de.showStructs,this.defaultValue.showStructs),showInterfaces:h(de.showInterfaces,this.defaultValue.showInterfaces),showModules:h(de.showModules,this.defaultValue.showModules),showProperties:h(de.showProperties,this.defaultValue.showProperties),showEvents:h(de.showEvents,this.defaultValue.showEvents),showOperators:h(de.showOperators,this.defaultValue.showOperators),showUnits:h(de.showUnits,this.defaultValue.showUnits),showValues:h(de.showValues,this.defaultValue.showValues),showConstants:h(de.showConstants,this.defaultValue.showConstants),showEnums:h(de.showEnums,this.defaultValue.showEnums),showEnumMembers:h(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(de.showKeywords,this.defaultValue.showKeywords),showWords:h(de.showWords,this.defaultValue.showWords),showColors:h(de.showColors,this.defaultValue.showColors),showFiles:h(de.showFiles,this.defaultValue.showFiles),showReferences:h(de.showReferences,this.defaultValue.showReferences),showFolders:h(de.showFolders,this.defaultValue.showFolders),showTypeParameters:h(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(de.showSnippets,this.defaultValue.showSnippets),showUsers:h(de.showUsers,this.defaultValue.showUsers),showIssues:h(de.showIssues,this.defaultValue.showIssues)}}}class Ce extends T{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Te extends y{constructor(){super(137)}compute(z,de,Ie){return de.get(86)?!0:z.tabFocusMode}}var Ve;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(Ve=e.WrappingIndent||(e.WrappingIndent={}));class xe extends T{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(z,de,Ie){return de.get(2)===2?0:Ie}}class et extends y{constructor(){super(139)}compute(z,de,Ie){const Le=de.get(138);return{isDominatedByLongLines:z.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class Qe extends T{constructor(){const z={enabled:!0};super(33,"dropIntoEditor",z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:z.enabled,markdownDescription:a.localize(183,null)}})}validate(z){return!z||typeof z!="object"?this.defaultValue:{enabled:h(z.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.isMacintosh?st:A.isLinux?ht:nt,fontWeight:"normal",fontSize:A.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var rt;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.autoClosingBrackets=5]="autoClosingBrackets",ce[ce.autoClosingDelete=6]="autoClosingDelete",ce[ce.autoClosingOvertype=7]="autoClosingOvertype",ce[ce.autoClosingQuotes=8]="autoClosingQuotes",ce[ce.autoIndent=9]="autoIndent",ce[ce.automaticLayout=10]="automaticLayout",ce[ce.autoSurround=11]="autoSurround",ce[ce.bracketPairColorization=12]="bracketPairColorization",ce[ce.guides=13]="guides",ce[ce.codeLens=14]="codeLens",ce[ce.codeLensFontFamily=15]="codeLensFontFamily",ce[ce.codeLensFontSize=16]="codeLensFontSize",ce[ce.colorDecorators=17]="colorDecorators",ce[ce.colorDecoratorsLimit=18]="colorDecoratorsLimit",ce[ce.columnSelection=19]="columnSelection",ce[ce.comments=20]="comments",ce[ce.contextmenu=21]="contextmenu",ce[ce.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=23]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=25]="cursorStyle",ce[ce.cursorSurroundingLines=26]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=28]="cursorWidth",ce[ce.disableLayerHinting=29]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ce[ce.domReadOnly=31]="domReadOnly",ce[ce.dragAndDrop=32]="dragAndDrop",ce[ce.dropIntoEditor=33]="dropIntoEditor",ce[ce.emptySelectionClipboard=34]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=36]="extraEditorClassName",ce[ce.fastScrollSensitivity=37]="fastScrollSensitivity",ce[ce.find=38]="find",ce[ce.fixedOverflowWidgets=39]="fixedOverflowWidgets",ce[ce.folding=40]="folding",ce[ce.foldingStrategy=41]="foldingStrategy",ce[ce.foldingHighlight=42]="foldingHighlight",ce[ce.foldingImportsByDefault=43]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=44]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=46]="fontFamily",ce[ce.fontInfo=47]="fontInfo",ce[ce.fontLigatures=48]="fontLigatures",ce[ce.fontSize=49]="fontSize",ce[ce.fontWeight=50]="fontWeight",ce[ce.fontVariations=51]="fontVariations",ce[ce.formatOnPaste=52]="formatOnPaste",ce[ce.formatOnType=53]="formatOnType",ce[ce.glyphMargin=54]="glyphMargin",ce[ce.gotoLocation=55]="gotoLocation",ce[ce.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ce[ce.hover=57]="hover",ce[ce.inDiffEditor=58]="inDiffEditor",ce[ce.inlineSuggest=59]="inlineSuggest",ce[ce.letterSpacing=60]="letterSpacing",ce[ce.lightbulb=61]="lightbulb",ce[ce.lineDecorationsWidth=62]="lineDecorationsWidth",ce[ce.lineHeight=63]="lineHeight",ce[ce.lineNumbers=64]="lineNumbers",ce[ce.lineNumbersMinChars=65]="lineNumbersMinChars",ce[ce.linkedEditing=66]="linkedEditing",ce[ce.links=67]="links",ce[ce.matchBrackets=68]="matchBrackets",ce[ce.minimap=69]="minimap",ce[ce.mouseStyle=70]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=72]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=74]="multiCursorModifier",ce[ce.multiCursorPaste=75]="multiCursorPaste",ce[ce.multiCursorLimit=76]="multiCursorLimit",ce[ce.occurrencesHighlight=77]="occurrencesHighlight",ce[ce.overviewRulerBorder=78]="overviewRulerBorder",ce[ce.overviewRulerLanes=79]="overviewRulerLanes",ce[ce.padding=80]="padding",ce[ce.parameterHints=81]="parameterHints",ce[ce.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=84]="quickSuggestions",ce[ce.quickSuggestionsDelay=85]="quickSuggestionsDelay",ce[ce.readOnly=86]="readOnly",ce[ce.renameOnType=87]="renameOnType",ce[ce.renderControlCharacters=88]="renderControlCharacters",ce[ce.renderFinalNewline=89]="renderFinalNewline",ce[ce.renderLineHighlight=90]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=92]="renderValidationDecorations",ce[ce.renderWhitespace=93]="renderWhitespace",ce[ce.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ce[ce.roundedSelection=95]="roundedSelection",ce[ce.rulers=96]="rulers",ce[ce.scrollbar=97]="scrollbar",ce[ce.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=99]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=100]="scrollPredominantAxis",ce[ce.selectionClipboard=101]="selectionClipboard",ce[ce.selectionHighlight=102]="selectionHighlight",ce[ce.selectOnLineNumbers=103]="selectOnLineNumbers",ce[ce.showFoldingControls=104]="showFoldingControls",ce[ce.showUnused=105]="showUnused",ce[ce.snippetSuggestions=106]="snippetSuggestions",ce[ce.smartSelect=107]="smartSelect",ce[ce.smoothScrolling=108]="smoothScrolling",ce[ce.stickyScroll=109]="stickyScroll",ce[ce.stickyTabStops=110]="stickyTabStops",ce[ce.stopRenderingLineAfter=111]="stopRenderingLineAfter",ce[ce.suggest=112]="suggest",ce[ce.suggestFontSize=113]="suggestFontSize",ce[ce.suggestLineHeight=114]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ce[ce.suggestSelection=116]="suggestSelection",ce[ce.tabCompletion=117]="tabCompletion",ce[ce.tabIndex=118]="tabIndex",ce[ce.unicodeHighlighting=119]="unicodeHighlighting",ce[ce.unusualLineTerminators=120]="unusualLineTerminators",ce[ce.useShadowDOM=121]="useShadowDOM",ce[ce.useTabStops=122]="useTabStops",ce[ce.wordBreak=123]="wordBreak",ce[ce.wordSeparators=124]="wordSeparators",ce[ce.wordWrap=125]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=128]="wordWrapColumn",ce[ce.wordWrapOverride1=129]="wordWrapOverride1",ce[ce.wordWrapOverride2=130]="wordWrapOverride2",ce[ce.wrappingIndent=131]="wrappingIndent",ce[ce.wrappingStrategy=132]="wrappingStrategy",ce[ce.showDeprecated=133]="showDeprecated",ce[ce.inlayHints=134]="inlayHints",ce[ce.editorClassName=135]="editorClassName",ce[ce.pixelRatio=136]="pixelRatio",ce[ce.tabFocusMode=137]="tabFocusMode",ce[ce.layoutInfo=138]="layoutInfo",ce[ce.wrappingInfo=139]="wrappingInfo"})(rt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Ue(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Ue(new r),accessibilityPageSize:Ue(new b(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Ue(new p(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Ue(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Ue(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Ue(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Ue(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Ue(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Ue(new d(10,"automaticLayout",!1)),autoSurround:Ue(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Ue(new he),bracketPairGuides:Ue(new we),stickyTabStops:Ue(new d(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Ue(new d(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Ue(new p(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Ue(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Ue(new d(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Ue(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Ue(new d(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Ue(new m),contextmenu:Ue(new d(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new d(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Ue(new s(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Ue(new o(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Ue(new s(25,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],S,{description:a.localize(222,null)})),cursorSurroundingLines:Ue(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Ue(new o(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Ue(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Ue(new d(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new d(30,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new d(31,"domReadOnly",!1)),dragAndDrop:Ue(new d(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Ue(new x),dropIntoEditor:Ue(new Qe),stickyScroll:Ue(new te),experimentalWhitespaceRendering:Ue(new o(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Ue(new p(36,"extraEditorClassName","")),fastScrollSensitivity:Ue(new C(37,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:a.localize(233,null)})),find:Ue(new V),fixedOverflowWidgets:Ue(new d(39,"fixedOverflowWidgets",!1)),folding:Ue(new d(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Ue(new o(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Ue(new d(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Ue(new d(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Ue(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Ue(new d(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Ue(new p(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Ue(new O),fontLigatures2:Ue(new M),fontSize:Ue(new U),fontWeight:Ue(new $),fontVariations:Ue(new B),formatOnPaste:Ue(new d(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Ue(new d(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Ue(new d(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Ue(new j),hideCursorInOverviewRuler:Ue(new d(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Ue(new le),inDiffEditor:Ue(new d(58,"inDiffEditor",!1)),letterSpacing:Ue(new C(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>C.clamp(ce,-5,20),{description:a.localize(247,null)})),lightbulb:Ue(new Z),lineDecorationsWidth:Ue(new _),lineHeight:Ue(new ie),lineNumbers:Ue(new ee),lineNumbersMinChars:Ue(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new d(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Ue(new d(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Ue(new o(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Ue(new pe),mouseStyle:Ue(new o(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new C(71,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Ue(new d(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Ue(new d(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Ue(new s(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Ue(new o(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Ue(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Ue(new d(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Ue(new d(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Ue(new b(79,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),parameterHints:Ue(new Oe),peekWidgetDefaultFocus:Ue(new o(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Ue(new d(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Ue(new ae),quickSuggestionsDelay:Ue(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Ue(new d(86,"readOnly",!1)),renameOnType:Ue(new d(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Ue(new d(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Ue(new o(89,"renderFinalNewline",A.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Ue(new o(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Ue(new d(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Ue(new o(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new o(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Ue(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new d(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Ue(new se),scrollbar:Ue(new W),scrollBeyondLastColumn:Ue(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Ue(new d(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Ue(new d(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Ue(new d(101,"selectionClipboard",!0,{description:a.localize(283,null),included:A.isLinux})),selectionHighlight:Ue(new d(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Ue(new d(103,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new o(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Ue(new d(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Ue(new d(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Ue(new X),snippetSuggestions:Ue(new o(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Ue(new Ce),smoothScrolling:Ue(new d(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Ue(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new be),inlineSuggest:Ue(new Y),suggestFontSize:Ue(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new d(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Ue(new o(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Ue(new o(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Ue(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new K),unusualLineTerminators:Ue(new o(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Ue(new d(121,"useShadowDOM",!0)),useTabStops:Ue(new d(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Ue(new o(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Ue(new p(124,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Ue(new o(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Ue(new p(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new p(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Ue(new o(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new o(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new F),pixelRatio:Ue(new oe),tabFocusMode:Ue(new Te),layoutInfo:Ue(new q),wrappingInfo:Ue(new et),wrappingIndent:Ue(new xe),wrappingStrategy:Ue(new Q)}}),define(ye[169],De([17,18]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[170],De([17,18]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[171],De([17,18]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[172],De([17,18]),function(ne,e){return ne.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[173],De([17,18]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ye[174],De([17,18]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(ye[175],De([17,18]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[176],De([17,18]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ye[177],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[178],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[179],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[180],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[181],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[182],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[183],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[184],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[185],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[186],De([17,18]),function(ne,e){return ne.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[187],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(ye[188],De([17,18]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(ye[189],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[190],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[191],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[192],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[193],De([17,18]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[194],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[195],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[196],De([17,18]),function(ne,e){return ne.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[197],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(R,D){this.a.set(R,D)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const D in R.contributes){const P=this.a.get(D);if(!P)continue;const E=R.contributes[D],k=Array.isArray(E)?E:[E];try{P(k,R.activationEvents)}catch(L){(0,a.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(ye[198],De([1,0,24,37,171,319]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function E(d){return d=d.trim(),d==="*"||D.test(d)}e.isValidVersionStr=E;function k(d){if(!E(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=d.match(D);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=k;function L(d){if(!d)return null;const g=d.majorBase,b=d.majorMustEqual,C=d.minorBase;let p=d.minorMustEqual;const i=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(g===0||(p=!1),o=!1);let s=0;if(d.preRelease){const c=P.exec(d.preRelease);if(c){const[,r,m,n]=c;s=Date.UTC(Number(r),Number(m)-1,Number(n))}}return{majorBase:g,majorMustEqual:b,minorBase:C,minorMustEqual:p,patchBase:i,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:s}}e.normalizeVersion=L;function T(d,g,b){let C;typeof d=="string"?C=L(k(d)):C=d;let p;g instanceof Date?p=g.getTime():typeof g=="string"&&(p=new Date(g).getTime());let i;if(typeof b=="string"?i=L(k(b)):i=b,!C||!i)return!1;const o=C.majorBase,s=C.minorBase,c=C.patchBase;let r=i.majorBase,m=i.minorBase,n=i.patchBase;const t=i.notBefore;let u=i.majorMustEqual,w=i.minorMustEqual,S=i.patchMustEqual;return i.isMinimum?o>r?!0:o<r?!1:s>m?!0:s<m||p&&p<t?!1:c>=n:(o===1&&r===0&&(!u||!w||!S)&&(r=1,m=0,n=0,u=!0,w=!1,S=!1),o<r?!1:o>r?!u:s<m?!1:s>m?!w:c<n?!1:c>n?!S:!(p&&p<t))}e.isValidVersion=T;function v(d,g,b,C,p){const i=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return i.push([A.default.Error,l.localize(0,null)]),i;if(typeof C.name!="string")return i.push([A.default.Error,l.localize(1,null,"name")]),i;if(typeof C.version!="string")return i.push([A.default.Error,l.localize(2,null,"version")]),i;if(!C.engines)return i.push([A.default.Error,l.localize(3,null,"engines")]),i;if(typeof C.engines.vscode!="string")return i.push([A.default.Error,l.localize(4,null,"engines.vscode")]),i;if(typeof C.extensionDependencies<"u"&&!h(C.extensionDependencies))return i.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),i;if(typeof C.activationEvents<"u"){if(!h(C.activationEvents))return i.push([A.default.Error,l.localize(6,null,"activationEvents")]),i;if(typeof C.main>"u"&&typeof C.browser>"u")return i.push([A.default.Error,l.localize(7,null,"activationEvents","main")]),i}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&i.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return i.push([A.default.Error,l.localize(9,null,"main")]),i;{const c=(0,a.joinPath)(b,C.main);(0,a.isEqualOrParent)(c,b)||i.push([A.default.Warning,l.localize(10,null,c.path,b.path)])}if(typeof C.activationEvents>"u")return i.push([A.default.Error,l.localize(11,null,"activationEvents","main")]),i}if(typeof C.browser<"u"){if(typeof C.browser!="string")return i.push([A.default.Error,l.localize(12,null,"browser")]),i;{const c=(0,a.joinPath)(b,C.browser);(0,a.isEqualOrParent)(c,b)||i.push([A.default.Warning,l.localize(13,null,c.path,b.path)])}if(typeof C.activationEvents>"u")return i.push([A.default.Error,l.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(C.version))return i.push([A.default.Error,l.localize(15,null)]),i;const o=[];if(!I(d,g,C,p,o))for(const c of o)i.push([A.default.Error,c]);return i}e.validateExtensionManifest=v;function I(d,g,b,C,p){return C||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(d,g,b.engines.vscode,p)}e.isValidExtensionVersion=I;function y(d,g,b){return d==="*"||f(g,b,d)}e.isEngineValid=y;function f(d,g,b,C=[]){const p=L(k(b));if(!p)return C.push(l.localize(16,null,b)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return C.push(l.localize(17,null,b)),!1}else if(!p.majorMustEqual)return C.push(l.localize(18,null,b)),!1;return T(d,g,p)?!0:(C.push(l.localize(19,null,d,b)),!1)}function h(d){if(!Array.isArray(d))return!1;for(let g=0,b=d.length;g<b;g++)if(typeof d[g]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(l,R=[],D=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=a}),define(ye[89],De([1,0,122]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function R(P,E,k){E instanceof a.SyncDescriptor||(E=new a.SyncDescriptor(E,[],Boolean(k))),A.push([P,E])}e.registerSingleton=R;function D(){return A}e.getSingletonServiceDescriptors=D}),define(ye[199],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,D){this.key=R,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class A{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const D of this.a.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const P=this.lookupOrInsertNode(R),E=this.lookupOrInsertNode(D);P.outgoing.set(E.key,E),E.incoming.set(P.key,P)}removeNode(R){const D=this.b(R);this.a.delete(D);for(const P of this.a.values())P.outgoing.delete(D),P.incoming.delete(D)}lookupOrInsertNode(R){const D=this.b(R);let P=this.a.get(D);return P||(P=new a(D,R),this.a.set(D,P)),P}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[D,P]of this.a)R.push(`${D}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,D]of this.a){const P=new Set([R]),E=this.c(D,P);if(E)return E}}c(R,D){for(const[P,E]of R.outgoing){if(D.has(P))return[...D,P].join(" -> ");D.add(P);const k=this.c(E,D);if(k)return k;D.delete(P)}}}e.Graph=A}),define(ye[4],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function P(E){return E[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=P})(a=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function A(D,P,E){P[a.DI_TARGET]===P?P[a.DI_DEPENDENCIES].push({id:D,index:E}):(P[a.DI_DEPENDENCIES]=[{id:D,index:E}],P[a.DI_TARGET]=P)}function l(D){if(a.serviceIds.has(D))return a.serviceIds.get(D);const P=function(E,k,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,E,L)};return P.toString=()=>D,a.serviceIds.set(D,P),P}e.createDecorator=l;function R(D){return D}e.refineServiceDecorator=R}),define(ye[53],De([1,0,9,2,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationOverrides=R;function D(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=D;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function k(h,d){const g=Object.create(null);for(const b in h)L(g,b,h[b],d);return g}e.toValuesTree=k;function L(h,d,g,b){const C=d.split("."),p=C.pop();let i=h;for(let o=0;o<C.length;o++){const s=C[o];let c=i[s];switch(typeof c){case"undefined":c=i[s]=Object.create(null);break;case"object":break;default:b(`Ignoring ${d} as ${C.slice(0,o+1).join(".")} is ${JSON.stringify(c)}`);return}i=c}if(typeof i=="object"&&i!==null)try{i[p]=g}catch{b(`Ignoring ${d} as ${C.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${d} as ${C.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=L;function T(h,d){const g=d.split(".");v(h,g)}e.removeFromValueTree=T;function v(h,d){const g=d.shift();if(d.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const b=h[g];typeof b=="object"&&!Array.isArray(b)&&(v(b,d),Object.keys(b).length===0&&delete h[g])}}function I(h,d,g){function b(i,o){let s=i;for(const c of o){if(typeof s!="object"||s===null)return;s=s[c]}return s}const C=d.split("."),p=b(h,C);return typeof p>"u"?g:p}e.getConfigurationValue=I;function y(h,d,g){Object.keys(d).forEach(b=>{b!=="__proto__"&&(b in h?a.isObject(h[b])&&a.isObject(d[b])?y(h[b],d[b],g):g&&(h[b]=d[b]):h[b]=d[b])})}e.merge=y;function f(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[54],De([1,0,12,8,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",a.isMacintosh),R.set("isLinux",a.isLinux),R.set("isWindows",a.isWindows),R.set("isWeb",a.isWeb),R.set("isMacNative",a.isMacintosh&&!a.isWeb),R.set("isEdge",a.isEdge),R.set("isFirefox",a.isFirefox),R.set("isChrome",a.isChrome),R.set("isSafari",a.isSafari);const D=Object.prototype.hasOwnProperty;var P;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return T.INSTANCE}static true(){return v.INSTANCE}static has(M){return I.create(M)}static equals(M,B){return y.create(M,B)}static notEquals(M,B){return d.create(M,B)}static regex(M,B){return s.create(M,B)}static in(M,B){return f.create(M,B)}static notIn(M,B){return h.create(M,B)}static not(M){return g.create(M)}static and(...M){return m.create(M,null,!0)}static or(...M){return n.create(M,null,!0)}static greater(M,B){return C.create(M,B)}static greaterEquals(M,B){return p.create(M,B)}static smaller(M,B){return i.create(M,B)}static smallerEquals(M,B){return o.create(M,B)}static deserialize(M,B=!1){if(!!M)return this.c(M,B)}static c(M,B){const O=M.split("||");return n.create(O.map(U=>this.d(U,B)),null,!0)}static d(M,B){const O=M.split("&&");return m.create(O.map(U=>this.f(U,B)),null,!0)}static f(M,B){if(M=M.trim(),M.indexOf("!=")>=0){const O=M.split("!=");return d.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("==")>=0){const O=M.split("==");return y.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf("=~")>=0){const O=M.split("=~");return s.create(O[0].trim(),this.h(O[1],B))}if(M.indexOf(" not in ")>=0){const O=M.split(" not in ");return h.create(O[0].trim(),this.g(O[1],B))}if(M.indexOf(" in ")>=0){const O=M.split(" in ");return f.create(O[0].trim(),this.g(O[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(M)){const O=M.split(">=");return p.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(M)){const O=M.split(">");return C.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(M)){const O=M.split("<=");return o.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(M)){const O=M.split("<");return i.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(M)?g.create(M.substr(1).trim()):I.create(M)}static g(M,B){if(M=M.trim(),M==="true")return!0;if(M==="false")return!1;const O=/^'([^']*)'$/.exec(M);return O?O[1].trim():M}static h(M,B){if((0,A.isFalsyOrWhitespace)(M)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const O=M.indexOf("/"),U=M.lastIndexOf("/");if(O===U||O<0){if(B)throw new Error(`bad regexp-value '${M}', missing /-enclosure`);return console.warn(`bad regexp-value '${M}', missing /-enclosure`),null}const $=M.slice(O+1,U),j=M[U+1]==="i"?"i":"";try{return new RegExp($,j)}catch(le){if(B)throw new Error(`bad regexp-value '${M}', parse error: ${le}`);return console.warn(`bad regexp-value '${M}', parse error: ${le}`),null}}}e.ContextKeyExpr=E;function k(V,M){const B=V?V.substituteConstants():void 0,O=M?M.substituteConstants():void 0;return!B&&!O?!0:!B||!O?!1:B.equals(O)}e.expressionsAreEqualWithConstantSubstitution=k;function L(V,M){return V.cmp(M)}class T{constructor(){this.type=0}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!1}serialize(){return"false"}keys(){return[]}map(M){return this}negate(){return v.INSTANCE}}T.INSTANCE=new T,e.ContextKeyFalseExpr=T;class v{constructor(){this.type=1}cmp(M){return this.type-M.type}equals(M){return M.type===this.type}substituteConstants(){return this}evaluate(M){return!0}serialize(){return"true"}keys(){return[]}map(M){return this}negate(){return T.INSTANCE}}v.INSTANCE=new v,e.ContextKeyTrueExpr=v;class I{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?v.INSTANCE:T.INSTANCE:new I(M,B)}constructor(M,B){this.key=M,this.c=B,this.type=2}cmp(M){return M.type!==this.type?this.type-M.type:u(this.key,M.key)}equals(M){return M.type===this.type?this.key===M.key:!1}substituteConstants(){const M=R.get(this.key);return typeof M=="boolean"?M?v.INSTANCE:T.INSTANCE:this}evaluate(M){return!!M.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(M){return M.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=I;class y{static create(M,B,O=null){if(typeof B=="boolean")return B?I.create(M,O):g.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?v.INSTANCE:T.INSTANCE:new y(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=4}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?v.INSTANCE:T.INSTANCE}return this}evaluate(M){return M.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(M){return M.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=y;class f{static create(M,B){return new f(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=10,this.c=null}cmp(M){return M.type!==this.type?this.type-M.type:w(this.d,this.f,M.d,M.f)}equals(M){return M.type===this.type?this.d===M.d&&this.f===M.f:!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.f),O=M.getValue(this.d);return Array.isArray(B)?B.includes(O):typeof O=="string"&&typeof B=="object"&&B!==null?D.call(B,O):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(M){return M.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class h{static create(M,B){return new h(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=11,this.c=f.create(M,B)}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(M){return M.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=h;class d{static create(M,B,O=null){if(typeof B=="boolean")return B?g.create(M,O):I.create(M,O);const U=R.get(M);return typeof U=="boolean"?B===(U?"true":"false")?T.INSTANCE:v.INSTANCE:new d(M,B,O)}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=5}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){const M=R.get(this.c);if(typeof M=="boolean"){const B=M?"true":"false";return this.d===B?T.INSTANCE:v.INSTANCE}return this}evaluate(M){return M.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(M){return M.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=d;class g{static create(M,B=null){const O=R.get(M);return typeof O=="boolean"?O?T.INSTANCE:v.INSTANCE:new g(M,B)}constructor(M,B){this.c=M,this.d=B,this.type=3}cmp(M){return M.type!==this.type?this.type-M.type:u(this.c,M.c)}equals(M){return M.type===this.type?this.c===M.c:!1}substituteConstants(){const M=R.get(this.c);return typeof M=="boolean"?M?T.INSTANCE:v.INSTANCE:this}evaluate(M){return!M.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(M){return M.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function b(V,M){if(typeof V=="string"){const B=parseFloat(V);isNaN(B)||(V=B)}return typeof V=="string"||typeof V=="number"?M(V):T.INSTANCE}class C{static create(M,B,O=null){return b(B,U=>new C(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=12}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=C;class p{static create(M,B,O=null){return b(B,U=>new p(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=13}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(M){return M.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=p;class i{static create(M,B,O=null){return b(B,U=>new i(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=14}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class o{static create(M,B,O=null){return b(B,U=>new o(M,U,O))}constructor(M,B,O){this.c=M,this.d=B,this.f=O,this.type=15}cmp(M){return M.type!==this.type?this.type-M.type:w(this.c,this.d,M.c,M.d)}equals(M){return M.type===this.type?this.c===M.c&&this.d===M.d:!1}substituteConstants(){return this}evaluate(M){return typeof this.d=="string"?!1:parseFloat(M.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(M){return M.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class s{static create(M,B){return new s(M,B)}constructor(M,B){this.d=M,this.f=B,this.type=7,this.c=null}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.d<M.d)return-1;if(this.d>M.d)return 1;const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return B<O?-1:B>O?1:0}equals(M){if(M.type===this.type){const B=this.f?this.f.source:"",O=M.f?M.f.source:"";return this.d===M.d&&B===O}return!1}substituteConstants(){return this}evaluate(M){const B=M.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const M=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${M}`}keys(){return[this.d]}map(M){return M.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=c.create(this)),this.c}}e.ContextKeyRegexExpr=s;class c{static create(M){return new c(M)}constructor(M){this.c=M,this.type=8}cmp(M){return M.type!==this.type?this.type-M.type:this.c.cmp(M.c)}equals(M){return M.type===this.type?this.c.equals(M.c):!1}substituteConstants(){return this}evaluate(M){return!this.c.evaluate(M)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(M){return new c(this.c.map(M))}negate(){return this.c}}e.ContextKeyNotRegexExpr=c;function r(V){let M=null;for(let B=0,O=V.length;B<O;B++){const U=V[B].substituteConstants();if(V[B]!==U&&M===null){M=[];for(let $=0;$<B;$++)M[$]=V[$]}M!==null&&(M[B]=U)}return M===null?V:M}class m{static create(M,B,O){return m.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=6}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:m.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].evaluate(M))return!1;return!0}static d(M,B,O){const U=[];let $=!1;for(const j of M)if(!!j){if(j.type===1){$=!0;continue}if(j.type===0)return T.INSTANCE;if(j.type===6){U.push(...j.expr);continue}U.push(j)}if(U.length===0&&$)return v.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(L);for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];for(;U.length>1;){const j=U[U.length-1];if(j.type!==9)break;U.pop();const le=U.pop(),J=U.length===0,q=n.create(j.expr.map(Q=>m.create([Q,le],null,O)),null,J);q&&(U.push(q),U.sort(L))}if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let le=j+1;le<U.length;le++)if(U[j].negate().equals(U[le]))return T.INSTANCE;if(U.length===1)return U[0]}return new m(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" && ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new m(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());this.c=n.create(M,this,!0)}return this.c}}class n{static create(M,B,O){return n.d(M,B,O)}constructor(M,B){this.expr=M,this.c=B,this.type=9}cmp(M){if(M.type!==this.type)return this.type-M.type;if(this.expr.length<M.expr.length)return-1;if(this.expr.length>M.expr.length)return 1;for(let B=0,O=this.expr.length;B<O;B++){const U=L(this.expr[B],M.expr[B]);if(U!==0)return U}return 0}equals(M){if(M.type===this.type){if(this.expr.length!==M.expr.length)return!1;for(let B=0,O=this.expr.length;B<O;B++)if(!this.expr[B].equals(M.expr[B]))return!1;return!0}return!1}substituteConstants(){const M=r(this.expr);return M===this.expr?this:n.create(M,this.c,!1)}evaluate(M){for(let B=0,O=this.expr.length;B<O;B++)if(this.expr[B].evaluate(M))return!0;return!1}static d(M,B,O){let U=[],$=!1;if(M){for(let j=0,le=M.length;j<le;j++){const J=M[j];if(!!J){if(J.type===0){$=!0;continue}if(J.type===1)return v.INSTANCE;if(J.type===9){U=U.concat(J.expr);continue}U.push(J)}}if(U.length===0&&$)return T.INSTANCE;U.sort(L)}if(U.length!==0){if(U.length===1)return U[0];for(let j=1;j<U.length;j++)U[j-1].equals(U[j])&&(U.splice(j,1),j--);if(U.length===1)return U[0];if(O){for(let j=0;j<U.length;j++)for(let le=j+1;le<U.length;le++)if(U[j].negate().equals(U[le]))return v.INSTANCE;if(U.length===1)return U[0]}return new n(U,B)}}serialize(){return this.expr.map(M=>M.serialize()).join(" || ")}keys(){const M=[];for(const B of this.expr)M.push(...B.keys());return M}map(M){return new n(this.expr.map(B=>B.map(M)),null)}negate(){if(!this.c){const M=[];for(const B of this.expr)M.push(B.negate());for(;M.length>1;){const B=M.shift(),O=M.shift(),U=[];for(const $ of x(B))for(const j of x(O))U.push(m.create([$,j],null,!1));M.unshift(n.create(U,null,!1))}this.c=n.create(M,this,!0)}return this.c}}class t extends I{static all(){return t.d.values()}constructor(M,B,O){super(M,null),this.f=B,typeof O=="object"?t.d.push({...O,key:M}):O!==!0&&t.d.push({key:M,description:O,type:B!=null?typeof B:void 0})}bindTo(M){return M.createKey(this.key,this.f)}getValue(M){return M.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(M){return y.create(this.key,M)}notEqualsTo(M){return d.create(this.key,M)}}t.d=[],e.RawContextKey=t,e.IContextKeyService=(0,l.createDecorator)("contextKeyService");function u(V,M){return V<M?-1:V>M?1:0}function w(V,M,B,O){return V<B?-1:V>B?1:M<O?-1:M>O?1:0}function S(V,M){if(V.type===0||M.type===1)return!0;if(V.type===9)return M.type===9?F(V.expr,M.expr):!1;if(M.type===9){for(const B of M.expr)if(S(V,B))return!0;return!1}if(V.type===6){if(M.type===6)return F(M.expr,V.expr);for(const B of V.expr)if(S(B,M))return!0;return!1}return V.equals(M)}e.implies=S;function F(V,M){let B=0,O=0;for(;B<V.length&&O<M.length;){const U=V[B].cmp(M[O]);if(U<0)return!1;U===0&&B++,O++}return B===V.length}function x(V){return V.type===9?V.expr:[V]}}),define(ye[200],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,170,4]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function D(d,g){switch(d){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function P(d,g){return g==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function E(d,g,b){return P(g,b)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===b?!0:k(b).includes(d)}e.isTargetPlatformCompatible=E;function k(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=k;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=L;var T;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(T=e.SortBy||(e.SortBy={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var I;(function(d){d.Install="install",d.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var y;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var f;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal",d.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class h extends Error{constructor(g,b){super(g),this.code=b,this.name=b}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(ye[201],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(ye[202],De([1,0,46,16,10,12,109,29,116,172,201]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const T=k.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:I.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class I extends v{openTerminal(C,p){return this.spawnTerminal(a,C,E.getWindowsShell(),p)}spawnTerminal(C,p,i,o){const s=p.windowsExec||I.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const c=l.basename(s,".exe").toLowerCase();if(c==="cmder")return C.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),c==="wt"&&r.push("-d ."),new Promise((m,n)=>{const t=h(process),u=C.spawn(i,r,{cwd:o,env:t});u.on("error",n),u.on("exit",()=>m())})}runInTerminal(C,p,i,o,s){const c="windowsExec"in s&&s.windowsExec?s.windowsExec:I.getDefaultTerminalWindows();return new Promise((r,m)=>{const n=`"${p} - ${T}"`,t=`""${i.join('" "')}" & pause"`,u=Object.assign({},h(process),o);Object.keys(u).filter(V=>u[V]===null).forEach(V=>delete u[V]);const w={cwd:p,env:u,windowsVerbatimArguments:!0};let S,F;l.basename(c,".exe")==="wt"?(S=c,F=["-d",".",I.b,"/c",t]):(S=I.b,F=["/c","start",n,"/wait",c,"/c",t]),a.spawn(S,F,w).on("error",V=>{m(d(V))}),r(void 0)})}static getDefaultTerminalWindows(){if(!I.d){const C=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");I.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${C?"Sysnative":"System32"}\\cmd.exe`}return I.d}}I.b="cmd.exe",e.WindowsExternalTerminalService=I;class y extends v{openTerminal(C,p){return this.spawnTerminal(a,C,p)}runInTerminal(C,p,i,o,s){const c=s.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((r,m)=>{if(c===L.DEFAULT_TERMINAL_OSX||c==="iTerm.app"){const n=c===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[A.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",C||T,"-w",p];for(const F of i)u.push("-a"),u.push(F);if(o){const F=Object.assign({},h(process),o);for(const x in F){const V=F[x];V===null?(u.push("-u"),u.push(x)):(u.push("-e"),u.push(`${x}=${V}`))}}let w="";const S=a.spawn(y.b,u);S.on("error",F=>{m(d(F))}),S.stderr.on("data",F=>{w+=F.toString()}),S.on("exit",F=>{if(F===0)r(void 0);else if(w){const x=w.split(`
`,1);m(new Error(x[0]))}else m(new Error(k.localize(1,null,n,F)))})}else m(new Error(k.localize(2,null,c)))})}spawnTerminal(C,p,i){const o=p.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((s,c)=>{const r=["-a",o];i&&r.push(i);const m=h(process),n=C.spawn("/usr/bin/open",r,{cwd:i,env:m});n.on("error",c),n.on("exit",()=>s())})}}y.b="/usr/bin/osascript",e.MacExternalTerminalService=y;class f extends v{openTerminal(C,p){return this.spawnTerminal(a,C,p)}runInTerminal(C,p,i,o,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,m)=>{const n=[];c.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const u=`${g(i)}; echo; read -p "${f.b}" -n1;`;n.push(`''${u}''`);const w=Object.assign({},h(process),o);Object.keys(w).filter(V=>w[V]===null).forEach(V=>delete w[V]);const S={cwd:p,env:w};let F="";const x=a.spawn(t,n,S);x.on("error",V=>{m(d(V))}),x.stderr.on("data",V=>{F+=V.toString()}),x.on("exit",V=>{if(V===0)r(void 0);else if(F){const M=F.split(`
`,1);m(new Error(M[0]))}else m(new Error(k.localize(4,null,t,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const C=await P.Promises.exists("/etc/debian_version");f.d=new Promise(p=>{C?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return f.d}spawnTerminal(C,p,i){const o=p.linuxExec?Promise.resolve(p.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,c)=>{o.then(r=>{const m=h(process),n=C.spawn(r,[],{cwd:i,env:m});n.on("error",c),n.on("exit",()=>s())})})}}f.b=k.localize(3,null),e.LinuxExternalTerminalService=f;function h(b){const C={...b.env};return(0,D.sanitizeProcessEnvironment)(C),C}function d(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(k.localize(5,null,b.path)):b}function g(b){let C="";for(const p of b)p.indexOf(" ")>=0?C+='"'+p+'"':C+=p,C+=" ";return C}}),define(ye[44],De([1,0,68,10,8,9,2,173,4,12,16]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function T(q){return q.create===!0}e.isFileOpenForWriteOptions=T;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var I;(function(q){q[q.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var y;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=f;function h(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=h;function d(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=d;function g(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function b(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=b;function C(q){return f(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var p;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(p=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(Q,Z){const te=new i(Q.toString(),Z);return c(te,Z),te}constructor(Q,Z){super(Q),this.code=Z}}e.FileSystemProviderError=i;function o(q,Q){return i.create(q,Q)}e.createFileSystemProviderError=o;function s(q){return q||o((0,P.localize)(0,null),p.Unknown)}e.ensureFileSystemProviderError=s;function c(q,Q){return q.name=Q?`${Q} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=c;function r(q){if(!q)return p.Unknown;if(q instanceof i)return q.code;const Q=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!Q)return p.Unknown;switch(Q[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileExceedsMemoryLimit:return p.FileExceedsMemoryLimit;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.toFileSystemProviderErrorCode=r;function m(q){if(q instanceof F)return q.fileOperationResult;switch(r(q)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 10;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileExceedsMemoryLimit:return 9;case p.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(Q,Z,te){this.resource=Q,this.operation=Z,this.target=te}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=t;var u;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(Q,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const X of Q){const _=te.get(X.type);switch(_?_.push([X.resource,X]):te.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,_]of te)switch(X){case 1:this.a=a.TernarySearchTree.forUris(()=>Z),this.a.fill(_);break;case 0:this.b=a.TernarySearchTree.forUris(()=>Z),this.b.fill(_);break;case 2:this.c=a.TernarySearchTree.forUris(()=>Z),this.c.fill(_);break}}contains(Q,...Z){return this.d(Q,{includeChildren:!1},...Z)}affects(Q,...Z){return this.d(Q,{includeChildren:!0},...Z)}d(Q,Z,...te){if(!Q)return!1;const X=te.length>0;return!!((!X||te.includes(1))&&(this.a?.get(Q)||Z.includeChildren&&this.a?.findSuperstr(Q))||(!X||te.includes(0))&&(this.b?.get(Q)||Z.includeChildren&&this.b?.findSuperstr(Q))||(!X||te.includes(2))&&(this.c?.findSubstr(Q)||Z.includeChildren&&this.c?.findSuperstr(Q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=w;function S(q,Q,Z){return!q||!Q||q===Q||Q.length>q.length?!1:(Q.charAt(Q.length-1)!==A.sep&&(Q+=A.sep),Z?(0,l.startsWithIgnoreCase)(q,Q):q.indexOf(Q)===0)}e.isParent=S;class F extends Error{constructor(Q,Z,te){super(Q),this.fileOperationResult=Z,this.options=te}}e.FileOperationError=F;class x extends F{constructor(Q,Z,te,X){super(Q,Z,X),this.fileOperationResult=Z,this.size=te}}e.TooLargeFileOperationError=x;class V extends F{constructor(Q,Z,te){super(Q,2,te),this.stat=Z}}e.NotModifiedSinceFileOperationError=V;var M;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(M=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=O;async function U(q,Q){if(!Q.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(Z=>{const te=Q.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===q.scheme&&X.added&&(te.dispose(),Z())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(Q){return(0,R.isNumber)(Q)||(Q=0),Q<$.KB?(0,P.localize)(1,null,Q.toFixed(0)):Q<$.MB?(0,P.localize)(2,null,(Q/$.KB).toFixed(2)):Q<$.GB?(0,P.localize)(3,null,(Q/$.MB).toFixed(2)):Q<$.TB?(0,P.localize)(4,null,(Q/$.GB).toFixed(2)):(0,P.localize)(5,null,(Q/$.TB).toFixed(2))}}$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB,e.ByteSize=$;var j;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function le(q){return{maxFileSize:q===0?300*$.MB:16*$.GB,maxHeapSize:q===0?700*$.MB:2*700*$.MB}}e.getPlatformFileLimits=le;function J(q){const Q=typeof q=="string"||q?.scheme===L.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===L.Schemas.file?1024*$.MB:Q?10*$.MB:k.isWeb?50*$.MB:1024*$.MB}e.getLargeFileConfirmationLimit=J}),define(ye[90],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...l){this.a=new Map;for(const[R,D]of l)this.set(R,D)}set(l,R){const D=this.a.get(l);return this.a.set(l,R),D}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=a}),define(ye[203],De([1,0,19,11,6,122,199,4,90,66]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class T extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class v{constructor(h=new E.ServiceCollection,d=!1,g,b=L){this.f=h,this.g=d,this.h=g,this.i=b,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=b?g?._globalGraph??new D.Graph(C=>C):void 0}createChild(h){return new v(h,this.g,this,this.i)}invokeFunction(h,...d){const g=y.traceInvocation(this.i,h);let b=!1;try{return h({get:p=>{if(b)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(p,g);if(!i)throw new Error(`[invokeFunction] unknown service '${p}'`);return i}},...d)}finally{b=!0,g.stop()}}createInstance(h,...d){let g,b;return h instanceof R.SyncDescriptor?(g=y.traceCreation(this.i,h.ctor),b=this.j(h.ctor,h.staticArguments.concat(d),g)):(g=y.traceCreation(this.i,h),b=this.j(h,d,g)),g.stop(),b}j(h,d=[],g){const b=P._util.getServiceDependencies(h).sort((i,o)=>i.index-o.index),C=[];for(const i of b){const o=this.m(i.id,g);o||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${i.id}.`,!1),C.push(o)}const p=b.length>0?b[0].index:d.length;if(d.length!==p){console.trace(`[createInstance] First service dependency of ${h.name} at position ${p+1} conflicts with ${d.length} static arguments`);const i=p-d.length;i>0?d=d.concat(new Array(i)):d=d.slice(0,p)}return Reflect.construct(h,d.concat(C))}k(h,d){if(this.f.get(h)instanceof R.SyncDescriptor)this.f.set(h,d);else if(this.h)this.h.k(h,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const d=this.f.get(h);return!d&&this.h?this.h.l(h):d}m(h,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const g=this.l(h);return g instanceof R.SyncDescriptor?this.q(h,g,d.branch(h,!0)):(d.branch(h,!1),g)}q(h,d,g){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,d,g)}finally{this.o.delete(h)}}r(h,d,g){const b=new D.Graph(i=>i.id.toString());let C=0;const p=[{id:h,desc:d,_trace:g}];for(;p.length;){const i=p.pop();if(b.lookupOrInsertNode(i),C++>1e3)throw new T(b);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${h} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),s instanceof R.SyncDescriptor){const c={id:o.id,desc:s,_trace:i._trace.branch(o.id,!0)};b.insertEdge(i,c),p.push(c)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new T(b);break}for(const{data:o}of i){if(this.l(o.id)instanceof R.SyncDescriptor){const c=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,c)}b.removeNode(o)}}return this.l(h)}s(h,d,g=[],b,C){if(this.f.get(h)instanceof R.SyncDescriptor)return this.t(h,d,g,b,C);if(this.h)return this.h.s(h,d,g,b,C);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(h,d,g=[],b,C){if(b){const p=new v(void 0,this.g,this,this.i);p.c=String(h);const i=new Map,o=new a.IdleValue(()=>{const s=p.j(d,g,C);for(const[c,r]of i){const m=s[c];if(typeof m=="function")for(const n of r)m.apply(s,n)}return i.clear(),s});return new Proxy(Object.create(null),{get(s,c){if(!o.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let n=i.get(c);return n||(n=new k.LinkedList,i.set(c,n)),(u,w,S)=>{const F=n.push([u,w,S]);return(0,l.toDisposable)(F)}}if(c in s)return s[c];const r=o.value;let m=r[c];return typeof m!="function"||(m=m.bind(r),s[c]=m),m},set(s,c,r){return o.value[c]=r,!0},getPrototypeOf(s){return d.prototype}})}else return this.j(d,g,C)}u(h,d){if(d&&console.warn(h),this.g)throw new Error(h)}}e.InstantiationService=v;var I;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(I||(I={}));class y{static traceInvocation(h,d){return h?new y(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(h,d){return h?new y(1,d.name):y.c}constructor(h,d){this.type=h,this.name=d,this.g=Date.now(),this.h=[]}branch(h,d){const g=new y(3,h.toString());return this.h.push([h,d,g]),g}stop(){const h=Date.now()-this.g;y.f+=h;let d=!1;function g(C,p){const i=[],o=new Array(C+1).join("	");for(const[s,c,r]of p.h)if(c&&r){d=!0,i.push(`${o}CREATES -> ${s}`);const m=g(C+1,r);m&&i.push(m)}else i.push(`${o}uses -> ${s}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(h>2||d)&&y.all.add(b.join(`
`))}}y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0,e.Trace=y}),define(ye[13],De([1,0,45,3,6,28,12,9,2,4]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function L(){return new Date().toISOString()}function T(n){return(0,P.isNumber)(n)}e.isLogLevel=T;var v;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function I(n,t,u){switch(t){case v.Trace:n.trace(u);break;case v.Debug:n.debug(u);break;case v.Info:n.info(u);break;case v.Warning:n.warn(u);break;case v.Error:n.error(u);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=I;function y(n){let t="";for(let u=0;u<n.length;u++){let w=n[u];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}t+=(u>0?" ":"")+w}return t}e.format=y;class f extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=f;class h extends f{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...u){this.f(v.Trace)&&this.g(v.Trace,y([t,...u]))}debug(t,...u){this.f(v.Debug)&&this.g(v.Debug,y([t,...u]))}info(t,...u){this.f(v.Info)&&this.g(v.Info,y([t,...u]))}warn(t,...u){this.f(v.Warning)&&this.g(v.Warning,y([t,...u]))}error(t,...u){if(this.f(v.Error))if(t instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=t.stack,this.g(v.Error,y(w))}else this.g(v.Error,y([t,...u]))}flush(){}}e.AbstractMessageLogger=h;class d extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!D.isWindows}trace(t,...u){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...u):console.log(`[main ${L()}]`,t,...u))}debug(t,...u){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...u):console.log(`[main ${L()}]`,t,...u))}info(t,...u){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${L()}]\x1B[0m`,t,...u):console.log(`[main ${L()}]`,t,...u))}warn(t,...u){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${L()}]\x1B[0m`,t,...u):console.warn(`[main ${L()}]`,t,...u))}error(t,...u){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${L()}]\x1B[0m`,t,...u):console.error(`[main ${L()}]`,t,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class g extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...u){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...u)}debug(t,...u){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...u)}info(t,...u){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...u)}warn(t,...u){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...u)}error(t,...u){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...u)}dispose(){}flush(){}}e.ConsoleLogger=g;class b extends f{constructor(t,u=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(u)}trace(t,...u){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...u])}debug(t,...u){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...u])}info(t,...u){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...u])}warn(t,...u){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...u])}error(t,...u){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...u])}h(t){return typeof t=="string"?t:(0,a.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class C extends f{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const u of this.g)u.setLevel(t);super.setLevel(t)}trace(t,...u){for(const w of this.g)w.trace(t,...u)}debug(t,...u){for(const w of this.g)w.debug(t,...u)}info(t,...u){for(const w of this.g)w.info(t,...u)}warn(t,...u){for(const w of this.g)w.warn(t,...u)}error(t,...u){for(const w of this.g)w.error(t,...u)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=C;class p extends l.Disposable{constructor(t,u){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,u)for(const w of u)this.c.set(w.resource,w)}getLogger(t){return this.b.get(t)}createLogger(t,u){let w=this.b.get(t);const S=u?.logLevel==="always"?v.Trace:u?.logLevel;return w||(w=this.k(t,S??this.getLogLevel(t)??this.j,u),this.b.set(t,w)),this.registerLogger({resource:t,id:u?.id??t.toString(),logLevel:S,name:u?.name,hidden:u?.hidden,extensionId:u?.extensionId}),w}setLogLevel(t,u){if(E.URI.isUri(t)){const w=t,S=u,F=this.c.get(w);F&&S!==F.logLevel&&(F.logLevel=S===this.j?void 0:S,this.b.get(w)?.setLevel(S),this.c.set(F.resource,F),this.g.fire([w,S]))}else{this.j=t;for(const[w,S]of this.b.entries())this.c.get(w)?.logLevel===void 0&&S.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,u){const w=this.c.get(t);w&&u!==!w.hidden&&(w.hidden=!u,this.c.set(w.resource,w),this.h.fire([t,u]))}getLogLevel(t){let u;return t&&(u=this.c.get(t)?.logLevel),u??this.j}registerLogger(t){const u=this.c.get(t.resource);u?u.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const u=this.c.get(t);if(u){this.c.delete(t);const w=this.b.get(t);w&&(this.b.delete(t),w.dispose()),this.f.fire({added:[],removed:[u]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=p;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...u){}debug(t,...u){}info(t,...u){}warn(t,...u){}error(t,...u){}critical(t,...u){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;class s extends p{constructor(){super(v.Info)}k(t,u,w){return new i}}e.NullLoggerService=s;function c(n){if(n.verbose)return v.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function r(n){switch(n){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=r;function m(n){switch(n){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m}),define(ye[204],De([1,0,6,13]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends a.Disposable{constructor(D,P=[]){super(),this.a=new A.MultiplexLogger([D,...P]),this.B(D.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...P){this.a.trace(D,...P)}debug(D,...P){this.a.debug(D,...P)}info(D,...P){this.a.info(D,...P)}warn(D,...P){this.a.warn(D,...P)}error(D,...P){this.a.error(D,...P)}flush(){this.a.flush()}}e.LogService=l}),define(ye[205],De([1,0,44,13]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(l||(l={}));async function R(k,L,T,v,I){try{const y=await new Promise((h,d)=>{ne(["spdlog"],h,d)});y.setFlushOn(l.Trace);const f=await y.createAsyncRotatingLogger(k,L,T,v);return I?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(y){console.error(y)}return null}function D(k,L,T){switch(L){case A.LogLevel.Trace:k.trace(T);break;case A.LogLevel.Debug:k.debug(T);break;case A.LogLevel.Info:k.info(T);break;case A.LogLevel.Warning:k.warn(T);break;case A.LogLevel.Error:k.error(T);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function P(k,L){switch(L){case A.LogLevel.Trace:k.setLevel(l.Trace);break;case A.LogLevel.Debug:k.setLevel(l.Debug);break;case A.LogLevel.Info:k.setLevel(l.Info);break;case A.LogLevel.Warning:k.setLevel(l.Warning);break;case A.LogLevel.Error:k.setLevel(l.Error);break;case A.LogLevel.Off:k.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class E extends A.AbstractMessageLogger{constructor(L,T,v,I,y){super(),this.k=[],this.setLevel(y),this.l=this.n(L,T,v,I),this.B(this.onDidChangeLogLevel(f=>{this.m&&P(this.m,f)}))}async n(L,T,v,I){const y=v?6:1,f=30/y*a.ByteSize.MB,h=await R(L,T,f,y,I);if(h){this.m=h,P(this.m,this.getLevel());for(const{level:d,message:g}of this.k)D(this.m,d,g);this.k=[]}}g(L,T){this.m?D(this.m,L,T):this.getLevel()<=L&&this.k.push({level:L,message:T})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=E}),define(ye[124],De([1,0,37,174,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var D;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(y,f){return f-y}E.compare=k;const L=Object.create(null);L[E.Error]=(0,A.localize)(0,null),L[E.Warning]=(0,A.localize)(1,null),L[E.Info]=(0,A.localize)(2,null);function T(y){return L[y]||""}E.toString=T;function v(y){switch(y){case a.default.Error:return E.Error;case a.default.Warning:return E.Warning;case a.default.Info:return E.Info;case a.default.Ignore:return E.Hint}}E.fromSeverity=v;function I(y){switch(y){case E.Error:return a.default.Error;case E.Warning:return a.default.Warning;case E.Info:return a.default.Info;case E.Hint:return a.default.Ignore}}E.toSeverity=I}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(E){const k="";function L(v){return T(v,!0)}E.makeKey=L;function T(v,I){const y=[k];return v.source?y.push(v.source.replace("\xA6","\\\xA6")):y.push(k),v.code?typeof v.code=="string"?y.push(v.code.replace("\xA6","\\\xA6")):y.push(v.code.value.replace("\xA6","\\\xA6")):y.push(k),v.severity!==void 0&&v.severity!==null?y.push(D.toString(v.severity)):y.push(k),v.message&&I?y.push(v.message.replace("\xA6","\\\xA6")):y.push(k),v.startLineNumber!==void 0&&v.startLineNumber!==null?y.push(v.startLineNumber.toString()):y.push(k),v.startColumn!==void 0&&v.startColumn!==null?y.push(v.startColumn.toString()):y.push(k),v.endLineNumber!==void 0&&v.endLineNumber!==null?y.push(v.endLineNumber.toString()):y.push(k),v.endColumn!==void 0&&v.endColumn!==null?y.push(v.endColumn.toString()):y.push(k),y.push(k),y.join("\xA6")}E.makeKeyOptionalMessage=T})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(ye[206],De([1,0,3,37,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=A.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new E,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=P;class E{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=E}),define(ye[125],De([1,0,8,2,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(k,L){return A.URI.isUri(k)?(0,a.equalsIgnoreCase)(k.scheme,L):(0,a.startsWithIgnoreCase)(k,L+":")}e.matchesScheme=R;function D(k,...L){return L.some(T=>R(k,T))}e.matchesSomeScheme=D;function P(k,L){return k.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=P;function E(k){let L;const T=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(k.fragment);return T&&(L={startLineNumber:parseInt(T[1]),startColumn:T[2]?parseInt(T[2]):1,endLineNumber:T[4]?parseInt(T[4]):void 0,endColumn:T[4]?T[5]?parseInt(T[5]):1:void 0},k=k.with({fragment:""})),{selection:L,uri:k}}e.extractSelection=E}),define(ye[207],De([1,0,12,36]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ye[208],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ne,e){return function(a,A){e(a,A,ne)}};define(ye[126],De([1,0,19,21,6,4]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var D;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(T){this.b=T}report(T){this.a=T,this.b(this.a)}}P.None=Object.freeze({report(){}}),e.Progress=P;let E=class extends l.Disposable{constructor(T,v){super(),this.a=new a.DeferredPromise,v.withProgress(T,I=>(this.b=I,this.c&&I.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(T){this.b?this.b.report(T):this.c=T}};E=qe([We(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends l.Disposable{constructor(T){super(),this.g=T,this.a=0,this.b=this.B(new l.DisposableStore)}start(T){this.stop();const v=++this.a,I=new A.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},T),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>I.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:I.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(T){this.a===T&&this.b.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,9]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(D,P){a.ok(A.isString(D)),a.ok(A.isObject(P)),a.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,P)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new l}),define(ye[91],De([1,0,3,39]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,k){this.a[l(E)]=k,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const D=new R;A.Registry.add(e.Extensions.JSONContribution,D)}),define(ye[127],De([1,0,15,3,9,169,53,91,39]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var k;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(k=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const T=E.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const s=new Set;this.n(i,o,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(i){const o=new Set;this.o(i,o),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const s=new Set;this.o(o,s),this.n(i,!1,s),T.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const s=[];for(const{overrides:c,source:r}of i)for(const m in c)if(o.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const n=this.a.get(m),t=n?.valuesSources??new Map;if(r)for(const F of Object.keys(c[m]))t.set(F,r);const u={...n?.value||{},...c[m]};this.a.set(m,{source:r,value:u,valuesSources:t});const w=(0,D.getLanguageTagSettingPlainKey)(m),S={type:"object",default:u,description:R.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:u,source:l.isString(r)?void 0:r,defaultValueSource:r};s.push(...f(m)),this.d[m]=S,this.b.properties[m]=S}else{this.a.set(m,{value:c[m],source:r});const n=this.d[m];n&&(this.w(m,n),this.r(m,n))}this.m(s)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:s,source:c}of i)for(const r in s){const m=this.a.get(r),n=l.isString(c)?c:c?.id,t=l.isString(m?.source)?m?.source:m?.source?.id;if(n===t)if(o.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const u=this.d[r];u&&(this.w(r,u),this.r(r,u))}}this.u()}deltaConfiguration(i){let o=!1;const s=new Set;i.removedDefaults&&(this.l(i.removedDefaults,s),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,s),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,s),i.addedConfigurations&&this.n(i.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,s){i.forEach(c=>{this.p(c,o,c.extensionInfo,c.restrictedProperties,void 0,s),this.c.push(c),this.q(c)})}o(i,o){const s=c=>{if(c.properties)for(const r in c.properties){o.add(r);const m=this.d[r];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[r],this.s(r,c.properties[r])}c.allOf?.forEach(r=>s(r))};for(const c of i){s(c);const r=this.c.indexOf(c);r!==-1&&this.c.splice(r,1)}}p(i,o=!0,s,c,r=3,m){r=l.isUndefinedOrNull(i.scope)?r:i.scope;const n=i.properties;if(n)for(const u in n){const w=n[u];if(o&&b(u,w)){delete n[u];continue}if(w.source=s,w.defaultDefaultValue=n[u].default,this.w(u,w),e.OVERRIDE_PROPERTY_REGEX.test(u)?w.scope=void 0:(w.scope=l.isUndefinedOrNull(w.scope)?r:w.scope,w.restricted=l.isUndefinedOrNull(w.restricted)?!!c?.includes(u):w.restricted),n[u].hasOwnProperty("included")&&!n[u].included){this.f[u]=n[u],delete n[u];continue}else this.d[u]=n[u],n[u].policy?.name&&this.e.set(n[u].policy.name,u);!n[u].deprecationMessage&&n[u].markdownDeprecationMessage&&(n[u].deprecationMessage=n[u].markdownDeprecationMessage),m.add(u)}const t=i.allOf;if(t)for(const u of t)this.p(u,o,s,c,r,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=s=>{const c=s.properties;if(c)for(const m in c)this.r(m,c[m]);s.allOf?.forEach(o)};o(i)}r(i,o){switch(e.allSettings.properties[i]=o,o.scope){case 1:e.applicationSettings.properties[i]=o;break;case 2:e.machineSettings.properties[i]=o;break;case 6:e.machineOverridableSettings.properties[i]=o;break;case 3:e.windowSettings.properties[i]=o;break;case 4:e.resourceSettings.properties[i]=o;break;case 5:e.resourceSettings.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.allSettings.properties[i],o.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(o,s),e.allSettings.properties[o]=s,e.applicationSettings.properties[o]=s,e.machineSettings.properties[o]=s,e.machineOverridableSettings.properties[o]=s,e.windowSettings.properties[o]=s,e.resourceSettings.properties[o]=s}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,o){const s=this.a.get(i);let c=s?.value,r=s?.source;l.isUndefined(c)&&(c=o.defaultDefaultValue,r=void 0),l.isUndefined(c)&&(c=d(o.type)),o.default=c,o.defaultValueSource=r}}const I="\\[([^\\]]+)\\]",y=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(p){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let o=y.exec(p);for(;o?.length;){const s=o[1].trim();s&&i.push(s),o=y.exec(p)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=f;function h(p){return p.reduce((i,o)=>`${i}[${o}]`,"")}e.keyFromOverrideIdentifiers=h;function d(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new v;E.Registry.add(e.Extensions.Configuration,g);function b(p,i){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?R.localize(7,null,p):g.getConfigurationProperties()[p]!==void 0?R.localize(8,null,p):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,p,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function C(){const p=[],i=g.getConfigurationProperties();for(const o of Object.keys(i))p.push([o,i[o].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=C}),define(ye[209],De([1,0,15,3,146,6,28,23,9,2,53,127,39]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function I(o){return Object.isFrozen(o)?o:P.deepFreeze(o)}class y{constructor(s={},c=[],r=[],m){this.b=s,this.c=c,this.d=r,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(c=>{if(c instanceof y)return c;const r=new f("");return r.parseRaw(c),r.configurationModel});this.f=s.reduce((c,r)=>r===c?r:c.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,c){const r=this.rawConfiguration.getValue(s),m=c?this.rawConfiguration.getOverrideValue(s,c):void 0,n=c?this.rawConfiguration.override(c).getValue(s):r;return{value:r,override:m,merged:n}}getOverrideValue(s,c){const r=this.i(c);return r?s?(0,L.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const c=[];for(const r of this.overrides)r.identifiers.includes(s)&&c.push(...r.keys);return a.distinct(c)}getAllOverrideIdentifiers(){const s=[];for(const c of this.overrides)s.push(...c.identifiers);return a.distinct(s)}override(s){let c=this.a.get(s);return c||(c=this.g(s),this.a.set(s,c)),c}merge(...s){const c=P.deepClone(this.contents),r=P.deepClone(this.overrides),m=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of s)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(c,t.contents);for(const u of t.overrides){const[w]=r.filter(S=>a.equals(S.identifiers,u.identifiers));w?(this.h(w.contents,u.contents),w.keys.push(...u.keys),w.keys=a.distinct(w.keys)):r.push(P.deepClone(u))}for(const u of t.keys)m.indexOf(u)===-1&&m.push(u)}return new y(c,m,r,n.every(t=>t instanceof y)?void 0:n)}g(s){const c=this.i(s);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const r={};for(const m of a.distinct([...Object.keys(this.contents),...Object.keys(c)])){let n=this.contents[m];const t=c[m];t&&(typeof n=="object"&&typeof t=="object"?(n=P.deepClone(n),this.h(n,t)):n=t),r[m]=n}return new y(r,this.keys,this.overrides)}h(s,c){for(const r of Object.keys(c)){if(r in s&&E.isObject(s[r])&&E.isObject(c[r])){this.h(s[r],c[r]);continue}s[r]=P.deepClone(c[r])}}i(s){let c=null,r=null;const m=n=>{n&&(r?this.h(r,n):r=P.deepClone(n))};for(const n of this.overrides)a.equals(n.identifiers,[s])?c=n.contents:n.identifiers.includes(s)&&m(n.contents);return m(c),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,c){this.j(s,c,!0)}setValue(s,c){this.j(s,c,!1)}removeValue(s){const c=this.keys.indexOf(s);c!==-1&&(this.keys.splice(c,1),(0,L.removeFromValueTree)(this.contents,s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>a.equals(r.identifiers,(0,T.overrideIdentifiersFromKey)(s))),1))}j(s,c,r){(0,L.addToValueTree)(this.contents,s,c,m=>console.error(m)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),T.OVERRIDE_PROPERTY_REGEX.test(s)&&this.overrides.push({identifiers:(0,T.overrideIdentifiersFromKey)(s),keys:Object.keys(this.contents[s]),contents:(0,L.toValuesTree)(this.contents[s],m=>console.error(m))})}}e.ConfigurationModel=y;class f{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,c){if(!E.isUndefinedOrNull(s)){const r=this.g(s);this.parseRaw(r,c)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,c){this.a=s;const{contents:r,keys:m,overrides:n,restricted:t,hasExcludedProperties:u}=this.h(s,c);this.b=new y(r,m,n,u?[s]:void 0),this.c=t||[]}g(s){let c={},r=null,m=[];const n=[],t=[];function u(S){Array.isArray(m)?m.push(S):r!==null&&(m[r]=S)}const w={onObjectBegin:()=>{const S={};u(S),n.push(m),m=S,r=null},onObjectProperty:S=>{r=S},onObjectEnd:()=>{m=n.pop()},onArrayBegin:()=>{const S=[];u(S),n.push(m),m=S,r=null},onArrayEnd:()=>{m=n.pop()},onLiteralValue:u,onError:(S,F,x)=>{t.push({error:S,offset:F,length:x})}};if(s)try{l.visit(s,w),c=m[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return c}h(s,c){const r=v.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),m=this.i(s,r,!0,c);s=m.raw;const n=(0,L.toValuesTree)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),t=Object.keys(s),u=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:n,keys:t,overrides:u,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(s,c,r,m){let n=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:n};const t={},u=[];for(const w in s)if(T.OVERRIDE_PROPERTY_REGEX.test(w)&&r){const S=this.i(s[w],c,!1,m);t[w]=S.raw,n=n||S.hasExcludedProperties,u.push(...S.restricted)}else{const S=c[w],F=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&u.push(w),(F===void 0||m.scopes===void 0||m.scopes.includes(F))&&!(m.skipRestricted&&S?.restricted)?t[w]=s[w]:n=!0}return{raw:t,restricted:u,hasExcludedProperties:n}}j(s,c){const r=[];for(const m of Object.keys(s))if(T.OVERRIDE_PROPERTY_REGEX.test(m)){const n={};for(const t in s[m])n[t]=s[m][t];r.push({identifiers:(0,T.overrideIdentifiersFromKey)(m),keys:Object.keys(n),contents:(0,L.toValuesTree)(n,c)})}return r}}e.ConfigurationModelParser=f;class h extends R.Disposable{constructor(s,c,r,m){super(),this.f=s,this.g=c,this.h=m,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&r.isEqual(n.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=h;class d{constructor(s,c,r,m,n,t,u,w,S,F,x,V,M){this.a=s,this.b=c,this.c=r,this.overrideIdentifiers=m,this.d=n,this.f=t,this.g=u,this.h=w,this.i=S,this.j=F,this.k=x,this.l=V,this.m=M}get value(){return I(this.c)}n(s,c,r){const m=s.inspect(c,r);return{get value(){return I(m.value)},get override(){return I(m.override)},get merged(){return I(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(s,c,r,m,n=new y,t=new y,u=new D.ResourceMap,w=new y,S=new D.ResourceMap){this.c=s,this.d=c,this.f=r,this.g=m,this.h=n,this.i=t,this.j=u,this.l=w,this.m=S,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(s,c,r){return this.q(s,c,r).getValue(s)}updateValue(s,c,r={}){let m;r.resource?(m=this.m.get(r.resource),m||(m=new y,this.m.set(r.resource,m))):m=this.l,c===void 0?m.removeValue(s):m.setValue(s,c),r.resource||(this.a=null)}inspect(s,c,r){const m=this.q(s,c,r),n=this.u(c.resource,r),t=c.resource?this.m.get(c.resource)||this.l:this.l,u=new Set;for(const w of m.overrides)for(const S of w.identifiers)m.getOverrideValue(s,S)!==void 0&&u.add(S);return new d(s,c,m.getValue(s),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,n||void 0,t)}keys(s){const c=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,c){this.j.set(s,c),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,c){const r=[];if(!c){const{added:m,updated:n,removed:t}=p(this.c,s);c=[...m,...n,...t]}for(const m of c)for(const n of(0,T.overrideIdentifiersFromKey)(m)){const t=this.c.getKeysForOverrideIdentifier(n),u=s.getKeysForOverrideIdentifier(n),w=[...u.filter(S=>t.indexOf(S)===-1),...t.filter(S=>u.indexOf(S)===-1),...t.filter(S=>!P.equals(this.c.override(n).getValue(S),s.override(n).getValue(S)))];r.push([n,w])}return this.updateDefaultConfiguration(s),{keys:c,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:c,updated:r,removed:m}=p(this.d,s),n=[...c,...r,...m];return n.length&&this.updatePolicyConfiguration(s),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:c,updated:r,removed:m,overrides:n}=p(this.applicationConfiguration,s),t=[...c,...r,...m];return t.length&&this.updateApplicationConfiguration(s),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(s){const{added:c,updated:r,removed:m,overrides:n}=p(this.localUserConfiguration,s),t=[...c,...r,...m];return t.length&&this.updateLocalUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(s){const{added:c,updated:r,removed:m,overrides:n}=p(this.remoteUserConfiguration,s),t=[...c,...r,...m];return t.length&&this.updateRemoteUserConfiguration(s),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(s){const{added:c,updated:r,removed:m,overrides:n}=p(this.workspaceConfiguration,s),t=[...c,...r,...m];return t.length&&this.updateWorkspaceConfiguration(s),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(s,c){const r=this.p.get(s),{added:m,updated:n,removed:t,overrides:u}=p(r,c),w=[...m,...n,...t];return(w.length||!r)&&this.updateFolderConfiguration(s,c),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(s){const c=this.p.get(s);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:m,removed:n,overrides:t}=p(c,void 0);return{keys:[...r,...m,...n],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,c,r){let m=this.r(c,r);return c.overrideIdentifier&&(m=m.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(m=m.merge(this.d)),m}r({resource:s},c){let r=this.s();if(c&&s){const m=c.getFolder(s);m&&(r=this.t(m.uri)||r);const n=this.m.get(s);n&&(r=r.merge(n))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let c=this.b.get(s);if(!c){const r=this.s(),m=this.j.get(s);m?(c=r.merge(m),this.b.set(s,c)):c=r}return c}u(s,c){if(c&&s){const r=c.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,c)=>{const{contents:r,overrides:m,keys:n}=this.j.get(c);return s.push([c,{contents:r,overrides:m,keys:n}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(c=>s.add(c)),this.userConfiguration.keys.forEach(c=>s.add(c)),this.i.keys.forEach(c=>s.add(c)),this.j.forEach(c=>c.keys.forEach(r=>s.add(r))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>s.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}w(s){const c=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>c.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(m=>c.add(m))),[...c.values()]}static parse(s){const c=this.x(s.defaults),r=this.x(s.policy),m=this.x(s.application),n=this.x(s.user),t=this.x(s.workspace),u=s.folders.reduce((w,S)=>(w.set(k.URI.revive(S[0]),this.x(S[1])),w),new D.ResourceMap);return new g(c,r,m,n,new y,t,u,new y,new D.ResourceMap)}static x(s){return new y(s.contents,s.keys,s.overrides)}}e.Configuration=g;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,c=new Map;for(const m of o)m.keys.forEach(n=>s.add(n)),m.overrides.forEach(([n,t])=>{const u=(0,D.getOrSet)(c,n,new Set);t.forEach(w=>u.add(w))});const r=[];return c.forEach((m,n)=>r.push([n,[...m.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=b;class C{constructor(s,c,r,m){this.change=s,this.f=c,this.g=r,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of s.keys)this.affectedKeys.add(n);for(const[,n]of s.overrides)for(const t of n)this.affectedKeys.add(t);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(s,c){const r=this.a+s,m=this.d.indexOf(r);if(m<0)return!1;const n=m+r.length;if(n>=this.d.length)return!1;const t=this.d.charCodeAt(n);if(t!==this.b&&t!==this.c)return!1;if(c){const u=this.previousConfiguration?this.previousConfiguration.getValue(s,c,this.f?.workspace):void 0,w=this.g.getValue(s,c,this.h);return!P.equals(u,w)}return!0}}e.ConfigurationChangeEvent=C;function p(o,s){const{added:c,removed:r,updated:m}=i(s?.rawConfiguration,o?.rawConfiguration),n=[],t=o?.getAllOverrideIdentifiers()||[],u=s?.getAllOverrideIdentifiers()||[];if(s){const w=u.filter(S=>!t.includes(S));for(const S of w)n.push([S,s.getKeysForOverrideIdentifier(S)])}if(o){const w=t.filter(S=>!u.includes(S));for(const S of w)n.push([S,o.getKeysForOverrideIdentifier(S)])}if(s&&o){for(const w of t)if(u.includes(w)){const S=i({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});n.push([w,[...S.added,...S.removed,...S.updated]])}}return{added:c,removed:r,updated:m,overrides:n}}function i(o,s){const c=o?s?o.keys.filter(n=>s.keys.indexOf(n)===-1):[...o.keys]:[],r=s?o?s.keys.filter(n=>o.keys.indexOf(n)===-1):[...s.keys]:[],m=[];if(o&&s){for(const n of s.keys)if(o.keys.indexOf(n)!==-1){const t=(0,L.getConfigurationValue)(s.contents,n),u=(0,L.getConfigurationValue)(o.contents,n);P.equals(t,u)||m.push(n)}}return{added:c,removed:r,updated:m}}}),define(ye[128],De([1,0,11,4]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(E){return E instanceof R&&E._code===l.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof R&&E._code===l.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof R&&E._code===l.NoResolverFound}static isHandled(E){return E instanceof R&&E.isHandled}constructor(E,k=l.Unknown,L){super(E),this._message=E,this._code=k,this._detail=L,this.isHandled=k===l.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function D(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.getRemoteAuthorityPrefix=D}),define(ye[72],De([1,0,16]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(k){return k.scheme===a.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=A;function l(k){if(!k)return;const L=k.indexOf("+");return L<0?k:k.substr(0,L)}e.getRemoteName=l;function R(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.getRemoteServerRootPath=R;function D(k){const{host:L,port:T}=E(k);if(typeof T>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:T}}e.parseAuthorityWithPort=D;function P(k,L){let{host:T,port:v}=E(k);return typeof v>"u"&&(v=L),{host:T,port:v}}e.parseAuthorityWithOptionalPort=P;function E(k){const L=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const T=k.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const v=k.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:k,port:void 0}}}),define(ye[26],De([1,0,8,4,72]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(I){if(typeof I=="object"&&I!==null&&I.supported!==!0)return I.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(I){I[I.System=0]="System",I[I.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var P;(function(I){I.WIN32_X64="win32-x64",I.WIN32_IA32="win32-ia32",I.WIN32_ARM64="win32-arm64",I.LINUX_X64="linux-x64",I.LINUX_ARM64="linux-arm64",I.LINUX_ARMHF="linux-armhf",I.ALPINE_X64="alpine-x64",I.ALPINE_ARM64="alpine-arm64",I.DARWIN_X64="darwin-x64",I.DARWIN_ARM64="darwin-arm64",I.WEB="web",I.UNIVERSAL="universal",I.UNKNOWN="unknown",I.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class E{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const h=typeof y=="string"?y:y.value,d=typeof f=="string"?f:f.value;return a.equalsIgnoreCase(h,d)}return y.c===f.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=E;function k(I){return L(I)}e.isApplicationScopedExtension=k;function L(I){return I.contributes&&I.contributes.localizations?I.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function T(I){return I.contributes&&I.contributes.authentication?I.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function v(I,y){if(y){const f=`onResolveRemoteAuthority:${(0,l.getRemoteName)(y)}`;return I.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[210],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((l,R)=>ne(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.c(),D=new R.validator;if(D){const P=String(a.a++);return this.b.set(P,D),{id:P,data:D.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const D=this.b.get(l.id);if(!D)return!1;this.b.delete(l.id);try{return D.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.c(),D=new R.signer;if(D)return D.sign(l)}catch{}return l}}a.a=1,e.SignService=a}),define(ye[211],De([1,0,12,36,2,30]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(k){if(a.platform===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}async function P(k,L,T,v,I,y,f,h,d,g){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=I,b.version=y,b["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,a.PlatformToString)(a.platform),b["common.nodePlatform"]=A.platform,b["common.nodeArch"]=v,b["common.product"]=g||"desktop",h&&(b["common.msftInternal"]=h);let C=0;const p=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),a.isLinuxSnap&&(b["common.snap"]="true");const i=D(T);i&&(b["common.platformDetail"]=i);try{const o=await k.readFile(l.URI.file(d));b["common.source"]=o.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=P;function E(k){const L=A.env.USERDNSDOMAIN;if(!L)return!1;const T=L.toLowerCase();return k.some(v=>T===v)}e.verifyMicrosoftInternalDomain=E}),define(ye[212],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[73],De([1,0,23,9,3,53,72,211,212]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class k{constructor(n){this.value=n}}e.TelemetryTrustedValue=k;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,t){return Promise.resolve(void 0)}publicLog2(n,t){return this.publicLog(n,t)}publicLogError(n,t){return Promise.resolve(void 0)}publicLogError2(n,t){return this.publicLogError(n,t)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class T{async publicLog(n,t,u){}async publicLogError(n,t,u){}}e.NullEndpointTelemetryService=T,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(m,n){return l.Event.debounce(n.onDidChangeConfiguration,(u,w)=>{const S=u?new Set([...u.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:S}},1e3,!0)(u=>{u.source!==7&&m.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(u.source),configurationKeys:C(u.affectedKeys)})})}e.configurationTelemetry=v;function I(m,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!m.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=I;function y(m,n){return!(n.isBuilt||n.disableTelemetry||m.enableTelemetry&&m.aiConfig?.ariaKey)}e.isLoggingOnly=y;function f(m){const n=m.getValue(E.TELEMETRY_SETTING_ID),t=m.getValue(E.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(m.getValue(E.TELEMETRY_OLD_SETTING_ID)===!1||t===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function h(m){const n={},t={},u={};b(m,u);for(let w in u){w=w.length>150?w.substr(w.length-149):w;const S=u[w];typeof S=="number"?t[w]=S:typeof S=="boolean"?t[w]=S?1:0:typeof S=="string"?(S.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${S.length}`),n[w]=S.substring(0,8191)):typeof S<"u"&&S!==null&&(n[w]=S)}return{properties:n,measurements:t}}e.validateTelemetryData=h;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(m){if(!m)return"none";const n=(0,D.getRemoteName)(m);return d.has(n)?n:"other"}e.cleanRemoteAuthority=g;function b(m,n,t=0,u){if(!!m)for(const w of Object.getOwnPropertyNames(m)){const S=m[w],F=u?u+w:w;Array.isArray(S)?n[F]=(0,a.safeStringify)(S):S instanceof Date?n[F]=S.toISOString():(0,A.isObject)(S)?t<2?b(S,n,t+1,F+"."):n[F]=(0,a.safeStringify)(S):n[F]=S}}function C(m){if(!m)return[];const n=[];return p(n,"",m),n}function p(m,n,t){t&&typeof t=="object"&&!Array.isArray(t)?Object.keys(t).forEach(u=>p(m,n?`${n}.${u}`:u,t[u])):m.push(n)}function i(m,n){const t=m.msftInternalDomains||[],u=n.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(t)||u}e.isInternalTelemetry=i;function o(m){return[m.appRoot,m.extensionsPath,m.userHome.fsPath,m.tmpDir.fsPath,m.userDataPath]}e.getPiiPathsFromEnvironment=o;function s(m,n){if(!m||!m.includes("/")&&!m.includes("\\"))return m;let t=m;const u=[];for(const x of n)for(;;){const V=x.exec(m);if(!V)break;u.push([V.index,x.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let F=0;for(t="";;){const x=S.exec(m);if(!x)break;const V=u.some(([M,B])=>x.index<B&&M<S.lastIndex);!w.test(x[0])&&!V&&(t+=m.substring(F,x.index)+"<REDACTED: user-file-path>",F=S.lastIndex)}return F<m.length&&(t+=m.substr(F)),t}function c(m){if(!m)return m;const n=m.toLowerCase(),t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of t)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return m}function r(m,n){return(0,a.cloneAndChange)(m,t=>{if(t instanceof k)return t.value;if(typeof t=="string"){let u=t.replaceAll("%20"," ");u=s(u,n);for(const w of n)u=u.replace(w,"");return u=c(u),u}})}e.cleanData=r}),define(ye[213],De([1,0,8,123,26,12,2,11,36,73]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(s,c){return s.uuid&&c.uuid?s.uuid===c.uuid:s.id===c.id?!0:(0,a.compareIgnoreCase)(s.id,c.id)===0}e.areSameExtensions=L;const T=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(c){const r=c.manifest?c.manifest.version:c.version,m=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new v(c.identifier,r,m)}static parse(c){const r=T.exec(c);return r&&r[1]&&r[2]?new v({id:r[1]},r[2],r[4]||void 0):null}constructor(c,r,m="undefined"){this.version=r,this.targetPlatform=m,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof v?L(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.ExtensionKey=v;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(s){const c=I.exec(s);return c&&c[1]?[h(c[1]),c[2]]:[h(s),void 0]}e.getIdAndVersion=y;function f(s,c){return`${s}.${c}`}e.getExtensionId=f;function h(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function d(s,c){return h(f(s,c))}e.getGalleryExtensionId=d;function g(s,c){const r=[],m=n=>{for(const t of r)if(t.some(u=>L(c(u),c(n))))return t;return null};for(const n of s){const t=m(n);t?t.push(n):r.push([n])}return r}e.groupByExtension=g;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function C(s){return{id:new k.TelemetryTrustedValue(s.identifier.id),name:new k.TelemetryTrustedValue(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function p(s,c){const r=[],m=c.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const n=m.shift();if(n&&r.every(t=>!L(t.identifier,{id:n}))){const t=s.filter(u=>L(u.identifier,{id:n}));t.length===1&&(r.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=p;async function i(s,c){if(!R.isLinux)return!1;let r;try{r=(await s.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){c.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(n))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,c){const r=await i(s,c),m=(0,A.getTargetPlatform)(r?"alpine":R.platform,E.arch);return c.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=o}),define(ye[214],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=a;function A(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=A;function l(D){return Array.from(D.entries()).map(P=>[P[0],a(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function R(D){return new Map(D.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[215],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,D=5){const P=R(E=>{const k=typeof E=="string"?E:E.data;let L=this.a.get(l);if(L){L.data.push(k);return}const T=setTimeout(()=>this.flushBuffer(l),D);L={data:[k],timeoutId:T,dispose:()=>{clearTimeout(T),this.flushBuffer(l),P.dispose()}},this.a.set(l,L)});return P}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[216],De([1,0,19,67,51,3,9,2,175,91,39]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var T;(function(C){function p(i,o){let s=i.defaults;for(;l.ThemeIcon.isThemeIcon(s);){const c=y.getIcon(s.id);if(!c)return;s=c.defaults}return s}C.getDefinition=p})(T=e.IconContribution||(e.IconContribution={}));var v;(function(C){function p(o){return{weight:o.weight,style:o.style,src:o.src.map(s=>({format:s.format,location:s.location.toString()}))}}C.toJSONObject=p;function i(o){const s=c=>(0,D.isString)(c)?c:void 0;if(o&&Array.isArray(o.src)&&o.src.every(c=>(0,D.isString)(c.format)&&(0,D.isString)(c.location)))return{weight:s(o.weight),style:s(o.style),src:o.src.map(c=>({format:c.format,location:P.URI.parse(c.location)}))}}C.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class I{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(p,i,o,s){const c=this.b[p];if(c){if(o&&!c.description){c.description=o,this.d.properties[p].markdownDescription=`${o} $(${p})`;const n=this.e.enum.indexOf(p);n!==-1&&(this.e.enumDescriptions[n]=o),this.a.fire()}return c}const r={id:p,description:o,defaults:i,deprecationMessage:s};this.b[p]=r;const m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),o&&(m.markdownDescription=`${o}: $(${p})`),this.d.properties[p]=m,this.e.enum.push(p),this.e.enumDescriptions.push(o||""),this.a.fire(),{id:p}}deregisterIcon(p){delete this.b[p],delete this.d.properties[p];const i=this.e.enum.indexOf(p);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(p=>this.b[p])}getIcon(p){return this.b[p]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(p,i){const o=this.f[p];return o||(this.f[p]=i,this.a.fire(),i)}deregisterIconFont(p){delete this.f[p]}getIconFont(p){return this.f[p]}toString(){const p=(c,r)=>c.id.localeCompare(r.id),i=c=>{for(;l.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(c=>this.b[c]);for(const c of s.filter(r=>!!r.description).sort(p))o.push(`|<i class="${i(c)}"></i>|${c.id}|${l.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const c of s.filter(r=>!l.ThemeIcon.isThemeIcon(r.defaults)).sort(p))o.push(`|<i class="${i(c)}"></i>|${c.id}|`);return o.join(`
`)}}const y=new I;L.Registry.add(e.Extensions.IconContribution,y);function f(C,p,i,o){return y.registerIcon(C,p,i,o)}e.registerIcon=f;function h(){return y}e.getIconRegistry=h;function d(){const C=(0,A.getCodiconFontCharacters)();for(const p in C){const i="\\"+C[p].toString(16);y.registerIcon(p,{fontCharacter:i})}}d(),e.iconsSchemaId="vscode://schemas/icons";const g=L.Registry.as(k.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,y.getIconSchema());const b=new a.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);y.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",A.Codicon.close,(0,E.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",A.Codicon.arrowUp,(0,E.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",A.Codicon.arrowDown,(0,E.localize)(4,null)),e.syncing=l.ThemeIcon.modify(A.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(A.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,53,4,13]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var D;(function(f){f.Http="http",f.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function k(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=k,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function T(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=T;function v(f,h,d,g){if(d===1)return!1;if(d===2&&T(h)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class I{constructor(h,d,g){this.remoteAddress=h,this.localAddress=d,this.b=g,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=I;let y=class{constructor(h,d){this.i=h,this.j=d,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const h=this.j.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.e=h,h?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.f=h.elevation,this.g=h.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const h=[],d=Array.from(this.d.values());for(const g of d){const b=Array.from(g.values());for(const C of b){const p=await C.value;p&&h.push(p)}}return h}async dispose(){for(const h of this.d.values()){for(const{value:d}of h.values())await d.then(g=>g?.dispose());h.clear()}this.d.clear()}setEnvironmentTunnel(h,d,g,b,C){this.o(h,d,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:d,localAddress:g,privacy:b,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,d){(T(h)||L(h))&&(h=e.LOCALHOST_ADDRESSES[0]);const g=this.q(h,d);if(g)return++g.refcount,g.value}openTunnel(h,d,g,b,C,p=!1,i,o){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${C}.`),!h)return;if(d||(d="localhost"),b||(b=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(h,d,g,b,C,p,i,o);return s?s.then(c=>{if(!c){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.m(c);return(c.tunnelRemoteHost!==d||c.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(r),r}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const d=this.d.get(h.tunnelRemoteHost);if(d){const g=d.get(h.tunnelRemotePort);g&&(g.refcount--,await this.n(h.tunnelRemoteHost,h.tunnelRemotePort,g))}}}}async n(h,d,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${d}.`);const b=g.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(h)&&this.d.get(h).delete(d),b}}async closeTunnel(h,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${d} `);const g=this.d.get(h);if(g&&g.has(d)){const b=g.get(d);b.refcount=0,await this.n(h,d,b)}}o(h,d,g){this.d.has(h)||this.d.set(h,new Map),this.d.get(h).set(d,{refcount:1,value:g})}async p(h,d){const g=this.d.get(h);g&&(await g.get(d)||g.delete(d),g.size===0&&this.d.delete(h))}q(h,d){const g=[h];L(h)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):T(h)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const b=g.map(C=>this.d.get(C));for(const C of b){const p=C?.get(d);if(p)return p}}canTunnel(h){return!!k(h)}s(h,d,g,b,C,p,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${b}.`);const o=g;this.h.add(o);const s=b===void 0?g:b,c={elevationRequired:C?this.isPortPrivileged(s):!1},r={remoteAddress:{host:d,port:g},localAddressPort:b,privacy:p,public:p?p!==P.Private:void 0,protocol:i},m=h.forwardPort(r,c);return m?(this.o(d,g,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(o)})):this.h.delete(o),m}};y=qe([We(0,R.ILogService),We(1,A.IConfigurationService)],y),e.AbstractTunnelService=y}),define(ye[217],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var A;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(A=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[218],De([1,0,16]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function A(E){return E.scheme!==a.Schemas.file&&E.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=A;function l(E){if(E.folders.length)return E.folders.every(k=>A(k.uri))?E.folders[0].uri:void 0;if(E.configuration&&A(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=l;function R(E){return l(E)?.scheme}e.getVirtualWorkspaceScheme=R;function D(E){return l(E)?.authority}e.getVirtualWorkspaceAuthority=D;function P(E){return l(E)!==void 0}e.isVirtualWorkspace=P}),define(ye[47],De([1,0,176,10,68,24,2,4,16]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function k(s){const c=s;return typeof c?.id=="string"&&D.URI.isUri(c.uri)}e.isSingleFolderWorkspaceIdentifier=k;function L(s){return typeof s?.id=="string"&&!k(s)&&!v(s)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function T(s,c){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.basename)(s)}:c?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=T;function v(s){const c=s;return typeof c?.id=="string"&&D.URI.isUri(c.configPath)}e.isWorkspaceIdentifier=v;function I(s){const c=s;if(c?.uri)return{id:c.id,uri:D.URI.revive(c.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=I;var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function f(s){const c=s;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.isWorkspace=f;function h(s){const c=s;return!!(c&&typeof c=="object"&&D.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(c,r,m,n,t){this.h=c,this.j=m,this.k=n,this.l=t,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class g{constructor(c,r){this.raw=r,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,R.joinPath)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function b(s){return new g({uri:s,index:0,name:(0,R.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(s,c){return R.extUriBiasedIgnorePathCase.isEqualOrParent(s,c.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function p(s){let c;return D.URI.isUri(s)?c=s:c=s.configuration,c?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=p;function i(s,c){return!C(s,c)&&!p(s)}e.isSavedWorkspace=i;function o(s){return(typeof s=="string"?(0,A.extname)(s):(0,R.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=o}),define(ye[74],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(ye[48],De([1,0,16,24,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new A.ExtUri(P=>{const E=this.b.get(P.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(P,E){E===null?this.b.delete(P.scheme):this.b.set(P.scheme,E)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[219],De([1,0,13,204,25]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends A.LogService{constructor(P,E){super(P.createLogger(E.logFile,{name:E.logName}))}};R=qe([We(0,a.ILoggerService),We(1,l.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[220],De([1,0,19]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class A{constructor(D,P,E){this.h=new Map,this.a=D,this.b=P,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new a.RunOnceScheduler(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of k.values())L.complete()}catch(L){for(const T of k.values())T.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this.d}get(D,P){let E=this.f[D];return typeof E>"u"&&(E=P),E}update(D,P){this.f[D]=P;const E=this.h.get(D);if(E!==void 0)return E.p;const k=new a.DeferredPromise;return this.h.set(D,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.ExtensionMemento=A;class l extends A{setKeysForSync(D){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},D)}constructor(D,P){super(D.identifier.value,!0,P),this.j=D}}e.ExtensionGlobalMemento=l}),define(ye[221],De([1,0,3,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(D){this.c=D,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(D,P,E,k){const T=this.c.getNotebookDocument(A.URI.revive(D)).acceptModelChanged(P.value,E,k);this.b.fire(T)}$acceptDirtyStateChanged(D,P){this.c.getNotebookDocument(A.URI.revive(D)).acceptDirty(P)}$acceptModelSaved(D){const P=this.c.getNotebookDocument(A.URI.revive(D));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(ye[20],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class A{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=A});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[222],De([1,0,26,3]),function(ne,e,a,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(P,E){l.set(this,void 0),this.b=new A.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(P.identifier),_e(this,l,E,"f"),Be(this,l,"f").onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(P){return Be(this,l,"f").get(this.a,P)}store(P,E){return Be(this,l,"f").store(this.a,P,E)}delete(P){return Be(this,l,"f").delete(this.a,P)}}e.ExtensionSecrets=R,l=new WeakMap}),define(ye[55],De([1,0,4,129,3,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(E){function k(T){return{remoteAddress:T.remoteAddress,localAddress:T.localAddress,public:!!T.public,privacy:T.privacy??(T.public?A.TunnelPrivacyId.Public:A.TunnelPrivacyId.Private),protocol:T.protocol}}E.fromApiTunnel=k;function L(T){return{remoteAddress:{host:T.tunnelRemoteHost,port:T.tunnelRemotePort},localAddress:T.localAddress,public:T.privacy!==A.TunnelPrivacyId.ConstantPrivate&&T.privacy!==A.TunnelPrivacyId.ConstantPrivate,privacy:T.privacy,protocol:T.protocol}}E.fromServiceTunnel=L})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let P=class{constructor(k){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(k){return k}async openTunnel(k,L){}async getTunnels(){return[]}async setTunnelFactory(k){return{dispose:()=>{}}}registerPortsAttributesProvider(k,L){return{dispose:()=>{}}}async $providePortAttributes(k,L,T,v,I){return[]}async $forwardPort(k,L){}async $closeTunnel(k){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=qe([We(0,R.IExtHostRpcService)],P),e.ExtHostTunnelService=P}),define(ye[56],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class A{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=A}),define(ye[223],De([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class A{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function l(P,E){if(E.serializeBuffersForPostMessage){const k=new A,L=(I,y)=>{if(y instanceof ArrayBuffer){const f=k.add(y);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(y)){const f=R(y);if(f){const h=k.add(y.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:f,byteLength:y.byteLength,byteOffset:y.byteOffset}}}}return y},T=JSON.stringify(P,L),v=k.buffers.map(I=>{const y=new Uint8Array(I);return a.VSBuffer.wrap(y)});return{message:T,buffers:v}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function R(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(P,E){const k=E.map(v=>{const I=new ArrayBuffer(v.byteLength);return new Uint8Array(I).set(v.buffer),I}),L=E.length?(v,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const y=I,{index:f}=y,h=k[f];if(y.view)switch(y.view.type){case 1:return new Int8Array(h,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return I}:void 0;return{message:JSON.parse(P,L),arrayBuffers:k}}e.deserializeWebviewMessage=D}),define(ye[224],De([1,0,114]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(R){return{transformIncoming:D=>D.scheme==="vscode-remote"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="file"?{scheme:"vscode-local",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoing:D=>D.scheme==="file"?{scheme:"vscode-remote",authority:R,path:D.path,query:D.query,fragment:D.fragment}:D.scheme==="vscode-local"?{scheme:"file",path:D.path,query:D.query,fragment:D.fragment}:D,transformOutgoingScheme:D=>D==="file"?"vscode-remote":D==="vscode-local"?"file":D}}function l(R){return new a.URITransformer(A(R))}e.createURITransformer=l}),define(ye[130],De([1,0,187,9,2,6,4,39,44,16,45,161,37]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var I;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(I=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var y;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(y=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const _=X;return!!_&&typeof _.getSelection=="function"&&!!_.onDidChangeSelection}e.isEditorPaneWithSelection=f;function h(X,_,ie){for(const pe of ie.visibleEditorPanes)if(pe.group.id===_&&X.matches(pe.input))return pe.getViewState()}e.findViewStateForEditor=h;function d(X){if(t(X))return!1;const _=X;return l.URI.isUri(_?.resource)}e.isResourceEditorInput=d;function g(X){if(t(X))return!1;const _=X;return _?.original!==void 0&&_.modified!==void 0}e.isResourceDiffEditorInput=g;function b(X){if(t(X)||g(X))return!1;const _=X;return _?.primary!==void 0&&_.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function C(X){if(t(X))return!1;const _=X;return _?_.resource===void 0||_.resource.scheme===k.Schemas.untitled||_.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;const p=/Untitled-\d+/;function i(X){return X.scheme===k.Schemas.untitled&&X.path.length>1&&!p.test(X.path)}e.isUntitledWithAssociatedResource=i;function o(X){if(t(X))return!1;const _=X;return l.URI.isUri(_?.base?.resource)&&l.URI.isUri(_?.input1?.resource)&&l.URI.isUri(_?.input2?.resource)&&l.URI.isUri(_?.result?.resource)}e.isResourceMergeEditorInput=o;var s;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(s=e.Verbosity||(e.Verbosity={}));var c;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));class r{constructor(){this.a=new Map}registerSource(_,ie){let pe=this.a.get(_);return pe||(pe={source:_,label:ie},this.a.set(_,pe)),pe.source}getSourceLabel(_){return this.a.get(_)?.label??_}}e.SaveSourceRegistry=new r;var m;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function t(X){return X instanceof n}e.isEditorInput=t;function u(X){const _=X;return l.URI.isUri(_?.preferredResource)}function w(X){const _=X;return t(_?.primary)&&t(_?.secondary)}e.isSideBySideEditorInput=w;function S(X){const _=X;return t(_?.modified)&&t(_?.original)}e.isDiffEditorInput=S;function F(X,_,ie,pe,ve){return te(pe,[(0,T.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const ke={...ie,limits:{size:Number.MAX_VALUE}};X.openEditor(_,ke)}}),(0,T.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=F;function x(X){return t(X?.editor)}e.isEditorInputWithOptions=x;function V(X){const _=X;return x(X)&&_?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function M(X){const _=X;return typeof _?.groupId=="number"&&t(_.editor)}e.isEditorIdentifier=M;var B;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var O;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(O=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var U;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(U=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(_,ie){if(!_)return;if(o(_))return e.EditorResourceAccessor.getOriginalUri(_.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(_);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getOriginalUri(ve,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:ie.filterByScheme});_=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(g(_)||b(_)||o(_))return;const pe=u(_)?_.preferredResource:_.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}a(_){return w(_)||b(_)?{primary:_.primary,secondary:_.secondary}:S(_)||g(_)?{primary:_.modified,secondary:_.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(_,ie){if(!_)return;if(o(_))return e.EditorResourceAccessor.getCanonicalUri(_.result,ie);if(ie?.supportSideBySide){const{primary:ve,secondary:ke}=this.a(_);if(ve&&ke){if(ie?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===U.ANY)return this.getCanonicalUri(ve,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:ie.filterByScheme});_=ie.supportSideBySide===U.PRIMARY?ve:ke}}if(g(_)||b(_)||o(_))return;const pe=_.resource;return!pe||!ie||!ie.filterByScheme?pe:this.b(pe,ie.filterByScheme)}b(_,ie){if(Array.isArray(ie)){if(ie.some(pe=>_.scheme===pe))return _}else if(ie===_.scheme)return _}}e.EditorResourceAccessor=new $;var j;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class le{constructor(){this.c=new Map,this.d=new Map}start(_){const ie=this.a=_.get(D.IInstantiationService);for(const[pe,ve]of this.c)this.e(pe,ve,ie);this.c.clear()}e(_,ie,pe){const ve=pe.createInstance(ie);this.d.set(_,ve)}registerFileEditorFactory(_){if(this.b)throw new Error("Can only register one file editor factory.");this.b=_}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(_,ie){if(this.c.has(_)||this.d.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.a?this.e(_,ie,this.a):this.c.set(_,ie),(0,R.toDisposable)(()=>{this.c.delete(_),this.d.delete(_)})}getEditorSerializer(_){return this.d.get(typeof _=="string"?_:_.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new le);async function J(X,_,ie){return!X||!X.length?[]:await Promise.all(X.map(async pe=>{const ve=l.URI.revive(pe.fileUri);if(!ve){ie.info("Cannot resolve the path because it is not valid.",pe);return}if(!await _.canHandleResource(ve)){ie.info("Cannot resolve the path because it cannot be handled",pe);return}let Oe=pe.exists,oe=pe.type;if(typeof Oe!="boolean"||typeof oe!="number")try{oe=(await _.stat(ve)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Oe=!0}catch(fe){ie.error(fe),Oe=!1}if(!Oe&&pe.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",pe);return}if(oe===E.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",pe);return}const ae={...pe.options,pinned:!0};return Oe?{resource:ve,options:ae}:{resource:ve,options:ae,forceUntitled:!0}}))}e.pathsToEditors=J;var q;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}));function Q(X){const _=X;if(!_)return!1;const ie=_;if(ie.modified)return Q(ie.modified);const pe=_;return!!(pe.contributionsState&&pe.viewState&&Array.isArray(pe.cursorState))}e.isTextEditorViewState=Q;function Z(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=Z;function te(X,_,ie){const pe=(0,L.createErrorWithActions)(X,_);return pe.forceMessage=ie?.forceMessage,pe.forceSeverity=ie?.forceSeverity,pe.allowDialog=ie?.allowDialog,pe}e.createEditorOpenError=te}),define(ye[225],De([1,0,3,188,4,6,28,39,15,61,23,67,216]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",T.Codicon.window,(0,A.localize)(0,null));var I;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(I=e.Extensions||(e.Extensions={}));var y;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(y=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class h extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.flatten)([...this.g.values()])}registerViewContainer(c,r,m){const n=this.get(c.id);if(n)return n;const t=c;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,D.getOrSet)(this.g,r,[]).push(t),m?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:r}),t}deregisterViewContainer(c){for(const r of this.g.keys()){const m=this.g.get(r),n=m?.indexOf(c);if(n!==-1){m?.splice(n,1),m.length===0&&this.g.delete(r),this.f.fire({viewContainer:c,viewContainerLocation:r});return}}}get(c){return this.all.filter(r=>r.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(r=>this.getViewContainers(r).filter(m=>m?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(r=>this.getViewContainerLocation(r)===c)}}P.Registry.add(I.ViewContainersRegistry,new h);var d;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function g(s,c){const r=s.group??d.More,m=c.group??d.More;return r!==m?r.localeCompare(m):(s.order??5)-(c.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new k.SetMap}registerViews(c,r){this.registerViews2([{views:c,viewContainer:r}])}registerViews2(c){c.forEach(({views:r,viewContainer:m})=>this.l(r,m)),this.c.fire(c)}deregisterViews(c,r){const m=this.m(c,r);m.length&&this.f.fire({views:m,viewContainer:r})}moveViews(c,r){for(const m of this.j.keys())if(m!==r){const n=this.m(c,m);n.length&&(this.l(n,r),this.g.fire({views:n,from:m,to:r}))}}getViews(c){return this.j.get(c)||[]}getView(c){for(const r of this.i){const m=(this.j.get(r)||[]).filter(n=>n.id===c)[0];if(m)return m}return null}getViewContainer(c){for(const r of this.i)if((this.j.get(r)||[]).filter(n=>n.id===c)[0])return r;return null}registerViewWelcomeContent(c,r){return this.k.add(c,r),this.h.fire(c),(0,R.toDisposable)(()=>{this.k.delete(c,r),this.h.fire(c)})}registerViewWelcomeContent2(c,r){const m=new Map;for(const[n,t]of r)this.k.add(c,t),m.set(n,(0,R.toDisposable)(()=>{this.k.delete(c,t),this.h.fire(c)}));return this.h.fire(c),m}getViewWelcomeContent(c){const r=[];return this.k.forEach(c,m=>r.push(m)),r.sort(g)}l(c,r){let m=this.j.get(r);m||(m=[],this.j.set(r,m),this.i.push(r));for(const n of c){if(this.getView(n.id)!==null)throw new Error((0,A.localize)(1,null,n.id));m.push(n)}}m(c,r){const m=this.j.get(r);if(!m)return[];const n=[],t=[];for(const u of m)c.includes(u)?n.push(u):t.push(u);return n.length&&(t.length?this.j.set(r,t):(this.j.delete(r),this.i.splice(this.i.indexOf(r),1))),n}}P.Registry.add(I.ViewsRegistry,new b),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var C;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(C=e.ViewVisibilityState||(e.ViewVisibilityState={}));var p;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(p=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,r){this.c=!1,this.d=!1,(0,L.mixin)(this,c),this.d=!!r,this.resolve=async m=>{if(r&&!this.c){const n=await r(m);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class o extends Error{constructor(c){super((0,A.localize)(2,null,c))}}e.NoTreeViewError=o}),define(ye[131],De([1,0,3,19,189]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,E,k,L){const T={command:P};if(E&&Object.keys(E).length>0&&(T.arguments=E),this.s("request",T),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const I=this.f.get(T.seq);if(I){this.f.delete(T.seq);const y={type:"response",seq:0,request_seq:T.seq,success:!1,command:P,message:(0,l.localize)(0,null,L,P)};I(y)}},L)}return k&&this.f.set(T.seq,k),T.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,E){return P.type!=="event"||E.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,A.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const E=P,k=this.f.get(E.request_seq);k&&(this.f.delete(E.request_seq),k(E));break}}}}s(P,E){E.type=P,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((E,k)=>P.set(k,E)),await(0,A.timeout)(500),P.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[226],De([1,0,190,54,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new A.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new A.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new A.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new A.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new A.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new A.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new A.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new A.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new A.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new A.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new A.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new A.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new A.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new A.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new A.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new A.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new A.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new A.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new A.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new A.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new A.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new A.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new A.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new A.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new A.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new A.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new A.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new A.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new A.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new A.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new A.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new A.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new A.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new A.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new A.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new A.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new A.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new A.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new A.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new A.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new A.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new A.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new A.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new A.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new A.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new A.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new A.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new A.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new A.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new A.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new A.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=v=>a.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var D;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(D=e.State||(e.State={}));function P(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var E;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var k;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(k=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var T;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(T=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[227],De([1,0,8,2,10,23,16,32,21,15]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const L=/{([^}]+)}/g;function T(n,t,u){return n.replace(L,function(w,S){return t&&S.length>0&&S[0]!=="_"?w:u&&u.hasOwnProperty(S)?u[S]:w})}e.formatPII=T;function v(n){const t={};for(const u of Object.keys(n))u.startsWith("!")||(t[u]=n[u]);return t}e.filterExceptionsFromTelemetry=v;function I(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||I(n.parentSession))}e.isSessionAttach=I;function y(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(t,"extensionhost")||(0,a.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function h(n,t,u){let w,S=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let x=null;for(;x=F.exec(n);){const V=x.index+1,M=V+x[0].length;if(V<=t&&M>=u){w=x[0],S=V;break}}if(w){const V=/\w+/g;let M=null;for(;(M=V.exec(w))&&!(M.index+1+S+M[0].length>=u););M&&(w=w.substring(0,V.lastIndex))}return w?{start:S,end:S+w.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;async function d(n,t,u,w){if(n.evaluatableExpressionProvider.has(t)){const S=n.evaluatableExpressionProvider.ordered(t),F=(0,k.coalesce)(await Promise.all(S.map(async x=>{try{return await x.provideEvaluatableExpression(t,u,w??E.CancellationToken.None)}catch{return}})));if(F.length>0){let x=F[0].expression;const V=F[0].range;return x||(x=t.getLineContent(u.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:x}}}else{const S=t.getLineContent(u.lineNumber),{start:F,end:x}=h(S,u.column,u.column),V=S.substring(F-1,x);return{matchingExpression:V,range:new P.Range(u.lineNumber,F,u.lineNumber,F+V.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(n){return!!(n&&n.match(g))}e.isUri=b;function C(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(b(n.path))return A.URI.parse(n.path);if((0,l.isAbsolute)(n.path))return A.URI.file(n.path)}return n.path}function p(n){if(typeof n.path=="object"){const t=A.URI.revive(n.path);if(t)return t.scheme===D.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const u=t?C:p,w=(0,R.deepClone)(n);return s(w,(S,F)=>{S&&F&&(F.path=u(F))}),w}e.convertToDAPaths=i;function o(n,t){const u=t?C:p,w=(0,R.deepClone)(n);return s(w,(S,F)=>{!S&&F&&(F.path=u(F))}),w}e.convertToVSCPaths=o;function s(n,t){switch(n.type){case"event":{const u=n;switch(u.event){case"output":t(!1,u.body.source);break;case"loadedSource":t(!1,u.body.source);break;case"breakpoint":t(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=n;switch(u.command){case"setBreakpoints":t(!0,u.arguments.source);break;case"breakpointLocations":t(!0,u.arguments.source);break;case"source":t(!0,u.arguments.source);break;case"gotoTargets":t(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(w=>t(!1,w));break;default:break}break}case"response":{const u=n;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(w=>t(!1,w.source));break;case"loadedSources":u.body.sources.forEach(w=>t(!1,w));break;case"scopes":u.body.scopes.forEach(w=>t(!1,w.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(w=>t(!1,w.source));break;case"setBreakpoints":u.body.breakpoints.forEach(w=>t(!1,w.source));break;case"disassemble":u.body?.instructions.forEach(S=>t(!1,S.location));break;default:break}break}}}function c(n){return n.filter(t=>!t.presentation?.hidden).sort((t,u)=>t.presentation?u.presentation?t.presentation.group?u.presentation.group?t.presentation.group!==u.presentation.group?t.presentation.group.localeCompare(u.presentation.group):r(t.presentation.order,u.presentation.order):-1:u.presentation.group?1:r(t.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=c;function r(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function m(n,t){const u=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(u!=="none"&&(await t.saveAll(),u==="allEditorsInActiveGroup")){const w=t.activeEditorPane;w&&w.input.resource?.scheme===D.Schemas.untitled&&await t.save({editor:w.input,groupId:w.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(ye[228],De([1,0,46,229,23,10,12,8,29,191,131]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class T extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,g){this.p=g,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",b=>this.w(b))}sendMessage(d){if(this.p){const g=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(g,"utf8")}${T.a}${g}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const g=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,g.length>0)try{this.acceptMessage(JSON.parse(g))}catch(b){this.m.fire(new Error((b.message||b)+`
`+g))}continue}}else{const g=this.r.indexOf(T.a);if(g!==-1){const C=this.r.toString("utf8",0,g).split(T.b);for(const p of C){const i=p.split(T.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(g+T.a.length);continue}}break}}}T.a=`\r
\r
`,T.b=/\r?\n/,T.l=/: */,e.StreamDebugAdapter=T;class v extends T{startSession(){return new Promise((d,g)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):g(new Error("connection closed"))}),this.x.on("error",C=>{b?this.m.fire(C):g(C)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class I extends v{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=I;class y extends v{constructor(d){super(),this.z=d}y(d){return A.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=y;class f extends T{constructor(d,g){super(),this.y=d,this.z=g}async startSession(){const d=this.y.command,g=this.y.args,b=this.y.options||{};try{if(d)if(R.isAbsolute(d)){if(!await E.Promises.exists(d))throw new Error(k.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let C=process.env;if(b.env&&Object.keys(b.env).length>0&&(C=l.mixin(l.deepClone(process.env),b.env)),d==="node")if(Array.isArray(g)&&g.length>0){const p=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:C,execArgv:p?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const o=a.fork(g[0],g.slice(1),i);if(!o.pid)throw new Error(k.localize(2,null,g[0]));this.x=o}else throw new Error(k.localize(3,null));else{const p={env:C};b.cwd&&(p.cwd=b.cwd),this.x=a.spawn(d,g,p)}this.x.on("error",p=>{this.m.fire(p)}),this.x.on("exit",(p,i)=>{this.n.fire(p)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",p=>{this.m.fire(p)}),this.x.stdin.on("error",p=>{this.m.fire(p)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(C){this.m.fire(C)}}async stopSession(){return this.x?(await this.u(),D.isWindows?new Promise((d,g)=>{const b=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(C,p,i){if(C)return g(C)});b.on("exit",d),b.on("error",g)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,g){if(!d)return;const b=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?b.runtime=R.join(g,d.runtime):b.runtime=d.runtime),d.runtimeArgs&&(b.runtimeArgs=d.runtimeArgs),d.program&&(R.isAbsolute(d.program)?b.program=d.program:b.program=R.join(g,d.program)),d.args&&(b.args=d.args);const C=d;return C.win&&(b.win=f.A(C.win,g)),C.winx86&&(b.winx86=f.A(C.winx86,g)),C.windows&&(b.windows=f.A(C.windows,g)),C.osx&&(b.osx=f.A(C.osx,g)),C.linux&&(b.linux=f.A(C.linux,g)),b}static platformAdapterExecutable(d,g){let b=Object.create(null);g=g.toLowerCase();for(const c of d)if(c.contributes){const r=c.contributes.debuggers;r&&r.length>0&&r.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,g)).forEach(m=>{const n=f.A(m,c.extensionLocation.fsPath);b=l.mixin(b,n,c.isBuiltin)})}let C;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?C=b.winx86||b.win||b.windows:D.isWindows?C=b.win||b.windows:D.isMacintosh?C=b.osx:D.isLinux&&(C=b.linux),C=C||b;const p=C.program||b.program,i=C.args||b.args,o=C.runtime||b.runtime,s=C.runtimeArgs||b.runtimeArgs;if(o)return{type:"executable",command:o,args:(s||[]).concat(typeof p=="string"?[p]:[]).concat(i||[])};if(p)return{type:"executable",command:p,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(ye[230],De([1,0,46,33,12]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(k,L){return new Promise((T,v)=>{let I="";const y=a.spawn(k,L);y.pid&&y.stdout.on("data",f=>{I+=f.toString()}),y.on("error",f=>{v(f)}),y.on("close",f=>{T(I)})})}async function D(k){if(k)if(l.isWindows){const L=await new Promise((T,v)=>{ne(["windows-process-tree"],T,v)});return new Promise(T=>{L.getProcessTree(k,v=>{T(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(k)]).then(L=>{const T=L.trim();return!(T.length===0||T.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var P;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(P||(P={}));function E(k,L,T,v,I){k=k.trim().toLowerCase();let y;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?y=1:k.indexOf("cmd.exe")>=0?y=0:k.indexOf("bash")>=0?y=2:l.isWindows?y=0:y=2;let f,h=" ";switch(y){case 1:if(f=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),v){const d=(0,A.getDriveLetter)(v);d&&(h+=`${d}:; `),h+=`cd ${f(v)}; `}if(I)for(const d in I){const g=I[d];g===null?h+=`Remove-Item env:${d}; `:h+=`\${env:${d}}='${g}'; `}if(L.length>0){const d=L.shift(),g=T?d:f(d);h+=g[0]==="'"?`& ${g} `:`${g} `;for(const b of L)h+=b==="<"||b===">"||T?b:f(b),h+=" "}break;case 0:if(f=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(g=>d.includes(g))||d.length===0?`"${d}"`:d),v){const d=(0,A.getDriveLetter)(v);d&&(h+=`${d}: && `),h+=`cd ${f(v)} && `}if(I){h+='cmd /C "';for(const d in I){let g=I[d];g===null?h+=`set "${d}=" && `:(g=g.replace(/[&^|<>]/g,b=>`^${b}`),h+=`set "${d}=${g}" && `)}}for(const d of L)h+=d==="<"||d===">"||T?d:f(d),h+=" ";I&&(h+='"');break;case 2:{f=g=>(g=g.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),g.length===0?'""':g);const d=g=>/[^\w@%\/+=,.:^-]/.test(g)?`'${g.replace(/'/g,"'\\''")}'`:g;if(v&&(h+=`cd ${f(v)} ; `),I){h+="/usr/bin/env";for(const g in I){const b=I[g];b===null?h+=` -u ${d(g)}`:h+=` ${d(`${g}=${b}`)}`}h+=" "}for(const g of L)h+=g==="<"||g===">"||T?g:f(g),h+=" ";break}}return h}e.prepareCommand=E}),define(ye[92],De([1,0,22,38,64,86,16,10,12,54]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var T;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(T=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var y;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(y=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var g;(function(U){U.scheme=D.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${$.join("")}]+`),le=7;function J(_,ie){const pe=ie.toString(le),ke=`${pe.length<$.length?$[pe.length-1]:"z"}${pe}s${(0,a.encodeBase64)(a.VSBuffer.fromString(_.scheme),!0,!0)}`;return _.with({scheme:U.scheme,fragment:ke})}U.generate=J;function q(_){if(_.scheme!==U.scheme)return;const ie=_.fragment.indexOf("s");if(ie<0)return;const pe=parseInt(_.fragment.substring(0,ie).replace(j,""),le),ve=(0,a.decodeBase64)(_.fragment.substring(ie+1)).toString();if(!isNaN(pe))return{handle:pe,notebook:_.with({scheme:ve,fragment:null})}}U.parse=q;function Q(_,ie){return _.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${_.scheme!==D.Schemas.file?_.scheme:""}`})}U.generateCellOutputUri=Q;function Z(_){if(_.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ie)return;const pe=ie[1]&&ie[1]!==""?ie[1]:void 0,ve=ie[2];return{outputId:pe,notebook:_.with({scheme:ve||D.Schemas.file,fragment:null})}}U.parseCellOutputUri=Z;function te(_,ie,pe){return U.generate(_,ie).with({scheme:pe})}U.generateCellPropertyUri=te;function X(_,ie){if(_.scheme===ie)return U.parse(_.with({scheme:U.scheme}))}U.parseCellPropertyUri=X})(g=e.CellUri||(e.CellUri={}));const b=U=>E.isWindows?U.replace(/\//g,"\\"):U;class C{constructor($=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set($)].map(le=>({pattern:le,matches:A.parse(b(le))}))}sort($){const j=new Map(l.Iterable.map($,J=>[J,b(J)]));let le=[];for(const{matches:J}of this.d)for(const[q,Q]of j)if(J(Q)){le.push(q),j.delete(q);break}return j.size&&(le=le.concat([...j.keys()].sort((J,q)=>this.e.indexOf(J)-this.e.indexOf(q)))),le}prioritize($,j){const le=this.f($);if(le===-1){this.d.unshift({pattern:$,matches:A.parse(b($))});return}const J=new Set(j.map(Q=>this.f(Q,le)));J.delete(-1);const q=Array.from(J).sort();this.d.splice(le+1,0,...q.map(Q=>this.d[Q]));for(let Q=q.length-1;Q>=0;Q--)this.d.splice(q[Q],1)}toArray(){return this.d.map($=>$.pattern)}f($,j=this.d.length){const le=b($);for(let J=0;J<j;J++)if(this.d[J].matches(le))return J;return-1}}e.MimeTypeDisplayOrder=C;function p(U,$,j,le=(J,q)=>J===q){const J=[];function q(te,X,_){if(X===0&&_.length===0)return;const ie=J[J.length-1];ie&&ie.start+ie.deleteCount===te?(ie.deleteCount+=X,ie.toInsert.push(..._)):J.push({start:te,deleteCount:X,toInsert:_})}let Q=0,Z=0;for(;;){if(Q===U.length){q(Q,0,$.slice(Z));break}if(Z===$.length){q(Q,U.length-Q,[]);break}const te=U[Q],X=$[Z];if(le(te,X)){Q+=1,Z+=1;continue}j(X)?(q(Q,1,[]),Q+=1):(q(Q,0,[X]),Z+=1)}return J}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new k.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(U){const $=U;return!!((typeof $.include=="string"||A.isRelativePattern($.include))&&(typeof $.exclude=="string"||A.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=o;function s(U,$,j){if(Array.isArray(U.viewType)&&U.viewType.indexOf($)>=0||U.viewType===$)return!0;if(U.filenamePattern){const le=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,J=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(A.match(le,(0,P.basename)(j.fsPath).toLowerCase()))return!(J&&A.match(J,(0,P.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var c;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(c=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create($){return`${r.d}${$}`}static parse($){if($.startsWith(r.d))return $.substring(r.d.length)}}r.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=r;function m(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=m;const n=new TextDecoder;function t(U){const $=[];let j=!1;for(const le of U)($.length===0||j)&&($.push(le),j=!0);return F($),O(a.VSBuffer.concat($.map(le=>a.VSBuffer.wrap(le))))}e.compressOutputItemStreams=t;const u=`${String.fromCharCode(27)}[A`,w=u.split("").map(U=>U.charCodeAt(0)),S=10;function F(U){U.forEach(($,j)=>{if(j===0||$.length<u.length)return;const le=U[j-1],J=$.subarray(0,u.length);if(J[0]===w[0]&&J[1]===w[1]&&J[2]===w[2]){const q=le.lastIndexOf(S);if(q===-1)return;U[j-1]=le.subarray(0,q),U[j]=$.subarray(u.length)}})}function x(U){let $=U;do U=$,$=U.replace(/[^\n]\x08/gm,"");while($.length<U.length);return U}function V(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const $=U.match(/^(.*)\r+/m)[1];let j=U.match(/\r+(.*)$/m)[1];j=j+$.slice(j.length,$.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return U}const M="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(U){return!U.buffer.includes(M)&&!U.buffer.includes(B)?U:a.VSBuffer.fromString(V(x(n.decode(U.buffer))))}}),define(ye[231],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var A;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(A=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[57],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(D,P,E=D.parent){if(D._isRoot)return new l([P]);const k=[D.id];for(let L=E;L&&L.id!==P;L=L.parent)k.push(L.id);return k.push(P),new l(k.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const P=D.indexOf("\0");return P===-1?D:D.slice(0,P)}static fromString(D){return new l(D.split("\0"))}static join(D,P){return new l([...D.path,P])}static joinToString(D,P){return D.toString()+"\0"+P}static parentId(D){const P=D.lastIndexOf("\0");return P===-1?void 0:D.slice(0,P)}static localId(D){const P=D.lastIndexOf("\0");return P===-1?D:D.slice(P+1)}static compare(D,P){return D===P?0:P.startsWith(D+"\0")?2:D.startsWith(P+"\0")?3:1}constructor(D,P=D.length){if(this.path=D,this.d=P,D.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let D=1;D<=this.d;D++)yield new l(this.path,D)}*idsToRoot(){for(let D=this.d;D>0;D--)yield new l(this.path,D)}compare(D){if(typeof D=="string")return l.compare(this.toString(),D);for(let P=0;P<D.d&&P<this.d;P++)if(D.path[P]!==this.path[P])return 1;return D.d>this.d?2:D.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let D=1;D<this.d;D++)this.c+="\0",this.c+=this.path[D]}return this.c}}e.TestId=l}),define(ye[75],De([1,0,2,32,57]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var D;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=n=>"runId"in n;e.isStartControllerTests=P;var E;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:A.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(E=e.IRichLocation||(e.IRichLocation={}));var k;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(k=e.TestMessageType||(e.TestMessageType={}));var L;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&E.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&E.deserialize(t.location)})})(L=e.ITestErrorMessage||(e.ITestErrorMessage={}));const T=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=T;var v;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&E.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&E.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var I;(function(n){n.serialize=t=>t.type===0?L.serialize(t):v.serialize(t),n.deserialize=t=>t.type===0?L.deserialize(t):v.deserialize(t)})(I=e.ITestMessage||(e.ITestMessage={}));var y;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(I.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",h=(n,t)=>n+f+t;e.namespaceTestTag=h;const d=n=>{const t=n.indexOf(f);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=d;var g;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?A.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(g=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(n){n.serialize=t=>({expand:t.expand,item:g.serialize(t.item)}),n.deserialize=t=>({controllerId:l.TestId.root(t.item.extId),expand:t.expand,item:g.deserialize(t.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(n){n.serialize=t=>{let u;return t.item&&(u={},t.item.label!==void 0&&(u.label=t.item.label),t.item.tags!==void 0&&(u.tags=t.item.tags),t.item.busy!==void 0&&(u.busy=t.item.busy),t.item.uri!==void 0&&(u.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(u.range=t.item.range?.toJSON()),t.item.description!==void 0&&(u.description=t.item.description),t.item.error!==void 0&&(u.error=t.item.error),t.item.sortText!==void 0&&(u.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:u}},n.deserialize=t=>{let u;return t.item&&(u={},t.item.label!==void 0&&(u.label=t.item.label),t.item.tags!==void 0&&(u.tags=t.item.tags),t.item.busy!==void 0&&(u.busy=t.item.busy),t.item.range!==void 0&&(u.range=t.item.range?A.Range.lift(t.item.range):null),t.item.description!==void 0&&(u.description=t.item.description),t.item.error!==void 0&&(u.error=t.item.error),t.item.sortText!==void 0&&(u.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:u}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var o;(function(n){n.serializeWithoutMessages=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired}),n.deserialize=t=>({...C.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.deserialize),retired:!0})})(o=e.TestResultItem||(e.TestResultItem={}));var s;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var c;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(c=e.TestDiffOpType||(e.TestDiffOpType={}));var r;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:C.deserialize(t.item)}:t.op===1?{op:t.op,item:p.deserialize(t.item)}:t.op===2?{op:t.op,uri:a.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:C.serialize(t.item)}:t.op===1?{op:t.op,item:p.serialize(t.item)}:t})(r=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const u=this.o();for(const w of t)switch(w.op){case 0:this.j(C.deserialize(w.item),u);break;case 1:this.k(p.deserialize(w.item),u);break;case 3:this.l(w.itemId,u);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}u.complete?.()}j(t,u){const w=l.TestId.parentId(t.item.extId)?.toString();let S;if(!w)S=this.p(t),this.f.add(S),this.d.set(t.item.extId,S);else if(this.d.has(w)){const F=this.d.get(w);F.children.add(t.item.extId),S=this.p(t,F),this.d.set(t.item.extId,S)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return u.add?.(S),t.expand===2&&this.g++,S}k(t,u){const w=this.d.get(t.extId);if(!!w)return t.expand!==void 0&&(w.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(w,t),u.update?.(w),w}l(t,u){const w=this.d.get(t);if(!w)return;const S=l.TestId.parentId(w.item.extId)?.toString();S?this.d.get(S).children.delete(w.item.extId):this.f.delete(w);const F=[[t]];for(;F.length;)for(const x of F.pop()){const V=this.d.get(x);V&&(F.push(V.children),this.d.delete(x),u.remove?.(V,V!==w),V.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(ye[93],De([1,0,19,3,6,50,75,57]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const k=(g,b)=>g===b,T=Object.entries({range:(g,b)=>g===b?!0:!g||!b?!1:g.equalsRange(b),busy:k,label:k,description:k,error:k,sortText:k,tags:(g,b)=>!(g.length!==b.length||g.some(C=>!b.includes(C)))}),v=(g,b)=>{let C;for(const[p,i]of T)i(g[p],b[p])||(C?C[p]=b[p]:C={[p]:b[p]});return C};class I extends l.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const C of this.tree.values())this.G(C)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const C of this.k)if(C.op===2&&C.uri===b.uri){C.docv=b.docv;return}break}case 1:{const C=this.k[this.k.length-1];if(C){if(C.op===1&&C.item.extId===b.item.extId){(0,D.applyTestItemUpdate)(C.item,b.item);return}if(C.op===0&&C.item.item.extId===b.item.extId){(0,D.applyTestItemUpdate)(C.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,C){const p=this.tree.get(b);if(!!p){if((p.expandLevels===void 0||C>p.expandLevels)&&(p.expandLevels=C),p.expand===1){const i=this.I(p);return i.isOpen()?this.H(p,C-1):i.wait().then(()=>this.H(p,C-1))}else if(p.expand===3)return p.resolveBarrier?.isOpen()===!1?p.resolveBarrier.wait().then(()=>this.H(p,C-1)):this.H(p,C-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,C){switch(C.op){case 3:this.L(P.TestId.joinToString(b.fullId,C.id));break;case 0:this.u(C.item,b);break;case 5:for(const p of C.ops)this.p(b,p);break;case 1:this.w(C.new,C.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:C.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(C)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,C){const p=P.TestId.fromExtHostTestItem(b,this.root.id,C?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==C?.actual&&this.m.getChildren(i.parent).delete(b.id);let o=this.tree.get(p.toString());if(!o){o={fullId:p,actual:b,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(o.fullId.toString(),o),this.C(b,C),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:o.expand,item:this.m.toITestItem(b)}}),this.F(b,o,C);return}if(o.actual===b){this.D(b,o,C);return}if(o.actual.uri?.toString()!==b.uri?.toString())return this.L(p.toString()),this.u(b,C);const s=this.m.getChildren(o.actual),c=o.actual,r=v(this.m.toITestItem(c),this.m.toITestItem(b));this.m.getApiFor(c).listener=void 0,o.actual=b,o.expand=0,r&&(r.hasOwnProperty("tags")&&(this.w(b.tags,c.tags,p.toString()),delete r.tags),this.p(o,{op:4,update:r})),this.F(b,o,C);for(const[m,n]of s)this.m.getChildren(b).get(n.id)||this.L(P.TestId.joinToString(p,n.id));this.s(o.actual.uri)}w(b,C,p){const i=new Set(C.map(o=>o.id));for(const o of b)i.delete(o.id)||this.y(o);this.pushDiff({op:1,item:{extId:p,item:{tags:b.map(o=>(0,D.namespaceTestTag)(this.m.controllerId,o.id))}}}),i.forEach(this.z,this)}y(b){const C=this.j.get(b.id);C?C.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const C=this.j.get(b);C&&!--C.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.m.controllerId,b)}))}C(b,C){this.m.getApiFor(b).parent=C&&C.actual!==this.root?C.actual:void 0}D(b,C,p){this.C(b,p);const i=this.m.getApiFor(b);i.parent=p?.actual,i.listener=o=>this.p(C,o),this.G(C)}F(b,C,p){this.D(b,C,p);for(const[i,o]of this.m.getChildren(b))this.u(o,C)}G(b){let C;this.h?b.resolveBarrier?C=b.resolveBarrier.isOpen()?3:2:C=b.actual.canResolveChildren?1:0:C=0,C!==b.expand&&(b.expand=C,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:C}}),C===1&&b.expandLevels!==void 0&&this.I(b))}H(b,C){if(C<0)return;const p=[];for(const[i,o]of this.m.getChildren(b.actual)){const s=this.expand(P.TestId.joinToString(b.fullId,o.id),C);(0,a.isThenable)(s)&&p.push(s)}if(p.length)return Promise.all(p).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const o=new a.Barrier;return o.open(),o}b.expand=2,this.J(b);const C=b.resolveBarrier=new a.Barrier,p=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,o)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(o){p(o)}return(0,a.isThenable)(i)?i.catch(p).then(()=>{C.open(),this.G(b)}):(C.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const C=this.tree.get(b);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const p=[C];for(;p.length;){const i=p.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const o of i.actual.tags)this.z(o.id);this.tree.delete(i.fullId.toString());for(const[o,s]of this.m.getChildren(i.actual))p.push(this.tree.get(P.TestId.joinToString(i.fullId,s.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=I;class y extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=y;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(b,C,p){super(`TestItem with ID "${b}" is from controller "${C}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=h;const d=(g,b,C)=>{let p=new Map;return{get size(){return p.size},forEach(i,o){for(const s of p.values())i.call(o,s,this)},[Symbol.iterator](){return p.entries()},replace(i){const o=new Map,s=new Set(p.keys()),c={op:5,ops:[]};for(const r of i){if(!(r instanceof C))throw new f(r.id);const m=b(r).controllerId;if(m!==g.controllerId)throw new h(r.id,m,g.controllerId);if(o.has(r.id))throw new y(r.id);o.set(r.id,r),s.delete(r.id),c.ops.push({op:0,item:r})}for(const r of s.keys())c.ops.push({op:3,id:r});g.listener?.(c),p=o},add(i){if(!(i instanceof C))throw new f(i.id);p.set(i.id,i),g.listener?.({op:0,item:i})},delete(i){p.delete(i)&&g.listener?.({op:3,id:i})},get(i){return p.get(i)},toJSON(){return Array.from(p.values())}}};e.createTestItemChildren=d}),define(ye[132],De([1,0,93]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(D,P)=>{const E={controllerId:P};return A.set(D,E),E};e.createPrivateApiFor=l;const R=D=>{const P=A.get(D);if(!P)throw new a.InvalidTestItemError(D?.id||"<unknown>");return P};e.getPrivateApiFor=R}),define(ye[94],De([1,0,16,2]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,E){return P.scheme===a.Schemas.http||P.scheme===a.Schemas.https?P:(E&&E.authority&&E.isRemote&&P.scheme===a.Schemas.file&&(P=A.URI.from({scheme:a.Schemas.vscodeRemote,authority:E.authority,path:P.path})),A.URI.from({scheme:a.Schemas.https,authority:`${P.scheme}+${R(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function R(P){return P.replace(/./g,E=>{const k=E.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?E:"-"+k.toString(16).padStart(4,"0")})}function D(P){return P.replace(/-([0-9a-f]{4})/g,(E,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=D}),define(ye[232],De([1,0,3,6,94]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(P,E,k){this.d=P,this.e=E,this.f=k,this.a=0,this.b=new A.DisposableStore,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const L=E.getVisibleTextEditors();for(const T of this.c.values())L.indexOf(T.editor)<0&&T.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,E,k,L,T){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===P){v=b;break}if(!v)throw new Error("not a visible editor");const I=this,y=this.a++,f=new a.Emitter,h=new a.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,l.asWebviewUri)(b,I.f)}get cspSource(){return l.webviewGenericCspSource}set options(b){this.b=b,I.d.$setOptions(y,b)}get options(){return this.b}set html(b){this.a=b,I.d.$setHtml(y,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return I.d.$postMessage(y,b)}},g=new class{constructor(){this.editor=P,this.line=E,this.height=k,this.webview=d,this.onDidDispose=h.event}dispose(){I.c.has(y)&&(I.c.delete(y),I.d.$disposeEditorInset(y),h.fire(),h.dispose(),f.dispose())}};return this.d.$createEditorInset(y,v.id,v.value.document.uri,E+1,k,L||{},T.identifier,T.extensionLocation),this.c.set(y,{editor:P,inset:g,onDidReceiveMessage:f}),g}$onDidDispose(P){const E=this.c.get(P);E&&E.inset.dispose()}$onDidReceiveMessage(P,E){this.c.get(P)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=R}),define(ye[233],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var A;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(D,P){super(P),this.variable=D}}e.VariableError=l}),define(ye[234],De([1,0,10,36,9,23,12,113,194,233,8]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(I,y,f,h){this.g=new Map,this.a=I,this.b=y,this.d=f,h&&(this.c=h.then(d=>this.h(d)))}h(I){if(D.isWindows){const y=Object.create(null);return Object.keys(I).forEach(f=>{y[f.toLowerCase()]=I[f]}),y}return I}resolveWithEnvironment(I,y,f){return this.j({env:this.h(I),userHome:void 0},y?y.uri:void 0,f)}async resolveAsync(I,y){const f={env:await this.c,userHome:await this.d};return this.j(f,I?I.uri:void 0,y)}async i(I,y,f,h){const d=R.deepClone(y);D.isWindows&&d.windows?Object.keys(d.windows).forEach(b=>d[b]=d.windows[b]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(b=>d[b]=d.osx[b]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(b=>d[b]=d.linux[b]),delete d.windows,delete d.osx,delete d.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,I?I.uri:void 0,d,f,h)}async resolveAnyAsync(I,y,f){return this.i(I,y,f)}async resolveAnyMap(I,y,f){const h=new Map;return{newConfig:await this.i(I,y,f,h),resolvedVariables:h}}resolveWithInteractionReplace(I,y,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,y,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,y){if(this.g.has(I))throw new Error("Variable "+I+" is contributed twice.");this.g.set(I,y)}async j(I,y,f,h,d){if(l.isString(f))return this.l(I,y,f,h,d);if(Array.isArray(f))return Promise.all(f.map(g=>this.j(I,y,g,h,d)));if(l.isObject(f)){const g=Object.create(null),b=await Promise.all(Object.keys(f).map(async C=>[await this.l(I,y,C,h,d),await this.j(I,y,f[C],h,d)]));for(const[C,p]of b)g[C]=p;return g}return f}l(I,y,f,h,d){return(0,L.replaceAsync)(f,T.VARIABLE_REGEXP,async(g,b)=>{if(b.includes(T.VARIABLE_LHS))return g;let C=await this.n(I,g,b,y,h);return d?.set(b,C),C!==g&&l.isString(C)&&C.match(T.VARIABLE_REGEXP)&&(C=await this.l(I,y,C,h,d)),C})}m(I){return this.b?this.b.getUriLabel(I,{noPrefix:!0}):I.fsPath}async n(I,y,f,h,d){let g;const b=f.split(":");b.length>1&&(f=b[0],g=b[1]);const C=o=>{const s=this.a.getFilePath();if(s)return(0,P.normalizeDriveLetter)(s);throw new k.VariableError(o,(0,E.localize)(0,null,y))},p=o=>{const s=C(o);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,P.normalizeDriveLetter)(c)}throw new k.VariableError(o,(0,E.localize)(1,null,y,a.basename(s)))},i=o=>{if(g){const s=this.a.getFolderUri(g);if(s)return s;throw new k.VariableError(o,(0,E.localize)(2,null,y,g))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new k.VariableError(o,(0,E.localize)(3,null,y)):new k.VariableError(o,(0,E.localize)(4,null,y))};switch(f){case"env":if(g){if(I.env){const o=I.env[D.isWindows?g.toLowerCase():g];if(l.isString(o))return o}return""}throw new k.VariableError(k.VariableKind.Env,(0,E.localize)(5,null,y));case"config":if(g){const o=this.a.getConfigurationValue(h,g);if(l.isUndefinedOrNull(o))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(6,null,y,g));if(l.isObject(o))throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(7,null,y,g));return o}throw new k.VariableError(k.VariableKind.Config,(0,E.localize)(8,null,y));case"command":return this.o(k.VariableKind.Command,y,g,d,"command");case"input":return this.o(k.VariableKind.Input,y,g,d,"input");case"extensionInstallFolder":if(g){const o=await this.a.getExtension(g);if(!o)throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,y,g));return this.m(o.extensionLocation)}throw new k.VariableError(k.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,y));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(i(k.VariableKind.WorkspaceFolder)));case"cwd":return h||g?(0,P.normalizeDriveLetter)(this.m(i(k.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(a.basename(this.m(i(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(I.userHome)return I.userHome;throw new k.VariableError(k.VariableKind.UserHome,(0,E.localize)(11,null,y))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new k.VariableError(k.VariableKind.LineNumber,(0,E.localize)(12,null,y))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new k.VariableError(k.VariableKind.SelectedText,(0,E.localize)(13,null,y))}case"file":return C(k.VariableKind.File);case"fileWorkspaceFolder":return p(k.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||g?a.relative(this.m(i(k.VariableKind.RelativeFile)),C(k.VariableKind.RelativeFile)):C(k.VariableKind.RelativeFile);case"relativeFileDirname":{const o=a.dirname(C(k.VariableKind.RelativeFileDirname));if(h||g){const s=a.relative(this.m(i(k.VariableKind.RelativeFileDirname)),o);return s.length===0?".":s}return o}case"fileDirname":return a.dirname(C(k.VariableKind.FileDirname));case"fileExtname":return a.extname(C(k.VariableKind.FileExtname));case"fileBasename":return a.basename(C(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=a.basename(C(k.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-a.extname(o).length)}case"fileDirnameBasename":return a.basename(a.dirname(C(k.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||y}case"execInstallFolder":{const o=this.a.getAppRoot();return o||y}case"pathSeparator":return a.sep;default:try{const o=g?`${f}:${g}`:f;return this.o(k.VariableKind.Unknown,y,o,d,void 0)}catch{return y}}}}o(I,y,f,h,d){if(f&&h){const g=d===void 0?h[f]:h[d+":"+f];if(typeof g=="string")return g;throw new k.VariableError(I,(0,E.localize)(14,null,y))}return y}}T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=T}),define(ye[133],De([1,0,4,130]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var l;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var R;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var P;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EVEN=1]="EVEN",y[y.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function k(y){const f=y;return(0,A.isEditorInput)(f?.editor)&&(0,A.isEditorInput)(f?.replacement)}e.isEditorReplacement=k;var L;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var T;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(T=e.OpenEditorContext||(e.OpenEditorContext={}));function v(y){const f=y;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function I(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ye[235],De([1,0,4,133]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const D=R;return typeof R=="number"||(0,A.isEditorGroup)(D)}e.isPreferredGroup=l}),define(ye[236],De([1,0,4,200]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(A.IEnvironmentService)}),define(ye[134],De([1,0,26,3,10]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(T){this.removedDueToLooping=T}}e.DeltaExtensionsResult=R;class D{static isHostExtension(T,v,I){if(v.getExtensionDescription(T))return!1;const y=I.getExtensionDescription(T);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(T){this.c=new A.Emitter,this.onDidChange=this.c.event,this.d=T,this.h()}h(){this.d.sort(E),this.e=new Map,this.f=[],this.g=new Map;for(const T of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(T.identifier))){console.error("Extension `"+T.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(T.identifier),T),this.f.push(T),Array.isArray(T.activationEvents))for(let v of T.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(T.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(T)}}set(T){this.d=T,this.h(),this.c.fire(void 0)}deltaExtensions(T,v){this.d=k(this.d,v),this.d=this.d.concat(T);const I=D.j(this.d);return this.d=k(this.d,I.map(y=>y.identifier)),this.h(),this.c.fire(void 0),new R(I)}static j(T){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,g){this.addNode(d),this.addNode(g),this.c.has(d)?this.c.get(d).push(g):this.c.set(d,[g])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,g){const b=v.getArcs(d);for(let C=0;C<b.length;C++)if(!g.has(b[C]))return!1;return!0}getNodes(){return this.e}},I=new Map;for(const d of T){const g=a.ExtensionIdentifier.toKey(d.identifier);if(I.set(g,d),d.extensionDependencies)for(const b of d.extensionDependencies){const C=a.ExtensionIdentifier.toKey(b);v.addArc(g,C)}}const y=new Set;v.getNodes().filter(d=>v.getArcs(d).length===0).forEach(d=>y.add(d));const f=v.getNodes().filter(d=>!y.has(d));let h;do{h=!1;for(let d=0;d<f.length;d++){const g=f[d];v.hasOnlyGoodArcs(g,y)&&(f.splice(d,1),d--,y.add(g),h=!0)}}while(h);return f.map(d=>I.get(d))}containsActivationEvent(T){return this.g.has(T)}containsExtension(T){return this.e.has(a.ExtensionIdentifier.toKey(T))}getExtensionDescriptionsForActivationEvent(T){const v=this.g.get(T);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(T){const v=this.e.get(a.ExtensionIdentifier.toKey(T));return v||void 0}getExtensionDescriptionByUUID(T){for(const v of this.f)if(v.uuid===T)return v}getExtensionDescriptionByIdOrUUID(T,v){return this.getExtensionDescription(T)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=D;var P;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(P||(P={}));function E(L,T){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,I=T.isBuiltin?0:T.isUnderDevelopment?2:1;if(v!==I)return v-I;const y=l.posix.basename(L.extensionLocation.path),f=l.posix.basename(T.extensionLocation.path);return y<f?-1:y>f?1:0}function k(L,T){const v=new Set;return T.forEach(I=>v.add(a.ExtensionIdentifier.toKey(I))),L.filter(I=>!v.has(a.ExtensionIdentifier.toKey(I.identifier)))}}),define(ye[237],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(T){this.pipeName=T,this.type=1}serialize(T){T[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class l{constructor(){this.type=2}serialize(T){T[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class R{constructor(){this.type=3}serialize(T){T[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function D(L){delete L[A.ENV_KEY],delete L[l.ENV_KEY],delete L[R.ENV_KEY]}function P(L,T){D(T),L.serialize(T)}e.writeExtHostConnection=P;function E(L){if(L[A.ENV_KEY])return k(L,new A(L[A.ENV_KEY]));if(L[l.ENV_KEY])return k(L,new l);if(L[R.ENV_KEY])return k(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=E;function k(L,T){return D(L),T}}),define(ye[95],De([1,0,22]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var l;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function D(k){const L=a.VSBuffer.alloc(1);switch(k){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=D;function P(k,L){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=P;var E;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[96],De([1,0,4,3,13,25,95,72,73,23,2,6,181]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let I=class extends T.Disposable{constructor(d,g){super(),this.m=d,this.n=g,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=L.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:E.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(b=>{(0,l.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,g,b){const C=this.getTelemetryDetails(),p=new y(g,b,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled});return this.l.set(d.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(d,g,b){this.f=d,this.g=g,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(d){const g={};switch(g["common.extname"]=`${d.publisher}.${d.name}`,g["common.extversion"]=d.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=f(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case D.UIKind.Web:g["common.uikind"]="web";break;case D.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,E.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const g=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(d,g){const b=this.l.get(d.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(g),!0)}};I=qe([We(0,R.IExtHostInitDataService),We(1,l.ILoggerService)],I),e.ExtHostTelemetry=I;class y{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,g,b,C,p,i,o){this.g=b,this.h=C,this.i=p,this.j=i,this.b=new A.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.c=g?.ignoreBuiltInCommonProperties??!1,this.d=g?.additionalCommonProperties,this.a=d,this.e={isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}}updateTelemetryEnablements(d,g){this.f&&(this.e={isUsageEnabled:d,isErrorsEnabled:g},this.b.fire(this.f))}mixInCommonPropsAndCleanData(d){let g=d.properties??d;return g=(0,E.cleanData)(g,[]),this.d&&(g=(0,k.mixin)(g,this.d)),this.c||(g=(0,k.mixin)(g,this.j)),d.properties?d.properties=g:d=g,d}k(d,g){this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.a.sendEventData(d,g),this.h.trace(d,g)}logUsage(d,g){!this.e.isUsageEnabled||this.k(d,g)}logError(d,g){!this.e.isErrorsEnabled||(typeof d=="string"?this.k(d,g):this.a.sendErrorData(d,g))}get apiTelemetryLogger(){if(!this.f){const d=this,g={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.e.isUsageEnabled},get isErrorsEnabled(){return d.e.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.b.event.bind(d)};this.f=Object.freeze(g)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=y;function f(h){const d=Date.now()-new Date(h).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[27],De([1,0,3,2,4,26,213]),function(ne,e,a,A,l,R,D){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class E{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class k{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=k;class L{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class T{constructor(m){this.dependency=m}}e.MissingExtensionDependency=T;var v;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class y{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,n){const t=[],u=[],w=[],S=[],F=d(this.c),x=d(m),V=(U,$)=>U.extensionLocation.toString()===$.extensionLocation.toString()||U.isBuiltin===$.isBuiltin||U.isUserBuiltin===$.isUserBuiltin||U.isUnderDevelopment===$.isUnderDevelopment;for(const U of this.c){const $=x.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}if(!V(U,$)){t.push(U.identifier),F.delete(R.ExtensionIdentifier.toKey(U.identifier));continue}}for(const U of m){const $=F.get(R.ExtensionIdentifier.toKey(U.identifier));if(!$){u.push(U);continue}if(!V($,U)){t.push($.identifier),F.delete(R.ExtensionIdentifier.toKey($.identifier));continue}}const M=h(this.d),B=h(n);for(const U of this.d)B.has(R.ExtensionIdentifier.toKey(U))||w.push(U);for(const U of n)M.has(R.ExtensionIdentifier.toKey(U))||S.push(U);const O={toRemove:t,toAdd:u,myToRemove:w,myToAdd:S};return this.delta(O),O}delta(m){const{toRemove:n,toAdd:t,myToRemove:u,myToAdd:w}=m,S=h(n),F=h(u);for(let x=0;x<this.c.length;x++)S.has(R.ExtensionIdentifier.toKey(this.c[x].identifier))&&(this.c.splice(x,1),x--);for(let x=0;x<this.d.length;x++)F.has(R.ExtensionIdentifier.toKey(this.d[x]))&&(this.d.splice(x,1),x--);for(const x of t)this.c.push(x);for(const x of w)this.d.push(x)}containsExtension(m){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=y;class f{constructor(m){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,m)for(const n of m)this.add(n)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,n){this.c.forEach(t=>m.call(n,t,t,this))}*entries(){for(const[m,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function h(r){const m=new Set;for(const n of r)m.add(R.ExtensionIdentifier.toKey(n));return m}e.extensionIdentifiersArrayToSet=h;function d(r){const m=new Map;for(const n of r)m.set(R.ExtensionIdentifier.toKey(n.identifier),n);return m}function g(r,m){return r.enabledApiProposals?r.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=g;function b(r,m){if(!g(r,m))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=b;class C{constructor(m,n,t,u){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=u}}e.ActivationTimes=C;class p{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var i;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function s(r,m){return{identifier:new R.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!m,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform,browserNlsBundleUris:r.browserNlsBundleUris}}e.toExtensionDescription=s;class c{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,n){return Promise.resolve(0)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=c}),define(ye[238],De([1,0,11,134,26,27,13,19]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class E{constructor(d,g,b,C){this.startup=d,this.codeLoadingTime=g,this.activateCallTime=b,this.activateResolvedTime=C}}E.NONE=new E(!1,-1,-1,-1),e.ExtensionActivationTimes=E;class k{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,g){return d===-1||g===-1?-1:g-d}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=k;class L{constructor(d,g,b,C,p,i){this.activationFailed=d,this.activationFailedError=g,this.activationTimes=b,this.module=C,this.exports=p,this.subscriptions=i}}e.ActivatedExtension=L;class T extends L{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=T;class v extends L{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class I extends L{constructor(d){super(!0,d,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(d,g,b,C){this.g=C,this.a=d,this.b=g,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[d,g]of this.d)g.dispose()}isActivated(d){const g=this.d.get(l.ExtensionIdentifier.toKey(d));return Boolean(g&&g.value)}getActivatedExtension(d){const g=this.d.get(l.ExtensionIdentifier.toKey(d));if(!g||!g.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return g.value}async activateByEvent(d,g){if(this.f[d])return;const b=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(b.map(C=>({id:C.identifier,reason:{startup:g,extensionId:C.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,g){const b=this.a.getExtensionDescription(d);if(!b)throw new Error(`Extension '${d}' is not known`);return this.h([{id:b.identifier,reason:g}])}async h(d){const g=d.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(g.map(b=>b.wait()))}j(d){if(this.d.has(l.ExtensionIdentifier.toKey(d.id)))return this.d.get(l.ExtensionIdentifier.toKey(d.id));if(this.l(d.id))return this.k(d,null,[],null);const g=this.a.getExtensionDescription(d.id);if(!g){const p=new Error(`Cannot activate unknown extension '${d.id.value}'`),i=this.k(d,null,[],new I(p));return this.c.onExtensionActivationError(d.id,p,new R.MissingExtensionDependency(d.id.value)),i}const b=[],C=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const p of C){if(this.m(p))continue;const i=this.d.get(l.ExtensionIdentifier.toKey(p));if(i){b.push(i);continue}if(this.l(p)){b.push(this.j({id:this.b.getExtensionDescription(p).identifier,reason:d.reason}));continue}const o=this.a.getExtensionDescription(p);if(o){if(!o.main&&!o.browser)continue;b.push(this.j({id:o.identifier,reason:d.reason}));continue}const s=g.displayName||g.identifier.value,c=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${p}'`),r=this.k(d,g.displayName,[],new I(c));return this.c.onExtensionActivationError(g.identifier,c,new R.MissingExtensionDependency(p)),r}return this.k(d,g.displayName,b,null)}k(d,g,b,C){const p=new f(d.id,g,d.reason,b,C,this.c,this.g);return this.d.set(l.ExtensionIdentifier.toKey(d.id),p),p}l(d){return A.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const g=this.b.getExtensionDescription(d);return g?!g.main&&!g.browser:!1}};y=qe([We(3,D.ILogService)],y),e.ExtensionsActivator=y;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,g,b,C,p,i,o){this.c=d,this.d=g,this.f=b,this.g=C,this.h=p,this.j=i,this.k=o,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const g=this.g[d];if(g.value&&!g.value.activationFailed){this.g.splice(d,1),d--;continue}if(g.value&&g.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);b.detail=g.value.activationFailedError,this.h=new I(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const g=new Error;if(d&&d.name&&(g.name=d.name),d&&d.message?g.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(g.stack=d.stack),this.h=new I(g),this.b&&a.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};f=qe([We(6,D.ILogService)],f)});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[7],De([1,0,15,11,112,28,86,8,9,2,30,44,128,92,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y){"use strict";var f,h,d,g,b,C,p,i,o,s,c,r,m,n,t,u,w,S,F,x,V,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function O(G){return Object.assign(G,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(G,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[me,...Pe]=arguments;return Reflect.construct(G,Pe,me.constructor)}}})}var U;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(U=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var $;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})($=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=C=class{static from(...H){let me=H;return new C(function(){if(me){for(const Pe of me)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();me=void 0}})}constructor(H){f.set(this,void 0),_e(this,f,H,"f")}dispose(){typeof Be(this,f,"f")=="function"&&(Be(this,f,"f").call(this),_e(this,f,void 0,"f"))}};f=new WeakMap,j=C=qe([O],j),e.Disposable=j;let le=p=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isBefore(me)&&(me=Ge)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Pe=1;Pe<H.length;Pe++){const Ge=H[Pe];Ge.isAfter(me)&&(me=Ge)}return me}static isPosition(H){if(!H)return!1;if(H instanceof p)return!0;const{line:me,character:Pe}=H;return typeof me=="number"&&typeof Pe=="number"}static of(H){if(H instanceof p)return H;if(this.isPosition(H))return new p(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,A.illegalArgument)("line must be non-negative");if(me<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=0:typeof H=="number"?Pe=H:(Pe=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Pe===0&&me===0?this:new p(this.line+Pe,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return typeof H>"u"?Pe=this.line:typeof H=="number"?Pe=H:(Pe=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Pe===this.line&&me===this.character?this:new p(Pe,me)}toJSON(){return{line:this.line,character:this.character}}};le=p=qe([O],le),e.Position=le;let J=i=class{static isRange(H){return H instanceof i?!0:H?le.isPosition(H.start)&&le.isPosition(H.end):!1}static of(H){if(H instanceof i)return H;if(this.isRange(H))return new i(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Pe,Ge){let Je,at;if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Je=new le(H,me),at=new le(Pe,Ge)):le.isPosition(H)&&le.isPosition(me)&&(Je=le.of(H),at=le.of(me)),!Je||!at)throw new Error("Invalid arguments");Je.isBefore(at)?(this.c=Je,this.e=at):(this.c=at,this.e=Je)}contains(H){return i.isRange(H)?this.contains(H.start)&&this.contains(H.end):le.isPosition(H)?!(le.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=le.Max(H.start,this.c),Pe=le.Min(H.end,this.e);if(!me.isAfter(Pe))return new i(me,Pe)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=le.Min(H.start,this.c),Pe=le.Max(H.end,this.end);return new i(me,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,A.illegalArgument)();let Pe;return H?le.isPosition(H)?Pe=H:(Pe=H.start||this.start,me=H.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Pe,me)}toJSON(){return[this.start,this.end]}};J=i=qe([O],J),e.Range=J;let q=o=class extends J{static isSelection(H){return H instanceof o?!0:H?J.isRange(H)&&le.isPosition(H.anchor)&&le.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Pe,Ge){let Je,at;if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"?(Je=new le(H,me),at=new le(Pe,Ge)):le.isPosition(H)&&le.isPosition(me)&&(Je=le.of(H),at=le.of(me)),!Je||!at)throw new Error("Invalid arguments");super(Je,at),this.f=Je,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=o=qe([O],q),e.Selection=q;class Q{constructor(H,me,Pe){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,A.illegalArgument)("port");if(typeof Pe<"u"&&(typeof Pe!="string"||Pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(Pe)))throw(0,A.illegalArgument)("connectionToken");this.host=H,this.port=Math.round(me),this.connectionToken=Pe}}e.ResolvedAuthority=Q;class Z extends Error{static NotAvailable(H,me){return new Z(H,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new Z(H,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=v.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(H),this._message=H,this._code=me,this._detail=Pe,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var te;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(te=e.EndOfLine||(e.EndOfLine={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let _=s=class{static isTextEdit(H){return H instanceof s?!0:H?J.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new s(H,me)}static insert(H,me){return s.replace(new J(H,H),me)}static delete(H){return s.replace(H,"")}static setEndOfLine(H){const me=new s(new J(new le(0,0),new le(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!J.isRange(H))throw(0,A.illegalArgument)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,A.illegalArgument)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,A.illegalArgument)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};_=s=qe([O],_),e.TextEdit=_;let ie=c=class{static isNotebookCellEdit(H){return H instanceof c?!0:H?xt.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new c(H,me)}static insertCells(H,me){return new c(new xt(H,H),me)}static deleteCells(H){return new c(H,[])}static updateCellMetadata(H,me){const Pe=new c(new xt(H,H),[]);return Pe.newCellMetadata=me,Pe}static updateNotebookMetadata(H){const me=new c(new xt(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};ie=c=qe([O],ie),e.NotebookEdit=ie;class pe{static isSnippetTextEdit(H){return H instanceof pe?!0:H?J.isRange(H.range)&&Oe.isSnippetString(H.snippet):!1}static replace(H,me){return new pe(H,me)}static insert(H,me){return pe.replace(new J(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.SnippetTextEdit=pe;var ve;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let ke=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Pe,Ge){this.c.push({_type:1,from:H,to:me,options:Pe,metadata:Ge})}createFile(H,me,Pe){this.c.push({_type:1,from:void 0,to:H,options:me,metadata:Pe})}deleteFile(H,me,Pe){this.c.push({_type:1,from:H,to:void 0,options:me,metadata:Pe})}e(H,me,Pe){this.c.push({_type:3,metadata:Pe,uri:H,edit:{editType:5,metadata:me},notebookMetadata:me})}f(H,me,Pe,Ge){const Je=me.start,at=me.end;(Je!==at||Pe.length>0)&&this.c.push({_type:5,uri:H,index:Je,count:at-Je,cells:Pe,metadata:Ge})}g(H,me,Pe,Ge){this.c.push({_type:3,metadata:Ge,uri:H,edit:{editType:8,index:me,metadata:Pe}})}replace(H,me,Pe,Ge){this.c.push({_type:2,uri:H,edit:new _(me,Pe),metadata:Ge})}insert(H,me,Pe,Ge){this.replace(H,new J(me,me),Pe,Ge)}delete(H,me,Pe){this.replace(H,me,"",Pe)}has(H){return this.c.some(me=>me._type===2&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Pe of me){if(!Pe)continue;let Ge,Je;Array.isArray(Pe)?(Ge=Pe[0],Je=Pe[1]):Ge=Pe,ie.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(H,Ge.range.start,Ge.newCellMetadata,Je):Ge.newNotebookMetadata?this.e(H,Ge.newNotebookMetadata,Je):this.f(H,Ge.range,Ge.newCells,Je):pe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:H,range:Ge.range,edit:Ge.snippet,metadata:Je}):this.c.push({_type:2,uri:H,edit:Ge,metadata:Je})}else{for(let Pe=0;Pe<this.c.length;Pe++){const Ge=this.c[Pe];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===H.toString()&&(this.c[Pe]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(H){const me=[];for(const Pe of this.c)Pe._type===2&&Pe.uri.toString()===H.toString()&&me.push(Pe.edit);return me}entries(){const H=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Pe=H.get(me.uri);Pe||(Pe=[me.uri,[]],H.set(me.uri,Pe)),Pe[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ke=qe([O],ke),e.WorkspaceEdit=ke;let Oe=r=class{static isSnippetString(H){return H instanceof r?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=r.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Pe=new r;Pe.e=this.e,H(Pe),this.e=Pe.e,H=Pe.value}else H=r.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Pe=H.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Pe=new r;Pe.e=this.e,me(Pe),this.e=Pe.e,me=Pe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Oe=r=qe([O],Oe),e.SnippetString=Oe;var oe;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=m=class{static isLocation(H){return H instanceof m?!0:H?J.isRange(H.range)&&k.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(J.isRange(me))this.range=J.of(me);else if(le.isPosition(me))this.range=new J(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=m=qe([O],fe),e.Location=fe;let ee=class{static is(H){return H?typeof H.message=="string"&&H.location&&J.isRange(H.location.range)&&k.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};ee=qe([O],ee),e.DiagnosticRelatedInformation=ee;let ue=class{constructor(H,me,Pe=ae.Error){if(!J.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Pe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,a.equals)(H.tags,me.tags)&&(0,a.equals)(H.relatedInformation,me.relatedInformation,ee.isEqual)}};ue=qe([O],ue),e.Diagnostic=ue;let se=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};se=qe([O],se),e.Hover=se;var N;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(N=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let W=class{constructor(H,me=N.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:N[this.kind]}}};W=qe([O],W),e.DocumentHighlight=W;var K;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(K=e.SymbolKind||(e.SymbolKind={}));var Y;(function(G){G[G.Deprecated=1]="Deprecated"})(Y=e.SymbolTag||(e.SymbolTag={}));let he=n=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Pe,Ge,Je){this.name=H,this.kind=me,this.containerName=Je,typeof Pe=="string"&&(this.containerName=Pe),Ge instanceof fe?this.location=Ge:Pe instanceof J&&(this.location=new fe(Ge,Pe)),n.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};he=n=qe([O],he),e.SymbolInformation=he;let we=t=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(t.validate)}constructor(H,me,Pe,Ge,Je){this.name=H,this.detail=me,this.kind=Pe,this.range=Ge,this.selectionRange=Je,this.children=[],t.validate(this)}};we=t=qe([O],we),e.DocumentSymbol=we;var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(H,me){this.title=H,this.kind=me}};be=qe([O],be),e.CodeAction=be;let Ce=u=class{constructor(H){this.value=H}append(H){return new u(this.value?this.value+u.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+u.c)}};Ce.c=".",Ce=u=qe([O],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let Te=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Te=qe([O],Te),e.SelectionRange=Te;class Ve{constructor(H,me,Pe,Ge,Je,at){this.kind=H,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.CallHierarchyItem=Ve;class xe{constructor(H,me){this.fromRanges=me,this.from=H}}e.CallHierarchyIncomingCall=xe;class et{constructor(H,me){this.fromRanges=me,this.to=H}}e.CallHierarchyOutgoingCall=et;var Qe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};nt=qe([O],nt),e.CodeLens=nt;let st=w=class{static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){h.set(this,void 0),_e(this,h,new l.MarkdownString(H,{supportThemeIcons:me}),"f")}get value(){return Be(this,h,"f").value}set value(H){Be(this,h,"f").value=H}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted(H){Be(this,h,"f").isTrusted=H}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons(H){Be(this,h,"f").supportThemeIcons=H}get supportHtml(){return Be(this,h,"f").supportHtml}set supportHtml(H){Be(this,h,"f").supportHtml=H}get baseUri(){return Be(this,h,"f").baseUri}set baseUri(H){Be(this,h,"f").baseUri=H}appendText(H){return Be(this,h,"f").appendText(H),this}appendMarkdown(H){return Be(this,h,"f").appendMarkdown(H),this}appendCodeblock(H,me){return Be(this,h,"f").appendCodeblock(me??"",H),this}};h=new WeakMap,st=w=qe([O],st),e.MarkdownString=st;let ht=class{constructor(H,me){this.label=H,this.documentation=me}};ht=qe([O],ht),e.ParameterInformation=ht;let Ue=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};Ue=qe([O],Ue),e.SignatureInformation=Ue;let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};rt=qe([O],rt),e.SignatureHelp=rt;var ce;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ce=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var z;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(z=e.InlayHintKind||(e.InlayHintKind={}));let de=class{constructor(H){this.value=H}};de=qe([O],de),e.InlayHintLabelPart=de;let Ie=class{constructor(H,me,Pe){this.position=H,this.label=me,this.kind=Pe}};Ie=qe([O],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ke;(function(G){G[G.Deprecated=1]="Deprecated"})(Ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([O],Ze),e.CompletionItem=Ze;let pt=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};pt=qe([O],pt),e.CompletionList=pt;let gt=class{constructor(H,me,Pe){this.insertText=H,this.range=me,this.command=Pe}};gt=qe([O],gt),e.InlineSuggestion=gt;let ct=class{constructor(H){this.commands=void 0,this.items=H}};ct=qe([O],ct),e.InlineSuggestionList=ct;var Et;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var tt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(tt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ft;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(ft=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Kt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var mt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(mt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function H(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Rt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(H,me){if(me&&!k.URI.isUri(me))throw(0,A.illegalArgument)("target");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.target=me}};$t=qe([O],$t),e.DocumentLink=$t;let Nt=class{constructor(H,me,Pe,Ge){this.red=H,this.green=me,this.blue=Pe,this.alpha=Ge}};Nt=qe([O],Nt),e.Color=Nt;let Xe=class{constructor(H,me){if(me&&!(me instanceof Nt))throw(0,A.illegalArgument)("color");if(!J.isRange(H)||H.isEmpty)throw(0,A.illegalArgument)("range");this.range=H,this.color=me}};Xe=qe([O],Xe),e.ColorInformation=Xe;let Mt=class{constructor(H){if(!H||typeof H!="string")throw(0,A.illegalArgument)("label");this.label=H}};Mt=qe([O],Mt),e.ColorPresentation=Mt;var Ut;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Ut=e.ColorFormat||(e.ColorFormat={}));var Wt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(Wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(H,me,Pe){if(this.startIndex=H,this.length=me,this.tooltip=Pe,typeof H!="number"||H<0)throw(0,A.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,A.illegalArgument)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Ne{constructor(H){this.uri=H}}e.TerminalQuickFixOpener=Ne;class Se{constructor(H){this.terminalCommand=H}}e.TerminalQuickFixCommand=Se;var re;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(re=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(H){if(this.options=H,typeof H!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Fe;var He;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(He=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let je=S=class{static from(H){switch(H){case"clean":return S.Clean;case"build":return S.Build;case"rebuild":return S.Rebuild;case"test":return S.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,A.illegalArgument)("name");this.c=H}get id(){return this.c}};je.Clean=new S("clean","Clean"),je.Build=new S("build","Build"),je.Rebuild=new S("rebuild","Rebuild"),je.Test=new S("test","Test"),je=S=qe([O],je),e.TaskGroup=je;function it(G){let H="";for(let me=0;me<G.length;me++)H+=G[me].replace(/,/g,",,")+",";return H}let lt=class{constructor(H,me,Pe){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Pe):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,A.illegalArgument)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return it(H)}};lt=qe([O],lt),e.ProcessExecution=lt;let Pt=class{constructor(H,me,Pe){if(this.f=[],Array.isArray(me)){if(!H)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H,this.f=me,this.g=Pe}else{if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,A.illegalArgument)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,A.illegalArgument)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return it(H)}};Pt=qe([O],Pt),e.ShellExecution=Pt;var St;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class kt{constructor(H){this.c=H}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(H){this.c=H}get callback(){return this.c}}e.CustomExecution=kt;let Dt=F=class{constructor(H,me,Pe,Ge,Je,at){this.j=!1,this.k=this.definition=H;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Pe,this.execution=Ge,dt=Je,this.j=!0):me===yt.Global||me===yt.Workspace?(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Je,dt=at):(this.target=me,this.m=this.name=Pe,this.t=this.source=Ge,this.execution=Je,dt=at),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(H){this.h=H}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof kt?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(H){if(H==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=H}get scope(){return this.l}set target(H){this.y(),this.l=H}get name(){return this.m}set name(H){if(typeof H!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=H}get execution(){return this.n}set execution(H){H===null&&(H=void 0),this.y(),this.n=H;const me=this.k.type;(F.g===me||F.e===me||F.f===me||F.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(H){if(Array.isArray(H))this.y(),this.o=H,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.y(),this.r=H}get source(){return this.t}set source(H){if(typeof H!="string"||H.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=H}get group(){return this.u}set group(H){H===null&&(H=void 0),this.y(),this.u=H}get detail(){return this.x}set detail(H){H===null&&(H=void 0),this.x=H}get presentationOptions(){return this.v}set presentationOptions(H){H==null&&(H=Object.create(null)),this.y(),this.v=H}get runOptions(){return this.w}set runOptions(H){H==null&&(H=Object.create(null)),this.y(),this.w=H}};Dt.c="customExecution",Dt.e="process",Dt.f="shell",Dt.g="$empty",Dt=F=qe([O],Dt),e.Task=Dt;var Ct;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Ct=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(G){function H(me){const Pe=me;return(0,E.isNumber)(Pe.value)?Pe.tooltip&&!(0,E.isString)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}G.isViewBadge=H})(qt=e.ViewBadge||(e.ViewBadge={}));let _t=x=class{static isTreeItem(H,me){if(H instanceof x)return!0;const Pe=H;if(Pe.label!==void 0&&!(0,E.isString)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,E.isString)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,E.isString)(Pe.iconPath)&&!k.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,E.isString)(Pe.iconPath.id))){const Ge=Pe.iconPath;if(!Ge||!(0,E.isString)(Ge.light)&&!k.URI.isUri(Ge.light)&&!(0,E.isString)(Ge.dark)&&!k.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}if(Pe.description!==void 0&&!(0,E.isString)(Pe.description)&&typeof Pe.description!="boolean")return console.log("INVALID tree item, invalid description",Pe.description),!1;if(Pe.resourceUri!==void 0&&!k.URI.isUri(Pe.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1;if(Pe.tooltip!==void 0&&!(0,E.isString)(Pe.tooltip)&&!(Pe.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1;if(Pe.command!==void 0&&!Pe.command.command)return console.log("INVALID tree item, invalid command",Pe.command),!1;if(Pe.collapsibleState!==void 0&&Pe.collapsibleState<wt.None&&Pe.collapsibleState>wt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1;if(Pe.contextValue!==void 0&&!(0,E.isString)(Pe.contextValue))return console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1;if(Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1;if(Pe.checkboxState!==void 0){(0,y.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ge=(0,E.isNumber)(Pe.checkboxState)?Pe.checkboxState:(0,E.isObject)(Pe.checkboxState)&&(0,E.isNumber)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Je=!(0,E.isNumber)(Pe.checkboxState)&&(0,E.isObject)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==si.Checked&&Ge!==si.Unchecked||Je!==void 0&&!(0,E.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}return!0}constructor(H,me=wt.None){this.collapsibleState=me,k.URI.isUri(H)?this.resourceUri=H:this.label=H}};_t=x=qe([O],_t),e.TreeItem=_t;var wt;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H,me){this.value=H,this.id=me??(0,L.generateUuid)()}};oi=qe([O],oi),e.DataTransferItem=oi;let Zt=class{constructor(H){d.set(this,new Map);for(const[me,Pe]of H??[]){const Ge=Be(this,d,"f").get(me);Ge?Ge.push(Pe):Be(this,d,"f").set(me,[Pe])}}get(H){return Be(this,d,"f").get(H)?.[0]}set(H,me){Be(this,d,"f").set(H,[me])}forEach(H,me){for(const[Pe,Ge]of Be(this,d,"f"))for(const Je of Ge)H.call(me,Je,Pe,this)}*[(d=new WeakMap,Symbol.iterator)](){for(const[H,me]of Be(this,d,"f"))for(const Pe of me)yield[H,Pe]}};Zt=qe([O],Zt),e.DataTransfer=Zt;let bi=class{constructor(H){this.insertText=H}};bi=qe([O],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(H){this.insertText=H}};Lt=qe([O],Lt),e.DocumentPasteEdit=Lt;let Ht=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};Ht=qe([O],Ht),e.ThemeIcon=Ht,Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let vi=class{constructor(H){this.id=H}};vi=qe([O],vi),e.ThemeColor=vi;var ai;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(H){this.c=H,this.e=k.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!k.URI.isUri(H)&&!k.URI.isUri(H.uri)))throw(0,A.illegalArgument)("base");if(typeof me!="string")throw(0,A.illegalArgument)("pattern");typeof H=="string"?this.baseUri=k.URI.file(H):k.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([O],ei),e.RelativePattern=ei;const ut=new WeakMap;function Bi(G,H){ut.set(G,H)}e.setBreakpointId=Bi;let Bt=class{constructor(H,me,Pe,Ge){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Pe=="string"&&(this.hitCondition=Pe),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=ut.get(this)??(0,L.generateUuid)()),this.c}};Bt=qe([O],Bt),e.Breakpoint=Bt;let Qt=class extends Bt{constructor(H,me,Pe,Ge,Je){if(super(me,Pe,Ge,Je),H===null)throw(0,A.illegalArgument)("location");this.location=H}};Qt=qe([O],Qt),e.SourceBreakpoint=Qt;let ci=class extends Bt{constructor(H,me,Pe,Ge,Je){super(me,Pe,Ge,Je),this.functionName=H}};ci=qe([O],ci),e.FunctionBreakpoint=ci;let wi=class extends Bt{constructor(H,me,Pe,Ge,Je,at,dt){if(super(Ge,Je,at,dt),!me)throw(0,A.illegalArgument)("dataId");this.label=H,this.dataId=me,this.canPersist=Pe}};wi=qe([O],wi),e.DataBreakpoint=wi;let Ei=class{constructor(H,me,Pe){this.command=H,this.args=me||[],this.options=Pe}};Ei=qe([O],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(H,me){this.port=H,this.host=me}};li=qe([O],li),e.DebugAdapterServer=li;let Si=class{constructor(H){this.path=H}};Si=qe([O],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(H){this.implementation=H}};ui=qe([O],ui),e.DebugAdapterInlineImplementation=ui;let ti=class{constructor(H,me){this.range=H,this.expression=me}};ti=qe([O],ti),e.EvaluatableExpression=ti;var $i;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(H,me){this.range=H,this.text=me}};ii=qe([O],ii),e.InlineValueText=ii;let ni=class{constructor(H,me,Pe=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Pe}};ni=qe([O],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(H,me){this.range=H,this.expression=me}};yi=qe([O],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};Di=qe([O],Di),e.InlineValueContext=Di;var ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ci=V=class extends Error{static FileExists(H){return new V(H,T.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(H){return new V(H,T.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(H){return new V(H,T.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(H){return new V(H,T.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(H){return new V(H,T.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(H){return new V(H,T.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(H,me=T.FileSystemProviderErrorCode.Unknown,Pe){super(k.URI.isUri(H)?H.toString(!0):H),this.code=Pe?.name??"Unknown",(0,T.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};Ci=V=qe([O],Ci),e.FileSystemError=Ci;let Ii=class{constructor(H,me,Pe){this.start=H,this.end=me,this.kind=Pe}};Ii=qe([O],Ii),e.FoldingRange=Ii;var zi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.SemanticTokensLegend=Ri;function Li(G){return typeof G>"u"||(0,E.isStringArray)(G)}class ze{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,H){this.l=!0;for(let me=0,Pe=H.tokenTypes.length;me<Pe;me++)this.j.set(H.tokenTypes[me],me);for(let me=0,Pe=H.tokenModifiers.length;me<Pe;me++)this.k.set(H.tokenModifiers[me],me)}}push(H,me,Pe,Ge,Je){if(typeof H=="number"&&typeof me=="number"&&typeof Pe=="number"&&typeof Ge=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(H,me,Pe,Ge,Je);if(J.isRange(H)&&typeof me=="string"&&Li(Pe))return this.m(H,me,Pe);throw(0,A.illegalArgument)()}m(H,me,Pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ge=H.start.line,Je=H.start.character,at=H.end.character-H.start.character,dt=this.j.get(me);let Ft=0;if(Pe)for(const Vt of Pe){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const Gt=this.k.get(Vt);Ft|=1<<Gt>>>0}this.n(Ge,Je,at,dt,Ft)}n(H,me,Pe,Ge,Je){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const Ft=this.g.length/5|0;let Vt=0,Gt=0;for(let Xt=0;Xt<Ft;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=Gt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,Gt=Pi}}let at=H,dt=me;this.f&&this.h>0&&(at-=this.c,at===0&&(dt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=dt,this.g[this.h++]=Pe,this.g[this.h++]=Ge,this.g[this.h++]=Je,this.c=H,this.e=me}static o(H){const me=[],Pe=H.length/5|0;for(let dt=0;dt<Pe;dt++)me[dt]=dt;me.sort((dt,Ft)=>{const Vt=H[5*dt],Gt=H[5*Ft];if(Vt===Gt){const Xt=H[5*dt+1],Yt=H[5*Ft+1];return Xt-Yt}return Vt-Gt});const Ge=new Uint32Array(H.length);let Je=0,at=0;for(let dt=0;dt<Pe;dt++){const Ft=5*me[dt],Vt=H[Ft+0],Gt=H[Ft+1],Xt=H[Ft+2],Yt=H[Ft+3],Pi=H[Ft+4],sn=Vt-Je,Rn=sn===0?Gt-at:Gt,Ai=5*dt;Ge[Ai+0]=sn,Ge[Ai+1]=Rn,Ge[Ai+2]=Xt,Ge[Ai+3]=Yt,Ge[Ai+4]=Pi,Je=Vt,at=Gt}return Ge}build(H){return this.f?new jt(new Uint32Array(this.g),H):new jt(ze.o(this.g),H)}}e.SemanticTokensBuilder=ze;class jt{constructor(H,me){this.resultId=me,this.data=H}}e.SemanticTokens=jt;class Oi{constructor(H,me,Pe){this.start=H,this.deleteCount=me,this.data=Pe}}e.SemanticTokensEdit=Oi;class vt{constructor(H,me){this.resultId=me,this.edits=H}}e.SemanticTokensEdits=vt;var ji;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Ht("arrow-left")},di=qe([O],di),e.QuickInputButtons=di;var Ni;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(H){if(typeof H.badge=="string"){let me=(0,P.nextCharLength)(H.badge,0);if(me<H.badge.length&&(me+=(0,P.nextCharLength)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!Ht.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Pe){this.badge=H,this.tooltip=me,this.color=Pe}}e.FileDecoration=qi;let Ti=class{constructor(H){this.kind=H}};Ti=qe([O],Ti),e.ColorTheme=Ti;var xi;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(xi=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(H){return H instanceof xt?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,A.illegalArgument)("start must be positive");if(me<0)throw(0,A.illegalArgument)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Pe=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Pe=H.end),me===this.c&&Pe===this.e?this:new xt(me,Pe)}}e.NotebookRange=xt;class fi{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>fi.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Pe,Ge,Je,at,dt){this.kind=H,this.value=me,this.languageId=Pe,this.mime=Ge,this.outputs=Je??[],this.metadata=at,this.executionSummary=dt,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(H){this.cells=H}}e.NotebookData=Gi;class zt{static isNotebookCellOutputItem(H){return H instanceof zt?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return zt.json(me,"application/vnd.code.notebook.error")}static stdout(H){return zt.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return zt.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new zt(H,me)}static text(H,me=D.Mimes.text){const Pe=Be(zt,g,"f",b).encode(String(H));return new zt(Pe,me)}static json(H,me="text/x-json"){const Pe=JSON.stringify(H,void 0,"	");return zt.text(Pe,me)}constructor(H,me){this.data=H,this.mime=me;const Pe=(0,D.normalizeMimeType)(me,!0);if(!Pe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}g=zt,b={value:new TextEncoder},e.NotebookCellOutputItem=zt;class mi{static isNotebookCellOutput(H){return H instanceof mi?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Pe=new Set,Ge=new Set;for(let Je=0;Je<H.length;Je++){const at=H[Je],dt=(0,D.normalizeMimeType)(at.mime);if(!Pe.has(dt)||(0,I.isTextStreamMime)(dt)){Pe.add(dt);continue}Ge.add(Je),me&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?H:H.filter((Je,at)=>!Ge.has(at))}constructor(H,me,Pe){this.items=mi.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Pe):(this.id=(0,L.generateUuid)(),this.metadata=me??Pe)}}e.NotebookCellOutput=mi;var Ki;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ge;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ge=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(H,me){this.text=H,this.alignment=me}}e.NotebookCellStatusBarItem=Me;var ot;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(H,me=[]){this.uri=H,this.provides=(0,a.asArray)(me)}}e.NotebookRendererScript=Ot;class ln{constructor(H){this.label=H}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(H,me){this.label=H,this.timestamp=me}};Qi=qe([O],Qi),e.TimelineItem=Qi;var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.LinkedEditingRanges=fn;class mn{constructor(H,me){this.c=H,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(H=void 0,me=void 0,Pe=void 0){this.include=H,this.exclude=me,this.profile=Pe}};Fi=qe([O],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(H=void 0,me=void 0,Pe=void 0,Ge=!1){super(H,me,Pe),this.continuous=Ge}};Yi=qe([O],Yi),e.TestRunRequest2=Yi;let Ji=M=class{static diff(H,me,Pe){const Ge=new M(H);return Ge.expectedOutput=me,Ge.actualOutput=Pe,Ge}constructor(H){this.message=H}};Ji=M=qe([O],Ji),e.TestMessage=Ji;let _i=class{constructor(H){this.id=H}};_i=qe([O],_i),e.TestTag=_i;let gi=class{constructor(H,me){this.covered=H,this.total=me}};gi=qe([O],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(H,me){const Pe=new gi(0,0),Ge=new gi(0,0),Je=new gi(0,0);for(const dt of me)if("branches"in dt){Pe.total+=1,Pe.covered+=dt.executionCount>0?1:0;for(const Ft of dt.branches)Ge.total+=1,Ge.covered+=Ft.executionCount>0?1:0}else Je.total+=1,Je.covered+=dt.executionCount>0?1:0;const at=new B(H,Pe,Ge.total>0?Ge:void 0,Je.total>0?Je:void 0);return at.detailedCoverage=me,at}constructor(H,me,Pe,Ge){this.uri=H,this.statementCoverage=me,this.branchCoverage=Pe,this.functionCoverage=Ge}};Zi=B=qe([O],Zi),e.FileCoverage=Zi;let en=class{constructor(H,me,Pe=[]){this.executionCount=H,this.location=me,this.branches=Pe}};en=qe([O],en),e.StatementCoverage=en;let tn=class{constructor(H,me){this.executionCount=H,this.location=me}};tn=qe([O],tn),e.BranchCoverage=tn;let nn=class{constructor(H,me){this.executionCount=H,this.location=me}};nn=qe([O],nn),e.FunctionCoverage=nn;var bn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(H,me,Pe,Ge,Je,at){this.kind=H,this.name=me,this.detail=Pe,this.uri=Ge,this.range=Je,this.selectionRange=at}}e.TypeHierarchyItem=En;class Sn{constructor(H){this.uri=H}}e.TextTabInput=Sn;class yn{constructor(H,me){this.original=H,this.modified=me}}e.TextDiffTabInput=yn;class Dn{constructor(H,me,Pe,Ge){this.base=H,this.input1=me,this.input2=Pe,this.result=Ge}}e.TextMergeTabInput=Dn;class Cn{constructor(H,me){this.uri=H,this.viewType=me}}e.CustomEditorTabInput=Cn;class In{constructor(H){this.viewType=H}}e.WebviewEditorTabInput=In;class kn{constructor(H,me){this.uri=H,this.notebookType=me}}e.NotebookEditorTabInput=kn;class Tn{constructor(H,me,Pe){this.original=H,this.modified=me,this.notebookType=Pe}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,165,106,7,15]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const k=new Map;function L(y,f){f?k.set(y,f):k.delete(y)}e.setWordDefinitionFor=L;function T(y){return k.get(y)}class v extends R.MirrorTextModel{constructor(f,h,d,g,b,C,p,i){super(h,d,g,b),this.m=f,this.p=C,this.q=p,this.notebook=i,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,E.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===A.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(h){return h?f.s(h):f.getText()},get eol(){return f.f===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(h){return f.t(h)},offsetAt(h){return f.u(h)},positionAt(h){return f.v(h)},validateRange(h){return f.w(h)},validatePosition(h){return f.x(h)},getWordRangeAtPosition(h,d){return f.y(h,d)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,a.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,a.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const h=this.w(f);if(h.isEmpty)return"";if(h.isSingleLine)return this.d[h.start.line].substring(h.start.character,h.end.character);const d=this.f,g=h.start.line,b=h.end.line,C=[];C.push(this.d[g].substring(h.start.character));for(let p=g+1;p<b;p++)C.push(this.d[p]);return C.push(this.d[b].substring(0,h.end.character)),C.join(d)}t(f){let h;if(f instanceof P.Position?h=f.line:typeof f=="number"&&(h=f),typeof h!="number"||h<0||h>=this.d.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new I(h,this.d[h],h===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const h=this.h.getIndexOf(f),d=this.d[h.index].length;return new P.Position(h.index,Math.min(h.remainder,d))}w(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const h=this.x(f.start),d=this.x(f.end);return h===f.start&&d===f.end?f:new P.Range(h.line,h.character,d.line,d.character)}x(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:h,character:d}=f,g=!1;if(h<0)h=0,d=0,g=!0;else if(h>=this.d.length)h=this.d.length-1,d=this.d[h].length,g=!0;else{const b=this.d[h].length;d<0?(d=0,g=!0):d>b&&(d=b,g=!0)}return g?new P.Position(h,d):f}y(f,h){const d=this.x(f);if(!h)h=T(this.p);else if((0,l.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const g=(0,D.getWordAtText)(d.character+1,(0,D.ensureValidWordDefinition)(h),this.d[d.line],0);if(g)return new P.Range(d.line,g.startColumn-1,d.line,g.endColumn-1)}}e.ExtHostDocumentData=v;class I{constructor(f,h,d){this.a=f,this.b=h,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=I}),define(ye[239],De([1,0,7,20,3]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(P){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let E;switch(P){case"light":E=a.ColorThemeKind.Light;break;case"hcDark":E=a.ColorThemeKind.HighContrast;break;case"hcLight":E=a.ColorThemeKind.HighContrastLight;break;default:E=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,149,63,112,28,147,69,86,23,9,2,32,71,124,132,130,92,57,75,235,7]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(Re){function Ne(re){const{selectionStartLineNumber:Fe,selectionStartColumn:He,positionLineNumber:Ye,positionColumn:je}=re,it=new o.Position(Fe-1,He-1),lt=new o.Position(Ye-1,je-1);return new o.Selection(it,lt)}Re.to=Ne;function Se(re){const{anchor:Fe,active:He}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Re.from=Se})(s=e.Selection||(e.Selection={}));var c;(function(Re){function Ne(re){if(!re)return;const{start:Fe,end:He}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Re.from=Ne;function Se(re){if(!re)return;const{startLineNumber:Fe,startColumn:He,endLineNumber:Ye,endColumn:je}=re;return new o.Range(Fe-1,He-1,Ye-1,je-1)}Re.to=Se})(c=e.Range||(e.Range={}));var r;(function(Re){function Ne(Se){switch(Se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Re.to=Ne})(r=e.TokenType||(e.TokenType={}));var m;(function(Re){function Ne(re){return new o.Position(re.lineNumber-1,re.column-1)}Re.to=Ne;function Se(re){return{lineNumber:re.line+1,column:re.character+1}}Re.from=Se})(m=e.Position||(e.Position={}));var n;(function(Re){function Ne(Fe,He){return(0,a.coalesce)((0,a.asArray)(Fe).map(Ye=>Se(Ye,He)))}Re.from=Ne;function Se(Fe,He){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,He),pattern:z.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function re(Fe,He){return He&&typeof Fe=="string"?He.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Re){function Ne(re){switch(re){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Re.from=Ne;function Se(re){switch(re){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(Re){function Ne(re){let Fe;return re.code&&((0,v.isString)(re.code)||(0,v.isNumber)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Fe,severity:S.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(w.from),tags:Array.isArray(re.tags)?(0,a.coalesce)(re.tags.map(t.from)):void 0}}Re.from=Ne;function Se(re){const Fe=new o.Diagnostic(c.to(re),re.message,S.to(re.severity));return Fe.source=re.source,Fe.code=(0,v.isString)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(w.to),Fe.tags=re.tags&&(0,a.coalesce)(re.tags.map(t.to)),Fe}Re.to=Se})(u=e.Diagnostic||(e.Diagnostic={}));var w;(function(Re){function Ne(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Re.from=Ne;function Se(re){return new o.DiagnosticRelatedInformation(new o.Location(re.resource,c.to(re)),re.message)}Re.to=Se})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var S;(function(Re){function Ne(re){switch(re){case o.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Re.from=Ne;function Se(re){switch(re){case h.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Re.to=Se})(S=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var F;(function(Re){function Ne(re){return typeof re=="number"&&re>=o.ViewColumn.One?re-1:re===o.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Ne;function Se(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(F=e.ViewColumn||(e.ViewColumn={}));function x(Re){return typeof Re.range<"u"}function V(Re){return Re.length===0?!0:!!x(Re[0])}e.isDecorationOptionsArr=V;var M;(function(Re){function Ne(je){return je.map(Re.from)}Re.fromMany=Ne;function Se(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function re(je){let it;if(Se(je)){const{language:yt,value:kt}=je;it={value:"```"+yt+`
`+kt+"\n```\n"}}else o.MarkdownString.isMarkdownString(je)?it={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?it={value:je}:it={value:""};const lt=Object.create(null);it.uris=lt;const Pt=yt=>{try{let kt=I.URI.parse(yt,!0);kt=kt.with({query:Fe(kt.query,lt)}),lt[yt]=kt}catch{}return""},St=new E.marked.Renderer;return St.link=Pt,St.image=yt=>typeof yt=="string"?Pt(D.parseHrefAndDimensions(yt).href):"",(0,E.marked)(it.value,{renderer:St}),it}Re.from=re;function Fe(je,it){if(!je)return je;let lt;try{lt=(0,k.parse)(je)}catch{}if(!lt)return je;let Pt=!1;return lt=(0,T.cloneAndChange)(lt,St=>{if(I.URI.isUri(St)){const yt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[yt]=St,Pt=!0,yt}else return}),Pt?JSON.stringify(lt):je}function He(je){const it=new o.MarkdownString(je.value,je.supportThemeIcons);return it.isTrusted=je.isTrusted,it.supportHtml=je.supportHtml,it.baseUri=je.baseUri?I.URI.from(je.baseUri):void 0,it}Re.to=He;function Ye(je){if(!!je)return typeof je=="string"?je:Re.from(je)}Re.fromStrict=Ye})(M=e.MarkdownString||(e.MarkdownString={}));function B(Re){return V(Re)?Re.map(Ne=>({range:c.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?M.fromMany(Ne.hoverMessage):Ne.hoverMessage?M.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Re.map(Ne=>({range:c.from(Ne)}))}e.fromRangeOrRangeWithMessage=B;function O(Re){return typeof Re>"u"?Re:typeof Re=="string"?I.URI.file(Re):Re}e.pathOrURIToURI=O;var U;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?O(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Ne})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var $;(function(Re){function Ne(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})($=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(Re){function Ne(Se){if(typeof Se>"u")return Se;switch(Se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Ne})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var le;(function(Re){function Ne(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?j.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?$.from(Se.light):void 0,dark:Se.dark?$.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?O(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Re.from=Ne})(le=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var J;(function(Re){function Ne(re){return{text:re.newText,eol:re.newEol&&st.from(re.newEol),range:c.from(re.range)}}Re.from=Ne;function Se(re){const Fe=new o.TextEdit(c.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:st.to(re.eol),Fe}Re.to=Se})(J=e.TextEdit||(e.TextEdit={}));var q;(function(Re){function Ne(re,Fe){const He={edits:[]};if(re instanceof o.WorkspaceEdit){const Ye=new P.ResourceSet;for(const je of re._allEntries())je._type===1&&I.URI.isUri(je.to)&&je.from===void 0&&Ye.add(je.to);for(const je of re._allEntries())je._type===1?He.edits.push({oldResource:je.from,newResource:je.to,options:{...je.options,contentsBase64:je.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(je.options.contents))},metadata:je.metadata}):je._type===2?He.edits.push({resource:je.uri,textEdit:J.from(je.edit),versionId:Ye.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===6?He.edits.push({resource:je.uri,textEdit:{range:c.from(je.range),text:je.edit.value,insertAsSnippet:!0},versionId:Ye.has(je.uri)?void 0:Fe?.getTextDocumentVersion(je.uri),metadata:je.metadata}):je._type===3?He.edits.push({metadata:je.metadata,resource:je.uri,cellEdit:je.edit,notebookMetadata:je.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri)}):je._type===5&&He.edits.push({metadata:je.metadata,resource:je.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(je.uri),cellEdit:{editType:1,index:je.index,count:je.count,cells:je.cells.map(pt.from)}})}return He}Re.from=Ne;function Se(re){const Fe=new o.WorkspaceEdit;for(const He of re.edits)He.textEdit?Fe.replace(I.URI.revive(He.resource),c.to(He.textEdit.range),He.textEdit.text):Fe.renameFile(I.URI.revive(He.oldResource),I.URI.revive(He.newResource),He.options);return Fe}Re.to=Se})(q=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Q;(function(Re){const Ne=Object.create(null);Ne[o.SymbolKind.File]=0,Ne[o.SymbolKind.Module]=1,Ne[o.SymbolKind.Namespace]=2,Ne[o.SymbolKind.Package]=3,Ne[o.SymbolKind.Class]=4,Ne[o.SymbolKind.Method]=5,Ne[o.SymbolKind.Property]=6,Ne[o.SymbolKind.Field]=7,Ne[o.SymbolKind.Constructor]=8,Ne[o.SymbolKind.Enum]=9,Ne[o.SymbolKind.Interface]=10,Ne[o.SymbolKind.Function]=11,Ne[o.SymbolKind.Variable]=12,Ne[o.SymbolKind.Constant]=13,Ne[o.SymbolKind.String]=14,Ne[o.SymbolKind.Number]=15,Ne[o.SymbolKind.Boolean]=16,Ne[o.SymbolKind.Array]=17,Ne[o.SymbolKind.Object]=18,Ne[o.SymbolKind.Key]=19,Ne[o.SymbolKind.Null]=20,Ne[o.SymbolKind.EnumMember]=21,Ne[o.SymbolKind.Struct]=22,Ne[o.SymbolKind.Event]=23,Ne[o.SymbolKind.Operator]=24,Ne[o.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Ne[Fe]=="number"?Ne[Fe]:6}Re.from=Se;function re(Fe){for(const He in Ne)if(Ne[He]===Fe)return Number(He);return o.SymbolKind.Property}Re.to=re})(Q=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Re){function Ne(re){switch(re){case o.SymbolTag.Deprecated:return 1}}Re.from=Ne;function Se(re){switch(re){case 1:return o.SymbolTag.Deprecated}}Re.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var te;(function(Re){function Ne(re){return{name:re.name,kind:Q.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:ve.from(re.location)}}Re.from=Ne;function Se(re){const Fe=new o.SymbolInformation(re.name,Q.to(re.kind),re.containerName,ve.to(re.location));return Fe.tags=re.tags&&re.tags.map(Z.to),Fe}Re.to=Se})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Ne(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:Q.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Fe.children=re.children.map(Ne)),Fe}Re.from=Ne;function Se(re){const Fe=new o.DocumentSymbol(re.name,re.detail,Q.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,a.isNonEmptyArray)(re.tags)&&(Fe.tags=re.tags.map(Z.to)),re.children&&(Fe.children=re.children.map(Se)),Fe}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var _;(function(Re){function Ne(re){const Fe=new o.CallHierarchyItem(Q.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Ne;function Se(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,name:re.name,detail:re.detail,kind:Q.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(_=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ie;(function(Re){function Ne(Se){return new o.CallHierarchyIncomingCall(_.to(Se.from),Se.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(ie=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(Re){function Ne(Se){return new o.CallHierarchyOutgoingCall(_.to(Se.to),Se.fromRanges.map(re=>c.to(re)))}Re.to=Ne})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Re){function Ne(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Re.from=Ne;function Se(re){return new o.Location(I.URI.revive(re.uri),c.to(re.range))}Re.to=Se})(ve=e.location||(e.location={}));var ke;(function(Re){function Ne(re){const Fe=re,He=re;return{originSelectionRange:Fe.originSelectionRange?c.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:He.uri,range:c.from(Fe.targetRange?Fe.targetRange:He.range),targetSelectionRange:Fe.targetSelectionRange?c.from(Fe.targetSelectionRange):void 0}}Re.from=Ne;function Se(re){return{targetUri:I.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Re.to=Se})(ke=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(Re){function Ne(re){return{range:c.from(re.range),contents:M.fromMany(re.contents)}}Re.from=Ne;function Se(re){return new o.Hover(re.contents.map(M.to),c.to(re.range))}Re.to=Se})(Oe=e.Hover||(e.Hover={}));var oe;(function(Re){function Ne(re){return{range:c.from(re.range),expression:re.expression}}Re.from=Ne;function Se(re){return new o.EvaluatableExpression(c.to(re.range),re.expression)}Re.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Re){function Ne(re){if(re instanceof o.InlineValueText)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof o.InlineValueVariableLookup)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Ne;function Se(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Re.to=Se})(ae=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Ne(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Re.from=Ne;function Se(re){return new o.InlineValueContext(re.frameId,c.to(re.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Ne(re){return{range:c.from(re.range),kind:re.kind}}Re.from=Ne;function Se(re){return new o.DocumentHighlight(c.to(re.range),re.kind)}Re.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var ue;(function(Re){function Ne(Se){switch(Se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Re.to=Ne})(ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(Re){function Ne(Se){return{triggerKind:ue.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Ne})(se=e.CompletionContext||(e.CompletionContext={}));var N;(function(Re){function Ne(re){switch(re){case o.CompletionItemTag.Deprecated:return 1}}Re.from=Ne;function Se(re){switch(re){case 1:return o.CompletionItemTag.Deprecated}}Re.to=Se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var W;(function(Re){const Ne=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function Se(He){return Ne.get(He)??9}Re.from=Se;const re=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Fe(He){return re.get(He)??o.CompletionItemKind.Property}Re.to=Fe})(W=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(Re){function Ne(Se,re){const Fe=new o.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=W.to(Se.kind),Fe.tags=Se.tags?.map(N.to),Fe.detail=Se.detail,Fe.documentation=D.isMarkdownString(Se.documentation)?M.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,y.Range.isIRange(Se.range)?Fe.range=c.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:c.to(Se.range.insert),replacing:c.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new o.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof o.Range?new o.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(He=>J.to(He))),Fe.command=re&&Se.command?re.fromInternal(Se.command):void 0,Fe}Re.to=Ne})(K=e.CompletionItem||(e.CompletionItem={}));var Y;(function(Re){function Ne(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:M.fromStrict(re.documentation)}}Re.from=Ne;function Se(re){return{label:re.label,documentation:D.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation}}Re.to=Se})(Y=e.ParameterInformation||(e.ParameterInformation={}));var he;(function(Re){function Ne(re){return{label:re.label,documentation:M.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Y.from):[],activeParameter:re.activeParameter}}Re.from=Ne;function Se(re){return{label:re.label,documentation:D.isMarkdownString(re.documentation)?M.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Y.to):[],activeParameter:re.activeParameter}}Re.to=Se})(he=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Ne(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.from):[]}}Re.from=Ne;function Se(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(he.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Ne(Se,re){const Fe=new o.InlayHint(m.to(re.position),typeof re.label=="string"?re.label:re.label.map(be.to.bind(void 0,Se)),re.kind&&Ce.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(J.to),Fe.tooltip=D.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Re.to=Ne})(Ae=e.InlayHint||(e.InlayHint={}));var be;(function(Re){function Ne(Se,re){const Fe=new o.InlayHintLabelPart(re.label);return Fe.tooltip=D.isMarkdownString(re.tooltip)?M.to(re.tooltip):re.tooltip,f.Command.is(re.command)&&(Fe.command=Se.fromInternal(re.command)),re.location&&(Fe.location=ve.to(re.location)),Fe}Re.to=Ne})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Re){function Ne(re){return re}Re.from=Ne;function Se(re){return re}Re.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var Te;(function(Re){function Ne(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Re.from=Ne;function Se(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?I.URI.parse(re.url,!0):I.URI.revive(re.url)}catch{}return new o.DocumentLink(c.to(re.range),Fe)}Re.to=Se})(Te=e.DocumentLink||(e.DocumentLink={}));var Ve;(function(Re){function Ne(re){const Fe=new o.ColorPresentation(re.label);return re.textEdit&&(Fe.textEdit=J.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map(He=>J.to(He))),Fe}Re.to=Ne;function Se(re){return{label:re.label,textEdit:re.textEdit?J.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>J.from(Fe)):void 0}}Re.from=Se})(Ve=e.ColorPresentation||(e.ColorPresentation={}));var xe;(function(Re){function Ne(re){return new o.Color(re[0],re[1],re[2],re[3])}Re.to=Ne;function Se(re){return[re.red,re.green,re.blue,re.alpha]}Re.from=Se})(xe=e.Color||(e.Color={}));var et;(function(Re){function Ne(re){return{range:c.from(re.range)}}Re.from=Ne;function Se(re){return new o.SelectionRange(c.to(re.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Re){function Ne(Se){switch(Se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Re.to=Ne})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Ne(re){switch(re){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Ne;function Se(re){switch(re){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Ne(re){if(re===o.EndOfLine.CRLF)return 1;if(re===o.EndOfLine.LF)return 0}Re.from=Ne;function Se(re){if(re===1)return o.EndOfLine.CRLF;if(re===0)return o.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Ne(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Ne})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Ue;(function(Re){function Ne(re){const Fe={start:re.start+1,end:re.end+1};return re.kind&&(Fe.kind=rt.from(re.kind)),Fe}Re.from=Ne;function Se(re){const Fe={start:re.start-1,end:re.end-1};return re.kind&&(Fe.kind=rt.to(re.kind)),Fe}Re.to=Se})(Ue=e.FoldingRange||(e.FoldingRange={}));var rt;(function(Re){function Ne(re){if(re)switch(re){case o.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Re.from=Ne;function Se(re){if(re)switch(re.value){case f.FoldingRangeKind.Comment.value:return o.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return o.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return o.FoldingRangeKind.Region}}Re.to=Se})(rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ce;(function(Re){function Ne(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?c.from(Se.selection):void 0,override:typeof Se.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Ne})(ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var z;(function(Re){function Ne(He){return He instanceof o.RelativePattern?He.toJSON():typeof He=="string"?He:Se(He)||re(He)?new o.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Re.from=Ne;function Se(He){const Ye=He;return Ye?I.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function re(He){const Ye=He;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(He){return typeof He=="string"?He:new o.RelativePattern(I.URI.revive(He.baseUri),He.pattern)}Re.to=Fe})(z=e.GlobPattern||(e.GlobPattern={}));var de;(function(Re){function Ne(Se){if(Se){if(Array.isArray(Se))return Se.map(Ne);if(typeof Se=="string")return Se;{const re=Se;return{language:re.language,scheme:re.scheme,pattern:z.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Re.from=Ne})(de=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Ne(re){return{start:re.start,end:re.end}}Re.from=Ne;function Se(re){return new o.NotebookRange(re.start,re.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Ne(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Re.to=Ne;function Se(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(Re){function Ne(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Ne})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ke;(function(Re){function Ne(re){switch(re){case o.NotebookCellKind.Markup:return b.CellKind.Markup;case o.NotebookCellKind.Code:default:return b.CellKind.Code}}Re.from=Ne;function Se(re){switch(re){case b.CellKind.Markup:return o.NotebookCellKind.Markup;case b.CellKind.Code:default:return o.NotebookCellKind.Code}}Re.to=Se})(Ke=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Ne(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)o.NotebookCellData.validate(He),Fe.cells.push(pt.from(He));return Fe}Re.from=Ne;function Se(re){const Fe=new o.NotebookData(re.cells.map(pt.to));return(0,v.isEmptyObject)(re.metadata)||(Fe.metadata=re.metadata),Fe}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var pt;(function(Re){function Ne(re){return{cellKind:Ke.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Le.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(ct.from):[]}}Re.from=Ne;function Se(re){return new o.NotebookCellData(Ke.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(ct.to):void 0,re.metadata,re.internalMetadata?Le.to(re.internalMetadata):void 0)}Re.to=Se})(pt=e.NotebookCellData||(e.NotebookCellData={}));var gt;(function(Re){function Ne(re){return{mime:re.mime,valueBytes:A.VSBuffer.wrap(re.data)}}Re.from=Ne;function Se(re){return new o.NotebookCellOutputItem(re.valueBytes.buffer,re.mime)}Re.to=Se})(gt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ct;(function(Re){function Ne(re){return{outputId:re.id,items:re.items.map(gt.from),metadata:re.metadata}}Re.from=Ne;function Se(re){const Fe=re.items.map(gt.to);return new o.NotebookCellOutput(Fe,re.outputId,re.metadata)}Re.to=Se})(ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Re){function Ne(Fe){return re(Fe)?{include:(0,v.withNullAsUndefined)(z.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(z.from(Fe.exclude))}:(0,v.withNullAsUndefined)(z.from(Fe))}Re.from=Ne;function Se(Fe){return re(Fe)?{include:z.to(Fe.include),exclude:z.to(Fe.exclude)}:z.to(Fe)}Re.to=Se;function re(Fe){const He=Fe;return He?!(0,v.isUndefinedOrNull)(He.include)&&!(0,v.isUndefinedOrNull)(He.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var tt;(function(Re){function Ne(Se,re,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Ne})(tt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ft;(function(Re){function Ne(Se,re,Fe){const He=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:re.toInternal(He,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Re.from=Ne})(ft=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var At;(function(Re){function Ne(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Ne})(At=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Kt;(function(Re){function Ne(re){return{uri:re.uri,provides:re.provides}}Re.from=Ne;function Se(re){return new o.NotebookRendererScript(I.URI.revive(re.uri),re.provides)}Re.to=Se})(Kt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Rt;(function(Re){function Ne(re){return{message:M.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Re.from=Ne;function Se(re){const Fe=new o.TestMessage(typeof re.message=="string"?re.message:M.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.location=re.location?ve.to(re.location):void 0,Fe}Re.to=Se})(Rt=e.TestMessage||(e.TestMessage={}));var mt;(function(Re){Re.namespace=p.namespaceTestTag,Re.denamespace=p.denamespaceTestTag})(mt=e.TestTag||(e.TestTag={}));var Tt;(function(Re){function Ne(re){const Fe=(0,d.getPrivateApiFor)(re).controllerId;return{extId:C.TestId.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:I.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>mt.namespace(Fe,He.id)),range:y.Range.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&M.fromStrict(re.error)||null}}Re.from=Ne;function Se(re){return{parent:void 0,error:void 0,id:C.TestId.fromString(re.extId).localId,label:re.label,uri:I.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:He}=mt.denamespace(Fe);return new o.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Re.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Re){function Ne(re){return{id:re.id}}Re.from=Ne;function Se(re){return new o.TestTag(re.id)}Re.to=Se}(mt=e.TestTag||(e.TestTag={}));var $t;(function(Re){const Ne=(re,Fe)=>{const He=[];for(const[je,it]of Fe)C.TestId.compare(it.item.extId,je)===2&&(Fe.delete(je),He.push(it));const Ye={...Tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(je=>({state:je.state,duration:je.duration,messages:je.messages.filter(it=>it.type===0).map(Rt.to)})),children:He.map(je=>Ne(je,Fe))};for(const je of Ye.children)je.parent=Ye;return Ye};function Se(re){const Fe=[],He=new Map;for(const Ye of re.items){He.set(Ye.item.extId,Ye);const je=C.TestId.root(Ye.item.extId);re.request.targets.some(it=>it.controllerId===je&&it.testIds.includes(Ye.item.extId))&&Fe.push(Ye)}return{completedAt:re.completedAt,results:Fe.map(Ye=>Ne(Ye,He))}}Re.to=Se})($t=e.TestResults||(e.TestResults={}));var Nt;(function(Re){function Ne(He){return{covered:He.covered,total:He.covered}}function Se(He){return"line"in He?m.from(He):c.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:Se(He.location),type:1,branches:He.branches.length?He.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Se(Ye.location)})):void 0}:{type:0,count:He.executionCount,location:Se(He.location)}}Re.fromDetailed=re;function Fe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Re.fromFile=Fe})(Nt=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Re){function Ne(Se){switch(Se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Re.to=Ne})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Mt;(function(Re){function Ne(re){const Fe=new o.TypeHierarchyItem(Q.to(re.kind),re.name,re.detail||"",I.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Re.to=Ne;function Se(re,Fe,He){if(Fe=Fe??re._sessionId,He=He??re._itemId,Fe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:He,kind:Q.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Re.from=Se})(Mt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ut;(function(Re){function Ne(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Ne})(Ut=e.ViewBadge||(e.ViewBadge={}));var Wt;(function(Re){function Ne(He,Ye,je){const it=Ye.fileData;return it?new class extends o.DataTransferItem{asFile(){return{name:it.name,uri:I.URI.revive(it.uri),data:(0,R.once)(()=>je())}}}("",Ye.id):He===L.Mimes.uriList&&Ye.uriListData?new o.DataTransferItem(Fe(Ye.uriListData)):new o.DataTransferItem(Ye.asString)}Re.to=Ne;async function Se(He,Ye){const je=await Ye.asString();if(He===L.Mimes.uriList)return{id:Ye.id,asString:je,fileData:void 0,uriListData:re(je)};const it=Ye.asFile();return{id:Ye.id,asString:je,fileData:it?{name:it.name,uri:it.uri}:void 0}}Re.from=Se;function re(He){return l.UriList.split(He).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return I.URI.parse(Ye)}catch{}return Ye})}function Fe(He){return l.UriList.create(He.map(Ye=>typeof Ye=="string"?Ye:I.URI.revive(Ye)))}})(Wt=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Re){function Ne(re,Fe){const He=re.items.map(([Ye,je])=>[Ye,Wt.to(Ye,je,()=>Fe(je.id))]);return new o.DataTransfer(He)}Re.toDataTransfer=Ne;async function Se(re){const Fe={items:[]},He=[];return re.forEach((Ye,je)=>{He.push((async()=>{Fe.items.push([je,await Wt.from(je,Ye)])})())}),await Promise.all(He),Fe}Re.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[240],De([1,0,2,11,7,14,66]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(k,L,T,v={timeout:1500,errors:3}){this.c=k,this.d=L,this.f=T,this.g=v,this.a=new D.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(L,T,v)=>{const y={dispose:this.a.push([L,T,k])};return Array.isArray(v)&&v.push(y),y}}async $participateInSave(k,L){const T=a.URI.revive(k);let v=!1;const I=setTimeout(()=>v=!0,this.g.timeout),y=[];try{for(const f of[...this.a]){if(v)break;const h=this.d.getDocument(T),d=await this.h(f,{document:h,reason:R.TextDocumentSaveReason.to(L)});y.push(d)}}finally{clearTimeout(I)}return y}h([k,L,T],v){const I=this.b.get(k);return typeof I=="number"&&I>this.g.errors?Promise.resolve(!1):this.i(T,k,L,v).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const f=this.b.get(k);this.b.set(k,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,L,T,v){const I=[],y=Date.now(),{document:f,reason:h}=v,{version:d}=f,g=Object.freeze({document:f,reason:h,waitUntil(b){if(Object.isFrozen(I))throw(0,A.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(b))}});try{L.apply(T,[g])}catch(b){return Promise.reject(b)}return Object.freeze(I),new Promise((b,C)=>{const p=setTimeout(()=>C(new Error("timeout")),this.g.timeout);return Promise.all(I).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(p),b(i)}).catch(i=>{clearTimeout(p),C(i)})}).then(b=>{const C={edits:[]};for(const p of b)if(Array.isArray(p)&&p.every(i=>i instanceof l.TextEdit))for(const{newText:i,newEol:o,range:s}of p)C.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:s&&R.Range.from(s),text:i,eol:o&&R.EndOfLine.from(o)}});if(C.edits.length!==0)return d===f.version?this.f.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[241],De([1,0,16,2,14,7,92]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(T,v,I,y){this.start=T,this.deletedCount=v,this.deletedItems=I,this.items=y}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(T=>T.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(T,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:T}}constructor(T,v,I){this.notebook=T,this.h=v,this.j=I,this.handle=I.handle,this.uri=A.URI.revive(I.uri),this.cellKind=I.cellKind,this.a=I.outputs.map(l.NotebookCellOutput.to),this.e=I.internalMetadata??{},this.b=Object.freeze(I.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const T=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return T.notebook.getCellIndex(T)},notebook:T.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return T.g},set mime(y){T.g=y},get outputs(){return T.a.slice(0)},get metadata(){return T.b},get executionSummary(){return T.d}};this.f=Object.freeze(I)}return this.f}setOutputs(T){this.a=T.map(l.NotebookCellOutput.to)}setOutputItems(T,v,I){const y=I.map(l.NotebookCellOutputItem.to),f=this.a.find(h=>h.id===T);if(f&&(v||(f.items.length=0),f.items.push(...y),f.items.length>1&&f.items.every(h=>D.isTextStreamMime(h.mime)))){const h=new Map,d=[];f.items.forEach(g=>{let b;h.has(g.mime)?b=h.get(g.mime):(b=[],h.set(g.mime,b),d.push(g.mime)),b.push(g.data)}),f.items.length=0,d.forEach(g=>{const b=D.compressOutputItemStreams(h.get(g));f.items.push({mime:g,data:b.buffer})})}}setMetadata(T){this.b=Object.freeze(T)}setInternalMetadata(T){this.e=T,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(T))}setMime(T){}}e.ExtHostCell=E;class k{constructor(T,v,I,y,f){this.k=T,this.l=v,this.m=I,this.uri=y,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const T=this,v={get uri(){return T.uri},get version(){return T.g},get notebookType(){return T.d},get isDirty(){return T.h},get isUntitled(){return T.uri.scheme===a.Schemas.untitled},get isClosed(){return T.j},get metadata(){return T.f},get cellCount(){return T.b.length},cellAt(I){return I=T.n(I),T.b[I].apiCell},getCells(I){return(I?T.p(I):T.b).map(f=>f.apiCell)},save(){return T.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(T){T.metadata&&(this.f=Object.freeze({...this.f,...T.metadata}))}acceptDirty(T){this.h=T}acceptModelChanged(T,v,I){this.g=T.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:I});const y={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},f=[];for(const d of T.rawEvents)d.kind===D.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,y.contentChanges):d.kind===D.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,y.contentChanges):d.kind===D.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),f.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===D.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),f.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),f.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===D.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===D.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),f.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),f.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const h=new Map;for(let d=0;d<f.length;d++){const g=f[d],b=h.get(g.cell);if(b===void 0){const C=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});h.set(g.cell,C-1)}else y.cellChanges[b]={...y.cellChanges[b],...g}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(T){return T=T|0,T<0?0:T>=this.b.length?this.b.length-1:T}o(T){let v=T.start|0,I=T.end|0;return v<0&&(v=0),I>this.b.length&&(I=this.b.length),T.with({start:v,end:I})}p(T){T=this.o(T);const v=[];for(let I=T.start;I<T.end;I++)v.push(this.b[I]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(T,v,I){if(this.j)return;const y=[],f=[],h=[];if(T.reverse().forEach(d=>{const b=d[2].map(i=>{const o=new E(this,this.l,i);return v||f.push(E.asModelAddData(this.apiNotebook,i)),o}),C=new P(d[0],d[1],[],b),p=this.b.splice(d[0],d[1],...b);for(const i of p)h.push(i.uri),C.deletedItems.push(i.apiCell);y.push(C)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:h}),I)for(const d of y)I.push(d.asApiEvent())}s(T,v,I,y){const f=this.b.splice(T,v);this.b.splice(I,0,...f);const h=[new P(T,v,f.map(d=>d.apiCell),[]),new P(I,0,[],f)];for(const d of h)y.push(d.asApiEvent())}t(T,v){this.b[T].setOutputs(v)}u(T,v,I,y){this.b[T].setOutputItems(v,I,y)}v(T,v){const I=this.b[T];I.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(I.uri,v)}w(T,v){const I=this.b[T];I.apiCell.mime=v}x(T,v){this.b[T].setMetadata(v)}y(T,v){this.b[T].setInternalMetadata(v)}getCellFromApiCell(T){return this.b.find(v=>v.apiCell===T)}getCellFromIndex(T){return this.b[T]}getCell(T){return this.b.find(v=>v.handle===T)}getCellIndex(T){return this.b.indexOf(T)}}k.a=0,e.ExtHostNotebookDocument=k}),define(ye[136],De([1,0,11,14,7]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(P,E,k,L,T,v){this.id=P,this.f=E,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=T,this.b=L,this.c=v}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(E){this.selections=[E]},get selections(){return P.a},set selections(E){if(!Array.isArray(E)||!E.every(l.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");P.a=E,P.g(E)},get visibleRanges(){return P.b},revealRange(E,k){P.f.$tryRevealRange(P.id,A.NotebookRange.from(E),k??l.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(A.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[242],De([1,0,3,13,14]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(P,E){this.c=P,this.d=E,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(P,E){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",P,E);const k=this.d.getEditorById(P);E.visibleRanges&&k._acceptVisibleRanges(E.visibleRanges.ranges.map(l.NotebookRange.to)),E.selections&&k._acceptSelections(E.selections.selections.map(l.NotebookRange.to)),E.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),E.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(P){for(const E in P)this.d.getEditorById(E)._acceptViewColumn(l.ViewColumn.to(P[E]))}};R=qe([We(0,A.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[243],De([1,0,14,126,179,21,62,11]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,I,y){const f=this.b++,{title:h,location:d,cancellable:g}=I,b={label:(0,l.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:a.ProgressLocation.from(d),title:h,source:b,cancellable:g},v.isUnderDevelopment?void 0:v.identifier.value).catch(P.onUnexpectedExternalError),this.d(f,y,!!g)}d(v,I,y){let f;y&&(f=new R.CancellationTokenSource,this.c.set(v,f));const h=g=>{this.a.$progressEnd(g),this.c.delete(g),f?.dispose()};let d;try{d=I(new L(this.a,v),y&&f?f.token:R.CancellationToken.None)}catch(g){throw h(v),g}return d.then(g=>h(v),g=>h(v)),d}$acceptProgressCanceled(v){const I=this.c.get(v);I&&(I.cancel(),this.c.delete(v))}}e.ExtHostProgress=E;function k(T,v){return T.message=v.message,typeof v.increment=="number"&&(typeof T.increment=="number"?T.increment+=v.increment:T.increment=v.increment),T}class L extends A.Progress{constructor(v,I){super(y=>this.throttledReport(y)),this.c=v,this.d=I}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,D.throttle)(100,(T,v)=>k(T,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],De([1,0,32,132,57,93,75,14,2]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const k=(b,C,p,i)=>{let o=C;return{enumerable:!0,configurable:!1,get(){return o},set(s){if(!p(o,s)){const c=o;o=s,b.listener?.(i(s,c))}}}},L=(b,C)=>b===C,T={range:(b,C)=>b===C?!0:!b||!C?!1:b.isEqual(C),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(b,C)=>!(b.length!==C.length||b.some(p=>!C.find(i=>p.id===i.id)))},v=b=>C=>({op:4,update:b(C)}),I=(b,C)=>({range:(()=>{let p;const i=v(o=>({range:a.Range.lift(P.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return p},set(o){b.listener?.({op:6}),T.range(p,o)||(p=o,b.listener?.(i(o)))}}})(),label:k(b,C,T.label,v(p=>({label:p}))),description:k(b,void 0,T.description,v(p=>({description:p}))),sortText:k(b,void 0,T.sortText,v(p=>({sortText:p}))),canResolveChildren:k(b,!1,T.canResolveChildren,p=>({op:2,state:p})),busy:k(b,!1,T.busy,v(p=>({busy:p}))),error:k(b,void 0,T.error,v(p=>({error:P.MarkdownString.fromStrict(p)||null}))),tags:k(b,[],T.tags,(p,i)=>({op:1,new:p.map(P.TestTag.from),old:i.map(P.TestTag.from)}))}),y=b=>{const C=l.TestId.fromString(b.extId),p=new h(C.controllerId,C.localId,b.label,E.URI.revive(b.uri)||void 0);return p.range=P.Range.to(b.range||void 0),p.description=b.description||void 0,p.sortText=b.sortText||void 0,p.tags=b.tags.map(i=>P.TestTag.to({id:(0,D.denamespaceTestTag)(i).tagId})),p},f=b=>{let C;for(const p of b.tests){const i=y(p.item);(0,A.getPrivateApiFor)(i).parent=C,C=i}return C};e.toItemFromContext=f;class h{constructor(C,p,i,o){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const s=(0,A.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof d?void 0:s.parent}},children:{value:(0,R.createTestItemChildren)(s,A.getPrivateApiFor,h),enumerable:!0,writable:!1},...I(s,i)})}}e.TestItemImpl=h;class d extends h{constructor(C,p){super(C,C,p,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class g extends R.TestItemCollection{constructor(C,p,i){super({controllerId:C,getDocumentVersion:o=>o&&i.getDocument(o)?.version,getApiFor:A.getPrivateApiFor,getChildren:o=>o.children,root:new d(C,p),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(ye[138],De([1,0,50,11,101,14,7]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(v,I,y){const f=P.c.nextId();v.$registerTextEditorDecorationType(I.identifier,f,R.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}P.c=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=P;class E{constructor(v,I){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=I.undoStopBefore,this.f=I.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,I){this.k();let y=null;if(v instanceof D.Position)y=new D.Range(v,v);else if(v instanceof D.Range)y=v;else throw new Error("Unrecognized location");this.l(y,I,!1)}insert(v,I){this.k(),this.l(new D.Range(v,v),I,!0)}delete(v){this.k();let I=null;if(v instanceof D.Range)I=v;else throw new Error("Unrecognized location");this.l(I,null,!0)}l(v,I,y){const f=this.c.validateRange(v);this.g.push({range:f,text:I,forceMoveMarkers:y})}setEndOfLine(v){if(this.k(),v!==D.EndOfLine.LF&&v!==D.EndOfLine.CRLF)throw(0,A.illegalArgument)("endOfLine");this.h=v}}class k{constructor(v,I,y,f){this.c=v,this.d=I,this._accept(y),this.e=f;const h=this;this.value={get tabSize(){return h.f},set tabSize(d){h.m(d)},get indentSize(){return h.g},set indentSize(d){h.o(d)},get insertSpaces(){return h.h},set insertSpaces(d){h.q(d)},get cursorStyle(){return h.j},set cursorStyle(d){h.s(d)},get lineNumbers(){return h.k},set lineNumbers(d){h.t(d)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const I=Math.floor(v);return I>0?I:null}if(typeof v=="string"){const I=parseInt(v,10);return isNaN(I)?null:I>0?I:null}return null}m(v){const I=this.l(v);if(I!==null){if(typeof I=="number"){if(this.f===I)return;this.f=I}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:I}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const I=Math.floor(v);return I>0?I:null}if(typeof v=="string"){const I=parseInt(v,10);return isNaN(I)?null:I>0?I:null}return null}o(v){const I=this.n(v);if(I!==null){if(typeof I=="number"){if(this.g===I)return;this.g=I}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:I}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const I=this.p(v);if(typeof I=="boolean"){if(this.h===I)return;this.h=I}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:I}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const I={};let y=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(y=!0,I.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,y=!0,I.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(y=!0,I.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,y=!0,I.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(y=!0,I.insertSpaces=f):this.h!==f&&(this.h=f,y=!0,I.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,y=!0,I.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,y=!0,I.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),y&&this.u("setOptions",this.c.$trySetOptions(this.d,I))}u(v,I){I.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(y)})}}e.ExtHostTextEditorOptions=k;class L{constructor(v,I,y,f,h,d,g,b){this.id=v,this.j=I,this.k=y,this.g=!1,this.h=new Set,this.c=h,this.d=new k(this.j,this.id,d,y),this.e=g,this.f=b;const C=this;this.value=Object.freeze({get document(){return f.value},set document(p){throw(0,A.readonly)("document")},get selection(){return C.c&&C.c[0]},set selection(p){if(!(p instanceof D.Selection))throw(0,A.illegalArgument)("selection");C.c=[p],C.l()},get selections(){return C.c},set selections(p){if(!Array.isArray(p)||p.some(i=>!(i instanceof D.Selection)))throw(0,A.illegalArgument)("selections");C.c=p,C.l()},get visibleRanges(){return C.e},set visibleRanges(p){throw(0,A.readonly)("visibleRanges")},get options(){return C.d.value},set options(p){C.g||C.d.assign(p)},get viewColumn(){return C.f},set viewColumn(p){throw(0,A.readonly)("viewColumn")},edit(p,i={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const o=new E(f.value,i);return p(o),C.m(o)},insertSnippet(p,i,o={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!i||Array.isArray(i)&&i.length===0)s=C.c.map(c=>R.Range.from(c));else if(i instanceof D.Position){const{lineNumber:c,column:r}=R.Position.from(i);s=[{startLineNumber:c,startColumn:r,endLineNumber:c,endColumn:r}]}else if(i instanceof D.Range)s=[R.Range.from(i)];else{s=[];for(const c of i)if(c instanceof D.Range)s.push(R.Range.from(c));else{const{lineNumber:r,column:m}=R.Position.from(c);s.push({startLineNumber:r,startColumn:m,endLineNumber:r,endColumn:m})}}return I.$tryInsertSnippet(v,f.value.version,p.value,s,o)},setDecorations(p,i){const o=i.length===0;o&&!C.h.has(p.key)||(o?C.h.delete(p.key):C.h.add(p.key),C.n(()=>{if(R.isDecorationOptionsArr(i))return I.$trySetDecorations(v,p.key,R.fromRangeOrRangeWithMessage(i));{const s=new Array(4*i.length);for(let c=0,r=i.length;c<r;c++){const m=i[c];s[4*c]=m.start.line+1,s[4*c+1]=m.start.character+1,s[4*c+2]=m.end.line+1,s[4*c+3]=m.end.character+1}return I.$trySetDecorationsFast(v,p.key,s)}}))},revealRange(p,i){C.n(()=>I.$tryRevealRange(v,R.Range.from(p),i||D.TextEditorRevealType.Default))},show(p){I.$tryShowEditor(v,R.ViewColumn.from(p))},hide(){I.$tryHideEditor(v)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,a.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,a.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,a.ok)(!this.g),this.f=v}_acceptSelections(v){(0,a.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const I=v.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const y=I.edits.map(h=>h.range);y.sort((h,d)=>h.end.line===d.end.line?h.end.character===d.end.character?h.start.line===d.start.line?h.start.character-d.start.character:h.start.line-d.start.line:h.end.character-d.end.character:h.end.line-d.end.line);for(let h=0,d=y.length-1;h<d;h++){const g=y[h].end;if(y[h+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=I.edits.map(h=>({range:R.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,I.documentVersionId,f,{setEndOfLine:typeof I.setEndOfLine=="number"?R.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this.k.warn(I),null))}}e.ExtHostTextEditor=L}),define(ye[244],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[245],De([1,0,195,11,37,123,91,39,26,244,208,197]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=P.Registry.as(D.Extensions.JSONContribution);class I{constructor(p,i,o){this.a=p,this.b=i,this.c=o}d(p,i){this.a({type:p,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(p){this.d(l.default.Error,p)}warn(p){this.d(l.default.Warning,p)}info(p){this.d(l.default.Info,p)}}e.ExtensionMessageCollector=I;class y{static a(p){const i=new Set;for(let o=0,s=p.length;o<s;o++)i.add(E.ExtensionIdentifier.toKey(p[o].description.identifier));return i}static compute(p,i){if(!p||!p.length)return new y(i,[]);if(!i||!i.length)return new y([],p);const o=this.a(p),s=this.a(i),c=i.filter(m=>!o.has(E.ExtensionIdentifier.toKey(m.description.identifier))),r=p.filter(m=>!s.has(E.ExtensionIdentifier.toKey(m.description.identifier)));return new y(c,r)}constructor(p,i){this.added=p,this.removed=i}}e.ExtensionPointUserDelta=y;class f{constructor(p,i){this.name=p,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(p){if(this.a!==null)throw new Error("Handler already set!");this.a=p,this.d()}acceptUsers(p){this.c=y.compute(this.b,p),this.b=p,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(p){(0,A.onUnexpectedError)(p)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(p){if(this.a.has(p.extensionPoint))throw new Error("Duplicate extension point: "+p.extensionPoint);const i=new f(p.extensionPoint,p.defaultExtensionKind);return this.a.set(p.extensionPoint,i),p.activationEventsGenerator&&T.ImplicitActivationEvents.register(p.extensionPoint,p.activationEventsGenerator),e.schema.properties.contributes.properties[p.extensionPoint]=p.jsonSchema,v.registerSchema(d,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const b={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(b.ExtensionsRegistry,new g),e.ExtensionsRegistry=P.Registry.as(b.ExtensionsRegistry),v.registerSchema(d,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ye[246],De([1,0,192,9,23,245,54,3]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var k;(function(v){function I(y,f,h){if(!y)return;const d=A.isString(y.type)?y.type:void 0;if(!d||d.length===0){h.error(a.localize(3,null));return}const g=[];if(Array.isArray(y.required))for(const b of y.required)A.isString(b)&&g.push(b);return{extensionId:f.value,taskType:d,required:g,properties:y.properties?l.deepClone(y.properties):{},when:y.when?D.ContextKeyExpr.deserialize(y.when):void 0}}v.from=I})(k||(k={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,I)=>{for(const y of v)y.type&&I.push(`onTaskType:${y.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:E}});class T{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((I,y)=>{L.setHandler((f,h)=>{this.c=void 0;try{for(const d of h.removed){const g=d.value;for(const b of g)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const d of h.added){const g=d.value;for(const b of g){const C=k.from(b,d.description.identifier,d.collector);C&&(this.a[C.taskType]=C)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}I(void 0)})})}onReady(){return this.b}get(I){return this.a[I]}all(){return Object.keys(this.a).map(I=>this.a[I])}getJsonSchema(){if(this.c===void 0){const I=[];for(const y of this.all()){const f={type:"object",additionalProperties:!1};y.required.length>0&&(f.required=y.required.slice(0)),y.properties!==void 0?f.properties=l.deepClone(y.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[y.taskType]},I.push(f)}this.c={oneOf:I}}return this.c}}e.TaskDefinitionRegistry=new T}),define(ye[247],De([1,0,193,9,24,23,54,246]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var E;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(O){function U($){if(!$)return O.Strong;switch($.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=U}(E=e.ShellQuoting||(e.ShellQuoting={}));var k;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(k=e.CommandOptions||(e.CommandOptions={}));var L;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(O){function U($){switch($.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=U}(L=e.RevealKind||(e.RevealKind={}));var T;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(T=e.RevealProblemKind||(e.RevealProblemKind={})),function(O){function U($){switch($.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=U}(T=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(O){function U($){switch($.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=U}(v=e.PanelKind||(e.PanelKind={}));var I;(function(O){O.defaults={echo:!0,reveal:L.Always,revealProblems:T.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var y;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(y=e.RuntimeType||(e.RuntimeType={})),function(O){function U(j){switch(j.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=U;function $(j){switch(j){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=$}(y=e.RuntimeType||(e.RuntimeType={}));var f;(function(O){function U($){return A.isString($)?$:$.value}O.value=U})(f=e.CommandString||(e.CommandString={}));var h;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function U(j){return j===O.Clean._id||j===O.Build._id||j===O.Rebuild._id||j===O.Test._id}O.is=U;function $(j){if(j!==void 0)return A.isString(j)?U(j)?{_id:j,isDefault:!1}:void 0:j}O.from=$})(h=e.TaskGroup||(e.TaskGroup={}));var d;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(d=e.TaskScope||(e.TaskScope={}));var g;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function U($){switch($){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=U})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var C;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(C=e.RunOnOptions||(e.RunOnOptions={}));var p;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(p=e.RunOptions||(e.RunOptions={}));class i{constructor(U,$,j,le,J,q){this._label="",this._id=U,$&&(this._label=$),j&&(this.type=j),this.runOptions=le,this.configurationProperties=J,this._source=q}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,$=!1){if(U===void 0)return!1;if(A.isString(U))return U===this._label||U===this.configurationProperties.identifier||$&&U===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class o extends i{constructor(U,$,j,le,J,q,Q,Z){super(U,j,void 0,Q,Z,$),this.command={},this._source=$,this.hasDefinedMatchers=q,J&&(this.command=J)}clone(){return new o(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let $;switch(this.command?this.command.runtime:void 0){case y.Shell:$="shell";break;case y.Process:$="process";break;case y.CustomExecution:$="customExecution";break;case void 0:$="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:$,_key:this._id,id:this._id}}}static is(U){return U instanceof o}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new o(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.CustomTask=o;class s extends i{constructor(U,$,j,le,J,q,Q){super(U,j,le,q,Q,$),this._source=$,this.configures=J}static is(U){return U instanceof s}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let $=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&($+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:U,id:$};return JSON.stringify(j)}}e.ConfiguringTask=s;class c extends i{constructor(U,$,j,le,J,q,Q,Z,te){super(U,j,le,Z,te,$),this.defines=J,this.hasDefinedMatchers=Q,this.command=q,this.icon=te.icon,this.hide=te.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof c}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new c(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.ContributedTask=c;class r extends i{constructor(U,$,j,le,J,q){super(U,j,le,J,q,$),this._source=$}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new r(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.InMemoryTask=r;var m;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(O){O._default=O.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(U){this.c=new Map;for(let $=0;$<U.length;$++)this.c.set(U[$].uri.toString(),$)}compare(U,$){const j=U.getWorkspaceFolder(),le=$.getWorkspaceFolder();if(j&&le){let J=this.c.get(j.uri.toString());J=J===void 0?0:J+1;let q=this.c.get(le.uri.toString());return q=q===void 0?0:q+1,J===q?U._label.localeCompare($._label):J-q}else return!j&&le?-1:j&&!le?1:0}}e.TaskSorter=t;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u=e.TaskEventKind||(e.TaskEventKind={}));var w;(function(O){O.SingleRun="singleRun",O.Background="background"})(w=e.TaskRunType||(e.TaskRunType={}));var S;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(S=e.TaskRunSource||(e.TaskRunSource={}));var F;(function(O){function U($,j,le,J){if(j){const q={kind:$,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:le,__task:j};return $==="start"?q.resolvedVariables=J:$==="processStarted"?q.processId=J:$==="processEnded"&&(q.exitCode=J),Object.freeze(q)}else return Object.freeze({kind:"changed"})}O.create=U})(F=e.TaskEvent||(e.TaskEvent={}));var x;(function(O){function U(j){const le=Object.keys(j).sort();let J="";for(const q of le){let Q=j[q];Q instanceof Object?Q=U(Q):typeof Q=="string"&&(Q=Q.replace(/,/g,",,")),J+=q+","+Q+","}return J}function $(j){const J={_key:U(j),type:j.taskType};return Object.assign(J,j),J}O.create=$})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var M;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(M=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(O){function U($,j){const le=P.TaskDefinitionRegistry.get($.type);if(le===void 0){const Z=R.deepClone($);return delete Z._key,x.create(Z)}const J=Object.create(null);J.type=le.taskType;const q=new Set;le.required.forEach(Z=>q.add(Z));const Q=le.properties;for(const Z of Object.keys(Q)){const te=$[Z];if(te!=null)J[Z]=te;else if(q.has(Z)){const X=Q[Z];if(X.default!==void 0)J[Z]=R.deepClone(X.default);else switch(X.type){case"boolean":J[Z]=!1;break;case"number":case"integer":J[Z]=0;break;case"string":J[Z]="";break;default:j.error(a.localize(2,null,JSON.stringify($,void 0,0),Z));return}}}return x.create(J)}O.createTaskIdentifier=U})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[248],De([1,0,11]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class A{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((D,P)=>{this.b=D,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(D){this.f||this.h||(this.f=!0,this.g=D,this.a&&this.b(D))}resolveErr(D){this.f||this.h||(this.h=!0,this.i=D,this.a?this.d(D):(0,a.onUnexpectedError)(D))}then(D,P){return this.j().then(D,P)}catch(D){return this.j().then(void 0,D)}finally(D){return this.j().finally(D)}}e.LazyPromise=A;class l extends A{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=l}),define(ye[58],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const A=[];function l(P){const E=new a(P);return A[E.nid]=E,E}e.createProxyIdentifier=l;function R(P){return A[P].sid}e.getStringIdentifierForProxy=R;class D{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=D}),define(ye[5],De([1,0,58]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var E;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(E=e.CellOutputKind||(e.CellOutputKind={}));var k;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(k=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class T{static mixin(h){return h._id=T.a++,h}}T.a=0,e.IdObject=T;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var I;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(I=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[76],De([1,0,4,13,5,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(E,k){this.c=k,this.a=new Set,this.b=E.getProxy(l.MainContext.MainThreadTelemetry)}report(E,k,L){const T=this.d(E,k);this.a.has(T)||(this.a.add(T),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}d(E,k){return`${E}-${k.identifier.value}`}};D=qe([We(0,R.IExtHostRpcService),We(1,A.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(P,E,k){}})}),define(ye[249],De([1,0,3,5,7,26]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(E){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=E.getProxy(A.MainContext.MainThreadAuthentication)}$setProviders(E){return this.c=E,Promise.resolve()}async getSession(E,k,L,T={}){const v=R.ExtensionIdentifier.toKey(E.identifier),I=this.f.get(v)||[],y=[...L].sort().join(" ");let f=I.find(h=>h.providerId===k&&h.scopes===y);if(f)return f.result;{const h=this.g(E,v,k,L,T);f={providerId:k,scopes:y,result:h},I.push(f),this.f.set(v,I);try{await h}finally{const d=I.findIndex(g=>g.providerId===k&&g.scopes===y);d>-1&&(I.splice(d),this.f.set(v,I))}return h}}async g(E,k,L,T,v={}){await this.a.$ensureProvider(L);const I=E.displayName||E.name;return this.a.$getSession(L,T,k,I,v)}async removeSession(E,k){const L=this.b.get(E);return L?L.provider.removeSession(k):this.a.$removeSession(E,k)}registerAuthenticationProvider(E,k,L,T){if(this.b.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this.b.set(E,{label:k,provider:L,options:T??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===E)||this.c.push({id:E,label:k});const v=L.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(E,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(E,k,T?.supportsMultipleAccounts??!1),new l.Disposable(()=>{v.dispose(),this.b.delete(E);const I=this.c.findIndex(y=>y.id===E);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const L=this.b.get(E);if(L)return Promise.resolve(L.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const L=this.b.get(E);if(L)return Promise.resolve(L.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const L=this.b.get(E);if(L)return Promise.resolve(L.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this.d.fire({provider:{id:E,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(ye[250],De([1,0,5,20,14]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(P,E){this.a=P.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>E.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,E,k){const L=l.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,k?.isRefactoring??!1)}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[251],De([1,0,5]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class A{constructor(R){const D=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(P){return D.$writeText(P)}})}}e.ExtHostClipboard=A});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[40],De([1,0,9,7,14,23,5,15,13,69,32,52,2,6,4,20,137,22,58,45,43,73]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(u,w){i.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),_e(this,i,u.getProxy(D.MainContext.MainThreadCommands),"f"),this.d=w,_e(this,o,u.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,S=>{const F=this.c.get(S);return F?.result===m.Void?F:void 0},w),this.f=[{processArgument(S){return(0,k.revive)(S)}},{processArgument(S){return(0,R.cloneAndChange)(S,function(F){if(L.Range.isIRange(F))return l.Range.to(F);if(T.Position.isIPosition(F))return l.Position.to(F);if(L.Range.isIRange(F.range)&&v.URI.isUri(F.uri))return l.location.to(F);if(F instanceof d.VSBuffer)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(u){this.f.push(u)}registerApiCommand(u){const w=this.registerCommand(!1,u.id,async(...S)=>{const F=u.args.map((V,M)=>{if(!V.validate(S[M]))throw new Error(`Invalid argument '${V.name}' when running '${u.id}', received: ${S[M]}`);return V.convert(S[M])}),x=await this.executeCommand(u.internalId,...F);return u.result.convert(x,S,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this.c.set(u.id,u),new A.Disposable(()=>{w.dispose(),this.c.delete(u.id)})}registerCommand(u,w,S,F,x,V){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:S,thisArg:F,description:x,extension:V}),u&&Be(this,i,"f").$registerCommand(w),new A.Disposable(()=>{this.b.delete(w)&&u&&Be(this,i,"f").$unregisterCommand(w)})}executeCommand(u,...w){return this.d.trace("ExtHostCommands#executeCommand",u),this.g(u,w,!0)}async g(u,w,S){if(this.b.has(u))return Be(this,i,"f").$fireCommandActivationEvent(u),this.h(u,w,!1);{let F=!1;const x=(0,R.cloneAndChange)(w,function(V){if(V instanceof A.Position)return l.Position.from(V);if(V instanceof A.Range)return l.Range.from(V);if(V instanceof A.Location)return l.location.from(V);if(A.NotebookRange.isNotebookRange(V))return l.NotebookRange.from(V);if(V instanceof ArrayBuffer)return F=!0,d.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return F=!0,d.VSBuffer.wrap(V);if(V instanceof d.VSBuffer)return F=!0,V;if(!Array.isArray(V))return V});try{const V=await Be(this,i,"f").$executeCommand(u,F?new g.SerializableObjectWithBuffers(x):x,S);return(0,k.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(u,w,!1);throw V}}}async h(u,w,S){const F=this.b.get(u);if(!F)throw new Error("Unknown command");const{callback:x,thisArg:V,description:M}=F;if(M)for(let O=0;O<M.args.length;O++)try{(0,a.validateConstraint)(w[O],M.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${M.args[O].name}' - ${M.args[O].description}`)}const B=C.StopWatch.create();try{return await x.apply(V,w)}catch(O){if(u===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...w);U&&(u=U.command)}throw this.d.error(O,u,F.extension?.identifier),S?new class extends Error{constructor(){super((0,b.toErrorMessage)(O)),this.id=u,this.source=F.extension?.displayName??F.extension?.name}}:O}finally{this.j(F,u,B.elapsed())}}j(u,w,S){!u.extension||Be(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:u.extension.identifier.value,id:new p.TelemetryTrustedValue(w),duration:S})}$executeContributedCommand(u,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",u);const S=this.b.get(u);return S?(w=w.map(F=>this.f.reduce((x,V)=>V.processArgument(x,S.extension?.identifier),F)),this.h(u,w,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this.d.trace("ExtHostCommands#getCommands",u),Be(this,i,"f").$getCommands().then(w=>(u&&(w=w.filter(S=>S[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(const[w,S]of this.b){const{description:F}=S;F&&(u[w]=F)}return Promise.resolve(u)}};i=new WeakMap,o=new WeakMap,s=qe([We(0,f.IExtHostRpcService),We(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,y.createDecorator)("IExtHostCommands");class c{constructor(u,w,S){this.d=u,this.f=w,this.g=S,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(u,w){if(!u)return;const S={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return S;const F=this.f(u.command);if(F)S.id=F.internalId,S.arguments=F.args.map((x,V)=>x.convert(u.arguments&&u.arguments[V]));else if((0,P.isNonEmptyArray)(u.arguments)){const x=`${u.command}/${++this.c}`;this.b.set(x,u),w.add((0,I.toDisposable)(()=>{this.b.delete(x),this.g.trace("CommandsConverter#DISPOSE",x)})),S.$ident=x,S.id=this.delegatingCommandId,S.arguments=[x],this.g.trace("CommandsConverter#CREATE",u.command,x)}return S}fromInternal(u){return typeof u.$ident=="string"?this.b.get(u.$ident):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this.b.get(u[0])}h(...u){const w=this.getActualCommand(...u);return this.g.trace("CommandsConverter#EXECUTE",u[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${u[0]}`)}}e.CommandsConverter=c;class r{constructor(u,w,S,F){this.name=u,this.description=w,this.validate=S,this.convert=F}optional(){return new r(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,w){return new r(u??this.name,w??this.description,this.validate,this.convert)}}r.Uri=new r("uri","Uri of a text document",t=>v.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>A.Position.isPosition(t),l.Position.from),r.Range=new r("range","A range in a text document",t=>A.Range.isRange(t),l.Range.from),r.Selection=new r("selection","A selection in a text document",t=>A.Selection.isSelection(t),l.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof h.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=r;class m{constructor(u,w){this.description=u,this.convert=w}}m.Void=new m("no result",t=>t),e.ApiCommandResult=m;class n{constructor(u,w,S,F,x){this.id=u,this.internalId=w,this.description=S,this.args=F,this.result=x}}e.ApiCommand=n}),define(ye[252],De([1,0,2,14,7,71,40,15,120,125,16]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const T=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(A.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,h)=>{if((0,P.isFalsyOrEmpty)(f))return;class d extends l.SymbolInformation{static to(b){const C=new d(b.name,A.SymbolKind.to(b.kind),b.containerName||"",new l.Location(h[0],A.Range.to(b.range)));return C.detail=b.detail,C.range=C.location.range,C.selectionRange=A.Range.to(b.selectionRange),C.children=b.children?b.children.map(d.to):[],C}}return f.map(d.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new D.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(A.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",y)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(A.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(A.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(h=>l.Position.isPosition(h)),f=>f.map(A.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(h=>{let d;for(const g of h.reverse())d=new l.SelectionRange(A.Range.to(g),d);return d}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(A.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(A.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(A.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(A.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:A.Range.to(f.range),placeholder:f.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return A.WorkspaceEdit.to(f)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(A.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const h=(0,E.decodeSemanticTokensDto)(f);if(h.type==="full")return new l.SemanticTokens(h.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const h=(0,E.decodeSemanticTokensDto)(f);if(h.type==="full")return new l.SemanticTokens(h.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,h,d)=>{if(!f)return new l.CompletionList([]);const g=f.suggestions.map(b=>A.CompletionItem.to(b,d));return new l.CompletionList(g,f.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return A.SignatureHelp.to(f)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,h,d)=>I(g=>new l.CodeLens(A.Range.to(g.range),g.command&&d.fromInternal(g.command)))(f))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>l.Range.isRange(f),f=>l.Selection.isSelection(f)?A.Selection.from(f):A.Range.from(f)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,h,d)=>I(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(g.command)}else{const b=new l.CodeAction(g.title,g.kind?new l.CodeActionKind(g.kind):void 0);return g.edit&&(b.edit=A.WorkspaceEdit.to(g.edit)),g.command&&(b.command=d.fromInternal(g.command)),b.isPreferred=g.isPreferred,b}})(f))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(h=>new l.ColorInformation(A.Range.to(h.range),A.Color.to(h.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",f=>f instanceof l.Color,A.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:A.Range.from(f.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(A.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,h,d)=>f.map(A.InlayHint.to.bind(void 0,d)))),new D.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(f,h)=>{if(f)return f.map(A.FoldingRange.to)})),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(h=>A.NotebookExclusiveDocumentPattern.to(h))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(A.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>a.URI.isUri(f)||typeof f=="string"&&(0,k.matchesSomeScheme)(f,L.Schemas.http,L.Schemas.https),f=>f),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[A.ViewColumn.from(f),void 0]:[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[A.ViewColumn.from(f.viewColumn),A.TextEditorOpenOptions.from(f)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(A.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void),new D.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[D.ApiCommandArgument.String.with("name","The context key name"),new D.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],D.ApiCommandResult.Void)];class v{static register(h){T.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=v;function I(f){return h=>{if(Array.isArray(h))return h.map(f)}}function y(f){if(!Array.isArray(f))return;const h=[];for(const d of f)R.isLocationLink(d)?h.push(A.DefinitionLink.to(d)):h.push(A.location.to(d));return h}}),define(ye[253],De([1,0,19,62,3,6,2,71,26,14,7,5]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(I,y,f){const h=I.getProxy(T.MainContext.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new Map,y.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const m=this.b.get(r.handle);return m?m.value:r}else if(r&&r.$mid===7){const m=this.b.get(r.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.commentThreadHandle);return n?n.value:r}else if(r&&(r.$mid===9||r.$mid===8)){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);return n?r.$mid===8?n.value:{thread:n.value,text:r.text}:r}else if(r&&r.$mid===10){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.commentUniqueId,u=n.getCommentByUniqueId(t);return u||r}else if(r&&r.$mid===11){const m=this.b.get(r.thread.commentControlHandle);if(!m)return r;const n=m.getCommentThread(r.thread.commentThreadHandle);if(!n)return r;const t=r.text,u=r.commentUniqueId,w=n.getCommentByUniqueId(u);return w?(typeof w.body=="string"?w.body=t:w.body=new L.MarkdownString(t),w):r}return r}})}createCommentController(r,m,n){const t=d.a++,u=new b(r,t,m,n);this.b.set(u.handle,u);const w=this.c.get(E.ExtensionIdentifier.toKey(r.identifier))||[];return w.push(u),this.c.set(E.ExtensionIdentifier.toKey(r.identifier),w),u.value}$createCommentThreadTemplate(r,m,n){const t=this.b.get(r);!t||t.$createCommentThreadTemplate(m,n)}async $updateCommentThreadTemplate(r,m,n){const t=this.b.get(r);!t||t.$updateCommentThreadTemplate(m,n)}$deleteCommentThread(r,m){this.b.get(r)?.$deleteCommentThread(m)}$provideCommentingRanges(r,m,n){const t=this.b.get(r);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const u=f.getDocument(D.URI.revive(m));return(0,a.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(u,n)).then(w=>w?w.map(S=>k.Range.from(S)):void 0)}$toggleReaction(r,m,n,t,u){const w=this.b.get(r);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const S=w.getCommentThread(m);if(S){const F=S.getCommentByUniqueId(t.uniqueIdInThread);if(w!==void 0&&F&&w.reactionHandler)return w.reactionHandler(F,i(u))}return Promise.resolve(void 0)})}dispose(){}}d.a=0;class g{set threadId(r){this.n=r}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(r){r.isEqual(this.p)||(this.p=r,this.b.range=r,this.c.fire())}get range(){return this.p}set canReply(r){this.d!==r&&(this.d=r,this.b.canReply=r,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(r){this.e=r,this.b.label=r,this.c.fire()}get contextValue(){return this.f}set contextValue(r){this.f=r,this.b.contextValue=r,this.c.fire()}get comments(){return this.q}set comments(r){this.q=r,this.b.comments=r,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(r){this.g=r,this.b.collapsibleState=r,this.c.fire()}get state(){return this.h}set state(r){this.h=r,this.b.state=r,this.c.fire()}get isDisposed(){return this.j}constructor(r,m,n,t,u,w,S,F){this.m=m,this.n=n,this.o=t,this.p=u,this.q=w,this.extensionDescription=S,this.r=F,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${r}.${this.handle}`),h.$createCommentThread(m,this.handle,this.n,this.o,k.Range.from(this.p),S.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{h.$deleteCommentThread(m,this.handle)}});const x=this;this.value={get uri(){return x.uri},get range(){return x.range},set range(V){x.range=V},get comments(){return x.comments},set comments(V){x.comments=V},get collapsibleState(){return x.collapsibleState},set collapsibleState(V){x.collapsibleState=V},get canReply(){return x.canReply},set canReply(V){x.canReply=V},get contextValue(){return x.contextValue},set contextValue(V){x.contextValue=V},get label(){return x.label},set label(V){x.label=V},get state(){return x.state},set state(V){x.state=V},dispose:()=>{x.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const r=n=>Object.prototype.hasOwnProperty.call(this.b,n),m={};r("range")&&(m.range=k.Range.from(this.p)),r("label")&&(m.label=this.label),r("contextValue")&&(m.contextValue=this.contextValue??null),r("comments")&&(m.comments=this.q.map(n=>C(this,n,this.k))),r("collapsibleState")&&(m.collapseState=o(this.g)),r("canReply")&&(m.canReply=this.canReply),r("state")&&(m.state=s(this.h)),r("isTemplate")&&(m.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(r){for(const m of this.k){const n=m[0],t=m[1];if(r===t)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(r=>r.dispose())}}g.a=0,qe([(0,A.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(r){this.b=r,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(r){this.c=r,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!r})}get options(){return this.d}set options(r){this.d=r,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(r,m,n,t){this.f=r,this.g=m,this.h=n,this.i=t,this.a=new Map,h.$registerCommentController(this.handle,n,t);const u=this;this.value=Object.freeze({id:u.id,label:u.label,get options(){return u.options},set options(w){u.options=w},get commentingRangeProvider(){return u.commentingRangeProvider},set commentingRangeProvider(w){u.commentingRangeProvider=w},get reactionHandler(){return u.reactionHandler},set reactionHandler(w){u.reactionHandler=w},createCommentThread(w,S,F){return u.createCommentThread(w,S,F).value},dispose:()=>{u.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(r,m,n,t){if(typeof r=="string"){const u=new g(this.id,this.handle,r,m,n,t,this.f,!1);return this.a.set(u.handle,u),u}else{const u=new g(this.id,this.handle,void 0,r,m,n,this.f,!1);return this.a.set(u.handle,u),u}}$createCommentThreadTemplate(r,m){const n=new g(this.id,this.handle,void 0,D.URI.revive(r),k.Range.to(m),[],this.f,!0);return n.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(r,m){const n=this.a.get(r);n&&(n.range=k.Range.to(m))}$deleteCommentThread(r){this.a.get(r)?.dispose(),this.a.delete(r)}getCommentThread(r){return this.a.get(r)}dispose(){this.a.forEach(r=>{r.dispose()}),this.e.forEach(r=>r.dispose())}}function C(c,r,m){let n=m.get(r);n||(n=++c.commentHandle,m.set(r,n));const t=r.author&&r.author.iconPath?r.author.iconPath.toString():void 0;return{mode:r.mode,contextValue:r.contextValue,uniqueIdInThread:n,body:typeof r.body=="string"?r.body:k.MarkdownString.from(r.body),userName:r.author.name,userIconPath:t,label:r.label,commentReactions:r.reactions?r.reactions.map(u=>p(u)):void 0,timestamp:r.timestamp?.toJSON()}}function p(c){return{label:c.label,iconPath:c.iconPath?k.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function i(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?D.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function o(c){if(c!==void 0)switch(c){case L.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function s(c){if(c!==void 0)switch(c){case L.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new d}e.createExtHostComments=v}),define(ye[254],De([1,0,23,5,25,20]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(L,T){this.a=L.getProxy(A.MainContext.MainThreadConsole),this.b=T.consoleForward.includeStack,this.c=T.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,T){const v=this,I=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,T,I,arguments)}})}e(L,T,v,I){this.a.$logExtensionHostMessage({type:"__$console",severity:T,arguments:E(I,this.b)}),this.c&&this.f(L,v,I)}};D=qe([We(0,R.IExtHostRpcService),We(1,l.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const P=1e5;function E(k,L){const T=[];if(k.length)for(let v=0;v<k.length;v++){let I=k[v];if(typeof I>"u")I="undefined";else if(I instanceof Error){const y=I;y.stack?I=y.stack:I=y.toString()}T.push(I)}if(L){const v=new Error().stack;v&&T.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,a.safeStringify)(T);return v.length>P?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,20,13,15,8,10,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(y,f){this.h=f,this.f=new Map,this.g=y.getProxy(A.MainContext.MainThreadDecorations)}registerFileDecorationProvider(y,f){const h=Mi.c++;this.f.set(h,{provider:y,extensionDescription:f}),this.g.$registerDecorationProvider(h,f.identifier.value);const d=y.onDidChangeFileDecorations&&y.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(h,null);return}const b=(0,E.asArray)(g);if(b.length<=Mi.d){this.g.$onDidChange(h,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,b.length);const C=b.map(o=>({uri:o,rank:(0,k.count)(o.path,"/")})),p=(0,E.groupBy)(C,(o,s)=>o.rank-s.rank||(0,k.compare)(o.uri.path,s.uri.path)),i=[];e:for(const o of p){let s;for(const c of o){const r=(0,L.dirname)(c.uri.path);if(s!==r&&(s=r,i.push(c.uri)>=Mi.d))break e}}this.g.$onDidChange(h,i)});return new l.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(h),this.f.delete(h)})}async $provideDecorations(y,f,h){if(!this.f.has(y))return Object.create(null);const d=Object.create(null),{provider:g,extensionDescription:b}=this.f.get(y);return await Promise.all(f.map(async C=>{try{const{uri:p,id:i}=C,o=await Promise.resolve(g.provideFileDecoration(a.URI.revive(p),h));if(!o)return;try{l.FileDecoration.validate(o),o.badge&&typeof o.badge!="string"&&(0,T.checkProposedApiEnabled)(b,"codiconDecoration"),d[i]=[o.propagate,o.tooltip,o.badge,o.color]}catch(s){this.h.warn(`INVALID decoration from extension '${b}': ${s}`)}}catch(p){this.h.error(p)}})),d}};v.c=0,v.d=250,v=qe([We(0,D.IExtHostRpcService),We(1,P.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[255],De([1,0,177,124,2,5,7,14,3,13,28,48]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";var v,I,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(g,b,C,p,i,o,s){this.d=g,this.e=b,this.f=C,this.g=p,v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),this.c=!1,_e(this,y,new L.ResourceMap(c=>i.getComparisonKey(c)),"f"),_e(this,v,o,"f"),_e(this,I,s,"f")}dispose(){this.c||(Be(this,I,"f").fire([...Be(this,y,"f").keys()]),Be(this,v,"f")?.$clear(this.e),Be(this,y,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,b){if(!g){this.clear();return}this.h();let C=[];if(l.URI.isUri(g)){if(!b){this.delete(g);return}Be(this,y,"f").set(g,b.slice()),C=[g]}else if(Array.isArray(g)){C=[];let i;g=[...g].sort(f.j);for(const o of g){const[s,c]=o;if((!i||s.toString()!==i.toString())&&(i&&Be(this,y,"f").get(i).length===0&&Be(this,y,"f").delete(i),i=s,C.push(s),Be(this,y,"f").set(s,[])),c)Be(this,y,"f").get(s)?.push(...c);else{const r=Be(this,y,"f").get(s);r&&(r.length=0)}}}if(Be(this,I,"f").fire(C),!Be(this,v,"f"))return;const p=[];for(const i of C){let o=[];const s=Be(this,y,"f").get(i);if(s)if(s.length>this.f){o=[];const c=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const m of s)if(m.severity===c[r]&&o.push({...P.Diagnostic.from(m),modelVersionId:this.g(i)})===this.f)break e;o.push({severity:A.MarkerSeverity.Info,message:(0,a.localize)(0,null,s.length-this.f),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=s.map(c=>({...P.Diagnostic.from(c),modelVersionId:this.g(i)}));p.push([i,o])}Be(this,v,"f").$changeMany(this.e,p)}delete(g){this.h(),Be(this,I,"f").fire([g]),Be(this,y,"f").delete(g),Be(this,v,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Be(this,I,"f").fire([...Be(this,y,"f").keys()]),Be(this,y,"f").clear(),Be(this,v,"f")?.$clear(this.e)}forEach(g,b){this.h();for(const[C,p]of this)g.call(b,C,p,this)}*[(v=new WeakMap,I=new WeakMap,y=new WeakMap,Symbol.iterator)](){this.h();for(const g of Be(this,y,"f").keys())yield[g,this.get(g)]}get(g){this.h();const b=Be(this,y,"f").get(g);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(g){return this.h(),Array.isArray(Be(this,y,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,b){return g[0].toString()<b[0].toString()?-1:g[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=f;let h=class pi{static _mapper(g){const b=new L.ResourceMap;for(const C of g)b.set(C,C);return{uris:Object.freeze(Array.from(b.values()))}}constructor(g,b,C,p){this.h=b,this.j=C,this.k=p,this.f=new Map,this.g=new E.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,b){const{f:C,e:p,g:i,h:o,j:s,k:c}=this,r=new class{$changeMany(t,u){p.$changeMany(t,u),o.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,t,u.length===0?"CLEARING":u)}$clear(t){p.$clear(t),o.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,t)}dispose(){p.dispose()}};let m;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,m=b;else if(!C.has(b))m=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do m=b+pi.c++;while(C.has(m))}return new class extends f{constructor(){super(b,m,pi.d,t=>c.getDocument(t)?.version,s.extUri,r,i),C.set(m,this)}dispose(){super.dispose(),C.delete(m)}}}getDiagnostics(g){if(g)return this.l(g);{const b=new Map,C=[];for(const p of this.f.values())p.forEach((i,o)=>{let s=b.get(i.toString());typeof s>"u"&&(s=C.length,b.set(i.toString(),s),C.push([i,[]])),C[s][1]=C[s][1].concat(...o)});return C}}l(g){let b=[];for(const C of this.f.values())C.has(g)&&(b=b.concat(C.get(g)));return b}$acceptMarkersChange(g){if(!this.m){const b="_generated_mirror",C=new f(b,b,pi.d,p=>{},this.j.extUri,void 0,this.g);this.f.set(b,C),this.m=C}for(const[b,C]of g)this.m.set(l.URI.revive(b),C.map(P.Diagnostic.to))}};h.c=0,h.d=1e3,h=qe([We(1,k.ILogService),We(2,T.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(ye[256],De([1,0,2,5]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class l{constructor(D){this.a=D.getProxy(A.MainContext.MainThreadDialogs)}showOpenDialog(D){return this.a.$showOpenDialog(D).then(P=>P?P.map(E=>a.URI.revive(E)):void 0)}showSaveDialog(D){return this.a.$showSaveDialog(D).then(P=>P?a.URI.revive(P):void 0)}}e.ExtHostDialogs=l}),define(ye[257],De([1,0,11,2,7,5,16,21,8]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(T,v,I){this.d=v,this.e=I,this.b=new Map,this.c=T.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(T,v){if(Object.keys(D.Schemas).indexOf(T)>=0)throw new Error(`scheme '${T}' already registered`);const I=k.a++;this.b.set(I,v),this.c.$registerTextContentProvider(I,T);let y;return typeof v.onDidChange=="function"&&(y=v.onDidChange(f=>{if(f.scheme!==T){this.e.warn(`Provider for scheme '${T}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(I,f).then(h=>{if(!h&&typeof h!="string")return;const d=this.d.getDocument(f);if(!d)return;const g=(0,E.splitLines)(h);if(!d.equalLines(g))return this.c.$onVirtualDocumentChange(f,h)},a.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(I)&&this.c.$unregisterTextContentProvider(I),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(T,v){const I=this.b.get(T);return I?Promise.resolve(I.provideTextDocumentContent(A.URI.revive(v),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}k.a=0,e.ExtHostDocumentContentProvider=k}),define(ye[258],De([1,0,3,6,2,5,135,14,9,23,7]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class T{constructor(I,y){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new A.DisposableStore,this.h=new Map,this.f=I.getProxy(R.MainContext.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(f=>{for(const h of f)this.b.fire(h.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const h of f)this.a.fire(h.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(I){if(!I)return;const y=this.g.getDocument(I);if(y)return y}getDocument(I){const y=this.getDocumentData(I);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return y.document}ensureDocumentData(I){const y=this.g.getDocument(I);if(y)return Promise.resolve(y);let f=this.h.get(I.toString());return f||(f=this.f.$tryOpenDocument(I).then(h=>{this.h.delete(I.toString());const d=l.URI.revive(h);return(0,E.assertIsDefined)(this.g.getDocument(d))},h=>(this.h.delete(I.toString()),Promise.reject(h))),this.h.set(I.toString(),f)),f}createDocumentData(I){return this.f.$tryCreateDocument(I).then(y=>l.URI.revive(y))}$acceptModelLanguageChanged(I,y){const f=l.URI.revive(I),h=this.g.getDocument(f);if(!h)throw new Error("unknown document");this.b.fire(h.document),h._acceptLanguageId(y),this.a.fire(h.document)}$acceptModelSaved(I){const y=l.URI.revive(I),f=this.g.getDocument(y);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(I,y){const f=l.URI.revive(I),h=this.g.getDocument(f);if(!h)throw new Error("unknown document");h._acceptIsDirty(y),this.c.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,y,f){const h=l.URI.revive(I),d=this.g.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),d.onEvents(y);let g;y.isUndoing?g=L.TextDocumentChangeReason.Undo:y.isRedoing&&(g=L.TextDocumentChangeReason.Redo),this.c.fire((0,k.deepFreeze)({document:d.document,contentChanges:y.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:g}))}setWordDefinitionFor(I,y){(0,D.setWordDefinitionFor)(I,y)}}e.ExtHostDocuments=T}),define(ye[59],De([1,0,50,3,6,2,4,5,135,20,138,14,13,28,16,64,65]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(C){this.value=C,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(C,p){this.h=C,this.i=p,this.a=null,this.b=new Map,this.c=new I.ResourceMap,this.d=new A.Emitter,this.e=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const p=[],i=[],o=[];if(C.removedDocuments)for(const s of C.removedDocuments){const c=R.URI.revive(s),r=this.c.get(c);r?.unref()&&(this.c.delete(c),p.push(r.value))}if(C.addedDocuments)for(const s of C.addedDocuments){const c=R.URI.revive(s.uri);let r=this.c.get(c);if(r&&c.scheme!==y.Schemas.vscodeNotebookCell&&c.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);r||(r=new d(new E.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),c,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(c,r),i.push(r.value)),r.ref()}if(C.removedEditors)for(const s of C.removedEditors){const c=this.b.get(s);this.b.delete(s),c&&o.push(c)}if(C.addedEditors)for(const s of C.addedEditors){const c=R.URI.revive(s.documentUri);a.ok(this.c.has(c),`document '${c}' does not exist`),a.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(c).value,m=new L.ExtHostTextEditor(s.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new h.Lazy(()=>r.document),s.selections.map(T.Selection.to),s.options,s.visibleRanges.map(n=>T.Range.to(n)),typeof s.editorPosition=="number"?T.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,m)}C.newActiveEditor!==void 0&&(a.ok(C.newActiveEditor===null||this.b.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this.a=C.newActiveEditor),(0,l.dispose)(p),(0,l.dispose)(o),C.removedDocuments&&this.e.fire(p),C.addedDocuments&&this.d.fire(i),(C.removedEditors||C.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),C.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(C){return this.c.get(C)?.value}allDocuments(){return f.Iterable.map(this.c.values(),C=>C.value)}getEditor(C){return this.b.get(C)}activeEditor(C){if(!this.a)return;const p=this.b.get(this.a);return C?p:p?.value}allEditors(){return[...this.b.values()]}};g=qe([We(0,k.IExtHostRpcService),We(1,v.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[60],De([1,0,14,5,2,3,4,7,20,9,61]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class T{constructor(h,d,g){this.e=g,this.d=d,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,d={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(h,d){this.c=[],this.d="",this.b=h,this.e=d;for(const g of h.tabs)g.isActive&&(this.d=g.id),this.c.push(new T(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,d={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return a.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(g=>g.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(g=>g.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const g=new T(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,g),h.tabDto.isActive&&(this.d=g.tabId),g}else if(h.kind===1){const g=this.c.splice(h.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(h.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,g),g}const d=this.c.find(g=>g.tabId===h.tabDto.id);if(!d)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(h.tabDto),d}activeTabId(){return this.d}}let I=class{constructor(h){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=h.getProxy(A.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,d={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(g=>g.apiObject))},get activeTabGroup(){const g=h.d;return(0,k.assertIsDefined)(h.e.find(C=>C.groupId===g)?.apiObject)},close:async(g,b)=>{const C=Array.isArray(g)?g:[g];return C.length?y(C[0])?this.j(C,b):this.i(C,b):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(h){const d=new Set(this.e.map(s=>s.groupId)),g=new Set(h.map(s=>s.groupId)),b=(0,L.diffSets)(d,g),C=this.e.filter(s=>b.removed.includes(s.groupId)).map(s=>s.apiObject),p=[],i=[];this.e=h.map(s=>{const c=new v(s,()=>this.d);return b.added.includes(c.groupId)?p.push(c.apiObject):i.push(c.apiObject),c});const o=(0,k.assertIsDefined)(h.find(s=>s.isActive===!0)?.groupId);o!==void 0&&this.d!==o&&(this.d=o),this.c.fire(Object.freeze({opened:p,closed:C,changed:i}))}$acceptTabGroupUpdate(h){const d=this.e.find(g=>g.groupId===h.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const d=this.e.find(b=>b.groupId===h.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const g=d.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(h){for(const d of this.e)for(const g of d.tabs)if(g.apiObject===h)return g}h(h){return this.e.find(d=>d.apiObject===h)}async i(h,d){const g=[];for(const b of h){const C=this.g(b);if(!C)throw new Error("Tab close: Invalid tab not found!");g.push(C.tabId)}return this.a.$closeTab(g,d)}async j(h,d){const g=[];for(const b of h){const C=this.h(b);if(!C)throw new Error("Group close: Invalid group not found!");g.push(C.groupId)}return this.a.$closeGroup(g,d)}};I=qe([We(0,E.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function y(f){return f.tabs!==void 0}}),define(ye[259],De([1,0,2,5,6,7,14,154,8,22,27]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class T{constructor(){this.a=[]}add(y){this.b=void 0,this.a.push(y)}delete(y){const f=this.a.indexOf(y);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const y=this.a.sort(),f=[];let h,d,g=14,b=14;for(const C of y){let p=h?(0,E.commonPrefixLength)(h,C):0;for(p===0?d=1:d=b;p<C.length;p++)p+1===C.length?(g=b,b=9):b+=1,f.push([d,C.toUpperCase().charCodeAt(p),b]),f.push([d,C.toLowerCase().charCodeAt(p),b]),d=b;h=C,b=g}f.push([9,58,10]),f.push([10,47,12]),this.b=new P.StateMachine(f)}}provideDocumentLinks(y){this.c();const f=[],h=P.LinkComputer.computeLinks({getLineContent(d){return y.lineAt(d-1).text},getLineCount(){return y.lineCount}},this.b);for(const d of h){const g=D.DocumentLink.to(d);g.target&&f.push(g)}return f}}class v{constructor(y,f){this.i=f,this.b=new T,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=y.getProxy(A.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(y,f,h,d={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(y,"*",this.b));const g=this.h++;this.b.add(f),this.d.add(f),this.c.set(g,h);let b=2;d.isCaseSensitive&&(b+=1024),d.isReadonly&&(b+=2048),typeof h.copy=="function"&&(b+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,L.checkProposedApiEnabled)(y,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(g,f,b).catch(p=>{console.error(`FAILED to register filesystem provider of ${y.identifier.value}-extension for the scheme ${f}`),console.error(p)});const C=h.onDidChangeFile(p=>{const i=[];for(const o of p){const{uri:s,type:c}=o;if(s.scheme!==f)continue;let r;switch(c){case R.FileChangeType.Changed:r=0;break;case R.FileChangeType.Created:r=1;break;case R.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:s,type:r})}this.a.$onFileSystemChange(g,i)});return(0,l.toDisposable)(()=>{C.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(y){const{type:f,ctime:h,mtime:d,size:g,permissions:b}=y;return{type:f,ctime:h,mtime:d,size:g,permissions:b}}$stat(y,f){return Promise.resolve(this.k(y).stat(a.URI.revive(f))).then(h=>v.j(h))}$readdir(y,f){return Promise.resolve(this.k(y).readDirectory(a.URI.revive(f)))}$readFile(y,f){return Promise.resolve(this.k(y).readFile(a.URI.revive(f))).then(h=>k.VSBuffer.wrap(h))}$writeFile(y,f,h,d){return Promise.resolve(this.k(y).writeFile(a.URI.revive(f),h.buffer,d))}$delete(y,f,h){return Promise.resolve(this.k(y).delete(a.URI.revive(f),h))}$rename(y,f,h,d){return Promise.resolve(this.k(y).rename(a.URI.revive(f),a.URI.revive(h),d))}$copy(y,f,h,d){const g=this.k(y);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(f),a.URI.revive(h),d))}$mkdir(y,f){return Promise.resolve(this.k(y).createDirectory(a.URI.revive(f)))}$watch(y,f,h,d){const g=this.k(y).watch(a.URI.revive(h),d);this.f.set(f,g)}$unwatch(y,f){const h=this.f.get(f);h&&(h.dispose(),this.f.delete(f))}$open(y,f,h){const d=this.k(y);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(a.URI.revive(f),h))}$close(y,f){const h=this.k(y);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(f))}$read(y,f,h,d){const g=this.k(y);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(d);return Promise.resolve(g.read(f,h,b.buffer,0,d)).then(C=>b.slice(0,C))}$write(y,f,h,d){const g=this.k(y);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(f,h,d.buffer,0,d.byteLength))}k(y){const f=this.c.get(y);if(!f){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return f}}e.ExtHostFileSystem=v}),define(ye[77],De([1,0,5,44,7,22,4,20,48,6]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Jt{constructor(v,I){this.b=new Map,this.a=v.getProxy(a.MainContext.MainThreadFileSystem);const y=this;this.value=Object.freeze({async stat(f){try{const h=y.b.get(f.scheme);if(!h)return await y.a.$stat(f);await y.a.$ensureActivation(f.scheme);const d=await h.stat(f);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(h){Jt.c(h)}},async readDirectory(f){try{const h=y.b.get(f.scheme);return h?(await y.a.$ensureActivation(f.scheme),(await h.readDirectory(f)).slice()):await y.a.$readdir(f)}catch(h){return Jt.c(h)}},async createDirectory(f){try{return await y.a.$mkdir(f)}catch(h){return Jt.c(h)}},async readFile(f){try{const h=y.b.get(f.scheme);return h?(await y.a.$ensureActivation(f.scheme),(await h.readFile(f)).slice()):(await y.a.$readFile(f)).buffer}catch(h){return Jt.c(h)}},async writeFile(f,h){try{return await y.a.$writeFile(f,R.VSBuffer.wrap(h))}catch(d){return Jt.c(d)}},async delete(f,h){try{const d=y.b.get(f.scheme);return d?(await y.a.$ensureActivation(f.scheme),await d.delete(f,{recursive:!1,...h})):await y.a.$delete(f,{recursive:!1,useTrash:!1,...h})}catch(d){return Jt.c(d)}},async rename(f,h,d){try{return await y.a.$rename(f,h,{overwrite:!1,...d})}catch(g){return Jt.c(g)}},async copy(f,h,d){try{return await y.a.$copy(f,h,{overwrite:!1,...d})}catch(g){return Jt.c(g)}},isWritableFileSystem(f){const h=I.getCapabilities(f);if(typeof h=="number")return!(h&2048)}})}static c(v){if(v instanceof l.FileSystemError)throw v;if(!(v instanceof Error))throw new l.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(v.message);switch(v.name){case A.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(v.message);case A.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(v.message);case A.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(v.message);case A.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(v.message);case A.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(v.message);case A.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(v.message);default:throw new l.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,I){return this.b.set(v,I),(0,k.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,P.IExtHostRpcService),We(1,E.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[260],De([1,0,3,38,2,5,14,7]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(T,v,I,y,f,h,d,g){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const b=this.h(T,I,f);this.g=0,h&&(this.g+=1),d&&(this.g+=2),g&&(this.g+=4);const C=(0,A.parse)(f),p=typeof f=="string",i=y(o=>{if(!h)for(const s of o.created){const c=l.URI.revive(s);C(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.a.fire(c)}if(!d)for(const s of o.changed){const c=l.URI.revive(s);C(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.b.fire(c)}if(!g)for(const s of o.deleted){const c=l.URI.revive(s);C(c.fsPath)&&(!p||v.getWorkspaceFolder(c))&&this.c.fire(c)}});this.d=P.Disposable.from(b,this.a,this.b,this.c,i)}h(T,v,I){const y=P.Disposable.from();if(typeof I=="string")return y;const f=T.getProxy(R.MainContext.MainThreadFileSystem);let h=!1;(I.pattern.includes(A.GLOBSTAR)||I.pattern.includes(A.GLOB_SPLIT))&&(h=!0);const d=Math.random();return f.$watch(v.identifier.value,d,I.baseUri,{recursive:h,excludes:[]}),P.Disposable.from({dispose:()=>f.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class k{constructor(T,v,I){this.j=T,this.k=v,this.l=I,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(T,v,I,y,f,h){return new E(this.j,T,v,this.a.event,D.GlobPattern.from(I),y,f,h)}$onFileEvent(T){this.a.fire(T)}$onDidRunFileOperation(T,v){switch(T){case 2:this.b.fire(Object.freeze({files:v.map(I=>({oldUri:l.URI.revive(I.source),newUri:l.URI.revive(I.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(I=>l.URI.revive(I.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(I=>l.URI.revive(I.target))}));break;default:}}getOnWillRenameFileEvent(T){return this.m(T,this.g)}getOnWillCreateFileEvent(T){return this.m(T,this.h)}getOnWillDeleteFileEvent(T){return this.m(T,this.i)}m(T,v){return(I,y,f)=>{const h=function(g){I.call(y,g)};return h.extension=T,v.event(h,void 0,f)}}async $onWillRunFileOperation(T,v,I,y){switch(T){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:l.URI.revive(f.source),newUri:l.URI.revive(f.target)}))},I,y);case 1:return await this.n(this.i,{files:v.map(f=>l.URI.revive(f.target))},I,y);case 0:case 3:return await this.n(this.h,{files:v.map(f=>l.URI.revive(f.target))},I,y)}}async n(T,v,I,y){const f=new Set,h=[];if(await T.fireAsync(v,y,async(g,b)=>{const C=Date.now(),p=await Promise.resolve(g);p instanceof P.WorkspaceEdit&&(h.push([b.extension,p]),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-C>I&&this.k.warn("SLOW file-participant",b.extension.identifier)}),y.isCancellationRequested||h.length===0)return;const d={edits:[]};for(const[,g]of h){const{edits:b}=D.WorkspaceEdit.from(g,{getTextDocumentVersion:C=>this.l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(b)}return{edit:d,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=k}),define(ye[261],De([1,0,2,40]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(D,P,E,k,L){this.a=P,this.b=E,this.c=k;const T=new A.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new A.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new A.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new A.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new A.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new A.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const I=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:I.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this.c.registerApiCommand(T)}$willAddInteractiveDocument(D,P,E,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:E,uri:D,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=l}),define(ye[262],De([1,0,6,5]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(D){this.b=0,this.a=D.getProxy(A.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,D),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(ye[263],De([1,0,2,23,14,7,71,5,8,32,15,9,150,21,6,120,101,74,43,11,19,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(N,W){this.d=N,this.e=W}async provideDocumentSymbols(N,W){const K=this.d.getDocument(N),Y=await this.e.provideDocumentSymbols(K,W);if(!(0,L.isFalsyOrEmpty)(Y))return Y[0]instanceof R.DocumentSymbol?Y.map(l.DocumentSymbol.from):i.f(Y)}static f(N){N=N.slice(0).sort((Y,he)=>{let we=Y.location.range.start.compareTo(he.location.range.start);return we===0&&(we=he.location.range.end.compareTo(Y.location.range.end)),we});const W=[],K=[];for(const Y of N){const he={name:Y.name||"!!MISSING: name!!",kind:l.SymbolKind.from(Y.kind),tags:Y.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:Y.containerName,range:l.Range.from(Y.location.range),selectionRange:l.Range.from(Y.location.range),children:[]};for(;;){if(K.length===0){K.push(he),W.push(he);break}const we=K[K.length-1];if(k.Range.containsRange(we.range,he.range)&&!k.Range.equalsRange(we.range,he.range)){we.children?.push(he),K.push(he);break}K.pop()}}return W}}class o{constructor(N,W,K){this.g=N,this.h=W,this.j=K,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,W){const K=this.g.getDocument(N),Y=await this.j.provideCodeLenses(K,W);if(!Y||W.isCancellationRequested)return;const he=this.e.add(Y),we=new y.DisposableStore;this.f.set(he,we);const Ae={cacheId:he,lenses:[]};for(let be=0;be<Y.length;be++)Ae.lenses.push({cacheId:[he,be],range:l.Range.from(Y[be].range),command:this.h.toInternal(Y[be].command,we)});return Ae}async resolveCodeLens(N,W){const K=N.cacheId&&this.e.get(...N.cacheId);if(!K)return;let Y;if(typeof this.j.resolveCodeLens!="function"||K.isResolved?Y=K:Y=await this.j.resolveCodeLens(K,W),Y||(Y=K),W.isCancellationRequested)return;const he=N.cacheId&&this.f.get(N.cacheId[0]);if(!!he)return N.command=this.h.toInternal(Y.command??o.d,he),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}o.d={command:"missing",title:"!!MISSING: command!!"};function s(se){return Array.isArray(se)?se.map(l.DefinitionLink.from):se?[l.DefinitionLink.from(se)]:[]}class c{constructor(N,W){this.d=N,this.e=W}async provideDefinition(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideDefinition(Y,he,K);return s(we)}}class r{constructor(N,W){this.d=N,this.e=W}async provideDeclaration(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideDeclaration(Y,he,K);return s(we)}}class m{constructor(N,W){this.d=N,this.e=W}async provideImplementation(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideImplementation(Y,he,K);return s(we)}}class n{constructor(N,W){this.d=N,this.e=W}async provideTypeDefinition(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideTypeDefinition(Y,he,K);return s(we)}}class t{constructor(N,W){this.d=N,this.e=W}async provideHover(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideHover(Y,he,K);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=Y.getWordRangeAtPosition(he)),we.range||(we.range=new R.Range(he,he)),l.Hover.from(we)}}class u{constructor(N,W){this.d=N,this.e=W}async provideEvaluatableExpression(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideEvaluatableExpression(Y,he,K);if(we)return l.EvaluatableExpression.from(we)}}class w{constructor(N,W){this.d=N,this.e=W}async provideInlineValues(N,W,K,Y){const he=this.d.getDocument(N),we=await this.e.provideInlineValues(he,l.Range.to(W),l.InlineValueContext.to(K),Y);if(Array.isArray(we))return we.map(Ae=>l.InlineValue.from(Ae))}}class S{constructor(N,W){this.d=N,this.e=W}async provideDocumentHighlights(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideDocumentHighlights(Y,he,K);if(Array.isArray(we))return we.map(l.DocumentHighlight.from)}}class F{constructor(N,W){this.d=N,this.e=W}async provideLinkedEditingRanges(N,W,K){const Y=this.d.getDocument(N),he=l.Position.to(W),we=await this.e.provideLinkedEditingRanges(Y,he,K);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(l.Range.from)),wordPattern:we.wordPattern}}}class x{constructor(N,W){this.d=N,this.e=W}async provideReferences(N,W,K,Y){const he=this.d.getDocument(N),we=l.Position.to(W),Ae=await this.e.provideReferences(he,we,K,Y);if(Array.isArray(Ae))return Ae.map(l.location.from)}}class V{constructor(N,W,K,Y,he,we,Ae){this.g=N,this.h=W,this.j=K,this.k=Y,this.l=he,this.m=we,this.n=Ae,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,W,K,Y){const he=this.g.getDocument(N),we=v.Selection.isISelection(W)?l.Selection.to(W):l.Range.to(W),Ae=[];for(const et of this.j.getDiagnostics(N))if(we.intersection(et.range)&&Ae.push(et)>V.d)break;const be={diagnostics:Ae,only:K.only?new R.CodeActionKind(K.only):void 0,triggerKind:l.CodeActionTriggerKind.to(K.trigger)},Ce=await this.k.provideCodeActions(he,we,be,Y);if(!(0,L.isNonEmptyArray)(Ce)||Y.isCancellationRequested)return;const Te=this.e.add(Ce),Ve=new y.DisposableStore;this.f.set(Te,Ve);const xe=[];for(let et=0;et<Ce.length;et++){const Qe=Ce[et];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,Ve)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Te,et],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,Ve),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(l.Diagnostic.from),edit:Qe.edit&&l.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:Te,actions:xe}}async resolveCodeAction(N,W){const[K,Y]=N,he=this.e.get(K,Y);if(!he||V.o(he)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(he,W)??he;return we?.edit?l.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}V.d=1e3;class M{constructor(N,W,K,Y){this.d=N,this.e=W,this.f=K,this.g=Y}async prepareDocumentPaste(N,W,K,Y){if(!this.f.prepareDocumentPaste)return;const he=this.e.getDocument(N),we=W.map(be=>l.Range.to(be)),Ae=l.DataTransfer.toDataTransfer(K,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(he,we,Ae,Y),l.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(N,W,K,Y,he){const we=this.e.getDocument(W),Ae=K.map(Te=>l.Range.to(Te)),be=l.DataTransfer.toDataTransfer(Y,async Te=>(await this.d.$resolvePasteFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class B{constructor(N,W){this.d=N,this.e=W}async provideDocumentFormattingEdits(N,W,K){const Y=this.d.getDocument(N),he=await this.e.provideDocumentFormattingEdits(Y,W,K);if(Array.isArray(he))return he.map(l.TextEdit.from)}}class O{constructor(N,W){this.d=N,this.e=W}async provideDocumentRangeFormattingEdits(N,W,K,Y){const he=this.d.getDocument(N),we=l.Range.to(W),Ae=await this.e.provideDocumentRangeFormattingEdits(he,we,K,Y);if(Array.isArray(Ae))return Ae.map(l.TextEdit.from)}}class U{constructor(N,W){this.d=N,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,W,K,Y,he){const we=this.d.getDocument(N),Ae=l.Position.to(W),be=await this.e.provideOnTypeFormattingEdits(we,Ae,K,Y,he);if(Array.isArray(be))return be.map(l.TextEdit.from)}}class ${constructor(N,W){this.e=N,this.f=W,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,W){const K=await this.e.provideWorkspaceSymbols(N,W);if(!(0,L.isNonEmptyArray)(K))return{symbols:[]};const Y=this.d.add(K),he={cacheId:Y,symbols:[]};for(let we=0;we<K.length;we++){const Ae=K[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}he.symbols.push({...l.WorkspaceSymbol.from(Ae),cacheId:[Y,we]})}return he}async resolveWorkspaceSymbol(N,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const K=this.d.get(...N.cacheId);if(K){const Y=await this.e.resolveWorkspaceSymbol(K,W);return Y&&(0,A.mixin)(N,l.WorkspaceSymbol.from(Y),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class j{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,W,K){this.d=N,this.e=W,this.f=K}async provideRenameEdits(N,W,K,Y){const he=this.d.getDocument(N),we=l.Position.to(W);try{const Ae=await this.e.provideRenameEdits(he,we,K,Y);return Ae?l.WorkspaceEdit.from(Ae):void 0}catch(Ae){const be=j.g(Ae);return be?{rejectReason:be,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(N,W,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Y=this.d.getDocument(N),he=l.Position.to(W);try{const we=await this.e.prepareRename(Y,he,K);let Ae,be;if(R.Range.isRange(we)?(Ae=we,be=Y.getText(we)):(0,T.isObject)(we)&&(Ae=we.range,be=we.placeholder),!Ae||!be)return;if(Ae.start.line>he.line||Ae.end.line<he.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Ae),text:be}}catch(we){const Ae=j.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class le{constructor(N,W){this.resultId=N,this.tokens=W}}class J{constructor(N,W){this.f=N,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,W,K){const Y=this.f.getDocument(N),he=W!==0?this.d.get(W):null;let we=typeof he?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Y,he.resultId,K):await this.g.provideDocumentSemanticTokens(Y,K);return he&&this.d.delete(W),we?(we=J.h(we),this.o(J.n(he,we),we)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return J.j(N)?J.k(N)?N:new R.SemanticTokens(new Uint32Array(N.data),N.resultId):J.l(N)?J.m(N)?N:new R.SemanticTokensEdits(N.edits.map(W=>new R.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const W of N.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(N,W){if(!J.j(W)||!N||!N.tokens)return W;const K=N.tokens,Y=K.length,he=W.data,we=he.length;let Ae=0;const be=Math.min(Y,we);for(;Ae<be&&K[Ae]===he[Ae];)Ae++;if(Ae===Y&&Ae===we)return new R.SemanticTokensEdits([],W.resultId);let Ce=0;const Te=be-Ae;for(;Ce<Te&&K[Y-Ce-1]===he[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Y-Ae-Ce,data:he.subarray(Ae,we-Ce)}],W.resultId)}o(N,W){if(J.j(N)){const K=this.e++;return this.d.set(K,new le(N.resultId,N.data)),(0,f.encodeSemanticTokensDto)({id:K,type:"full",data:N.data})}if(J.l(N)){const K=this.e++;return J.j(W)?this.d.set(K,new le(W.resultId,W.data)):this.d.set(K,new le(N.resultId)),(0,f.encodeSemanticTokensDto)({id:K,type:"delta",deltas:(N.edits||[]).map(Y=>({start:Y.start,deleteCount:Y.deleteCount,data:Y.data}))})}return null}}class q{constructor(N,W){this.d=N,this.e=W}async provideDocumentRangeSemanticTokens(N,W,K){const Y=this.d.getDocument(N),he=await this.e.provideDocumentRangeSemanticTokens(Y,l.Range.to(W),K);return he?this.f(he):null}f(N){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class Q{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,W,K,Y,he){this.f=N,this.g=W,this.h=K,this.j=Y,this.k=he,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,W,K,Y){const he=this.f.getDocument(N),we=l.Position.to(W),Ae=he.getWordRangeAtPosition(we)||new R.Range(we,we),be=Ae.with({end:we}),Ce=new g.StopWatch(!0),Te=await this.h.provideCompletionItems(he,we,Y,l.CompletionContext.to(K));if(!Te||Y.isCancellationRequested)return;const Ve=Array.isArray(Te)?new R.CompletionList(Te):Te,xe=Q.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),et=new y.DisposableStore;this.e.set(xe,et);const Qe=[],nt={x:xe,b:Qe,a:{replace:l.Range.from(Ae),insert:l.Range.from(be)},c:Ve.isIncomplete||void 0,d:Ce.elapsed()};for(let st=0;st<Ve.items.length;st++){const ht=Ve.items[st],Ue=this.l(ht,[xe,st],be,Ae);Qe.push(Ue)}return nt}async resolveCompletionItem(N,W){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...N);if(!K)return;const Y=await this.h.resolveCompletionItem(K,W);if(!!Y)return this.l(Y,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,W,K,Y){const he=this.e.get(W[0]);if(!he)throw Error("DisposableStore is missing...");const we=this.g.toInternal(N.command,he),Ae={x:W,a:N.label,b:N.kind!==void 0?l.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(l.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:l.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(l.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=N.textEdit.newText):typeof N.insertText=="string"?Ae.h=N.insertText:N.insertText instanceof R.SnippetString&&(Ae.h=N.insertText.value,Ae.i|=4);let be;return N.textEdit?be=N.textEdit.range:N.range&&(be=N.range),R.Range.isRange(be)?Ae.j=l.Range.from(be):be&&(!K?.isEqual(be.inserting)||!Y?.isEqual(be.replacing))&&(Ae.j={insert:l.Range.from(be.inserting),replace:l.Range.from(be.replacing)}),Ae}}class Z{async provideInlineCompletions(N,W,K,Y){}disposeCompletions(N){}handleDidShowCompletionItem(N,W){}handlePartialAccept(N,W,K){}}class te extends Z{constructor(N,W,K,Y){super(),this.f=N,this.g=W,this.h=K,this.j=Y,this.d=new X,this.e=(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[D.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,p.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,W,K,Y){const he=this.g.getDocument(N),we=l.Position.to(W),Ae=await this.h.provideInlineCompletionItems(he,we,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:l.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},Y);if(!Ae||Y.isCancellationRequested)return;const be=Array.isArray(Ae)?Ae:Ae.items,Ce=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let Te;return{pid:this.d.createReferenceId({dispose(){Te?.dispose()},items:be}),items:be.map((xe,et)=>{let Qe;xe.command&&(Te||(Te=new y.DisposableStore),Qe=this.j.toInternal(xe.command,Te));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?l.Range.from(xe.range):void 0,command:Qe,idx:et,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:Ce.map(xe=>(Te||(Te=new y.DisposableStore),this.j.toInternal(xe,Te)))}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,W){const K=this.d.get(N)?.items[W];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K)}handlePartialAccept(N,W,K){const Y=this.d.get(N)?.items[W];Y&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Y,K)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const W=this.e++;return this.d.set(W,N),W}disposeReferenceId(N){const W=this.d.get(N);return this.d.delete(N),W}get(N){return this.d.get(N)}}class _{constructor(N,W){this.e=N,this.f=W,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(N,W,K,Y){const he=this.e.getDocument(N),we=l.Position.to(W),Ae=this.g(K),be=await this.f.provideSignatureHelp(he,we,Y,Ae);if(be){const Ce=this.d.add([be]);return{...l.SignatureHelp.from(be),id:Ce}}}g(N){let W;if(N.activeSignatureHelp){const K=l.SignatureHelp.to(N.activeSignatureHelp),Y=this.d.get(N.activeSignatureHelp.id,0);Y?(W=Y,W.activeSignature=K.activeSignature,W.activeParameter=K.activeParameter):W=K}return{...N,activeSignatureHelp:W}}releaseSignatureHelp(N){this.d.delete(N)}}class ie{constructor(N,W,K,Y,he){this.f=N,this.g=W,this.h=K,this.j=Y,this.k=he,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,W,K){const Y=this.f.getDocument(N),he=l.Range.to(W),we=await this.h.provideInlayHints(Y,he,K);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new y.DisposableStore);const be={hints:[],cacheId:Ae};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],he)&&be.hints.push(this.m(we[Ce],[Ae,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),be}async resolveInlayHint(N,W){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...N);if(!K)return;const Y=await this.h.resolveInlayHint(K,W);if(!!Y&&!!this.l(Y))return this.m(Y,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,W){return N.label.length===0||Array.isArray(N.label)&&N.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(W&&!W.contains(N.position))}m(N,W){const K=this.e.get(W[0]);if(!K)throw Error("DisposableStore is missing...");const Y={label:"",cacheId:W,tooltip:l.MarkdownString.fromStrict(N.tooltip),position:l.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(l.TextEdit.from),kind:N.kind&&l.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?Y.label=N.label:Y.label=N.label.map(he=>{const we={label:he.value};return we.tooltip=l.MarkdownString.fromStrict(he.tooltip),R.Location.isLocation(he.location)&&(we.location=l.location.from(he.location)),he.command&&(we.command=this.g.toInternal(he.command,K)),we}),Y}}class pe{constructor(N,W){this.e=N,this.f=W,this.d=new d.Cache("DocumentLink")}async provideLinks(N,W){const K=this.e.getDocument(N),Y=await this.f.provideDocumentLinks(K,W);if(!(!Array.isArray(Y)||Y.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Y.filter(pe.g).map(l.DocumentLink.from)};{const he=this.d.add(Y),we={links:[],cacheId:he};for(let Ae=0;Ae<Y.length;Ae++){if(!pe.g(Y[Ae]))continue;const be=l.DocumentLink.from(Y[Ae]);be.cacheId=[he,Ae],we.links.push(be)}return we}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,W){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...N);if(!K)return;const Y=await this.f.resolveDocumentLink(K,W);if(!(!Y||!pe.g(Y)))return l.DocumentLink.from(Y)}releaseLinks(N){this.d.delete(N)}}class ve{constructor(N,W){this.d=N,this.e=W}async provideColors(N,W){const K=this.d.getDocument(N),Y=await this.e.provideDocumentColors(K,W);return Array.isArray(Y)?Y.map(we=>({color:l.Color.from(we.color),range:l.Range.from(we.range)})):[]}async provideColorPresentations(N,W,K){const Y=this.d.getDocument(N),he=l.Range.to(W.range),we=l.Color.to(W.color),Ae=await this.e.provideColorPresentations(we,{document:Y,range:he},K);if(!!Array.isArray(Ae))return Ae.map(l.ColorPresentation.from)}}class ke{constructor(N,W){this.d=N,this.e=W}async provideFoldingRanges(N,W,K){const Y=this.d.getDocument(N),he=await this.e.provideFoldingRanges(Y,W,K);if(!!Array.isArray(he))return he.map(l.FoldingRange.from)}}class Oe{constructor(N,W,K){this.d=N,this.e=W,this.f=K}async provideSelectionRanges(N,W,K){const Y=this.d.getDocument(N),he=W.map(l.Position.to),we=await this.e.provideSelectionRanges(Y,he,K);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==he.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let be=0;be<he.length;be++){const Ce=[];Ae.push(Ce);let Te=he[be],Ve=we[be];for(;;){if(!Ve.range.contains(Te))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(l.SelectionRange.from(Ve)),!Ve.parent)break;Te=Ve.range,Ve=Ve.parent}}return Ae}}class oe{constructor(N,W){this.f=N,this.g=W,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(N,W,K){const Y=this.f.getDocument(N),he=l.Position.to(W),we=await this.g.prepareCallHierarchy(Y,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideCallsTo(N,W,K){const Y=this.j(N,W);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyIncomingCalls(Y,K);if(!!he)return he.map(we=>({from:this.h(N,we.from),fromRanges:we.fromRanges.map(Ae=>l.Range.from(Ae))}))}async provideCallsFrom(N,W,K){const Y=this.j(N,W);if(!Y)throw new Error("missing call hierarchy item");const he=await this.g.provideCallHierarchyOutgoingCalls(Y,K);if(!!he)return he.map(we=>({to:this.h(N,we.to),fromRanges:we.fromRanges.map(Ae=>l.Range.from(Ae))}))}releaseSession(N){this.e.delete(N)}h(N,W){const K=this.e.get(N),Y=l.CallHierarchyItem.from(W,N,K.size.toString(36));return K.set(Y._itemId,W),Y}j(N,W){return this.e.get(N)?.get(W)}}class ae{constructor(N,W){this.f=N,this.g=W,this.d=new h.IdGenerator(""),this.e=new Map}async prepareSession(N,W,K){const Y=this.f.getDocument(N),he=l.Position.to(W),we=await this.g.prepareTypeHierarchy(Y,he,K);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(be=>this.h(Ae,be)):[this.h(Ae,we)]}async provideSupertypes(N,W,K){const Y=this.j(N,W);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySupertypes(Y,K);if(!!he)return he.map(we=>this.h(N,we))}async provideSubtypes(N,W,K){const Y=this.j(N,W);if(!Y)throw new Error("missing type hierarchy item");const he=await this.g.provideTypeHierarchySubtypes(Y,K);if(!!he)return he.map(we=>this.h(N,we))}releaseSession(N){this.e.delete(N)}h(N,W){const K=this.e.get(N),Y=l.TypeHierarchyItem.from(W,N,K.size.toString(36));return K.set(Y._itemId,W),Y}j(N,W){return this.e.get(N)?.get(W)}}class fe{constructor(N,W,K,Y){this.d=N,this.e=W,this.f=K,this.g=Y}async provideDocumentOnDropEdits(N,W,K,Y,he){const we=this.e.getDocument(W),Ae=l.Position.to(K),be=l.DataTransfer.toDataTransfer(Y,async Te=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Te)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Ae,be,he);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ee{constructor(N,W){this.adapter=N,this.extension=W}}class ue{constructor(N,W,K,Y,he,we,Ae,be){this.g=W,this.h=K,this.j=Y,this.k=he,this.l=we,this.m=Ae,this.n=be,this.f=new Map,this.e=N.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(N){return l.DocumentSelector.from(N,this.g)}p(N){return new R.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return ue.d++}async s(N,W,K,Y,he,we=!1){const Ae=this.f.get(N);if(!Ae||!(Ae.adapter instanceof W))return Y;const be=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ce=K(Ae.adapter,Ae.extension);return Promise.resolve(Ce).catch(Te=>{(0,b.isCancellationError)(Te)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Te),this.n.onExtensionError(Ae.extension.identifier,Te))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),I.CancellationToken.isCancellationToken(he)?(0,C.raceCancellationError)(Ce,he):Ce}t(N,W){const K=this.q();return this.f.set(K,new ee(N,W)),K}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,W,K,Y){const he=this.t(new i(this.h,K),N),we=Y&&Y.label||ue.u(N);return this.e.$registerDocumentSymbolProvider(he,this.o(W),we),this.p(he)}$provideDocumentSymbols(N,W,K){return this.s(N,i,Y=>Y.provideDocumentSymbols(a.URI.revive(W),K),void 0,K)}registerCodeLensProvider(N,W,K){const Y=this.q(),he=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Y,new ee(new o(this.h,this.j.converter,K),N)),this.e.$registerCodeLensSupport(Y,this.o(W),he);let we=this.p(Y);if(he!==void 0){const Ae=K.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(N,W,K){return this.s(N,o,Y=>Y.provideCodeLenses(a.URI.revive(W),K),void 0,K)}$resolveCodeLens(N,W,K){return this.s(N,o,Y=>Y.resolveCodeLens(W,K),void 0,void 0)}$releaseCodeLenses(N,W){this.s(N,o,K=>Promise.resolve(K.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(N,W,K){const Y=this.t(new c(this.h,K),N);return this.e.$registerDefinitionSupport(Y,this.o(W)),this.p(Y)}$provideDefinition(N,W,K,Y){return this.s(N,c,he=>he.provideDefinition(a.URI.revive(W),K,Y),[],Y)}registerDeclarationProvider(N,W,K){const Y=this.t(new r(this.h,K),N);return this.e.$registerDeclarationSupport(Y,this.o(W)),this.p(Y)}$provideDeclaration(N,W,K,Y){return this.s(N,r,he=>he.provideDeclaration(a.URI.revive(W),K,Y),[],Y)}registerImplementationProvider(N,W,K){const Y=this.t(new m(this.h,K),N);return this.e.$registerImplementationSupport(Y,this.o(W)),this.p(Y)}$provideImplementation(N,W,K,Y){return this.s(N,m,he=>he.provideImplementation(a.URI.revive(W),K,Y),[],Y)}registerTypeDefinitionProvider(N,W,K){const Y=this.t(new n(this.h,K),N);return this.e.$registerTypeDefinitionSupport(Y,this.o(W)),this.p(Y)}$provideTypeDefinition(N,W,K,Y){return this.s(N,n,he=>he.provideTypeDefinition(a.URI.revive(W),K,Y),[],Y)}registerHoverProvider(N,W,K,Y){const he=this.t(new t(this.h,K),N);return this.e.$registerHoverProvider(he,this.o(W)),this.p(he)}$provideHover(N,W,K,Y){return this.s(N,t,he=>he.provideHover(a.URI.revive(W),K,Y),void 0,Y)}registerEvaluatableExpressionProvider(N,W,K,Y){const he=this.t(new u(this.h,K),N);return this.e.$registerEvaluatableExpressionProvider(he,this.o(W)),this.p(he)}$provideEvaluatableExpression(N,W,K,Y){return this.s(N,u,he=>he.provideEvaluatableExpression(a.URI.revive(W),K,Y),void 0,Y)}registerInlineValuesProvider(N,W,K,Y){const he=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new w(this.h,K),N);this.e.$registerInlineValuesProvider(we,this.o(W),he);let Ae=this.p(we);if(he!==void 0){const be=K.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(he));Ae=R.Disposable.from(Ae,be)}return Ae}$provideInlineValues(N,W,K,Y,he){return this.s(N,w,we=>we.provideInlineValues(a.URI.revive(W),K,Y,he),void 0,he)}registerDocumentHighlightProvider(N,W,K){const Y=this.t(new S(this.h,K),N);return this.e.$registerDocumentHighlightProvider(Y,this.o(W)),this.p(Y)}$provideDocumentHighlights(N,W,K,Y){return this.s(N,S,he=>he.provideDocumentHighlights(a.URI.revive(W),K,Y),void 0,Y)}registerLinkedEditingRangeProvider(N,W,K){const Y=this.t(new F(this.h,K),N);return this.e.$registerLinkedEditingRangeProvider(Y,this.o(W)),this.p(Y)}$provideLinkedEditingRanges(N,W,K,Y){return this.s(N,F,async he=>{const we=await he.provideLinkedEditingRanges(a.URI.revive(W),K,Y);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ue.w(we.wordPattern):void 0}},void 0,Y)}registerReferenceProvider(N,W,K){const Y=this.t(new x(this.h,K),N);return this.e.$registerReferenceSupport(Y,this.o(W)),this.p(Y)}$provideReferences(N,W,K,Y,he){return this.s(N,x,we=>we.provideReferences(a.URI.revive(W),K,Y,he),void 0,he)}registerCodeActionProvider(N,W,K,Y){const he=new y.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,K,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(we,this.o(W),{providedKinds:Y?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Y?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,he)}))},ue.u(N),Boolean(K.resolveCodeAction)),he.add(this.p(we)),he}$provideCodeActions(N,W,K,Y,he){return this.s(N,V,we=>we.provideCodeActions(a.URI.revive(W),K,Y,he),void 0,he)}$resolveCodeAction(N,W,K){return this.s(N,V,Y=>Y.resolveCodeAction(W,K),void 0,void 0)}$releaseCodeActions(N,W){this.s(N,V,K=>Promise.resolve(K.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(N,W,K){const Y=this.t(new B(this.h,K),N);return this.e.$registerDocumentFormattingSupport(Y,this.o(W),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentFormattingEdits(N,W,K,Y){return this.s(N,B,he=>he.provideDocumentFormattingEdits(a.URI.revive(W),K,Y),void 0,Y)}registerDocumentRangeFormattingEditProvider(N,W,K){const Y=this.t(new O(this.h,K),N);return this.e.$registerRangeFormattingSupport(Y,this.o(W),N.identifier,N.displayName||N.name),this.p(Y)}$provideDocumentRangeFormattingEdits(N,W,K,Y,he){return this.s(N,O,we=>we.provideDocumentRangeFormattingEdits(a.URI.revive(W),K,Y,he),void 0,he)}registerOnTypeFormattingEditProvider(N,W,K,Y){const he=this.t(new U(this.h,K),N);return this.e.$registerOnTypeFormattingSupport(he,this.o(W),Y,N.identifier),this.p(he)}$provideOnTypeFormattingEdits(N,W,K,Y,he,we){return this.s(N,U,Ae=>Ae.provideOnTypeFormattingEdits(a.URI.revive(W),K,Y,he,we),void 0,we)}registerWorkspaceSymbolProvider(N,W){const K=this.t(new $(W,this.l),N);return this.e.$registerNavigateTypeSupport(K,typeof W.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(N,W,K){return this.s(N,$,Y=>Y.provideWorkspaceSymbols(W,K),{symbols:[]},K)}$resolveWorkspaceSymbol(N,W,K){return this.s(N,$,Y=>Y.resolveWorkspaceSymbol(W,K),void 0,void 0)}$releaseWorkspaceSymbols(N,W){this.s(N,$,K=>K.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(N,W,K){const Y=this.t(new j(this.h,K,this.l),N);return this.e.$registerRenameSupport(Y,this.o(W),j.supportsResolving(K)),this.p(Y)}$provideRenameEdits(N,W,K,Y,he){return this.s(N,j,we=>we.provideRenameEdits(a.URI.revive(W),K,Y,he),void 0,he)}$resolveRenameLocation(N,W,K,Y){return this.s(N,j,he=>he.resolveRenameLocation(a.URI.revive(W),K,Y),void 0,Y)}registerDocumentSemanticTokensProvider(N,W,K,Y){const he=this.t(new J(this.h,K),N),we=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(he,this.o(W),Y,we);let Ae=this.p(he);if(we){const be=K.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,be)}return Ae}$provideDocumentSemanticTokens(N,W,K,Y){return this.s(N,J,he=>he.provideDocumentSemanticTokens(a.URI.revive(W),K,Y),null,Y)}$releaseDocumentSemanticTokens(N,W){this.s(N,J,K=>K.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,W,K,Y){const he=this.t(new q(this.h,K),N);return this.e.$registerDocumentRangeSemanticTokensProvider(he,this.o(W),Y),this.p(he)}$provideDocumentRangeSemanticTokens(N,W,K,Y){return this.s(N,q,he=>he.provideDocumentRangeSemanticTokens(a.URI.revive(W),K,Y),null,Y)}registerCompletionItemProvider(N,W,K,Y){const he=this.t(new Q(this.h,this.j.converter,K,this.m,N),N);return this.e.$registerCompletionsProvider(he,this.o(W),Y,Q.supportsResolving(K),`${N.identifier.value}(${Y.join("")})`),this.p(he)}$provideCompletionItems(N,W,K,Y,he){return this.s(N,Q,we=>we.provideCompletionItems(a.URI.revive(W),K,Y,he),void 0,he)}$resolveCompletionItem(N,W,K){return this.s(N,Q,Y=>Y.resolveCompletionItem(W,K),void 0,K)}$releaseCompletionItems(N,W){this.s(N,Q,K=>K.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(N,W,K){const Y=new te(N,this.h,K,this.j.converter),he=this.t(Y,N);return this.e.$registerInlineCompletionsSupport(he,this.o(W),Y.supportsHandleEvents),this.p(he)}$provideInlineCompletions(N,W,K,Y,he){return this.s(N,Z,we=>we.provideInlineCompletions(a.URI.revive(W),K,Y,he),void 0,he)}$handleInlineCompletionDidShow(N,W,K){this.s(N,Z,async Y=>{Y.handleDidShowCompletionItem(W,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,W,K,Y){this.s(N,Z,async he=>{he.handlePartialAccept(W,K,Y)},void 0,void 0)}$freeInlineCompletionsList(N,W){this.s(N,Z,async K=>{K.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(N,W,K,Y){const he=Array.isArray(Y)?{triggerCharacters:Y,retriggerCharacters:[]}:Y,we=this.t(new _(this.h,K),N);return this.e.$registerSignatureHelpProvider(we,this.o(W),he),this.p(we)}$provideSignatureHelp(N,W,K,Y,he){return this.s(N,_,we=>we.provideSignatureHelp(a.URI.revive(W),K,Y,he),void 0,he)}$releaseSignatureHelp(N,W){this.s(N,_,K=>K.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(N,W,K){const Y=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,he=this.t(new ie(this.h,this.j.converter,K,this.l,N),N);this.e.$registerInlayHintsProvider(he,this.o(W),typeof K.resolveInlayHint=="function",Y,ue.u(N));let we=this.p(he);if(Y!==void 0){const Ae=K.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(Y));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(N,W,K,Y){return this.s(N,ie,he=>he.provideInlayHints(a.URI.revive(W),K,Y),void 0,Y)}$resolveInlayHint(N,W,K){return this.s(N,ie,Y=>Y.resolveInlayHint(W,K),void 0,K)}$releaseInlayHints(N,W){this.s(N,ie,K=>K.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(N,W,K){const Y=this.t(new pe(this.h,K),N);return this.e.$registerDocumentLinkProvider(Y,this.o(W),typeof K.resolveDocumentLink=="function"),this.p(Y)}$provideDocumentLinks(N,W,K){return this.s(N,pe,Y=>Y.provideLinks(a.URI.revive(W),K),void 0,K,W.scheme==="output")}$resolveDocumentLink(N,W,K){return this.s(N,pe,Y=>Y.resolveLink(W,K),void 0,void 0,!0)}$releaseDocumentLinks(N,W){this.s(N,pe,K=>K.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(N,W,K){const Y=this.t(new ve(this.h,K),N);return this.e.$registerDocumentColorProvider(Y,this.o(W)),this.p(Y)}$provideDocumentColors(N,W,K){return this.s(N,ve,Y=>Y.provideColors(a.URI.revive(W),K),[],K)}$provideColorPresentations(N,W,K,Y){return this.s(N,ve,he=>he.provideColorPresentations(a.URI.revive(W),K,Y),void 0,Y)}registerFoldingRangeProvider(N,W,K){const Y=this.q(),he=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Y,new ee(new ke(this.h,K),N)),this.e.$registerFoldingRangeProvider(Y,this.o(W),N.identifier,he);let we=this.p(Y);if(he!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(he));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(N,W,K,Y){return this.s(N,ke,he=>he.provideFoldingRanges(a.URI.revive(W),K,Y),void 0,Y)}registerSelectionRangeProvider(N,W,K){const Y=this.t(new Oe(this.h,K,this.l),N);return this.e.$registerSelectionRangeProvider(Y,this.o(W)),this.p(Y)}$provideSelectionRanges(N,W,K,Y){return this.s(N,Oe,he=>he.provideSelectionRanges(a.URI.revive(W),K,Y),[],Y)}registerCallHierarchyProvider(N,W,K){const Y=this.t(new oe(this.h,K),N);return this.e.$registerCallHierarchyProvider(Y,this.o(W)),this.p(Y)}$prepareCallHierarchy(N,W,K,Y){return this.s(N,oe,he=>Promise.resolve(he.prepareSession(a.URI.revive(W),K,Y)),void 0,Y)}$provideCallHierarchyIncomingCalls(N,W,K,Y){return this.s(N,oe,he=>he.provideCallsTo(W,K,Y),void 0,Y)}$provideCallHierarchyOutgoingCalls(N,W,K,Y){return this.s(N,oe,he=>he.provideCallsFrom(W,K,Y),void 0,Y)}$releaseCallHierarchy(N,W){this.s(N,oe,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(N,W,K){const Y=this.t(new ae(this.h,K),N);return this.e.$registerTypeHierarchyProvider(Y,this.o(W)),this.p(Y)}$prepareTypeHierarchy(N,W,K,Y){return this.s(N,ae,he=>Promise.resolve(he.prepareSession(a.URI.revive(W),K,Y)),void 0,Y)}$provideTypeHierarchySupertypes(N,W,K,Y){return this.s(N,ae,he=>he.provideSupertypes(W,K,Y),void 0,Y)}$provideTypeHierarchySubtypes(N,W,K,Y){return this.s(N,ae,he=>he.provideSubtypes(W,K,Y),void 0,Y)}$releaseTypeHierarchy(N,W){this.s(N,ae,K=>Promise.resolve(K.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(N,W,K){const Y=this.q();return this.f.set(Y,new ee(new fe(this.e,this.h,K,Y),N)),this.e.$registerDocumentOnDropEditProvider(Y,this.o(W)),this.p(Y)}$provideDocumentOnDropEdits(N,W,K,Y,he,we){return this.s(N,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(W,a.URI.revive(K),Y,he,we)),void 0,void 0)}registerDocumentPasteEditProvider(N,W,K,Y){const he=this.q();return this.f.set(he,new ee(new M(this.e,this.h,K,he),N)),this.e.$registerPasteEditProvider(he,this.o(W),!!K.prepareDocumentPaste,Y.pasteMimeTypes),this.p(he)}$prepareDocumentPaste(N,W,K,Y,he){return this.s(N,M,we=>we.prepareDocumentPaste(a.URI.revive(W),K,Y,he),void 0,he)}$providePasteEdits(N,W,K,Y,he,we){return this.s(N,M,Ae=>Ae.providePasteEdits(W,a.URI.revive(K),Y,he,we),void 0,we)}static w(N){return{pattern:N.source,flags:(0,E.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:ue.w(N.decreaseIndentPattern),increaseIndentPattern:ue.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ue.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ue.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:ue.w(N.beforeText),afterText:N.afterText?ue.w(N.afterText):void 0,previousLineText:N.previousLineText?ue.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(ue.z)}setLanguageConfiguration(N,W,K){const{wordPattern:Y}=K;if(Y&&(0,E.regExpLeadsToEndlessLoop)(Y))throw new Error(`Invalid language configuration: wordPattern '${Y}' is not allowed to match the empty string.`);Y?this.h.setWordDefinitionFor(W,Y):this.h.setWordDefinitionFor(W,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const he=this.q(),we={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?ue.w(K.wordPattern):void 0,indentationRules:K.indentationRules?ue.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?ue.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport};return this.e.$setLanguageConfiguration(he,W,we),this.p(he)}$setWordDefinitions(N){for(const W of N)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}ue.d=0,e.ExtHostLanguageFeatures=ue}),define(ye[264],De([1,0,5,14,7,37,19,6]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(L,T,v,I){this.c=T,this.d=v,this.e=I,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,T){await this.a.$changeLanguage(L,T);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,T){const v=L.version,I=A.Position.from(T),y=await this.a.$tokensAtPosition(L.uri,I),f={type:l.StandardTokenType.Other,range:L.getWordRangeAtPosition(T)??new l.Range(T.line,T.character,T.line,T.character)};if(!y)return f;const h={range:A.Range.to(y.range),type:A.TokenType.to(y.type)};return!h.range.contains(T)||v!==L.version?f:h}createLanguageStatusItem(L,T,v){const I=this.f++,y=this.a,f=this.g,h=`${L.identifier.value}/${T}`;if(f.has(h))throw new Error(`LanguageStatusItem with id '${T}' ALREADY exists`);f.add(h);const d={selector:v,id:T,name:L.displayName??L.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const b=new P.DisposableStore,C=()=>{g?.dispose(),g=(0,D.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(I,{id:h,name:d.name??L.displayName??L.name,source:L.displayName??L.name,selector:A.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?R.default.Error:d.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:d.command&&this.d.toInternal(d.command,b),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},p={dispose(){b.dispose(),g?.dispose(),y.$removeLanguageStatus(I),f.delete(h)},get id(){return d.id},get name(){return d.name},set name(i){d.name=i,C()},get selector(){return d.selector},set selector(i){d.selector=i,C()},get text(){return d.text},set text(i){d.text=i,C()},get detail(){return d.detail},set detail(i){d.detail=i,C()},get severity(){return d.severity},set severity(i){d.severity=i,C()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(i){d.accessibilityInformation=i,C()},get command(){return d.command},set command(i){d.command=i,C()},get busy(){return d.busy},set busy(i){d.busy=i,C()}};return C(),p}}e.ExtHostLanguages=E}),define(ye[97],De([1,0,12,8,2,4,13,5,25,20]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,I,y){this.f=y,this.d=new Map,this.a=I.getProxy(P.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(v,I){const{message:y,args:f,comment:h}=I;if(this.c)return(0,A.format2)(y,f??{});let d=y;h&&h.length>0&&(d+=`/${Array.isArray(h)?h.join(""):h}`);const g=this.d.get(v)?.contents[d];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,A.format2)(g??y,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let I;const y=await this.g(v);if(!y){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(y),h=JSON.parse(f);I=v.isBuiltin?h.contents?.bundle:h}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${y}: ${f.message}`);return}I&&this.d.set(v.identifier.value,{contents:I,uri:y})}async g(v){if(v.isBuiltin){const I=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return l.URI.revive(I)}return v.l10n?l.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,E.IExtHostInitDataService),We(1,k.IExtHostRpcService),We(2,D.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,20,2,69]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let E=class extends a.AbstractLoggerService{constructor(T,v){super(v.logLevel,v.loggers.map(I=>(0,P.revive)(I))),this.l=T.getProxy(A.MainContext.MainThreadLogger)}$setLogLevel(T,v){v?this.setLogLevel(D.URI.revive(v),T):this.setLogLevel(T)}setVisibility(T,v){super.setVisibility(T,v),this.l.$setVisibility(T,v)}k(T,v,I){return new k(this.l,T,v,I)}};E=qe([We(0,R.IExtHostRpcService),We(1,l.IExtHostInitDataService)],E),e.ExtHostLoggerService=E;class k extends a.AbstractMessageLogger{constructor(T,v,I,y){super(y?.logLevel==="always"),this.m=T,this.n=v,this.k=!1,this.l=[],this.setLevel(I),this.m.$createLogger(v,y).then(()=>{this.r(this.l),this.k=!0})}g(T,v){const I=[[T,v]];this.k?this.r(I):this.l.push(...I)}r(T){this.m.$log(this.n,T)}}}),define(ye[265],De([1,0,5,13,27]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(P){return P&&P.title}let D=class{constructor(E,k){this.b=k,this.a=E.getProxy(a.MainContext.MainThreadMessageService)}showMessage(E,k,L,T,v){const I={source:{identifier:E.identifier,label:E.displayName||E.name}};let y;typeof T=="string"||R(T)?y=[T,...v]:(I.modal=T?.modal,I.useCustom=T?.useCustom,I.detail=T?.detail,y=v),I.useCustom&&(0,l.checkProposedApiEnabled)(E,"resolvers");const f=[];for(let h=0;h<y.length;h++){const d=y[h];if(typeof d=="string")f.push({title:d,handle:h,isCloseAffordance:!1});else if(typeof d=="object"){const{title:g,isCloseAffordance:b}=d;f.push({title:g,isCloseAffordance:!!b,handle:h})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(k,L,I,f).then(h=>{if(typeof h=="number")return y[h]})}};D=qe([We(1,A.ILogService)],D),e.ExtHostMessageService=D}),define(ye[266],De([1,0,22,3,6,28,8,9,2,74,5,40,14,7,58,241,136]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,C,p,i){this.q=p,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new A.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(L.MainContext.MainThreadNotebook),this.c=b.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=C.converter,C.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===13){const s=o.notebookEditor?.notebookUri,c=o.cell.handle,m=this.g.get(s)?.getCell(c);if(m)return m.apiCell}if(o&&o.$mid===14){const s=o.uri,c=this.g.get(s);if(c)return c.apiNotebook}return o}}),d.x(C)}getEditorById(b){const C=this.h.get(b);if(!C)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return C}getIdByEditor(b){for(const[C,p]of this.h)if(p.apiEditor===b)return C}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,C){const p=this.g.get(b);if(!p&&!C)throw new Error(`NO notebook document for '${b}'`);return p}static s(b,C){if(!C)return;const p=C.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(C.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:C.displayName,filenamePattern:p,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,C,p){const i=d.a++,o=typeof p.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(i,p),this.b.$registerNotebookCellStatusBarItemProvider(i,o,C);let s;return o!==void 0&&(s=p.onDidChangeCellStatusBarItems(c=>this.b.$emitCellStatusBarEvent(o))),new I.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,o),s?.dispose()})}async createNotebookDocument(b){const C=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return E.URI.revive(C)}async openNotebookDocument(b){const C=this.g.get(b);if(C)return C.apiNotebook;const p=await this.c.$tryOpenNotebook(b),i=this.g.get(E.URI.revive(p));return(0,P.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,C){E.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let p;typeof C=="object"?p={position:v.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(v.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:p={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,p),o=i&&this.h.get(i)?.apiEditor;if(o)return o;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,C,p,i){const o=this.f.get(b),s=E.URI.revive(C),c=this.g.get(s);if(!c||!o)return;const r=c.getCellFromIndex(p);if(!r)return;const m=await o.provideCellStatusBarItems(r.apiCell,i);if(!m)return;const n=new l.DisposableStore,t=this.p.add([n]),w=(Array.isArray(m)?m:[m]).map(S=>v.NotebookStatusBarItem.from(S,this.i,n));return{cacheId:t,items:w}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,C,p,i,o){if((0,D.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,p),this.b.$registerNotebookSerializer(s,{id:b.identifier,location:b.extensionLocation},C,v.NotebookDocumentContentOptions.from(i),d.s(b,o)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(b,C,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.deserializeNotebook(C.buffer,p);return new y.SerializableObjectWithBuffers(v.NotebookData.from(o))}async $notebookToData(b,C,p){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const o=await i.serializeNotebook(v.NotebookData.to(C.value),p);return a.VSBuffer.wrap(o)}w(b,C,p){if(this.h.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const i=new h.ExtHostNotebookEditor(C,this.d,b,p.visibleRanges.map(v.NotebookRange.to),p.selections.map(v.NotebookRange.to),typeof p.viewColumn=="number"?v.ViewColumn.to(p.viewColumn):void 0);this.h.set(C,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const p of b.value.removedDocuments){const i=E.URI.revive(p),o=this.g.get(i);o&&(o.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:o.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(o.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===i.toString()&&this.h.delete(s.id)}if(b.value.addedDocuments){const p=[];for(const i of b.value.addedDocuments){const o=E.URI.revive(i.uri);if(this.g.has(o))throw new Error(`adding EXISTING notebook ${o} `);const s=new f.ExtHostNotebookDocument(this.c,this.q,this.r,o,i);p.push(...i.cells.map(c=>f.ExtHostCell.asModelAddData(s.apiNotebook,c))),this.g.get(o)?.dispose(),this.g.set(o,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(s.apiNotebook)}}if(b.value.addedEditors)for(const p of b.value.addedEditors){if(this.h.has(p.id))return;const i=E.URI.revive(p.documentUri),o=this.g.get(i);o&&this.w(o,p.id,p)}const C=[];if(b.value.removedEditors)for(const p of b.value.removedEditors){const i=this.h.get(p);i&&(this.h.delete(p),this.k?.id===i.id&&(this.k=void 0),C.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const p=new Set;this.l.forEach(i=>p.add(i.id));for(const i of this.h.values()){const o=p.has(i.id);i._acceptVisibility(o)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const C=T.ApiCommandArgument.String.with("notebookType","A notebook type"),p=new T.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new T.ApiCommandArgument("data","Bytes to convert to data",o=>o instanceof Uint8Array,o=>a.VSBuffer.wrap(o))],new T.ApiCommandResult("Notebook Data",o=>v.NotebookData.to(o.value))),i=new T.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new T.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",o=>!0,o=>new y.SerializableObjectWithBuffers(v.NotebookData.from(o)))],new T.ApiCommandResult("Bytes",o=>o.buffer));b.registerApiCommand(p),b.registerApiCommand(i)}}d.a=0,e.ExtHostNotebookController=d}),define(ye[267],De([1,0,15,19,21,3,6,28,2,26,13,74,5,40,14,7,94,231,27,58]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(r,m,n,t,u){this.k=m,this.l=n,this.m=t,this.n=u,this.b=new P.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new T.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=r.getProxy(v.MainContext.MainThreadNotebookKernels);const w=new I.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new I.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const F=this.l.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:F}}else if(S&&"notebookEditor"in S){const F=this.l.getIdByEditor(S.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return S})],I.ApiCommandResult.Void);this.m.registerApiCommand(w)}createNotebookController(r,m,n,t,u,w){for(const Z of this.h.values())if(Z.controller.id===m&&k.ExtensionIdentifier.equals(r.identifier,Z.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const S=this.i++,F=this;this.n.trace(`NotebookController[${S}], CREATED by ${r.identifier.value}, ${m}`);const x=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${r.identifier}'`);let V=!1;const M=new D.DisposableStore,B=new R.Emitter,O=new R.Emitter,U={id:s(r.identifier,m),notebookType:n,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:t||r.identifier.value,preloads:w?w.map(y.NotebookRendererScript.from):[]};let $=u??x,j;this.a.$addKernel(S,U).catch(Z=>{console.log(Z),V=!0});let le=0;const J=()=>{if(V)return;const Z=++le;Promise.resolve().then(()=>{Z===le&&this.a.$updateKernel(S,U)})},q=new P.ResourceMap,Q={get id(){return m},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return U.label},set label(Z){U.label=Z??r.displayName??r.name,J()},get detail(){return U.detail??""},set detail(Z){U.detail=Z,J()},get description(){return U.description??""},set description(Z){U.description=Z,J()},get kind(){return(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind??""},set kind(Z){(0,g.checkProposedApiEnabled)(r,"notebookControllerKind"),U.kind=Z,J()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages(Z){U.supportedLanguages=Z,J()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){U.supportsExecutionOrder=Z,J()},get rendererScripts(){return U.preloads?U.preloads.map(y.NotebookRendererScript.to):[]},get executeHandler(){return $},set executeHandler(Z){$=Z??x},get interruptHandler(){return j},set interruptHandler(Z){j=Z,U.supportsInterrupt=Boolean(Z),J()},createNotebookCellExecution(Z){if(V)throw new Error("notebook controller is DISPOSED");if(!q.has(Z.notebook.uri))throw F.n.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(q.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return F._createNotebookCellExecution(Z,s(r.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${S}], DISPOSED`),V=!0,this.h.delete(S),M.dispose(),B.dispose(),O.dispose(),this.a.$removeKernel(S))},updateNotebookAffinity(Z,te){te===f.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(r,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(S,Z.uri,te)},onDidReceiveMessage:O.event,postMessage(Z,te){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),F.a.$postMessage(S,te&&F.l.getIdByEditor(te),Z)},asWebviewUri(Z){return(0,g.checkProposedApiEnabled)(r,"notebookMessaging"),(0,h.asWebviewUri)(Z,F.k.remote)}};return this.h.set(S,{extensionId:r.identifier,controller:Q,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:q}),Q}getIdByController(r){for(const[m,n]of this.h)if(n.controller===r)return s(n.extensionId,r.id);return null}createNotebookControllerDetectionTask(r,m){const n=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${r.identifier.value}`),this.a.$addKernelDetectionTask(n,m);const u={dispose:()=>{this.c.delete(n),t.a.$removeKernelDetectionTask(n)}};return this.c.set(n,u),u}registerKernelSourceActionProvider(r,m,n){const t=this.f++,u=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,w=this;this.e.set(t,n),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${r.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,m);let S;return u!==void 0&&(S=n.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(u))),{dispose:()=>{this.e.delete(t),w.a.$removeKernelSourceActionProvider(t,t),S?.dispose()}}}async $provideKernelSourceActions(r,m){const n=this.e.get(r);if(n){const t=new D.DisposableStore;return this.g.add([t]),(await n.provideNotebookKernelSourceActions(m)??[]).map(w=>y.NotebookKernelSourceAction.from(w,this.m.converter,t))}return[]}$acceptNotebookAssociation(r,m,n){const t=this.h.get(r);if(t){const u=this.l.getNotebookDocument(E.URI.revive(m));n?t.associatedNotebooks.set(u.uri,!0):t.associatedNotebooks.delete(u.uri),this.n.trace(`NotebookController[${r}] ASSOCIATE notebook`,u.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:u.apiNotebook})}}async $executeCells(r,m,n){const t=this.h.get(r);if(!t)return;const u=this.l.getNotebookDocument(E.URI.revive(m)),w=[];for(const S of n){const F=u.getCell(S);F&&w.push(F.apiCell)}try{this.n.trace(`NotebookController[${r}] EXECUTE cells`,u.uri.toString(),w.length),await t.controller.executeHandler.call(t.controller,w,u.apiNotebook,t.controller)}catch(S){this.n.error(`NotebookController[${r}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(r,m,n){const t=this.h.get(r);if(!t)return;const u=this.l.getNotebookDocument(E.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,u.apiNotebook);else for(const w of n){const S=u.getCell(w);S&&this.b.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,m,n){const t=this.h.get(r);if(!t)return;const u=this.l.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:n}))}$cellExecutionChanged(r,m,n){const u=this.l.getNotebookDocument(E.URI.revive(r)).getCell(m);if(u){const w=n?y.NotebookCellExecutionState.to(n):f.NotebookCellExecutionState.Idle;w!==void 0&&this.j.fire({cell:u.apiCell,state:w})}}_createNotebookCellExecution(r,m){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const u=new i(m,t,this.a);this.b.set(t.uri,u);const w=u.onDidChangeState(()=>{u.state===p.Resolved&&(u.dispose(),w.dispose(),this.b.delete(t.uri))});return u.asApiObject()}};C=qe([We(4,L.ILogService)],C),e.ExtHostNotebookKernels=C;var p;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(p||(p={}));class i extends D.Disposable{get state(){return this.f}constructor(r,m,n){super(),this.j=m,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new o(10,t=>this.m(t)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,r,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(r){await this.h.addItem(r)}async m(r){const m=Array.isArray(r)?r:[r];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(m))}n(){if(this.f===p.Init)throw new Error("Must call start before modifying cell output");if(this.f===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(r){let m=this.j;if(r&&(m=this.j.notebook.getCellFromApiCell(r)),!m)throw new Error("INVALID cell");return m.handle}s(r){return r.map(m=>{const n=f.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return n===m.items?y.NotebookCellOutput.from(m):y.NotebookCellOutput.from({items:n,id:m.id,metadata:m.metadata})})}async t(r,m,n){const t=this.r(m),u=this.s((0,a.asArray)(r));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:u})}async w(r,m,n){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:r.map(y.NotebookCellOutputItem.from),outputId:m.id,append:n})}asApiObject(){const r=this;return Object.freeze({get token(){return r.g.token},get cell(){return r.j.apiCell},get executionOrder(){return r.i},set executionOrder(n){r.i=n,r.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:r.i}])},start(n){if(r.f===p.Resolved||r.f===p.Started)throw new Error("Cannot call start again");r.f=p.Started,r.c.fire(),r.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(r.f===p.Resolved)throw new Error("Cannot call resolve twice");r.f=p.Resolved,r.c.fire(),r.h.flush(),r.k.$completeExecution(r.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return r.n(),r.t([],n,!1)},appendOutput(n,t){return r.n(),r.t(n,t,!0)},replaceOutput(n,t){return r.n(),r.t(n,t,!1)},appendOutputItems(n,t){return r.n(),r.w(n,t,!0)},replaceOutputItems(n,t){return r.n(),r.w(n,t,!1)}})}}i.a=0;class o{constructor(r,m){this.d=r,this.e=m,this.a=[],this.b=Date.now()}addItem(r){return this.a.push(r),this.c||(this.c=new A.DeferredPromise,this.b=Date.now(),(0,A.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const r=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>r.complete())}}function s(c,r){return`${c.value}/${r}`}e.createKernelId=s}),define(ye[268],De([1,0,3,5,136]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(P,E){this.c=E,this.a=new Map,this.b=P.getProxy(A.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,E,k){const L=this.c.getEditorById(P);this.a.get(E)?.fire({editor:L.apiEditor,message:k})}createRendererMessaging(P,E){if(!P.contributes?.notebookRenderer?.some(L=>L.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(L,T,v)=>this.d(E).event(L,T,v),postMessage:(L,T)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,T]=[T,L]);const v=T&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(T);return this.b.$postMessage(v?.id,E,L)}}}d(P){let E=this.a.get(P);return E||(E=new a.Emitter({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(P)}}),this.a.set(P,E),E)}}e.ExtHostNotebookRenderers=R}),define(ye[269],De([1,0,6,9,2,27,5]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(k){this.b=new Map,this.a=k.getProxy(D.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(k,L,T){if((0,R.checkProposedApiEnabled)(k,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,T),this.a.$registerProfileContentHandler(L,T.name,T.description,k.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(k,L,T,v){const I=this.b.get(k);if(!I)throw new Error(`Unknown handler with id: ${k}`);return I.saveProfile(L,T,v)}async $readProfile(k,L,T){const v=this.b.get(k);if(!v)throw new Error(`Unknown handler with id: ${k}`);return v.readProfile((0,A.isString)(L)?L:l.URI.revive(L),T)}}e.ExtHostProfileContentHandlers=P}),define(ye[270],De([1,0,2,5,19,14]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class D{constructor(E,k){this.d=k,this.c=new Map,this.b=E.getProxy(A.MainContext.MainThreadQuickDiff)}$provideOriginalResource(E,k,L){const T=a.URI.revive(k),v=this.c.get(E);return v?(0,l.asPromise)(()=>v.provideOriginalResource(T,L)).then(I=>I||null):Promise.resolve(null)}registerQuickDiffProvider(E,k,L,T){const v=D.a++;return this.c.set(v,k),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(E,this.d),L,T),{dispose:()=>this.c.delete(v)}}}D.a=0,e.ExtHostQuickDiff=D}),define(ye[271],De([1,0,21,3,6,5,2,7,11,15,37,51]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(I,y,f){const h=I.getProxy(R.MainContext.MainThreadQuickOpen);class d{constructor(r,m){this.e=new Map,this.f=0,this.a=r,this.b=m}showQuickPick(r,m,n=a.CancellationToken.None){this.c=void 0;const t=Promise.resolve(r),u=++this.f,w=h.$show(u,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},n),S={},F=w.then(()=>S);return Promise.race([F,t]).then(x=>{if(x!==S)return t.then(V=>{const M=[];for(let B=0;B<V.length;B++){const O=V[B];typeof O=="string"?M.push({label:O,handle:B}):O.kind===P.QuickPickItemKind.Separator?M.push({type:"separator",label:O.label}):M.push({label:O.label,description:O.description,detail:O.detail,picked:O.picked,alwaysShow:O.alwaysShow,handle:B})}return m&&typeof m.onDidSelectItem=="function"&&(this.c=B=>{m.onDidSelectItem(V[B])}),h.$setItems(u,M),w.then(B=>{if(typeof B=="number")return V[B];if(Array.isArray(B))return B.map(O=>V[O])})})}).then(void 0,x=>{if(!(0,E.isCancellationError)(x))return h.$setError(u,x),Promise.reject(x)})}$onItemSelected(r){this.c?.(r)}showInput(r,m=a.CancellationToken.None){return this.d=r?.validateInput,h.$input(r,typeof this.d=="function",m).then(void 0,n=>{if(!(0,E.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(r){if(!this.d)return;const m=await this.d(r);if(!m||typeof m=="string")return m;let n;switch(m.severity){case P.InputBoxValidationSeverity.Info:n=L.default.Info;break;case P.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case P.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=m.message?L.default.Error:L.default.Ignore;break}return{content:m.message,severity:n}}async showWorkspaceFolderPick(r,m=a.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!n)return;const t=await this.a.getWorkspaceFolders2();if(!!t)return t.find(u=>u.uri.toString()===n.uri.toString())}createQuickPick(r){const m=new o(r,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}createInputBox(r){const m=new s(r,()=>this.e.delete(m._id));return this.e.set(m._id,m),m}$onDidChangeValue(r,m){this.e.get(r)?._fireDidChangeValue(m)}$onDidAccept(r){this.e.get(r)?._fireDidAccept()}$onDidChangeActive(r,m){const n=this.e.get(r);n instanceof o&&n._fireDidChangeActive(m)}$onDidChangeSelection(r,m){const n=this.e.get(r);n instanceof o&&n._fireDidChangeSelection(m)}$onDidTriggerButton(r,m){this.e.get(r)?._fireDidTriggerButton(m)}$onDidTriggerItemButton(r,m,n){const t=this.e.get(r);t instanceof o&&t._fireDidTriggerItemButton(m,n)}$onDidHide(r){this.e.get(r)?._fireDidHide()}}class g{constructor(r,m){this.x=r,this.y=m,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new A.Emitter,this.q=new A.Emitter,this.r=new A.Emitter,this.s=new A.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(r){this.b=r,this.z({title:r})}get step(){return this.c}set step(r){this.c=r,this.z({step:r})}get totalSteps(){return this.d}set totalSteps(r){this.d=r,this.z({totalSteps:r})}get enabled(){return this.g}set enabled(r){this.g=r,this.z({enabled:r})}get busy(){return this.j}set busy(r){this.j=r,this.z({busy:r})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(r){this.k=r,this.z({ignoreFocusOut:r})}get value(){return this.l}set value(r){this.l=r,this.z({value:r})}get placeholder(){return this.m}set placeholder(r){this.m=r,this.z({placeholder:r})}get buttons(){return this.n}set buttons(r){this.n=r.slice(),this.o.clear(),r.forEach((m,n)=>{const t=m===P.QuickInputButtons.Back?-1:n;this.o.set(t,m)}),this.z({buttons:r.map((m,n)=>({...i(m),tooltip:m.tooltip,handle:m===P.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(r){this.l=r,this.q.fire(r)}_fireDidTriggerButton(r){const m=this.o.get(r);m&&this.r.fire(m)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(r){if(!this.v){for(const m of Object.keys(r)){const n=r[m];this.u[m]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function b(c){if(c instanceof P.ThemeIcon)return{id:c.id};const r=p(c),m=C(c);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof m=="string"?D.URI.file(m):m}}function C(c){return typeof c=="object"&&"light"in c?c.light:c}function p(c){return typeof c=="object"&&"dark"in c?c.dark:c}function i(c){const r=b(c.iconPath);let m,n;return"id"in r?n=T.ThemeIcon.asClassName(r):m=r,{iconPath:m,iconClass:n}}class o extends g{constructor(r,m){super(r.identifier,m),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new A.Emitter,this.L=[],this.M=new A.Emitter,this.N=new A.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(r){this.B=r.slice(),this.C.clear(),this.D.clear(),r.forEach((n,t)=>{this.C.set(t,n),this.D.set(n,t)});const m=[];for(let n=0;n<r.length;n++){const t=r[n];t.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:t.label}):m.push({handle:n,label:t.label,description:t.description,detail:t.detail,picked:t.picked,alwaysShow:t.alwaysShow,buttons:t.buttons?.map((u,w)=>({...i(u),tooltip:u.tooltip,handle:w}))})}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(r){this.E=r,this.z({canSelectMany:r})}get matchOnDescription(){return this.F}set matchOnDescription(r){this.F=r,this.z({matchOnDescription:r})}get matchOnDetail(){return this.G}set matchOnDetail(r){this.G=r,this.z({matchOnDetail:r})}get sortByLabel(){return this.H}set sortByLabel(r){this.H=r,this.z({sortByLabel:r})}get keepScrollPosition(){return this.I}set keepScrollPosition(r){this.I=r,this.z({keepScrollPosition:r})}get activeItems(){return this.J}set activeItems(r){this.J=r.filter(m=>this.D.has(m)),this.z({activeItems:this.J.map(m=>this.D.get(m))})}get selectedItems(){return this.L}set selectedItems(r){this.L=r.filter(m=>this.D.has(m)),this.z({selectedItems:this.L.map(m=>this.D.get(m))})}_fireDidChangeActive(r){const m=(0,k.coalesce)(r.map(n=>this.C.get(n)));this.J=m,this.K.fire(m)}_fireDidChangeSelection(r){const m=(0,k.coalesce)(r.map(n=>this.C.get(n)));this.L=m,this.M.fire(m)}_fireDidTriggerItemButton(r,m){const n=this.C.get(r);if(!n||!n.buttons||!n.buttons.length)return;const t=n.buttons[m];t&&this.N.fire({button:t,item:n})}}class s extends g{constructor(r,m){super(r.identifier,m),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(r){this.B=r,this.z({password:r})}get prompt(){return this.C}set prompt(r){this.C=r,this.z({prompt:r})}get valueSelection(){return this.D}set valueSelection(r){this.D=r,this.z({valueSelection:r})}get validationMessage(){return this.E}set validationMessage(r){this.E=r,r?typeof r=="string"?this.z({validationMessage:r,severity:L.default.Error}):this.z({validationMessage:r.message,severity:r.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new d(y,f)}e.createExtHostQuickOpen=v});var Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)},_e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a};define(ye[272],De([1,0,2,3,62,6,19,5,15,108,13,26,51,14,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y){"use strict";var f,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(t){if(t)return typeof t.iconPath=="string"?a.URI.file(t.iconPath):a.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function g(t,u){if(!t.iconPath&&!u.iconPath)return 0;if(t.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof t.iconPath=="string"?t.iconPath:a.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,S=typeof u.iconPath=="string"?u.iconPath:a.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,k.comparePaths)(w,S)}function b(t,u){let w=0;if(t.strikeThrough!==u.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==u.faded)return t.faded?1:-1;if(t.tooltip!==u.tooltip)return(t.tooltip||"").localeCompare(u.tooltip||"");if(w=g(t,u),w!==0)return w;if(t.light&&u.light)w=g(t.light,u.light);else{if(t.light)return 1;if(u.light)return-1}if(w!==0)return w;if(t.dark&&u.dark)w=g(t.dark,u.dark);else{if(t.dark)return 1;if(u.dark)return-1}return w}function C(t,u){if(t.command!==u.command)return t.command<u.command?-1:1;if(t.title!==u.title)return t.title<u.title?-1:1;if(t.tooltip!==u.tooltip){if(t.tooltip!==void 0&&u.tooltip!==void 0)return t.tooltip<u.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(t.arguments===u.arguments)return 0;if(t.arguments)if(u.arguments){if(t.arguments.length!==u.arguments.length)return t.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<t.arguments.length;w++){const S=t.arguments[w],F=u.arguments[w];if(S!==F)return S<F?-1:1}return 0}function p(t,u){let w=(0,k.comparePaths)(t.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(t.command&&u.command)w=C(t.command,u.command);else{if(t.command)return 1;if(u.command)return-1}if(w!==0)return w;if(t.decorations&&u.decorations)w=b(t.decorations,u.decorations);else{if(t.decorations)return 1;if(u.decorations)return-1}return w}function i(t,u){for(let w=0;w<t.length;w++)if(t[w]!==u[w])return!1;return!0}function o(t,u){return t.command===u.command&&t.title===u.title&&t.tooltip===u.tooltip&&(t.arguments&&u.arguments?i(t.arguments,u.arguments):t.arguments===u.arguments)}function s(t,u){return(0,E.equals)(t,u,o)}class c{get value(){return this.d}set value(u){u=u??"",Be(this,f,"f").$setInputBoxValue(this.l,u),this.m(u)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(u){Be(this,f,"f").$setInputBoxPlaceholder(this.l,u),this.f=u}get validateInput(){return(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(u){if((0,y.checkProposedApiEnabled)(this.k,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=u,Be(this,f,"f").$setValidationProviderIsEnabled(this.l,!!u)}get enabled(){return this.h}set enabled(u){u=!!u,this.h!==u&&(this.h=u,Be(this,f,"f").$setInputBoxEnablement(this.l,u))}get visible(){return this.j}set visible(u){u=!!u,this.j!==u&&(this.j=u,Be(this,f,"f").$setInputBoxVisibility(this.l,u))}constructor(u,w,S){this.k=u,this.l=S,f.set(this,void 0),this.d="",this.e=new A.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,f,w,"f")}showValidationMessage(u,w){(0,y.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,f,"f").$showValidationMessage(this.l,u,w)}$onInputBoxValueChange(u){this.m(u)}m(u){this.d=u,this.e.fire(u)}}e.ExtHostSCMInputBox=c,f=new WeakMap;class r{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(u){this.v=u,this.q.$updateGroupLabel(this.t,this.handle,u)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(u){this.p=u,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(u){this.f=[...u],this.k.fire()}constructor(u,w,S,F,x){this.q=u,this.s=w,this.t=S,this.u=F,this.v=x,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new A.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new A.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=r.d++}getResourceState(u){return this.g.get(u)}$executeResourceCommand(u,w){const S=this.h.get(u);return S?(0,D.asPromise)(()=>this.s.executeCommand(S.command,...S.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this.f].sort(p),S=(0,E.sortedDiff)(this.o,u,p).map(V=>{const M=V.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const U=B.resourceUri;let $;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ie=new R.DisposableStore;$=this.s.converter.toInternal(B.command,ie),this.j.set(O,ie)}else this.h.set(O,B.command);const j=d(B.decorations),le=B.decorations&&d(B.decorations.light)||j,J=B.decorations&&d(B.decorations.dark)||j,q=[le,J],Q=B.decorations&&B.decorations.tooltip||"",Z=B.decorations&&!!B.decorations.strikeThrough,te=B.decorations&&!!B.decorations.faded,X=B.contextValue||"";return{rawResource:[O,U,q,Q,Z,te,X,$],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:M}}),F=S.map(({start:V,deleteCount:M,toInsert:B})=>[V,M,B.map(O=>O.rawResource)]),x=S.reverse();for(const{start:V,deleteCount:M,toInsert:B}of x){const O=B.map($=>$.handle),U=this.n.splice(V,M,...O);for(const $ of U)this.g.delete($),this.h.delete($),this.j.get($)?.dispose(),this.j.delete($)}return this.o=u,F}dispose(){this.l=!0,this.m.fire()}}r.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(u){this.g!==u&&(this.g=u,Be(this,h,"f").$updateSourceControl(this.t,{count:u}))}get quickDiffProvider(){return this.h}set quickDiffProvider(u){this.h=u,Be(this,h,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this.j}set commitTemplate(u){u!==this.j&&(this.j=u,Be(this,h,"f").$updateSourceControl(this.t,{commitTemplate:u}))}get acceptInputCommand(){return this.l}set acceptInputCommand(u){this.k.value=new R.DisposableStore,this.l=u;const w=this.v.converter.toInternal(u,this.k.value);Be(this,h,"f").$updateSourceControl(this.t,{acceptInputCommand:w})}get actionButton(){return(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(u){(0,y.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=u;const w=u!==void 0?{command:this.v.converter.toInternal(u.command,this.m.value),secondaryCommands:u.secondaryCommands?.map(S=>S.map(F=>this.v.converter.toInternal(F,this.m.value))),description:u.description,enabled:u.enabled}:void 0;Be(this,h,"f").$updateSourceControl(this.t,{actionButton:w??null})}get statusBarCommands(){return this.p}set statusBarCommands(u){if(this.p&&u&&s(this.p,u))return;this.o.value=new R.DisposableStore,this.p=u;const w=(u||[]).map(S=>this.v.converter.toInternal(S,this.o.value));Be(this,h,"f").$updateSourceControl(this.t,{statusBarCommands:w})}get selected(){return this.q}constructor(u,w,S,F,x,V){this.u=u,this.v=S,this.w=F,this.x=x,this.y=V,h.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new A.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,_e(this,h,w,"f"),this.f=new c(u,Be(this,h,"f"),this.t),Be(this,h,"f").$registerSourceControl(this.t,F,x,V)}createResourceGroup(u,w){const S=new r(Be(this,h,"f"),this.v,this.t,u,w),F=A.Event.once(S.onDidDispose)(()=>this.z.delete(S));return this.z.set(S,F),this.eventuallyAddResourceGroups(),S}eventuallyAddResourceGroups(){const u=[],w=[];for(const[S,F]of this.z){F.dispose();const x=S.onDidUpdateResourceStates(()=>{this.A.add(S),this.eventuallyUpdateResourceStates()});A.Event.once(S.onDidDispose)(()=>{this.A.delete(S),x.dispose(),this.e.delete(S.handle),Be(this,h,"f").$unregisterGroup(this.t,S.handle)}),u.push([S.handle,S.id,S.label,S.features]);const V=S._takeResourceStateSnapshot();V.length>0&&w.push([S.handle,V]),this.e.set(S.handle,S)}Be(this,h,"f").$registerGroups(this.t,u,w),this.z.clear()}eventuallyUpdateResourceStates(){const u=[];this.A.forEach(w=>{const S=w._takeResourceStateSnapshot();S.length!==0&&u.push([w.handle,S])}),u.length>0&&Be(this,h,"f").$spliceResourceStates(this.t,u),this.A.clear()}getResourceGroup(u){return this.e.get(u)}setSelectionState(u){this.q=u,this.s.fire(u)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(u=>u.dispose()),Be(this,h,"f").$unregisterSourceControl(this.t)}}h=new WeakMap,m.d=0,qe([(0,l.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),qe([(0,l.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(u,w,S){this.l=w,this.m=S,this.g=new Map,this.h=new Map,this.j=new A.Emitter,this.e=u.getProxy(P.MainContext.MainThreadSCM),this.f=u.getProxy(P.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===3){const x=this.g.get(F.sourceControlHandle);if(!x)return F;const V=x.getResourceGroup(F.groupHandle);return V?V.getResourceState(F.handle):F}else if(F&&F.$mid===4){const x=this.g.get(F.sourceControlHandle);return x?x.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===5){const x=this.g.get(F.handle);return x||F}return F}})}createSourceControl(u,w,S,F){this.m.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,S,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const x=on.d++,V=new m(u,this.e,this.l,w,S,F);this.g.set(x,V);const M=this.h.get(T.ExtensionIdentifier.toKey(u.identifier))||[];return M.push(V),this.h.set(T.ExtensionIdentifier.toKey(u.identifier),M),V}getLastInputBox(u){this.m.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this.h.get(T.ExtensionIdentifier.toKey(u.identifier)),S=w&&w[w.length-1];return S&&S.inputBox}$provideOriginalResource(u,w,S){const F=a.URI.revive(w);this.m.trace("ExtHostSCM#$provideOriginalResource",u,F.toString());const x=this.g.get(u);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(F,S)).then(V=>V||null)}$onInputBoxValueChange(u,w){this.m.trace("ExtHostSCM#$onInputBoxValueChange",u);const S=this.g.get(u);return S&&S.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,S,F){this.m.trace("ExtHostSCM#$executeResourceCommand",u,w,S);const x=this.g.get(u);if(!x)return Promise.resolve(void 0);const V=x.getResourceGroup(w);return V?V.$executeResourceCommand(S,F):Promise.resolve(void 0)}$validateInput(u,w,S){this.m.trace("ExtHostSCM#$validateInput",u);const F=this.g.get(u);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>F.inputBox.validateInput(w,S)).then(x=>{if(!x)return Promise.resolve(void 0);const V=I.MarkdownString.fromStrict(x.message);return V?Promise.resolve([V,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this.g.get(u)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=u,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[98],De([1,0,5,3,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(P){this.b=new A.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,E){return this.a.$getPassword(P,E)}store(P,E,k){return this.a.$setPassword(P,E,k)}delete(P,E){return this.a.$deletePassword(P,E)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[273],De([1,0,7,5,180,6,14,9]),function(ne,e,a,A,l,R,D,P){"use strict";var E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(y,f,h,d,g=a.StatusBarAlignment.Left,b){E.set(this,void 0),k.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,E,y,"f"),_e(this,k,f,"f"),this.c=L.a++,this.e=h,this.f=d,this.g=g,this.h=this.u(b)}u(y){if(!!(0,P.isNumber)(y))return y===Number.POSITIVE_INFINITY?Number.MAX_VALUE:y===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:y}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(y){this.k=y,this.v()}set name(y){this.m=y,this.v()}set tooltip(y){this.l=y,this.v()}set color(y){this.n=y,this.v()}set backgroundColor(y){y&&!L.b.has(y.id)&&(y=void 0),this.o=y,this.v()}set command(y){this.r?.fromApi!==y&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof y=="string"?this.r={fromApi:y,internal:Be(this,k,"f").toInternal({title:"",command:y},this.p)}:y?this.r={fromApi:y,internal:Be(this,k,"f").toInternal(y,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(y){this.t=y,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,E,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let y;this.e?this.f?y=`${this.e.identifier.value}.${this.f}`:y=this.e.identifier.value:y=this.f;let f;this.m?f=this.m:f=(0,l.localize)(0,null,this.e.displayName||this.e.name);let h=this.n;this.o&&(h=L.b.get(this.o.id));const d=D.MarkdownString.fromStrict(this.l);Be(this,E,"f").$setEntry(this.c,y,f,this.k,d,this.r?.internal,h,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}E=new WeakMap,k=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=L;class T{constructor(y){this.b=[],this.a=y.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(y){const f={message:y};return this.b.unshift(f),this.c(),new a.Disposable(()=>{const h=this.b.indexOf(f);h>=0&&(this.b.splice(h,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(y,f){this.a=y.getProxy(A.MainContext.MainThreadStatusBar),this.b=f,this.c=new T(this)}createStatusBarEntry(y,f,h,d){return new L(this.a,this.b,y,f,h,d)}setStatusBarMessage(y,f){const h=this.c.setMessage(y);let d;return typeof f=="number"?d=setTimeout(()=>h.dispose(),f):typeof f<"u"&&f.then(()=>h.dispose(),()=>h.dispose()),new a.Disposable(()=>{h.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(P,E){this.c=E,this.b=new A.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,E){this.a.$registerExtensionStorageKeysToSync(P,E)}async initializeExtensionStorage(P,E,k){const L=await this.a.$initializeExtensionStorage(P,E);let T;return L&&(T=this.d(P,E,L)),T||k}setValue(P,E,k){return this.a.$setValue(P,E,k)}$acceptValue(P,E,k){const L=this.d(P,E,k);L&&this.b.fire({shared:P,key:E,value:L})}d(P,E,k){try{return JSON.parse(k)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${P}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(ye[78],De([1,0,4,25,13,77,2]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let P=class{constructor(k,L,T){this.d=L,this.f=T,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(k){return D.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,L=await this.g(k);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(D.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:D.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(T){this.d.error("[ExtHostStorage]",T);return}}workspaceValue(k){if(this.c)return D.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return D.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=qe([We(0,A.IExtHostInitDataService),We(1,l.ILogService),We(2,R.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[41],De([1,0,3,5,4,2,20,6,7,182,11,214,21,30,215,51,9,19,14]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class b{constructor(n,t,u,w){this.k=n,this._id=t,this.l=u,this.m=w,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(F=>this.f=F);const S=this;this.value={get name(){return S.m||""},get processId(){return S.b},get creationOptions(){return S.l},get exitStatus(){return S.h},get state(){return S.j},sendText(F,x=!0){S.o(),S.k.$sendText(S._id,F,x)},show(F){S.o(),S.k.$show(S._id,F)},hide(){S.o(),S.k.$hide(S._id)},dispose(){S.a||(S.a=!0,S.k.$dispose(S._id))},get dimensions(){if(!(S.d===void 0||S.g===void 0))return{columns:S.d,rows:S.g}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,h.withNullAsUndefined)(n.shellPath),shellArgs:(0,h.withNullAsUndefined)(n.shellArgs),cwd:(0,h.withNullAsUndefined)(n.cwd),env:(0,h.withNullAsUndefined)(n.env),icon:(0,h.withNullAsUndefined)(c(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,h.withNullAsUndefined)(n.message),strictEnv:(0,h.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,u,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:u,color:f.ThemeColor.isThemeColor(w)?w.id:void 0,location:this.n(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:g.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,t){this.h=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this.d&&t===this.g||n===0||t===0?!1:(this.d=n,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(t=>{t!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class C{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,t){this.g.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let p=1,i=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(A.MainContext.MainThreadTerminalService),this.s=new y.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[u,w]of this.g)w.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,t){const u=new b(this.a,(0,I.generateUuid)(),n,n.name),w=new C(n.pty);return u.createExtensionTerminal(n.location,this.L(n,t).resolvedExtHostIdentifier,c(n.iconPath),r(n.color)).then(S=>{const F=this.M(S,w);this.h[S]=F}),this.f.push(u),u.value}L(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const u=n.location.parentTerminal;if(u){const w=this.f.find(S=>S.value===u);w&&(t.resolvedExtHostIdentifier=w._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const w=new C(t),S=this.M(n,w);this.h[n]=S}async $acceptActiveTerminalChanged(n){const t=this.b;if(n===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const u=this.O(n);u&&(this.b=u,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,t){const u=this.O(n);u&&this.I.fire({terminal:u.value,data:t})}async $acceptTerminalDimensions(n,t,u){const w=this.O(n);w&&w.setDimensions(t,u)&&this.G.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,u){this.g.get(n)?.resize(t,u)}async $acceptTerminalTitleChange(n,t){const u=this.O(n);u&&(u.name=t)}async $acceptTerminalClosed(n,t,u){const w=this.Q(this.f,n);if(w!==null){const S=this.f.splice(w,1)[0];S.setExitStatus(t,u),this.C.fire(S.value)}}$acceptTerminalOpened(n,t,u,w){if(t){const x=this.Q(this.f,t);if(x!==null){this.f[x]._id=n,this.D.fire(this.terminals[x]),this.f[x].isOpen=!0;return}}const S={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:R.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},F=new b(this.a,n,S,u);this.f.push(F),this.D.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(n,t){this.O(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const u=this.O(n);if(!u)return{message:(0,k.localize)(0,null,n)};u.isOpen||await new Promise(S=>{const F=this.onDidOpenTerminal(async x=>{x===u.value&&(F.dispose(),S())})});const w=this.g.get(n);w?w.startSendingEvents(t):this.j[n]={initialDimensions:t}}M(n,t){const u=new P.DisposableStore;u.add(t.onProcessReady(S=>this.a.$sendProcessReady(n,S.pid,S.cwd))),u.add(t.onDidChangeProperty(S=>this.a.$sendProcessProperty(n,S))),this.s.startBuffering(n,t.onProcessData),u.add(t.onProcessExit(S=>this.N(n,S))),this.g.set(n,t);const w=this.j[n];return w&&t instanceof C&&(t.startSendingEvents(w.initialDimensions),delete this.j[n]),u}$acceptProcessAckDataEvent(n,t){this.g.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this.g.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this.O(n);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(n,t,u){try{this.g.get(n)?.resize(t,u)}catch(w){if(w.code!=="EPIPE"&&w.code!=="ERR_IPC_CHANNEL_CLOSED")throw w}}$acceptProcessShutdown(n,t){this.g.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(t=>this.a.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new E.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,t,u){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,u),this.a.$registerProfileProvider(t,n.identifier.value),new E.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,u){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,u),this.a.$registerQuickFixProvider(n,t),new E.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const u=new v.CancellationTokenSource().token;if(u.isCancellationRequested)return;const w=this.w.get(n);if(!w)return;const S=await w.provideTerminalQuickFixes(t,u);if(S!==null)return S}async $createContributedProfileTerminal(n,t){const u=new v.CancellationTokenSource().token;let w=await this.v.get(n)?.provideTerminalProfile(u);if(!u.isCancellationRequested){if(w&&!("options"in w)&&(w={options:w}),!w||!("options"in w))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in w.options){this.createExtensionTerminal(w.options,t);return}this.createTerminalFromOptions(w.options,t)}}async $provideLinks(n,t){const u=this.O(n);if(!u)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const S=new v.CancellationTokenSource;this.z.set(n,S);const F=[],x={terminal:u.value,line:t},V=[];for(const O of this.u)V.push(d.Promises.withAsyncBody(async U=>{S.token.onCancellationRequested(()=>U({provider:O,links:[]}));const $=await O.provideTerminalLinks(x,S.token)||[];S.token.isCancellationRequested||U({provider:O,links:$})}));const M=await Promise.all(V);if(S.token.isCancellationRequested)return[];const B=new Map;for(const O of M)O&&O.links.length>0&&F.push(...O.links.map(U=>{const $={id:p++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set($.id,{provider:O.provider,link:U}),$}));return this.y.set(n,B),F}$activateLink(n,t){const u=this.y.get(n)?.get(t);!u||u.provider.handleTerminalLink(u.link)}N(n,t){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const u=this.h[n];u&&(u.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,t)}O(n){return this.P(this.f,n)}P(n,t){const u=this.Q(n,t);return u!==null?n[u]:null}Q(n,t){let u=null;return n.some((w,S)=>w._id===t?(u=S,!0):!1),u}getEnvironmentVariableCollection(n){let t=this.l.get(n.identifier.value);return t||(t=new o,this.S(n.identifier.value,t)),t}R(n,t){const u=(0,T.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(n,t.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const u=t[0],w=new o(t[1]);this.S(u,w)})}$acceptDefaultProfile(n,t){const u=this.m;this.m=n,this.n=t,u?.path!==n.path&&this.J.fire(n.path)}S(n,t){this.l.set(n,t),t.onDidChangeCollection(()=>{this.R(n,t)})}};i=qe([We(1,D.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class o{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this.d(n,{value:t,type:E.EnvironmentVariableMutatorType.Replace})}append(n,t){this.d(n,{value:t,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,t){this.d(n,{value:t,type:E.EnvironmentVariableMutatorType.Prepend})}d(n,t){const u=this.map.get(n);(!u||u.value!==t.value||u.type!==t.type)&&(this.map.set(n,t),this.b.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((u,w)=>n.call(t,w,u,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let s=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,u){throw new L.NotSupportedError}createTerminalFromOptions(n,t){throw new L.NotSupportedError}};s=qe([We(0,D.IExtHostRpcService)],s),e.WorkerExtHostTerminalService=s;function c(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function r(m){return f.ThemeColor.isThemeColor(m)?m:void 0}});var Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)},_e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a};define(ye[274],De([1,0,15,19,22,21,3,63,87,6,23,9,30,5,20,137,14,7,57,93,75,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p){"use strict";var i,o;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(O,U,$){this.j=$,this.c=new D.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=O.getProxy(I.MainContext.MainThreadTesting),this.h=new x(this.f),this.g=new n(this.f),U.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const le=j,J=le.tests[le.tests.length-1].item.extId;return this.d.get(g.TestId.root(J))?.collection.tree.get(J)?.actual??(0,f.toItemFromContext)(j)}})}createTestController(O,U,$,j){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const le=new k.DisposableStore,J=le.add(new f.ExtHostTestItemCollection(U,$,this.j));J.root.label=$;const q=new Map,Q=this.f,Z={items:J.root.children,get label(){return $},set label(X){$=X,J.root.label=X,Q.$updateController(U,{label:$})},get refreshHandler(){return j},set refreshHandler(X){j=X,Q.$updateController(U,{canRefresh:!!X})},get id(){return U},createRunProfile:(X,_,ie,pe,ve,ke)=>{let Oe=(0,E.hash)(X);for(;q.has(Oe);)Oe++;return ke!==void 0&&(0,p.checkProposedApiEnabled)(O,"testContinuousRun"),new V(this.f,q,U,Oe,X,_,ie,pe,ve,ke)},createTestItem(X,_,ie){return new f.TestItemImpl(U,X,_,ie)},createTestRun:(X,_,ie=!0)=>this.g.createTestRun(U,J,X,_,ie),set resolveHandler(X){J.resolveHandler=X},get resolveHandler(){return J.resolveHandler},dispose:()=>{le.dispose()}};Q.$registerTestController(U,$,!!j),le.add((0,k.toDisposable)(()=>Q.$unregisterTestController(U)));const te={controller:Z,collection:J,profiles:q};return this.d.set(U,te),le.add((0,k.toDisposable)(()=>this.d.delete(U))),le.add(J.onDidGenerateDiff(X=>Q.$publishDiff(U,X.map(C.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.h.checkout()}async runTests(O,U=R.CancellationToken.None){const $=t(O);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get($.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(le=>g.TestId.fromExtHostTestItem(le,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:M[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:O.exclude?.map(le=>le.id)},U)}$syncTests(){for(const{collection:O}of this.d.values())O.flushDiff();return Promise.resolve()}$provideFileCoverage(O,U,$){return(0,a.mapFind)(this.g.trackers,le=>le.id===O?le.getCoverage(U):void 0)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(O,U,$,j){return(0,a.mapFind)(this.g.trackers,J=>J.id===O?J.getCoverage(U):void 0)?.resolveFileCoverage($,j)??Promise.resolve([])}$configureRunProfile(O,U){this.d.get(O)?.profiles.get(U)?.configureHandler?.()}async $refreshTests(O,U){await this.d.get(O)?.controller.refreshHandler?.(U)}$publishTestResults(O){this.results=Object.freeze(O.map(U=>(0,L.deepFreeze)(h.TestResults.to(U))).concat(this.results).sort((U,$)=>$.completedAt-U.completedAt).slice(0,32)),this.c.fire()}async $expandTest(O,U){const $=this.d.get(g.TestId.fromString(O).controllerId)?.collection;$&&(await $.expand(O,U<0?1/0:U),$.flushDiff())}$acceptDiff(O){this.h.applyDiff(O.map(C.TestsDiffOp.deserialize))}async $runControllerTests(O,U){return Promise.all(O.map($=>this.k($,!1,U)))}async $startContinuousRun(O,U){const $=new R.CancellationTokenSource(U),j=await Promise.all(O.map(le=>this.k(le,!0,$.token)));return!U.isCancellationRequested&&!j.some(le=>le.error)&&await new Promise(le=>U.onCancellationRequested(le)),$.dispose(!0),j}async k(O,U,$){const j=this.d.get(O.controllerId);if(!j)return{};const{collection:le,profiles:J}=j,q=J.get(O.profileId);if(!q)return{};const Q=O.testIds.map(_=>le.tree.get(_)).filter(T.isDefined),Z=O.excludeExtIds.map(_=>j.collection.tree.get(_)).filter(T.isDefined).filter(_=>Q.some(ie=>ie.fullId.compare(_.fullId)===2));if(!Q.length)return{};const te=new d.TestRunRequest2(Q.some(_=>_.actual instanceof f.TestItemRootImpl)?void 0:Q.map(_=>_.actual),Z.map(_=>_.actual),q,U),X=(0,C.isStartControllerTests)(O)&&this.g.prepareForMainThreadTestRun(te,u.fromInternal(O,j.collection),$);try{return await q.runHandler(te,$),{}}catch(_){return{error:String(_)}}finally{X&&(X.hasRunningTasks&&!$.isCancellationRequested&&await D.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.g.cancelAllRuns():this.g.cancelRunById(O)}};s=qe([We(0,y.IExtHostRpcService)],s),e.ExtHostTesting=s;const c=1e4;var r;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(r||(r={}));class m extends k.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(O,U,$){super(),this.k=O,this.l=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new D.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource($));const j=this.B(new A.RunOnceScheduler(()=>this.m(),c));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(O){return this.f.get(O)?.coverage}createRun(O){const U=this.k.id,$=this.k.controllerId,j=(0,v.generateUuid)(),le=new w(this.l,U,j),J=te=>(X,..._)=>{if(Q){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),te(X,..._))},q=(te,X)=>{const _=X instanceof Array?X.map(h.TestMessage.from):[h.TestMessage.from(X)];if(te.uri&&te.range){const ie={range:h.Range.from(te.range),uri:te.uri};for(const pe of _)pe.location=pe.location||ie}this.l.$appendTestMessagesInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),_)};let Q=!1;const Z={isPersisted:this.k.isPersisted,token:this.h.token,name:O,get coverageProvider(){return le.coverageProvider},set coverageProvider(te){le.coverageProvider=te},enqueued:J(te=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),1)}),skipped:J(te=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),5)}),started:J(te=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),2)}),errored:J((te,X,_)=>{q(te,X),this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),6,_)}),failed:J((te,X,_)=>{q(te,X),this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,$).toString(),4,_)}),passed:J((te,X)=>{this.l.$updateTestStateInRun(U,j,g.TestId.fromExtHostTestItem(te,this.k.controllerId).toString(),3,X)}),appendOutput:(te,X,_)=>{Q||(_&&(this.k.isIncluded(_)?this.s(_):_=void 0),this.l.$appendOutputToRun(U,j,l.VSBuffer.fromString(te),X&&h.location.from(X),_&&g.TestId.fromExtHostTestItem(_,$).toString()))},end:()=>{Q||(Q=!0,this.l.$finishedTestRunTask(U,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:Z,coverage:le}),this.l.$startedTestRunTask(U,{id:j,name:O,running:!0}),Z}m(){for(const{run:O}of this.f.values())O.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(O){if(!(O instanceof f.TestItemImpl))throw new b.InvalidTestItemError(O.id);if(this.g.has(g.TestId.fromExtHostTestItem(O,this.k.controllerId).toString()))return;const U=[],$=this.k.colllection.root;for(;;){const j=h.TestItem.from(O);if(U.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),O===$))break;O=O.parent||$}this.l.$addTestsToRun(this.k.controllerId,this.k.id,U)}}class n{get trackers(){return this.c.values()}constructor(O){this.d=O,this.c=new Map}prepareForMainThreadTestRun(O,U,$){return this.f(O,U,$)}cancelRunById(O){for(const U of this.c.values())if(U.id===O){U.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,U,$,j,le){const J=this.c.get($);if(J)return J.createRun(j);const q=u.fromPublic(O,U,$,le),Q=t($);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!$.continuous,profile:Q&&{group:M[Q.kind],id:Q.profileId},exclude:$.exclude?.map(te=>g.TestId.fromExtHostTestItem(te,U.root.id).toString())??[],id:q.id,include:$.include?.map(te=>g.TestId.fromExtHostTestItem(te,U.root.id).toString())??[U.root.id],persist:le});const Z=this.f($,q);return Z.onEnd(()=>{this.d.$finishedExtensionTestRun(q.id),Z.dispose()}),Z.createRun(j)}f(O,U,$){const j=new m(U,this.d,$);return this.c.set(O,j),j.onEnd(()=>this.c.delete(O)),j}}e.TestRunCoordinator=n;const t=B=>{if(!!B.profile){if(!(B.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class u{static fromPublic(O,U,$,j){return new u(O,(0,v.generateUuid)(),$.include?.map(le=>g.TestId.fromExtHostTestItem(le,O).toString())??[O],$.exclude?.map(le=>g.TestId.fromExtHostTestItem(le,O).toString())??[],j,U)}static fromInternal(O,U){return new u(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,U)}constructor(O,U,$,j,le,J){this.controllerId=O,this.id=U,this.isPersisted=le,this.colllection=J,this.c=$.map(q=>q+"\0"),this.d=j.map(q=>q+"\0")}isIncluded(O){const U=g.TestId.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const $ of this.d)if(U===$||U.startsWith($))return!1;for(const $ of this.c)if(U===$||U.startsWith($))return!0;return!1}}e.TestRunDto=u;class w{set coverageProvider(O){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!O||(this.c=O,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(O,U,$){this.f=O,this.g=U,this.h=$}async provideFileCoverage(O){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(O))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(U){throw this.d=void 0,U}}async resolveFileCoverage(O,U){const $=await this.d;let j=$?.[O];return!this.c||!$||!j?[]:(j.detailedCoverage||(j=$[O]=await this.c.resolveFileCoverage?.(j,U)??j),j.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,h.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const U=g.TestId.parentId(O.item.extId);if(U&&this.g.has(U.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:U,f:$}=this;return{get added(){return[...O].map(j=>j.revived)},get updated(){return[...U].map(j=>j.revived)},get removed(){return[...$].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class F extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new D.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,U){return{...O,revived:h.TestItem.toPlain(O.item),depth:U?U.depth+1:0,children:new Set}}o(){return new S(this.q)}}class x{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(U=>U.revived)},dispose:(0,P.once)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new F;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class V{get label(){return this.d}set label(O){O!==this.d&&(this.d=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?h.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,Be(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}constructor(O,U,$,j,le,J,q,Q=!1,Z=void 0,te=!1){this.controllerId=$,this.profileId=j,this.d=le,this.kind=J,this.runHandler=q,this.f=Q,this._tag=Z,this.g=te,i.set(this,void 0),o.set(this,void 0),_e(this,i,O,"f"),_e(this,o,U,"f"),U.set(j,this);const X=M[J];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);Be(this,i,"f").$publishTestRunProfile({profileId:j,controllerId:$,tag:Z?h.TestTag.namespace(this.controllerId,Z.id):null,label:le,group:X,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){Be(this,o,"f")?.delete(this.profileId)&&(_e(this,o,void 0,"f"),Be(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,i=new WeakMap,o=new WeakMap;const M={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(ye[275],De([1,0,15,3,5,138,14,7]),function(ne,e,a,A,l,R,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(L,T){this.i=T,this.a=new A.Emitter,this.b=new A.Emitter,this.c=new A.Emitter,this.d=new A.Emitter,this.f=new A.Emitter,this.g=new A.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(l.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const T=this.i.allEditors();return L?T:T.map(v=>v.value)}async showTextDocument(L,T,v){let I;typeof T=="number"?I={position:D.ViewColumn.from(T),preserveFocus:v}:typeof T=="object"?I={position:D.ViewColumn.from(T.viewColumn),preserveFocus:T.preserveFocus,selection:typeof T.selection=="object"?D.Range.from(T.selection):void 0,pinned:typeof T.preview=="boolean"?!T.preview:void 0}:I={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(L.uri,I),f=y&&this.i.getEditor(y);if(f)return f.value;throw y?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,T){return new R.TextEditorDecorationType(this.h,L,T).value}$acceptEditorPropertiesChanged(L,T){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(T.options&&v._acceptOptions(T.options),T.selections){const I=T.selections.selections.map(D.Selection.to);v._acceptSelections(I)}if(T.visibleRanges){const I=a.coalesce(T.visibleRanges.map(D.Range.to));v._acceptVisibleRanges(I)}if(T.options&&this.b.fire({textEditor:v.value,options:{...T.options,lineNumbers:D.TextEditorLineNumbersStyle.to(T.options.lineNumbers)}}),T.selections){const I=P.TextEditorSelectionChangeKind.fromValue(T.selections.source),y=T.selections.selections.map(D.Selection.to);this.a.fire({textEditor:v.value,selections:y,kind:I})}if(T.visibleRanges){const I=a.coalesce(T.visibleRanges.map(D.Range.to));this.c.fire({textEditor:v.value,visibleRanges:I})}}$acceptEditorPositionData(L){for(const T in L){const v=this.i.getEditor(T);if(!v)throw new Error("Unknown text editor");const I=D.ViewColumn.to(L[T]);v.value.viewColumn!==I&&(v._acceptViewColumn(I),this.d.fire({textEditor:v.value,viewColumn:I}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=E}),define(ye[276],De([1,0,2,4,5,6,7,14,26,9]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,A.createDecorator)("IExtHostTimeline");class L{constructor(I,y){this.b=new Map,this.c=new Map,this.a=I.getProxy(l.MainContext.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(f,h)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&E.ExtensionIdentifier.equals(h,this.b.get(f.source)?.extension)){const d=f.uri===void 0?void 0:a.URI.revive(f.uri);return this.c.get(f.source)?.get(T(d))?.get(f.handle)}else return;return f}})}async $getTimeline(I,y,f,h){return this.b.get(I)?.provider.provideTimeline(a.URI.revive(y),f,h)}registerTimelineProvider(I,y,f,h){const d=new R.DisposableStore,g=this.d(y.id,h,d).bind(this);let b;y.onDidChange&&(b=y.onDidChange(p=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:y.id}),this));const C=this.c;return this.f({...y,scheme:I,onDidChange:void 0,async provideTimeline(p,i,o){i?.resetCache&&(d.clear(),C.get(y.id)?.clear());const s=await y.provideTimeline(p,i,o);if(s==null)return;const c=g(p,i);return{...s,source:y.id,items:s.items.map(c)}},dispose(){for(const p of C.values())p.get(y.id)?.clear();b?.dispose(),d.dispose()}},f)}d(I,y,f){return(h,d)=>{let g;if(d?.cacheResults){let b=this.c.get(I);b===void 0&&(b=new Map,this.c.set(I,b));const C=T(h);g=b.get(C),g===void 0&&(g=new Map,b.set(C,g))}return b=>{const{iconPath:C,...p}=b,i=`${I}|${b.id??b.timestamp}`;g?.set(i,b);let o,s,c;b.iconPath&&(C instanceof D.ThemeIcon?c={id:C.id,color:C.color}:a.URI.isUri(C)?(o=C,s=C):{light:o,dark:s}=C);let r;return D.MarkdownString.isMarkdownString(p.tooltip)?r=P.MarkdownString.from(p.tooltip):(0,k.isString)(p.tooltip)?r=p.tooltip:D.MarkdownString.isMarkdownString(p.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=P.MarkdownString.from(p.detail)):(0,k.isString)(p.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=p.detail),{...p,id:p.id??void 0,handle:i,source:I,command:b.command?y.toInternal(b.command,f):void 0,icon:o,iconDark:s,themeIcon:c,tooltip:r,accessibilityInformation:b.accessibilityInformation}}}}f(I,y){if(this.b.get(I.id))throw new Error(`Timeline Provider ${I.id} already exists.`);return this.a.$registerTimelineProvider({id:I.id,label:I.label,scheme:I.scheme}),this.b.set(I.id,{provider:I,extension:y}),(0,R.toDisposable)(()=>{for(const h of this.c.values())h.get(I.id)?.clear();this.b.delete(I.id),this.a.$unregisterTimelineProvider(I.id),I.dispose()})}}e.ExtHostTimeline=L;function T(v){return v?.toString()}}),define(ye[277],De([1,0,6,16,2,5]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(E){this.c=new Map,this.b=E.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,L,T){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const v=T.schemes.find(I=>!D.a.has(I));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(k,L),this.b.$registerUriOpener(k,T.schemes,E,T.label),(0,a.toDisposable)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(E,k,L){const T=this.c.get(E);if(!T)throw new Error(`Unknown opener with id: ${E}`);const v=l.URI.revive(k);return T.canOpenExternalUri(v,L)}async $openUri(E,k,L){const T=this.c.get(E);if(!T)throw new Error(`Unknown opener id: '${E}'`);return T.openExternalUri(l.URI.revive(k.resolvedUri),{sourceUri:l.URI.revive(k.sourceUri)},L)}}D.a=new Set([A.Schemas.http,A.Schemas.https]),e.ExtHostUriOpeners=D}),define(ye[278],De([1,0,5,2,6,11,26]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(k){this.c=new Set,this.d=new Map,this.b=k.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(k,L){if(this.c.has(D.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const T=P.a++;return this.c.add(D.ExtensionIdentifier.toKey(k)),this.d.set(T,L),this.b.$registerUriHandler(T,k),(0,l.toDisposable)(()=>{this.c.delete(D.ExtensionIdentifier.toKey(k)),this.d.delete(T),this.b.$unregisterUriHandler(T)})}$handleExternalUri(k,L){const T=this.d.get(k);if(!T)return Promise.resolve(void 0);try{T.handleUri(A.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(k){return A.URI.revive(await this.b.$createAppUri(k))}}P.a=0,e.ExtHostUrls=P});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[79],De([1,0,3,16,23,2,198,223,94,5]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";var L,T,v,I,y,f,h,d,g,b,C,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(S,F,x,V,M,B,O){L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,""),d.set(this,void 0),g.set(this,!1),b.set(this,!1),C.set(this,void 0),p.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new a.Emitter),this._onDidDispose=Be(this,i,"f").event,_e(this,L,S,"f"),_e(this,T,F,"f"),_e(this,d,x,"f"),_e(this,I,V,"f"),_e(this,y,M,"f"),_e(this,f,B,"f"),_e(this,C,s(B),"f"),_e(this,p,c(B),"f"),_e(this,v,O,"f")}dispose(){_e(this,g,!0,"f"),Be(this,i,"f").fire(),Be(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(S){return _e(this,b,!0,"f"),(0,E.asWebviewUri)(S,Be(this,I,"f"))}get cspSource(){const S=Be(this,f,"f").extensionLocation;if(S.scheme===A.Schemas.https||S.scheme===A.Schemas.http){let F=S.toString();return F.endsWith("/")||(F+="/"),F+" "+E.webviewGenericCspSource}return E.webviewGenericCspSource}get html(){return this.a(),Be(this,h,"f")}set html(S){this.a(),Be(this,h,"f")!==S&&(_e(this,h,S,"f"),Be(this,p,"f")&&!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(S)&&(_e(this,b,!0,"f"),Be(this,v,"f").report("Webview vscode-resource: uris",Be(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,T,"f").$setHtml(Be(this,L,"f"),this.b(S)))}get options(){return this.a(),Be(this,d,"f")}set options(S){this.a(),l.equals(Be(this,d,"f"),S)||Be(this,T,"f").$setOptions(Be(this,L,"f"),n(Be(this,f,"f"),Be(this,y,"f"),S)),_e(this,d,S,"f")}async postMessage(S){if(Be(this,g,"f"))return!1;const F=(0,P.serializeWebviewMessage)(S,{serializeBuffersForPostMessage:Be(this,C,"f")});return Be(this,T,"f").$postMessage(Be(this,L,"f"),F.message,...F.buffers)}a(){if(Be(this,g,"f"))throw new Error("Webview is disposed")}b(S){if(!Be(this,p,"f"))return S;const F=Be(this,f,"f").extensionLocation?.scheme===A.Schemas.vscodeRemote,x=Be(this,f,"f").extensionLocation.scheme===A.Schemas.vscodeRemote?Be(this,f,"f").extensionLocation.authority:void 0;return S.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,B,O,U,$)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),le=(0,E.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${le}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,M,B,O,U,$)=>{const j=R.URI.from({scheme:O||"file",path:decodeURIComponent(U)}),le=(0,E.asWebviewUri)(j,{isRemote:F,authority:x}).toString();return`${M}${le}${$}`})}}e.ExtHostWebview=o,L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,b=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap;function s(w){try{const S=(0,D.normalizeVersion)((0,D.parseVersion)(w.engines.vscode));return!!S&&S.majorBase>=1&&S.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;function c(w){try{const S=(0,D.normalizeVersion)((0,D.parseVersion)(w.engines.vscode));return S?S.majorBase<1||S.majorBase===1&&S.minorBase<60:!1}catch{return!1}}class r{constructor(S,F,x,V,M){this.c=F,this.d=x,this.e=V,this.f=M,this.b=new Map,this.a=S.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(S,F,x){const V=this.g(S);if(V){const{message:M}=(0,P.deserializeWebviewMessage)(F,x.value);V._onMessageEmitter.fire(M)}}$onMissingCsp(S,F){this.e.warn(`${F} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(S,F,x){const V=new o(S,this.a,t(F),this.c,this.d,x,this.f);return this.b.set(S,V),V._onDidDispose(()=>{this.b.delete(S)}),V}deleteWebview(S){this.b.delete(S)}g(S){return this.b.get(S)}}e.ExtHostWebviews=r;function m(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=m;function n(w,S,F){return{enableCommandUris:F.enableCommandUris,enableScripts:F.enableScripts,enableForms:F.enableForms,portMapping:F.portMapping,localResourceRoots:F.localResourceRoots||u(w,S)}}e.serializeWebviewOptions=n;function t(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(S=>R.URI.from(S))}}function u(w,S){return[...(S?.getWorkspaceFolders()||[]).map(F=>F.uri),w.extensionLocation]}}),define(ye[279],De([1,0,21,87,6,16,24,2,14,79,74,5,7]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(o,s){this.document=o,this.b=s,this.a=1,this.c=new L.Cache("custom documents")}addEdit(o){return this.c.add([o])}async undo(o,s){await this.f(o).undo(),s||this.disposeBackup()}async redo(o,s){await this.f(o).redo(),s||this.disposeBackup()}disposeEdits(o){for(const s of o)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const o=p(this.document.uri)+this.a++;return(0,D.joinPath)(this.b,o)}updateBackup(o){this.d?.delete(),this.d=o}disposeBackup(){this.d?.delete(),this.d=void 0}f(o){const s=this.c.get(o,0);if(!s)throw new Error("No edit found");return s}}class y{constructor(){this.a=new Map}get(o,s){return this.a.get(this.b(o,s))}add(o,s,c){const r=this.b(o,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${o} resource:${s.uri}`);const m=new I(s,c);return this.a.set(r,m),m}delete(o,s){const c=this.b(o,s.uri);this.a.delete(c)}b(o,s){return`${o}@@@${s}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class h{constructor(){this.a=new Map}addTextProvider(o,s,c){return this.b(0,o,s,c)}addCustomProvider(o,s,c){return this.b(1,o,s,c)}get(o){return this.a.get(o)}b(o,s,c,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:o,extension:c,provider:r}),new v.Disposable(()=>this.a.delete(s))}}class d{constructor(o,s,c,r,m){this.d=s,this.f=c,this.g=r,this.h=m,this.b=new h,this.c=new y,this.a=o.getProxy(T.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(o,s,c,r){const m=new l.DisposableStore;return b(c)?(m.add(this.b.addTextProvider(s,o,c)),this.a.$registerTextEditorProvider((0,k.toExtensionData)(o),s,r.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(o))):(m.add(this.b.addCustomProvider(s,o,c)),g(c)&&m.add(c.onDidChangeCustomDocument(n=>{const t=this.i(s,n.document.uri);if(C(n)){const u=t.addEdit(n);this.a.$onDidEdit(n.document.uri,s,u,n.label)}else this.a.$onContentChange(n.document.uri,s)})),this.a.$registerCustomEditorProvider((0,k.toExtensionData)(o),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(o))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(o,s,c,r,m){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${s}'`);const t=P.URI.revive(o),u=await n.provider.openCustomDocument(t,{backupId:c,untitledDocumentData:r?.buffer},m);let w;return g(n.provider)&&this.f&&(w=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(s,u,w),{editable:g(n.provider)}}async $disposeCustomDocument(o,s){const c=this.b.get(s);if(!c)throw new Error(`No provider found for '${s}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=P.URI.revive(o),{document:m}=this.i(s,r);this.c.delete(s,m),m.dispose()}async $resolveCustomEditor(o,s,c,r,m,n){const t=this.b.get(c);if(!t)throw new Error(`No provider found for '${c}'`);const u=E.ViewColumn.to(m),w=this.g.createNewWebview(s,r.contentOptions,t.extension),S=this.h.createNewWebviewPanel(s,c,r.title,u,r.options,w,!0),F=P.URI.revive(o);switch(t.type){case 1:{const{document:x}=this.i(c,F);return t.provider.resolveCustomEditor(x,S,n)}case 0:{const x=this.d.getDocument(F);return t.provider.resolveCustomTextEditor(x,S,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(o,s,c){this.i(s,o).disposeEdits(c)}async $onMoveCustomEditor(o,s,c){const r=this.b.get(c);if(!r)throw new Error(`No provider found for '${c}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const m=this.h.getWebviewPanel(o);if(!m)throw new Error("No webview found");const n=P.URI.revive(s),t=this.d.getDocument(n);await r.provider.moveCustomTextEditor(t,m,a.CancellationToken.None)}async $undo(o,s,c,r){return this.i(s,o).undo(c,r)}async $redo(o,s,c,r){return this.i(s,o).redo(c,r)}async $revert(o,s,c){const r=this.i(s,o);await this.j(s).revertCustomDocument(r.document,c),r.disposeBackup()}async $onSave(o,s,c){const r=this.i(s,o);await this.j(s).saveCustomDocument(r.document,c),r.disposeBackup()}async $onSaveAs(o,s,c,r){const m=this.i(s,o);return this.j(s).saveCustomDocumentAs(m.document,P.URI.revive(c),r)}async $backup(o,s,c){const r=this.i(s,o),n=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},c);return r.updateBackup(n),n.id}i(o,s){const c=this.c.get(o,P.URI.revive(s));if(!c)throw new Error("No custom document found");return c}j(o){const c=this.b.get(o)?.provider;if(!c||!g(c))throw new Error("Custom document is not editable");return c}}e.ExtHostCustomEditors=d;function g(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function C(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function p(i){const o=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,A.hash)(o)+""}});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[280],De([1,0,3,6,2,30,14,79,5,7]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";var L,T,v,I,y,f,h,d,g,b,C,p,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class o extends A.Disposable{constructor(m,n,t,u){super(),L.set(this,void 0),T.set(this,void 0),v.set(this,void 0),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),g.set(this,!0),b.set(this,void 0),C.set(this,!1),p.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,p,"f").event,i.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Be(this,i,"f").event,_e(this,L,m,"f"),_e(this,T,n,"f"),_e(this,I,t,"f"),_e(this,v,u.viewType,"f"),_e(this,y,u.panelOptions,"f"),_e(this,d,u.viewColumn,"f"),_e(this,f,u.title,"f"),_e(this,b,u.active,"f")}dispose(){Be(this,C,"f")||(_e(this,C,!0,"f"),Be(this,p,"f").fire(),Be(this,T,"f").$disposeWebview(Be(this,L,"f")),Be(this,I,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,I,"f")}get viewType(){return this.c(),Be(this,v,"f")}get title(){return this.c(),Be(this,f,"f")}set title(m){this.c(),Be(this,f,"f")!==m&&(_e(this,f,m,"f"),Be(this,T,"f").$setTitle(Be(this,L,"f"),m))}get iconPath(){return this.c(),Be(this,h,"f")}set iconPath(m){this.c(),Be(this,h,"f")!==m&&(_e(this,h,m,"f"),Be(this,T,"f").$setIconPath(Be(this,L,"f"),l.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Be(this,y,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,d,"f")=="number"&&Be(this,d,"f")<0))return Be(this,d,"f")}get active(){return this.c(),Be(this,b,"f")}get visible(){return this.c(),Be(this,g,"f")}_updateViewState(m){Be(this,C,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(_e(this,b,m.active,"f"),_e(this,g,m.visible,"f"),_e(this,d,m.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(m,n){this.c(),Be(this,T,"f").$reveal(Be(this,L,"f"),{viewColumn:typeof m>"u"?void 0:D.ViewColumn.from(m),preserveFocus:!!n})}c(){if(Be(this,C,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap,b=new WeakMap,C=new WeakMap,p=new WeakMap,i=new WeakMap;class s{static c(){return(0,R.generateUuid)()}constructor(m,n,t){this.g=n,this.h=t,this.e=new Map,this.f=new Map,this.d=m.getProxy(E.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,n,t,u,w={}){const S=typeof u=="object"?u.viewColumn:u,F={viewColumn:D.ViewColumn.from(S),preserveFocus:typeof u=="object"&&!!u.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(m),V=s.c();this.d.$createWebviewPanel((0,P.toExtensionData)(m),V,n,{title:t,panelOptions:c(w),webviewOptions:(0,P.serializeWebviewOptions)(m,this.h,w),serializeBuffersForPostMessage:x},F);const M=this.g.createNewWebview(V,w,m);return this.createNewWebviewPanel(V,n,t,S,w,M,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((t,u)=>{const w=m[t],S=m[u];return w.active?1:S.active?-1:+w.visible-+S.visible});for(const t of n){const u=this.getWebviewPanel(t);if(!u)continue;const w=m[t];u._updateViewState({active:w.active,visible:w.visible,viewColumn:D.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,n,t){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:t,extension:m}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(m)}),new k.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,t,u){const w=this.f.get(n);if(!w)throw new Error(`No serializer found for '${n}'`);const{serializer:S,extension:F}=w,x=this.g.createNewWebview(m,t.webviewOptions,F),V=this.createNewWebviewPanel(m,n,t.title,u,t.panelOptions,x,t.active);await S.deserializeWebviewPanel(V,t.state)}createNewWebviewPanel(m,n,t,u,w,S,F){const x=new o(m,this.d,S,{viewType:n,title:t,viewColumn:u,panelOptions:w,active:F});return this.e.set(m,x),x}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=s;function c(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[281],De([1,0,3,6,79,14,5,7]),function(ne,e,a,A,l,R,D,P){"use strict";var E,k,L,T,v,I,y,f,h,d,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends A.Disposable{constructor(i,o,s,c,r,m){super(),E.set(this,void 0),k.set(this,void 0),L.set(this,void 0),T.set(this,void 0),v.set(this,!1),I.set(this,void 0),y.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Be(this,d,"f").event,g.set(this,this.B(new a.Emitter)),this.onDidDispose=Be(this,g,"f").event,_e(this,L,s,"f"),_e(this,y,c,"f"),_e(this,E,i,"f"),_e(this,k,o,"f"),_e(this,T,r,"f"),_e(this,I,m,"f")}dispose(){Be(this,v,"f")||(_e(this,v,!0,"f"),Be(this,g,"f").fire(),Be(this,T,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,y,"f")}set title(i){this.a(),Be(this,y,"f")!==i&&(_e(this,y,i,"f"),Be(this,k,"f").$setWebviewViewTitle(Be(this,E,"f"),i))}get description(){return this.a(),Be(this,f,"f")}set description(i){this.a(),Be(this,f,"f")!==i&&(_e(this,f,i,"f"),Be(this,k,"f").$setWebviewViewDescription(Be(this,E,"f"),i))}get visible(){return Be(this,I,"f")}get webview(){return Be(this,T,"f")}get viewType(){return Be(this,L,"f")}_setVisible(i){i===Be(this,I,"f")||Be(this,v,"f")||(_e(this,I,i,"f"),Be(this,d,"f").fire())}get badge(){return this.a(),Be(this,h,"f")}set badge(i){this.a(),!(i?.value===Be(this,h,"f")?.value&&i?.tooltip===Be(this,h,"f")?.tooltip)&&(_e(this,h,R.ViewBadge.from(i),"f"),Be(this,k,"f").$setWebviewViewBadge(Be(this,E,"f"),i))}show(i){this.a(),Be(this,k,"f").$show(Be(this,E,"f"),!!i)}a(){if(Be(this,v,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,k=new WeakMap,L=new WeakMap,T=new WeakMap,v=new WeakMap,I=new WeakMap,y=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,g=new WeakMap;class C{constructor(i,o){this.d=o,this.b=new Map,this.c=new Map,this.a=i.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,o,s,c){if(this.b.has(o))throw new Error(`View provider for '${o}' already registered`);return this.b.set(o,{provider:s,extension:i}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(i),o,{retainContextWhenHidden:c?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(i)}),new P.Disposable(()=>{this.b.delete(o),this.a.$unregisterWebviewViewProvider(o)})}async $resolveWebviewView(i,o,s,c,r){const m=this.b.get(o);if(!m)throw new Error(`No view provider found for '${o}'`);const{provider:n,extension:t}=m,u=this.d.createNewWebview(i,{},t),w=new b(i,this.a,o,s,u,!0);this.c.set(i,w),await n.resolveWebviewView(w,{state:c},r)}async $onDidChangeWebviewViewVisibility(i,o){this.e(i)._setVisible(o)}async $disposeWebviewView(i){const o=this.e(i);this.c.delete(i),o.dispose(),this.d.deleteWebview(i)}e(i){const o=this.c.get(i);if(!o)throw new Error("No webview found");return o}}e.ExtHostWebviewViews=C}),define(ye[141],De([1,0,3,5,2,16,8,4,20]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class an{get state(){return this.d}constructor(T){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=T.getProxy(A.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(T){T!==this.d.focused&&(this.d={...this.d,focused:T},this.c.fire(this.d))}openUri(T,v){let I;if(typeof T=="string"){I=T;try{T=l.URI.parse(T)}catch{return Promise.reject(`Invalid uri - '${T}'`)}}return(0,D.isFalsyOrWhitespace)(T.scheme)?Promise.reject("Invalid scheme - cannot be empty"):T.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${T.scheme}'`):this.b.$openUri(T,I,v)}async asExternalUri(T,v){if((0,D.isFalsyOrWhitespace)(T.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this.b.$asExternalUri(T,v);return l.URI.from(I)}};k.a={focused:!0},k=qe([We(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[282],De([1,0,119,283,70,40,2,13,47]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class k{constructor(v,I,y){this.b=v,this.c=I,this.f=y,this.a=A.createServer((f,h)=>this.h(f,h)),this.g().catch(f=>(I.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,I){const y=(h,d)=>{I.writeHead(h,{"content-type":"application/json"}),I.end(JSON.stringify(d||null),g=>g&&this.c.error(g))},f=[];v.setEncoding("utf8"),v.on("data",h=>f.push(h)),v.on("end",async()=>{try{const h=JSON.parse(f.join(""));let d;switch(h.type){case"open":d=await this.i(h);break;case"openExternal":d=await this.j(h);break;case"status":d=await this.l(h);break;case"extensionManagement":d=await this.k(h);break;default:y(404,`Unknown message type: ${h.type}`);break}y(200,d)}catch(h){const d=h instanceof Error?h.message:JSON.stringify(h);y(500,d),this.c.error("Error while processing pipe request",h)}})}async i(v){const{fileURIs:I,folderURIs:y,forceNewWindow:f,diffMode:h,mergeMode:d,addMode:g,forceReuseWindow:b,gotoLineMode:C,waitMarkerFilePath:p,remoteAuthority:i}=v,o=[];if(Array.isArray(y))for(const m of y)try{o.push({folderUri:D.URI.parse(m)})}catch{}if(Array.isArray(I))for(const m of I)try{(0,E.hasWorkspaceFileExtension)(m)?o.push({workspaceUri:D.URI.parse(m)}):o.push({fileUri:D.URI.parse(m)})}catch{}const s=p?D.URI.file(p):void 0,r={forceNewWindow:f,diffMode:h,mergeMode:d,addMode:g,gotoLineMode:C,forceReuseWindow:b,preferNewWindow:!b&&!s&&!g,waitMarkerFileURI:s,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",o,r),""}async j(v){for(const I of v.uris){const y=D.URI.parse(I),f=y.scheme==="file"?y:I;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const I=f=>f?.map(h=>/\.vsix$/i.test(h)?D.URI.parse(h):h),y={list:v.list,install:I(v.install),uninstall:I(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=k;let L=class extends k{constructor(v,I){super(v,I,(0,a.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,P.ILogService)],L),e.CLIServer=L}),define(ye[284],De([1,0,254,25,20]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let D=class extends a.AbstractExtHostConsoleForwarder{constructor(E,k){super(E,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,k,L){const T=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,T.write(`
START_NATIVE_LOG
`),k.apply(console,L),T.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,k){const L=process[E],T=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(I,y,f)=>{if(!this.g){v+=I.toString(y);const h=v.length>R?v.length:v.lastIndexOf(`
`);h!==-1&&(console[k](v.slice(0,h)),v=v.slice(h+1))}T.call(L,I,y,f)}})}};D=qe([We(0,l.IExtHostRpcService),We(1,A.IExtHostInitDataService)],D),e.ExtHostConsoleForwarder=D}),define(ye[285],De([1,0,10,88,30,40,6,5,2,20]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends D.Disposable{constructor(v,I){super();const y=v.getProxy(P.MainContext.MainThreadDownloadService);I.registerCommand(!1,"_workbench.downloadResource",async f=>{const h=E.URI.file((0,a.join)((0,A.tmpdir)(),(0,l.generateUuid)()));return await y.$download(f,h),h})}};L=qe([We(0,k.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[286],De([1,0,140,16,205,30]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class D extends a.ExtHostLoggerService{k(E,k,L){return E.scheme===A.Schemas.file?new l.SpdLogLogger(L?.name||(0,R.generateUuid)(),E.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,k):super.k(E,k,L)}registerLogger(E){super.registerLogger(E),this.l.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.l.$deregisterLogger(E)}}e.ExtHostLoggerService=D}),define(ye[287],De([1,0,70,10,2,78,6,16,19,29]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const o=await super.g(i);if(o.scheme!==P.Schemas.file)return o;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${o.fsPath}.`),o;const s=o.fsPath;let c=0;do{let r;c===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${c}`:`${s}-${c}`,await T(r);const m=A.join(r,"vscode.lock"),n=await f(this.d,m,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),l.URI.file(r);c++}while(c<10);return o}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function T(p){try{await k.Promises.stat(p);return}catch{}try{await k.Promises.mkdir(p,{recursive:!0})}catch{}}const v=1e3,I=10*60*1e3;class y extends D.Disposable{constructor(i,o){super(),this.b=i,this.c=o,this.a=this.B(new E.IntervalTimer),this.a.cancelAndSet(async()=>{const s=await h(i,o);(!s||s.pid!==process.pid)&&(i.info(`Lock '${o}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(o,new Date,new Date)}catch(c){i.error(c),i.info(`Lock '${o}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const o={pid:process.pid,willReleaseAt:Date.now()+i};await k.Promises.writeFile(this.c,JSON.stringify(o),{flag:"w"})}catch(o){this.b.error(o)}}}async function f(p,i,o){try{const c={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(i,JSON.stringify(c),{flag:"wx"})}catch(c){p.error(c)}const s=await h(p,i);return!s||s.pid!==process.pid?o?(p.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(p,i)):(p.info(`Lock '${i}': Lock acquired.`),new y(p,i))}async function h(p,i){let o;try{o=await k.Promises.readFile(i)}catch(s){return p.error(s),null}try{return JSON.parse(String(o))}catch(s){return p.error(s),null}}async function d(p,i){let o;try{o=await k.Promises.stat(i)}catch(s){return p.error(s),0}return o.mtime.getTime()}function g(p){try{return process.kill(p,0),!0}catch{return!1}}async function b(p,i){const o=await h(p,i);if(!o)return p.info(`Lock '${i}': Could not read pid of lock holder.`),C(p,i);if(o.willReleaseAt){let n=o.willReleaseAt-Date.now();if(n<5e3){for(n>0?p.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):p.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,E.timeout)(Math.min(100,n)),await d(p,i)===0)return C(p,i);n=o.willReleaseAt-Date.now()}return C(p,i)}}if(!g(o.pid))return p.info(`Lock '${i}': The pid ${o.pid} appears to be gone.`),C(p,i);const s=await d(p,i),c=Date.now()-s;if(c<=I)return p.info(`Lock '${i}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;p.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const r=await d(p,i),m=Date.now()-r;return m<=I?(p.info(`Lock '${i}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(p.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),C(p,i))}async function C(p,i){p.info(`Lock '${i}': Deleting a stale lock.`);try{await k.Promises.unlink(i)}catch{}return f(p,i,!0)}}),define(ye[288],De([1,0,30,20,41]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,E,k){return this.createTerminalFromOptions({name:P,shellPath:E,shellArgs:k})}createTerminalFromOptions(P,E){const k=new l.ExtHostTerminal(this.a,(0,a.generateUuid)(),P,P.name);return this.f.push(k),k.create(P,this.L(P,E)),k.value}};R=qe([We(0,A.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[289],De([1,0,5,20,186,6,25,2,46,24,29,7,12,55,3,129,102,13]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class g extends f.DisposableTunnel{}function b(n){const t=n.trim().split(`
`),u=[];return t.forEach(S=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(S);F&&F.length>=3&&u.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),u.reduce((S,F)=>(S[F.socket]=F,S),{})}e.getSockets=b;function C(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(u=>u.st==="0A").map(u=>{const w=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:p(w[0]),port:parseInt(w[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=C;function p(n){let t="";if(n.length===8)for(let u=n.length-2;u>=0;u-=2)t+=parseInt(n.substr(u,2),16),u!==0&&(t+=".");else for(let u=n.length-4;u>=0;u-=4)t+=parseInt(n.substr(u,4),16).toString(16),u!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),u=t.shift().trim().split(/\s+/).filter(S=>S!=="rx_queue"&&S!=="tm->when");return t.map(S=>S.trim().split(/\s+/).reduce((F,x,V)=>(F[u[V]||V]=x,F),{}))}e.loadConnectionTable=i;function o(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function s(n){const t=n.trim().split(`
`),u=[];return t.forEach(w=>{const S=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);S&&S.length>=4&&u.push({pid:parseInt(S[1],10),ppid:parseInt(S[2]),cmd:S[3]})}),u}e.getRootProcesses=s;async function c(n,t,u){const w=u.reduce((F,x)=>(F[x.pid]=x,F),{}),S=[];return n.forEach(({socket:F,ip:x,port:V})=>{const M=t[F]?t[F].pid:void 0,B=M?w[M]?.cmd:void 0;M&&B&&!o(B)&&S.push({host:x,port:V,detail:B,pid:M})}),S}e.findPorts=c;function r(n,t,u){const w=new Map,S=s(t);for(const F of n){const x=u.get(F.port);if(x){w.set(F.port,x);continue}const V=S.find(M=>M.cmd.includes(`${F.port}`));if(V){let M=V,B;do B=S.find(O=>O.ppid===M.pid),B&&(M=B);while(B);w.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else w.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let m=class extends R.Disposable{constructor(t,u,w){super(),this.n=w,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new y.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(a.MainContext.MainThreadTunnelService),v.isLinux&&u.remote.isRemote&&u.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,u){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const w=await this.a.$openTunnel(u,t.displayName);if(w){const S=new g(w.remoteAddress,w.localAddress,()=>this.a.$closeTunnel(w.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,u){const w=this.r();return this.l.set(w,{selector:t,provider:u}),this.a.$registerPortsAttributesProvider(t,w),new T.Disposable(()=>{this.l.delete(w),this.a.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(t,u,w,S,F){const x=[];for(const M of t){const B=this.l.get(M);if(!B)return[];x.push(...await Promise.all(u.map(async O=>B.provider.providePortAttributes(O,w,S,F))))}const V=x.filter(M=>!!M);return V.length>0?V.map(M=>({autoForwardAction:M.autoForwardAction,port:M.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const u=new h.MovingAverage;let w;for(;this.h;){const S=new Date().getTime(),F=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(V=>V.port).join(", ")}`);const x=new Date().getTime()-S;u.update(x),(!w||JSON.stringify(w)!==JSON.stringify(F))&&(w=F,await this.a.$onFoundNewCandidates(w)),await new Promise(V=>setTimeout(()=>V(),this.p(u.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let u=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const w=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:u}:void 0;this.a.$setTunnelProvider(w)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,u){if(this.f.has(t.host)){const w=this.f.get(t.host);w.has(t.port)&&(u&&w.get(t.port).disposeListener.dispose(),await w.get(t.port).tunnel.dispose(),w.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,u){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this.b(t,u);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const S=await w;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const F=this.B(S.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:S,disposeListener:F}),I.TunnelDtoConverter.fromApiTunnel(S)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const u=await Promise.all(t.map(S=>this.c(S.host,S.port,S.detail??""))),w=t.filter((S,F)=>u[F]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(S=>S.port).join(", ")} to ${w.map(S=>S.port).join(", ")}`),w}async findCandidatePorts(){let t="",u="";try{t=await L.Promises.readFile("/proc/net/tcp","utf8"),u=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=C(t,u),S=await new Promise($=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(j,le,J)=>{$(le)})}),F=b(S),x=await L.Promises.readdir("/proc"),V=[];for(const $ of x)try{const j=Number($),le=k.joinPath(P.URI.file("/proc"),$);if((await L.Promises.stat(le.fsPath)).isDirectory()&&!isNaN(j)){const q=await L.Promises.readlink(k.joinPath(le,"cwd").fsPath),Q=await L.Promises.readFile(k.joinPath(le,"cmdline").fsPath,"utf8");V.push({pid:j,cwd:q,cmd:Q})}}catch{}const M=[],B=w.filter($=>{const j=F[$.socket];return j||M.push($),j}),O=c(B,F,V);let U;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const $=await new Promise(j=>{(0,E.exec)("ps -F -A -l | grep root",(le,J,q)=>{j(J)})});this.j=r(M,$,this.j),U=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(j=>j.port).join(", ")}`)}return O.then($=>U?$.concat(U):$)}};m=qe([We(0,A.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,d.ILogService)],m),e.ExtHostTunnelService=m}),define(ye[290],De([1,0,19,22,21,11,3,6,114,248,58]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(w,S){try{return JSON.stringify(w,S)}catch{return"null"}}const I="$$ref$$",y={[I]:-1};class f{constructor(S,F){this.jsonString=S,this.referencedBuffers=F}}function h(w,S=null,F=!1){const x=[];return{jsonString:(F?v:JSON.stringify)(w,(M,B)=>{if(typeof B>"u")return y;if(typeof B=="object"){if(B instanceof A.VSBuffer){const O=x.push(B)-1;return{[I]:O}}if(S)return S(M,B)}return B}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=h;function d(w,S,F){return JSON.parse(w,(x,V)=>{if(V){const M=V[I];if(typeof M=="number")return S[M];if(F&&V.$mid===1)return F.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=d;function g(w,S){return JSON.stringify(w,S)}function b(w){return w?(S,F)=>F&&F.$mid===1?w.transformOutgoing(F):F:null}var C;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},o=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class c extends P.Disposable{constructor(S,F=null,x=null){super(),this[T]=!0,this.b=this.B(new D.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=S,this.f=F,this.g=x,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,M=L.ProxyIdentifier.count;V<M;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(S=>{this.s[S].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(S){this.u===0&&(this.v=Date.now()+c.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(S){this.v=Date.now()+c.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(S){this.t!==S&&(this.t=S,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(S){return this.g?(0,E.transformIncomingURIs)(S,this.g):S}getProxy(S){const{nid:F,sid:x}=S;return this.l[F]||(this.l[F]=this.F(F,x)),this.l[F]}F(S,F){const x={get:(V,M)=>(typeof M=="string"&&!V[M]&&M.charCodeAt(0)===36&&(V[M]=(...B)=>this.O(S,M,B)),M===s?F:V[M])};return new Proxy(Object.create(null),x)}set(S,F){return this.k[S.nid]=F,F}assertRegistered(S){for(let F=0,x=S.length;F<x;F++){const V=S[F];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(S){if(this.j)return;const F=S.byteLength,x=r.read(S,0),V=x.readUInt8(),M=x.readUInt32();switch(V){case 1:case 2:{let{rpcId:B,method:O,args:U}=n.deserializeRequestJSONArgs(x);this.g&&(U=(0,E.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,V===2);break}case 3:case 4:{let{rpcId:B,method:O,args:U}=n.deserializeRequestMixedArgs(x);this.g&&(U=(0,E.transformIncomingURIs)(U,this.g)),this.H(F,M,B,O,U,V===4);break}case 5:{this.f?.logIncoming(F,M,0,"ack"),this.z(M);break}case 6:{this.I(F,M);break}case 7:{this.J(F,M,void 0);break}case 9:{let B=n.deserializeReplyOKJSON(x);this.g&&(B=(0,E.transformIncomingURIs)(B,this.g)),this.J(F,M,B);break}case 10:{const B=n.deserializeReplyOKJSONWithBuffers(x,this.g);this.J(F,M,B);break}case 8:{const B=n.deserializeReplyOKVSBuffer(x);this.J(F,M,B);break}case 11:{let B=n.deserializeReplyErrError(x);this.g&&(B=(0,E.transformIncomingURIs)(B,this.g)),this.L(F,M,B);break}case 12:{this.L(F,M,void 0);break}default:console.error("received unexpected message"),console.error(S)}}H(S,F,x,V,M,B){this.f?.logIncoming(S,F,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(x)}.${V}(`,M);const O=String(F);let U,$;if(B){const le=new l.CancellationTokenSource;M.push(le.token),U=this.M(x,V,M),$=()=>le.cancel()}else U=this.M(x,V,M),$=i;this.p[O]=$;const j=n.serializeAcknowledged(F);this.f?.logOutgoing(j.byteLength,F,1,"ack"),this.c.send(j),U.then(le=>{delete this.p[O];const J=n.serializeReplyOK(F,le,this.h);this.f?.logOutgoing(J.byteLength,F,1,"reply:",le),this.c.send(J)},le=>{delete this.p[O];const J=n.serializeReplyErr(F,le);this.f?.logOutgoing(J.byteLength,F,1,"replyErr:",le),this.c.send(J)})}I(S,F){this.f?.logIncoming(S,F,1,"receiveCancel");const x=String(F);this.p[x]?.()}J(S,F,x){this.f?.logIncoming(S,F,0,"receiveReply:",x);const V=String(F);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V],M.resolveOk(x)}L(S,F,x){this.f?.logIncoming(S,F,0,"receiveReplyErr:",x);const V=String(F);if(!this.s.hasOwnProperty(V))return;const M=this.s[V];delete this.s[V];let B;x&&(x.$isError?(B=new Error,B.name=x.name,B.message=x.message,B.stack=x.stack):B=x),M.resolveErr(B)}M(S,F,x){try{return Promise.resolve(this.N(S,F,x))}catch(V){return Promise.reject(V)}}N(S,F,x){const V=this.k[S];if(!V)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(S));const M=V[F];if(typeof M!="function")throw new Error("Unknown method "+F+" on actor "+(0,L.getStringIdentifierForProxy)(S));return M.apply(V,x)}O(S,F,x){if(this.j)return new k.CanceledLazyPromise;let V=null;if(x.length>0&&l.CancellationToken.isCancellationToken(x[x.length-1])&&(V=x.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const M=n.serializeRequestArguments(x,this.h),B=++this.m,O=String(B),U=new k.LazyPromise;V&&V.onCancellationRequested(()=>{const j=n.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(n.serializeCancel(B))}),this.s[O]=U,this.y(B);const $=n.serializeRequest(B,S,F,M,!!V);return this.f?.logOutgoing($.byteLength,B,0,`request: ${(0,L.getStringIdentifierForProxy)(S)}.${F}(`,x),this.c.send($),U}}T=o,c.a=3*1e3,e.RPCProtocol=c;class r{static alloc(S,F,x){const V=new r(A.VSBuffer.alloc(x+1+4),0);return V.writeUInt8(S),V.writeUInt32(F),V}static read(S,F){return new r(S,F)}get buffer(){return this.a}constructor(S,F){this.a=S,this.b=F}static sizeUInt8(){return 1}writeUInt8(S){this.a.writeUInt8(S,this.b),this.b+=1}readUInt8(){const S=this.a.readUInt8(this.b);return this.b+=1,S}writeUInt32(S){this.a.writeUInt32BE(S,this.b),this.b+=4}readUInt32(){const S=this.a.readUInt32BE(this.b);return this.b+=4,S}static sizeShortString(S){return 1+S.byteLength}writeShortString(S){this.a.writeUInt8(S.byteLength,this.b),this.b+=1,this.a.set(S,this.b),this.b+=S.byteLength}readShortString(){const S=this.a.readUInt8(this.b);this.b+=1;const x=this.a.slice(this.b,this.b+S).toString();return this.b+=S,x}static sizeLongString(S){return 4+S.byteLength}writeLongString(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readLongString(){const S=this.a.readUInt32BE(this.b);this.b+=4;const x=this.a.slice(this.b,this.b+S).toString();return this.b+=S,x}writeBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}static sizeVSBuffer(S){return 4+S.byteLength}writeVSBuffer(S){this.a.writeUInt32BE(S.byteLength,this.b),this.b+=4,this.a.set(S,this.b),this.b+=S.byteLength}readVSBuffer(){const S=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+S);return this.b+=S,F}static sizeMixedArray(S){let F=0;F+=1;for(let x=0,V=S.length;x<V;x++){const M=S[x];switch(F+=1,M.type){case 1:F+=this.sizeLongString(M.value);break;case 2:F+=this.sizeVSBuffer(M.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(M.value);for(let B=0;B<M.buffers.length;++B)F+=this.sizeVSBuffer(M.buffers[B]);break;case 4:break}}return F}writeMixedArray(S){this.a.writeUInt8(S.length,this.b),this.b+=1;for(let F=0,x=S.length;F<x;F++){const V=S[F];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let M=0;M<V.buffers.length;++M)this.writeBuffer(V.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const S=this.a.readUInt8(this.b);this.b+=1;const F=new Array(S);for(let x=0;x<S;x++)switch(this.readUInt8()){case 1:F[x]=this.readLongString();break;case 2:F[x]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),B=this.readLongString(),O=[];for(let U=0;U<M;++U)O.push(this.readVSBuffer());F[x]=new L.SerializableObjectWithBuffers(d(B,O,null));break}case 4:F[x]=void 0;break}return F}}r.sizeUInt32=4;var m;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(m||(m={}));class n{static a(S){for(let F=0,x=S.length;F<x;F++)if(S[F]instanceof A.VSBuffer||S[F]instanceof L.SerializableObjectWithBuffers||typeof S[F]>"u")return!0;return!1}static serializeRequestArguments(S,F){if(this.a(S)){const x=[];for(let V=0,M=S.length;V<M;V++){const B=S[V];if(B instanceof A.VSBuffer)x[V]={type:2,value:B};else if(typeof B>"u")x[V]={type:4};else if(B instanceof L.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:U}=h(B.value,F);x[V]={type:3,value:A.VSBuffer.fromString(O),buffers:U}}else x[V]={type:1,value:A.VSBuffer.fromString(g(B,F))}}return{type:1,args:x}}return{type:0,args:g(S,F)}}static serializeRequest(S,F,x,V,M){switch(V.type){case 0:return this.b(S,F,x,V.args,M);case 1:return this.c(S,F,x,V.args,M)}}static b(S,F,x,V,M){const B=A.VSBuffer.fromString(x),O=A.VSBuffer.fromString(V);let U=0;U+=r.sizeUInt8(),U+=r.sizeShortString(B),U+=r.sizeLongString(O);const $=r.alloc(M?2:1,S,U);return $.writeUInt8(F),$.writeShortString(B),$.writeLongString(O),$.buffer}static deserializeRequestJSONArgs(S){const F=S.readUInt8(),x=S.readShortString(),V=S.readLongString();return{rpcId:F,method:x,args:JSON.parse(V)}}static c(S,F,x,V,M){const B=A.VSBuffer.fromString(x);let O=0;O+=r.sizeUInt8(),O+=r.sizeShortString(B),O+=r.sizeMixedArray(V);const U=r.alloc(M?4:3,S,O);return U.writeUInt8(F),U.writeShortString(B),U.writeMixedArray(V),U.buffer}static deserializeRequestMixedArgs(S){const F=S.readUInt8(),x=S.readShortString(),V=S.readMixedArray(),M=new Array(V.length);for(let B=0,O=V.length;B<O;B++){const U=V[B];typeof U=="string"?M[B]=JSON.parse(U):M[B]=U}return{rpcId:F,method:x,args:M}}static serializeAcknowledged(S){return r.alloc(5,S,0).buffer}static serializeCancel(S){return r.alloc(6,S,0).buffer}static serializeReplyOK(S,F,x){if(typeof F>"u")return this.d(S);if(F instanceof A.VSBuffer)return this.e(S,F);if(F instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:M}=h(F.value,x,!0);return this.g(S,V,M)}else return this.f(S,v(F,x))}static d(S){return r.alloc(7,S,0).buffer}static e(S,F){let x=0;x+=r.sizeVSBuffer(F);const V=r.alloc(8,S,x);return V.writeVSBuffer(F),V.buffer}static deserializeReplyOKVSBuffer(S){return S.readVSBuffer()}static f(S,F){const x=A.VSBuffer.fromString(F);let V=0;V+=r.sizeLongString(x);const M=r.alloc(9,S,V);return M.writeLongString(x),M.buffer}static g(S,F,x){const V=A.VSBuffer.fromString(F);let M=0;M+=r.sizeUInt32,M+=r.sizeLongString(V);for(const O of x)M+=r.sizeVSBuffer(O);const B=r.alloc(10,S,M);B.writeUInt32(x.length),B.writeLongString(V);for(const O of x)B.writeBuffer(O);return B.buffer}static deserializeReplyOKJSON(S){const F=S.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(S,F){const x=S.readUInt32(),V=S.readLongString(),M=[];for(let B=0;B<x;++B)M.push(S.readVSBuffer());return new L.SerializableObjectWithBuffers(d(V,M,F))}static serializeReplyErr(S,F){const x=F?v(R.transformErrorForSerialization(F),null):void 0;if(typeof x!="string")return this.h(S);const V=A.VSBuffer.fromString(x);let M=0;M+=r.sizeLongString(V);const B=r.alloc(11,S,M);return B.writeLongString(V),B.buffer}static deserializeReplyErrError(S){const F=S.readLongString();return JSON.parse(F)}static h(S){return r.alloc(12,S,0).buffer}}var t;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var u;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(u||(u={}))}),define(ye[291],De([1,0,3,39,54,4]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var D;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(L=>k.push(L)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}A.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,20,26,13,291,77,25,48,158,22,9,44,3,6]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends D.AbstractMessageLogger{get disposed(){return this.l}constructor(p,i,o,s,c){super(),this.id=p,this.name=i,this.m=o,this.n=s,this.extension=c,this.k=0,this.l=!1,this.visible=!1,this.setLevel(o.getLevel()),this.B(o.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(p){this.append(p+`
`)}append(p){this.info(p)}clear(){const p=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,p)}replace(p){const i=this.k;this.info(p),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(p,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof p=="boolean"?p:i))}hide(){this.n.$close(this.id)}g(p,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,D.log)(this.m,p,i),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends d{appendLine(p){this.append(p)}}let b=class{constructor(p,i,o,s,c,r){this.i=i,this.j=o,this.k=s,this.l=c,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=p.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.h=p;for(const[i,o]of this.g)o.visible=i===this.h}createOutputChannel(p,i,o){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const s=typeof i=="object"&&i.log,c=(0,I.isString)(i)?i:void 0;if((0,I.isString)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const m=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(o.identifier,t))?.[1];m&&(r=(0,D.parseLogLevel)(m));const n=s?this.o(p,r,o):this.n(p,c,o);return n.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),s?this.r(p,r??this.m.getLevel(),n):this.q(p,n)}async n(p,i,o){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,c=this.k.extUri.joinPath(s,`${this.f++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(p,c,i,o.identifier.value);return new d(m,p,r,this.a,o)}async o(p,i,o){const s=await this.p(o),c=this.k.extUri.joinPath(s,`${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=c.toString(),m=this.l.createLogger(c,{id:r,name:p,logLevel:i,extensionId:o.identifier.value});return new g(r,p,m,this.a,o)}p(p){let i=this.d.get(p.identifier.value);if(!i){const o=this.k.extUri.joinPath(this.i.logsLocation,p.identifier.value);this.d.set(p.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(o)}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileExists)throw s}return o})())}return i}q(p,i){let o=!1;const s=()=>{if(o)throw new Error("Channel has been closed")};return{get name(){return p},append(c){s(),i.then(r=>r.append(c))},appendLine(c){s(),i.then(r=>r.appendLine(c))},clear(){s(),i.then(c=>c.clear())},replace(c){s(),i.then(r=>r.replace(c))},show(c,r){s(),i.then(m=>m.show(c,r))},hide(){s(),i.then(c=>c.hide())},dispose(){o=!0,i.then(c=>c.dispose())}}}r(p,i,o){const s=new h.DisposableStore,c=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new f.Emitter);function m(n){i=n,r.fire(n)}return o.then(n=>{s.add(n),n.logLevel!==i&&m(n.logLevel),s.add(n.onDidChangeLogLevel(t=>m(t)))}),{...this.q(p,o),get logLevel(){return i},onDidChangeLogLevel:r.event,trace(n,...t){c(),o.then(u=>u.trace(n,...t))},debug(n,...t){c(),o.then(u=>u.debug(n,...t))},info(n,...t){c(),o.then(u=>u.info(n,...t))},warn(n,...t){c(),o.then(u=>u.warn(n,...t))},error(n,...t){c(),o.then(u=>u.error(n,...t))},dispose(){s.dispose()}}}};b=qe([We(0,l.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,E.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,D.ILoggerService),We(5,D.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,A.createDecorator)("IExtHostOutputService")}),define(ye[292],De([1,0,4]),function(ne,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[293],De([1,0,33,16,10,12,24,2,4,218,47,236,292]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let I=class cn{constructor(f,h,d,g){this.d=f,this.e=h,this.f=d,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??f})()}hasValidBasename(f,h,d){return typeof h=="string"||typeof h>"u"?this.a.then(g=>this.h(f,g,h)):this.h(f,h,d)}h(f,h,d){return f.scheme===A.Schemas.file||f.scheme===A.Schemas.vscodeRemote?(0,a.isValidBasename)(d??(0,D.basename)(f),h===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,h){if(f.remoteAuthority)return A.Schemas.vscodeRemote;const d=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(d)return d;const g=h.getWorkspace().folders[0];if(g)return g.uri.scheme;const b=h.getWorkspace().configuration;return b?b.scheme:A.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?l.win32:l.posix)}async fileURI(f){let h="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const g=f.indexOf("/",2);g===-1?(h=f.substring(2),f="/"):(h=f.substring(2,g),f=f.substring(g)||"/")}return P.URI.from({scheme:A.Schemas.file,authority:h,path:f,query:"",fragment:""})}};I=qe([We(1,v.IRemoteAgentService),We(2,T.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(ye[80],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(D,P){this.line=D,this.character=P}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,P){return new a(0,0)}with(D){return new a(0,0)}}e.Position=a;class A{constructor(D,P,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(D,P),this.end=new a(E,k)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new A(0,0,0,0)}with(D){return new A(0,0,0,0)}}e.Range=A;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,33,8,4,10,11,80,19]),function(ne,e,a,A,l,R,D,P,E,k,L,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",I=" characters skipped \u27EB",y=(v.length+I.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var f;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function d(Q){return!!Q.preview}e.resultIsMatch=d;function g(Q){return!!Q.resource}e.isFileMatch=g;function b(Q){return!!Q.message}e.isProgressMessage=b;var C;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(C=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=p;class i{constructor(Z,te,X){this.ranges=te;const _=Array.isArray(te)?te:[te];if(X&&X.matchLines===1&&o(_)){Z=(0,D.getNLines)(Z,X.matchLines);let ie="",pe=0,ve=0;const ke=Math.floor(X.charsPerLine/5),Oe=[];for(const oe of _){const ae=Math.max(oe.startColumn-ke,0),fe=oe.startColumn+X.charsPerLine;if(ae>ve+ke+y){const ee=v+(ae-ve)+I;ie+=ee+Z.slice(ae,fe),pe+=ae-(ve+ee.length)}else ie+=Z.slice(ve,fe);Oe.push(new c(0,oe.startColumn-pe,oe.endColumn-pe)),ve=fe}this.preview={text:ie,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ie=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:Z,matches:(0,a.mapArrayOrNot)(te,pe=>new s(pe.startLineNumber-ie,pe.startColumn,pe.endLineNumber-ie,pe.endColumn))}}}}e.TextSearchMatch=i;function o(Q){const Z=Q[0].startLineNumber;for(const te of Q)if(te.startLineNumber!==Z||te.endLineNumber!==Z)return!1;return!0}class s{constructor(Z,te,X,_){this.startLineNumber=Z,this.startColumn=te,this.endLineNumber=X,this.endColumn=_}}e.SearchRange=s;class c extends s{constructor(Z,te,X){super(Z,te,Z,X)}}e.OneLineRange=c;var r;(function(Q){Q.List="list",Q.Tree="tree"})(r=e.ViewMode||(e.ViewMode={}));var m;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Q,Z=!0){const te=Q&&Q.files&&Q.files.exclude,X=Z&&Q&&Q.search&&Q.search.exclude;if(!te&&!X)return;if(!te||!X)return te||X;let _=Object.create(null);return _=l.mixin(_,l.deepClone(te)),_=l.mixin(_,l.deepClone(X),!0),_}e.getExcludes=n;function t(Q,Z){return Q.excludePattern&&A.match(Q.excludePattern,Z)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&A.match(Q.includePattern,Z)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(te=>{const X=te.folder.fsPath;if(R.isEqualOrParent(Z,X)){const _=E.relative(X,Z);return!te.includePattern||!!A.match(te.includePattern,_)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var u;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(u=e.SearchErrorCode||(e.SearchErrorCode={}));class w extends Error{constructor(Z,te){super(Z),this.code=te}}e.SearchError=w;function S(Q){const Z=Q.message;if((0,k.isCancellationError)(Q))return new w(Z,u.canceled);try{const te=JSON.parse(Z);return new w(te.message,te.code)}catch{return new w(Z,u.other)}}e.deserializeSearchError=S;function F(Q){const Z={message:Q.message,code:Q.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=F;function x(Q){return Q.type==="error"?!0:Q.type==="success"}e.isSerializedSearchComplete=x;function V(Q){return Q.type==="success"}e.isSerializedSearchSuccess=V;function M(Q){return!!Q.path}e.isSerializedFileMatch=M;function B(Q,Z){const te=Q.searchPath?Q.searchPath:Q.relativePath;return(0,D.fuzzyContains)(te,Z)}e.isFilePatternMatch=B;class O{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=O;function U(Q,Z){const te={...Q||{},...Z||{}};return Object.keys(te).filter(X=>{const _=te[X];return typeof _=="boolean"&&_})}e.resolvePatternsForProvider=U;class ${constructor(Z,te){this.c=null,this.a={...Z.excludePattern||{},...te.excludePattern||{}},this.b=A.parse(this.a);let X=Z.includePattern;te.includePattern&&(X?X={...X,...te.includePattern}:X=te.includePattern),X&&(this.c=A.parse(X))}matchesExcludesSync(Z,te,X){return!!(this.b&&this.b(Z,te,X))}includedInQuerySync(Z,te,X){return!(this.b&&this.b(Z,te,X)||this.c&&!this.c(Z,te,X))}includedInQuery(Z,te,X){const _=this.b(Z,te,X),ie=()=>this.c?!!this.c(Z,te,X):!0;return(0,T.isThenable)(_)?_.then(pe=>pe?!1:ie()):ie()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=$;function j(Q){for(const Z in Q)if(typeof Q[Z]!="boolean")return!0;return!1}function le(Q){if(!Q)return;let Z;return te=>(Z||(Z=(Q()||Promise.resolve([])).then(X=>X?q(X):{})),Z.then(X=>!!X[te]))}e.hasSiblingPromiseFn=le;function J(Q){if(!Q)return;let Z;return te=>{if(!Z){const X=Q();Z=X?q(X):{}}return!!Z[te]}}e.hasSiblingFn=J;function q(Q){const Z={};for(const te of Q)Z[te]=!0;return Z}}),define(ye[34],De([1,0,15,19,21,3,6,68,16,102,24,8,9,2,184,4,13,206,47,48,25,20,14,7,56,31,5]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p,i,o,s,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(V,M,B){return new L.ExtUri(O=>w(O,B)).isEqual(V,M)}function n(V,M,B){return m(V.uri,M.uri,B)?0:(0,T.compare)(V.uri.toString(),M.uri.toString())}function t(V,M,B){return V.index!==M.index?V.index<M.index?-1:1:m(V.uri,M.uri,B)?(0,T.compare)(V.name,M.name):(0,T.compare)(V.uri.toString(),M.uri.toString())}function u(V,M,B,O){const U=V.slice(0).sort((j,le)=>B(j,le,O)),$=M.slice(0).sort((j,le)=>B(j,le,O));return(0,a.delta)(U,$,(j,le)=>B(j,le,O))}function w(V,M){const B=M.getCapabilities(V.scheme);return!(B&&B&1024)}class S extends g.Workspace{static toExtHostWorkspace(M,B,O,U){if(!M)return{workspace:null,added:[],removed:[]};const{id:$,name:j,folders:le,configuration:J,transient:q,isUntitled:Q}=M,Z=[],te=B;B?le.forEach((pe,ve)=>{const ke=I.URI.revive(pe.uri),Oe=S.o(O||B,ke,U);Oe?(Oe.name=pe.name,Oe.index=pe.index,Z.push(Oe)):Z.push({uri:ke,name:pe.name,index:ve})}):Z.push(...le.map(({uri:pe,name:ve,index:ke})=>({uri:I.URI.revive(pe),name:ve,index:ke}))),Z.sort((pe,ve)=>pe.index<ve.index?-1:1);const X=new S($,j,Z,!!q,J?I.URI.revive(J):null,!!Q,pe=>w(pe,U)),{added:_,removed:ie}=u(te?te.workspaceFolders:[],X.workspaceFolders,n,U);return{workspace:X,added:_,removed:ie}}static o(M,B,O){for(let U=0;U<M.folders.length;U++){const $=M.workspaceFolders[U];if(m($.uri,B,O))return $}}constructor(M,B,O,U,$,j,le){super(M,O.map(J=>new g.WorkspaceFolder(J)),U,$,le),this.t=B,this.u=j,this.q=[],this.s=P.TernarySearchTree.forUris(le),O.forEach(J=>{this.q.push(J),this.s.set(J.uri,J)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,B){return B&&this.s.get(M)&&(M=(0,L.dirname)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let F=class{constructor(M,B,O,U,$){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=U,this.s=O,this.t=$,this.j=new k.Counter,this.k=new A.Barrier,this.o=M.getProxy(r.MainContext.MainThreadWorkspace),this.q=M.getProxy(r.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new S(j.id,j.name,[],!!j.transient,j.configuration?I.URI.revive(j.configuration):null,!!j.isUntitled,le=>w(le,O)):void 0}$initializeWorkspace(M,B){this.v=B,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?I.URI.from({scheme:E.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,B,O,...U){const $=[];if(Array.isArray(U)&&U.forEach(Q=>{I.URI.isUri(Q.uri)&&!$.some(Z=>m(Z.uri,Q.uri,this.s))&&$.push({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri)})}),this.n||[B,O].some(Q=>typeof Q!="number"||Q<0)||O===0&&$.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+O>j.length)return!1;const le=j.slice(0);le.splice(B,O,...$.map(Q=>({uri:Q.uri,name:Q.name||(0,L.basenameOrAuthority)(Q.uri),index:void 0})));for(let Q=0;Q<le.length;Q++){const Z=le[Q];if(le.some((te,X)=>X!==Q&&m(Z.uri,te.uri,this.s)))return!1}le.forEach((Q,Z)=>Q.index=Z);const{added:J,removed:q}=u(j,le,t,this.s);if(J.length===0&&q.length===0)return!1;if(this.o){const Q=M.displayName||M.name;this.o.$updateWorkspaceFolders(Q,B,O,$).then(void 0,Z=>{this.n=void 0;const te={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(d.Severity.Error,(0,y.localize)(0,null,Q,Z.toString()),te,[])})}return this.y(le),!0}getWorkspaceFolder(M,B){if(!!this.x)return this.x.getWorkspaceFolder(M,B)}async getWorkspaceFolder2(M,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,B)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,B){let O,U="";if(typeof M=="string"?(O=I.URI.file(M),U=M):typeof M<"u"&&(O=M,U=M.fsPath),!O)return U;const $=this.getWorkspaceFolder(O,!0);if(!$)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,L.relativePath)($.uri,O);return B&&$.name&&(j=`${$.name}/${j}`),j}y(M){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:B,added:O,removed:U}=S.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:U}))}findFiles(M,B,O,U,$=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:le,folder:J}=x(i.GlobPattern.from(M));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(le),(0,v.withUndefinedAsNull)(J),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(O),$).then(q=>Array.isArray(q)?q.map(Q=>I.URI.revive(Q)):[])}async findTextInFiles(M,B,O,U,$=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),le=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:J,folder:q}=x(i.GlobPattern.from(B.include)),Q=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,Z={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:le,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:J,excludePattern:Q},te=!1;if(this.u[j]=X=>{if(te)return;const _=I.URI.revive(X.resource);X.results.forEach(ie=>{(0,c.resultIsMatch)(ie)?O({uri:_,preview:{text:ie.preview.text,matches:(0,a.mapArrayOrNot)(ie.preview.matches,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))},ranges:(0,a.mapArrayOrNot)(ie.ranges,pe=>new o.Range(pe.startLineNumber,pe.startColumn,pe.endLineNumber,pe.endColumn))}):O({uri:_,text:ie.text,lineNumber:ie.lineNumber})})},$.isCancellationRequested)return{};try{const X=await this.o.$startTextSearch(M,(0,v.withUndefinedAsNull)(q),Z,j,$);return delete this.u[j],X||{}}catch(X){throw delete this.u[j],X}}$handleTextSearchResult(M,B){this.u[B]?.(M)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,B){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,B);const O=this.t.transformOutgoingScheme(M),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,O),(0,D.toDisposable)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(M,B){this.h.info("Getting edit session identifier for workspaceFolder",M);const O=await this.resolveWorkspaceFolder(I.URI.revive(M));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const U=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!U),!U)return;const $=await U.provideEditSessionIdentity(O,B);if(this.h.info("Provider returned edit session identifier: ",$),!!$)return $}async $provideEditSessionIdentityMatch(M,B,O,U){this.h.info("Getting edit session identifier for workspaceFolder",M);const $=await this.resolveWorkspaceFolder(I.URI.revive(M));if(!$){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",$);const j=this.w.get($.uri.scheme);if(this.h.info(`Provider for scheme ${$.uri.scheme} is defined: `,!!j),!j)return;const le=await j.provideEditSessionIdentityMatch?.(B,O,U);if(this.h.info("Provider returned edit session identifier match result: ",le),!!le)return le}getOnWillCreateEditSessionIdentityEvent(M){return(B,O,U)=>{const $=function(le){B.call(O,le)};return $.extension=M,this.A.event($,void 0,U)}}async $onWillCreateEditSessionIdentity(M,B,O){const U=await this.resolveWorkspaceFolder(I.URI.revive(M));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async($,j)=>{const le=Date.now();await Promise.resolve($),Date.now()-le>O&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};F=qe([We(0,p.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,h.ILogService),We(4,s.IURITransformerService)],F),e.ExtHostWorkspace=F,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function x(V){let M,B;return V&&(typeof V=="string"?M=V:(M=V.pattern,B=I.URI.revive(V.baseUri))),{includePattern:M,folder:B}}}),define(ye[35],De([1,0,23,3,34,5,7,209,127,9,19,4,20,13,2]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(o,s){if(s){const c=s.split(".");let r=o;for(let m=0;r&&m<c.length;m++)r=r[c[m]];return r}}function h(o){return o instanceof y.URI}function d(o){return o&&o.uri instanceof y.URI&&o.languageId&&typeof o.languageId=="string"}function g(o){return o&&!o.uri&&o.languageId&&typeof o.languageId=="string"}function b(o){return o&&o.uri instanceof y.URI&&(!o.name||typeof o.name=="string")&&(!o.index||typeof o.index=="number")}function C(o){if(h(o))return{resource:o};if(d(o))return{resource:o.uri,overrideIdentifier:o.languageId};if(g(o))return{overrideIdentifier:o.languageId};if(b(o))return{resource:o.uri};if(o===null)return{resource:null}}let p=class{constructor(s,c,r){this.a=s.getProxy(R.MainContext.MainThreadConfiguration),this.c=c,this.b=r,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new i(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,c){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,c))}};p=qe([We(0,v.IExtHostRpcService),We(1,l.IExtHostWorkspace),We(2,I.ILogService)],p),e.ExtHostConfiguration=p;class i{constructor(s,c,r,m){this.a=new A.Emitter,this.b=s,this.f=m,this.c=c,this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,c){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(c,r))}getConfiguration(s,c,r){const m=C(c)||{},n=this.g(s?f(this.e.getValue(void 0,m,this.c.workspace),s):this.e.getValue(void 0,m,this.c.workspace));s&&this.h(s,m,r?.identifier);function t(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(w){return typeof f(n,w)<"u"},get:(w,S)=>{this.h(s?`${s}.${w}`:w,m,r?.identifier);let F=f(n,w);if(typeof F>"u")F=S;else{let x;const V=(M,B)=>{let O;const U=()=>{x=x||(0,a.deepClone)(n),O=O||f(x,B)};return(0,k.isObject)(M)?new Proxy(M,{get:($,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return U(),()=>O;if(x)return O=O||f(x,B),O[j];const le=$[j];return typeof j=="string"?V(le,`${B}.${j}`):le},set:($,j,le)=>(U(),O&&(O[j]=le),!0),deleteProperty:($,j)=>(U(),O&&delete O[j],!0),defineProperty:($,j,le)=>(U(),O&&Object.defineProperty(O,j,le),!0)}):M};F=V(F,w)}return F},update:(w,S,F,x)=>{w=s?`${s}.${w}`:w;const V=t(F);return S!==void 0?this.b.$updateConfigurationOption(V,w,S,m,x):this.b.$removeConfigurationOption(V,w,m,x)},inspect:w=>{w=s?`${s}.${w}`:w;const S=this.e.inspect(w,m,this.c.workspace);if(S)return{key:w,defaultValue:(0,a.deepClone)(S.policy?.value??S.default?.value),globalValue:(0,a.deepClone)(S.user?.value??S.application?.value),workspaceValue:(0,a.deepClone)(S.workspace?.value),workspaceFolderValue:(0,a.deepClone)(S.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(S.default?.override),globalLanguageValue:(0,a.deepClone)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,a.deepClone)(S.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(S.workspaceFolder?.override),languageIds:(0,a.deepClone)(S.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(u,n,!1),Object.freeze(u)}g(s){const c=r=>(0,k.isObject)(r)?new Proxy(r,{get:(m,n)=>c(m[n]),set:(m,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(m,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(m,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return c(s)}h(s,c,r){const m=E.OVERRIDE_PROPERTY_REGEX.test(s)?4:this.d.get(s),n=r?`[${r.value}] `:"";if(m===4){typeof c?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){c?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,c){const r=new P.ConfigurationChangeEvent(s,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,n)=>r.affectsConfiguration(m,C(n))})}k(s){return s.reduce((c,r)=>(c.set(r[0],r[1]),c),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,T.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[81],De([1,0,2,19,3,5,7,34,59,35,21,41,20,25,4,16,12,13,76,247,11]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(i||(i={}));var o;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(o||(o={}));var s;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(s||(s={}));var c;(function(M){function B($){if($){const j=$;return j&&!!j.process}else return!1}M.is=B;function O($){if($==null)return;const j={process:$.process,args:$.args};return $.options&&(j.options=s.from($.options)),j}M.from=O;function U($){if($!=null)return new D.ProcessExecution($.process,$.args,$.options)}M.to=U})(c||(c={}));var r;(function(M){function B(U){if(U!=null)return U}M.from=B;function O(U){if(U!=null)return U}M.to=O})(r||(r={}));var m;(function(M){function B($){if($){const j=$;return j&&(!!j.commandLine||!!j.command)}else return!1}M.is=B;function O($){if($==null)return;const j={};return $.commandLine!==void 0?j.commandLine=$.commandLine:(j.command=$.command,j.args=$.args),$.options&&(j.options=r.from($.options)),j}M.from=O;function U($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new D.ShellExecution($.commandLine,$.options):new D.ShellExecution($.command,$.args?$.args:[],$.options)}M.to=U})(m||(m={}));var n;(function(M){function B($){if($){const j=$;return j&&j.customExecution==="customExecution"}else return!1}M.is=B;function O($){return{customExecution:"customExecution"}}M.from=O;function U($,j){return j.get($)}M.to=U})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(M){function B(O,U){let $;return O.scope!==void 0&&typeof O.scope!="number"?$=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===D.TaskScope.Workspace&&U&&U.workspaceFile?$=U.workspaceFile:$=b.USER_TASKS_GROUP_KEY),{id:O._id,workspaceFolder:$}}M.from=B})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(M){function B(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}M.from=B})(u||(u={}));var w;(function(M){function B($,j){if($==null)return[];const le=[];for(const J of $){const q=O(J,j);q&&le.push(q)}return le}M.fromMany=B;function O($,j){if($==null)return;let le;$.execution instanceof D.ProcessExecution?le=c.from($.execution):$.execution instanceof D.ShellExecution?le=m.from($.execution):$.execution&&$.execution instanceof D.CustomExecution&&(le=n.from($.execution));const J=i.from($.definition);let q;return $.scope?typeof $.scope=="number"?q=$.scope:q=$.scope.uri:q=D.TaskScope.Workspace,!J||!q?void 0:{_id:$._id,definition:J,name:$.name,source:{extensionId:j.identifier.value,label:$.source,scope:q},execution:le,isBackground:$.isBackground,group:u.from($.group),presentationOptions:o.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}M.from=O;async function U($,j,le){if($==null)return;let J;c.is($.execution)?J=c.to($.execution):m.is($.execution)?J=m.to($.execution):n.is($.execution)&&(J=n.to($._id,le));const q=i.to($.definition);let Q;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?Q=$.source.scope:Q=await j.resolveWorkspaceFolder(a.URI.revive($.source.scope)):Q=D.TaskScope.Workspace),!q||!Q)return;const Z=new D.Task(q,Q,$.name,$.source.label,J,$.problemMatchers);return $.isBackground!==void 0&&(Z.isBackground=$.isBackground),$.group!==void 0&&(Z.group=D.TaskGroup.from($.group._id),Z.group&&$.group.isDefault&&(Z.group=new D.TaskGroup(Z.group.id,Z.group.label),$.group.isDefault===!0&&(Z.group.isDefault=$.group.isDefault))),$.presentationOptions&&(Z.presentationOptions=o.to($.presentationOptions)),$._id&&(Z._id=$._id),$.detail&&(Z.detail=$.detail),Z}M.to=U})(w=e.TaskDTO||(e.TaskDTO={}));var S;(function(M){function B(U){return U}M.from=B;function O(U){if(!!U)return Object.assign(Object.create(null),U)}M.to=O})(S||(S={}));class F{constructor(B,O,U){this._id=O,this.a=U,p.set(this,void 0),_e(this,p,B,"f")}get task(){return this.a}terminate(){Be(this,p,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}p=new WeakMap;let x=class{constructor(B,O,U,$,j,le,J,q){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=B.getProxy(R.MainContext.MainThreadTask),this.b=U,this.c=$,this.d=j,this.e=le,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=J,this.g=q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,O,U){if(!U)return new D.Disposable(()=>{});const $=this.w();return this.j.set($,{type:O,provider:U,extension:B}),this.a.$registerTaskProvider($,O),new D.Disposable(()=>{this.j.delete($),this.a.$unregisterTaskProvider($)})}registerTaskSystem(B,O){this.a.$registerTaskSystem(B,O)}fetchTasks(B){return this.a.$fetchTasks(S.from(B)).then(async O=>{const U=[];for(const $ of O){const j=await w.to($,this.b,this.m);j&&U.push(j)}return U})}get taskExecutions(){const B=[];return this.k.forEach(O=>B.push(O)),B}terminateTask(B){if(!(B instanceof F))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,O,U){const $=this.m.get(B.id);$&&(this.o.set(B.id,$),this.e.attachPtyToTerminal(O,await $.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const O=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const O=await this.y(B.id);this.s.fire({execution:O,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const O=await this.y(B.id);this.t.fire({execution:O,exitCode:B.exitCode})}$provideTasks(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const $=[],j=(0,A.asPromise)(()=>U.provider.provideTasks(L.CancellationToken.None)).then(le=>this.u(O,$,U,le));return new Promise(le=>{j.then(J=>{Promise.all($).then(()=>{le(J)})})})}async $resolveTask(B,O){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(O.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${U.type}].`);const $=await w.to(O,this.b,this.m);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const j=await U.provider.resolveTask($,L.CancellationToken.None);if(!j)return;this.z(j,U);const le=w.from(j,U.extension);if(!le)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(le.execution)&&await this.x(le,j,!0),await this.v(le)}w(){return this.h++}async x(B,O,U){const $=await this.a.$createTaskId(B);!U&&!this.m.has($)&&(this.n.add($),this.o.set($,O.execution)),this.m.set($,O.execution)}async y(B,O){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const U=this.l.get(B.id);if(U)return U;const $=new Promise((j,le)=>{function J(q,Q,Z){Z?j(new F(q,Q.id,Z)):le("Unexpected: Task does not exist.")}O?J(this,B,O):w.to(B.task,this.b,this.m).then(q=>J(this,B,q))});return this.l.set(B.id,$),$.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,O){B._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let $=U.next();for(;!$.done;)!this.o.has($.value)&&this.p!==$.value&&(this.m.delete($.value),this.n.delete($.value)),$=U.next()}};x=qe([We(0,v.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,d.ILogService),We(7,g.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let V=class extends x{constructor(B,O,U,$,j,le,J,q){super(B,O,U,$,j,le,J,q),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(B,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const U=w.from(O,B);if(U===void 0)throw new Error("Task is not valid");if(n.is(U.execution))await this.x(U,O,!1);else throw new C.NotSupportedError;const $=await this.y(await this.a.$getTaskExecution(U),O);return this.a.$executeTask(U).catch(j=>{throw new Error(j)}),$}u(B,O,U,$){const j=[];if($)for(const le of $){this.z(le,U),(!le.definition||!B[le.definition.type])&&this.f.warn(`The task [${le.source}, ${le.name}] uses an undefined task type. The task will be ignored in the future.`);const J=w.from(le,U.extension);J&&n.is(J.execution)?(j.push(J),O.push(this.x(J,le,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:U.extension}}async v(B){if(n.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,O,U){}};V=qe([We(0,v.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,E.IExtHostDocumentsAndEditors),We(4,k.IExtHostConfiguration),We(5,T.IExtHostTerminalService),We(6,d.ILogService),We(7,g.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,y.createDecorator)("IExtHostTask")}),define(ye[294],De([1,0,10,21,45,38,24,43,31]),function(ne,e,a,A,l,R,D,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(v,I,y){this.k=v,this.l=I,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const I=this.k.folderQueries||[];return new Promise((y,f)=>{const h=d=>{this.f++,v(d)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const g=d.toString(),b=a.basename(g);this.j&&this.j(g,b)||this.v(h,{base:d,basename:b})}),Promise.all(I.map(d=>this.p(d,h))).then(d=>{y({limitHit:this.e,stats:d[0]||void 0})},d=>{f(new Error((0,l.toErrorMessage)(d)))})})}async p(v,I){const y=new A.CancellationTokenSource,f=this.q(v),h=this.r(),d=new E.QueryGlobTester(this.k,v),g=!d.hasSiblingExcludeClauses();let b;try{this.h.add(y),b=P.StopWatch.create();const C=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,y.token),p=b.elapsed(),i=P.StopWatch.create();return this.g&&!this.e||(C&&C.forEach(o=>{const s=a.posix.relative(v.folder.path,o.path);if(g){const c=a.basename(o.path);this.v(I,{base:v.folder,relativePath:s,basename:c});return}this.s(h,v.folder,s,I)}),this.g&&!this.e)?null:(this.u(h,d,I),{providerTime:p,postProcessTime:i.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(v){const I=(0,E.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),y=(0,E.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:y,includes:I,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},I,y,f){if(y===this.a){const d=a.basename(this.a);this.v(f,{base:I,relativePath:this.a,basename:d})}function h(d){const g=a.basename(d),b=a.dirname(d);let C=v[b];C||(C=v[b]=[],h(b)),C.push({base:I,relativePath:d,basename:g})}h(y)}u({rootEntries:v,pathToEntries:I},y,f){const h=this,d=this.a;function g(b){const C=(0,E.hasSiblingFn)(()=>b.map(p=>p.basename));for(let p=0,i=b.length;p<i;p++){const o=b[p],{relativePath:s,basename:c}=o;if(y.matchesExcludesSync(s,c,d!==c?C:void 0))continue;const r=I[s];if(r)g(r);else{if(s===d)continue;h.v(f,o)}if(h.e)break}}g(v)}v(v,I){(!this.b||I.relativePath&&this.b(I.relativePath,I.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(I))}}class L{constructor(){this.b=new Map}fileSearch(v,I,y,f){const h=this.c(v.cacheKey),d=new k(v,I,h&&h.token);let g=0;const b=C=>{g+=C.length,y(C.map(p=>this.d(p)))};return this.e(d,L.a,b,f).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:C.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new A.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:D.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,I,y,f){f.onCancellationRequested(()=>{v.cancel()});const h=g=>{g&&(d.push(g),I>0&&d.length>=I&&(y(d),d=[]))};let d=[];return v.search(h).then(g=>(d.length&&y(d),g),g=>(d.length&&y(d),Promise.reject(g)))}}L.a=512,e.FileSearchManager=L}),define(ye[295],De([1,0,15,61,38,113,28,16,10,24,8,9,2,166,196,53,13,47,133,293,31]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(w,S,F,x,V){this.a=w,this.b=S,this.c=F,this.d=x,this.e=V}text(w,S,F={}){w=this.f(w,F);const x=this.a.getValue(),V=S&&S.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(S?.map(d.toWorkspaceFolder),F),type:2,contentPattern:w,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:x.search.usePCRE2||V||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(w,S){const F=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const x={...w,wordSeparators:F.editor.wordSeparators};return this.j(w,S)&&(x.isCaseSensitive=!0),this.k(w)&&(x.isMultiline=!0),x}file(w,S={}){return{...this.h(w,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(w,S){return w?(w=Array.isArray(w)?w.map(r):r(w),S?this.parseSearchPaths(w):{pattern:o(...Array.isArray(w)?w:[w])}):{}}h(w=[],S={}){const F=this.g(S.includePattern,S.expandPatterns),x=this.g(S.excludePattern,S.expandPatterns),V=w.length>1,M=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(U=>this.q(U,S,x)):w.map(U=>this.r(U,S,x,V))).filter(U=>!!U),B={_reason:S._reason,folderQueries:M,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:x.pattern,includePattern:F.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const U=a.coalesce(a.flatten(this.c.groups.map(le=>le.editors.map(J=>J.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const $=U.filter(le=>(0,C.pathIncludedInQuery)(B,le.fsPath)),j=this.i($);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...B,...j}}const O=S.extraFileResources&&S.extraFileResources.filter(U=>(0,C.pathIncludedInQuery)(B,U.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(w){const S=[],F=new D.ResourceMap,x={};let V=!1;return w.forEach(M=>{if(M.scheme===P.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(M)){const O=this.b.getWorkspaceFolder(M)?.uri??M.with({path:E.dirname(M.fsPath)});let U=F.get(O);U||(V=!0,U={folder:O,includePattern:{}},S.push(U),F.set(O,U));const $=E.relative(O.fsPath,M.fsPath);(0,T.assertIsDefined)(U.includePattern)[$.replace(/\\/g,"/")]=!0}else M.fsPath&&(V=!0,x[M.fsPath]=!0)}),{folderQueries:S,includePattern:x,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(w,S){if(S.isSmartCase){if(w.isRegExp){if(L.containsUppercaseCharacter(w.pattern,!0))return!0}else if(L.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,I.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const S=j=>E.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),x=(Array.isArray(w)?w:s(w)).map(j=>{const le=this.e.resolvedUserHome;return le?(0,R.untildify)(j,le.scheme===P.Schemas.file?le.fsPath:le.path):j}),V=A.groupBy(x,j=>S(j)?"searchPaths":"exprSegments"),M=(V.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),c(j))),B={},O=this.m(V.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const U=a.flatten(M),$=o(...U);return $&&(B.pattern=$),B}l(w,S){return S.disregardExcludeSettings?void 0:(0,C.getExcludes)(w,!S.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const S=w.flatMap(x=>{let{pathPortion:V,globPortion:M}=i(x);return M&&(M=m(M)),this.n(V).flatMap(O=>this.o(O,M))}),F=new Map;return S.forEach(x=>{const V=x.searchPath.toString(),M=F.get(V);M?x.pattern&&(M.pattern=M.pattern||{},M.pattern[x.pattern]=!0):F.set(V,{searchPath:x.searchPath,pattern:x.pattern?o(x.pattern):void 0})}),Array.from(F.values())}n(w){if(E.isAbsolute(w)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==P.Schemas.file?[{searchPath:S[0].uri.with({path:w})}]:[{searchPath:v.URI.file(E.normalize(w))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(w=r(w),w.startsWith("../")||w===".."){const x=E.posix.resolve(S.path,w);return[{searchPath:S.with({path:x})}]}const F=m(w);return[{searchPath:S,pattern:F}]}else{if(w==="./"||w===".\\")return[];{const S=w.replace(/^\.[\/\\]/,""),x=this.b.getWorkspace().folders.map(V=>{const M=S.match(new RegExp(`^${L.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return M?{match:M,folder:V}:null}).filter(T.isDefined);if(x.length)return x.map(V=>{const M=V.match[1];return{searchPath:V.folder.uri,pattern:M&&m(M)}});{const V=w.match(/\.[\/\\](.+)[\/\\]?/),M=V?V[1]:w,B=y.localize(0,null,M);throw new Error(B)}}}}o(w,S){const F=w.pattern&&S?`${w.pattern}/${S}`:w.pattern||S,x=[{searchPath:w.searchPath,pattern:F}];return F&&!F.endsWith("**")&&x.push({searchPath:w.searchPath,pattern:F+"/**"}),x}q(w,S,F){const x=this.r((0,d.toWorkspaceFolder)(w.searchPath),S,F,!1);return x?{...x,includePattern:w.pattern}:null}r(w,S,F,x){let V;const M=v.URI.isUri(w)?w:w.uri;if(F.searchPaths){const j=F.searchPaths.filter(le=>(0,k.isEqual)(le.searchPath,M))[0];if(j&&!j.pattern)return null;j&&(V=j.pattern)}const B=this.a.getValue({resource:M}),U={...this.l(B,S)||{},...V||{}},$=v.URI.isUri(w)?(0,k.basename)(w):w.name;return{folder:M,folderName:x?$:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!B.search.followSymlinks}}};p=qe([We(0,f.IConfigurationService),We(1,d.IWorkspaceContextService),We(2,g.IEditorGroupsService),We(3,h.ILogService),We(4,b.IPathService)],p),e.QueryBuilder=p;function i(u){const w=u.match(/[\*\{\}\(\)\[\]\?]/);if(w){const S=w.index,F=u.substr(0,S).match(/[/|\\][^/\\]*$/);if(F){let x=u.substr(0,F.index);return x.match(/[/\\]/)||(x+="/"),{pathPortion:x,globPortion:u.substr((F.index||0)+1)}}}return{pathPortion:u}}function o(...u){return u.length?u.reduce((w,S)=>(w[S]=!0,w),Object.create(null)):void 0}function s(u){return l.splitGlobAware(u,",").map(w=>w.trim()).filter(w=>!!w.length)}function c(u){return[`**/${u}/**`,`**/${u}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function r(u){return u.replace(/\\/g,"/")}function m(u){return r(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(u){return u.replace(/([?*[\]])/g,"[$1]")}function t(u,w){u=a.distinct(u,x=>x.toString());const S=[],F=w.getWorkspace();return u&&u.forEach(x=>{let V;if(w.getWorkbenchState()===2)V=(0,k.relativePath)(F.folders[0].uri,x),V&&V!=="."&&(V="./"+V);else{const M=w.getWorkspaceFolder(x);if(M){const B=M.name;if(F.folders.filter(U=>U.name===B).length===1){const U=(0,k.relativePath)(M.uri,x);U===""?V=`./${M.name}`:V=`./${M.name}/${U}`}else V=x.fsPath}}V&&S.push(n(V))}),S}e.resolveResourcesForSearchIncludes=t}),define(ye[296],De([1,0,24,2,21,11,4,295,31,47]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function T(f,h){const d=h.activationEvents;if(!d)return Promise.resolve(void 0);const g=[],b=[];for(const c of d)if(/^workspaceContains:/.test(c)){const r=c.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||f.forceUsingSearch?b.push(r):g.push(r)}if(g.length===0&&b.length===0)return Promise.resolve(void 0);let C;const p=new Promise((c,r)=>{C=c}),i=c=>C({activationEvent:c}),o=Promise.all(g.map(c=>v(f,c,i))).then(()=>{}),s=I(f,h.identifier,b,i);return Promise.all([o,s]).then(()=>{C(void 0)}),p}e.checkActivateWorkspaceContainsExtension=T;async function v(f,h,d){for(const g of f.folders)if(await f.exists(a.joinPath(A.URI.revive(g),h))){d(`workspaceContains:${h}`);return}}async function I(f,h,d,g){if(d.length===0)return Promise.resolve(void 0);const b=new l.CancellationTokenSource,C=f.checkExists(f.folders,d,b.token),p=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},L);let i=!1;try{i=await C}catch(o){R.isCancellationError(o)||R.onUnexpectedError(o)}b.dispose(),clearTimeout(p),i&&g(`workspaceContains:${d.join(",")}`)}function y(f,h,d,g){const b=f.get(D.IInstantiationService),C=f.get(E.ISearchService),i=b.createInstance(P.QueryBuilder).file(h.map(o=>(0,k.toWorkspaceFolder)(A.URI.revive(o))),{_reason:"checkExists",includePattern:d,exists:!0});return C.fileSearch(i,g).then(o=>!!o.limitHit,o=>R.isCancellationError(o)?!1:Promise.reject(o))}e.checkGlobFileExists=y});var _e=this&&this.__classPrivateFieldSet||function(ne,e,a,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!l:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(ne,a):l?l.value=a:e.set(ne,a),a},Be=this&&this.__classPrivateFieldGet||function(ne,e,a,A){if(a==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!A:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?A:a==="a"?A.call(ne):A?A.value:e.get(ne)};define(ye[42],De([1,0,178,10,82,24,19,6,68,2,13,5,35,238,99,34,27,134,11,26,22,220,7,128,4,25,78,20,90,55,41,3,296,98,222,16,97,43]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p,i,o,s,c,r,m,n,t,u,w,S,F,x,V,M,B){"use strict";var O,U,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let j=class Ui extends P.Disposable{constructor(te,X,_,ie,pe,ve,ke,Oe,oe,ae,fe){super(),this.a=this.B(new w.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=_,this.f=ke,this.j=ie,this.k=pe,this.l=ve,this.m=oe,this.p=ae,this.s=fe,this.t=this.g.getProxy(T.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(T.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(T.MainContext.MainThreadExtensionService),this.w=new D.Barrier,this.y=new D.Barrier,this.z=new D.Barrier,this.C=new D.Barrier,this.F=new d.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,h.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new d.ExtensionDescriptionRegistry(q(this.F,ee)),this.G=new y.ExtHostStorage(this.g,this.l),this.H=new F.ExtHostSecretState(this.g),this.I=Oe,this.h=te.createChild(new n.ServiceCollection([y.IExtHostStorage,this.G],[F.IExtHostSecretState,this.H])),this.J=this.B(new I.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(ue,se,N)=>{this.v.$onExtensionActivationError(ue,g.transformErrorForSerialization(se),N)},actualActivateExtension:async(ue,se)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(ue,this.D,this.F))return await this.v.$activateExtension(ue,se),new I.HostExtension;const N=this.D.getExtensionDescription(ue);return this.Y(N,se)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(te){g.onUnexpectedError(te)}}async Q(){this.I.onWillDeactivateAll();let te=[];try{te=this.D.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this.X(pe))}catch{}await Promise.all(te)}terminate(te,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${te}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(ie=>{this.l.error(ie)}),this.g.dispose();const _=this.Q();Promise.race([(0,D.timeout)(5e3),_]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(te){return this.z.isOpen()?this.J.isActivated(te):!1}async getExtension(te){const X=await this.v.$getExtension(te);let _;if(X?.browserNlsBundleUris){_={};for(const ie of Object.keys(X.browserNlsBundleUris))_[ie]=k.URI.revive(X.browserNlsBundleUris[ie])}return X&&{...X,identifier:new b.ExtensionIdentifier(X.identifier.value),extensionLocation:k.URI.revive(X.extensionLocation),browserNlsBundleUris:_}}R(te,X){return this.J.activateByEvent(te,X)}S(te,X){return this.J.activateById(te,X)}activateByIdWithErrors(te,X){return this.S(te,X).then(()=>{const _=this.J.getActivatedExtension(te);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(te=>this.D)}getExtensionExports(te){return this.z.isOpen()?this.J.getActivatedExtension(te).exports:null}async U(te){if(te.scheme!==V.Schemas.file)return te;const X=await this.c.realpath(te.fsPath);return k.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(te=>new Q(te))),this.L}async W(te){const X=E.TernarySearchTree.forUris(_=>R.extUriBiasedIgnorePathCase.ignorePathCasing(_));return await Promise.all(te.map(async _=>{if(this.ob(_)){const ie=await this.U(_.extensionLocation);X.set(ie,_)}})),X}X(te){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(te))return X;const _=this.J.getActivatedExtension(te);if(!_)return X;try{typeof _.module.deactivate=="function"&&(X=Promise.resolve(_.module.deactivate()).then(void 0,ie=>(this.l.error(ie),Promise.resolve(void 0))))}catch(ie){this.l.error(`An error occurred when deactivating the extension '${te.value}':`),this.l.error(ie)}try{(0,P.dispose)(_.subscriptions)}catch(ie){this.l.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.l.error(ie)}return X}async Y(te,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(te.identifier):await this.v.$onWillActivateExtension(te.identifier),this.ab(te,X).then(_=>{const ie=_.activationTimes;return this.v.$onDidActivateExtension(te.identifier,ie.codeLoadingTime,ie.activateCallTime,ie.activateResolvedTime,X),this.Z(te,X,"success",ie),_},_=>{throw this.Z(te,X,"failure"),_})}Z(te,X,_,ie){const pe=le(te,X);this.u.$publicLog2("extensionActivationTimes",{...pe,...ie||{},outcome:_})}ab(te,X){const _=le(te,X);this.u.$publicLog2("activatePlugin",_);const ie=this.ob(te);if(!ie)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${te.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const pe=new I.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(te,(0,R.joinPath)(te.extensionLocation,ie),pe),this.bb(te)]).then(ve=>(l.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ui.cb(this.l,te.identifier,ve[0],ve[1],pe))).then(ve=>(l.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ve))}bb(te){const X=new p.ExtensionGlobalMemento(te,this.G),_=new p.ExtensionMemento(te.identifier.value,!1,this.G),ie=new x.ExtensionSecrets(te,this.H),pe=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ve=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([X.whenReady,_.whenReady,this.I.whenReady]).then(()=>{const ke=this;let Oe,oe;const ae=(0,h.isProposedApiEnabled)(te,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:_,secrets:ie,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(fe){return A.join(te.extensionLocation.fsPath,fe)},get storagePath(){return ke.I.workspaceValue(te)?.fsPath},get globalStoragePath(){return ke.I.globalValue(te).fsPath},get logPath(){return A.join(ke.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return k.URI.joinPath(ke.f.logsLocation,te.identifier.value)},get storageUri(){return ke.I.workspaceValue(te)},get globalStorageUri(){return ke.I.globalValue(te)},get extensionMode(){return pe},get extension(){return Oe===void 0&&(Oe=new J(ke,te.identifier,te,ve,!1)),Oe},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(te,"extensionRuntime"),ke.extensionRuntime},get environmentVariableCollection(){return ke.p.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!oe){if(!ae)return;const fe=w.Event.buffer(w.Event.fromDOMEventEmitter(ae,"message",ee=>ee.data));ae.start(),oe={onDidReceiveMessage:fe,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static cb(te,X,_,ie,pe){return _=_||{activate:void 0,deactivate:void 0},this.db(te,X,_,ie,pe).then(ve=>new I.ActivatedExtension(!1,null,pe.build(),_,ve,ie.subscriptions))}static db(te,X,_,ie,pe){if(typeof _.activate=="function")try{pe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${X.value}`);const ve=typeof global=="object"?global:self,ke=_.activate.apply(ve,[ie]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(ke).then(Oe=>(pe.activateResolveStop(),Oe))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(_)}eb(te,X){this.S(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:X}).then(void 0,_=>{this.l.error(_)})}fb(){this.v.$setPerformanceMarks(l.getMarks());for(const te of this.D.getAllExtensionDescriptions())if(te.activationEvents)for(const X of te.activationEvents)X==="onStartupFinished"&&this.eb(te,X)}gb(){const te=this.R("*",!0).then(void 0,pe=>{this.l.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.hb(pe.added)));const X=this.j.workspace?this.j.workspace.folders:[],_=this.hb(X),ie=Promise.all([te,_]).then(()=>{});return Promise.race([ie,(0,D.timeout)(1e4)]).then(()=>{this.fb()}),ie}hb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(te,X))).then(()=>{})}async ib(te,X){if(this.isActivated(X.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,ie={logService:this.l,folders:te.map(ve=>ve.uri),forceUsingSearch:_,exists:ve=>this.c.exists(ve.fsPath),checkExists:(ve,ke,Oe)=>this.t.$checkExists(ve,ke,Oe)},pe=await(0,S.checkActivateWorkspaceContainsExtension)(ie,X);if(!!pe)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:pe.activationEvent}).then(void 0,ve=>this.l.error(ve))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(te){throw console.error(te),te}}async jb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:X}=this.f.environment;if(!te||!X)throw new Error(a.localize(0,null));const _=await this.pb(null,X,new I.ExtensionActivationTimesBuilder(!1));if(!_||typeof _.run!="function")throw new Error(a.localize(1,null,X.toString()));return new Promise((ie,pe)=>{const ve=(oe,ae)=>{oe?pe(oe):ie(typeof ae=="number"&&ae>0?1:0)},ke=(0,R.originalFSPath)(X),Oe=_.run(ke,ve);Oe&&Oe.then&&Oe.then(()=>{ie(0)}).catch(oe=>{pe(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,X){return this.M[te]=X,(0,P.toDisposable)(()=>{delete this.M[te]})}async lb(te){const X=te.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const _=te.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.M[_]}}async $resolveAuthority(te,X){const _=B.StopWatch.create(!1),ie=()=>`[resolveAuthority(${(0,o.getRemoteAuthorityPrefix)(te)},${X})][${_.elapsed()}ms] `,pe=ae=>this.l.info(`${ie()}${ae}`),ve=(ae,fe=void 0)=>this.l.error(`${ie()}${ae}`,fe);pe("activating resolver...");const{authorityPrefix:ke,resolver:Oe}=await this.lb(te);if(!Oe)return ve("no resolver"),{type:"error",error:{code:o.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ke}.`,detail:void 0}};const oe=new D.IntervalTimer;try{pe("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Oe)),oe.cancelAndSet(()=>pe("waiting..."),1e3),pe("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${ke}`);const ae=await Oe.resolve(te,{resolveAttempt:X});l.mark(`code/extHost/didResolveAuthorityOK/${ke}`),oe.dispose(),pe(`returned ${ae.host}:${ae.port}`);const fe={authority:te,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},ee={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:ee,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(l.mark(`code/extHost/didResolveAuthorityError/${ke}`),oe.dispose(),ve("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(te,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,o.getRemoteAuthorityPrefix)(te)})`);const{resolver:_}=await this.lb(te);if(!_)return null;const ie=k.URI.revive(X);if(typeof _.getCanonicalURI>"u")return ie;const pe=await(0,D.asPromise)(()=>_.getCanonicalURI(ie));return pe||ie}static mb(te,X,_){const ie=new d.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ie.deltaExtensions(_.toAdd,_.toRemove);const pe=(0,h.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(ke=>ke.identifier));for(const ke of _.myToRemove)pe.delete(b.ExtensionIdentifier.toKey(ke));for(const ke of _.myToAdd)pe.add(b.ExtensionIdentifier.toKey(ke));const ve=q(ie,pe);return{globalRegistry:ie,myExtensions:ve}}$startExtensionHost(te){te.toAdd.forEach(ie=>ie.extensionLocation=k.URI.revive(ie.extensionLocation));const{globalRegistry:X,myExtensions:_}=Ui.mb(this.F,this.D,te);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(_),this.kb()}$activateByEvent(te,X){return X===1?this.R(te,!1):this.z.wait().then(_=>this.R(te,!1))}async $activate(te,X){return await this.z.wait(),this.D.getExtensionDescription(te)?(await this.S(te,X),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ve=>ve.extensionLocation=k.URI.revive(ve.extensionLocation));const{globalRegistry:X,myExtensions:_}=Ui.mb(this.F,this.D,te),ie=await this.W(_);return(await this.getExtensionPathIndex()).setSearchTree(ie),this.F.set(X.getAllExtensionDescriptions()),this.D.set(_),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const X=C.VSBuffer.alloc(te),_=Math.random()%256;for(let ie=0;ie<te;ie++)X.writeUInt8(_,ie);return X}async $updateRemoteConnectionData(te){this.P=te,this.a.fire()}};j=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,m.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,c.IExtHostInitDataService),We(7,r.IExtensionStoragePaths),We(8,t.IExtHostTunnelService),We(9,u.IExtHostTerminalService),We(10,M.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function le(Z,te){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class J{constructor(te,X,_,ie,pe){O.set(this,void 0),U.set(this,void 0),$.set(this,void 0),_e(this,O,te,"f"),_e(this,U,X,"f"),_e(this,$,_.identifier,"f"),this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=A.normalize((0,R.originalFSPath)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=ie,this.isFromDifferentExtensionHost=pe}get isActive(){return Be(this,O,"f").isActivated(Be(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,O,"f").getExtensionExports(Be(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,O,"f").activateByIdWithErrors(Be(this,$,"f"),{startup:!1,extensionId:Be(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=J,O=new WeakMap,U=new WeakMap,$=new WeakMap;function q(Z,te){return Z.getAllExtensionDescriptions().filter(X=>te.has(b.ExtensionIdentifier.toKey(X.identifier)))}class Q{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.ExtensionPaths=Q}),define(ye[297],De([1,0,82,2,5,35,27,26,20,25,4,42,36,13,8]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(p,i,o,s,c,r,m){this.c=p,this.d=i,this.e=o,this.f=s,this.g=c,this.h=r,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const p=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new d(this.c,i,this.d,p,this.i)),this.register(this.e.createInstance(g,i)),this.register(this.e.createInstance(h)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(p){if("nodeModuleName"in p)if(Array.isArray(p.nodeModuleName))for(const i of p.nodeModuleName)this.a.set(i,p);else this.a.set(p.nodeModuleName,p);typeof p.alternativeModuleName=="function"&&this.b.push(i=>p.alternativeModuleName(i))}};f=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,T.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,I.ILogService)],f),e.RequireInterceptor=f;let h=class rn{constructor(p){if(p.environment.appRoot&&rn.a.size){const i=(0,y.escapeRegExpCharacters)(this.c(p.environment.appRoot.fsPath)),o="[a-z0-9_.-]",s=`@${o}+\\/${o}+|${o}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${c}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(p){if(!this.b)return;const i=this.b.exec(this.c(p));if(!i)return;const[,o,s,c]=i,r=rn.a.get(s);if(r!==void 0)return console.warn(`${s} as been renamed to ${r}, please update your imports`),o+r+c}c(p){return p.replace(/\\/g,"/")}};h.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=qe([We(0,k.IExtHostInitDataService)],h);class d{constructor(p,i,o,s,c){this.c=p,this.d=i,this.e=o,this.f=s,this.g=c,this.nodeModuleName="vscode",this.a=new Map}load(p,i){const o=this.d.findSubstr(i);if(o){let s=this.a.get(P.ExtensionIdentifier.toKey(o.identifier));return s||(s=this.c(o,this.e,this.f),this.a.set(P.ExtensionIdentifier.toKey(o.identifier),s)),s}if(!this.b){let s="";this.d.forEach((c,r)=>s+=`	${r} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(D.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(p,i,o){this.d=p,this.nodeModuleName="keytar",this.a=i.getProxy(l.MainContext.MainThreadTelemetry);const{environment:s}=o,c=i.getProxy(l.MainContext.MainThreadKeytar);if(s.appRoot){let r=s.appRoot.fsPath;v.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.b=new Set,this.b.add(`${r}/node_modules.asar/keytar`),this.b.add(`${r}/node_modules/keytar`)}this.c={getPassword:(r,m)=>c.$getPassword(r,m),setPassword:(r,m,n)=>c.$setPassword(r,m,n),deletePassword:(r,m)=>c.$deletePassword(r,m),findPassword:r=>c.$findPassword(r),findCredentials(r){return c.$findCredentials(r)}}}load(p,i){const o=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:o?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(p){const i=p.length;if(i<=7||!this.b)return;const o=i-7;if((p.charAt(o)==="/"||p.charAt(o)==="\\")&&p.endsWith("keytar")&&(p=p.replace(/\\/g,"/"),this.b.has(p)))return"keytar"}};g=qe([We(1,E.IExtHostRpcService),We(2,k.IExtHostInitDataService)],g);let b=class{constructor(p,i,o){this.e=p,this.f=i,this.nodeModuleName=["open","opn"],this.d=o.getProxy(l.MainContext.MainThreadTelemetry);const s=o.getProxy(l.MainContext.MainThreadWindow);this.c=(c,r)=>{const m=A.URI.parse(c);return r?this.g(c,r):m.scheme==="http"||m.scheme==="https"?s.$openUri(m,c,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?s.$openUri(m,c,{}):this.g(c,r)}}load(p,i,o){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=o(p),this.c}g(p,i){return this.i(),this.b(p,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([We(2,E.IExtHostRpcService)],b)}),define(ye[49],De([1,0,65,6,10,36,4,59,60,42,7,34,234,35]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class y extends v.AbstractVariableResolverService{constructor(d,g,b,C,p,i,o){function s(){if(b){const c=b.activeEditor();if(c)return c.document.uri;const r=C.tabGroups.all.find(m=>m.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof L.TextDiffTabInput||r.input instanceof L.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof L.TextTabInput||r.input instanceof L.NotebookEditorTabInput||r.input instanceof L.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:c=>{const r=i.folders.filter(m=>m.name===c);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(c,r)=>p.getConfiguration(void 0,c).get(r),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=s();if(c)return l.normalize(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const c=s();if(c){const r=g.getWorkspaceFolder(c);if(r)return l.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(b){const c=b.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(b){const c=b.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>d.getExtension(c)},void 0,o?Promise.resolve(o):void 0,Promise.resolve(R.env))}}let f=class extends A.Disposable{constructor(d,g,b,C,p){super(),this.b=d,this.c=g,this.g=b,this.h=C,this.i=p,this.a=new a.Lazy(async()=>{const i=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.i,i,s,this.j())})}getResolver(){return this.a.value}j(){}};f=qe([We(0,k.IExtHostExtensionService),We(1,T.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,I.IExtHostConfiguration),We(4,E.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[83],De([1,0,19,3,9,2,4,5,60,42,20,7,34,131,227,35,49]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,c,r,m,n,t){this.D=c,this.E=r,this.F=m,this.G=n,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new A.Emitter,this.n=new A.Emitter,this.o=new A.Emitter,this.u=new A.Emitter,this.k=s.getProxy(P.MainContext.MainThreadDebugService),this.z=new A.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(u=>{u.onDidChange(w=>{this.I(u)}),this.I(u)})}asDebugSourceUri(s,c){const r=s;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let m=`debug:${encodeURIComponent(r.path||"")}`,n="?";return c&&(m+=`${n}session=${encodeURIComponent(c.id)}`,n="&"),m+=`${n}ref=${r.sourceReference}`,R.URI.parse(m)}else{if(r.path)return R.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(s){const c=[];for(const r of s.getAllExtensionDescriptions())if(r.contributes){const m=r.contributes.debuggers;if(m&&m.length>0)for(const n of m)(0,y.isDebuggerMainContribution)(n)&&c.push(n.type)}this.k.$registerDebugTypes(c)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const s=[];return this.w.forEach(c=>s.push(c)),s}addBreakpoints(s){this.T();const c=s.filter(n=>{const t=n.id;return this.w.has(t)?!1:(this.w.set(t,n),!0)});this.U(c,[],[]);const r=[],m=new Map;for(const n of c)if(n instanceof T.SourceBreakpoint){let t=m.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},m.set(n.location.uri.toString(),t),r.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof T.FunctionBreakpoint&&r.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(r)}removeBreakpoints(s){this.T();const c=s.filter(t=>this.w.delete(t.id));this.U([],c,[]);const r=c.filter(t=>t instanceof T.SourceBreakpoint).map(t=>t.id),m=c.filter(t=>t instanceof T.FunctionBreakpoint).map(t=>t.id),n=c.filter(t=>t instanceof T.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(r,m,n)}startDebugging(s,c,r){return this.k.$startDebugging(s?s.uri:void 0,c,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,suppressSaveBeforeStart:r.suppressSaveBeforeStart,suppressDebugStatusbar:r.suppressDebugStatusbar??r.debugUI?.simple,suppressDebugToolbar:r.suppressDebugToolbar??r.debugUI?.simple,suppressDebugView:r.suppressDebugView??r.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,c,r){if(!c)return new T.Disposable(()=>{});const m=this.d++;return this.f.push({type:s,handle:m,provider:c}),this.k.$registerDebugConfigurationProvider(s,r,!!c.provideDebugConfigurations,!!c.resolveDebugConfiguration,!!c.resolveDebugConfigurationWithSubstitutedVariables,m),new T.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==c),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(s,c,r){if(!r)return new T.Disposable(()=>{});if(!this.P(s,c))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${c}' debugger.`);if(this.M(c))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:c,handle:m,factory:r}),this.k.$registerDebugAdapterDescriptorFactory(c,m),new T.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==r),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(s,c){if(!c)return new T.Disposable(()=>{});const r=this.i++;return this.j.push({type:s,handle:r,factory:c}),new T.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==c)})}async $runInTerminal(s,c){return Promise.resolve(void 0)}async $substituteVariables(s,c){let r;const m=await this.W(s);return m&&(r={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(r,c)}J(s,c){if(s.type==="implementation")return new p(s.implementation)}K(){}async $startDASession(s,c){const r=this,m=await this.V(c);return this.R(this.M(m.type),m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.L(n),u=this.J(t,m);if(!u)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const w=u;return this.A.set(s,w),this.Q(m).then(S=>(S&&this.B.set(s,S),w.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const x=F,V={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const M=await this.C.sign(x.arguments.value);V.body={signature:M},w.sendResponse(V)}else throw new Error("no signer")}catch(M){V.success=!1,V.message=M.message,w.sendResponse(V)}}else S&&S.onDidSendMessage&&S.onDidSendMessage(F),F=(0,y.convertToVSCPaths)(F,!0),r.k.$acceptDAMessage(s,F)}),w.onError(F=>{S&&S.onError&&S.onError(F),this.k.$acceptDAError(s,F.name,F.message,F.stack)}),w.onExit(F=>{S&&S.onExit&&S.onExit((0,l.withNullAsUndefined)(F),void 0),this.k.$acceptDAExit(s,(0,l.withNullAsUndefined)(F),void 0)}),S&&S.onWillStartSession&&S.onWillStartSession(),w.startSession()))})}$sendDAMessage(s,c){c=(0,y.convertToDAPaths)(c,!1);const r=this.B.get(s);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(c),this.A.get(s)?.sendMessage(c)}$stopDASession(s){const c=this.B.get(s);this.B.delete(s),c&&c.onWillStopSession&&c.onWillStopSession();const r=this.A.get(s);return this.A.delete(s),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const c=[],r=[],m=[];if(s.added)for(const n of s.added){const t=n.id;if(t&&!this.w.has(t)){let u;if(n.type==="function")u=new T.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")u=new T.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const w=R.URI.revive(n.uri);u=new T.SourceBreakpoint(new T.Location(w,new T.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,T.setBreakpointId)(u,t),this.w.set(t,u),c.push(u)}}if(s.removed)for(const n of s.removed){const t=this.w.get(n);t&&(this.w.delete(n),r.push(t))}if(s.changed){for(const n of s.changed)if(n.id){const t=this.w.get(n.id);if(t){if(t instanceof T.FunctionBreakpoint&&n.type==="function"){const u=t;u.enabled=n.enabled,u.condition=n.condition,u.hitCondition=n.hitCondition,u.logMessage=n.logMessage,u.functionName=n.functionName}else if(t instanceof T.SourceBreakpoint&&n.type==="source"){const u=t;u.enabled=n.enabled,u.condition=n.condition,u.hitCondition=n.hitCondition,u.logMessage=n.logMessage,u.location=new T.Location(R.URI.revive(n.uri),new T.Position(n.line,n.character))}m.push(t)}}}this.U(c,r,m)}$provideDebugConfigurations(s,c,r){return(0,a.asPromise)(async()=>{const m=this.O(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(c);return m.provideDebugConfigurations(n,r)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(s,c,r,m){return(0,a.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(c);return n.resolveDebugConfiguration(t,r,m)})}$resolveDebugConfigurationWithSubstitutedVariables(s,c,r,m){return(0,a.asPromise)(async()=>{const n=this.O(s);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(c);return n.resolveDebugConfigurationWithSubstitutedVariables(t,r,m)})}async $provideDebugAdapter(s,c){const r=this.N(s);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(c);return this.R(r,m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(s){const c=await this.V(s);this.m.fire(c)}async $acceptDebugSessionTerminated(s){const c=await this.V(s);c&&(this.n.fire(c),this.l.delete(c.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,c){(await this.V(s))?._acceptNameChanged(c)}async $acceptDebugSessionCustomEvent(s,c){const m={session:await this.V(s),event:c.event,body:c.body};this.u.fire(m)}L(s){if(s instanceof T.DebugAdapterExecutable)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof T.DebugAdapterServer)return{type:"server",port:s.port,host:s.host};if(s instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:s.path};if(s instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}M(s){const c=this.h.filter(r=>r.type===s);if(c.length>0)return c[0].factory}N(s){const c=this.h.filter(r=>r.handle===s);if(c.length>0)return c[0].factory}O(s){const c=this.f.filter(r=>r.handle===s);if(c.length>0)return c[0].provider}P(s,c){if(s.contributes){const r=s.contributes.debuggers;if(r&&r.length>0){for(const m of r)if(m.label&&m.type&&m.type===c)return!0}}return!1}Q(s){const r=s.configuration.type,m=this.j.filter(n=>n.type===r||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(s)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(n=>{const t=n.filter(u=>!!u);if(t.length>0)return new C(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(s,c){const r=c.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new T.DebugAdapterServer(r));if(s){const n=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>s.createDebugAdapterDescriptor(c,this.S(c,n))).then(t=>{if(t)return t})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(c,m))}S(s,c){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(s,c,r){(s.length>0||c.length>0||r.length>0)&&this.z.fire(Object.freeze({added:s,removed:c,changed:r}))}async V(s){if(s)if(typeof s=="string"){const c=this.l.get(s);if(c)return c}else{let c=this.l.get(s.id);if(!c){const r=await this.W(s.folderUri),m=s.parent?this.l.get(s.parent):void 0;c=new g(this.k,s.id,s.type,s.name,r,s.configuration,m),this.l.set(c.id,c),this.k.$sessionCached(c.id)}return c}throw new Error("cannot find session")}W(s){if(s){const c=R.URI.revive(s);return this.D.resolveWorkspaceFolder(c)}return Promise.resolve(void 0)}};d=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,E.IExtHostEditorTabs),We(5,h.IExtHostVariableResolverProvider)],d),e.ExtHostDebugServiceBase=d;class g{constructor(s,c,r,m,n,t,u){this.d=s,this.f=c,this.g=r,this.h=m,this.i=n,this.j=t,this.k=u}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,c){return this.d.$customDebugAdapterRequest(this.f,s,c)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.ExtHostDebugSession=g;class b{constructor(s){this.value=Object.freeze({append(c){s.$appendDebugConsole(c)},appendLine(c){this.append(c+`
`)}})}}e.ExtHostDebugConsole=b;class C{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(c=>c.onWillReceiveMessage?c.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(c=>c.onDidSendMessage?c.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(c=>c.onError?c.onError(s):void 0)}onExit(s,c){this.d.forEach(r=>r.onExit?r.onExit(s,c):void 0)}}class p extends I.AbstractDebugAdapter{constructor(s){super(),this.h=s,s.onDidSendMessage(c=>{this.acceptMessage(c)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends d{constructor(s,c,r,m,n,t){super(s,c,r,m,n,t)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,E.IExtHostEditorTabs),We(5,h.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[298],De([1,0,11,82,2,5,290,13,89,90,25,203,20,56,42,96]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{static async installEarlyHandler(b){const C=b.get(P.ILogService),i=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(o=>{C.error(o);const s=a.transformErrorForSerialization(o);i.$onUnexpectedError(s)})}static async installFullHandler(b){const C=b.get(P.ILogService),p=b.get(v.IExtHostRpcService),i=b.get(y.IExtHostExtensionService),o=b.get(f.IExtHostTelemetry),s=p.getProxy(R.MainContext.MainThreadExtensionService),c=p.getProxy(R.MainContext.MainThreadErrors),r=await i.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(n,t)=>{let u="",w,S;for(const F of t)u+=`
	at ${F.toString()}`,S=F.getFileName(),!w&&S&&(w=r.findSubstr(l.URI.file(S)));return m.set(n,w?.identifier),`${n.name||"Error"}: ${n.message||""}${u}`},a.setUnexpectedErrorHandler(n=>{C.error(n);const t=a.transformErrorForSerialization(n),u=m.get(n);if(!u){c.$onUnexpectedError(t);return}s.$onExtensionRuntimeError(u,t);const w=o.onExtensionError(u,n);C.trace("forwarded error to extension?",w,u)})}}Error.stackTraceLimit=100;class d{constructor(b,C,p,i,o){this.a=p,this.b=new D.RPCProtocol(b,null,i),C=d.e(C,this.b);const s=new k.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());s.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:o}),s.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),s.set(I.IURITransformerService,new I.URITransformerService(i)),s.set(y.IHostUtils,p);const c=new T.InstantiationService(s,!0);c.invokeFunction(h.installEarlyHandler),this.d=c.invokeFunction(r=>r.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",C),this.c=c.invokeFunction(r=>r.get(y.IExtHostExtensionService)),this.c.initialize(),c.invokeFunction(h.installFullHandler)}async asBrowserUri(b){const C=this.b.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await C.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,C){b.allExtensions.forEach(i=>{i.extensionLocation=l.URI.revive(C.transformIncomingURIs(i.extensionLocation));const o={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(s=>o[s]=l.URI.revive(C.transformIncomingURIs(i.browserNlsBundleUris[s]))),i.browserNlsBundleUris=o)}),b.environment.appRoot=l.URI.revive(C.transformIncomingURIs(b.environment.appRoot));const p=b.environment.extensionDevelopmentLocationURI;return p&&(b.environment.extensionDevelopmentLocationURI=p.map(i=>l.URI.revive(C.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=l.URI.revive(C.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=l.URI.revive(C.transformIncomingURIs(b.logsLocation)),b.logFile=l.URI.revive(C.transformIncomingURIs(b.logFile)),b.workspace=C.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=d}),define(ye[299],De([1,0,19,12,185,202,210,83,60,42,20,41,7,49,34,228,230,35]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let g=class extends P.ExtHostDebugServiceBase{constructor(o,s,c,r,m,n,t){super(o,s,c,r,n,t),this.Z=m,this.X=new p}J(o,s){switch(o.type){case"server":return new f.SocketDebugAdapter(o);case"pipeServer":return new f.NamedPipeDebugAdapter(o);case"executable":return new f.ExecutableDebugAdapter(o,s.type)}return super.J(o,s)}S(o,s){const c=f.ExecutableDebugAdapter.platformAdapterExecutable(s.getAllExtensionDescriptions(),o.type);if(c)return new v.DebugAdapterExecutable(c.command,c.args,c.options)}K(){return new D.SignService}async $runInTerminal(o,s){if(o.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const c=await this.F.getConfigProvider(),r=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),n=o.title||l.localize(0,null),t=JSON.stringify({shell:r,shellArgs:m});let u=await this.X.checkout(t,n),w,S=!1;if(u)w=o.cwd;else{const M={shellPath:r,shellArgs:m,cwd:o.cwd,name:n,iconPath:new v.ThemeIcon("debug")};S=!0,u=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(u,t)}u.show(!0);const F=await u.processId;S?await new Promise(M=>setTimeout(M,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?u.sendText("cls"):r.indexOf("bash")>=0?u.sendText("clear"):A.isWindows?u.sendText("cls"):u.sendText("clear"));const x=(0,h.prepareCommand)(r,o.args,!!o.argsCanBeInterpretedByShell,w,o.env);u.sendText(x);const V=this.onDidTerminateDebugSession(M=>{M.id===s&&(this.X.free(u),V.dispose())});return F}else if(o.kind==="external")return C(o,await this.F.getConfigProvider());return super.$runInTerminal(o,s)}};g=qe([We(0,L.IExtHostRpcService),We(1,y.IExtHostWorkspace),We(2,k.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,T.IExtHostTerminalService),We(5,E.IExtHostEditorTabs),We(6,I.IExtHostVariableResolverProvider)],g),e.ExtHostDebugService=g;let b;function C(i,o){if(!b)if(A.isWindows)b=new R.WindowsExternalTerminalService;else if(A.isMacintosh)b=new R.MacExternalTerminalService;else if(A.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const s=o.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},s.external||{})}class p{constructor(){this.b=new Map}async checkout(o,s){const r=[...this.b.entries()].map(([m,n])=>(0,a.createCancelablePromise)(async t=>{if(m.name!==s||n.lastUsedAt!==-1&&await(0,h.hasChildProcesses)(await m.processId))return null;const u=Date.now();return n.lastUsedAt+p.a>u||t.isCancellationRequested||n.config!==o?null:(n.lastUsedAt=u,m)}));return await(0,a.firstParallel)(r,m=>!!m)}insert(o,s){this.b.set(o,{lastUsedAt:Date.now(),config:s})}free(o){const s=this.b.get(o);s&&(s.lastUsedAt=-1)}onTerminalClosed(o){this.b.delete(o)}}p.a=1e3}),define(ye[300],De([1,0,10,2,116,34,59,35,47,41,20,25,81,16,13,76,24,88,49]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(p,i,o,s,c,r,m,n,t){super(p,i,o,s,c,r,m,n),this.B=o,this.C=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(I.Schemas.vscodeRemote,{scheme:I.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(I.Schemas.file,{scheme:I.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(p,i){const o=i;if(!i.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const s=v.TaskHandleDTO.from(o,this.B),c=await this.a.$getTaskExecution(s);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(c,i);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=v.TaskDTO.from(i,p);if(s===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(s.execution)&&await this.x(s,i,!1);const c=await this.y(await this.a.$getTaskExecution(s),i);return this.a.$executeTask(s).catch(()=>{}),c}}u(p,i,o,s){const c=[];if(s)for(const r of s){this.z(r,o),(!r.definition||!p[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(r,o.extension);m&&(c.push(m),v.CustomExecutionDTO.is(m.execution)&&i.push(this.x(m,r,!0)))}return{tasks:c,extension:o.extension}}async v(p){return p}async F(p){let i=p&&p.length>0?p[0]:void 0;if(!i){const o=A.URI.file((0,d.homedir)());i=new E.WorkspaceFolder({uri:o,name:h.basename(o),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(p,i){const o=A.URI.revive(p),s={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(o),r=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),n=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const t of i.variables)s.variables[t]=await m.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(a.delimiter);for(let u=0;u<t.length;u++)t[u]=await m.resolveAsync(n,t[u])}s.process=await l.win32.findExecutable(await m.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await m.resolveAsync(n,i.process.cwd):void 0,t)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(p,i,o){return l.win32.findExecutable(p,i,o)}};b=qe([We(0,L.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,y.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,g.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[301],De([1,0,88,49]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends A.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(ye[143],De([1,0,15,19,21,45,16,10,24,2,31]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class T{constructor(g,b,C,p){this.d=g,this.e=b,this.f=C,this.g=p,this.a=null,this.b=!1,this.c=0}search(g,b){const C=this.d.folderQueries||[],p=new l.CancellationTokenSource;return b.onCancellationRequested(()=>p.cancel()),new Promise((i,o)=>{this.a=new I(g);let s=!1;const c=(r,m)=>{if(!s&&!this.b){const n=this.h(r);f(r)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,s=!0,p.cancel(),r=this.j(r,this.d.maxResults-this.c));const t=this.h(r);this.c+=t,(t>0||!f(r))&&this.a.add(r,m)}};Promise.all(C.map((r,m)=>this.k(r,n=>c(n,m),p.token))).then(r=>{p.dispose(),this.a.flush();const m=r.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||m,messages:(0,a.flatten)(r.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},r=>{p.dispose();const m=(0,R.toErrorMessage)(r);o(new Error(m))})})}h(g){return f(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,b){const C=Array.isArray(g.ranges)?g.ranges:[g.ranges],p=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:C.slice(0,b),preview:{matches:p.slice(0,b),text:g.preview.text},uri:g.uri}}async k(g,b,C){const p=new L.QueryGlobTester(this.d,g),i=[],o={report:r=>{if(!this.l(r))return;const m=g.folder.scheme===D.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(E.dirname(r.uri))):void 0,n=E.relativePath(g.folder,r.uri);if(n){const t=p.includedInQuery(n,P.basename(n),m);(0,A.isThenable)(t)?i.push(t.then(u=>{u&&b(r)})):t&&b(r)}}},s=this.n(g),c=await this.e.provideTextSearchResults(v(this.d.contentPattern),s,o,C);return i.length&&await Promise.all(i),c}l(g){if(f(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const b=(0,L.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),C=(0,L.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),p={folder:k.URI.from(g.folder),excludes:C,includes:b,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return p.usePCRE2=this.d.usePCRE2,p}}e.TextSearchManager=T;function v(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class I{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new h(512,b=>this.g(b))}add(g,b){this.d&&(this.b!==b||!E.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:g.uri,results:[]}),this.d.results.push(y(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=I;function y(d){return f(d)?{preview:{matches:(0,a.mapArrayOrNot)(d.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:d.preview.text},ranges:(0,a.mapArrayOrNot)(d.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function f(d){return!!d.preview}e.extensionResultIsMatch=f;class h{constructor(g,b){this.g=g,this.h=b,this.c=0,this.d=[],this.e=0}addItem(g,b){!g||this.j(g,b)}addItems(g,b){!g||this.k(g,b)}j(g,b){this.d.push(g),this.e+=b,this.l()}k(g,b){this.d=this.d.concat(g),this.e+=b,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}h.a=4e3,h.b=50,e.BatchedCollector=h}),define(ye[84],De([1,0,6,5,4,294,20,56,13,2,143]),function(ne,e,a,A,l,R,D,P,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let T=class{constructor(f,h,d){this.k=f,this.l=h,this.n=d,this.c=this.k.getProxy(A.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,h){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const d=this.d++;return this.e.set(d,h),this.c.$registerTextSearchProvider(d,this.o(f)),(0,a.toDisposable)(()=>{this.g.delete(f),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(f,h){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const d=this.d++;return this.h.set(d,h),this.c.$registerFileSearchProvider(d,this.o(f)),(0,a.toDisposable)(()=>{this.i.delete(f),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(f,h,d,g){const b=v(d),C=this.h.get(f);if(C)return this.j.fileSearch(b,C,p=>{this.c.$handleFileMatch(f,h,p.map(i=>i.resource))},g);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,h,d,g){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const C=v(d);return this.q(C,b).search(i=>this.c.$handleTextMatch(f,h,i),g)}$enableExtensionHostSearch(){}q(f,h){return new L.TextSearchManager(f,h,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};T=qe([We(0,D.IExtHostRpcService),We(1,P.IURITransformerService),We(2,E.ILogService)],T),e.ExtHostSearch=T;function v(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(I),extraFileResources:y.extraFileResources&&y.extraFileResources.map(f=>k.URI.revive(f))}}e.reviveQuery=v;function I(y){return{...y,folder:k.URI.revive(y.folder)}}}),define(ye[302],De([1,0,89,142,34,139,35,40,59,41,81,83,84,99,55,76,141,77,48,98,96,60,140,13,219,49,97]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p,i,o,s,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(r.IExtHostLocalizationService,r.ExtHostLocalizationService,1),(0,a.registerSingleton)(o.ILoggerService,i.ExtHostLoggerService,1),(0,a.registerSingleton)(o.ILogService,s.ExtHostLogService,1),(0,a.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,a.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,a.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(T.IExtHostDebugService,T.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(A.IExtHostOutputService,A.ExtHostOutputService,1),(0,a.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,a.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage,0),(0,a.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(y.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow,0),(0,a.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,a.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,a.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,a.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs,0),(0,a.registerSingleton)(c.IExtHostVariableResolverProvider,c.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,80]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function D(T){return T.startsWith("**")||T.startsWith("/")?T:`/${T}`}e.anchorGlob=D;function P(T,v,I,y){const f=(0,a.mapArrayOrNot)(I,E),h=new l.TextSearchMatch(v,f,y),d=h.preview.matches;return{ranges:(0,a.mapArrayOrNot)(f,k),uri:T,preview:{text:h.preview.text,matches:(0,a.mapArrayOrNot)(d,k)}}}e.createTextSearchResult=P;function E(T){return new l.SearchRange(T.start.line,T.start.character,T.end.line,T.end.character)}function k(T){return new R.Range(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn)}let L=class{constructor(v,I){this.a=v,this.b=I}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,A.ILogService)],L),e.OutputChannel=L}),define(ye[303],De([1,0,46,10,85,33,12,8,100,304]),function(ne,e,a,A,l,R,D,P,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function T(b,C,p,i){const o=v(b,C,p,i),s=C.folder.fsPath;return{cmd:a.spawn(L,o.args,{cwd:s}),rgDiskPath:L,siblingClauses:o.siblingClauses,rgArgs:o,cwd:s}}e.spawnRipgrepCmd=T;function v(b,C,p,i){const o=["--files","--hidden","--case-sensitive"];y([C],p,!1).forEach(c=>{const r=(0,E.anchorGlob)(c);if(o.push("-g",r),D.isMacintosh){const m=(0,l.normalizeNFD)(r);m!==r&&o.push("-g",m)}});const s=I([C],i,void 0,!1);return s.globArgs.forEach(c=>{const r=`!${(0,E.anchorGlob)(c)}`;if(o.push("-g",r),D.isMacintosh){const m=(0,l.normalizeNFD)(r);m!==r&&o.push("-g",m)}}),C.disregardIgnoreFiles!==!1?o.push("--no-ignore"):C.disregardParentIgnoreFiles!==!1&&o.push("--no-ignore-parent"),C.ignoreSymlinks||o.push("--follow"),b.exists&&o.push("--quiet"),o.push("--no-config"),C.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global"),{args:o,siblingClauses:s.siblingClauses}}function I(b,C,p,i=!0){const o=[];let s={};return b.forEach(c=>{const r=Object.assign({},c.excludePattern||{},C||{}),m=f(r,i?c.folder.fsPath:void 0,p);o.push(...m.globArgs),m.siblingClauses&&(s=Object.assign(s,m.siblingClauses))}),{globArgs:o,siblingClauses:s}}function y(b,C,p=!0){const i=[];return b.forEach(o=>{const s=Object.assign({},C||{},o.includePattern||{}),c=f(s,p?o.folder.fsPath:void 0);i.push(...c.globArgs)}),i}function f(b,C,p){const i=[],o={};return Object.keys(b).forEach(s=>{if(p&&p.has(s)||!s)return;const c=b[s];s=d(C?h(C,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof c=="boolean"&&c?(s.startsWith("\\\\")&&(s+="**"),i.push(g(s))):c&&c.when&&(o[s]=c)}),{globArgs:i,siblingClauses:o}}function h(b,C){return A.isAbsolute(C)?C:A.join(b,C)}e.getAbsoluteGlob=h;function d(b){return b=P.rtrim(b,"\\"),P.rtrim(b,"/")}function g(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=g}),define(ye[305],De([1,0,46,70,10,306,15,45,38,85,33,12,43,8,9,29,31,303,111]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(s=>s())});class C{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&E.parse(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,g.prepareQuery)(this.b).normalizedLowercase),this.u=c.excludePattern&&E.parse(c.excludePattern),this.t=new Map,c.folderQueries.forEach(r=>{const m=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),n=r.folder.fsPath;c.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,L.isEqualOrParent)(t,n)&&(m[l.relative(n,t)]=!0)}),this.t.set(n,new i(m,n))})}cancel(){this.l=!0,b.forEach(c=>c())}walk(c,r,m,n,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);r.forEach(u=>{const w=l.basename(u.fsPath);this.u&&this.u(u.fsPath,w)||this.J(m,{relativePath:u.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(c,(u,w)=>{this.x(this.y,this,u,m,n,S=>{if(S){const F=(0,P.toErrorMessage)(S);console.error(F),this.q.push(F),w(S,void 0)}else w(null,void 0)})},(u,w)=>{this.m.stop();const S=u?D.coalesce(u)[0]:null;t(S,this.j)})}w(c,r,m){const n=new Array(c.length),t=new Array(c.length);let u=!1,w=0;if(c.length===0)return m(null,[]);c.forEach((S,F)=>{r(S,(x,V)=>{if(x?(u=!0,n[F]=null,t[F]=x):(n[F]=V,t[F]=null),++w===c.length)return m(u?t:null,n)})})}x(c,r,...m){try{c.apply(r,m)}catch(n){m[m.length-1](n)}}y(c,r,m,n){const t=c.folder.fsPath,u=T.isMacintosh,w=()=>M&&M.kill();b.add(w);let S=$=>{b.delete(w),S=()=>{},n($)},F="";const x=this.D(),V=(0,d.spawnRipgrepCmd)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),M=V.cmd,B=!Object.keys(V.siblingClauses).length,O=V.rgArgs.args.map($=>$.match(/^-/)?$:`'${$}'`).join(" ");let U=`${V.rgDiskPath} ${O}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),m({message:U}),this.s=0,this.z(M,"utf8",m,($,j,le)=>{if($){S($);return}if(this.j){S();return}const q=(F+(u?k.normalizeNFC(j||""):j)).split(`
`);if(le){const Q=q.length;q[Q-1]=q[Q-1].trim(),q[Q-1]||q.pop()}else F=q.pop()||"";if(q.length&&q[0].indexOf(`
`)!==-1){S(new Error("Splitting up files failed"));return}if(this.s+=q.length,B){for(const Q of q)if(this.J(r,{base:t,relativePath:Q,searchPath:this.N(c,Q)}),this.j){w();break}(le||this.j)&&S();return}this.G(c,x,t,q,r),le&&(this.H(x,t,r),S())})}spawnFindCmd(c){const r=this.t.get(c.folder.fsPath),m=r.getBasenameTerms(),n=r.getPathTerms(),t=["-L","."];if(m.length||n.length){t.push("-not","(","(");for(const u of m)t.push("-name",u),t.push("-o");for(const u of n)t.push("-path",u),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),a.spawn("find",t,{cwd:c.folder.fsPath})}readStdout(c,r,m){let n="";this.z(c,r,()=>{},(t,u,w)=>{if(t){m(t);return}n+=u,w&&m(null,n)})}z(c,r,m,n){let t=(S,F,x)=>{(S||x)&&(t=()=>{},this.r?.stop()),n(S,F,x)},u=!1;c.stdout?(this.A(c.stdout,r,t),c.stdout.once("data",()=>u=!0)):m({message:"stdout is null"});let w;c.stderr?w=this.B(c.stderr):m({message:"stderr is null"}),c.on("error",S=>{t(S)}),c.on("close",S=>{let F;!u&&(F=this.C(w,r))&&o(F)?t(new Error(`command failed with error code ${S}: ${this.C(w,r)}`)):(this.g&&S===0&&(this.j=!0),t(null,"",!0))})}A(c,r,m){const n=new R.StringDecoder(r);return c.on("data",t=>{m(null,n.write(t))}),n}B(c){const r=[];return c.on("data",m=>{r.push(m)}),r}C(c,r){const m=new R.StringDecoder(r);return c.map(n=>m.write(n)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:r},m,n,t){n.indexOf(this.b)!==-1&&this.J(t,{base:m,relativePath:this.b,searchPath:this.N(c,this.b)});const u=w=>{const S=l.basename(w),F=l.dirname(w);let x=r[F];x||(x=r[F]=[],u(F)),x.push({base:m,relativePath:w,basename:S,searchPath:this.N(c,w)})};n.forEach(u)}H({rootEntries:c,pathToEntries:r},m,n){const t=this,u=this.t.get(m),w=this.b;function S(F){t.o++;const x=(0,h.hasSiblingFn)(()=>F.map(V=>V.basename));for(let V=0,M=F.length;V<M;V++){const B=F[V],{relativePath:O,basename:U}=B;if(u.test(O,U,w!==U?x:void 0))continue;const $=r[O];if($)S($);else{if(t.p++,O===w)continue;t.J(n,B)}if(t.j)break}}S(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,r,m,n,t){const u=c.folder,w=(0,h.hasSiblingFn)(()=>m);this.w(m,(S,F)=>{if(this.l||this.j)return F(null);const x=r?[r,S].join(l.sep):S;if(this.t.get(c.folder.fsPath).test(x,S,this.a.filePattern!==S?w:void 0))return F(null);const V=[u.fsPath,x].join(l.sep);A.lstat(V,(M,B)=>{if(M||this.l||this.j)return F(null);this.L(V,B,(O,U)=>O||this.l||this.j?F(null):U.isDirectory()?(this.o++,this.M(V,B,($,j)=>$||this.l||this.j||(j=j||"",this.v[j])?F(null):(this.v[j]=!0,f.Promises.readdir(V).then(le=>{if(this.l||this.j)return F(null);this.I(c,x,le,n,J=>F(J||null))},le=>{F(null)})))):(this.p++,x===this.b||this.h&&y.isNumber(U.size)&&U.size>this.h||this.J(n,{base:u.fsPath,relativePath:x,searchPath:this.N(c,x)}),F(null,void 0)))})},S=>{const F=S&&D.coalesce(S);return t(F&&F.length>0?F[0]:void 0)})}J(c,r){this.K(r)&&(!this.d||this.d(r.relativePath,l.basename(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(r))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.isFilePatternMatch)(c,this.c)}return!0}L(c,r,m){return r.isSymbolicLink()?A.stat(c,m):m(null,r)}M(c,r,m){return r.isSymbolicLink()?A.realpath(c,(n,t)=>n?m(n):m(null,t)):m(null,c)}N(c,r){return c.folderName?l.join(c.folderName,r):r}}e.FileWalker=C;class p{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new C(c)}search(c,r,m){this.c.walk(this.a,this.b,c,r,(n,t)=>{m(n,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=p;class i{constructor(c,r){this.expression=c,this.c=r,this.d(c)}d(c){let r,m;Object.keys(c).filter(n=>c[n]).forEach(n=>{l.isAbsolute(n)?(r=r||E.getEmptyExpression(),r[n]=c[n]):(m=m||E.getEmptyExpression(),m[n]=c[n])}),this.a=r&&E.parse(r,{trimForExclusions:!0}),this.b=m&&E.parse(m,{trimForExclusions:!0})}test(c,r,m){return this.b&&this.b(c,r,m)||this.a&&this.a(l.join(this.c,c),r,m)}getBasenameTerms(){const c=[];return this.a&&c.push(...E.getBasenameTerms(this.a)),this.b&&c.push(...E.getBasenameTerms(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...E.getPathTerms(this.a)),this.b&&c.push(...E.getPathTerms(this.b)),c}}function o(s){const c=s.trim().split(`
`),r=c[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return I.uppercaseFirstLetter(c[c.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(ye[307],De([1,0,103,22]),function(ne,e,a,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(s){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(c=>c===s)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,D=512,P=512*8,E=512*128;var k;(function(s){s[s.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(k=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(c,r){super(c),this.decodeStreamErrorKind=r}}e.DecodeStreamError=L;class T{static async create(c){let r;if(c!==e.UTF8)r=(await new Promise((n,t)=>{ne(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(f(c));else{const m=new TextDecoder;r={write(n){return m.decode(n,{stream:!0})},end(){return m.decode()}}}return new T(r)}constructor(c){this.a=c}write(c){return this.a.write(c)}end(){return this.a.end()}}function v(s,c){const r=c.minBytesRequiredForDetection??c.guessEncoding?P:D;return new Promise((m,n)=>{const t=(0,a.newWriteableStream)(V=>V.join("")),u=[];let w=0,S;const F=async()=>{try{const V=await o({buffer:A.VSBuffer.concat(u),bytesRead:w},c.guessEncoding);if(V.seemsBinary&&c.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);V.encoding=await c.overwriteEncoding(V.encoding),S=await T.create(V.encoding);const M=S.write(A.VSBuffer.concat(u).buffer);t.write(M),u.length=0,w=0,m({stream:t,detected:V})}catch(V){x?.dispose(),t.destroy(),n(V)}},x=(0,a.listenStream)(s,{onData:async V=>{S?t.write(S.write(V.buffer)):(u.push(V),w+=V.byteLength,w>=r&&(s.pause(),await F(),setTimeout(()=>s.resume())))},onError:V=>t.error(V),onEnd:async()=>{S||await F(),t.end(S?.end())}})})}e.toDecodeStream=v;async function I(s,c,r){const n=(await new Promise((w,S)=>{ne(["@vscode/iconv-lite-umd"],w,S)})).getEncoder(f(c),r);let t=!1,u=!1;return{read(){if(u)return null;const w=s.read();if(typeof w!="string"){if(u=!0,!t&&r?.addBOM)switch(c){case e.UTF8:case e.UTF8_with_bom:return A.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return A.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const S=n.end();return S&&S.length>0?(t=!0,A.VSBuffer.wrap(S)):null}return t=!0,A.VSBuffer.wrap(n.write(w))}}}e.toEncodeReadable=I;async function y(s){return(await new Promise((r,m)=>{ne(["@vscode/iconv-lite-umd"],r,m)})).encodingExists(f(s))}e.encodingExists=y;function f(s){return s===e.UTF8_with_bom||s===null?e.UTF8:s}e.toNodeEncoding=f;function h(s,c){if(!s||c<e.UTF16be_BOM.length)return null;const r=s.readUInt8(0),m=s.readUInt8(1);if(r===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(c<e.UTF8_BOM.length)return null;const n=s.readUInt8(2);return r===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const d=["ascii","utf-16","utf-32"];async function g(s){const c=await new Promise((u,w)=>{ne(["jschardet"],u,w)}),r=s.slice(0,E),m=p(r.buffer),n=c.detect(m);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=d.indexOf(t)?null:C(n.encoding)}const b={ibm866:"cp866",big5:"cp950"};function C(s){const c=s.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[c]||c}function p(s){let c="";for(let r=0;r<s.length;r++)c+=String.fromCharCode(s[r]);return c}function i(s){switch(s){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const c=s.match(/windows(\d+)/);return c?"windows-"+c[1]:s}}}e.toCanonicalName=i;function o({buffer:s,bytesRead:c},r){let m=h(s,c),n=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&s){let t=!0,u=!0,w=!1;for(let S=0;S<c&&S<R;S++){const F=S%2===1,x=s.readUInt8(S)===0;if(x&&(w=!0),t&&(F&&!x||!F&&x)&&(t=!1),u&&(F&&x||!F&&!x)&&(u=!1),x&&!t&&!u)break}w&&(t?m=e.UTF16le:u?m=e.UTF16be:n=!0)}return r&&!n&&!m&&s?g(s.slice(0,c)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:m}}e.detectEncodingFromBuffer=o,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,307,29,143]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(P,E,k=A,L="searchProcess"){super(P,E,{readdir:T=>k.Promises.readdir(T.fsPath),toCanonicalName:T=>(0,a.toCanonicalName)(T)},L)}}e.NativeTextSearchManager=R}),define(ye[308],De([1,0]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(l){if(l&&this.a.has(l)){const R=this.a.get(l);return this.a.delete(l),R}}addDragOperationTransfer(l,R){this.a.set(l,R)}getRenderedTreeElement(l){if(this.b.has(l))return this.b.get(l)}addRenderedTreeItemElement(l,R){this.b.set(l,R)}removeRenderedTreeItemElement(l){this.b.has(l)&&this.b.delete(l)}}e.TreeviewsService=a}),define(ye[309],De([1,0,183,7,24,2,3,6,225,19,7,9,15,14,21,308,27]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(C,p){if((0,T.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let i;return Array.isArray(C.highlights)&&(i=C.highlights.filter(o=>o.length===2&&typeof o[0]=="number"&&typeof o[1]=="number"),i=i.length?i:void 0),{label:C.label,highlights:i}}}class g{constructor(p,i,o){this.d=p,this.e=i,this.f=o,this.a=new Map,this.b=new f.TreeviewsService;function s(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:c=>s(c)?this.i(c):Array.isArray(c)&&c.length>0?c.map(r=>s(r)?this.i(r):r):c})}registerTreeDataProvider(p,i,o){const s=this.createTreeView(p,{treeDataProvider:i},o);return{dispose:()=>s.dispose()}}createTreeView(p,i,o){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=i.dragAndDropController?.dropMimeTypes??[],c=i.dragAndDropController?.dragMimeTypes??[],r=!!i.dragAndDropController?.handleDrag,m=!!i.dragAndDropController?.handleDrop,n=this.h(p,i,o),t=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:s,dragMimeTypes:c,hasHandleDrag:r,hasHandleDrop:m});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,h.checkProposedApiEnabled)(o,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(u){n.message=u},get title(){return n.title},set title(u){n.title=u},get description(){return n.description},set description(u){n.description=u},get badge(){return n.badge},set badge(u){u!==void 0&&L.ViewBadge.isViewBadge(u)?n.badge={value:Math.floor(Math.abs(u.value)),tooltip:u.tooltip}:u===void 0&&(n.badge=void 0)},reveal:(u,w)=>n.reveal(u,w),dispose:async()=>{await t,this.a.delete(p),n.dispose()}}}$getChildren(p,i){const o=this.a.get(p);return o?o.getChildren(i):Promise.reject(new E.NoTreeViewError(p))}async $handleDrop(p,i,o,s,c,r,m,n){const t=this.a.get(p);if(!t)return Promise.reject(new E.NoTreeViewError(p));const u=I.DataTransfer.toDataTransfer(o,async w=>(await this.d.$resolveDropFileData(p,i,w)).buffer);return m===p&&n&&await this.g(u,t,n,c,r),t.onDrop(u,s,c)}async g(p,i,o,s,c){const r=this.b.removeDragOperationTransfer(c);if(r)(await r)?.forEach((m,n)=>{m&&p.set(n,m)});else if(c&&i.handleDrag){const m=i.handleDrag(o,p,s);this.b.addDragOperationTransfer(c,m),await m}return p}async $handleDrag(p,i,o,s){const c=this.a.get(p);if(!c)return Promise.reject(new E.NoTreeViewError(p));const r=await this.g(new A.DataTransfer,c,i,s,o);if(!!r)return I.DataTransfer.toDataTransferDTO(r)}async $hasResolve(p){const i=this.a.get(p);if(!i)throw new E.NoTreeViewError(p);return i.hasResolve}$resolve(p,i,o){const s=this.a.get(p);if(!s)throw new E.NoTreeViewError(p);return s.resolveTreeItem(i,o)}$setExpanded(p,i,o){const s=this.a.get(p);if(!s)throw new E.NoTreeViewError(p);s.setExpanded(i,o)}$setSelection(p,i){const o=this.a.get(p);if(!o)throw new E.NoTreeViewError(p);o.setSelection(i)}$setFocus(p,i){const o=this.a.get(p);if(!o)throw new E.NoTreeViewError(p);o.setFocus(i)}$setVisible(p,i){const o=this.a.get(p);if(!o)throw new E.NoTreeViewError(p);o.setVisible(i)}$changeCheckboxState(p,i){const o=this.a.get(p);if(!o)throw new E.NoTreeViewError(p);o.setCheckboxState(i)}h(p,i,o){const s=new b(p,i,this.d,this.e.converter,this.f,o);return this.a.set(p,s),s}i(p){const i=this.a.get(p.$treeViewId);return i&&"$treeItemHandle"in p?i.getExtensionElement(p.$treeItemHandle):i&&"$focusedTreeItem"in p&&p.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=g;class b extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,T.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,i,o,s,c,r){if(super(),this.C=p,this.D=o,this.F=s,this.G=c,this.H=r,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new D.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new D.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new D.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new D.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new D.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new D.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new y.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const u of r.contributes.views[t])u.id===p&&(this.J=u.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let m,n;this.B(D.Event.debounce(this.w.event,(t,u)=>(t||(t={message:!1,elements:[]}),u.element!==!1&&(m||(m=new Promise(w=>n=w),this.y=this.y.then(()=>m)),Array.isArray(u.element)?t.elements.push(...u.element):t.elements.push(u.element)),u.message&&(t.message=!0),t),200,!0)(({message:t,elements:u})=>{u.length&&(this.z=this.z.then(()=>{const w=n;return m=null,this.U(u).then(()=>w())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const i=p?this.getExtensionElement(p):void 0;if(p&&!i)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let o=this.Q(p);return o||(o=await this.R(i)),o?o.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,i){i=i||{select:!0,focus:!1};const o=(0,T.isUndefinedOrNull)(i.select)?!0:i.select,s=(0,T.isUndefinedOrNull)(i.focus)?!1:i.focus,c=(0,T.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(r=>this.P(p,r[r.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:r.map(n=>n.item)},{select:o,focus:s,expand:c})),r=>this.G.error(r)):this.D.$reveal(this.C,void 0,{select:o,focus:s,expand:c})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=I.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,i){const o=this.getExtensionElement(p);o&&(i?this.r.fire(Object.freeze({element:o})):this.s.fire(Object.freeze({element:o})))}setSelection(p){(0,v.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const i=(await Promise.all(p.map(async o=>{const s=this.getExtensionElement(o.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(o=>o!==void 0);i.forEach(o=>{o.treeItem.checkboxState=o.newState?L.TreeItemCheckboxState.Checked:L.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(o=>[o.extensionItem,o.newState])})}async handleDrag(p,i,o){const s=[];for(const c of p){const r=this.getExtensionElement(c);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,i,o),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,i,o){const s=i?this.getExtensionElement(i):void 0;if(!(!s&&i||!this.g?.handleDrop))return(0,k.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,o):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,i){if(!this.f.resolveTreeItem)return;const o=this.i.get(p);if(o){const s=this.j.get(o);if(s){const c=await this.f.resolveTreeItem(s.extensionItem,o,i)??s.extensionItem;return this.db(c),s.item.tooltip=this.ab(c.tooltip),s.item.command=this.bb(s.disposableStore,c.command),s.item}}}N(p){return this.O(p).then(i=>i?this.N(i).then(o=>this.P(i,o[o.length-1]).then(s=>(o.push(s),o))):Promise.resolve([]))}O(p){const i=this.j.get(p);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,k.asPromise)(()=>this.f.getParent(p))}P(p,i){const o=this.j.get(p);return o?Promise.resolve(o):(0,k.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,i,!0)).then(s=>this.getChildren(i?i.item.handle:void 0).then(()=>{const c=this.getExtensionElement(s);if(c){const r=this.j.get(c);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let i;if(typeof p=="string"){const o=this.getExtensionElement(p);i=o?this.j.get(o):void 0}else i=p;return i&&i.children||void 0}return this.h}async R(p){this.nb(p);const i=new y.CancellationTokenSource(this.S.token);try{const o=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(i.token.isCancellationRequested)return;const c=await Promise.all((0,v.coalesce)(s||[]).map(async r=>{const m=await this.f.getTreeItem(r);return m&&!i.token.isCancellationRequested?this.Z(r,m,o):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(c)}finally{i.dispose()}}U(p){if(p.some(o=>!o))return this.S.dispose(!0),this.S=new y.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const o=this.W(p);if(o.length)return this.X(o)}return Promise.resolve(void 0)}W(p){const i=new Set,o=p.map(c=>this.j.get(c));for(const c of o)if(c&&!i.has(c.item.handle)){let r=c;for(;r&&r.parent&&o.findIndex(m=>r&&r.parent&&m&&m.item.handle===r.parent.item.handle)===-1;){const m=this.i.get(r.parent.item.handle);r=m?this.j.get(m):void 0}r&&!r.parent&&i.add(c.item.handle)}const s=[];return i.forEach(c=>{const r=this.i.get(c);if(r){const m=this.j.get(r);m&&(!m.parent||!i.has(m.parent.item.handle))&&s.push(c)}}),s}X(p){const i={};return Promise.all(p.map(o=>this.Y(o).then(s=>{s&&(i[o]=s.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(p){const i=this.getExtensionElement(p);if(i){const o=this.j.get(i);if(o)return this.nb(i),(0,k.asPromise)(()=>this.f.getTreeItem(i)).then(s=>{if(s){const c=this.eb(i,s,o.parent);return this.lb(i,c,o,o.parent),o.dispose(),c}return null})}return Promise.resolve(null)}Z(p,i,o){const s=this.eb(p,i,o);if(i.id&&this.i.has(s.item.handle))throw new Error((0,a.localize)(0,null,i.id));return this.kb(p,s),this.mb(s,o),s}ab(p){return L.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}bb(p,i){return i?{...this.F.toInternal(i,p),originalId:i.command}:void 0}cb(p){if(!p.checkboxState)return;let i,o;return typeof p.checkboxState=="number"?i=p.checkboxState:(i=p.checkboxState.state,o=p.checkboxState.tooltip),{isChecked:i===L.TreeItemCheckboxState.Checked,tooltip:o}}db(p){if(!L.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,i,o){this.db(i);const s=new P.DisposableStore,c=this.gb(p,i,o),r=this.hb(i);return{item:{handle:c,parentHandle:o?o.item.handle:void 0,label:d(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(s,i.command),contextValue:i.contextValue,icon:r,iconDark:this.ib(i)||r,themeIcon:this.fb(i),collapsibleState:(0,T.isUndefinedOrNull)(i.collapsibleState)?L.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:o,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof L.ThemeIcon?p.iconPath:void 0}gb(p,{id:i,label:o,resourceUri:s},c,r){if(i)return`${b.b}/${i}`;const m=d(o,this.H),n=c?c.item.handle:b.a;let t=m?m.label:s?(0,l.basename)(s):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const u=this.j.has(p)?this.j.get(p).item.handle:void 0,w=this.Q(c)||[];let S,F=0;do{if(S=`${n}/${F}:${t}`,r||!this.i.has(S)||u===S)break;F++}while(F<=w.length);return S}hb(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof L.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,i){this.i.set(i.item.handle,p),this.j.set(p,i)}lb(p,i,o,s){this.i.delete(i.item.handle),this.j.delete(p),i.item.handle!==o.item.handle&&this.i.delete(o.item.handle),this.kb(p,i);const c=this.Q(s)||[],r=c.filter(m=>m.item.handle===o.item.handle)[0];r&&c.splice(c.indexOf(r),1,i)}mb(p,i){i?(i.children||(i.children=[]),i.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const i=this.j.get(p);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}i.children=void 0}}else this.pb()}ob(p){const i=this.j.get(p);if(i){if(i.children)for(const o of i.children){const s=this.i.get(o.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[310],De([1,0,21,11,3,37,2,121,107,153,164,44,5,95,252,251,40,253,35,255,256,257,240,258,59,42,259,260,263,264,265,142,243,271,272,273,99,41,275,309,14,7,73,278,79,141,34,232,262,72,139,81,83,84,13,56,20,25,266,239,55,76,249,276,78,77,281,279,280,250,48,274,277,98,60,96,267,80,268,16,125,242,221,261,6,27,226,97,217,269,270]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C,p,i,o,s,c,r,m,n,t,u,w,S,F,x,V,M,B,O,U,$,j,le,J,q,Q,Z,te,X,_,ie,pe,ve,ke,Oe,oe,ae,fe,ee,ue,se,N,W,K,Y,he,we,Ae,be,Ce,Te,Ve,xe,et,Qe,nt,st,ht,Ue,rt,ce,z,de,Ie,Le,$e,Ke,Ze,pt,gt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(tt){const ft=tt.get(fe.IExtHostInitDataService),At=tt.get(Te.IExtHostFileSystemInfo),Kt=tt.get(he.IExtHostConsumerFileSystem),Rt=tt.get(c.IExtHostExtensionService),mt=tt.get(Z.IExtHostWorkspace),Tt=tt.get(nt.IExtHostTelemetry),$t=tt.get(g.IExtHostConfiguration),Nt=tt.get(oe.IURITransformerService),Xe=tt.get(ae.IExtHostRpcService),Mt=tt.get(M.IExtHostStorage),Ut=tt.get(Y.IExtensionStoragePaths),Wt=tt.get(Oe.ILoggerService),bt=tt.get(Oe.ILogService),Re=tt.get(se.IExtHostTunnelService),Ne=tt.get(N.IExtHostApiDeprecationService),Se=tt.get(Q.IExtHostWindow),re=tt.get(et.IExtHostSecretState),Fe=tt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,At),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Wt),Xe.set(v.ExtHostContext.ExtHostWorkspace,mt),Xe.set(v.ExtHostContext.ExtHostConfiguration,$t),Xe.set(v.ExtHostContext.ExtHostExtensionService,Rt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Re),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,re),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const He=Xe.set(v.ExtHostContext.ExtHostDecorations,tt.get(ie.IExtHostDecorations)),Ye=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,tt.get(s.IExtHostDocumentsAndEditors)),je=Xe.set(v.ExtHostContext.ExtHostCommands,tt.get(h.IExtHostCommands)),it=Xe.set(v.ExtHostContext.ExtHostTerminalService,tt.get(B.IExtHostTerminalService)),lt=Xe.set(v.ExtHostContext.ExtHostDebugService,tt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,tt.get(ke.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,tt.get(pe.IExtHostTask)),yt=Xe.set(v.ExtHostContext.ExtHostOutputService,tt.get(w.IExtHostOutputService)),kt=Xe.set(v.ExtHostContext.ExtHostLocalization,tt.get(Ze.IExtHostLocalizationService)),Dt=Xe.set(v.ExtHostContext.ExtHostUrls,new J.ExtHostUrls(Xe)),Ct=Xe.set(v.ExtHostContext.ExtHostDocuments,new o.ExtHostDocuments(Xe,Ye)),qt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Xe,Ye,bt)),_t=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,Ct,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),wt=Xe.set(v.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,je,Ye,Ct)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new de.ExtHostNotebookDocuments(wt)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new z.ExtHostNotebookEditors(bt,wt)),Zt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,ft,wt,je,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Ue.ExtHostNotebookRenderers(Xe,wt)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new O.ExtHostEditors(Xe,Ye)),Ht=Xe.set(v.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),je,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,ft.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,At,Ye)),ei=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,Ct,je.converter,Nt)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Nt,Ct,je,ai,bt,Ne,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Xe,ut)),Bt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,bt,Ye)),Qt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(Xe,mt,je)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Xe,je,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new ct.ExtHostQuickDiff(Xe,Nt)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Xe,je,Ct)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new S.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ue.ExtHostTheming(Xe)),ti=Xe.set(v.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new K.ExtHostTimeline(Xe,je)),ii=Xe.set(v.ExtHostContext.ExtHostWebviews,new q.ExtHostWebviews(Xe,ft.remote,mt,bt,Ne)),ni=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ii,mt)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,Ct,Ut,ii,ni)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ii)),ri=Xe.set(v.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,je,Ye)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new xe.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new gt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,wt,Ye,je,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,Ye),Hi=new f.ExtHostClipboard(Xe),ki=new u.ExtHostMessageService(Xe,bt),Ri=new C.ExtHostDialogs(Xe),Li=new V.ExtHostStatusBar(Xe,je.converter);return y.ExtHostApiCommands.register(je),function(ze,jt,Oi){const vt=function(){let ge=!ze.isUnderDevelopment;function Ee(){ge||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,$e.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(ge,Ee,Me){return ti.getSession(ze,ge,Ee,Me)},async hasSession(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"authSession"),!!await ti.getSession(ze,ge,Ee,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ge,Ee,Me,ot){return ti.registerAuthenticationProvider(ge,Ee,Me,ot)}},di={registerCommand(ge,Ee,Me){return je.registerCommand(!0,ge,Ee,Me,void 0,ze)},registerTextEditorCommand(ge,Ee,Me){return je.registerCommand(!0,ge,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+ge+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+ge,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"diffCommand"),je.registerCommand(!0,ge,async(...ot)=>{const It=Ye.activeEditor(!0);if(!It){bt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,ze)),executeCommand(ge,...Ee){return je.executeCommand(ge,...Ee)},getCommands(ge=!1){return je.getCommands(ge)}},Ni={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,$e.checkProposedApiEnabled)(ze,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,$e.checkProposedApiEnabled)(ze,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return nt.ExtHostTelemetryLogger.validateSender(ge),Tt.instantiateLogger(ze,ge)},openExternal(ge,Ee){return Se.openUri(ge,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===ft.environment.appUriScheme)return Dt.createAppUri(ge);try{return await Se.asExternalUri(ge,{allowTunneling:!!ft.remote.authority})}catch(Ee){if((0,ce.matchesScheme)(ge,rt.Schemas.http)||(0,ce.matchesScheme)(ge,rt.Schemas.https))return ge;throw Ee}},get remoteName(){return(0,_.getRemoteName)(ft.remote.authority)},get remoteAuthority(){return(0,$e.checkProposedApiEnabled)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};ft.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(ge,Ee,Me){return ri.createTestController(ze,ge,Ee,Me)},createTestObserver(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.createTestObserver()},runTests(ge){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.runTests(ge)},get onDidChangeTestResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.onResultsChanged},get testResults(){return(0,$e.checkProposedApiEnabled)(ze,"testObserver"),ri.results}},hi=ft.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ge,Ee){(0,$e.isProposedApiEnabled)(ze,"extensionsAny")||(Ee=!1);const Me=jt.mine.getExtensionDescription(ge);if(Me)return new c.Extension(Rt,ze.identifier,Me,hi,!1);if(Ee){const ot=jt.all.getExtensionDescription(ge);if(ot)return new c.Extension(Rt,ze.identifier,ot,hi,!0)}},get all(){const ge=[];for(const Ee of jt.mine.getAllExtensionDescriptions())ge.push(new c.Extension(Rt,ze.identifier,Ee,hi,!1));return ge},get allAcrossExtensionHosts(){(0,$e.checkProposedApiEnabled)(ze,"extensionsAny");const ge=new $e.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of jt.all.getAllExtensionDescriptions()){const ot=!ge.has(Me.identifier);Ee.push(new c.Extension(Rt,ze.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,$e.isProposedApiEnabled)(ze,"extensionsAny")?l.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Ti={createDiagnosticCollection(ge){return ai.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ge=>ai.getDiagnostics(ge),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ge,Ee){return ei.changeLanguage(ge.uri,Ee)},match(ge,Ee){const Me=Ct.getDocumentData(Ee.uri)?.notebook;return(0,L.score)($.LanguageSelector.from(ge),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(ge,Ee,Me){return ut.registerCodeActionProvider(ze,vt(ge),Ee,Me)},registerDocumentPasteEditProvider(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,vt(ge),Ee,Me)},registerCodeLensProvider(ge,Ee){return ut.registerCodeLensProvider(ze,vt(ge),Ee)},registerDefinitionProvider(ge,Ee){return ut.registerDefinitionProvider(ze,vt(ge),Ee)},registerDeclarationProvider(ge,Ee){return ut.registerDeclarationProvider(ze,vt(ge),Ee)},registerImplementationProvider(ge,Ee){return ut.registerImplementationProvider(ze,vt(ge),Ee)},registerTypeDefinitionProvider(ge,Ee){return ut.registerTypeDefinitionProvider(ze,vt(ge),Ee)},registerHoverProvider(ge,Ee){return ut.registerHoverProvider(ze,vt(ge),Ee,ze.identifier)},registerEvaluatableExpressionProvider(ge,Ee){return ut.registerEvaluatableExpressionProvider(ze,vt(ge),Ee,ze.identifier)},registerInlineValuesProvider(ge,Ee){return ut.registerInlineValuesProvider(ze,vt(ge),Ee,ze.identifier)},registerDocumentHighlightProvider(ge,Ee){return ut.registerDocumentHighlightProvider(ze,vt(ge),Ee)},registerLinkedEditingRangeProvider(ge,Ee){return ut.registerLinkedEditingRangeProvider(ze,vt(ge),Ee)},registerReferenceProvider(ge,Ee){return ut.registerReferenceProvider(ze,vt(ge),Ee)},registerRenameProvider(ge,Ee){return ut.registerRenameProvider(ze,vt(ge),Ee)},registerDocumentSymbolProvider(ge,Ee,Me){return ut.registerDocumentSymbolProvider(ze,vt(ge),Ee,Me)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,Ee){return ut.registerDocumentFormattingEditProvider(ze,vt(ge),Ee)},registerDocumentRangeFormattingEditProvider(ge,Ee){return ut.registerDocumentRangeFormattingEditProvider(ze,vt(ge),Ee)},registerOnTypeFormattingEditProvider(ge,Ee,Me,...ot){return ut.registerOnTypeFormattingEditProvider(ze,vt(ge),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerDocumentRangeSemanticTokensProvider(ge,Ee,Me){return ut.registerDocumentRangeSemanticTokensProvider(ze,vt(ge),Ee,Me)},registerSignatureHelpProvider(ge,Ee,Me,...ot){return typeof Me=="object"?ut.registerSignatureHelpProvider(ze,vt(ge),Ee,Me):ut.registerSignatureHelpProvider(ze,vt(ge),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(ge,Ee,...Me){return ut.registerCompletionItemProvider(ze,vt(ge),Ee,Me)},registerInlineCompletionItemProvider(ge,Ee){return Ee.handleDidShowCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,$e.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,vt(ge),Ee)},registerDocumentLinkProvider(ge,Ee){return ut.registerDocumentLinkProvider(ze,vt(ge),Ee)},registerColorProvider(ge,Ee){return ut.registerColorProvider(ze,vt(ge),Ee)},registerFoldingRangeProvider(ge,Ee){return ut.registerFoldingRangeProvider(ze,vt(ge),Ee)},registerSelectionRangeProvider(ge,Ee){return ut.registerSelectionRangeProvider(ze,ge,Ee)},registerCallHierarchyProvider(ge,Ee){return ut.registerCallHierarchyProvider(ze,ge,Ee)},registerTypeHierarchyProvider(ge,Ee){return ut.registerTypeHierarchyProvider(ze,ge,Ee)},setLanguageConfiguration:(ge,Ee)=>ut.setLanguageConfiguration(ze,ge,Ee),getTokenInformationAtPosition(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"tokenInformation"),ei.tokenAtPosition(ge,Ee)},registerInlayHintsProvider(ge,Ee){return ut.registerInlayHintsProvider(ze,ge,Ee)},createLanguageStatusItem(ge,Ee){return ei.createLanguageStatusItem(ze,ge,Ee)},registerDocumentDropEditProvider(ge,Ee){return ut.registerDocumentOnDropEditProvider(ze,ge,Ee)}},xi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(ge,Ee,Me){const ot=await(D.URI.isUri(ge)?Promise.resolve(xt.openTextDocument(ge)):Promise.resolve(ge));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(ge){return Lt.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,Ee,Me){return Lt.onDidChangeActiveTextEditor(ge,Ee,Me)},onDidChangeVisibleTextEditors(ge,Ee,Me){return Lt.onDidChangeVisibleTextEditors(ge,Ee,Me)},onDidChangeTextEditorSelection(ge,Ee,Me){return Lt.onDidChangeTextEditorSelection(ge,Ee,Me)},onDidChangeTextEditorOptions(ge,Ee,Me){return Lt.onDidChangeTextEditorOptions(ge,Ee,Me)},onDidChangeTextEditorVisibleRanges(ge,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(ge,Ee,Me)},onDidChangeTextEditorViewColumn(ge,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(ge,Ee,Me)},onDidCloseTerminal(ge,Ee,Me){return it.onDidCloseTerminal(ge,Ee,Me)},onDidOpenTerminal(ge,Ee,Me){return it.onDidOpenTerminal(ge,Ee,Me)},onDidChangeActiveTerminal(ge,Ee,Me){return it.onDidChangeActiveTerminal(ge,Ee,Me)},onDidChangeTerminalDimensions(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDimensions"),it.onDidChangeTerminalDimensions(ge,Ee,Me)},onDidChangeTerminalState(ge,Ee,Me){return it.onDidChangeTerminalState(ge,Ee,Me)},onDidWriteTerminalData(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),it.onDidWriteTerminalData(ge,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(ge,Ee,Me){return Se.onDidChangeWindowState(ge,Ee,Me)},showInformationMessage(ge,...Ee){return ki.showMessage(ze,R.default.Info,ge,Ee[0],Ee.slice(1))},showWarningMessage(ge,...Ee){return ki.showMessage(ze,R.default.Warning,ge,Ee[0],Ee.slice(1))},showErrorMessage(ge,...Ee){return ki.showMessage(ze,R.default.Error,ge,Ee[0],Ee.slice(1))},showQuickPick(ge,Ee,Me){return Qt.showQuickPick(ge,Ee,Me)},showWorkspaceFolderPick(ge){return Qt.showWorkspaceFolderPick(ge)},showInputBox(ge,Ee){return Qt.showInput(ge,Ee)},showOpenDialog(ge){return Ri.showOpenDialog(ge)},showSaveDialog(ge){return Ri.showSaveDialog(ge)},createStatusBarItem(ge,Ee,Me){let ot,It,Ot;return typeof ge=="string"?(ot=ge,It=Ee,Ot=Me):(It=ge,Ot=Ee),Li.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(ge,Ee){return Li.setStatusBarMessage(ge,Ee)},withScmProgress(ge){return Ne.report("window.withScmProgress",ze,"Use 'withProgress' instead."),li.withProgress(ze,{location:j.ProgressLocation.SourceControl},(Ee,Me)=>ge({report(ot){}}))},withProgress(ge,Ee){return li.withProgress(ze,ge,Ee)},createOutputChannel(ge,Ee){return yt.createOutputChannel(ge,Ee,ze)},createWebviewPanel(ge,Ee,Me,ot){return ni.createWebviewPanel(ze,ge,Ee,Me,ot)},createWebviewTextEditorInset(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"editorInsets"),vi.createWebviewEditorInset(ge,Ee,Me,ot,ze)},createTerminal(ge,Ee,Me){return typeof ge=="object"?"pty"in ge?it.createExtensionTerminal(ge):it.createTerminalFromOptions(ge):it.createTerminal(ge,Ee,Me)},registerTerminalLinkProvider(ge){return it.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,Ee){return it.registerProfileProvider(ze,ge,Ee)},registerTerminalQuickFixProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),it.registerTerminalQuickFixProvider(ge,ze.identifier.value,Ee)},registerTreeDataProvider(ge,Ee){return Ht.registerTreeDataProvider(ge,Ee,ze)},createTreeView(ge,Ee){return Ht.createTreeView(ge,Ee,ze)},registerWebviewPanelSerializer:(ge,Ee)=>ni.registerWebviewPanelSerializer(ze,ge,Ee),registerCustomEditorProvider:(ge,Ee,Me={})=>yi.registerCustomEditorProvider(ze,ge,Ee,Me),registerFileDecorationProvider(ge){return He.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return Dt.registerUriHandler(ze.identifier,ge)},createQuickPick(){return Qt.createQuickPick(ze)},createInputBox(){return Qt.createInputBox(ze)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(ge,Ee,Me){return ui.onDidChangeActiveColorTheme(ge,Ee,Me)},registerWebviewViewProvider(ge,Ee,Me){return Di.registerWebviewViewProvider(ze,ge,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,Ee,Me){return wt.onDidChangeActiveNotebookEditor(ge,Ee,Me)},get visibleNotebookEditors(){return wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,Ee,Me){return oi.onDidChangeNotebookEditorSelection(ge,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(ge,Ee,Me)},showNotebookDocument(ge,Ee){return wt.showNotebookDocument(ge,Ee)},registerExternalUriOpener(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"externalUriOpener"),Ci.registerExternalUriOpener(ze.identifier,ge,Ee,Me)},registerProfileContentHandler(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"profileContentHandlers"),Ii.registrProfileContentHandler(ze,ge,Ee)},registerQuickDiffProvider(ge,Ee,Me,ot){return(0,$e.checkProposedApiEnabled)(ze,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(ge),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},xt={get rootPath(){return Ne.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw A.readonly()},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw A.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw A.readonly()},updateWorkspaceFolders:(ge,Ee,...Me)=>mt.updateWorkspaceFolders(ze,ge,Ee||0,...Me),onDidChangeWorkspaceFolders:function(ge,Ee,Me){return mt.onDidChangeWorkspace(ge,Ee,Me)},asRelativePath:(ge,Ee)=>mt.getRelativePath(ge,Ee),findFiles:(ge,Ee,Me,ot)=>mt.findFiles(ge,Ee,Me,ze.identifier,ot),findTextInFiles:(ge,Ee,Me,ot)=>{(0,$e.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),mt.findTextInFiles(ge,It||{},Ot,ze.identifier,ot)},saveAll:ge=>mt.saveAll(ge),applyEdit(ge,Ee){return Wi.applyWorkspaceEdit(ge,ze,Ee)},createFileSystemWatcher:(ge,Ee,Me,ot)=>Bt.createFileSystemWatcher(mt,ze,ge,Ee,Me,ot),get textDocuments(){return Ct.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw A.readonly()},openTextDocument(ge){let Ee;const Me=ge;if(typeof ge=="string")Ee=Promise.resolve(D.URI.file(ge));else if(D.URI.isUri(ge))Ee=Promise.resolve(ge);else if(!Me||typeof Me=="object")Ee=Ct.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>Ct.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(ge,Ee,Me)=>Ct.onDidAddDocument(ge,Ee,Me),onDidCloseTextDocument:(ge,Ee,Me)=>Ct.onDidRemoveDocument(ge,Ee,Me),onDidChangeTextDocument:(ge,Ee,Me)=>Ct.onDidChangeDocument(ge,Ee,Me),onDidSaveTextDocument:(ge,Ee,Me)=>Ct.onDidSaveDocument(ge,Ee,Me),onWillSaveTextDocument:(ge,Ee,Me)=>_t.getOnWillSaveTextDocumentEvent(ze)(ge,Ee,Me),get notebookDocuments(){return wt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,Ee){let Me;if(D.URI.isUri(ge))Me=ge,await wt.openNotebookDocument(ge);else if(typeof ge=="string")Me=D.URI.revive(await wt.createNotebookDocument({viewType:ge,content:Ee}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(ge,Ee,Me){return si.onDidSaveNotebookDocument(ge,Ee,Me)},onDidChangeNotebookDocument(ge,Ee,Me){return si.onDidChangeNotebookDocument(ge,Ee,Me)},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,Ee,Me,ot){return wt.registerNotebookSerializer(ze,ge,Ee,Me,(0,$e.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ge,Ee,Me)=>Oi.onDidChangeConfiguration(ge,Ee,Me),getConfiguration(ge,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(ge,Ee,ze)},registerTextDocumentContentProvider(ge,Ee){return qt.registerTextDocumentContentProvider(ge,Ee)},registerTaskProvider:(ge,Ee)=>(Ne.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(ze,ge,Ee)),registerFileSystemProvider(ge,Ee,Me){return(0,Le.combinedDisposable)(Bi.registerFileSystemProvider(ze,ge,Ee,Me),Kt.addFileSystemProvider(ge,Ee))},get fs(){return Kt.value},registerFileSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"fileSearchProvider"),Pt.registerFileSearchProvider(ge,Ee)),registerTextSearchProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"textSearchProvider"),Pt.registerTextSearchProvider(ge,Ee)),registerRemoteAuthorityResolver:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver(ge,Ee)),registerResourceLabelFormatter:ge=>((0,$e.checkProposedApiEnabled)(ze,"resolvers"),Si.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,Ee,Me)=>Bt.onDidCreateFile(ge,Ee,Me),onDidDeleteFiles:(ge,Ee,Me)=>Bt.onDidDeleteFile(ge,Ee,Me),onDidRenameFiles:(ge,Ee,Me)=>Bt.onDidRenameFile(ge,Ee,Me),onWillCreateFiles:(ge,Ee,Me)=>Bt.getOnWillCreateFileEvent(ze)(ge,Ee,Me),onWillDeleteFiles:(ge,Ee,Me)=>Bt.getOnWillDeleteFileEvent(ze)(ge,Ee,Me),onWillRenameFiles:(ge,Ee,Me)=>Bt.getOnWillRenameFileEvent(ze)(ge,Ee,Me),openTunnel:ge=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.openTunnel(ze,ge).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.getTunnels()},onDidChangeTunnels:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"tunnels"),Re.onDidChangeTunnels(ge,Ee,Me)),registerPortAttributesProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"portsAttributes"),Re.registerPortsAttributesProvider(ge,Ee)),registerTimelineProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"timeline"),$i.registerTimelineProvider(ge,Ee,ze.identifier,je.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,$e.checkProposedApiEnabled)(ze,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,Ee,Me)=>mt.onDidGrantWorkspaceTrust(ge,Ee,Me),registerEditSessionIdentityProvider:(ge,Ee)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,Ee)),onWillCreateEditSessionIdentity:(ge,Ee,Me)=>((0,$e.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),mt.getOnWillCreateEditSessionIdentityEvent(ze)(ge,Ee,Me))},fi={get inputBox(){return Ne.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(ze)},createSourceControl(ge,Ee,Me){return ci.createSourceControl(ze,ge,Ee,Me)}},Gi={createCommentController(ge,Ee){return Ei.createCommentController(ze,ge,Ee)}},zt={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(ge,Ee,Me){return lt.onDidStartDebugSession(ge,Ee,Me)},onDidTerminateDebugSession(ge,Ee,Me){return lt.onDidTerminateDebugSession(ge,Ee,Me)},onDidChangeActiveDebugSession(ge,Ee,Me){return lt.onDidChangeActiveDebugSession(ge,Ee,Me)},onDidReceiveDebugSessionCustomEvent(ge,Ee,Me){return lt.onDidReceiveDebugSessionCustomEvent(ge,Ee,Me)},onDidChangeBreakpoints(ge,Ee,Me){return lt.onDidChangeBreakpoints(ge,Ee,Me)},registerDebugConfigurationProvider(ge,Ee,Me){return lt.registerDebugConfigurationProvider(ge,Ee,Me||Ke.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,Ee){return lt.registerDebugAdapterDescriptorFactory(ze,ge,Ee)},registerDebugAdapterTrackerFactory(ge,Ee){return lt.registerDebugAdapterTrackerFactory(ge,Ee)},startDebugging(ge,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?lt.startDebugging(ge,Ee,{parentSession:Me}):lt.startDebugging(ge,Ee,Me||{})},stopDebugging(ge){return lt.stopDebugging(ge)},addBreakpoints(ge){return lt.addBreakpoints(ge)},removeBreakpoints(ge){return lt.removeBreakpoints(ge)},asDebugSourceUri(ge,Ee){return lt.asDebugSourceUri(ge,Ee)}},mi={registerTaskProvider:(ge,Ee)=>St.registerTaskProvider(ze,ge,Ee),fetchTasks:ge=>St.fetchTasks(ge),executeTask:ge=>St.executeTask(ze,ge),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ge,Ee,Me)=>St.onDidStartTask(ge,Ee,Me),onDidEndTask:(ge,Ee,Me)=>St.onDidEndTask(ge,Ee,Me),onDidStartTaskProcess:(ge,Ee,Me)=>St.onDidStartTaskProcess(ge,Ee,Me),onDidEndTaskProcess:(ge,Ee,Me)=>St.onDidEndTaskProcess(ge,Ee,Me)},Ki={createNotebookController(ge,Ee,Me,ot,It){return Zt.createNotebookController(ze,ge,Ee,Me,ot,(0,$e.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(ge,Ee)=>wt.registerNotebookCellStatusBarItemProvider(ze,ge,Ee),createRendererMessaging(ge){return bi.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,Ee){return(0,$e.checkProposedApiEnabled)(ze,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(ze,ge,Ee)},onDidChangeNotebookCellExecutionState(ge,Ee,Me){return(0,$e.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ge,Ee,Me)}},Xi={t(...ge){if(typeof ge[0]=="string"){const Ee=ge.shift(),Me=!ge||typeof ge[0]!="object"?ge:ge[0];return kt.getMessage(ze.identifier.value,{message:Ee,args:Me})}return kt.getMessage(ze.identifier.value,ge[0])},get bundle(){return kt.getBundle(ze.identifier.value)},get uri(){return kt.getBundleUri(ze.identifier.value)}};return{version:ft.version,authentication:ji,commands:di,comments:Gi,debug:zt,env:Ni,extensions:qi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:xi,workspace:xt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ke.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:T.FileType,FilePermission:T.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:k.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:I.UIKind,Uri:D.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:le.TelemetryTrustedValue,LogLevel:Oe.LogLevel,EditSessionIdentityMatch:pt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[311],De([1,0,283,320,321,2,322]),function(ne,e,a,A,l,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(T,v,I,y,f,h){const d=h.environment.useHostProxy,g=typeof d=="boolean"?d:!h.remote.isRemote,b=(0,D.createProxyResolver)({resolveProxy:p=>T.resolveProxy(p),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(p,i,...o)=>{switch(p){case D.LogLevel.Trace:y.trace(i,...o);break;case D.LogLevel.Debug:y.debug(i,...o);break;case D.LogLevel.Info:y.info(i,...o);break;case D.LogLevel.Warning:y.warn(i,...o);break;case D.LogLevel.Error:y.error(i,...o);break;case D.LogLevel.Critical:y.error(i,...o);break;case D.LogLevel.Off:break;default:s(p,i,o);break}function s(c,r,...m){y.error("Unknown log level",c),y.error(r,...m)}},getLogLevel:()=>y.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:g,env:process.env}),C=E(v,b);return L(I,C)}e.connectProxyResolver=P;function E(T,v){const I={config:T.getConfiguration("http").get("proxySupport")||"off"};T.onDidChangeConfiguration(f=>{I.config=T.getConfiguration("http").get("proxySupport")||"off"});const y={config:!!T.getConfiguration("http").get("systemCertificates")};return T.onDidChangeConfiguration(f=>{y.config=!!T.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,D.createHttpPatch)(a,v,{config:"off"},y,!0)),on:Object.assign({},a,(0,D.createHttpPatch)(a,v,{config:"on"},y,!0)),override:Object.assign({},a,(0,D.createHttpPatch)(a,v,{config:"override"},y,!0)),onRequest:Object.assign({},a,(0,D.createHttpPatch)(a,v,I,y,!0)),default:Object.assign(a,(0,D.createHttpPatch)(a,v,I,y,!1))},https:{off:Object.assign({},A,(0,D.createHttpPatch)(A,v,{config:"off"},y,!0)),on:Object.assign({},A,(0,D.createHttpPatch)(A,v,{config:"on"},y,!0)),override:Object.assign({},A,(0,D.createHttpPatch)(A,v,{config:"override"},y,!0)),onRequest:Object.assign({},A,(0,D.createHttpPatch)(A,v,I,y,!0)),default:Object.assign(A,(0,D.createHttpPatch)(A,v,I,y,!1))},tls:Object.assign(l,(0,D.createTlsPatch)(l))}}const k=new Map;function L(T,v){return T.getExtensionPathIndex().then(I=>{const y=globalThis._VSCODE_NODE_MODULES.module,f=y._load;y._load=function(d,g,b){if(d==="tls")return v.tls;if(d!=="http"&&d!=="https")return f.apply(this,arguments);const C=v[d],p=I.findSubstr(R.URI.file(g.filename));let i=k.get(p);if(i||k.set(p,i={}),!i[d]){const o=C.default;i[d]={...o}}return i[d]}})}}),define(ye[312],De([1,0,82,310,297,311,42,285,2,16,7,282,115,284]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class y extends l.RequireInterceptor{j(){const d=this,g=globalThis._VSCODE_NODE_MODULES.module,b=g._load;g._load=function(o,s,c){return o=p(o),d.a.has(o)?d.a.get(o).load(o,E.URI.file((0,v.realpathSync)(s.filename)),r=>b.apply(this,[r,s,c])):b.apply(this,arguments)};const C=g._resolveLookupPaths;g._resolveLookupPaths=(i,o)=>C.call(this,p(i),o);const p=i=>{for(const o of d.b){const s=o(i);if(s){i=s;break}}return i}}}class f extends D.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(I.ExtHostConsoleForwarder);const d=this.h.invokeFunction(A.createApiFactoryAndRegisterActors);if(this.h.createInstance(P.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const C=this.h.createInstance(T.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=C.ipcHandlePath}await this.h.createInstance(y,d,{mine:this.D,all:this.F}).install(),a.mark("code/extHost/didInitAPI");const b=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,b,this,this.l,this.u,this.f),a.mark("code/extHost/didInitProxyResolver")}ob(d){return d.main}async pb(d,g,b){if(g.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let C=null;b.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const p=d?.identifier.value;d&&await this.s.initializeLocalizedMessages(d);try{p&&a.mark(`code/extHost/willLoadExtensionCode/${p}`),C=ne.__$__nodeRequire(g.fsPath)}finally{p&&a.mark(`code/extHost/didLoadExtensionCode/${p}`),b.codeLoadingStop()}return C}async $setRemoteEnvironment(d){if(!!this.f.remote.isRemote)for(const g in d){const b=d[g];b===null?delete process.env[g]:process.env[g]=b}}}e.ExtHostExtensionService=f}),define(ye[145],De([1,0,46,323,306,15,61,38,10,8,2,31,80,324,304,100]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const h=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(u){this.a=u}provideTextSearchResults(u,w,S,F){return this.a.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((x,V)=>{F.onCancellationRequested(()=>J());const M=o(u,w),B=w.folder.fsPath,O=M.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${h} ${O}
 - cwd: ${B}`);let U=a.spawn(h,M,{cwd:B});U.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),V((0,T.serializeSearchError)(new T.SearchError(X&&X.message,T.SearchErrorCode.rgProcessError)))});let $=!1;const j=new C(w.maxResults,B,w.previewOptions);j.on("result",X=>{$=!0,Q="",S.report(X)});let le=!1;const J=()=>{le=!0,U?.kill(),j?.cancel()};let q=!1;j.on("hitLimit",()=>{q=!0,J()});let Q="";U.stdout.on("data",X=>{j.handleData(X),$||(Q+=X)});let Z=!1;U.stdout.once("data",()=>Z=!0);let te="";U.stderr.on("data",X=>{const _=X.toString();this.a.appendLine(_),te.length+_.length<1e6&&(te+=_)}),U.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine($?"Got result from parser":"No result from parser"),Q&&this.a.appendLine(`Got data without result: ${Q}`),this.a.appendLine(""),le)x({limitHit:q});else{j.flush(),U=null;let X;te&&!Z&&(X=g(te))?V((0,T.serializeSearchError)(new T.SearchError(X.message,X.code))):x({limitHit:q})}})})}}e.RipgrepTextSearchEngine=d;function g(t){const u=t.split(`
`),w=u[0].trim();if(u.some(F=>F.startsWith("regex parse error")))return new T.SearchError(b(u),T.SearchErrorCode.regexParseError);const S=w.match(/grep config error: unknown encoding: (.*)/);if(S)return new T.SearchError(`Unknown encoding: ${S[1]}`,T.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new T.SearchError(w.charAt(0).toUpperCase()+w.substr(1),T.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new T.SearchError(w.charAt(0).toUpperCase()+w.substr(1),T.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new T.SearchError(w,T.SearchErrorCode.regexParseError)}function b(t){const u=["Regex parse error"],w=t.filter(S=>S.startsWith("PCRE2:"));if(w.length>=1){const S=w[0].replace("PCRE2:","");if(S.indexOf(":")!==-1&&S.split(":").length>=2){const F=S.split(":")[1];u.push(":"+F)}}return u.join("")}class C extends A.EventEmitter{constructor(u,w,S){super(),this.g=u,this.h=w,this.j=S,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(u,w){return super.on(u,w),this}handleData(u){if(this.b)return;const w=typeof u=="string"?u:this.d.write(u);this.k(w)}k(u){let w=u.indexOf(`
`);const S=this.a+u;if(w>=0)w+=this.a.length;else{this.a=S;return}let F=0;for(;w>=0;)this.m(S.substring(F,w).trim()),F=w+1,w=S.indexOf(`
`,F);this.a=S.substring(F)}m(u){if(this.b||!u)return;let w;try{w=JSON.parse(u)}catch{throw new Error(`malformed line from rg: ${u}`)}if(w.type==="match"){const S=p(w.data.path),F=L.URI.file(E.join(this.h,S)),x=this.n(w.data,F);this.p(x),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const S=p(w.data.path),F=L.URI.file(E.join(this.h,S));this.o(w.data,F).forEach(V=>this.p(V))}}n(u,w){const S=u.line_number-1,F=p(u.lines),x=Buffer.from(F);let V=0,M=0,B=S;u.submatches.length===0&&u.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,R.coalesce)(u.submatches.map((U,$)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const j=p(U.match),le=x.slice(V,U.start).toString(),J=i(le),q=J.numLines>0?J.lastLineLength:J.lastLineLength+M,Q=i(j),Z=J.numLines+B,te=Q.numLines+Z,X=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+q;return V=U.end,M=X,B=te,new v.Range(Z,q,te,X)}));return(0,f.createTextSearchResult)(w,F,O,this.j)}o(u,w){const S=p(u.lines),F=u.line_number;return S.replace(/\r?\n$/,"").split(`
`).map((x,V)=>({text:x,uri:w,lineNumber:F+V}))}p(u){this.emit("result",u)}}e.RipgrepParser=C;function p(t){return t.bytes?Buffer.from(t.bytes,"base64").toString():t.text}function i(t){const u=/\n/g;let w=0,S=-1,F;for(;F=u.exec(t);)w++,S=F.index;const x=S>=0?t.length-S-1:t.length;return{numLines:w,lastLineLength:x}}function o(t,u){const w=["--hidden"];w.push(t.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:S,otherIncludes:F}=(0,D.groupBy)(u.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const V=new Set;F.forEach(M=>{V.add(M)}),w.push("-g","!*"),V.forEach(M=>{s(M).map(f.anchorGlob).forEach(B=>{w.push("-g",B)})})}S&&S.length&&S.forEach(V=>{w.push("-g",V)}),u.excludes.map(f.anchorGlob).forEach(V=>w.push("-g",`!${V}`)),u.maxFileSize&&w.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?u.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),u.followSymlinks&&w.push("--follow"),u.encoding&&u.encoding!=="utf8"&&w.push("--encoding",u.encoding),t.pattern==="--"&&(t.isRegExp=!0,t.pattern="\\-\\-"),t.isMultiline&&!t.isRegExp&&(t.pattern=(0,k.escapeRegExpCharacters)(t.pattern),t.isRegExp=!0),u.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),t.isRegExp&&(t.pattern=c(t.pattern),w.push("--engine","auto"));let x;if(t.isWordMatch){const M=(0,k.createRegExp)(t.pattern,!!t.isRegExp,{wholeWord:t.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",M)}else if(t.isRegExp){let V=m(t.pattern);V=n(V),w.push("--regexp",V)}else x=t.pattern,w.push("--fixed-strings");return w.push("--no-config"),u.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),t.isMultiline&&w.push("--multiline"),u.beforeContext&&w.push("--before-context",u.beforeContext+""),u.afterContext&&w.push("--after-context",u.afterContext+""),w.push("--"),x&&w.push(x),w.push("."),w}function s(t){const u=(0,P.splitGlobAware)(t,"/");return u.map((w,S)=>u.slice(0,S+1).join("/"))}function c(t){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;t.match(u);)t=t.replace(u,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;t.match(w);)t=t.replace(w,"$1\\x{$2}");return t}e.unicodeEscapesToPCRE2=c;const r=t=>t.type==="Assertion"&&t.kind==="lookbehind";function m(t){let u;try{u=new I.RegExpParser().parsePattern(t)}catch{return t}let w="",S=0;const F=(M,B,O)=>{w+=t.slice(S,M)+O,S=B},x=[];return new I.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const B=x[0];if(!B)F(M.start,M.end,"\\r?\\n");else if(!x.some(r))if(B.type==="CharacterClass")if(B.negate){const O=t.slice(B.start+2,M.start)+t.slice(M.end,B.end-1);B.parent?.type==="Quantifier"?F(B.start,B.end,O?`[^${O}]`:"."):F(B.start,B.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=t.slice(B.start+1,M.start)+t.slice(M.end,B.end-1);F(B.start,B.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else B.type==="Quantifier"&&F(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){x.unshift(M)},onQuantifierLeave(){x.shift()},onCharacterClassRangeEnter(M){x.unshift(M)},onCharacterClassRangeLeave(){x.shift()},onCharacterClassEnter(M){x.unshift(M)},onCharacterClassLeave(){x.shift()},onAssertionEnter(M){r(M)&&x.push(M)},onAssertionLeave(M){x[0]===M&&x.shift()}}).visit(u),w+=t.slice(S),w}e.fixRegexNewline=m;function n(t){return t.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[313],De([1,0,21,145,126,16]),function(ne,e,a,A,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class D{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,L,T,v){const I=new A.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const y={...L,folder:L.folder.with({scheme:R.Schemas.file})},f=new l.Progress(h=>T.report({...h,uri:h.uri.with({scheme:L.folder.scheme})}));return this.c(v,h=>I.provideTextSearchResults(k,y,f,h))}else return this.c(v,y=>I.provideTextSearchResults(k,L,T,y))}async c(k,L){const T=P(k);this.a.add(T);const v=await L(T.token);return this.a.delete(T),v}d(){this.a.forEach(k=>k.cancel())}}e.RipgrepSearchProvider=D;function P(E){const k=new a.CancellationTokenSource;return E.onCancellationRequested(()=>k.cancel()),k}}),define(ye[314],De([1,0,29,145,144]),function(ne,e,a,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(E){this.a=E}search(E,k,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const T={appendLine(I){L({message:I})}},v=new l.NativeTextSearchManager(this.a,new A.RipgrepTextSearchEngine(T),a);return new Promise((I,y)=>v.search(f=>{k(f.map(D))},E).then(f=>I({limitHit:f.limitHit,type:"success",stats:f.stats}),y))}}e.TextSearchEngineAdapter=R;function D(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((E,k)=>{if(k.ranges){const L=k;return E+(Array.isArray(L.ranges)?L.ranges.length:1)}else return E+1},0)}}}),define(ye[315],De([1,0,15,19,11,3,111,10,43,2,44,31,305,314]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class y{constructor(C="searchProcess"){this.d=C,this.b=Object.create(null)}fileSearch(C){let p;const i=d(C),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(s=>this.doFileSearchWithEngine(v.Engine,i,c=>o.fire(c),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}textSearch(C){let p;const i=d(C),o=new R.Emitter({onDidAddFirstListener:()=>{p=(0,A.createCancelablePromise)(s=>this.f(i,c=>o.fire(c),s)),p.then(s=>o.fire(s),s=>o.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{p.cancel()}});return o.event}f(C,p,i){return C.maxFileSize=(0,L.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new I.TextSearchEngineAdapter(C).search(i,p,p)}doFileSearch(C,p,i){return this.doFileSearchWithEngine(v.Engine,C,p,i)}doFileSearchWithEngine(C,p,i,o,s=y.a){let c=0;const r=n=>{Array.isArray(n)?(c+=n.length,i(n.map(t=>this.g(t)))):n.relativePath?(c++,i(this.g(n))):i(n)};if(p.sortByScore){let n=this.k(p,r,o);if(!n){const t=p.maxResults?Object.assign({},p,{maxResults:null}):p,u=new C(t);n=this.h(u,p,i,r,o)}return new Promise((t,u)=>{n.then(([w,S])=>{const F=S.map(x=>this.g(x));this.n(F,i,s),t(w)},u)})}const m=new C(p);return this.q(m,r,s,o).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}g(C){return{path:C.base?(0,P.join)(C.base,C.relativePath):C.relativePath}}h(C,p,i,o,s){const c=new R.Emitter;let r=(0,A.createCancelablePromise)(n=>{let t=[];const u=w=>{Array.isArray(w)?t=w:(o(w),c.fire(w))};return this.q(C,u,-1,n).then(w=>[w,t])}),m;if(p.cacheKey){m=this.j(p.cacheKey);const n={promise:r,event:c.event,resolved:!1};m.resultsToSearchCache[p.filePattern||""]=n,r.then(()=>{n.resolved=!0},t=>{delete m.resultsToSearchCache[p.filePattern||""]}),r=this.r(r)}return r.then(([n,t])=>{const u=m?m.scorerCache:Object.create(null),w=(typeof p.maxResults!="number"||p.maxResults>0)&&E.StopWatch.create(!1);return this.l(p,t,u,s).then(S=>{const F=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:F,fromCache:!1,type:this.d,workspaceFolderCount:p.folderQueries.length,resultCount:S.length},messages:n.messages,limitHit:n.limitHit||typeof p.maxResults=="number"&&t.length>p.maxResults},S]})})}j(C){const p=this.b[C];return p||(this.b[C]=new f)}k(C,p,i){const o=C.cacheKey&&this.b[C.cacheKey];if(!o)return;const s=this.o(o,C.filePattern||"",p,i);if(s)return s.then(([c,r,m])=>{const n=E.StopWatch.create(!1);return this.l(C,r,o.scorerCache,i).then(t=>{const u=n.elapsed(),w={fromCache:!0,detailStats:m,type:this.d,resultCount:r.length,sortingTime:u};return[{type:"success",limitHit:c.limitHit||typeof C.maxResults=="number"&&r.length>C.maxResults,stats:w},t]})})}l(C,p,i,o){const s=(0,D.prepareQuery)(C.filePattern||""),c=(m,n)=>(0,D.compareItemsByFuzzyScore)(m,n,s,!0,h,i),r=typeof C.maxResults=="number"?C.maxResults:Number.MAX_VALUE;return a.topAsync(p,c,r,1e4,o)}n(C,p,i){if(i&&i>0)for(let o=0;o<C.length;o+=i)p(C.slice(o,o+i));else p(C)}o(C,p,i,o){const s=E.StopWatch.create(!1),c=p.indexOf(P.sep)>=0;let r;for(const u in C.resultsToSearchCache)if(p.startsWith(u)){if(c&&u.indexOf(P.sep)<0&&u!=="")continue;const w=C.resultsToSearchCache[u];r={promise:this.r(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const m=s.elapsed(),n=E.StopWatch.create(!1),t=r.event(i);return o&&o.onCancellationRequested(()=>{t.dispose()}),r.promise.then(([u,w])=>{if(o&&o.isCancellationRequested)throw(0,l.canceled)();const S=[],F=(0,D.prepareQuery)(p).normalizedLowercase;for(const x of w)!(0,T.isFilePatternMatch)(x,F)||S.push(x);return[u,S,{cacheWasResolved:r.resolved,cacheLookupTime:m,cacheFilterTime:n.elapsed(),cacheEntryCount:w.length}]})}q(C,p,i,o){return new Promise((s,c)=>{let r=[];o?.onCancellationRequested(()=>C.cancel()),C.search(m=>{m&&(i?(r.push(m),i>0&&r.length>=i&&(p(r),r=[])):p(m))},m=>{p(m)},(m,n)=>{r.length&&p(r),m?c(m):s(n)})})}clearCache(C){return delete this.b[C],Promise.resolve(void 0)}r(C){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,i){return C.then(p,i)}catch(p){return this.then(void 0,p)}finally(p){return C.finally(p)}}}}y.a=512,e.SearchService=y;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(b){return(0,P.basename)(b.relativePath)}getItemDescription(b){return(0,P.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function d(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(g),extraFileResources:b.extraFileResources&&b.extraFileResources.map(C=>k.URI.revive(C))}}function g(b){return{...b,folder:k.URI.revive(b.folder)}}}),define(ye[316],De([1,0,6,16,2,29,13,25,20,84,56,31,315,313,100,144]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let h=class extends k.ExtHostSearch{constructor(g,b,C,p){super(g,C,p),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new y.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(A.Schemas.vscodeUserData,new I.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const g=new y.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(A.Schemas.file,new I.RipgrepSearchProvider(g)),this.y(A.Schemas.file,new v.SearchService("fileSearchProvider"))}y(g,b){const C=this.d++;return this.v=b,this.t=C,this.c.$registerFileSearchProvider(C,this.o(g)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(C)})}$provideFileSearchResults(g,b,C,p){const i=(0,k.reviveQuery)(C);return g===this.t?this.z(g,b,i,p):super.$provideFileSearchResults(g,b,C,p)}z(g,b,C,p){const i=o=>{if((0,T.isSerializedFileMatch)(o)&&(o=[o]),Array.isArray(o)){this.c.$handleFileMatch(g,b,o.map(s=>l.URI.file(s.path)));return}o.message&&this.n.debug("ExtHostSearch",o.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(C,i,p)}$clearCache(g){return this.v?.clearCache(g),super.$clearCache(g)}q(g,b){return new f.NativeTextSearchManager(g,b,void 0,"textSearchProvider")}};h=qe([We(0,E.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,D.ILogService)],h),e.NativeExtHostSearch=h}),define(ye[317],De([1,0,89,288,300,299,316,312,289,83,42,84,81,41,55,78,287,286,13,301,49]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d,g,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(L.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,a.registerSingleton)(g.ILoggerService,d.ExtHostLoggerService,1),(0,a.registerSingleton)(f.IExtensionStoragePaths,h.ExtensionStoragePaths,0),(0,a.registerSingleton)(k.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(T.IExtHostSearch,D.NativeExtHostSearch,0),(0,a.registerSingleton)(v.IExtHostTask,l.ExtHostTask,0),(0,a.registerSingleton)(I.IExtHostTerminalService,A.ExtHostTerminalService,0),(0,a.registerSingleton)(y.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,a.registerSingleton)(C.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[325],De([1,0,229,326,82,11,118,119,207,95,298,22,29,115,19,121,224,237,302,317]),function(ne,e,a,A,l,R,D,P,E,k,L,T,v,I,y,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const g=A(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const r=globalThis._VSCODE_NODE_MODULES.module,m=r._load;r._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const b=process.exit.bind(process);function C(r){process.exit=function(m){if(r)b(m);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let p=function(r){b()};function i(){const r=(0,d.readExtHostConnection)(process.env);if(r.type===3)return new Promise((m,n)=>{const t=u=>{const w=u[0],S=new D.BufferedEmitter;w.on("message",F=>S.fire(T.VSBuffer.wrap(F.data))),w.on("close",()=>{p("renderer closed the MessagePort")}),w.start(),m({onMessage:S.event,send:F=>w.postMessage(F.buffer)})};process.parentPort.on("message",u=>t(u.ports))});if(r.type===2)return new Promise((m,n)=>{let t=null;const u=setTimeout(()=>{p("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),w=108e5,S=3e5,F=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (1)"),w),x=new y.ProcessTimeRunOnceScheduler(()=>p("renderer disconnected for too long (2)"),S);process.on("message",(M,B)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){B.setNoDelay(!0);const O=T.VSBuffer.wrap(Buffer.from(M.initialDataChunk,"base64"));let U;if(M.skipWebSocketFrames)U=new P.NodeSocket(B,"extHost-socket");else{const $=T.VSBuffer.wrap(Buffer.from(M.inflateBytes,"base64"));U=new P.WebSocketNodeSocket(new P.NodeSocket(B,"extHost-socket"),M.permessageDeflate,$,!1)}t?(F.cancel(),x.cancel(),t.beginAcceptReconnection(U,O),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(u),t=new D.PersistentProtocol({socket:U,initialChunk:O}),t.sendResume(),t.onDidDispose(()=>p("renderer disconnected")),m(t),t.onSocketClose(()=>{F.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(x.isScheduled())return;F.isScheduled()&&x.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const m=r.pipeName;return new Promise((n,t)=>{const u=a.createConnection(m,()=>{u.removeListener("error",t);const w=new D.PersistentProtocol({socket:new P.NodeSocket(u,"extHost-renderer")});w.sendResume(),n(w)});u.once("error",t),u.on("close",()=>{p("renderer closed the socket")})})}}async function o(){const r=await i();return new class{constructor(){this.a=new D.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,r.onMessage(m=>{(0,k.isMessageOfType)(m,2)?(this.b=!0,p("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||r.send(m)}async drain(){if(r.drain)return r.drain()}}}function s(r){return new Promise(m=>{const n=r.onMessage(t=>{n.dispose();const u=JSON.parse(t.toString()),w=u.commit,S=E.default.commit;if(w&&S&&w!==S&&b(55),u.parentPid){let F=0;setInterval(function(){try{process.kill(u.parentPid,0),F=0}catch(V){V&&V.code==="EPERM"?(F++,F>=3&&p(`parent process ${u.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):p(`parent process ${u.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let x;try{x=globalThis._VSCODE_NODE_MODULES["native-watchdog"],x.start(u.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}r.send((0,k.createMessageOfType)(0)),m({protocol:r,initData:u})});r.send((0,k.createMessageOfType)(1))})}async function c(){const r=[];process.on("unhandledRejection",(F,x)=>{r.push(x),setTimeout(()=>{const V=r.indexOf(x);V>=0&&x.catch(M=>{r.splice(V,1),(0,R.isCancellationError)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),F&&(0,R.onUnexpectedError)(F))})},1e3)}),process.on("rejectionHandled",F=>{const x=r.indexOf(F);x>=0&&r.splice(x,1)}),process.on("uncaughtException",function(F){(0,R.isSigPipeError)(F)||(0,R.onUnexpectedError)(F)}),l.mark("code/extHost/willConnectToRenderer");const m=await o();l.mark("code/extHost/didConnectToRenderer");const n=await s(m);l.mark("code/extHost/didWaitForInitData");const{initData:t}=n;C(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=g.useHostProxy!==void 0?g.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(g.skipWorkspaceStorageLock,!1);const u=new class{constructor(){this.pid=process.pid}exit(x){b(x)}exists(x){return v.Promises.exists(x)}realpath(x){return(0,I.realpath)(x)}};let w=null;t.remote.authority&&g.transformURIs&&(w=(0,h.createURITransformer)(t.remote.authority));const S=new L.ExtensionHostMain(n.protocol,t,u,w);p=F=>S.terminate(F)}c().catch(r=>console.log(r))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/18db596fd684939b60ae47f4068d74ffc42ad729/core/vs/workbench/api/node/extensionHostProcess.js.map
