/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/stopwatch","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],ke=function(te){for(var e=[],n=0,C=te.length;n<C;n++)e[n]=Ce[te[n]];return e};define(Ce[62],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(S,R){const y=Object.create(null);for(const T of S){const N=R(T);let w=y[N];w||(w=y[N]=[]),w.push(T)}return y}e.groupBy=n;function C(S,R){const y=[],T=[];for(const N of S)R.has(N)||y.push(N);for(const N of R)S.has(N)||T.push(N);return{removed:y,added:T}}e.diffSets=C;function D(S,R){const y=[],T=[];for(const[N,w]of S)R.has(N)||y.push(w);for(const[N,w]of R)S.has(N)||T.push(w);return{removed:y,added:T}}e.diffMaps=D;class M{constructor(){this.a=new Map}add(R,y){let T=this.a.get(R);T||(T=new Set,this.a.set(R,T)),T.add(y)}delete(R,y){const T=this.a.get(R);!T||(T.delete(y),T.size===0&&this.a.delete(R))}forEach(R,y){const T=this.a.get(R);!T||T.forEach(y)}}e.SetMap=M}),define(Ce[63],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(S){return(R,y,T)=>{let N=null,w=null;if(typeof T.value=="function"?(N="value",w=T.value):typeof T.get=="function"&&(N="get",w=T.get),!w)throw new Error("not supported");T[N]=S(w,y)}}function C(S,R,y){let T=null,N=null;if(typeof y.value=="function"?(T="value",N=y.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",N=y.get),!N)throw new Error("not supported");const w=`$memoize$${R}`;y[T]=function(...h){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,h)}),this[w]}}e.memoize=C;function D(S,R,y){return n((T,N)=>{const w=`$debounce$${N}`,h=`$debounce$result$${N}`;return function(...b){this[h]||(this[h]=y?y():void 0),clearTimeout(this[w]),R&&(this[h]=R(this[h],...b),b=[this[h]]),this[w]=setTimeout(()=>{T.apply(this,b),this[h]=y?y():void 0},S)}})}e.debounce=D;function M(S,R,y){return n((T,N)=>{const w=`$throttle$timer$${N}`,h=`$throttle$result$${N}`,b=`$throttle$lastRun$${N}`,m=`$throttle$pending$${N}`;return function(...a){if(this[h]||(this[h]=y?y():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),R&&(this[h]=R(this[h],...a)),this[m])return;const s=this[b]+S;s<=Date.now()?(this[b]=Date.now(),T.apply(this,[this[h]]),this[h]=y?y():void 0):(this[m]=!0,this[w]=setTimeout(()=>{this[m]=!1,this[b]=Date.now(),T.apply(this,[this[h]]),this[h]=y?y():void 0},s-Date.now()))}})}e.throttle=M}),define(Ce[83],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(D){this.a=D,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Ce[111],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function S(t,d=!1){let r=0;const u=t.length;let i="",p=0,c=16,o=0;function f(B){let P=0,F=0;for(;P<B;){const H=t.charCodeAt(r);if(H>=48&&H<=57)F=F*16+H-48;else if(H>=65&&H<=70)F=F*16+H-65+10;else if(H>=97&&H<=102)F=F*16+H-97+10;else break;r++,P++}return P<B&&(F=-1),F}function k(B){r=B,i="",p=0,c=16,o=0}function A(){const B=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&T(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&T(t.charCodeAt(r)))for(r++;r<t.length&&T(t.charCodeAt(r));)r++;else return o=3,t.substring(B,r);let P=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&T(t.charCodeAt(r))){for(r++;r<t.length&&T(t.charCodeAt(r));)r++;P=r}else o=3;return t.substring(B,P)}function V(){let B="",P=r;for(;;){if(r>=u){B+=t.substring(P,r),o=2;break}const F=t.charCodeAt(r);if(F===34){B+=t.substring(P,r),r++;break}if(F===92){if(B+=t.substring(P,r),r++,r>=u){o=2;break}switch(t.charCodeAt(r++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const j=f(4);j>=0?B+=String.fromCharCode(j):o=4;break}default:o=5}P=r;continue}if(F>=0&&F<=31)if(y(F)){B+=t.substring(P,r),o=2;break}else o=6;r++}return B}function _(){if(i="",o=0,p=r,r>=u)return p=u,c=17;let B=t.charCodeAt(r);if(R(B)){do r++,i+=String.fromCharCode(B),B=t.charCodeAt(r);while(R(B));return c=15}if(y(B))return r++,i+=String.fromCharCode(B),B===13&&t.charCodeAt(r)===10&&(r++,i+=`
`),c=14;switch(B){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,i=V(),c=10;case 47:{const P=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<u&&!y(t.charCodeAt(r));)r++;return i=t.substring(P,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const F=u-1;let H=!1;for(;r<F;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,H=!0;break}r++}return H||(r++,o=1),i=t.substring(P,r),c=13}return i+=String.fromCharCode(B),r++,c=16}case 45:if(i+=String.fromCharCode(B),r++,r===u||!T(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=A(),c=11;default:for(;r<u&&K(B);)r++,B=t.charCodeAt(r);if(p!==r){switch(i=t.substring(p,r),i){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return i+=String.fromCharCode(B),r++,c=16}}function K(B){if(R(B)||y(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let B;do B=_();while(B>=12&&B<=15);return B}return{setPosition:k,getPosition:()=>r,scan:d?O:_,getToken:()=>c,getTokenValue:()=>i,getTokenOffset:()=>p,getTokenLength:()=>r-p,getTokenError:()=>o}}e.createScanner=S;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function T(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function w(t,d){const r=[],u=new Object;let i;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function o(f,k,A,V){p.value=f,p.offset=k,p.length=A,p.type=V,p.colonOffset=void 0,i=p}try{E(t,{onObjectBegin:(f,k)=>{if(d<=f)throw u;i=void 0,c=d>f,r.push("")},onObjectProperty:(f,k,A)=>{if(d<k||(o(f,k,A,"property"),r[r.length-1]=f,d<=k+A))throw u},onObjectEnd:(f,k)=>{if(d<=f)throw u;i=void 0,r.pop()},onArrayBegin:(f,k)=>{if(d<=f)throw u;i=void 0,r.push(0)},onArrayEnd:(f,k)=>{if(d<=f)throw u;i=void 0,r.pop()},onLiteralValue:(f,k,A)=>{if(d<k||(o(f,k,A,v(f)),d<=k+A))throw u},onSeparator:(f,k,A)=>{if(d<=k)throw u;if(f===":"&&i&&i.type==="property")i.colonOffset=k,c=!1,i=void 0;else if(f===","){const V=r[r.length-1];typeof V=="number"?r[r.length-1]=V+1:(c=!0,r[r.length-1]=""),i=void 0}}})}catch(f){if(f!==u)throw f}return{path:r,previousNode:i,isAtPropertyKey:c,matches:f=>{let k=0;for(let A=0;k<f.length&&A<r.length;A++)if(f[k]===r[A]||f[k]==="*")k++;else if(f[k]!=="**")return!1;return k===f.length}}}e.getLocation=w;function h(t,d=[],r=M.DEFAULT){let u=null,i=[];const p=[];function c(f){Array.isArray(i)?i.push(f):u!==null&&(i[u]=f)}return E(t,{onObjectBegin:()=>{const f={};c(f),p.push(i),i=f,u=null},onObjectProperty:f=>{u=f},onObjectEnd:()=>{i=p.pop()},onArrayBegin:()=>{const f=[];c(f),p.push(i),i=f,u=null},onArrayEnd:()=>{i=p.pop()},onLiteralValue:c,onError:(f,k,A)=>{d.push({error:f,offset:k,length:A})}},r),i[0]}e.parse=h;function b(t,d=[],r=M.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(f){u.type==="property"&&(u.length=f-u.offset,u=u.parent)}function p(f){return u.children.push(f),f}E(t,{onObjectBegin:f=>{u=p({type:"object",offset:f,length:-1,parent:u,children:[]})},onObjectProperty:(f,k,A)=>{u=p({type:"property",offset:k,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:f,offset:k,length:A,parent:u})},onObjectEnd:(f,k)=>{u.length=f+k-u.offset,u=u.parent,i(f+k)},onArrayBegin:(f,k)=>{u=p({type:"array",offset:f,length:-1,parent:u,children:[]})},onArrayEnd:(f,k)=>{u.length=f+k-u.offset,u=u.parent,i(f+k)},onLiteralValue:(f,k,A)=>{p({type:v(f),offset:k,length:A,parent:u,value:f}),i(k+A)},onSeparator:(f,k,A)=>{u.type==="property"&&(f===":"?u.colonOffset=k:f===","&&i(k))},onError:(f,k,A)=>{d.push({error:f,offset:k,length:A})}},r);const o=u.children[0];return o&&delete o.parent,o}e.parseTree=b;function m(t,d){if(!t)return;let r=t;for(const u of d)if(typeof u=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let i=!1;for(const p of r.children)if(Array.isArray(p.children)&&p.children[0].value===u){r=p.children[1],i=!0;break}if(!i)return}else{const i=u;if(r.type!=="array"||i<0||!Array.isArray(r.children)||i>=r.children.length)return;r=r.children[i]}return r}e.findNodeAtLocation=m;function a(t){if(!t.parent||!t.parent.children)return[];const d=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;d.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&d.push(r)}return d}e.getNodePath=a;function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const d=Object.create(null);for(const r of t.children){const u=r.children[1];u&&(d[r.children[0].value]=s(u))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=s;function l(t,d,r=!1){return d>=t.offset&&d<t.offset+t.length||r&&d===t.offset+t.length}e.contains=l;function g(t,d,r=!1){if(l(t,d,r)){const u=t.children;if(Array.isArray(u))for(let i=0;i<u.length&&u[i].offset<=d;i++){const p=g(u[i],d,r);if(p)return p}return t}}e.findNodeAtOffset=g;function E(t,d,r=M.DEFAULT){const u=S(t,!1);function i(se){return se?()=>se(u.getTokenOffset(),u.getTokenLength()):()=>!0}function p(se){return se?Y=>se(Y,u.getTokenOffset(),u.getTokenLength()):()=>!0}const c=i(d.onObjectBegin),o=p(d.onObjectProperty),f=i(d.onObjectEnd),k=i(d.onArrayBegin),A=i(d.onArrayEnd),V=p(d.onLiteralValue),_=p(d.onSeparator),K=i(d.onComment),O=p(d.onError),B=r&&r.disallowComments,P=r&&r.allowTrailingComma;function F(){for(;;){const se=u.scan();switch(u.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(se){case 12:case 13:B?H(10):K();break;case 16:H(1);break;case 15:case 14:break;default:return se}}}function H(se,Y=[],G=[]){if(O(se),Y.length+G.length>0){let Z=u.getToken();for(;Z!==17;){if(Y.indexOf(Z)!==-1){F();break}else if(G.indexOf(Z)!==-1)break;Z=F()}}}function j(se){const Y=u.getTokenValue();return se?V(Y):o(Y),F(),!0}function de(){switch(u.getToken()){case 11:{let se=0;try{se=JSON.parse(u.getTokenValue()),typeof se!="number"&&(H(2),se=0)}catch{H(2)}V(se);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return F(),!0}function pe(){return u.getToken()!==10?(H(3,[],[2,5]),!1):(j(!1),u.getToken()===6?(_(":"),F(),ae()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function re(){c(),F();let se=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(se||H(4,[],[]),_(","),F(),u.getToken()===2&&P)break}else se&&H(6,[],[]);pe()||H(4,[],[2,5]),se=!0}return f(),u.getToken()!==2?H(7,[2],[]):F(),!0}function ue(){k(),F();let se=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(se||H(4,[],[]),_(","),F(),u.getToken()===4&&P)break}else se&&H(6,[],[]);ae()||H(4,[],[4,5]),se=!0}return A(),u.getToken()!==4?H(8,[4],[]):F(),!0}function ae(){switch(u.getToken()){case 3:return ue();case 1:return re();case 10:return j(!0);default:return de()}}return F(),u.getToken()===17?r.allowEmptyContent?!0:(H(4,[],[]),!1):ae()?(u.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=E;function L(t,d){const r=S(t),u=[];let i,p=0,c;do switch(c=r.getPosition(),i=r.scan(),i){case 12:case 13:case 17:p!==c&&u.push(t.substring(p,c)),d!==void 0&&u.push(r.getTokenValue().replace(/[^\r\n]/g,d)),p=r.getPosition();break}while(i!==17);return u.join("")}e.stripComments=L;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Ce[28],ke([1,0]),function(te,e){"use strict";var n,C,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,a,s){let l=m.get(a);return l===void 0&&(l=s,m.set(a,l)),l}e.getOrSet=M;function S(m){const a=[];return m.forEach((s,l)=>{a.push(`${l} => ${s}`)}),`Map(${m.size}) {${a.join(", ")}}`}e.mapToString=S;function R(m){const a=[];return m.forEach(s=>{a.push(s)}),`Set(${m.size}) {${a.join(", ")}}`}e.setToString=R;class y{constructor(a,s){this.uri=a,this.value=s}}class T{constructor(a,s){this[n]="ResourceMap",a instanceof T?(this.b=new Map(a.b),this.c=s??T.a):(this.b=new Map,this.c=a??T.a)}set(a,s){return this.b.set(this.c(a),new y(a,s)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,s){typeof s<"u"&&(a=a.bind(s));for(const[l,g]of this.b)a(g.value,g.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}T.a=m=>m.toString(),e.ResourceMap=T;class N{constructor(a,s){this[C]="ResourceSet",!a||typeof a=="function"?this.a=new T(a):(this.a=new T(s),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,s){this.a.forEach((l,g)=>a.call(s,g,g,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=N;var w;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class h{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,s=0){const l=this.a.get(a);if(!!l)return s!==0&&this.j(l,s),l.value}set(a,s,l=0){let g=this.a.get(a);if(g)g.value=s,l!==0&&this.j(g,l);else{switch(g={key:a,value:s,next:void 0,previous:void 0},l){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(a,g),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const s=this.a.get(a);if(!!s)return this.a.delete(a),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,s){const l=this.e;let g=this.b;for(;g;){if(s?a.bind(s)(g.value,g.key,this):a(g.value,g.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.key,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}values(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:l.value,done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}entries(){const a=this,s=this.e;let l=this.b;const g={[Symbol.iterator](){return g},next(){if(a.e!==s)throw new Error("LinkedMap got modified during iteration.");if(l){const E={value:[l.key,l.value],done:!1};return l=l.next,E}else return{value:void 0,done:!0}}};return g}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let s=this.b,l=this.size;for(;s&&l>a;)this.a.delete(s.key),s=s.next,l--;this.b=s,this.d=l,s&&(s.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const s=a.next,l=a.previous;if(!s||!l)throw new Error("Invalid list");s.previous=l,l.next=s}a.next=void 0,a.previous=void 0,this.e++}j(a,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(a===this.b)return;const l=a.next,g=a.previous;a===this.c?(g.next=void 0,this.c=g):(l.previous=g,g.next=l),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(s===2){if(a===this.c)return;const l=a.next,g=a.previous;a===this.b?(l.previous=void 0,this.b=l):(l.previous=g,g.next=l),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((s,l)=>{a.push([l,s])}),a}fromJSON(a){this.clear();for(const[s,l]of a)this.set(s,l)}}e.LinkedMap=h;class b extends h{constructor(a,s=1){super(),this.k=a,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,s=2){return super.get(a,s)}peek(a){return super.get(a,0)}set(a,s){return super.set(a,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=b}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[112],ke([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Pe,Se){for(var Ie=0;Ie<Se.length;Ie++){var oe=Se[Ie];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(Pe,oe.key,oe)}}function n(Pe,Se,Ie){return Se&&e(Pe.prototype,Se),Ie&&e(Pe,Ie),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function C(Pe,Se){if(!!Pe){if(typeof Pe=="string")return D(Pe,Se);var Ie=Object.prototype.toString.call(Pe).slice(8,-1);if(Ie==="Object"&&Pe.constructor&&(Ie=Pe.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Pe);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return D(Pe,Se)}}function D(Pe,Se){(Se==null||Se>Pe.length)&&(Se=Pe.length);for(var Ie=0,oe=new Array(Se);Ie<Se;Ie++)oe[Ie]=Pe[Ie];return oe}function M(Pe,Se){var Ie=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(Ie)return(Ie=Ie.call(Pe)).next.bind(Ie);if(Array.isArray(Pe)||(Ie=C(Pe))||Se&&Pe&&typeof Pe.length=="number"){Ie&&(Pe=Ie);var oe=0;return function(){return oe>=Pe.length?{done:!0}:{done:!1,value:Pe[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=S();function R(Pe){te.defaults=Pe}var y=/[&<>"']/,T=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(Se){return h[Se]};function m(Pe,Se){if(Se){if(y.test(Pe))return Pe.replace(T,b)}else if(N.test(Pe))return Pe.replace(w,b);return Pe}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Pe){return Pe.replace(a,function(Se,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var l=/(^|[^\[])\^/g;function g(Pe,Se){Pe=typeof Pe=="string"?Pe:Pe.source,Se=Se||"";var Ie={replace:function(le,J){return J=J.source||J,J=J.replace(l,"$1"),Pe=Pe.replace(le,J),Ie},getRegex:function(){return new RegExp(Pe,Se)}};return Ie}var E=/[^\w:]/g,L=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Pe,Se,Ie){if(Pe){var oe;try{oe=decodeURIComponent(s(Ie)).replace(E,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}Se&&!L.test(Ie)&&(Ie=i(Se,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var t={},d=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Pe,Se){t[" "+Pe]||(d.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=f(Pe,"/",!0)),Pe=t[" "+Pe];var Ie=Pe.indexOf(":")===-1;return Se.substring(0,2)==="//"?Ie?Se:Pe.replace(r,"$1")+Se:Se.charAt(0)==="/"?Ie?Se:Pe.replace(u,"$1")+Se:Pe+Se}var p={exec:function(){}};function c(Pe){for(var Se=1,Ie,oe;Se<arguments.length;Se++){Ie=arguments[Se];for(oe in Ie)Object.prototype.hasOwnProperty.call(Ie,oe)&&(Pe[oe]=Ie[oe])}return Pe}function o(Pe,Se){var Ie=Pe.replace(/\|/g,function(J,I,$){for(var W=!1,q=I;--q>=0&&$[q]==="\\";)W=!W;return W?"|":" |"}),oe=Ie.split(/ \|/),le=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>Se)oe.splice(Se);else for(;oe.length<Se;)oe.push("");for(;le<oe.length;le++)oe[le]=oe[le].trim().replace(/\\\|/g,"|");return oe}function f(Pe,Se,Ie){var oe=Pe.length;if(oe===0)return"";for(var le=0;le<oe;){var J=Pe.charAt(oe-le-1);if(J===Se&&!Ie)le++;else if(J!==Se&&Ie)le++;else break}return Pe.slice(0,oe-le)}function k(Pe,Se){if(Pe.indexOf(Se[1])===-1)return-1;for(var Ie=Pe.length,oe=0,le=0;le<Ie;le++)if(Pe[le]==="\\")le++;else if(Pe[le]===Se[0])oe++;else if(Pe[le]===Se[1]&&(oe--,oe<0))return le;return-1}function A(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(Pe,Se){if(Se<1)return"";for(var Ie="";Se>1;)Se&1&&(Ie+=Pe),Se>>=1,Pe+=Pe;return Ie+Pe}function _(Pe,Se,Ie,oe){var le=Se.href,J=Se.title?m(Se.title):null,I=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){oe.state.inLink=!0;var $={type:"link",raw:Ie,href:le,title:J,text:I,tokens:oe.inlineTokens(I)};return oe.state.inLink=!1,$}return{type:"image",raw:Ie,href:le,title:J,text:m(I)}}function K(Pe,Se){var Ie=Pe.match(/^(\s+)(?:```)/);if(Ie===null)return Se;var oe=Ie[1];return Se.split(`
`).map(function(le){var J=le.match(/^\s+/);if(J===null)return le;var I=J[0];return I.length>=oe.length?le.slice(oe.length):le}).join(`
`)}var O=function(){function Pe(Ie){this.options=Ie||te.defaults}var Se=Pe.prototype;return Se.space=function(oe){var le=this.rules.block.newline.exec(oe);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Se.code=function(oe){var le=this.rules.block.code.exec(oe);if(le){var J=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?J:f(J,`
`)}}},Se.fences=function(oe){var le=this.rules.block.fences.exec(oe);if(le){var J=le[0],I=K(J,le[3]||"");return{type:"code",raw:J,lang:le[2]?le[2].trim():le[2],text:I}}},Se.heading=function(oe){var le=this.rules.block.heading.exec(oe);if(le){var J=le[2].trim();if(/#$/.test(J)){var I=f(J,"#");(this.options.pedantic||!I||/ $/.test(I))&&(J=I.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:J,tokens:this.lexer.inline(J)}}},Se.hr=function(oe){var le=this.rules.block.hr.exec(oe);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(oe){var le=this.rules.block.blockquote.exec(oe);if(le){var J=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},Se.list=function(oe){var le=this.rules.block.list.exec(oe);if(le){var J,I,$,W,q,ee,me,ye,ce,be,Ee,We,Ve=le[1].trim(),tt=Ve.length>1,Xe={type:"list",raw:"",ordered:tt,start:tt?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=tt?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=tt?Ve:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(We=!1,!(!(le=et.exec(oe))||this.rules.block.hr.test(oe)));){if(J=le[0],oe=oe.substring(J.length),ye=le[2].split(`
`,1)[0],ce=oe.split(`
`,1)[0],this.options.pedantic?(W=2,Ee=ye.trimLeft()):(W=le[2].search(/[^ ]/),W=W>4?1:W,Ee=ye.slice(W),W+=le[1].length),ee=!1,!ye&&/^ *$/.test(ce)&&(J+=ce+`
`,oe=oe.substring(ce.length+1),We=!0),!We)for(var it=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),dt=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");oe&&(be=oe.split(`
`,1)[0],ye=be,this.options.pedantic&&(ye=ye.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(ye)||ot.test(ye)||it.test(ye)||dt.test(oe)));){if(ye.search(/[^ ]/)>=W||!ye.trim())Ee+=`
`+ye.slice(W);else if(!ee)Ee+=`
`+ye;else break;!ee&&!ye.trim()&&(ee=!0),J+=be+`
`,oe=oe.substring(be.length+1)}Xe.loose||(me?Xe.loose=!0:/\n *\n *$/.test(J)&&(me=!0)),this.options.gfm&&(I=/^\[[ xX]\] /.exec(Ee),I&&($=I[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:J,task:!!I,checked:$,loose:!1,text:Ee}),Xe.raw+=J}Xe.items[Xe.items.length-1].raw=J.trimRight(),Xe.items[Xe.items.length-1].text=Ee.trimRight(),Xe.raw=Xe.raw.trimRight();var Q=Xe.items.length;for(q=0;q<Q;q++){this.lexer.state.top=!1,Xe.items[q].tokens=this.lexer.blockTokens(Xe.items[q].text,[]);var X=Xe.items[q].tokens.filter(function(Me){return Me.type==="space"}),ve=X.every(function(Me){for(var ze=Me.raw.split(""),He=0,Ye=M(ze),nt;!(nt=Ye()).done;){var vt=nt.value;if(vt===`
`&&(He+=1),He>1)return!0}return!1});!Xe.loose&&X.length&&ve&&(Xe.loose=!0,Xe.items[q].loose=!0)}return Xe}},Se.html=function(oe){var le=this.rules.block.html.exec(oe);if(le){var J={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var I=this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]);J.type="paragraph",J.text=I,J.tokens=this.lexer.inline(I)}return J}},Se.def=function(oe){var le=this.rules.block.def.exec(oe);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var J=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(oe){var le=this.rules.block.table.exec(oe);if(le){var J={type:"table",header:o(le[1]).map(function(me){return{text:me}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=le[0];var I=J.align.length,$,W,q,ee;for($=0;$<I;$++)/^ *-+: *$/.test(J.align[$])?J.align[$]="right":/^ *:-+: *$/.test(J.align[$])?J.align[$]="center":/^ *:-+ *$/.test(J.align[$])?J.align[$]="left":J.align[$]=null;for(I=J.rows.length,$=0;$<I;$++)J.rows[$]=o(J.rows[$],J.header.length).map(function(me){return{text:me}});for(I=J.header.length,W=0;W<I;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(I=J.rows.length,W=0;W<I;W++)for(ee=J.rows[W],q=0;q<ee.length;q++)ee[q].tokens=this.lexer.inline(ee[q].text);return J}}},Se.lheading=function(oe){var le=this.rules.block.lheading.exec(oe);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},Se.paragraph=function(oe){var le=this.rules.block.paragraph.exec(oe);if(le){var J=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:J,tokens:this.lexer.inline(J)}}},Se.text=function(oe){var le=this.rules.block.text.exec(oe);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},Se.escape=function(oe){var le=this.rules.inline.escape.exec(oe);if(le)return{type:"escape",raw:le[0],text:m(le[1])}},Se.tag=function(oe){var le=this.rules.inline.tag.exec(oe);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]}},Se.link=function(oe){var le=this.rules.inline.link.exec(oe);if(le){var J=le[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var I=f(J.slice(0,-1),"\\");if((J.length-I.length)%2===0)return}else{var $=k(le[2],"()");if($>-1){var W=le[0].indexOf("!")===0?5:4,q=W+le[1].length+$;le[2]=le[2].substring(0,$),le[0]=le[0].substring(0,q).trim(),le[3]=""}}var ee=le[2],me="";if(this.options.pedantic){var ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);ye&&(ee=ye[1],me=ye[3])}else me=le[3]?le[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),_(le,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:me&&me.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Se.reflink=function(oe,le){var J;if((J=this.rules.inline.reflink.exec(oe))||(J=this.rules.inline.nolink.exec(oe))){var I=(J[2]||J[1]).replace(/\s+/g," ");if(I=le[I.toLowerCase()],!I||!I.href){var $=J[0].charAt(0);return{type:"text",raw:$,text:$}}return _(J,I,J[0],this.lexer)}},Se.emStrong=function(oe,le,J){J===void 0&&(J="");var I=this.rules.inline.emStrong.lDelim.exec(oe);if(!!I&&!(I[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=I[1]||I[2]||"";if(!$||$&&(J===""||this.rules.inline.punctuation.exec(J))){var W=I[0].length-1,q,ee,me=W,ye=0,ce=I[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,le=le.slice(-1*oe.length+W);(I=ce.exec(le))!=null;)if(q=I[1]||I[2]||I[3]||I[4]||I[5]||I[6],!!q){if(ee=q.length,I[3]||I[4]){me+=ee;continue}else if((I[5]||I[6])&&W%3&&!((W+ee)%3)){ye+=ee;continue}if(me-=ee,!(me>0)){if(ee=Math.min(ee,ee+me+ye),Math.min(W,ee)%2){var be=oe.slice(1,W+I.index+ee);return{type:"em",raw:oe.slice(0,W+I.index+ee+1),text:be,tokens:this.lexer.inlineTokens(be)}}var Ee=oe.slice(2,W+I.index+ee-1);return{type:"strong",raw:oe.slice(0,W+I.index+ee+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},Se.codespan=function(oe){var le=this.rules.inline.code.exec(oe);if(le){var J=le[2].replace(/\n/g," "),I=/[^ ]/.test(J),$=/^ /.test(J)&&/ $/.test(J);return I&&$&&(J=J.substring(1,J.length-1)),J=m(J,!0),{type:"codespan",raw:le[0],text:J}}},Se.br=function(oe){var le=this.rules.inline.br.exec(oe);if(le)return{type:"br",raw:le[0]}},Se.del=function(oe){var le=this.rules.inline.del.exec(oe);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},Se.autolink=function(oe,le){var J=this.rules.inline.autolink.exec(oe);if(J){var I,$;return J[2]==="@"?(I=m(this.options.mangle?le(J[1]):J[1]),$="mailto:"+I):(I=m(J[1]),$=I),{type:"link",raw:J[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.url=function(oe,le){var J;if(J=this.rules.inline.url.exec(oe)){var I,$;if(J[2]==="@")I=m(this.options.mangle?le(J[0]):J[0]),$="mailto:"+I;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);I=m(J[0]),J[1]==="www."?$="http://"+I:$=I}return{type:"link",raw:J[0],text:I,href:$,tokens:[{type:"text",raw:I,text:I}]}}},Se.inlineText=function(oe,le){var J=this.rules.inline.text.exec(oe);if(J){var I;return this.lexer.state.inRawBlock?I=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):m(J[0]):J[0]:I=m(this.options.smartypants?le(J[0]):J[0]),{type:"text",raw:J[0],text:I}}},Pe}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:p,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:p,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var P={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:p,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:p,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};P._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",P.punctuation=g(P.punctuation).replace(/punctuation/g,P._punctuation).getRegex(),P.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,P.escapedEmSt=/\\\*|\\_/g,P._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),P.emStrong.lDelim=g(P.emStrong.lDelim).replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimAst=g(P.emStrong.rDelimAst,"g").replace(/punct/g,P._punctuation).getRegex(),P.emStrong.rDelimUnd=g(P.emStrong.rDelimUnd,"g").replace(/punct/g,P._punctuation).getRegex(),P._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,P._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,P._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,P.autolink=g(P.autolink).replace("scheme",P._scheme).replace("email",P._email).getRegex(),P._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,P.tag=g(P.tag).replace("comment",P._comment).replace("attribute",P._attribute).getRegex(),P._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,P._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,P._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,P.link=g(P.link).replace("label",P._label).replace("href",P._href).replace("title",P._title).getRegex(),P.reflink=g(P.reflink).replace("label",P._label).replace("ref",B._label).getRegex(),P.nolink=g(P.nolink).replace("ref",B._label).getRegex(),P.reflinkSearch=g(P.reflinkSearch,"g").replace("reflink",P.reflink).replace("nolink",P.nolink).getRegex(),P.normal=c({},P),P.pedantic=c({},P.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",P._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",P._label).getRegex()}),P.gfm=c({},P.normal,{escape:g(P.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),P.gfm.url=g(P.gfm.url,"i").replace("email",P.gfm._extended_email).getRegex(),P.breaks=c({},P.gfm,{br:g(P.br).replace("{2,}","*").getRegex(),text:g(P.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(Pe){var Se="",Ie,oe,le=Pe.length;for(Ie=0;Ie<le;Ie++)oe=Pe.charCodeAt(Ie),Math.random()>.5&&(oe="x"+oe.toString(16)),Se+="&#"+oe+";";return Se}var j=function(){function Pe(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||te.defaults,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:B.normal,inline:P.normal};this.options.pedantic?(oe.block=B.pedantic,oe.inline=P.pedantic):this.options.gfm&&(oe.block=B.gfm,this.options.breaks?oe.inline=P.breaks:oe.inline=P.gfm),this.tokenizer.rules=oe}Pe.lex=function(oe,le){var J=new Pe(le);return J.lex(oe)},Pe.lexInline=function(oe,le){var J=new Pe(le);return J.inlineTokens(oe)};var Se=Pe.prototype;return Se.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Se.blockTokens=function(oe,le){var J=this;le===void 0&&(le=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(me,ye,ce){return ye+"    ".repeat(ce.length)});for(var I,$,W,q;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(me){return(I=me.call({lexer:J},oe,le))?(oe=oe.substring(I.raw.length),le.push(I),!0):!1}))){if(I=this.tokenizer.space(oe)){oe=oe.substring(I.raw.length),I.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(I);continue}if(I=this.tokenizer.code(oe)){oe=oe.substring(I.raw.length),$=le[le.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(I);continue}if(I=this.tokenizer.fences(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.heading(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.hr(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.blockquote(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.list(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.html(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.def(oe)){oe=oe.substring(I.raw.length),$=le[le.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+I.raw,$.text+=`
`+I.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[I.tag]||(this.tokens.links[I.tag]={href:I.href,title:I.title});continue}if(I=this.tokenizer.table(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.lheading(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var me=1/0,ye=oe.slice(1),ce=void 0;J.options.extensions.startBlock.forEach(function(be){ce=be.call({lexer:this},ye),typeof ce=="number"&&ce>=0&&(me=Math.min(me,ce))}),me<1/0&&me>=0&&(W=oe.substring(0,me+1))}(),this.state.top&&(I=this.tokenizer.paragraph(W))){$=le[le.length-1],q&&$.type==="paragraph"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(I),q=W.length!==oe.length,oe=oe.substring(I.raw.length);continue}if(I=this.tokenizer.text(oe)){oe=oe.substring(I.raw.length),$=le[le.length-1],$&&$.type==="text"?($.raw+=`
`+I.raw,$.text+=`
`+I.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):le.push(I);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,le},Se.inline=function(oe,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:oe,tokens:le}),le},Se.inlineTokens=function(oe,le){var J=this;le===void 0&&(le=[]);var I,$,W,q=oe,ee,me,ye;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ce.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,ee.index)+"["+V("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,ee.index)+"["+V("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,ee.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(me||(ye=""),me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(I=Ee.call({lexer:J},oe,le))?(oe=oe.substring(I.raw.length),le.push(I),!0):!1}))){if(I=this.tokenizer.escape(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.tag(oe)){oe=oe.substring(I.raw.length),$=le[le.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):le.push(I);continue}if(I=this.tokenizer.link(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(I.raw.length),$=le[le.length-1],$&&I.type==="text"&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):le.push(I);continue}if(I=this.tokenizer.emStrong(oe,q,ye)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.codespan(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.br(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.del(oe)){oe=oe.substring(I.raw.length),le.push(I);continue}if(I=this.tokenizer.autolink(oe,H)){oe=oe.substring(I.raw.length),le.push(I);continue}if(!this.state.inLink&&(I=this.tokenizer.url(oe,H))){oe=oe.substring(I.raw.length),le.push(I);continue}if(W=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,We=oe.slice(1),Ve=void 0;J.options.extensions.startInline.forEach(function(tt){Ve=tt.call({lexer:this},We),typeof Ve=="number"&&Ve>=0&&(Ee=Math.min(Ee,Ve))}),Ee<1/0&&Ee>=0&&(W=oe.substring(0,Ee+1))}(),I=this.tokenizer.inlineText(W,F)){oe=oe.substring(I.raw.length),I.raw.slice(-1)!=="_"&&(ye=I.raw.slice(-1)),me=!0,$=le[le.length-1],$&&$.type==="text"?($.raw+=I.raw,$.text+=I.text):le.push(I);continue}if(oe){var be="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return le},n(Pe,null,[{key:"rules",get:function(){return{block:B,inline:P}}}]),Pe}(),de=function(){function Pe(Ie){this.options=Ie||te.defaults}var Se=Pe.prototype;return Se.code=function(oe,le,J){var I=(le||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(oe,I);$!=null&&$!==oe&&(J=!0,oe=$)}return oe=oe.replace(/\n$/,"")+`
`,I?'<pre><code class="'+this.options.langPrefix+m(I,!0)+'">'+(J?oe:m(oe,!0))+`</code></pre>
`:"<pre><code>"+(J?oe:m(oe,!0))+`</code></pre>
`},Se.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},Se.html=function(oe){return oe},Se.heading=function(oe,le,J,I){if(this.options.headerIds){var $=this.options.headerPrefix+I.slug(J);return"<h"+le+' id="'+$+'">'+oe+"</h"+le+`>
`}return"<h"+le+">"+oe+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(oe,le,J){var I=le?"ol":"ul",$=le&&J!==1?' start="'+J+'"':"";return"<"+I+$+`>
`+oe+"</"+I+`>
`},Se.listitem=function(oe){return"<li>"+oe+`</li>
`},Se.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(oe){return"<p>"+oe+`</p>
`},Se.table=function(oe,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+le+`</table>
`},Se.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},Se.tablecell=function(oe,le){var J=le.header?"th":"td",I=le.align?"<"+J+' align="'+le.align+'">':"<"+J+">";return I+oe+("</"+J+`>
`)},Se.strong=function(oe){return"<strong>"+oe+"</strong>"},Se.em=function(oe){return"<em>"+oe+"</em>"},Se.codespan=function(oe){return"<code>"+oe+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(oe){return"<del>"+oe+"</del>"},Se.link=function(oe,le,J){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return J;var I='<a href="'+m(oe)+'"';return le&&(I+=' title="'+le+'"'),I+=">"+J+"</a>",I},Se.image=function(oe,le,J){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return J;var I='<img src="'+oe+'" alt="'+J+'"';return le&&(I+=' title="'+le+'"'),I+=this.options.xhtml?"/>":">",I},Se.text=function(oe){return oe},Pe}(),pe=function(){function Pe(){}var Se=Pe.prototype;return Se.strong=function(oe){return oe},Se.em=function(oe){return oe},Se.codespan=function(oe){return oe},Se.del=function(oe){return oe},Se.html=function(oe){return oe},Se.text=function(oe){return oe},Se.link=function(oe,le,J){return""+J},Se.image=function(oe,le,J){return""+J},Se.br=function(){return""},Pe}(),re=function(){function Pe(){this.seen={}}var Se=Pe.prototype;return Se.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(oe,le){var J=oe,I=0;if(this.seen.hasOwnProperty(J)){I=this.seen[oe];do I++,J=oe+"-"+I;while(this.seen.hasOwnProperty(J))}return le||(this.seen[oe]=I,this.seen[J]=0),J},Se.slug=function(oe,le){le===void 0&&(le={});var J=this.serialize(oe);return this.getNextSafeSlug(J,le.dryrun)},Pe}(),ue=function(){function Pe(Ie){this.options=Ie||te.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new re}Pe.parse=function(oe,le){var J=new Pe(le);return J.parse(oe)},Pe.parseInline=function(oe,le){var J=new Pe(le);return J.parseInline(oe)};var Se=Pe.prototype;return Se.parse=function(oe,le){le===void 0&&(le=!0);var J="",I,$,W,q,ee,me,ye,ce,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Q=oe.length;for(I=0;I<Q;I++){if(Ee=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(ot=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){J+=ot||"";continue}switch(Ee.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,s(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(ce="",ye="",q=Ee.header.length,$=0;$<q;$++)ye+=this.renderer.tablecell(this.parseInline(Ee.header[$].tokens),{header:!0,align:Ee.align[$]});for(ce+=this.renderer.tablerow(ye),be="",q=Ee.rows.length,$=0;$<q;$++){for(me=Ee.rows[$],ye="",ee=me.length,W=0;W<ee;W++)ye+=this.renderer.tablecell(this.parseInline(me[W].tokens),{header:!1,align:Ee.align[W]});be+=this.renderer.tablerow(ye)}J+=this.renderer.table(ce,be);continue}case"blockquote":{be=this.parse(Ee.tokens),J+=this.renderer.blockquote(be);continue}case"list":{for(We=Ee.ordered,Ve=Ee.start,tt=Ee.loose,q=Ee.items.length,be="",$=0;$<q;$++)et=Ee.items[$],it=et.checked,dt=et.task,Xe="",et.task&&(Fe=this.renderer.checkbox(it),tt?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=Fe+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=Fe+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:Fe}):Xe+=Fe),Xe+=this.parse(et.tokens,tt),be+=this.renderer.listitem(Xe,dt,it);J+=this.renderer.list(be,We,Ve);continue}case"html":{J+=this.renderer.html(Ee.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(be=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;I+1<Q&&oe[I+1].type==="text";)Ee=oe[++I],be+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);J+=le?this.renderer.paragraph(be):be;continue}default:{var X='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return J},Se.parseInline=function(oe,le){le=le||this.renderer;var J="",I,$,W,q=oe.length;for(I=0;I<q;I++){if($=oe[I],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(W=this.options.extensions.renderers[$.type].call({parser:this},$),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){J+=W||"";continue}switch($.type){case"escape":{J+=le.text($.text);break}case"html":{J+=le.html($.text);break}case"link":{J+=le.link($.href,$.title,this.parseInline($.tokens,le));break}case"image":{J+=le.image($.href,$.title,$.text);break}case"strong":{J+=le.strong(this.parseInline($.tokens,le));break}case"em":{J+=le.em(this.parseInline($.tokens,le));break}case"codespan":{J+=le.codespan($.text);break}case"br":{J+=le.br();break}case"del":{J+=le.del(this.parseInline($.tokens,le));break}case"text":{J+=le.text($.text);break}default:{var ee='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},Pe}();function ae(Pe,Se,Ie){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof Se=="function"&&(Ie=Se,Se=null),Se=c({},ae.defaults,Se||{}),A(Se),Ie){var oe=Se.highlight,le;try{le=j.lex(Pe,Se)}catch(q){return Ie(q)}var J=function(ee){var me;if(!ee)try{Se.walkTokens&&ae.walkTokens(le,Se.walkTokens),me=ue.parse(le,Se)}catch(ye){ee=ye}return Se.highlight=oe,ee?Ie(ee):Ie(null,me)};if(!oe||oe.length<3||(delete Se.highlight,!le.length))return J();var I=0;ae.walkTokens(le,function(q){q.type==="code"&&(I++,setTimeout(function(){oe(q.text,q.lang,function(ee,me){if(ee)return J(ee);me!=null&&me!==q.text&&(q.text=me,q.escaped=!0),I--,I===0&&J()})},0))}),I===0&&J();return}function $(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var W=j.lex(Pe,Se);if(Se.walkTokens){if(Se.async)return Promise.all(ae.walkTokens(W,Se.walkTokens)).then(function(){return ue.parse(W,Se)}).catch($);ae.walkTokens(W,Se.walkTokens)}return ue.parse(W,Se)}catch(q){$(q)}}ae.options=ae.setOptions=function(Pe){return c(ae.defaults,Pe),R(ae.defaults),ae},ae.getDefaults=S,ae.defaults=te.defaults,ae.use=function(){for(var Pe=arguments.length,Se=new Array(Pe),Ie=0;Ie<Pe;Ie++)Se[Ie]=arguments[Ie];var oe=c.apply(void 0,[{}].concat(Se)),le=ae.defaults.extensions||{renderers:{},childTokens:{}},J;Se.forEach(function(I){if(I.extensions&&(J=!0,I.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=le.renderers?le.renderers[W.name]:null;q?le.renderers[W.name]=function(){for(var ee=arguments.length,me=new Array(ee),ye=0;ye<ee;ye++)me[ye]=arguments[ye];var ce=W.renderer.apply(this,me);return ce===!1&&(ce=q.apply(this,me)),ce}:le.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[W.level]?le[W.level].unshift(W.tokenizer):le[W.level]=[W.tokenizer],W.start&&(W.level==="block"?le.startBlock?le.startBlock.push(W.start):le.startBlock=[W.start]:W.level==="inline"&&(le.startInline?le.startInline.push(W.start):le.startInline=[W.start]))}W.childTokens&&(le.childTokens[W.name]=W.childTokens)})),I.renderer&&function(){var W=ae.defaults.renderer||new de,q=function(ye){var ce=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var Ve=I.renderer[ye].apply(W,Ee);return Ve===!1&&(Ve=ce.apply(W,Ee)),Ve}};for(var ee in I.renderer)q(ee);oe.renderer=W}(),I.tokenizer&&function(){var W=ae.defaults.tokenizer||new O,q=function(ye){var ce=W[ye];W[ye]=function(){for(var be=arguments.length,Ee=new Array(be),We=0;We<be;We++)Ee[We]=arguments[We];var Ve=I.tokenizer[ye].apply(W,Ee);return Ve===!1&&(Ve=ce.apply(W,Ee)),Ve}};for(var ee in I.tokenizer)q(ee);oe.tokenizer=W}(),I.walkTokens){var $=ae.defaults.walkTokens;oe.walkTokens=function(W){var q=[];return q.push(I.walkTokens.call(this,W)),$&&(q=q.concat($.call(this,W))),q}}J&&(oe.extensions=le),ae.setOptions(oe)})},ae.walkTokens=function(Pe,Se){for(var Ie=[],oe=function(){var $=J.value;switch(Ie=Ie.concat(Se.call(ae,$)),$.type){case"table":{for(var W=M($.header),q;!(q=W()).done;){var ee=q.value;Ie=Ie.concat(ae.walkTokens(ee.tokens,Se))}for(var me=M($.rows),ye;!(ye=me()).done;)for(var ce=ye.value,be=M(ce),Ee;!(Ee=be()).done;){var We=Ee.value;Ie=Ie.concat(ae.walkTokens(We.tokens,Se))}break}case"list":{Ie=Ie.concat(ae.walkTokens($.items,Se));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[$.type]?ae.defaults.extensions.childTokens[$.type].forEach(function(Ve){Ie=Ie.concat(ae.walkTokens($[Ve],Se))}):$.tokens&&(Ie=Ie.concat(ae.walkTokens($.tokens,Se)))}},le=M(Pe),J;!(J=le()).done;)oe();return Ie},ae.parseInline=function(Pe,Se){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");Se=c({},ae.defaults,Se||{}),A(Se);try{var Ie=j.lexInline(Pe,Se);return Se.walkTokens&&ae.walkTokens(Ie,Se.walkTokens),ue.parseInline(Ie,Se)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+m(oe.message+"",!0)+"</pre>";throw oe}},ae.Parser=ue,ae.parser=ue.parse,ae.Renderer=de,ae.TextRenderer=pe,ae.Lexer=j,ae.lexer=j.lex,ae.Tokenizer=O,ae.Slugger=re,ae.parse=ae;var se=ae.options,Y=ae.setOptions,G=ae.use,Z=ae.walkTokens,he=ae.parseInline,Te=ae,Ne=ue.parse,Ke=j.lex;te.Lexer=j,te.Parser=ue,te.Renderer=de,te.Slugger=re,te.TextRenderer=pe,te.Tokenizer=O,te.getDefaults=S,te.lexer=Ke,te.marked=ae,te.options=se,te.parse=Te,te.parseInline=he,te.parser=Ne,te.setOptions=Y,te.use=G,te.walkTokens=Z,Object.defineProperty(te,"__esModule",{value:!0})}),define(Ce[113],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(R,y,T){return Math.min(Math.max(R,y),T)}e.clamp=n;function C(R,y){return(y+R%y)%y}e.rot=C;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class M{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=M;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const T=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=T,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function te(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function S(y){M.push(y,Date.now())}function R(){const y=[];for(let T=0;T<M.length;T+=2)y.push({name:M[T],startTime:M[T+1]});return y}return{mark:S,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const S of performance.getEntriesByType("mark"))M.push({name:S.name,startTime:Math.round(D+S.startTime)});return M}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:te)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(C){if(e[C])return e[C].exports;var D=e[C]={i:C,l:!1,exports:{}};return te[C].call(D.exports,D,D.exports,n),D.l=!0,D.exports}return n.m=te,n.c=e,n.d=function(C,D,M){n.o(C,D)||Object.defineProperty(C,D,{enumerable:!0,get:M})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,D){if(1&D&&(C=n(C)),8&D||4&D&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&D&&typeof C!="string")for(var S in C)n.d(M,S,function(R){return C[R]}.bind(null,S));return M},n.n=function(C){var D=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(D,"a",D),D},n.o=function(C,D){return Object.prototype.hasOwnProperty.call(C,D)},n.p="",n(n.s=0)}([function(te,e,n){(function(C){var D;e=te.exports=G,D=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],y=e.src=[],T=0,N=T++;y[N]="0|[1-9]\\d*";var w=T++;y[w]="[0-9]+";var h=T++;y[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=T++;y[b]="("+y[N]+")\\.("+y[N]+")\\.("+y[N]+")";var m=T++;y[m]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var a=T++;y[a]="(?:"+y[N]+"|"+y[h]+")";var s=T++;y[s]="(?:"+y[w]+"|"+y[h]+")";var l=T++;y[l]="(?:-("+y[a]+"(?:\\."+y[a]+")*))";var g=T++;y[g]="(?:-?("+y[s]+"(?:\\."+y[s]+")*))";var E=T++;y[E]="[0-9A-Za-z-]+";var L=T++;y[L]="(?:\\+("+y[E]+"(?:\\."+y[E]+")*))";var v=T++,t="v?"+y[b]+y[l]+"?"+y[L]+"?";y[v]="^"+t+"$";var d="[v=\\s]*"+y[m]+y[g]+"?"+y[L]+"?",r=T++;y[r]="^"+d+"$";var u=T++;y[u]="((?:<|>)?=?)";var i=T++;y[i]=y[w]+"|x|X|\\*";var p=T++;y[p]=y[N]+"|x|X|\\*";var c=T++;y[c]="[v=\\s]*("+y[p]+")(?:\\.("+y[p]+")(?:\\.("+y[p]+")(?:"+y[l]+")?"+y[L]+"?)?)?";var o=T++;y[o]="[v=\\s]*("+y[i]+")(?:\\.("+y[i]+")(?:\\.("+y[i]+")(?:"+y[g]+")?"+y[L]+"?)?)?";var f=T++;y[f]="^"+y[u]+"\\s*"+y[c]+"$";var k=T++;y[k]="^"+y[u]+"\\s*"+y[o]+"$";var A=T++;y[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=T++;y[V]="(?:~>?)";var _=T++;y[_]="(\\s*)"+y[V]+"\\s+",R[_]=new RegExp(y[_],"g");var K=T++;y[K]="^"+y[V]+y[c]+"$";var O=T++;y[O]="^"+y[V]+y[o]+"$";var B=T++;y[B]="(?:\\^)";var P=T++;y[P]="(\\s*)"+y[B]+"\\s+",R[P]=new RegExp(y[P],"g");var F=T++;y[F]="^"+y[B]+y[c]+"$";var H=T++;y[H]="^"+y[B]+y[o]+"$";var j=T++;y[j]="^"+y[u]+"\\s*("+d+")$|^$";var de=T++;y[de]="^"+y[u]+"\\s*("+t+")$|^$";var pe=T++;y[pe]="(\\s*)"+y[u]+"\\s*("+d+"|"+y[c]+")",R[pe]=new RegExp(y[pe],"g");var re=T++;y[re]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var ue=T++;y[ue]="^\\s*("+y[o]+")\\s+-\\s+("+y[o]+")\\s*$";var ae=T++;y[ae]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)D(se,y[se]),R[se]||(R[se]=new RegExp(y[se]));function Y(ce,be){if(ce instanceof G)return ce;if(typeof ce!="string"||ce.length>M||!(be?R[r]:R[v]).test(ce))return null;try{return new G(ce,be)}catch{return null}}function G(ce,be){if(ce instanceof G){if(ce.loose===be)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof G))return new G(ce,be);D("SemVer",ce,be),this.loose=be;var Ee=ce.trim().match(be?R[r]:R[v]);if(!Ee)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(We){if(/^[0-9]+$/.test(We)){var Ve=+We;if(Ve>=0&&Ve<S)return Ve}return We}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=Y,e.valid=function(ce,be){var Ee=Y(ce,be);return Ee?Ee.version:null},e.clean=function(ce,be){var Ee=Y(ce.trim().replace(/^[=v]+/,""),be);return Ee?Ee.version:null},e.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof G||(ce=new G(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},G.prototype.compareMain=function(ce){return ce instanceof G||(ce=new G(ce,this.loose)),he(this.major,ce.major)||he(this.minor,ce.minor)||he(this.patch,ce.patch)},G.prototype.comparePre=function(ce){if(ce instanceof G||(ce=new G(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var be=0;do{var Ee=this.prerelease[be],We=ce.prerelease[be];if(D("prerelease compare",be,Ee,We),Ee===void 0&&We===void 0)return 0;if(We===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==We)return he(Ee,We)}while(++be)},G.prototype.inc=function(ce,be){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",be);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",be);break;case"prepatch":this.prerelease.length=0,this.inc("patch",be),this.inc("pre",be);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",be),this.inc("pre",be);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}be&&(this.prerelease[0]===be?isNaN(this.prerelease[1])&&(this.prerelease=[be,0]):this.prerelease=[be,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,be,Ee,We){typeof Ee=="string"&&(We=Ee,Ee=void 0);try{return new G(ce,Ee).inc(be,We).version}catch{return null}},e.diff=function(ce,be){if(Pe(ce,be))return null;var Ee=Y(ce),We=Y(be);if(Ee.prerelease.length||We.prerelease.length){for(var Ve in Ee)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ee[Ve]!==We[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Ee)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ee[Ve]!==We[Ve])return Ve},e.compareIdentifiers=he;var Z=/^[0-9]+$/;function he(ce,be){var Ee=Z.test(ce),We=Z.test(be);return Ee&&We&&(ce=+ce,be=+be),Ee&&!We?-1:We&&!Ee?1:ce<be?-1:ce>be?1:0}function Te(ce,be,Ee){return new G(ce,Ee).compare(new G(be,Ee))}function Ne(ce,be,Ee){return Te(ce,be,Ee)>0}function Ke(ce,be,Ee){return Te(ce,be,Ee)<0}function Pe(ce,be,Ee){return Te(ce,be,Ee)===0}function Se(ce,be,Ee){return Te(ce,be,Ee)!==0}function Ie(ce,be,Ee){return Te(ce,be,Ee)>=0}function oe(ce,be,Ee){return Te(ce,be,Ee)<=0}function le(ce,be,Ee,We){var Ve;switch(be){case"===":typeof ce=="object"&&(ce=ce.version),typeof Ee=="object"&&(Ee=Ee.version),Ve=ce===Ee;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof Ee=="object"&&(Ee=Ee.version),Ve=ce!==Ee;break;case"":case"=":case"==":Ve=Pe(ce,Ee,We);break;case"!=":Ve=Se(ce,Ee,We);break;case">":Ve=Ne(ce,Ee,We);break;case">=":Ve=Ie(ce,Ee,We);break;case"<":Ve=Ke(ce,Ee,We);break;case"<=":Ve=oe(ce,Ee,We);break;default:throw new TypeError("Invalid operator: "+be)}return Ve}function J(ce,be){if(ce instanceof J){if(ce.loose===be)return ce;ce=ce.value}if(!(this instanceof J))return new J(ce,be);D("comparator",ce,be),this.loose=be,this.parse(ce),this.semver===I?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,be){return he(be,ce)},e.major=function(ce,be){return new G(ce,be).major},e.minor=function(ce,be){return new G(ce,be).minor},e.patch=function(ce,be){return new G(ce,be).patch},e.compare=Te,e.compareLoose=function(ce,be){return Te(ce,be,!0)},e.rcompare=function(ce,be,Ee){return Te(be,ce,Ee)},e.sort=function(ce,be){return ce.sort(function(Ee,We){return e.compare(Ee,We,be)})},e.rsort=function(ce,be){return ce.sort(function(Ee,We){return e.rcompare(Ee,We,be)})},e.gt=Ne,e.lt=Ke,e.eq=Pe,e.neq=Se,e.gte=Ie,e.lte=oe,e.cmp=le,e.Comparator=J;var I={};function $(ce,be){if(ce instanceof $)return ce.loose===be?ce:new $(ce.raw,be);if(ce instanceof J)return new $(ce.value,be);if(!(this instanceof $))return new $(ce,be);if(this.loose=be,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function W(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function q(ce,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Q){return((be=W(Ee)?"":W(We)?">="+Ee+".0.0":W(Ve)?">="+Ee+"."+We+".0":">="+be)+" "+(et=W(it)?"":W(dt)?"<"+(+it+1)+".0.0":W(Fe)?"<"+it+"."+(+dt+1)+".0":ot?"<="+it+"."+dt+"."+Fe+"-"+ot:"<="+et)).trim()}function ee(ce,be){for(var Ee=0;Ee<ce.length;Ee++)if(!ce[Ee].test(be))return!1;if(be.prerelease.length){for(Ee=0;Ee<ce.length;Ee++)if(D(ce[Ee].semver),ce[Ee].semver!==I&&ce[Ee].semver.prerelease.length>0){var We=ce[Ee].semver;if(We.major===be.major&&We.minor===be.minor&&We.patch===be.patch)return!0}return!1}return!0}function me(ce,be,Ee){try{be=new $(be,Ee)}catch{return!1}return be.test(ce)}function ye(ce,be,Ee,We){var Ve,tt,Xe,et,it;switch(ce=new G(ce,We),be=new $(be,We),Ee){case">":Ve=Ne,tt=oe,Xe=Ke,et=">",it=">=";break;case"<":Ve=Ke,tt=Ie,Xe=Ne,et="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(ce,be,We))return!1;for(var dt=0;dt<be.set.length;++dt){var Fe=be.set[dt],ot=null,Q=null;if(Fe.forEach(function(X){X.semver===I&&(X=new J(">=0.0.0")),ot=ot||X,Q=Q||X,Ve(X.semver,ot.semver,We)?ot=X:Xe(X.semver,Q.semver,We)&&(Q=X)}),ot.operator===et||ot.operator===it||(!Q.operator||Q.operator===et)&&tt(ce,Q.semver)||Q.operator===it&&Xe(ce,Q.semver))return!1}return!0}J.prototype.parse=function(ce){var be=this.loose?R[j]:R[de],Ee=ce.match(be);if(!Ee)throw new TypeError("Invalid comparator: "+ce);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new G(Ee[2],this.loose):this.semver=I},J.prototype.toString=function(){return this.value},J.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===I||(typeof ce=="string"&&(ce=new G(ce,this.loose)),le(ce,this.operator,this.semver,this.loose))},J.prototype.intersects=function(ce,be){if(!(ce instanceof J))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new $(ce.value,be),me(this.value,Ee,be);if(ce.operator==="")return Ee=new $(this.value,be),me(ce.semver,Ee,be);var We=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),tt=this.semver.version===ce.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),et=le(this.semver,"<",ce.semver,be)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),it=le(this.semver,">",ce.semver,be)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return We||Ve||tt&&Xe||et||it},e.Range=$,$.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},$.prototype.toString=function(){return this.range},$.prototype.parseRange=function(ce){var be=this.loose;ce=ce.trim(),D("range",ce,be);var Ee=be?R[ue]:R[re];ce=ce.replace(Ee,q),D("hyphen replace",ce),ce=ce.replace(R[pe],"$1$2$3"),D("comparator trim",ce,R[pe]),ce=(ce=(ce=ce.replace(R[_],"$1~")).replace(R[P],"$1^")).split(/\s+/).join(" ");var We=be?R[j]:R[de],Ve=ce.split(" ").map(function(tt){return function(Xe,et){return D("comp",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){D("caret",ot,Q);var X=Q?R[H]:R[F];return ot.replace(X,function(ve,Me,ze,He,Ye){var nt;return D("caret",ot,ve,Me,ze,He,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(He)?nt=Me==="0"?">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+".0 <"+(+Me+1)+".0.0":Ye?(D("replaceCaret pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+ze+"."+(+He+1):">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+He+Ye+" <"+(+Me+1)+".0.0"):(D("no pr"),nt=Me==="0"?ze==="0"?">="+Me+"."+ze+"."+He+" <"+Me+"."+ze+"."+(+He+1):">="+Me+"."+ze+"."+He+" <"+Me+"."+(+ze+1)+".0":">="+Me+"."+ze+"."+He+" <"+(+Me+1)+".0.0"),D("caret return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("caret",Xe),Xe=function(it,dt){return it.trim().split(/\s+/).map(function(Fe){return function(ot,Q){var X=Q?R[O]:R[K];return ot.replace(X,function(ve,Me,ze,He,Ye){var nt;return D("tilde",ot,ve,Me,ze,He,Ye),W(Me)?nt="":W(ze)?nt=">="+Me+".0.0 <"+(+Me+1)+".0.0":W(He)?nt=">="+Me+"."+ze+".0 <"+Me+"."+(+ze+1)+".0":Ye?(D("replaceTilde pr",Ye),Ye.charAt(0)!=="-"&&(Ye="-"+Ye),nt=">="+Me+"."+ze+"."+He+Ye+" <"+Me+"."+(+ze+1)+".0"):nt=">="+Me+"."+ze+"."+He+" <"+Me+"."+(+ze+1)+".0",D("tilde return",nt),nt})}(Fe,dt)}).join(" ")}(Xe,et),D("tildes",Xe),Xe=function(it,dt){return D("replaceXRanges",it,dt),it.split(/\s+/).map(function(Fe){return function(ot,Q){ot=ot.trim();var X=Q?R[k]:R[f];return ot.replace(X,function(ve,Me,ze,He,Ye,nt){D("xRange",ot,ve,Me,ze,He,Ye,nt);var vt=W(ze),wt=vt||W(He),Ct=wt||W(Ye);return Me==="="&&Ct&&(Me=""),vt?ve=Me===">"||Me==="<"?"<0.0.0":"*":Me&&Ct?(wt&&(He=0),Ct&&(Ye=0),Me===">"?(Me=">=",wt?(ze=+ze+1,He=0,Ye=0):Ct&&(He=+He+1,Ye=0)):Me==="<="&&(Me="<",wt?ze=+ze+1:He=+He+1),ve=Me+ze+"."+He+"."+Ye):wt?ve=">="+ze+".0.0 <"+(+ze+1)+".0.0":Ct&&(ve=">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0"),D("xRange return",ve),ve})}(Fe,dt)}).join(" ")}(Xe,et),D("xrange",Xe),Xe=function(it,dt){return D("replaceStars",it,dt),it.trim().replace(R[ae],"")}(Xe,et),D("stars",Xe),Xe}(tt,be)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(tt){return!!tt.match(We)})),Ve=Ve.map(function(tt){return new J(tt,be)})},$.prototype.intersects=function(ce,be){if(!(ce instanceof $))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(We){return ce.set.some(function(Ve){return Ve.every(function(tt){return We.intersects(tt,be)})})})})},e.toComparators=function(ce,be){return new $(ce,be).set.map(function(Ee){return Ee.map(function(We){return We.value}).join(" ").trim().split(" ")})},$.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new G(ce,this.loose));for(var be=0;be<this.set.length;be++)if(ee(this.set[be],ce))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(ce,be,Ee){var We=null,Ve=null;try{var tt=new $(be,Ee)}catch{return null}return ce.forEach(function(Xe){tt.test(Xe)&&(We&&Ve.compare(Xe)!==-1||(Ve=new G(We=Xe,Ee)))}),We},e.minSatisfying=function(ce,be,Ee){var We=null,Ve=null;try{var tt=new $(be,Ee)}catch{return null}return ce.forEach(function(Xe){tt.test(Xe)&&(We&&Ve.compare(Xe)!==1||(Ve=new G(We=Xe,Ee)))}),We},e.validRange=function(ce,be){try{return new $(ce,be).range||"*"}catch{return null}},e.ltr=function(ce,be,Ee){return ye(ce,be,"<",Ee)},e.gtr=function(ce,be,Ee){return ye(ce,be,">",Ee)},e.outside=ye,e.prerelease=function(ce,be){var Ee=Y(ce,be);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(ce,be,Ee){return ce=new $(ce,Ee),be=new $(be,Ee),ce.intersects(be)},e.coerce=function(ce){if(ce instanceof G)return ce;if(typeof ce!="string")return null;var be=ce.match(R[A]);return be==null?null:Y((be[1]||"0")+"."+(be[2]||"0")+"."+(be[3]||"0"))}}).call(this,n(1))},function(te,e){var n,C,D=te.exports={};function M(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function R(s){if(n===setTimeout)return setTimeout(s,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(s,0);try{return n(s,0)}catch{try{return n.call(null,s,0)}catch{return n.call(this,s,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{C=typeof clearTimeout=="function"?clearTimeout:S}catch{C=S}})();var y,T=[],N=!1,w=-1;function h(){N&&y&&(N=!1,y.length?T=y.concat(T):w=-1,T.length&&b())}function b(){if(!N){var s=R(h);N=!0;for(var l=T.length;l;){for(y=T,T=[];++w<l;)y&&y[w].run();w=-1,l=T.length}y=null,N=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===S||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(s)}}function m(s,l){this.fun=s,this.array=l}function a(){}D.nextTick=function(s){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];T.push(new m(s,l)),T.length!==1||N||R(b)},m.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=a,D.addListener=a,D.once=a,D.off=a,D.removeListener=a,D.removeAllListeners=a,D.emit=a,D.prependListener=a,D.prependOnceListener=a,D.listeners=function(s){return[]},D.binding=function(s){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(s){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(Ce[114],ke([1,0,12,6]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(L){const v=L;return v?typeof v.read=="function":!1}e.isReadable=D;function M(L){const v=L;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=M;function S(L){const v=L;return v?M(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=S;function R(L,v){return new y(L,v)}e.newWriteableStream=R;class y{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,n.onUnexpectedError)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let d;switch(v){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const r=d.indexOf(t);r>=0&&d.splice(r,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function T(L,v){const t=[];let d;for(;(d=L.read())!==null;)t.push(d);return v(t)}e.consumeReadable=T;function N(L,v,t){const d=[];let r;for(;(r=L.read())!==null&&d.length<t;)d.push(r);return r===null&&d.length>0?v(d):{read:()=>{if(d.length>0)return d.shift();if(typeof r<"u"){const u=r;return r=void 0,u}return L.read()}}}e.peekReadable=N;function w(L,v){return new Promise((t,d)=>{const r=[];h(L,{onData:u=>{v&&r.push(u)},onError:u=>{v?d(u):t(void 0)},onEnd:()=>{t(v?v(r):void 0)}})})}e.consumeStream=w;function h(L,v){let t=!1;return L.on("error",d=>{t||v.onError(d)}),L.on("end",()=>{t||v.onEnd()}),L.on("data",d=>{t||v.onData(d)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=h;function b(L,v){return new Promise((t,d)=>{const r=new C.DisposableStore,u=[],i=o=>{if(u.push(o),u.length>v)return r.dispose(),L.pause(),t({stream:L,buffer:u,ended:!1})},p=o=>d(o),c=()=>t({stream:L,buffer:u,ended:!0});r.add((0,C.toDisposable)(()=>L.removeListener("error",p))),L.on("error",p),r.add((0,C.toDisposable)(()=>L.removeListener("end",c))),L.on("end",c),r.add((0,C.toDisposable)(()=>L.removeListener("data",i))),L.on("data",i)})}e.peekStream=b;function m(L,v){const t=R(v);return t.end(L),t}e.toStream=m;function a(){const L=R(()=>{throw new Error("not supported")});return L.end(),L}e.emptyStream=a;function s(L){let v=!1;return{read:()=>v?null:(v=!0,L)}}e.toReadable=s;function l(L,v,t){const d=R(t);return h(L,{onData:r=>d.write(v.data(r)),onError:r=>d.error(v.error?v.error(r):r),onEnd:()=>d.end()}),d}e.transform=l;function g(L,v,t){let d=!1;return{read:()=>{const r=v.read();return d?r:(d=!0,r!==null?t([L,r]):L)}}}e.prefixedReadable=g;function E(L,v,t){let d=!1;const r=R(t);return h(v,{onData:u=>d?r.write(u):(d=!0,r.write(t([L,u]))),onError:u=>r.error(u),onEnd:()=>{d||(d=!0,r.write(L)),r.end()}}),r}e.prefixedStream=E}),define(Ce[23],ke([1,0,114]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let D,M;class S{static alloc(o){return C?new S(Buffer.allocUnsafe(o)):new S(new Uint8Array(o))}static wrap(o){return C&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new S(o)}static fromString(o,f){return!(f?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(o)):(D||(D=new TextEncoder),new S(D.encode(o)))}static fromByteArray(o){const f=S.alloc(o.length);for(let k=0,A=o.length;k<A;k++)f.buffer[k]=o[k];return f}static concat(o,f){if(typeof f>"u"){f=0;for(let V=0,_=o.length;V<_;V++)f+=o[V].byteLength}const k=S.alloc(f);let A=0;for(let V=0,_=o.length;V<_;V++){const K=o[V];k.set(K,A),A+=K.byteLength}return k}constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}clone(){const o=S.alloc(this.byteLength);return o.set(this),o}toString(){return C?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(o,f){return new S(this.buffer.subarray(o,f))}set(o,f){if(o instanceof S)this.buffer.set(o.buffer,f);else if(o instanceof Uint8Array)this.buffer.set(o,f);else if(o instanceof ArrayBuffer)this.buffer.set(new Uint8Array(o),f);else if(ArrayBuffer.isView(o))this.buffer.set(new Uint8Array(o.buffer,o.byteOffset,o.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(o){return T(this.buffer,o)}writeUInt32BE(o,f){N(this.buffer,o,f)}readUInt32LE(o){return w(this.buffer,o)}writeUInt32LE(o,f){h(this.buffer,o,f)}readUInt8(o){return b(this.buffer,o)}writeUInt8(o,f){m(this.buffer,o,f)}}e.VSBuffer=S;function R(c,o){return c[o+0]<<0>>>0|c[o+1]<<8>>>0}e.readUInt16LE=R;function y(c,o,f){c[f+0]=o&255,o=o>>>8,c[f+1]=o&255}e.writeUInt16LE=y;function T(c,o){return c[o]*2**24+c[o+1]*2**16+c[o+2]*2**8+c[o+3]}e.readUInt32BE=T;function N(c,o,f){c[f+3]=o,o=o>>>8,c[f+2]=o,o=o>>>8,c[f+1]=o,o=o>>>8,c[f]=o}e.writeUInt32BE=N;function w(c,o){return c[o+0]<<0>>>0|c[o+1]<<8>>>0|c[o+2]<<16>>>0|c[o+3]<<24>>>0}e.readUInt32LE=w;function h(c,o,f){c[f+0]=o&255,o=o>>>8,c[f+1]=o&255,o=o>>>8,c[f+2]=o&255,o=o>>>8,c[f+3]=o&255}e.writeUInt32LE=h;function b(c,o){return c[o]}e.readUInt8=b;function m(c,o,f){c[f]=o}e.writeUInt8=m;function a(c){return n.consumeReadable(c,o=>S.concat(o))}e.readableToBuffer=a;function s(c){return n.toReadable(c)}e.bufferToReadable=s;function l(c){return n.consumeStream(c,o=>S.concat(o))}e.streamToBuffer=l;async function g(c){return c.ended?S.concat(c.buffer):S.concat([...c.buffer,await l(c.stream)])}e.bufferedStreamToBuffer=g;function E(c){return n.toStream(c,o=>S.concat(o))}e.bufferToStream=E;function L(c){return n.transform(c,{data:o=>typeof o=="string"?S.fromString(o):S.wrap(o)},o=>S.concat(o))}e.streamToBufferReadableStream=L;function v(c){return n.newWriteableStream(o=>S.concat(o),c)}e.newWriteableBufferStream=v;function t(c,o){return n.prefixedReadable(c,o,f=>S.concat(f))}e.prefixedBufferReadable=t;function d(c,o){return n.prefixedStream(c,o,f=>S.concat(f))}e.prefixedBufferStream=d;function r(c){let o=0,f=0,k=0;const A=new Uint8Array(Math.floor(c.length/4*3)),V=K=>{switch(f){case 3:A[k++]=o|K,f=0;break;case 2:A[k++]=o|K>>>2,o=K<<6,f=3;break;case 1:A[k++]=o|K>>>4,o=K<<4,f=2;break;default:o=K<<2,f=1}};for(let K=0;K<c.length;K++){const O=c.charCodeAt(K);if(O>=65&&O<=90)V(O-65);else if(O>=97&&O<=122)V(O-97+26);else if(O>=48&&O<=57)V(O-48+52);else if(O===43||O===45)V(62);else if(O===47||O===95)V(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${c[K]}`)}}const _=k;for(;f>0;)V(0);return S.wrap(A).slice(0,_)}e.decodeBase64=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:c},o=!0,f=!1){const k=f?i:u;let A="";const V=c.byteLength%3;let _=0;for(;_<c.byteLength-V;_+=3){const K=c[_+0],O=c[_+1],B=c[_+2];A+=k[K>>>2],A+=k[(K<<4|O>>>4)&63],A+=k[(O<<2|B>>>6)&63],A+=k[B&63]}if(V===1){const K=c[_+0];A+=k[K>>>2],A+=k[K<<4&63],o&&(A+="==")}else if(V===2){const K=c[_+0],O=c[_+1];A+=k[K>>>2],A+=k[(K<<4|O>>>4)&63],A+=k[O<<2&63],o&&(A+="=")}return A}e.encodeBase64=p}),define(Ce[115],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[38],ke([1,0,84]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var C;(function(S){function R(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=R})(C=e.ThemeColor||(e.ThemeColor={}));function D(S){return{id:S}}e.themeColorFromId=D;var M;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(g){const E=R.exec(g.id);if(!E)return y(n.Codicon.error);const[,L,v]=E,t=["codicon","codicon-"+L];return v&&t.push("codicon-modifier-"+v.substring(1)),t}S.asClassNameArray=y;function T(g){return y(g).join(" ")}S.asClassName=T;function N(g){return"."+y(g).join(".")}S.asCSSSelector=N;function w(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||C.isThemeColor(g.color))}S.isThemeIcon=w;const h=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function b(g){const E=h.exec(g);if(!E)return;const[,L]=E;return{id:L}}S.fromString=b;function m(g){return{id:g}}S.fromId=m;function a(g,E){let L=g.id;const v=L.lastIndexOf("~");return v!==-1&&(L=L.substring(0,v)),E&&(L=`${L}~${E}`),{id:L}}S.modify=a;function s(g){const E=g.id.lastIndexOf("~");if(E!==-1)return g.id.substring(E+1)}S.getModifier=s;function l(g,E){return g.id===E.id&&g.color?.id===E.color?.id}S.isEqual=l})(M=e.ThemeIcon||(e.ThemeIcon={}))}),define(Ce[34],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(D){return n.test(D)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let y=0;y<R.length;y++)R[y]=Math.floor(Math.random()*256);return R};const M=new Uint8Array(16),S=[];for(let R=0;R<256;R++)S.push(R.toString(16).padStart(2,"0"));return function(){D(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,T="";return T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+="-",T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T+=S[M[y++]],T}}()}),define(Ce[116],ke([1,0,16,34]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function D(R){return{id:(0,C.generateUuid)(),asString:async()=>R,asFile:()=>{},value:typeof R=="string"?R:void 0}}e.createStringDataTransferItem=D;function M(R,y,T){return{id:(0,C.generateUuid)(),asString:async()=>"",asFile:()=>({name:R,uri:y,data:T}),value:void 0}}e.createFileDataTransferItem=M;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,T){const N=this.a.get(y);N?N.push(T):this.a.set(this.b(y),[T])}replace(y,T){this.a.set(this.b(y),[T])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,T]of this.a.entries())for(const N of T)yield[y,N]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[T,N]of this.entries())y(N,T)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:R=>(0,n.distinct)(R.map(y=>y.toString())).join(`\r
`),split:R=>R.split(`\r
`),parse:R=>e.UriList.split(R).filter(y=>!y.startsWith("#"))})}),define(Ce[117],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[118],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(n=e.IndentAction||(e.IndentAction={}));class C{constructor(R){if(this.e=null,this.f=!1,this.open=R.open,this.close=R.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(R.notIn))for(let y=0,T=R.notIn.length;y<T;y++)switch(R.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(R){switch(R){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(R,y){if(R.getTokenCount()===0)return!0;const T=R.findTokenIndexAtOffset(y-2),N=R.getStandardTokenType(T);return this.isOK(N)}g(R,y){for(let T=R;T<=y;T++){const N=String.fromCharCode(T);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=C;class D{constructor(R){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of R)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=D;function M(S,R,y){S.has(R)?S.get(R).push(y):S.set(R,[y])}}),define(Ce[119],ke([13,14]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Ce[120],ke([13,14]),function(te,e){return te.create("vs/base/common/date",e)}),define(Ce[121],ke([1,0,120]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,D=C*60,M=D*24,S=M*7,R=M*30,y=M*365;function T(w,h,b,m){typeof w!="number"&&(w=w.getTime());const a=Math.round((new Date().getTime()-w)/1e3);if(a<-30)return(0,n.localize)(0,null,T(new Date().getTime()+a*1e3,!1));if(!m&&a<30)return(0,n.localize)(1,null);let s;return a<C?(s=a,h?s===1?b?(0,n.localize)(2,null,s):(0,n.localize)(3,null,s):b?(0,n.localize)(4,null,s):(0,n.localize)(5,null,s):s===1?b?(0,n.localize)(6,null,s):(0,n.localize)(7,null,s):b?(0,n.localize)(8,null,s):(0,n.localize)(9,null,s)):a<D?(s=Math.floor(a/C),h?s===1?b?(0,n.localize)(10,null,s):(0,n.localize)(11,null,s):b?(0,n.localize)(12,null,s):(0,n.localize)(13,null,s):s===1?b?(0,n.localize)(14,null,s):(0,n.localize)(15,null,s):b?(0,n.localize)(16,null,s):(0,n.localize)(17,null,s)):a<M?(s=Math.floor(a/D),h?s===1?b?(0,n.localize)(18,null,s):(0,n.localize)(19,null,s):b?(0,n.localize)(20,null,s):(0,n.localize)(21,null,s):s===1?b?(0,n.localize)(22,null,s):(0,n.localize)(23,null,s):b?(0,n.localize)(24,null,s):(0,n.localize)(25,null,s)):a<S?(s=Math.floor(a/M),h?s===1?(0,n.localize)(26,null,s):(0,n.localize)(27,null,s):s===1?(0,n.localize)(28,null,s):(0,n.localize)(29,null,s)):a<R?(s=Math.floor(a/S),h?s===1?b?(0,n.localize)(30,null,s):(0,n.localize)(31,null,s):b?(0,n.localize)(32,null,s):(0,n.localize)(33,null,s):s===1?b?(0,n.localize)(34,null,s):(0,n.localize)(35,null,s):b?(0,n.localize)(36,null,s):(0,n.localize)(37,null,s)):a<y?(s=Math.floor(a/R),h?s===1?b?(0,n.localize)(38,null,s):(0,n.localize)(39,null,s):b?(0,n.localize)(40,null,s):(0,n.localize)(41,null,s):s===1?b?(0,n.localize)(42,null,s):(0,n.localize)(43,null,s):b?(0,n.localize)(44,null,s):(0,n.localize)(45,null,s)):(s=Math.floor(a/y),h?s===1?b?(0,n.localize)(46,null,s):(0,n.localize)(47,null,s):b?(0,n.localize)(48,null,s):(0,n.localize)(49,null,s):s===1?b?(0,n.localize)(50,null,s):(0,n.localize)(51,null,s):b?(0,n.localize)(52,null,s):(0,n.localize)(53,null,s))}e.fromNow=T;function N(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(Ce[122],ke([13,14]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Ce[39],ke([1,0,16,9,122]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(w,h){return h&&(w.stack||w.stacktrace)?D.localize(0,null,R(w),S(w.stack)||S(w.stacktrace)):R(w)}function S(w){return Array.isArray(w)?w.join(`
`):w}function R(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?D.localize(1,null,w.message):w.message||D.localize(2,null)}function y(w=null,h=!1){if(!w)return D.localize(3,null);if(Array.isArray(w)){const b=n.coalesce(w),m=y(b[0],h);return b.length>1?D.localize(4,null,m,b.length):m}if(C.isString(w))return w;if(w.detail){const b=w.detail;if(b.error)return M(b.error,h);if(b.exception)return M(b.exception,h)}return w.stack?M(w,h):w.message?w.message:D.localize(5,null)}e.toErrorMessage=y;function T(w){const h=w;return h instanceof Error&&Array.isArray(h.actions)}e.isErrorWithActions=T;function N(w,h){let b;return typeof w=="string"?b=new Error(w):b=w,b.actions=h,b}e.createErrorWithActions=N}),define(Ce[123],ke([1,0,85,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new n.Lazy(()=>{const o=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:o,collatorIsNumeric:o.resolvedOptions().numeric}}),M=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(o,f,k=!1){const A=o||"",V=f||"",_=D.value.collator.compare(A,V);return D.value.collatorIsNumeric&&_===0&&A!==V?A<V?-1:1:_}e.compareFileNames=R;function y(o,f){const k=M.value.collator;return o=o||"",f=f||"",L(k,o,f)}e.compareFileNamesDefault=y;function T(o,f){const k=M.value.collator;return o=o||"",f=f||"",r(o,f)||L(k,o,f)}e.compareFileNamesUpper=T;function N(o,f){const k=M.value.collator;return o=o||"",f=f||"",d(o,f)||L(k,o,f)}e.compareFileNamesLower=N;function w(o,f){return o=o||"",f=f||"",o===f?0:o<f?-1:1}e.compareFileNamesUnicode=w;function h(o,f){const[k,A]=g(o),[V,_]=g(f);let K=D.value.collator.compare(A,_);if(K===0){if(D.value.collatorIsNumeric&&A!==_)return A<_?-1:1;if(K=D.value.collator.compare(k,V),D.value.collatorIsNumeric&&K===0&&k!==V)return k<V?-1:1}return K}e.compareFileExtensions=h;function b(o,f){o=o||"",f=f||"";const k=E(o),A=E(f),V=M.value.collator,_=S.value.collator;return L(_,k,A)||L(V,o,f)}e.compareFileExtensionsDefault=b;function m(o,f){o=o||"",f=f||"";const k=E(o),A=E(f),V=M.value.collator,_=S.value.collator;return L(_,k,A)||r(o,f)||L(V,o,f)}e.compareFileExtensionsUpper=m;function a(o,f){o=o||"",f=f||"";const k=E(o),A=E(f),V=M.value.collator,_=S.value.collator;return L(_,k,A)||d(o,f)||L(V,o,f)}e.compareFileExtensionsLower=a;function s(o,f){o=o||"",f=f||"";const k=E(o).toLowerCase(),A=E(f).toLowerCase();return k!==A?k<A?-1:1:o!==f?o<f?-1:1:0}e.compareFileExtensionsUnicode=s;const l=/^(.*?)(\.([^.]*))?$/;function g(o,f=!1){const k=o?l.exec(o):[];let A=[k&&k[1]||"",k&&k[3]||""];return f&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function E(o){const f=o?l.exec(o):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function L(o,f,k){const A=o.compare(f,k);return A!==0?A:f.length!==k.length?f.length<k.length?-1:1:0}function v(o){const f=o.charAt(0);return f.toLocaleUpperCase()!==f}function t(o){const f=o.charAt(0);return f.toLocaleLowerCase()!==f}function d(o,f){return v(o)&&t(f)?-1:t(o)&&v(f)?1:0}function r(o,f){return t(o)&&v(f)?-1:v(o)&&t(f)?1:0}function u(o,f,k=!1){return k||(o=o&&o.toLowerCase(),f=f&&f.toLowerCase()),o===f?0:o<f?-1:1}function i(o,f,k=!1){const A=o.split(C.sep),V=f.split(C.sep),_=A.length-1,K=V.length-1;let O,B;for(let P=0;;P++){if(O=_===P,B=K===P,O&&B)return R(A[P],V[P],k);if(O)return-1;if(B)return 1;const F=u(A[P],V[P],k);if(F!==0)return F}}e.comparePaths=i;function p(o,f,k){const A=o.toLowerCase(),V=f.toLowerCase(),_=c(o,f,k);if(_)return _;const K=A.endsWith(k),O=V.endsWith(k);if(K!==O)return K?-1:1;const B=R(A,V);return B!==0?B:A.localeCompare(V)}e.compareAnything=p;function c(o,f,k){const A=o.toLowerCase(),V=f.toLowerCase(),_=A.startsWith(k),K=V.startsWith(k);if(_!==K)return _?-1:1;if(_&&K){if(A.length<V.length)return-1;if(A.length>V.length)return 1}return 0}e.compareByPrefix=c}),define(Ce[64],ke([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(N){const w=(0,n.extname)(N),h=C[w.toLowerCase()];return h!==void 0?h:S(N)}e.getMediaOrTextMime=M;function S(N){const w=(0,n.extname)(N);return D[w.toLowerCase()]}e.getMediaMime=S;function R(N){for(const w in D)if(D[w]===N)return w}e.getExtensionForMimeType=R;const y=/^(.+)\/(.+?)(;.+)?$/;function T(N,w){const h=y.exec(N);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:w?void 0:N}e.normalizeMimeType=T}),define(Ce[124],ke([1,0,4,6,119]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class M extends C.Disposable{constructor(h,b="",m="",a=!0,s){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=b,this.u=m,this.w=a,this.C=s}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,b){this.C&&await this.C(h)}}e.Action=M;class S extends C.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(h,b){if(!h.enabled)return;this.f.fire({action:h});let m;try{await this.runAction(h,b)}catch(a){m=a}this.h.fire({action:h,error:m})}async runAction(h,b){await h.run(b)}}e.ActionRunner=S;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let b=[];for(const m of h)m.length&&(b.length?b=[...b,new R,...m]:b=m);return b}async run(){}}R.ID="vs.actions.separator",e.Separator=R;class y{get actions(){return this.a}constructor(h,b,m,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=b,this.class=a,this.a=m}async run(){}}e.SubmenuAction=y;class T extends M{constructor(){super(T.ID,D.localize(0,null),void 0,!1)}}T.ID="vs.actions.empty",e.EmptySubmenuAction=T;function N(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=N}),define(Ce[40],ke([1,0,19,21,10,9]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(i){return i===47||i===92}e.isPathSeparator=S;function R(i){return i.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=R;function y(i){return i.indexOf("/")===-1&&(i=R(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function T(i,p=n.posix.sep){if(!i)return"";const c=i.length,o=i.charCodeAt(0);if(S(o)){if(S(i.charCodeAt(1))&&!S(i.charCodeAt(2))){let k=3;const A=k;for(;k<c&&!S(i.charCodeAt(k));k++);if(A!==k&&!S(i.charCodeAt(k+1))){for(k+=1;k<c;k++)if(S(i.charCodeAt(k)))return i.slice(0,k+1).replace(/[\\/]/g,p)}}return p}else if(l(o)&&i.charCodeAt(1)===58)return S(i.charCodeAt(2))?i.slice(0,2)+p:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(S(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=T;function N(i){if(!C.isWindows||!i||i.length<5)return!1;let p=i.charCodeAt(0);if(p!==92||(p=i.charCodeAt(1),p!==92))return!1;let c=2;const o=c;for(;c<i.length&&(p=i.charCodeAt(c),p!==92);c++);return!(o===c||(p=i.charCodeAt(c+1),isNaN(p)||p===92))}e.isUNC=N;const w=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(i,p=C.isWindows){const c=p?w:h;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||p&&b.test(i)||i==="."||i===".."||p&&i[i.length-1]==="."||p&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=m;function a(i,p,c){const o=i===p;return!c||o?o:!i||!p?!1:(0,D.equalsIgnoreCase)(i,p)}e.isEqual=a;function s(i,p,c,o=n.sep){if(i===p)return!0;if(!i||!p||p.length>i.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(i,p))return!1;if(p.length===i.length)return!0;let k=p.length;return p.charAt(p.length-1)===o&&k--,i.charAt(k)===o}return p.charAt(p.length-1)!==o&&(p+=o),i.indexOf(p)===0}e.isEqualOrParent=s;function l(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=l;function g(i,p){return C.isWindows&&i.endsWith(":")&&(i+=n.sep),(0,n.isAbsolute)(i)||(i=(0,n.join)(p,i)),i=(0,n.normalize)(i),C.isWindows?(i=(0,D.rtrim)(i,n.sep),i.endsWith(":")&&(i+=n.sep)):(i=(0,D.rtrim)(i,n.sep),i||(i=n.sep)),i}e.sanitizeFilePath=g;function E(i){const p=(0,n.normalize)(i);return C.isWindows?i.length>3?!1:L(p)&&(i.length===2||p.charCodeAt(2)===92):p===n.posix.sep}e.isRootOrDriveLetter=E;function L(i,p=C.isWindows){return p?l(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=L;function v(i){return L(i)?i[0]:void 0}e.getDriveLetter=v;function t(i,p,c){return p.length>i.length?-1:i===p?0:(c&&(i=i.toLowerCase(),p=p.toLowerCase()),i.indexOf(p))}e.indexOfPath=t;function d(i){const p=i.split(":");let c,o,f;for(const k of p){const A=Number(k);(0,M.isNumber)(A)?o===void 0?o=A:f===void 0&&(f=A):c=c?[c,k].join(":"):k}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:o!==void 0?o:void 0,column:f!==void 0?f:o!==void 0?1:void 0}}e.parseLineAndColumnAware=d;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(i,p,c=8){let o="";for(let k=0;k<c;k++)o+=r.charAt(Math.floor(Math.random()*r.length));let f;return p?f=`${p}-${o}`:f=o,i?(0,n.join)(i,f):f}e.randomPath=u}),define(Ce[125],ke([1,0,28,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...J){return function(I,$){for(let W=0,q=J.length;W<q;W++){const ee=J[W](I,$);if(ee)return ee}return null}}e.or=D,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,I,$){if(!$||$.length<I.length)return null;let W;return J?W=C.startsWithIgnoreCase($,I):W=$.indexOf(I)===0,W?I.length>0?[{start:0,end:I.length}]:[]:null}function S(J,I){const $=I.toLowerCase().indexOf(J.toLowerCase());return $===-1?null:[{start:$,end:$+J.length}]}e.matchesContiguousSubString=S;function R(J,I){return y(J.toLowerCase(),I.toLowerCase(),0,0)}e.matchesSubString=R;function y(J,I,$,W){if($===J.length)return[];if(W===I.length)return null;if(J[$]===I[W]){let q=null;return(q=y(J,I,$+1,W+1))?l({start:W,end:W+1},q):null}return y(J,I,$,W+1)}function T(J){return 97<=J&&J<=122}function N(J){return 65<=J&&J<=90}e.isUpper=N;function w(J){return 48<=J&&J<=57}function h(J){return J===32||J===9||J===10||J===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>b.add(J.charCodeAt(0)));function m(J){return h(J)||b.has(J)}function a(J,I){return J===I||m(J)&&m(I)}function s(J){return T(J)||N(J)||w(J)}function l(J,I){return I.length===0?I=[J]:J.end===I[0].start?I[0].start=J.start:I.unshift(J),I}function g(J,I){for(let $=I;$<J.length;$++){const W=J.charCodeAt($);if(N(W)||w(W)||$>0&&!s(J.charCodeAt($-1)))return $}return J.length}function E(J,I,$,W){if($===J.length)return[];if(W===I.length)return null;if(J[$]!==I[W].toLowerCase())return null;{let q=null,ee=W+1;for(q=E(J,I,$+1,W+1);!q&&(ee=g(I,ee))<I.length;)q=E(J,I,$+1,ee),ee++;return q===null?null:l({start:W,end:W+1},q)}}function L(J){let I=0,$=0,W=0,q=0,ee=0;for(let Ee=0;Ee<J.length;Ee++)ee=J.charCodeAt(Ee),N(ee)&&I++,T(ee)&&$++,s(ee)&&W++,w(ee)&&q++;const me=I/J.length,ye=$/J.length,ce=W/J.length,be=q/J.length;return{upperPercent:me,lowerPercent:ye,alphaPercent:ce,numericPercent:be}}function v(J){const{upperPercent:I,lowerPercent:$}=J;return $===0&&I>.6}function t(J){const{upperPercent:I,lowerPercent:$,alphaPercent:W,numericPercent:q}=J;return $>.2&&I<.8&&W>.6&&q<.2}function d(J){let I=0,$=0,W=0,q=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),N(W)&&I++,T(W)&&$++,h(W)&&q++;return(I===0||$===0)&&q===0?J.length<=30:I<=5}function r(J,I){if(!I||(I=I.trim(),I.length===0)||!d(J)||I.length>60)return null;const $=L(I);if(!t($)){if(!v($))return null;I=I.toLowerCase()}let W=null,q=0;for(J=J.toLowerCase();q<I.length&&(W=E(J,I,0,q))===null;)q=g(I,q+1);return W}e.matchesCamelCase=r;function u(J,I,$=!1){if(!I||I.length===0)return null;let W=null,q=0;for(J=J.toLowerCase(),I=I.toLowerCase();q<I.length&&(W=i(J,I,0,q,$))===null;)q=p(I,q+1);return W}e.matchesWords=u;function i(J,I,$,W,q){if($===J.length)return[];if(W===I.length)return null;if(a(J.charCodeAt($),I.charCodeAt(W))){let ee=null,me=W+1;if(ee=i(J,I,$+1,W+1,q),!q)for(;!ee&&(me=p(I,me))<I.length;)ee=i(J,I,$+1,me,q),me++;return ee?J.charCodeAt($)!==I.charCodeAt(W)?ee:l({start:W,end:W+1},ee):null}else return null}function p(J,I){for(let $=I;$<J.length;$++)if(m(J.charCodeAt($))||$>0&&m(J.charCodeAt($-1)))return $;return J.length}const c=D(e.matchesPrefix,r,S),o=D(e.matchesPrefix,r,R),f=new n.LRUCache(1e4);function k(J,I,$=!1){if(typeof J!="string"||typeof I!="string")return null;let W=f.get(J);W||(W=new RegExp(C.convertSimple2RegExpPattern(J),"i"),f.set(J,W));const q=W.exec(I);return q?[{start:q.index,end:q.index+q[0].length}]:$?o(J,I):c(J,I)}e.matchesFuzzy=k;function A(J,I){const $=Ne(J,J.toLowerCase(),0,I,I.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?_($):null}e.matchesFuzzy2=A;function V(J,I,$,W,q,ee){const me=Math.min(13,J.length);for(;$<me;$++){const ye=Ne(J,I,$,W,q,ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ye)return ye}return[0,ee]}e.anyScore=V;function _(J){if(typeof J>"u")return[];const I=[],$=J[1];for(let W=J.length-1;W>1;W--){const q=J[W]+$,ee=I[I.length-1];ee&&ee.end===q?ee.end=q+1:I.push({start:q,end:q+1})}return I}e.createMatches=_;const K=128;function O(){const J=[],I=[];for(let $=0;$<=K;$++)I[$]=0;for(let $=0;$<=K;$++)J.push(I.slice(0));return J}function B(J){const I=[];for(let $=0;$<=J;$++)I[$]=0;return I}const P=B(2*K),F=B(2*K),H=O(),j=O(),de=O(),pe=!1;function re(J,I,$,W,q){function ee(ye,ce,be=" "){for(;ye.length<ce;)ye=be+ye;return ye}let me=` |   |${W.split("").map(ye=>ee(ye,3)).join("|")}
`;for(let ye=0;ye<=$;ye++)ye===0?me+=" |":me+=`${I[ye-1]}|`,me+=J[ye].slice(0,q+1).map(ce=>ee(ce.toString(),3)).join("|")+`
`;return me}function ue(J,I,$,W){J=J.substr(I),$=$.substr(W),console.log(re(j,J,J.length,$,$.length)),console.log(re(de,J,J.length,$,$.length)),console.log(re(H,J,J.length,$,$.length))}function ae(J,I){if(I<0||I>=J.length)return!1;const $=J.codePointAt(I);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.isEmojiImprecise($)}}function se(J,I){if(I<0||I>=J.length)return!1;switch(J.charCodeAt(I)){case 32:case 9:return!0;default:return!1}}function Y(J,I,$){return I[J]!==$[J]}function G(J,I,$,W,q,ee,me=!1){for(;I<$&&q<ee;)J[I]===W[q]&&(me&&(P[I]=q),I+=1),q+=1;return I===$}e.isPatternInWord=G;var Z;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var he;(function(J){J.Default=[-100,0];function I($){return!$||$.length===2&&$[0]===-100&&$[1]===0}J.isDefault=I})(he=e.FuzzyScore||(e.FuzzyScore={}));class Te{constructor(I,$){this.firstMatchCanBeWeak=I,this.boostFullMatch=$}}Te.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=Te;function Ne(J,I,$,W,q,ee,me=Te.default){const ye=J.length>K?K:J.length,ce=W.length>K?K:W.length;if($>=ye||ee>=ce||ye-$>ce-ee||!G(I,$,ye,q,ee,ce,!0))return;Ke(ye,ce,$,ee,I,q);let be=1,Ee=1,We=$,Ve=ee;const tt=[!1];for(be=1,We=$;We<ye;be++,We++){const Fe=P[We],ot=F[We],Q=We+1<ye?F[We+1]:ce;for(Ee=Fe-ee+1,Ve=Fe;Ve<Q;Ee++,Ve++){let X=Number.MIN_SAFE_INTEGER,ve=!1;Ve<=ot&&(X=Pe(J,I,We,$,W,q,Ve,ce,ee,H[be-1][Ee-1]===0,tt));let Me=0;X!==Number.MAX_SAFE_INTEGER&&(ve=!0,Me=X+j[be-1][Ee-1]);const ze=Ve>Fe,He=ze?j[be][Ee-1]+(H[be][Ee-1]>0?-5:0):0,Ye=Ve>Fe+1&&H[be][Ee-1]>0,nt=Ye?j[be][Ee-2]+(H[be][Ee-2]>0?-5:0):0;if(Ye&&(!ze||nt>=He)&&(!ve||nt>=Me))j[be][Ee]=nt,de[be][Ee]=3,H[be][Ee]=0;else if(ze&&(!ve||He>=Me))j[be][Ee]=He,de[be][Ee]=2,H[be][Ee]=0;else if(ve)j[be][Ee]=Me,de[be][Ee]=1,H[be][Ee]=H[be-1][Ee-1]+1;else throw new Error("not possible")}}if(pe&&ue(J,$,W,ee),!tt[0]&&!me.firstMatchCanBeWeak)return;be--,Ee--;const Xe=[j[be][Ee],ee];let et=0,it=0;for(;be>=1;){let Fe=Ee;do{const ot=de[be][Fe];if(ot===3)Fe=Fe-2;else if(ot===2)Fe=Fe-1;else break}while(Fe>=1);et>1&&I[$+be-1]===q[ee+Ee-1]&&!Y(Fe+ee-1,W,q)&&et+1>H[be][Fe]&&(Fe=Ee),Fe===Ee?et++:et=1,it||(it=Fe),be--,Ee=Fe-1,Xe.push(Ee)}ce===ye&&me.boostFullMatch&&(Xe[0]+=2);const dt=it-ye;return Xe[0]-=dt,Xe}e.fuzzyScore=Ne;function Ke(J,I,$,W,q,ee){let me=J-1,ye=I-1;for(;me>=$&&ye>=W;)q[me]===ee[ye]&&(F[me]=ye,me--),ye--}function Pe(J,I,$,W,q,ee,me,ye,ce,be,Ee){if(I[$]!==ee[me])return Number.MIN_SAFE_INTEGER;let We=1,Ve=!1;return me===$-W?We=J[$]===q[me]?7:5:Y(me,q,ee)&&(me===0||!Y(me-1,q,ee))?(We=J[$]===q[me]?7:5,Ve=!0):ae(ee,me)&&(me===0||!ae(ee,me-1))?We=5:(ae(ee,me-1)||se(ee,me-1))&&(We=5,Ve=!0),We>1&&$===W&&(Ee[0]=!0),Ve||(Ve=Y(me,q,ee)||ae(ee,me-1)||se(ee,me-1)),$===W?me>ce&&(We-=Ve?3:5):be?We+=Ve?2:0:We+=Ve?0:1,me+1===ye&&(We-=Ve?3:5),We}function Se(J,I,$,W,q,ee,me){return oe(J,I,$,W,q,ee,!0,me)}e.fuzzyScoreGracefulAggressive=Se;function Ie(J,I,$,W,q,ee,me){return oe(J,I,$,W,q,ee,!1,me)}e.fuzzyScoreGraceful=Ie;function oe(J,I,$,W,q,ee,me,ye){let ce=Ne(J,I,$,W,q,ee,ye);if(ce&&!me)return ce;if(J.length>=3){const be=Math.min(7,J.length-1);for(let Ee=$+1;Ee<be;Ee++){const We=le(J,Ee);if(We){const Ve=Ne(We,We.toLowerCase(),$,W,q,ee,ye);Ve&&(Ve[0]-=3,(!ce||Ve[0]>ce[0])&&(ce=Ve))}}}return ce}function le(J,I){if(I+1>=J.length)return;const $=J[I],W=J[I+1];if($!==W)return J.slice(0,I)+W+$+J.slice(I+2)}}),define(Ce[126],ke([1,0,125,10,38]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const M="$(",S=new RegExp(`\\$\\(${D.ThemeIcon.iconNameExpression}(?:${D.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${S.source}`,"g");function y(l){return l.replace(R,(g,E)=>E?g:`\\${g}`)}e.escapeIcons=y;const T=new RegExp(`\\\\${S.source}`,"g");function N(l){return l.replace(T,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=N;const w=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function h(l){return l.indexOf(M)===-1?l:l.replace(w,(g,E,L,v)=>L?g:E||v||"")}e.stripIcons=h;function b(l){return l?l.replace(/\$\((.*?)\)/g,(g,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=b;const m=new RegExp(`\\$\\(${D.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(l){m.lastIndex=0;let g="";const E=[];let L=0;for(;;){const v=m.lastIndex,t=m.exec(l),d=l.substring(v,t?.index);if(d.length>0){g+=d;for(let r=0;r<d.length;r++)E.push(L)}if(!t)break;L+=t[0].length}return{text:g,iconOffsets:E}}e.parseLabelWithIcons=a;function s(l,g,E=!1){const{text:L,iconOffsets:v}=g;if(!v||v.length===0)return(0,n.matchesFuzzy)(l,L,E);const t=(0,C.ltrim)(L," "),d=L.length-t.length,r=(0,n.matchesFuzzy)(l,t,E);if(r)for(const u of r){const i=v[u.start+d]+d;u.start+=i,u.end+=i}return r}e.matchesFuzzyIconAware=s}),define(Ce[29],ke([1,0,10]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(C||(C={})),function(D){const M="error",S="warning",R="warn",y="info",T="ignore";function N(h){return h?n.equalsIgnoreCase(M,h)?D.Error:n.equalsIgnoreCase(S,h)||n.equalsIgnoreCase(R,h)?D.Warning:n.equalsIgnoreCase(y,h)?D.Info:D.Ignore:D.Ignore}D.fromValue=N;function w(h){switch(h){case D.Error:return M;case D.Warning:return S;case D.Info:return y;default:return T}}D.toString=w}(C||(C={})),e.default=C}),define(Ce[48],ke([1,0,16,10]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const m=b.charCodeAt(0),a=this.b.charCodeAt(this.c);return m-a}value(){return this.b[this.c]}}e.StringIterator=D;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.compareSubstring)(b,this.b,0,b.length,this.c,this.d):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=M;class S{constructor(b=!0,m=!0){this.f=b,this.g=m}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let m=b.length-1;m>=0;m--,this.c--){const a=this.b.charCodeAt(m);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.compareSubstring)(b,this.b,0,b.length,this.d,this.e):(0,C.compareSubstringIgnoreCase)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var R;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(R||(R={}));class y{constructor(b,m){this.f=b,this.g=m,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.compareIgnoreCase)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.compareIgnoreCase)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.compare)(b,this.c.query);if(this.d[this.e]===5)return(0,C.compare)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(N||(N={}));class w{static forUris(b=()=>!1,m=()=>!1){return new w(new y(b,m))}static forPaths(b=!1){return new w(new S(void 0,!b))}static forStrings(){return new w(new D)}static forConfigKeys(){return new w(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,m){if(m){const a=m.slice(0);(0,n.shuffle)(a);for(const s of a)this.set(s,b)}else{const a=b.slice(0);(0,n.shuffle)(a);for(const s of a)this.set(s[0],s[1])}}set(b,m){const a=this.b.reset(b);let s;this.c||(this.c=new T,this.c.segment=a.value());const l=[];for(s=this.c;;){const E=a.cmp(s.segment);if(E>0)s.left||(s.left=new T,s.left.segment=a.value()),l.push([-1,s]),s=s.left;else if(E<0)s.right||(s.right=new T,s.right.segment=a.value()),l.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new T,s.mid.segment=a.value()),l.push([0,s]),s=s.mid;else break}const g=s.value;s.value=m,s.key=b;for(let E=l.length-1;E>=0;E--){const L=l[E][1];L.updateHeight();const v=L.balanceFactor();if(v<-1||v>1){const t=l[E][0],d=l[E+1][0];if(t===1&&d===1)l[E][1]=L.rotateLeft();else if(t===-1&&d===-1)l[E][1]=L.rotateRight();else if(t===1&&d===-1)L.right=l[E+1][1]=l[E+1][1].rotateRight(),l[E][1]=L.rotateLeft();else if(t===-1&&d===1)L.left=l[E+1][1]=l[E+1][1].rotateLeft(),l[E][1]=L.rotateRight();else throw new Error;if(E>0)switch(l[E-1][0]){case-1:l[E-1][1].left=l[E][1];break;case 1:l[E-1][1].right=l[E][1];break;case 0:l[E-1][1].mid=l[E][1];break}else this.c=l[0][1]}}return g}get(b){return this.d(b)?.value}d(b){const m=this.b.reset(b);let a=this.c;for(;a;){const s=m.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else break}return a}has(b){const m=this.d(b);return!(m?.value===void 0&&m?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,m){const a=this.b.reset(b),s=[];let l=this.c;for(;l;){const g=a.cmp(l.segment);if(g>0)s.push([-1,l]),l=l.left;else if(g<0)s.push([1,l]),l=l.right;else if(a.hasNext())a.next(),s.push([0,l]),l=l.mid;else break}if(!!l){if(m?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const g=this.f(l.right);if(g.key){const{key:E,value:L,segment:v}=g;this.e(g.key,!1),l.key=E,l.value=L,l.segment=v}}else{const g=l.left??l.right;if(s.length>0){const[E,L]=s[s.length-1];switch(E){case-1:L.left=g;break;case 0:L.mid=g;break;case 1:L.right=g;break}}else this.c=g}for(let g=s.length-1;g>=0;g--){const E=s[g][1];E.updateHeight();const L=E.balanceFactor();if(L>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),s[g][1]=E.rotateLeft()):L<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),s[g][1]=E.rotateRight()),g>0)switch(s[g-1][0]){case-1:s[g-1][1].left=s[g][1];break;case 1:s[g-1][1].right=s[g][1];break;case 0:s[g-1][1].mid=s[g][1];break}else this.c=s[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const m=this.b.reset(b);let a=this.c,s;for(;a;){const l=m.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(m.hasNext())m.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(b){return this.g(b,!1)}g(b,m){const a=this.b.reset(b);let s=this.c;for(;s;){const l=a.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):m?s.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[m,a]of this)b(a,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const m=[];return this.j(b,m),m[Symbol.iterator]()}j(b,m){!b||(b.left&&this.j(b.left,m),b.value&&m.push([b.key,b.value]),b.mid&&this.j(b.mid,m),b.right&&this.j(b.right,m))}_isBalanced(){const b=m=>{if(!m)return!0;const a=m.balanceFactor();return a<-1||a>1?!1:b(m.left)&&b(m.right)};return b(this.c)}}e.TernarySearchTree=w}),define(Ce[65],ke([1,0,23,10,2]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,R)}e.stringify=M;function S(T){let N=JSON.parse(T);return N=y(N),N}e.parse=S;function R(T,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,C.regExpFlags)(N)}:N}function y(T,N=0){if(!T||N>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return D.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 16:return new Date(T.source)}if(T instanceof n.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let w=0;w<T.length;++w)T[w]=y(T[w],N+1);else for(const w in T)Object.hasOwnProperty.call(T,w)&&(T[w]=y(T[w],N+1))}return T}e.revive=y}),define(Ce[15],ke([1,0,12,21,2]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var M;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.vscodeUserData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls",T.vscodeSourceControl="vscode-scm"})(M=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(N){this.d=N}setDelegate(N){this.e=N}setServerRootPath(N){this.f=`${N}/${M.vscodeRemoteResource}`}set(N,w,h){this.a[N]=w,this.b[N]=h}setConnectionToken(N,w){this.c[N]=w}getPreferredWebSchema(){return this.d}rewrite(N){if(this.e)try{return this.e(N)}catch(s){return n.onUnexpectedError(s),N}const w=N.authority;let h=this.a[w];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const b=this.b[w],m=this.c[w];let a=`path=${encodeURIComponent(N.path)}`;return typeof m=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),D.URI.from({scheme:C.isWeb?this.d:M.vscodeRemoteResource,authority:`${h}:${b}`,path:this.f,query:a})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(N){const w=this.b(N,te);return this.uriToBrowserUri(w)}uriToBrowserUri(N){return N.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===M.file&&(C.isNative||C.isWebWorker&&C.globals.origin===`${M.vscodeFileResource}://${R.a}`)?N.with({scheme:M.vscodeFileResource,authority:N.authority||R.a,query:null,fragment:null}):N}asFileUri(N){const w=this.b(N,te);return this.uriToFileUri(w)}uriToFileUri(N){return N.scheme===M.vscodeFileResource?N.with({scheme:M.file,authority:N.authority!==R.a?N.authority:null,query:null,fragment:null}):N}b(N,w){return D.URI.isUri(N)?N:D.URI.parse(w.toUrl(N))}}R.a="vscode-app",e.FileAccess=new R;var y;(function(T){const N=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);T.CoopAndCoep=Object.freeze(N.get("3"));const w="vscode-coi";function h(m){let a;typeof m=="string"?a=new URL(m).searchParams:m instanceof URL?a=m.searchParams:D.URI.isUri(m)&&(a=new URL(m.toString(!0)).searchParams);const s=a?.get(w);if(!!s)return N.get(s)}T.getHeadersFromQuery=h;function b(m,a,s){if(!globalThis.crossOriginIsolated)return;const l=a&&s?"3":s?"2":"1";m instanceof URLSearchParams?m.set(w,l):m[w]=l}T.addSearchParam=b})(y=e.COI||(e.COI={}))}),define(Ce[24],ke([1,0,40,15,19,21,10,2]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(b){return(0,R.uriToFsPath)(b,!0)}e.originalFSPath=y;class T{constructor(m){this.a=m}compare(m,a,s=!1){return m===a?0:(0,S.compare)(this.getComparisonKey(m,s),this.getComparisonKey(a,s))}isEqual(m,a,s=!1){return m===a?!0:!m||!a?!1:this.getComparisonKey(m,s)===this.getComparisonKey(a,s)}getComparisonKey(m,a=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,a,s=!1){if(m.scheme===a.scheme){if(m.scheme===C.Schemas.file)return n.isEqualOrParent(y(m),y(a),this.a(m))&&m.query===a.query&&(s||m.fragment===a.fragment);if((0,e.isEqualAuthority)(m.authority,a.authority))return n.isEqualOrParent(m.path,a.path,this.a(m),"/")&&m.query===a.query&&(s||m.fragment===a.fragment)}return!1}joinPath(m,...a){return R.URI.joinPath(m,...a)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return D.posix.basename(m.path)}extname(m){return D.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let a;return m.scheme===C.Schemas.file?a=R.URI.file(D.dirname(y(m))).path:(a=D.posix.dirname(m.path),m.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),a="/")),m.with({path:a})}normalizePath(m){if(!m.path.length)return m;let a;return m.scheme===C.Schemas.file?a=R.URI.file(D.normalize(y(m))).path:a=D.posix.normalize(m.path),m.with({path:a})}relativePath(m,a){if(m.scheme!==a.scheme||!(0,e.isEqualAuthority)(m.authority,a.authority))return;if(m.scheme===C.Schemas.file){const g=D.relative(y(m),y(a));return M.isWindows?n.toSlashes(g):g}let s=m.path||"/";const l=a.path||"/";if(this.a(m)){let g=0;for(const E=Math.min(s.length,l.length);g<E&&!(s.charCodeAt(g)!==l.charCodeAt(g)&&s.charAt(g).toLowerCase()!==l.charAt(g).toLowerCase());g++);s=l.substr(0,g)+s.substr(g)}return D.posix.relative(s,l)}resolvePath(m,a){if(m.scheme===C.Schemas.file){const s=R.URI.file(D.resolve(y(m),a));return m.with({authority:s.authority,path:s.path})}return a=n.toPosixPath(a),m.with({path:D.posix.resolve(m.path,a)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,a){return m===a||m!==void 0&&a!==void 0&&(0,S.equalsIgnoreCase)(m,a)}hasTrailingPathSeparator(m,a=D.sep){if(m.scheme===C.Schemas.file){const s=y(m);return s.length>n.getRoot(s).length&&s[s.length-1]===a}else{const s=m.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,a=D.sep){return(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,a=D.sep){let s=!1;if(m.scheme===C.Schemas.file){const l=y(m);s=l!==void 0&&l.length===n.getRoot(l).length&&l[l.length-1]===a}else{a="/";const l=m.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(m,a)?m.with({path:m.path+"/"}):m}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(b=>b.scheme===C.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(b,m){const a=[];for(let s=0;s<b.length;s++){const l=m(b[s]);b.some((g,E)=>E===s?!1:(0,e.isEqualOrParent)(l,m(g)))||a.push(b[s])}return a}e.distinctParents=N;var w;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function m(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(E=>{const[L,v]=E.split(":");L&&v&&s.set(L,v)});const g=a.path.substring(0,a.path.indexOf(";"));return g&&s.set(b.META_DATA_MIME,g),s}b.parseMetaData=m})(w=e.DataUri||(e.DataUri={}));function h(b,m,a){if(m){let s=b.path;return s&&s[0]!==D.posix.sep&&(s=D.posix.sep+s),b.with({scheme:a,authority:m,path:s})}return b.with({scheme:a})}e.toLocalResource=h}),define(Ce[17],ke([1,0,20,12,4,6,24,21,115]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(G){return!!G&&typeof G.then=="function"}e.isThenable=T;function N(G){const Z=new n.CancellationTokenSource,he=G(Z.token),Te=new Promise((Ne,Ke)=>{const Pe=Z.token.onCancellationRequested(()=>{Pe.dispose(),Z.dispose(),Ke(new C.CancellationError)});Promise.resolve(he).then(Se=>{Pe.dispose(),Z.dispose(),Ne(Se)},Se=>{Pe.dispose(),Z.dispose(),Ke(Se)})});return new class{cancel(){Z.cancel()}then(Ne,Ke){return Te.then(Ne,Ke)}catch(Ne){return this.then(void 0,Ne)}finally(Ne){return Te.finally(Ne)}}}e.createCancelablePromise=N;function w(G,Z,he){return new Promise((Te,Ne)=>{const Ke=Z.onCancellationRequested(()=>{Ke.dispose(),Te(he)});G.then(Te,Ne).finally(()=>Ke.dispose())})}e.raceCancellation=w;function h(G,Z){return new Promise((he,Te)=>{const Ne=Z.onCancellationRequested(()=>{Ne.dispose(),Te(new C.CancellationError)});G.then(he,Te).finally(()=>Ne.dispose())})}e.raceCancellationError=h;async function b(G){let Z=-1;const he=G.map((Ne,Ke)=>Ne.then(Pe=>(Z=Ke,Pe))),Te=await Promise.race(he);return G.forEach((Ne,Ke)=>{Ke!==Z&&Ne.cancel()}),Te}e.raceCancellablePromises=b;function m(G,Z,he){let Te;const Ne=setTimeout(()=>{Te?.(void 0),he?.()},Z);return Promise.race([G.finally(()=>clearTimeout(Ne)),new Promise(Ke=>Te=Ke)])}e.raceTimeout=m;function a(G){return new Promise((Z,he)=>{const Te=G();T(Te)?Te.then(Z,he):Z(Te)})}e.asPromise=a;class s{constructor(){this.a=null,this.b=null,this.d=null}queue(Z){if(this.a){if(this.d=Z,!this.b){const he=()=>{this.b=null;const Te=this.queue(this.d);return this.d=null,Te};this.b=new Promise(Te=>{this.a.then(he,he).then(Te)})}return new Promise((he,Te)=>{this.b.then(he,Te)})}return this.a=Z(),new Promise((he,Te)=>{this.a.then(Ne=>{this.a=null,he(Ne)},Ne=>{this.a=null,Te(Ne)})})}}e.Throttler=s;class l{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.Sequencer=l;class g{constructor(){this.a=new Map}queue(Z,he){const Ne=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(Z)===Ne&&this.a.delete(Z)});return this.a.set(Z,Ne),Ne}}e.SequencerByKey=g;const E=(G,Z)=>{let he=!0;const Te=setTimeout(()=>{he=!1,Z()},G);return{isTriggered:()=>he,dispose:()=>{clearTimeout(Te),he=!1}}},L=G=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,G())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class v{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,he=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((Ne,Ke)=>{this.d=Ne,this.f=Ke}).then(()=>{if(this.b=null,this.d=null,this.g){const Ne=this.g;return this.g=null,Ne()}}));const Te=()=>{this.a=null,this.d?.(null)};return this.a=he===y.MicrotaskDelay?L(Te):E(he,Te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class t{constructor(Z){this.a=new v(Z),this.b=new s}trigger(Z,he){return this.a.trigger(()=>this.b.queue(Z),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class d{constructor(){this.a=!1,this.b=new Promise((Z,he)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=d;class r extends d{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function u(G,Z){return Z?new Promise((he,Te)=>{const Ne=setTimeout(()=>{Ke.dispose(),he()},G),Ke=Z.onCancellationRequested(()=>{clearTimeout(Ne),Ke.dispose(),Te(new C.CancellationError)})}):N(he=>u(G,he))}e.timeout=u;function i(G,Z=0){const he=setTimeout(G,Z);return(0,M.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=i;function p(G){const Z=[];let he=0;const Te=G.length;function Ne(){return he<Te?G[he++]():null}function Ke(Pe){Pe!=null&&Z.push(Pe);const Se=Ne();return Se?Se.then(Ke):Promise.resolve(Z)}return Promise.resolve(null).then(Ke)}e.sequence=p;function c(G,Z=Te=>!!Te,he=null){let Te=0;const Ne=G.length,Ke=()=>{if(Te>=Ne)return Promise.resolve(he);const Pe=G[Te++];return Promise.resolve(Pe()).then(Ie=>Z(Ie)?Promise.resolve(Ie):Ke())};return Ke()}e.first=c;function o(G,Z=Te=>!!Te,he=null){if(G.length===0)return Promise.resolve(he);let Te=G.length;const Ne=()=>{Te=-1;for(const Ke of G)Ke.cancel?.()};return new Promise((Ke,Pe)=>{for(const Se of G)Se.then(Ie=>{--Te>=0&&Z(Ie)?(Ne(),Ke(Ie)):Te===0&&Ke(he)}).catch(Ie=>{--Te>=0&&(Ne(),Pe(Ie))})})}e.firstParallel=o;class f{constructor(Z){this.a=0,this.d=Z,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(Z){return this.a++,new Promise((he,Te)=>{this.f.push({factory:Z,c:he,e:Te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Z=this.f.shift();this.b++;const he=Z.factory();he.then(Z.c,Z.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=f;class k extends f{constructor(){super(1)}}e.Queue=k;class A{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const Z=new pe;return this.b.add(Z),Z.p}d(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueFor(Z,he=S.extUri){const Te=he.getComparisonKey(Z);let Ne=this.a.get(Te);return Ne||(Ne=new k,D.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete(Te),this.f()}),this.a.set(Te,Ne)),Ne}f(){!this.d()||this.g()}g(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.g()}}e.ResourceQueue=A;class V{constructor(Z,he){this.a=-1,typeof Z=="function"&&typeof he=="number"&&this.setIfNotSet(Z,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},he)}setIfNotSet(Z,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},he))}}e.TimeoutTimer=V;class _{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(Z,he){this.cancel(),this.a=setInterval(()=>{Z()},he)}}e.IntervalTimer=_;class K{constructor(Z,he){this.b=-1,this.a=Z,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=K;class O{constructor(Z,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=Z,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=O;class B extends K{constructor(Z,he){super(Z,he),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=B;class P extends M.Disposable{constructor(Z,he){super(),this.g=Z,this.h=he,this.a=[],this.b=this.B(new M.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of Z)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=G=>{(0,R.setTimeout0)(()=>{if(Z)return;const he=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.runWhenIdle=(G,Z)=>{const he=requestIdleCallback(G,typeof Z=="number"?{timeout:Z}:void 0);let Te=!1;return{dispose(){Te||(Te=!0,cancelIdleCallback(he))}}}}();class F{constructor(Z){this.d=!1,this.a=()=>{try{this.f=Z()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=F;async function H(G,Z,he){let Te;for(let Ne=0;Ne<he;Ne++)try{return await G()}catch(Ke){Te=Ke,await u(Z)}throw Te}e.retry=H;class j{hasPending(Z){return this.a?typeof Z=="number"?this.a.taskId===Z:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(Z,he,Te){return this.a={taskId:Z,cancel:()=>Te?.(),promise:he},he.then(()=>this.d(Z),()=>this.d(Z)),he}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}setNext(Z){if(this.b)this.b.run=Z;else{let he,Te;const Ne=new Promise((Ke,Pe)=>{he=Ke,Te=Pe});this.b={run:Z,promise:Ne,promiseResolve:he,promiseReject:Te}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class de{constructor(Z,he=()=>Date.now()){this.d=Z,this.f=he,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.IntervalCounter=de;class pe{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((Z,he)=>{this.a=Z,this.b=he})}complete(Z){return new Promise(he=>{this.a(Z),this.f=!0,he()})}error(Z){return new Promise(he=>{this.b(Z),this.d=!0,he()})}cancel(){new Promise(Z=>{this.b(new C.CancellationError),this.d=!0,Z()})}}e.DeferredPromise=pe;var re;(function(G){async function Z(Te){let Ne;const Ke=await Promise.all(Te.map(Pe=>Pe.then(Se=>Se,Se=>{Ne||(Ne=Se)})));if(typeof Ne<"u")throw Ne;return Ke}G.settled=Z;function he(Te){return new Promise(async(Ne,Ke)=>{try{await Te(Ne,Ke)}catch(Pe){Ke(Pe)}})}G.withAsyncBody=he})(re=e.Promises||(e.Promises={}));var ue;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(ue||(ue={}));class ae{static fromArray(Z){return new ae(he=>{he.emitMany(Z)})}static fromPromise(Z){return new ae(async he=>{he.emitMany(await Z)})}static fromPromises(Z){return new ae(async he=>{await Promise.all(Z.map(async Te=>he.emitOne(await Te)))})}static merge(Z){return new ae(async he=>{await Promise.all(Z.map(async Te=>{for await(const Ne of Te)he.emitOne(Ne)}))})}constructor(Z){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const he={emitOne:Te=>this.g(Te),emitMany:Te=>this.h(Te),reject:Te=>this.k(Te)};try{await Promise.resolve(Z(he)),this.j()}catch(Te){this.k(Te)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(Z,he){return new ae(async Te=>{for await(const Ne of Z)Te.emitOne(he(Ne))})}map(Z){return ae.map(this,Z)}static filter(Z,he){return new ae(async Te=>{for await(const Ne of Z)he(Ne)&&Te.emitOne(Ne)})}filter(Z){return ae.filter(this,Z)}static coalesce(Z){return ae.filter(Z,he=>!!he)}coalesce(){return ae.coalesce(this)}static async toPromise(Z){const he=[];for await(const Te of Z)he.push(Te);return he}toPromise(){return ae.toPromise(this)}g(Z){this.a===0&&(this.b.push(Z),this.f.fire())}h(Z){this.a===0&&(this.b=this.b.concat(Z),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Z){this.a===0&&(this.a=2,this.d=Z,this.f.fire())}}ae.EMPTY=ae.fromArray([]),e.AsyncIterableObject=ae;class se extends ae{constructor(Z,he){super(he),this.l=Z}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=se;function Y(G){const Z=new n.CancellationTokenSource,he=G(Z.token);return new se(Z,async Te=>{const Ne=Z.token.onCancellationRequested(()=>{Ne.dispose(),Z.dispose(),Te.reject(new C.CancellationError)});try{for await(const Ke of he){if(Z.token.isCancellationRequested)return;Te.emitOne(Ke)}Ne.dispose(),Z.dispose()}catch(Ke){Ne.dispose(),Z.dispose(),Te.reject(Ke)}})}e.createCancelableAsyncIterable=Y}),define(Ce[35],ke([1,0,16,17,40,28,19,21,10]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const N="[/\\\\]",w="[^/\\\\]",h=/\//g;function b(de,pe){switch(de){case 0:return"";case 1:return`${w}*?`;default:return`(?:${N}|${w}+${N}${pe?`|${N}${w}+`:""})*?`}}function m(de,pe){if(!de)return[];const re=[];let ue=!1,ae=!1,se="";for(const Y of de){switch(Y){case pe:if(!ue&&!ae){re.push(se),se="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}se+=Y}return se&&re.push(se),re}e.splitGlobAware=m;function a(de){if(!de)return"";let pe="";const re=m(de,e.GLOB_SPLIT);if(re.every(ue=>ue===e.GLOBSTAR))pe=".*";else{let ue=!1;re.forEach((ae,se)=>{if(ae===e.GLOBSTAR){if(ue)return;pe+=b(2,se===re.length-1)}else{let Y=!1,G="",Z=!1,he="";for(const Te of ae){if(Te!=="}"&&Y){G+=Te;continue}if(Z&&(Te!=="]"||!he)){let Ne;Te==="-"?Ne=Te:(Te==="^"||Te==="!")&&!he?Ne="^":Te===e.GLOB_SPLIT?Ne="":Ne=(0,y.escapeRegExpCharacters)(Te),he+=Ne;continue}switch(Te){case"{":Y=!0;continue;case"[":Z=!0;continue;case"}":{pe+=`(?:${m(G,",").map(Pe=>a(Pe)).join("|")})`,Y=!1,G="";break}case"]":{pe+="["+he+"]",Z=!1,he="";break}case"?":pe+=w;continue;case"*":pe+=b(1);continue;default:pe+=(0,y.escapeRegExpCharacters)(Te)}}se<re.length-1&&(re[se+1]!==e.GLOBSTAR||se+2<re.length)&&(pe+=N)}ue=ae===e.GLOBSTAR})}return pe}const s=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,L=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),d=function(){return!1},r=function(){return null};function u(de,pe){if(!de)return r;let re;typeof de!="string"?re=de.pattern:re=de,re=re.trim();const ue=`${re}_${!!pe.trimForExclusions}`;let ae=t.get(ue);if(ae)return i(ae,de);let se;return s.test(re)?ae=c(re.substr(4),re):(se=l.exec(p(re,pe)))?ae=o(se[1],re):(pe.trimForExclusions?E:g).test(re)?ae=f(re,pe):(se=L.exec(p(re,pe)))?ae=k(se[1].substr(1),re,!0):(se=v.exec(p(re,pe)))?ae=k(se[1],re,!1):ae=A(re),t.set(ue,ae),i(ae,de)}function i(de,pe){if(typeof pe=="string")return de;const re=function(ue,ae){return(0,D.isEqualOrParent)(ue,pe.base,!R.isLinux)?de((0,y.ltrim)(ue.substr(pe.base.length),S.sep),ae):null};return re.allBasenames=de.allBasenames,re.allPaths=de.allPaths,re.basenames=de.basenames,re.patterns=de.patterns,re}function p(de,pe){return pe.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function c(de,pe){return function(re,ue){return typeof re=="string"&&re.endsWith(de)?pe:null}}function o(de,pe){const re=`/${de}`,ue=`\\${de}`,ae=function(Y,G){return typeof Y!="string"?null:G?G===de?pe:null:Y===de||Y.endsWith(re)||Y.endsWith(ue)?pe:null},se=[de];return ae.basenames=se,ae.patterns=[pe],ae.allBasenames=se,ae}function f(de,pe){const re=H(de.slice(1,-1).split(",").map(G=>u(G,pe)).filter(G=>G!==r),de),ue=re.length;if(!ue)return r;if(ue===1)return re[0];const ae=function(G,Z){for(let he=0,Te=re.length;he<Te;he++)if(re[he](G,Z))return de;return null},se=re.find(G=>!!G.allBasenames);se&&(ae.allBasenames=se.allBasenames);const Y=re.reduce((G,Z)=>Z.allPaths?G.concat(Z.allPaths):G,[]);return Y.length&&(ae.allPaths=Y),ae}function k(de,pe,re){const ue=S.sep===S.posix.sep,ae=ue?de:de.replace(h,S.sep),se=S.sep+ae,Y=S.posix.sep+de;let G;return re?G=function(Z,he){return typeof Z=="string"&&(Z===ae||Z.endsWith(se)||!ue&&(Z===de||Z.endsWith(Y)))?pe:null}:G=function(Z,he){return typeof Z=="string"&&(Z===ae||!ue&&Z===de)?pe:null},G.allPaths=[(re?"*/":"./")+de],G}function A(de){try{const pe=new RegExp(`^${a(de)}$`);return function(re){return pe.lastIndex=0,typeof re=="string"&&pe.test(re)?de:null}}catch{return r}}function V(de,pe,re){return!de||typeof pe!="string"?!1:_(de)(pe,void 0,re)}e.match=V;function _(de,pe={}){if(!de)return d;if(typeof de=="string"||K(de)){const re=u(de,pe);if(re===r)return d;const ue=function(ae,se){return!!re(ae,se)};return re.allBasenames&&(ue.allBasenames=re.allBasenames),re.allPaths&&(ue.allPaths=re.allPaths),ue}return P(de,pe)}e.parse=_;function K(de){const pe=de;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.isRelativePattern=K;function O(de){return de.allBasenames||[]}e.getBasenameTerms=O;function B(de){return de.allPaths||[]}e.getPathTerms=B;function P(de,pe){const re=H(Object.getOwnPropertyNames(de).map(G=>F(G,de[G],pe)).filter(G=>G!==r)),ue=re.length;if(!ue)return r;if(!re.some(G=>!!G.requiresSiblings)){if(ue===1)return re[0];const G=function(Te,Ne){let Ke;for(let Pe=0,Se=re.length;Pe<Se;Pe++){const Ie=re[Pe](Te,Ne);if(typeof Ie=="string")return Ie;(0,C.isThenable)(Ie)&&(Ke||(Ke=[]),Ke.push(Ie))}return Ke?(async()=>{for(const Pe of Ke){const Se=await Pe;if(typeof Se=="string")return Se}return null})():null},Z=re.find(Te=>!!Te.allBasenames);Z&&(G.allBasenames=Z.allBasenames);const he=re.reduce((Te,Ne)=>Ne.allPaths?Te.concat(Ne.allPaths):Te,[]);return he.length&&(G.allPaths=he),G}const ae=function(G,Z,he){let Te,Ne;for(let Ke=0,Pe=re.length;Ke<Pe;Ke++){const Se=re[Ke];Se.requiresSiblings&&he&&(Z||(Z=(0,S.basename)(G)),Te||(Te=Z.substr(0,Z.length-(0,S.extname)(G).length)));const Ie=Se(G,Z,Te,he);if(typeof Ie=="string")return Ie;(0,C.isThenable)(Ie)&&(Ne||(Ne=[]),Ne.push(Ie))}return Ne?(async()=>{for(const Ke of Ne){const Pe=await Ke;if(typeof Pe=="string")return Pe}return null})():null},se=re.find(G=>!!G.allBasenames);se&&(ae.allBasenames=se.allBasenames);const Y=re.reduce((G,Z)=>Z.allPaths?G.concat(Z.allPaths):G,[]);return Y.length&&(ae.allPaths=Y),ae}function F(de,pe,re){if(pe===!1)return r;const ue=u(de,re);if(ue===r)return r;if(typeof pe=="boolean")return ue;if(pe){const ae=pe.when;if(typeof ae=="string"){const se=(Y,G,Z,he)=>{if(!he||!ue(Y,G))return null;const Te=ae.replace("$(basename)",()=>Z),Ne=he(Te);return(0,C.isThenable)(Ne)?Ne.then(Ke=>Ke?de:null):Ne?de:null};return se.requiresSiblings=!0,se}}return ue}function H(de,pe){const re=de.filter(G=>!!G.basenames);if(re.length<2)return de;const ue=re.reduce((G,Z)=>{const he=Z.basenames;return he?G.concat(he):G},[]);let ae;if(pe){ae=[];for(let G=0,Z=ue.length;G<Z;G++)ae.push(pe)}else ae=re.reduce((G,Z)=>{const he=Z.patterns;return he?G.concat(he):G},[]);const se=function(G,Z){if(typeof G!="string")return null;if(!Z){let Te;for(Te=G.length;Te>0;Te--){const Ne=G.charCodeAt(Te-1);if(Ne===47||Ne===92)break}Z=G.substr(Te)}const he=ue.indexOf(Z);return he!==-1?ae[he]:null};se.basenames=ue,se.patterns=ae,se.allBasenames=ue;const Y=de.filter(G=>!G.basenames);return Y.push(se),Y}function j(de,pe){return(0,n.equals)(de,pe,(re,ue)=>typeof re=="string"&&typeof ue=="string"?re===ue:typeof re!="string"&&typeof ue!="string"?re.base===ue.base&&re.pattern===ue.pattern:!1)}e.patternsEquals=j}),define(Ce[86],ke([1,0,12,126,24,10,2]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var R;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(R=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(l="",g=!1){if(this.value=l,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(l,g=0){return this.value+=h(this.supportThemeIcons?(0,C.escapeIcons)(l):l).replace(/([ \t]+)/g,(E,L)=>"&nbsp;".repeat(L.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,g){return this.value+="\n```",this.value+=l,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(l,g,E){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(l),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(l,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return l.replace(E,(L,v)=>l.charAt(v-1)!=="\\"?`\\${L}`:L)}}e.MarkdownString=y;function T(s){return N(s)?!s.value:Array.isArray(s)?s.every(T):!0}e.isEmptyMarkdownString=T;function N(s){return s instanceof y?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function w(s,l){return s===l?!0:!s||!l?!1:s.value===l.value&&s.isTrusted===l.isTrusted&&s.supportThemeIcons===l.supportThemeIcons&&s.supportHtml===l.supportHtml&&(s.baseUri===l.baseUri||!!s.baseUri&&!!l.baseUri&&(0,D.isEqual)(S.URI.from(s.baseUri),S.URI.from(l.baseUri)))}e.markdownStringEqual=w;function h(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=h;function b(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=b;function m(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function a(s){const l=[],g=s.split("|").map(L=>L.trim());s=g[0];const E=g[1];if(E){const L=/height=(\d+)/.exec(E),v=/width=(\d+)/.exec(E),t=L?L[1]:"",d=v?v[1]:"",r=isFinite(parseInt(d)),u=isFinite(parseInt(t));r&&l.push(`width="${d}"`),u&&l.push(`height="${t}"`)}return{href:s,dimensions:l}}e.parseHrefAndDimensions=a}),define(Ce[87],ke([1,0,16,40,19,21,24,10]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,u){const{os:i,tildify:p,relative:c}=u;if(c){const k=T(r,c,i);if(typeof k=="string")return k}let o=r.fsPath;if(i===1&&!M.isWindows?o=o.replace(/\//g,"\\"):i!==1&&M.isWindows&&(o=o.replace(/\\/g,"/")),i!==1&&p?.userHome){const k=p.userHome.fsPath;let A;r.scheme!==p.userHome.scheme&&r.path.startsWith(D.posix.sep)?A=p.userHome.with({path:r.path}).fsPath:A=r.fsPath,o=h(A,k,i)}return(i===1?D.win32:D.posix).normalize(N(o,i===1))}e.getPathLabel=y;function T(r,u,i){const p=i===1?D.win32:D.posix,c=i===3?S.extUri:S.extUriIgnorePathCase,o=u.getWorkspace(),f=(0,n.firstOrDefault)(o.folders);if(!f)return;r.scheme!==f.uri.scheme&&r.path.startsWith(D.posix.sep)&&(r=f.uri.with({path:r.path}));const k=u.getWorkspaceFolder(r);if(!k)return;let A;if(c.isEqual(k.uri,r)?A="":A=c.relativePath(k.uri,r)??"",A&&(A=p.normalize(A)),o.folders.length>1&&!u.noPrefix){const V=k.name?k.name:c.basenameOrAuthority(k.uri);A=A?`${V} \u2022 ${A}`:V}return A}function N(r,u=M.isWindows){return(0,C.hasDriveLetter)(r,u)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=N;let w=Object.create(null);function h(r,u,i=M.OS){if(i===1||!r||!u)return r;let p=w.original===u?w.normalized:void 0;p||(p=u,M.isWindows&&(p=(0,C.toSlashes)(p)),p=`${(0,R.rtrim)(p,D.posix.sep)}${D.posix.sep}`,w={original:u,normalized:p});let c=r;return M.isWindows&&(c=(0,C.toSlashes)(c)),(i===3?c.startsWith(p):(0,R.startsWithIgnoreCase)(c,p))?`~/${c.substr(p.length)}`:r}e.tildify=h;function b(r,u){return r.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=b;const m="\u2026",a="\\\\",s="~";function l(r,u=D.sep){const i=new Array(r.length);let p=!1;for(let c=0;c<r.length;c++){const o=r[c];if(o===""){i[c]=`.${u}`;continue}if(!o){i[c]=o;continue}p=!0;let f="",k=o;k.indexOf(a)===0?(f=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(u)===0?(f=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(s)===0&&(f=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const A=k.split(u);for(let V=1;p&&V<=A.length;V++)for(let _=A.length-V;p&&_>=0;_--){p=!1;let K=A.slice(_,_+V).join(u);for(let O=0;!p&&O<r.length;O++)if(O!==c&&r[O]&&r[O].indexOf(K)>-1){const B=_+V===A.length,P=_>0&&r[O].indexOf(u)>-1?u+K:K,F=r[O].endsWith(P);p=!B||F}if(!p){let O="";(A[0].endsWith(":")||f!=="")&&(_===1&&(_=0,V++,K=A[0]+u+K),_>0&&(O=A[0]+u),O=f+O),_>0&&(O=O+m+u),O=O+K,_+V<A.length&&(O=O+u+m),i[c]=O}}p&&(i[c]=o)}return i}e.shorten=l;var g;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(r,u=Object.create(null)){const i=[];let p=!1,c="";for(const o of r)if(o==="$"||p&&o==="{")c&&i.push({value:c,type:g.TEXT}),c="",p=!0;else if(o==="}"&&p){const f=u[c];if(typeof f=="string")f.length&&i.push({value:f,type:g.VARIABLE});else if(f){const k=i[i.length-1];(!k||k.type!==g.SEPARATOR)&&i.push({value:f.label,type:g.SEPARATOR})}c="",p=!1}else c+=o;return c&&!p&&i.push({value:c,type:g.TEXT}),i.filter((o,f)=>{if(o.type===g.SEPARATOR){const k=i[f-1],A=i[f+1];return[k,A].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(o=>o.value).join("")}e.template=E;function L(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,i=>i==="&"?"&&":"&")}e.mnemonicMenuLabel=L;function v(r,u){return M.isMacintosh||u?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,i=>i==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function d(r){const u=r.indexOf("/")!==-1?D.posix:D.win32,i=u.basename(r),p=u.dirname(r);return i.length?{name:i,parentPath:p}:{name:p,parentPath:""}}e.splitName=d}),define(Ce[127],ke([1,0,23,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(w){return w.toJSON()}class M{constructor(h){this.a=h}transformIncoming(h){const b=this.a.transformIncoming(h);return b===h?h:D(C.URI.from(b))}transformOutgoing(h){const b=this.a.transformOutgoing(h);return b===h?h:D(C.URI.from(b))}transformOutgoingURI(h){const b=this.a.transformOutgoing(h);return b===h?h:C.URI.from(b)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.URITransformer=M,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function S(w,h,b){if(!w||b>200)return null;if(typeof w=="object"){if(w instanceof C.URI)return h.transformOutgoing(w);for(const m in w)if(Object.hasOwnProperty.call(w,m)){const a=S(w[m],h,b+1);a!==null&&(w[m]=a)}}return null}function R(w,h){const b=S(w,h,0);return b===null?w:b}e.transformOutgoingURIs=R;function y(w,h,b,m){if(!w||m>200)return null;if(typeof w=="object"){if(w.$mid===1)return b?C.URI.revive(h.transformIncoming(w)):h.transformIncoming(w);if(w instanceof n.VSBuffer)return null;for(const a in w)if(Object.hasOwnProperty.call(w,a)){const s=y(w[a],h,b,m+1);s!==null&&(w[a]=s)}}return null}function T(w,h){const b=y(w,h,!1,0);return b===null?w:b}e.transformIncomingURIs=T;function N(w,h){const b=y(w,h,!0,0);return b===null?w:b}e.transformAndReviveIncomingURIs=N}),define(Ce[128],ke([1,0,35,19]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(M,S,R,y,T,N){if(Array.isArray(M)){let w=0;for(const h of M){const b=D(h,S,R,y,T,N);if(b===10)return b;b>w&&(w=b)}return w}else{if(typeof M=="string")return y?M==="*"?5:M===R?10:0:0;if(M){const{language:w,pattern:h,scheme:b,hasAccessToAllModels:m,notebookType:a}=M;if(!y&&!m)return 0;a&&T&&(S=T);let s=0;if(b)if(b===S.scheme)s=10;else if(b==="*")s=5;else return 0;if(w)if(w===R)s=10;else if(w==="*")s=Math.max(s,5);else return 0;if(a)if(a===N)s=10;else if(a==="*"&&N!==void 0)s=Math.max(s,5);else return 0;if(h){let l;if(typeof h=="string"?l=h:l={...h,base:(0,C.normalize)(h.base)},l===S.fsPath||(0,n.match)(l,S.fsPath))s=10;else return 0}return s}else return 0}}e.score=D}),define(Ce[88],ke([1,0,23,21]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(D||(D={}));function M(w){for(let h=0,b=w.length;h<b;h+=4){const m=w[h+0],a=w[h+1],s=w[h+2],l=w[h+3];w[h+0]=l,w[h+1]=s,w[h+2]=a,w[h+3]=m}}function S(w){const h=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return C.isLittleEndian()||M(h),n.VSBuffer.wrap(h)}function R(w){const h=w.buffer;if(C.isLittleEndian()||M(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const b=new Uint8Array(h.byteLength);return b.set(h),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function y(w){const h=new Uint32Array(T(w));let b=0;if(h[b++]=w.id,w.type==="full")h[b++]=1,h[b++]=w.data.length,h.set(w.data,b),b+=w.data.length;else{h[b++]=2,h[b++]=w.deltas.length;for(const m of w.deltas)h[b++]=m.start,h[b++]=m.deleteCount,m.data?(h[b++]=m.data.length,h.set(m.data,b),b+=m.data.length):h[b++]=0}return S(h)}e.encodeSemanticTokensDto=y;function T(w){let h=0;if(h+=1+1,w.type==="full")h+=1+w.data.length;else{h+=1,h+=(1+1+1)*w.deltas.length;for(const b of w.deltas)b.data&&(h+=b.data.length)}return h}function N(w){const h=R(w);let b=0;const m=h[b++];if(h[b++]===1){const g=h[b++],E=h.subarray(b,b+g);return b+=g,{id:m,type:"full",data:E}}const s=h[b++],l=[];for(let g=0;g<s;g++){const E=h[b++],L=h[b++],v=h[b++];let t;v>0&&(t=h.subarray(b,b+v),b+=v),l[g]={start:E,deleteCount:L,data:t}}return{id:m,type:"delta",deltas:l}}e.decodeSemanticTokensDto=N}),define(Ce[129],ke([13,14]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Ce[130],ke([1,0,129,21,131,16,22,117]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=T;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class w{constructor(X,ve,Me,ze){this.id=X,this.name=ve,this.defaultValue=Me,this.schema=ze}applyUpdate(X,ve){return b(X,ve)}compute(X,ve,Me){return Me}}class h{constructor(X,ve){this.newValue=X,this.didChange=ve}}e.ApplyUpdateResult=h;function b(Q,X){if(typeof Q!="object"||typeof X!="object"||!Q||!X)return new h(X,Q!==X);if(Array.isArray(Q)||Array.isArray(X)){const Me=Array.isArray(Q)&&Array.isArray(X)&&M.equals(Q,X);return new h(X,!Me)}let ve=!1;for(const Me in X)if(X.hasOwnProperty(Me)){const ze=b(Q[Me],X[Me]);ze.didChange&&(Q[Me]=ze.newValue,ve=!0)}return new h(Q,ve)}class m{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ve){return b(X,ve)}validate(X){return this.defaultValue}}class a{constructor(X,ve,Me,ze){this.id=X,this.name=ve,this.defaultValue=Me,this.schema=ze}applyUpdate(X,ve){return b(X,ve)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ve,Me){return Me}}function s(Q,X){return typeof Q>"u"?X:Q==="false"?!1:Boolean(Q)}e.boolean=s;class l extends a{constructor(X,ve,Me,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=Me),super(X,ve,Me,ze)}validate(X){return s(X,this.defaultValue)}}function g(Q,X,ve,Me){if(typeof Q>"u")return X;let ze=parseInt(Q,10);return isNaN(ze)?X:(ze=Math.max(ve,ze),ze=Math.min(Me,ze),ze|0)}e.clampedInt=g;class E extends a{static clampedInt(X,ve,Me,ze){return g(X,ve,Me,ze)}constructor(X,ve,Me,ze,He,Ye=void 0){typeof Ye<"u"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=ze,Ye.maximum=He),super(X,ve,Me,Ye),this.minimum=ze,this.maximum=He}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class L extends a{static clamp(X,ve,Me){return X<ve?ve:X>Me?Me:X}static float(X,ve){if(typeof X=="number")return X;if(typeof X>"u")return ve;const Me=parseFloat(X);return isNaN(Me)?ve:Me}constructor(X,ve,Me,ze,He){typeof He<"u"&&(He.type="number",He.default=Me),super(X,ve,Me,He),this.validationFn=ze}validate(X){return this.validationFn(L.float(X,this.defaultValue))}}class v extends a{static string(X,ve){return typeof X!="string"?ve:X}constructor(X,ve,Me,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=Me),super(X,ve,Me,ze)}validate(X){return v.string(X,this.defaultValue)}}function t(Q,X,ve){return typeof Q!="string"||ve.indexOf(Q)===-1?X:Q}e.stringSet=t;class d extends a{constructor(X,ve,Me,ze,He=void 0){typeof He<"u"&&(He.type="string",He.enum=ze,He.default=Me),super(X,ve,Me,He),this.c=ze}validate(X){return t(X,this.defaultValue,this.c)}}class r extends w{constructor(X,ve,Me,ze,He,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=He,nt.default=ze),super(X,ve,Me,nt),this.c=He,this.d=Ye}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function u(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class i extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ve,Me){return Me===0?X.accessibilitySupport:Me}}class p extends w{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:n.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertSpace:s(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function o(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(Q){switch(Q){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function A(Q){switch(Q){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class V extends m{constructor(){super(135)}compute(X,ve,Me){const ze=["monaco-editor"];return ve.get(36)&&ze.push(ve.get(36)),X.extraEditorClassName&&ze.push(X.extraEditorClassName),ve.get(70)==="default"?ze.push("mouse-default"):ve.get(70)==="copy"&&ze.push("mouse-copy"),ve.get(105)&&ze.push("showUnused"),ve.get(133)&&ze.push("showDeprecated"),ze.join(" ")}}class _ extends l{constructor(){super(34,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(X,ve,Me){return Me&&X.emptySelectionClipboard}}class K extends w{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:n.localize(16,null),included:C.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:n.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{cursorMoveOnType:s(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":t(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":t(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ve.loop,this.defaultValue.loop)}}}class O extends w{constructor(){super(48,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?O.OFF:X==="true"?O.ON:X:Boolean(X)?O.ON:O.OFF}}O.OFF='"liga" off, "calt" off',O.ON='"liga" on, "calt" on',e.EditorFontLigatures=O;class B extends w{constructor(){super(51,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?B.OFF:X==="true"?B.TRANSLATE:X:Boolean(X)?B.TRANSLATE:B.OFF}compute(X,ve,Me){return X.fontInfo.fontVariationSettings}}B.OFF="normal",B.TRANSLATE="translate",e.EditorFontVariations=B;class P extends m{constructor(){super(47)}compute(X,ve,Me){return X.fontInfo}}class F extends a{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(X){const ve=L.float(X,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:L.clamp(ve,6,100)}compute(X,ve,Me){return X.fontInfo.fontSize}}class H extends w{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class j extends w{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Me,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Me,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Me,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Me,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Me,description:n.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{multiple:t(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??t(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??t(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??t(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??t(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??t(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends w{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:n.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),delay:E.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:s(ve.sticky,this.defaultValue.sticky),above:s(ve.above,this.defaultValue.above)}}}var pe;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(pe=e.RenderMinimap||(e.RenderMinimap={}));class re extends m{constructor(){super(138)}compute(X,ve,Me){return re.computeLayout(ve,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const ve=X.height/X.lineHeight,Me=Math.floor(X.paddingTop/X.lineHeight);let ze=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(ze=Math.max(ze,ve-1));const He=(Me+X.viewLineCount+ze)/(X.pixelRatio*X.height),Ye=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:ze,desiredRatio:He,minimapLineCount:Ye}}static c(X,ve){const Me=X.outerWidth,ze=X.outerHeight,He=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(He*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const Ye=ve.stableMinimapLayoutInput,nt=Ye&&X.outerHeight===Ye.outerHeight&&X.lineHeight===Ye.lineHeight&&X.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&X.pixelRatio===Ye.pixelRatio&&X.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&X.paddingTop===Ye.paddingTop&&X.paddingBottom===Ye.paddingBottom&&X.minimap.enabled===Ye.minimap.enabled&&X.minimap.side===Ye.minimap.side&&X.minimap.size===Ye.minimap.size&&X.minimap.showSlider===Ye.minimap.showSlider&&X.minimap.renderCharacters===Ye.minimap.renderCharacters&&X.minimap.maxColumn===Ye.minimap.maxColumn&&X.minimap.scale===Ye.minimap.scale&&X.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&X.isViewportWrapping===Ye.isViewportWrapping,vt=X.lineHeight,wt=X.typicalHalfwidthCharacterWidth,Ct=X.scrollBeyondLastLine,jt=X.minimap.renderCharacters;let rt=He>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const mt=X.minimap.maxColumn,Ft=X.minimap.size,Gt=X.minimap.side,Pt=X.verticalScrollbarWidth,ht=X.viewLineCount,kt=X.remainingWidth,$t=X.isViewportWrapping,Ot=jt?2:3;let Ge=Math.floor(He*ze);const Nt=Ge/He;let Mt=!1,zt=!1,ft=Ot*rt,De=rt/He,Ae=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:Ze,extraLinesBeforeFirstLine:ct,extraLinesBeyondLastLine:Tt,desiredRatio:bt,minimapLineCount:Et}=re.computeContainedMinimapLineCount({viewLineCount:ht,scrollBeyondLastLine:Ct,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:ze,lineHeight:vt,pixelRatio:He});if(ht/Et>1)Mt=!0,zt=!0,rt=1,ft=1,De=rt/He;else{let St=!1,yt=rt+1;if(Ft==="fit"){const qt=Math.ceil((ct+ht+Tt)*ft);$t&&nt&&kt<=ve.stableFitRemainingWidth?(St=!0,yt=ve.stableFitMaxMinimapScale):St=qt>Ge}if(Ft==="fill"||St){Mt=!0;const qt=rt;ft=Math.min(vt*He,Math.max(1,Math.floor(1/bt))),$t&&nt&&kt<=ve.stableFitRemainingWidth&&(yt=ve.stableFitMaxMinimapScale),rt=Math.min(yt,Math.max(1,Math.floor(ft/Ot))),rt>qt&&(Ae=Math.min(2,rt/qt)),De=rt/He/Ae,Ge=Math.ceil(Math.max(Ze,ct+ht+Tt)*ft),$t?(ve.stableMinimapLayoutInput=X,ve.stableFitRemainingWidth=kt,ve.stableFitMaxMinimapScale=rt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const ge=Math.floor(mt*De),x=Math.min(ge,Math.max(0,Math.floor((kt-Pt-2)*De/(wt+De)))+e.MINIMAP_GUTTER_WIDTH);let Re=Math.floor(He*x);const $e=Re/He;Re=Math.floor(Re*Ae);const Qe=jt?1:2,Be=Gt==="left"?0:Me-x-Pt;return{renderMinimap:Qe,minimapLeft:Be,minimapWidth:x,minimapHeightIsEditorHeight:Mt,minimapIsSampling:zt,minimapScale:rt,minimapLineHeight:ft,minimapCanvasInnerWidth:Re,minimapCanvasInnerHeight:Ge,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Nt}}static computeLayout(X,ve){const Me=ve.outerWidth|0,ze=ve.outerHeight|0,He=ve.lineHeight|0,Ye=ve.lineNumbersDigitCount|0,nt=ve.typicalHalfwidthCharacterWidth,vt=ve.maxDigitWidth,wt=ve.pixelRatio,Ct=ve.viewLineCount,jt=X.get(130),rt=jt==="inherit"?X.get(129):jt,mt=rt==="inherit"?X.get(125):rt,Ft=X.get(128),Gt=ve.isDominatedByLongLines,Pt=X.get(54),ht=X.get(64).renderType!==0,kt=X.get(65),$t=X.get(99),Ot=X.get(80),Ge=X.get(69),Nt=X.get(97),Mt=Nt.verticalScrollbarSize,zt=Nt.verticalHasArrows,ft=Nt.arrowSize,De=Nt.horizontalScrollbarSize,Ae=X.get(40),ge=X.get(104)!=="never";let x=X.get(62);Ae&&ge&&(x+=16);let Re=0;if(ht){const pt=Math.max(Ye,kt);Re=Math.round(pt*vt)}let $e=0;Pt&&($e=He);let Qe=0,Be=Qe+$e,Ze=Be+Re,ct=Ze+x;const Tt=Me-$e-Re-x;let bt=!1,Et=!1,It=-1;rt==="inherit"&&Gt?(bt=!0,Et=!0):mt==="on"||mt==="bounded"?Et=!0:mt==="wordWrapColumn"&&(It=Ft);const St=re.c({outerWidth:Me,outerHeight:ze,lineHeight:He,typicalHalfwidthCharacterWidth:nt,pixelRatio:wt,scrollBeyondLastLine:$t,paddingTop:Ot.top,paddingBottom:Ot.bottom,minimap:Ge,verticalScrollbarWidth:Mt,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:Et},ve.memory||new N);St.renderMinimap!==0&&St.minimapLeft===0&&(Qe+=St.minimapWidth,Be+=St.minimapWidth,Ze+=St.minimapWidth,ct+=St.minimapWidth);const yt=Tt-St.minimapWidth,qt=Math.max(1,Math.floor((yt-Mt-2)/nt)),Jt=zt?ft:0;return Et&&(It=Math.max(1,qt),mt==="bounded"&&(It=Math.min(It,Ft))),{width:Me,height:ze,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Be,lineNumbersWidth:Re,decorationsLeft:Ze,decorationsWidth:x,contentLeft:ct,contentWidth:yt,minimap:St,viewportColumn:qt,isWordWrapMinified:bt,isViewportWrapping:Et,wrappingColumn:It,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:De,overviewRuler:{top:Jt,width:Mt,height:ze-2*Jt,right:0}}}}e.EditorLayoutInfoComputer=re;class ue extends w{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(X){return t(X,"simple",["simple","advanced"])}compute(X,ve,Me){return ve.get(2)===2?"advanced":Me}}class ae extends w{constructor(){const X={enabled:!0};super(61,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:n.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:s(X.enabled,this.defaultValue.enabled)}}}class se extends w{constructor(){const X={enabled:!1,maxLineCount:5};super(109,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class Y extends w{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:n.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(53,null),n.localize(54,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(55,null,C.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:n.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:n.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:n.localize(59,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:t(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ve.fontFamily,this.defaultValue.fontFamily),padding:s(ve.padding,this.defaultValue.padding)}}}class G extends w{constructor(){super(62,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):E.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ve,Me){return Me<0?E.clampedInt(-Me*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class Z extends L{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>L.clamp(X,0,150),{markdownDescription:n.localize(60,null)})}compute(X,ve,Me){return X.fontInfo.lineHeight}}class he extends w{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:n.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:n.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(63,null),n.localize(64,null),n.localize(65,null)],default:X.size,description:n.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:n.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:n.localize(68,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:n.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:n.localize(71,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),autohide:s(ve.autohide,this.defaultValue.autohide),size:t(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:t(ve.side,this.defaultValue.side,["right","left"]),showSlider:t(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ve.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(ve.scale,1,1,3),maxColumn:E.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Q){return Q==="ctrlCmd"?C.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ne extends w{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{top:E.clampedInt(ve.top,0,0,1e3),bottom:E.clampedInt(ve.bottom,0,0,1e3)}}}class Ke extends w{constructor(){const X={enabled:!0,cycle:!0};super(81,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:n.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:n.localize(75,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),cycle:s(ve.cycle,this.defaultValue.cycle)}}}class Pe extends m{constructor(){super(136)}compute(X,ve,Me){return X.pixelRatio}}class Se extends w{constructor(){const X={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(76,null),n.localize(77,null),n.localize(78,null)]}];super(84,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:X.strings,description:n.localize(79,null)},comments:{anyOf:ve,default:X.comments,description:n.localize(80,null)},other:{anyOf:ve,default:X.other,description:n.localize(81,null)}},default:X,markdownDescription:n.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const wt=X?"on":"off";return{comments:wt,strings:wt,other:wt}}if(!X||typeof X!="object")return this.defaultValue;const{other:ve,comments:Me,strings:ze}=X,He=["on","inline","off"];let Ye,nt,vt;return typeof ve=="boolean"?Ye=ve?"on":"off":Ye=t(ve,this.defaultValue.other,He),typeof Me=="boolean"?nt=Me?"on":"off":nt=t(Me,this.defaultValue.comments,He),typeof ze=="boolean"?vt=ze?"on":"off":vt=t(ze,this.defaultValue.strings,He),{other:Ye,comments:nt,strings:vt}}}var Ie;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(Ie=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class oe extends w{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(83,null),n.localize(84,null),n.localize(85,null),n.localize(86,null)],default:"on",description:n.localize(87,null)})}validate(X){let ve=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ve=4,Me=X):X==="interval"?ve=3:X==="relative"?ve=2:X==="on"?ve=1:ve=0),{renderType:ve,renderFn:Me}}}function le(Q){const X=Q.get(92);return X==="editable"?Q.get(86):X!=="on"}e.filterValidationDecorations=le;class J extends w{constructor(){const X=[],ve={type:"number",description:n.localize(88,null)};super(96,"rulers",X,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:n.localize(89,null),format:"color-hex"}}}]},default:X,description:n.localize(90,null)})}validate(X){if(Array.isArray(X)){const ve=[];for(const Me of X)if(typeof Me=="number")ve.push({column:E.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const ze=Me;ve.push({column:E.clampedInt(ze.column,0,0,1e4),color:ze.color})}return ve.sort((Me,ze)=>Me.column-ze.column),ve}return this.defaultValue}}function I(Q,X){if(typeof Q!="string")return X;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class $ extends w{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(91,null),n.localize(92,null),n.localize(93,null)],default:"auto",description:n.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(95,null),n.localize(96,null),n.localize(97,null)],default:"auto",description:n.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:n.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:n.localize(101,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X,Me=E.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=E.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:I(ve.vertical,this.defaultValue.vertical),horizontal:I(ve.horizontal,this.defaultValue.horizontal),useShadows:s(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:E.clampedInt(ve.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:E.clampedInt(ve.verticalSliderSize,ze,0,1e3),scrollByPage:s(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends w{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:n.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:n.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:n.localize(108,null)}})}applyUpdate(X,ve){let Me=!1;ve.allowedCharacters&&X&&(S.equals(X.allowedCharacters,ve.allowedCharacters)||(X={...X,allowedCharacters:ve.allowedCharacters},Me=!0)),ve.allowedLocales&&X&&(S.equals(X.allowedLocales,ve.allowedLocales)||(X={...X,allowedLocales:ve.allowedLocales},Me=!0));const ze=super.applyUpdate(X,ve);return Me?new h(ze.newValue,!0):ze}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{nonBasicASCII:ye(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ye(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ye(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ve){if(typeof X!="object"||!X)return ve;const Me={};for(const[ze,He]of Object.entries(X))He===!0&&(Me[ze]=!0);return Me}}class q extends w{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:n.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(110,null),n.localize(111,null)],description:n.localize(112,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),mode:t(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:t(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class ee extends w{constructor(){const X={enabled:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:n.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:n.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{enabled:s(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class me extends w{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(115,null),n.localize(116,null),n.localize(117,null)],default:X.bracketPairs,description:n.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(119,null),n.localize(120,null),n.localize(121,null)],default:X.bracketPairsHorizontal,description:n.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:n.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:n.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(125,null),n.localize(126,null),n.localize(127,null)],default:X.highlightActiveIndentation,description:n.localize(128,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{bracketPairs:ye(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ye(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:ye(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ye(Q,X,ve){const Me=ve.indexOf(Q);return Me===-1?X:ve[Me]}class ce extends w{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(129,null),n.localize(130,null)],default:X.insertMode,description:n.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:n.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:n.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:n.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(135,null),n.localize(136,null),n.localize(137,null),n.localize(138,null)],default:X.selectionMode,markdownDescription:n.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:n.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:n.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:n.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:n.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:n.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ve=X;return{insertMode:t(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:t(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(ve.showIcons,this.defaultValue.showIcons),showStatusBar:s(ve.showStatusBar,this.defaultValue.showStatusBar),preview:s(ve.preview,this.defaultValue.preview),previewMode:t(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ve.showMethods,this.defaultValue.showMethods),showFunctions:s(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ve.showFields,this.defaultValue.showFields),showVariables:s(ve.showVariables,this.defaultValue.showVariables),showClasses:s(ve.showClasses,this.defaultValue.showClasses),showStructs:s(ve.showStructs,this.defaultValue.showStructs),showInterfaces:s(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ve.showModules,this.defaultValue.showModules),showProperties:s(ve.showProperties,this.defaultValue.showProperties),showEvents:s(ve.showEvents,this.defaultValue.showEvents),showOperators:s(ve.showOperators,this.defaultValue.showOperators),showUnits:s(ve.showUnits,this.defaultValue.showUnits),showValues:s(ve.showValues,this.defaultValue.showValues),showConstants:s(ve.showConstants,this.defaultValue.showConstants),showEnums:s(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ve.showKeywords,this.defaultValue.showKeywords),showWords:s(ve.showWords,this.defaultValue.showWords),showColors:s(ve.showColors,this.defaultValue.showColors),showFiles:s(ve.showFiles,this.defaultValue.showFiles),showReferences:s(ve.showReferences,this.defaultValue.showReferences),showFolders:s(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ve.showSnippets,this.defaultValue.showSnippets),showUsers:s(ve.showUsers,this.defaultValue.showUsers),showIssues:s(ve.showIssues,this.defaultValue.showIssues)}}}class be extends w{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(177,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ee extends m{constructor(){super(137)}compute(X,ve,Me){return ve.get(86)?!0:X.tabFocusMode}}var We;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(We=e.WrappingIndent||(e.WrappingIndent={}));class Ve extends w{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(178,null),n.localize(179,null),n.localize(180,null),n.localize(181,null)],description:n.localize(182,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ve,Me){return ve.get(2)===2?0:Me}}class tt extends m{constructor(){super(139)}compute(X,ve,Me){const ze=ve.get(138);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Xe extends w{constructor(){const X={enabled:!0};super(33,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:n.localize(183,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:s(X.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",dt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.isMacintosh?it:C.isLinux?dt:et,fontWeight:"normal",fontSize:C.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var ot;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.bracketPairColorization=12]="bracketPairColorization",Q[Q.guides=13]="guides",Q[Q.codeLens=14]="codeLens",Q[Q.codeLensFontFamily=15]="codeLensFontFamily",Q[Q.codeLensFontSize=16]="codeLensFontSize",Q[Q.colorDecorators=17]="colorDecorators",Q[Q.colorDecoratorsLimit=18]="colorDecoratorsLimit",Q[Q.columnSelection=19]="columnSelection",Q[Q.comments=20]="comments",Q[Q.contextmenu=21]="contextmenu",Q[Q.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=23]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=25]="cursorStyle",Q[Q.cursorSurroundingLines=26]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=28]="cursorWidth",Q[Q.disableLayerHinting=29]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",Q[Q.domReadOnly=31]="domReadOnly",Q[Q.dragAndDrop=32]="dragAndDrop",Q[Q.dropIntoEditor=33]="dropIntoEditor",Q[Q.emptySelectionClipboard=34]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=36]="extraEditorClassName",Q[Q.fastScrollSensitivity=37]="fastScrollSensitivity",Q[Q.find=38]="find",Q[Q.fixedOverflowWidgets=39]="fixedOverflowWidgets",Q[Q.folding=40]="folding",Q[Q.foldingStrategy=41]="foldingStrategy",Q[Q.foldingHighlight=42]="foldingHighlight",Q[Q.foldingImportsByDefault=43]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=44]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=46]="fontFamily",Q[Q.fontInfo=47]="fontInfo",Q[Q.fontLigatures=48]="fontLigatures",Q[Q.fontSize=49]="fontSize",Q[Q.fontWeight=50]="fontWeight",Q[Q.fontVariations=51]="fontVariations",Q[Q.formatOnPaste=52]="formatOnPaste",Q[Q.formatOnType=53]="formatOnType",Q[Q.glyphMargin=54]="glyphMargin",Q[Q.gotoLocation=55]="gotoLocation",Q[Q.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",Q[Q.hover=57]="hover",Q[Q.inDiffEditor=58]="inDiffEditor",Q[Q.inlineSuggest=59]="inlineSuggest",Q[Q.letterSpacing=60]="letterSpacing",Q[Q.lightbulb=61]="lightbulb",Q[Q.lineDecorationsWidth=62]="lineDecorationsWidth",Q[Q.lineHeight=63]="lineHeight",Q[Q.lineNumbers=64]="lineNumbers",Q[Q.lineNumbersMinChars=65]="lineNumbersMinChars",Q[Q.linkedEditing=66]="linkedEditing",Q[Q.links=67]="links",Q[Q.matchBrackets=68]="matchBrackets",Q[Q.minimap=69]="minimap",Q[Q.mouseStyle=70]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=72]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=74]="multiCursorModifier",Q[Q.multiCursorPaste=75]="multiCursorPaste",Q[Q.multiCursorLimit=76]="multiCursorLimit",Q[Q.occurrencesHighlight=77]="occurrencesHighlight",Q[Q.overviewRulerBorder=78]="overviewRulerBorder",Q[Q.overviewRulerLanes=79]="overviewRulerLanes",Q[Q.padding=80]="padding",Q[Q.parameterHints=81]="parameterHints",Q[Q.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=84]="quickSuggestions",Q[Q.quickSuggestionsDelay=85]="quickSuggestionsDelay",Q[Q.readOnly=86]="readOnly",Q[Q.renameOnType=87]="renameOnType",Q[Q.renderControlCharacters=88]="renderControlCharacters",Q[Q.renderFinalNewline=89]="renderFinalNewline",Q[Q.renderLineHighlight=90]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=92]="renderValidationDecorations",Q[Q.renderWhitespace=93]="renderWhitespace",Q[Q.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",Q[Q.roundedSelection=95]="roundedSelection",Q[Q.rulers=96]="rulers",Q[Q.scrollbar=97]="scrollbar",Q[Q.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=99]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=100]="scrollPredominantAxis",Q[Q.selectionClipboard=101]="selectionClipboard",Q[Q.selectionHighlight=102]="selectionHighlight",Q[Q.selectOnLineNumbers=103]="selectOnLineNumbers",Q[Q.showFoldingControls=104]="showFoldingControls",Q[Q.showUnused=105]="showUnused",Q[Q.snippetSuggestions=106]="snippetSuggestions",Q[Q.smartSelect=107]="smartSelect",Q[Q.smoothScrolling=108]="smoothScrolling",Q[Q.stickyScroll=109]="stickyScroll",Q[Q.stickyTabStops=110]="stickyTabStops",Q[Q.stopRenderingLineAfter=111]="stopRenderingLineAfter",Q[Q.suggest=112]="suggest",Q[Q.suggestFontSize=113]="suggestFontSize",Q[Q.suggestLineHeight=114]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",Q[Q.suggestSelection=116]="suggestSelection",Q[Q.tabCompletion=117]="tabCompletion",Q[Q.tabIndex=118]="tabIndex",Q[Q.unicodeHighlighting=119]="unicodeHighlighting",Q[Q.unusualLineTerminators=120]="unusualLineTerminators",Q[Q.useShadowDOM=121]="useShadowDOM",Q[Q.useTabStops=122]="useTabStops",Q[Q.wordBreak=123]="wordBreak",Q[Q.wordSeparators=124]="wordSeparators",Q[Q.wordWrap=125]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=128]="wordWrapColumn",Q[Q.wordWrapOverride1=129]="wordWrapOverride1",Q[Q.wordWrapOverride2=130]="wordWrapOverride2",Q[Q.wrappingIndent=131]="wrappingIndent",Q[Q.wrappingStrategy=132]="wrappingStrategy",Q[Q.showDeprecated=133]="showDeprecated",Q[Q.inlayHints=134]="inlayHints",Q[Q.editorClassName=135]="editorClassName",Q[Q.pixelRatio=136]="pixelRatio",Q[Q.tabFocusMode=137]="tabFocusMode",Q[Q.layoutInfo=138]="layoutInfo",Q[Q.wrappingInfo=139]="wrappingInfo"})(ot=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new l(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(184,null)})),acceptSuggestionOnEnter:Fe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(185,null),""],markdownDescription:n.localize(186,null)})),accessibilitySupport:Fe(new i),accessibilityPageSize:Fe(new E(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(187,null),tags:["accessibility"]})),ariaLabel:Fe(new v(4,"ariaLabel",n.localize(188,null))),autoClosingBrackets:Fe(new d(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(189,null),n.localize(190,null),""],description:n.localize(191,null)})),autoClosingDelete:Fe(new d(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(192,null),""],description:n.localize(193,null)})),autoClosingOvertype:Fe(new d(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(194,null),""],description:n.localize(195,null)})),autoClosingQuotes:Fe(new d(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(196,null),n.localize(197,null),""],description:n.localize(198,null)})),autoIndent:Fe(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[n.localize(199,null),n.localize(200,null),n.localize(201,null),n.localize(202,null),n.localize(203,null)],description:n.localize(204,null)})),automaticLayout:Fe(new l(10,"automaticLayout",!1)),autoSurround:Fe(new d(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),""],description:n.localize(208,null)})),bracketPairColorization:Fe(new ee),bracketPairGuides:Fe(new me),stickyTabStops:Fe(new l(110,"stickyTabStops",!1,{description:n.localize(209,null)})),codeLens:Fe(new l(14,"codeLens",!0,{description:n.localize(210,null)})),codeLensFontFamily:Fe(new v(15,"codeLensFontFamily","",{description:n.localize(211,null)})),codeLensFontSize:Fe(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(212,null)})),colorDecorators:Fe(new l(17,"colorDecorators",!0,{description:n.localize(213,null)})),colorDecoratorsLimit:Fe(new E(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(214,null)})),columnSelection:Fe(new l(19,"columnSelection",!1,{description:n.localize(215,null)})),comments:Fe(new p),contextmenu:Fe(new l(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new l(22,"copyWithSyntaxHighlighting",!0,{description:n.localize(216,null)})),cursorBlinking:Fe(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:n.localize(217,null)})),cursorSmoothCaretAnimation:Fe(new d(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(218,null),n.localize(219,null),n.localize(220,null)],description:n.localize(221,null)})),cursorStyle:Fe(new r(25,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:n.localize(222,null)})),cursorSurroundingLines:Fe(new E(26,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(223,null)})),cursorSurroundingLinesStyle:Fe(new d(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(224,null),n.localize(225,null)],description:n.localize(226,null)})),cursorWidth:Fe(new E(28,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(227,null)})),disableLayerHinting:Fe(new l(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new l(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new l(31,"domReadOnly",!1)),dragAndDrop:Fe(new l(32,"dragAndDrop",!0,{description:n.localize(228,null)})),emptySelectionClipboard:Fe(new _),dropIntoEditor:Fe(new Xe),stickyScroll:Fe(new se),experimentalWhitespaceRendering:Fe(new d(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(229,null),n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),extraEditorClassName:Fe(new v(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new L(37,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:n.localize(233,null)})),find:Fe(new K),fixedOverflowWidgets:Fe(new l(39,"fixedOverflowWidgets",!1)),folding:Fe(new l(40,"folding",!0,{description:n.localize(234,null)})),foldingStrategy:Fe(new d(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(235,null),n.localize(236,null)],description:n.localize(237,null)})),foldingHighlight:Fe(new l(42,"foldingHighlight",!0,{description:n.localize(238,null)})),foldingImportsByDefault:Fe(new l(43,"foldingImportsByDefault",!1,{description:n.localize(239,null)})),foldingMaximumRegions:Fe(new E(44,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(240,null)})),unfoldOnClickAfterEndOfLine:Fe(new l(45,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(241,null)})),fontFamily:Fe(new v(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(242,null)})),fontInfo:Fe(new P),fontLigatures2:Fe(new O),fontSize:Fe(new F),fontWeight:Fe(new H),fontVariations:Fe(new B),formatOnPaste:Fe(new l(52,"formatOnPaste",!1,{description:n.localize(243,null)})),formatOnType:Fe(new l(53,"formatOnType",!1,{description:n.localize(244,null)})),glyphMargin:Fe(new l(54,"glyphMargin",!0,{description:n.localize(245,null)})),gotoLocation:Fe(new j),hideCursorInOverviewRuler:Fe(new l(56,"hideCursorInOverviewRuler",!1,{description:n.localize(246,null)})),hover:Fe(new de),inDiffEditor:Fe(new l(58,"inDiffEditor",!1)),letterSpacing:Fe(new L(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>L.clamp(Q,-5,20),{description:n.localize(247,null)})),lightbulb:Fe(new ae),lineDecorationsWidth:Fe(new G),lineHeight:Fe(new Z),lineNumbers:Fe(new oe),lineNumbersMinChars:Fe(new E(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new l(66,"linkedEditing",!1,{description:n.localize(248,null)})),links:Fe(new l(67,"links",!0,{description:n.localize(249,null)})),matchBrackets:Fe(new d(68,"matchBrackets","always",["always","near","never"],{description:n.localize(250,null)})),minimap:Fe(new he),mouseStyle:Fe(new d(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new L(71,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:n.localize(251,null)})),mouseWheelZoom:Fe(new l(72,"mouseWheelZoom",!1,{markdownDescription:n.localize(252,null)})),multiCursorMergeOverlapping:Fe(new l(73,"multiCursorMergeOverlapping",!0,{description:n.localize(253,null)})),multiCursorModifier:Fe(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[n.localize(254,null),n.localize(255,null)],markdownDescription:n.localize(256,null)})),multiCursorPaste:Fe(new d(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(257,null),n.localize(258,null)],markdownDescription:n.localize(259,null)})),multiCursorLimit:Fe(new E(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(260,null)})),occurrencesHighlight:Fe(new l(77,"occurrencesHighlight",!0,{description:n.localize(261,null)})),overviewRulerBorder:Fe(new l(78,"overviewRulerBorder",!0,{description:n.localize(262,null)})),overviewRulerLanes:Fe(new E(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Ne),parameterHints:Fe(new Ke),peekWidgetDefaultFocus:Fe(new d(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(263,null),n.localize(264,null)],description:n.localize(265,null)})),definitionLinkOpensInPeek:Fe(new l(83,"definitionLinkOpensInPeek",!1,{description:n.localize(266,null)})),quickSuggestions:Fe(new Se),quickSuggestionsDelay:Fe(new E(85,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(267,null)})),readOnly:Fe(new l(86,"readOnly",!1)),renameOnType:Fe(new l(87,"renameOnType",!1,{description:n.localize(268,null),markdownDeprecationMessage:n.localize(269,null)})),renderControlCharacters:Fe(new l(88,"renderControlCharacters",!0,{description:n.localize(270,null),restricted:!0})),renderFinalNewline:Fe(new d(89,"renderFinalNewline",C.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(271,null)})),renderLineHighlight:Fe(new d(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(272,null)],description:n.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Fe(new l(91,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(274,null)})),renderValidationDecorations:Fe(new d(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new d(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(275,null),n.localize(276,null),n.localize(277,null),""],description:n.localize(278,null)})),revealHorizontalRightPadding:Fe(new E(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new l(95,"roundedSelection",!0,{description:n.localize(279,null)})),rulers:Fe(new J),scrollbar:Fe(new $),scrollBeyondLastColumn:Fe(new E(98,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(280,null)})),scrollBeyondLastLine:Fe(new l(99,"scrollBeyondLastLine",!0,{description:n.localize(281,null)})),scrollPredominantAxis:Fe(new l(100,"scrollPredominantAxis",!0,{description:n.localize(282,null)})),selectionClipboard:Fe(new l(101,"selectionClipboard",!0,{description:n.localize(283,null),included:C.isLinux})),selectionHighlight:Fe(new l(102,"selectionHighlight",!0,{description:n.localize(284,null)})),selectOnLineNumbers:Fe(new l(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new d(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(285,null),n.localize(286,null),n.localize(287,null)],description:n.localize(288,null)})),showUnused:Fe(new l(105,"showUnused",!0,{description:n.localize(289,null)})),showDeprecated:Fe(new l(133,"showDeprecated",!0,{description:n.localize(290,null)})),inlayHints:Fe(new Y),snippetSuggestions:Fe(new d(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null),n.localize(294,null)],description:n.localize(295,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new l(108,"smoothScrolling",!1,{description:n.localize(296,null)})),stopRenderingLineAfter:Fe(new E(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ce),inlineSuggest:Fe(new q),suggestFontSize:Fe(new E(113,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new E(114,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new l(115,"suggestOnTriggerCharacters",!0,{description:n.localize(299,null)})),suggestSelection:Fe(new d(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(300,null),n.localize(301,null),n.localize(302,null)],description:n.localize(303,null)})),tabCompletion:Fe(new d(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(304,null),n.localize(305,null),n.localize(306,null)],description:n.localize(307,null)})),tabIndex:Fe(new E(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new W),unusualLineTerminators:Fe(new d(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(308,null),n.localize(309,null),n.localize(310,null)],description:n.localize(311,null)})),useShadowDOM:Fe(new l(121,"useShadowDOM",!0)),useTabStops:Fe(new l(122,"useTabStops",!0,{description:n.localize(312,null)})),wordBreak:Fe(new d(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(313,null),n.localize(314,null)],description:n.localize(315,null)})),wordSeparators:Fe(new v(124,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:n.localize(316,null)})),wordWrap:Fe(new d(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(317,null),n.localize(318,null),n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordWrapBreakAfterCharacters:Fe(new v(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new v(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new E(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(322,null)})),wordWrapOverride1:Fe(new d(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new d(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new V),pixelRatio:Fe(new Pe),tabFocusMode:Fe(new Ee),layoutInfo:Fe(new re),wrappingInfo:Fe(new tt),wrappingIndent:Fe(new Ve),wrappingStrategy:Fe(new ue)}}),define(Ce[132],ke([13,14]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[133],ke([13,14]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[134],ke([13,14]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[135],ke([13,14]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Ce[136],ke([13,14]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Ce[137],ke([13,14]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[138],ke([13,14]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Ce[139],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[140],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[141],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[142],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[143],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[144],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[145],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[146],ke([13,14]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[147],ke([13,14]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Ce[148],ke([13,14]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Ce[149],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[150],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[151],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[152],ke([13,14]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[153],ke([13,14]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[154],ke([13,14]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[155],ke([13,14]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[156],ke([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class C{constructor(){this.a=new Map}register(M,S){this.a.set(M,S)}updateManifest(M){if(!(typeof M.main>"u"&&typeof M.browser>"u")&&(M.activationEvents===void 0&&Object.assign(M,{activationEvents:[]}),!(!Array.isArray(M.activationEvents)||!M.contributes)))for(const S in M.contributes){const R=this.a.get(S);if(!R)continue;const y=M.contributes[S],T=Array.isArray(y)?y:[y];try{R(T,M.activationEvents)}catch(N){(0,n.onUnexpectedError)(N)}}}}e.ImplicitActivationEventsImpl=C,e.ImplicitActivationEvents=new C}),define(Ce[157],ke([1,0,24,29,134,257]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function y(l){return l=l.trim(),l==="*"||S.test(l)}e.isValidVersionStr=y;function T(l){if(!y(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(S);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function N(l){if(!l)return null;const g=l.majorBase,E=l.majorMustEqual,L=l.minorBase;let v=l.minorMustEqual;const t=l.patchBase;let d=l.patchMustEqual;l.hasCaret&&(g===0||(v=!1),d=!1);let r=0;if(l.preRelease){const u=R.exec(l.preRelease);if(u){const[,i,p,c]=u;r=Date.UTC(Number(i),Number(p)-1,Number(c))}}return{majorBase:g,majorMustEqual:E,minorBase:L,minorMustEqual:v,patchBase:t,patchMustEqual:d,isMinimum:l.hasGreaterEquals,notBefore:r}}e.normalizeVersion=N;function w(l,g,E){let L;typeof l=="string"?L=N(T(l)):L=l;let v;g instanceof Date?v=g.getTime():typeof g=="string"&&(v=new Date(g).getTime());let t;if(typeof E=="string"?t=N(T(E)):t=E,!L||!t)return!1;const d=L.majorBase,r=L.minorBase,u=L.patchBase;let i=t.majorBase,p=t.minorBase,c=t.patchBase;const o=t.notBefore;let f=t.majorMustEqual,k=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?d>i?!0:d<i?!1:r>p?!0:r<p||v&&v<o?!1:u>=c:(d===1&&i===0&&(!f||!k||!A)&&(i=1,p=0,c=0,f=!0,k=!1,A=!1),d<i?!1:d>i?!f:r<p?!1:r>p?!k:u<c?!1:u>c?!A:!(v&&v<o))}e.isValidVersion=w;function h(l,g,E,L,v){const t=[];if(typeof L.publisher<"u"&&typeof L.publisher!="string")return t.push([C.default.Error,D.localize(0,null)]),t;if(typeof L.name!="string")return t.push([C.default.Error,D.localize(1,null,"name")]),t;if(typeof L.version!="string")return t.push([C.default.Error,D.localize(2,null,"version")]),t;if(!L.engines)return t.push([C.default.Error,D.localize(3,null,"engines")]),t;if(typeof L.engines.vscode!="string")return t.push([C.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof L.extensionDependencies<"u"&&!s(L.extensionDependencies))return t.push([C.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof L.activationEvents<"u"){if(!s(L.activationEvents))return t.push([C.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof L.main>"u"&&typeof L.browser>"u")return t.push([C.default.Error,D.localize(7,null,"activationEvents","main")]),t}if(typeof L.extensionKind<"u"&&typeof L.main>"u"&&t.push([C.default.Warning,D.localize(8,null,"extensionKind")]),typeof L.main<"u"){if(typeof L.main!="string")return t.push([C.default.Error,D.localize(9,null,"main")]),t;{const u=(0,n.joinPath)(E,L.main);(0,n.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(10,null,u.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([C.default.Error,D.localize(11,null,"activationEvents","main")]),t}if(typeof L.browser<"u"){if(typeof L.browser!="string")return t.push([C.default.Error,D.localize(12,null,"browser")]),t;{const u=(0,n.joinPath)(E,L.browser);(0,n.isEqualOrParent)(u,E)||t.push([C.default.Warning,D.localize(13,null,u.path,E.path)])}if(typeof L.activationEvents>"u")return t.push([C.default.Error,D.localize(14,null,"activationEvents","browser")]),t}if(!M.valid(L.version))return t.push([C.default.Error,D.localize(15,null)]),t;const d=[];if(!b(l,g,L,v,d))for(const u of d)t.push([C.default.Error,u]);return t}e.validateExtensionManifest=h;function b(l,g,E,L,v){return L||typeof E.main>"u"&&typeof E.browser>"u"?!0:a(l,g,E.engines.vscode,v)}e.isValidExtensionVersion=b;function m(l,g,E){return l==="*"||a(g,E,l)}e.isEngineValid=m;function a(l,g,E,L=[]){const v=N(T(E));if(!v)return L.push(D.localize(16,null,E)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return L.push(D.localize(17,null,E)),!1}else if(!v.majorMustEqual)return L.push(D.localize(18,null,E)),!1;return w(l,g,v)?!0:(L.push(D.localize(19,null,l,E)),!1)}function s(l){if(!Array.isArray(l))return!1;for(let g=0,E=l.length;g<E;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Ce[89],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(D,M=[],S=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=n}),define(Ce[66],ke([1,0,89]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function M(R,y,T){y instanceof n.SyncDescriptor||(y=new n.SyncDescriptor(y,[],Boolean(T))),C.push([R,y])}e.registerSingleton=M;function S(){return C}e.getSingletonServiceDescriptors=S}),define(Ce[158],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(M,S){this.key=M,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const S of this.a.values())S.outgoing.size===0&&M.push(S);return M}insertEdge(M,S){const R=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(S);R.outgoing.set(y.key,y),y.incoming.set(R.key,R)}removeNode(M){const S=this.b(M);this.a.delete(S);for(const R of this.a.values())R.outgoing.delete(S),R.incoming.delete(S)}lookupOrInsertNode(M){const S=this.b(M);let R=this.a.get(S);return R||(R=new n(S,M),this.a.set(S,R)),R}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[S,R]of this.a)M.push(`${S}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,S]of this.a){const R=new Set([M]),y=this.c(S,R);if(y)return y}}c(M,S){for(const[R,y]of M.outgoing){if(S.has(R))return[...S,R].join(" -> ");S.add(R);const T=this.c(y,S);if(T)return T;S.delete(R)}}}e.Graph=C}),define(Ce[3],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function R(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=R})(n=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function C(S,R,y){R[n.DI_TARGET]===R?R[n.DI_DEPENDENCIES].push({id:S,index:y}):(R[n.DI_DEPENDENCIES]=[{id:S,index:y}],R[n.DI_TARGET]=R)}function D(S){if(n.serviceIds.has(S))return n.serviceIds.get(S);const R=function(y,T,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(R,y,N)};return R.toString=()=>S,n.serviceIds.set(S,R),R}e.createDecorator=D;function M(S){return S}e.refineServiceDecorator=M}),define(Ce[41],ke([1,0,9,2,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function M(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationOverrides=M;function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=S;var R;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function T(s,l){const g=Object.create(null);for(const E in s)N(g,E,s[E],l);return g}e.toValuesTree=T;function N(s,l,g,E){const L=l.split("."),v=L.pop();let t=s;for(let d=0;d<L.length;d++){const r=L[d];let u=t[r];switch(typeof u){case"undefined":u=t[r]=Object.create(null);break;case"object":break;default:E(`Ignoring ${l} as ${L.slice(0,d+1).join(".")} is ${JSON.stringify(u)}`);return}t=u}if(typeof t=="object"&&t!==null)try{t[v]=g}catch{E(`Ignoring ${l} as ${L.join(".")} is ${JSON.stringify(t)}`)}else E(`Ignoring ${l} as ${L.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=N;function w(s,l){const g=l.split(".");h(s,g)}e.removeFromValueTree=w;function h(s,l){const g=l.shift();if(l.length===0){delete s[g];return}if(Object.keys(s).indexOf(g)!==-1){const E=s[g];typeof E=="object"&&!Array.isArray(E)&&(h(E,l),Object.keys(E).length===0&&delete s[g])}}function b(s,l,g){function E(t,d){let r=t;for(const u of d){if(typeof r!="object"||r===null)return;r=r[u]}return r}const L=l.split("."),v=E(s,L);return typeof v>"u"?g:v}e.getConfigurationValue=b;function m(s,l,g){Object.keys(l).forEach(E=>{E!=="__proto__"&&(E in s?n.isObject(s[E])&&n.isObject(l[E])?m(s[E],l[E],g):g&&(s[E]=l[E]):s[E]=l[E])})}e.merge=m;function a(s){return s.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=a}),define(Ce[42],ke([1,0,21,10,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",n.isMacintosh),M.set("isLinux",n.isLinux),M.set("isWindows",n.isWindows),M.set("isWeb",n.isWeb),M.set("isMacNative",n.isMacintosh&&!n.isWeb),M.set("isEdge",n.isEdge),M.set("isFirefox",n.isFirefox),M.set("isChrome",n.isChrome),M.set("isSafari",n.isSafari);const S=Object.prototype.hasOwnProperty;var R;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return w.INSTANCE}static true(){return h.INSTANCE}static has(O){return b.create(O)}static equals(O,B){return m.create(O,B)}static notEquals(O,B){return l.create(O,B)}static regex(O,B){return r.create(O,B)}static in(O,B){return a.create(O,B)}static notIn(O,B){return s.create(O,B)}static not(O){return g.create(O)}static and(...O){return p.create(O,null,!0)}static or(...O){return c.create(O,null,!0)}static greater(O,B){return L.create(O,B)}static greaterEquals(O,B){return v.create(O,B)}static smaller(O,B){return t.create(O,B)}static smallerEquals(O,B){return d.create(O,B)}static deserialize(O,B=!1){if(!!O)return this.c(O,B)}static c(O,B){const P=O.split("||");return c.create(P.map(F=>this.d(F,B)),null,!0)}static d(O,B){const P=O.split("&&");return p.create(P.map(F=>this.f(F,B)),null,!0)}static f(O,B){if(O=O.trim(),O.indexOf("!=")>=0){const P=O.split("!=");return l.create(P[0].trim(),this.g(P[1],B))}if(O.indexOf("==")>=0){const P=O.split("==");return m.create(P[0].trim(),this.g(P[1],B))}if(O.indexOf("=~")>=0){const P=O.split("=~");return r.create(P[0].trim(),this.h(P[1],B))}if(O.indexOf(" not in ")>=0){const P=O.split(" not in ");return s.create(P[0].trim(),this.g(P[1],B))}if(O.indexOf(" in ")>=0){const P=O.split(" in ");return a.create(P[0].trim(),this.g(P[1],B))}if(/^[^<=>]+>=[^<=>]+$/.test(O)){const P=O.split(">=");return v.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(O)){const P=O.split(">");return L.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(O)){const P=O.split("<=");return d.create(P[0].trim(),P[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(O)){const P=O.split("<");return t.create(P[0].trim(),P[1].trim())}return/^\!\s*/.test(O)?g.create(O.substr(1).trim()):b.create(O)}static g(O,B){if(O=O.trim(),O==="true")return!0;if(O==="false")return!1;const P=/^'([^']*)'$/.exec(O);return P?P[1].trim():O}static h(O,B){if((0,C.isFalsyOrWhitespace)(O)){if(B)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const P=O.indexOf("/"),F=O.lastIndexOf("/");if(P===F||P<0){if(B)throw new Error(`bad regexp-value '${O}', missing /-enclosure`);return console.warn(`bad regexp-value '${O}', missing /-enclosure`),null}const H=O.slice(P+1,F),j=O[F+1]==="i"?"i":"";try{return new RegExp(H,j)}catch(de){if(B)throw new Error(`bad regexp-value '${O}', parse error: ${de}`);return console.warn(`bad regexp-value '${O}', parse error: ${de}`),null}}}e.ContextKeyExpr=y;function T(K,O){const B=K?K.substituteConstants():void 0,P=O?O.substituteConstants():void 0;return!B&&!P?!0:!B||!P?!1:B.equals(P)}e.expressionsAreEqualWithConstantSubstitution=T;function N(K,O){return K.cmp(O)}class w{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return h.INSTANCE}}w.INSTANCE=new w,e.ContextKeyFalseExpr=w;class h{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return w.INSTANCE}}h.INSTANCE=new h,e.ContextKeyTrueExpr=h;class b{static create(O,B=null){const P=M.get(O);return typeof P=="boolean"?P?h.INSTANCE:w.INSTANCE:new b(O,B)}constructor(O,B){this.key=O,this.c=B,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:f(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=M.get(this.key);return typeof O=="boolean"?O?h.INSTANCE:w.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=b;class m{static create(O,B,P=null){if(typeof B=="boolean")return B?b.create(O,P):g.create(O,P);const F=M.get(O);return typeof F=="boolean"?B===(F?"true":"false")?h.INSTANCE:w.INSTANCE:new m(O,B,P)}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=M.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?h.INSTANCE:w.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=m;class a{static create(O,B){return new a(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:k(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.f),P=O.getValue(this.d);return Array.isArray(B)?B.includes(P):typeof P=="string"&&typeof B=="object"&&B!==null?S.call(B,P):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=s.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=a;class s{static create(O,B){return new s(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=11,this.c=a.create(O,B)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=s;class l{static create(O,B,P=null){if(typeof B=="boolean")return B?g.create(O,P):b.create(O,P);const F=M.get(O);return typeof F=="boolean"?B===(F?"true":"false")?w.INSTANCE:h.INSTANCE:new l(O,B,P)}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=M.get(this.c);if(typeof O=="boolean"){const B=O?"true":"false";return this.d===B?w.INSTANCE:h.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class g{static create(O,B=null){const P=M.get(O);return typeof P=="boolean"?P?w.INSTANCE:h.INSTANCE:new g(O,B)}constructor(O,B){this.c=O,this.d=B,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:f(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=M.get(this.c);return typeof O=="boolean"?O?w.INSTANCE:h.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function E(K,O){if(typeof K=="string"){const B=parseFloat(K);isNaN(B)||(K=B)}return typeof K=="string"||typeof K=="number"?O(K):w.INSTANCE}class L{static create(O,B,P=null){return E(B,F=>new L(O,F,P))}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=L;class v{static create(O,B,P=null){return E(B,F=>new v(O,F,P))}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=v;class t{static create(O,B,P=null){return E(B,F=>new t(O,F,P))}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class d{static create(O,B,P=null){return E(B,F=>new d(O,F,P))}constructor(O,B,P){this.c=O,this.d=B,this.f=P,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:k(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=d;class r{static create(O,B){return new r(O,B)}constructor(O,B){this.d=O,this.f=B,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const B=this.f?this.f.source:"",P=O.f?O.f.source:"";return B<P?-1:B>P?1:0}equals(O){if(O.type===this.type){const B=this.f?this.f.source:"",P=O.f?O.f.source:"";return this.d===O.d&&B===P}return!1}substituteConstants(){return this}evaluate(O){const B=O.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=r;class u{static create(O){return new u(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(O){return new u(this.c.map(O))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function i(K){let O=null;for(let B=0,P=K.length;B<P;B++){const F=K[B].substituteConstants();if(K[B]!==F&&O===null){O=[];for(let H=0;H<B;H++)O[H]=K[H]}O!==null&&(O[B]=F)}return O===null?K:O}class p{static create(O,B,P){return p.d(O,B,P)}constructor(O,B){this.expr=O,this.c=B,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],O.expr[B]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:p.create(O,this.c,!1)}evaluate(O){for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].evaluate(O))return!1;return!0}static d(O,B,P){const F=[];let H=!1;for(const j of O)if(!!j){if(j.type===1){H=!0;continue}if(j.type===0)return w.INSTANCE;if(j.type===6){F.push(...j.expr);continue}F.push(j)}if(F.length===0&&H)return h.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(N);for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];for(;F.length>1;){const j=F[F.length-1];if(j.type!==9)break;F.pop();const de=F.pop(),pe=F.length===0,re=c.create(j.expr.map(ue=>p.create([ue,de],null,P)),null,pe);re&&(F.push(re),F.sort(N))}if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let de=j+1;de<F.length;de++)if(F[j].negate().equals(F[de]))return w.INSTANCE;if(F.length===1)return F[0]}return new p(F,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new p(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());this.c=c.create(O,this,!0)}return this.c}}class c{static create(O,B,P){return c.d(O,B,P)}constructor(O,B){this.expr=O,this.c=B,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let B=0,P=this.expr.length;B<P;B++){const F=N(this.expr[B],O.expr[B]);if(F!==0)return F}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let B=0,P=this.expr.length;B<P;B++)if(!this.expr[B].equals(O.expr[B]))return!1;return!0}return!1}substituteConstants(){const O=i(this.expr);return O===this.expr?this:c.create(O,this.c,!1)}evaluate(O){for(let B=0,P=this.expr.length;B<P;B++)if(this.expr[B].evaluate(O))return!0;return!1}static d(O,B,P){let F=[],H=!1;if(O){for(let j=0,de=O.length;j<de;j++){const pe=O[j];if(!!pe){if(pe.type===0){H=!0;continue}if(pe.type===1)return h.INSTANCE;if(pe.type===9){F=F.concat(pe.expr);continue}F.push(pe)}}if(F.length===0&&H)return w.INSTANCE;F.sort(N)}if(F.length!==0){if(F.length===1)return F[0];for(let j=1;j<F.length;j++)F[j-1].equals(F[j])&&(F.splice(j,1),j--);if(F.length===1)return F[0];if(P){for(let j=0;j<F.length;j++)for(let de=j+1;de<F.length;de++)if(F[j].negate().equals(F[de]))return h.INSTANCE;if(F.length===1)return F[0]}return new c(F,B)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const B of this.expr)O.push(...B.keys());return O}map(O){return new c(this.expr.map(B=>B.map(O)),null)}negate(){if(!this.c){const O=[];for(const B of this.expr)O.push(B.negate());for(;O.length>1;){const B=O.shift(),P=O.shift(),F=[];for(const H of _(B))for(const j of _(P))F.push(p.create([H,j],null,!1));O.unshift(c.create(F,null,!1))}this.c=c.create(O,this,!0)}return this.c}}class o extends b{static all(){return o.d.values()}constructor(O,B,P){super(O,null),this.f=B,typeof P=="object"?o.d.push({...P,key:O}):P!==!0&&o.d.push({key:O,description:P,type:B!=null?typeof B:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return m.create(this.key,O)}notEqualsTo(O){return l.create(this.key,O)}}o.d=[],e.RawContextKey=o,e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function f(K,O){return K<O?-1:K>O?1:0}function k(K,O,B,P){return K<B?-1:K>B?1:O<P?-1:O>P?1:0}function A(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?V(K.expr,O.expr):!1;if(O.type===9){for(const B of O.expr)if(A(K,B))return!0;return!1}if(K.type===6){if(O.type===6)return V(O.expr,K.expr);for(const B of K.expr)if(A(B,O))return!0;return!1}return K.equals(O)}e.implies=A;function V(K,O){let B=0,P=0;for(;B<K.length&&P<O.length;){const F=K[B].cmp(O[P]);if(F<0)return!1;F===0&&B++,P++}return B===K.length}function _(K){return K.type===9?K.expr:[K]}}),define(Ce[159],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[90],ke([1,0,133,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function S(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function R(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function y(l,g,E){return R(g,E)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===E?!0:T(E).includes(l)}e.isTargetPlatformCompatible=y;function T(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function N(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=N;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var b;(function(l){l.Install="install",l.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var m;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var a;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(a=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Ce[43],ke([1,0,48,19,10,9,2,135,3,21,15]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function w(re){return re.create===!0}e.isFileOpenForWriteOptions=w;var h;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(h=e.FileType||(e.FileType={}));var b;(function(re){re[re.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function a(re){return!!(re.capabilities&2)}e.hasReadWriteCapability=a;function s(re){return!!(re.capabilities&8)}e.hasFileFolderCopyCapability=s;function l(re){return!!(re.capabilities&32768)}e.hasFileCloneCapability=l;function g(re){return!!(re.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(re){return!!(re.capabilities&16)}e.hasFileReadStreamCapability=E;function L(re){return a(re)?!!(re.capabilities&16384):!1}e.hasFileAtomicReadCapability=L;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(ue,ae){const se=new t(ue.toString(),ae);return u(se,ae),se}constructor(ue,ae){super(ue),this.code=ae}}e.FileSystemProviderError=t;function d(re,ue){return t.create(re,ue)}e.createFileSystemProviderError=d;function r(re){return re||d((0,R.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function u(re,ue){return re.name=ue?`${ue} (FileSystemError)`:"FileSystemError",re}e.markAsFileSystemProviderError=u;function i(re){if(!re)return v.Unknown;if(re instanceof t)return re.code;const ue=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ue)return v.Unknown;switch(ue[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=i;function p(re){if(re instanceof V)return re.fileOperationResult;switch(i(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=p;var c;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(c=e.FileOperation||(e.FileOperation={}));class o{constructor(ue,ae,se){this.resource=ue,this.operation=ae,this.target=se}isOperation(ue){return this.operation===ue}}e.FileOperationEvent=o;var f;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class k{constructor(ue,ae){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const Y of ue){const G=se.get(Y.type);switch(G?G.push([Y.resource,Y]):se.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,G]of se)switch(Y){case 1:this.a=n.TernarySearchTree.forUris(()=>ae),this.a.fill(G);break;case 0:this.b=n.TernarySearchTree.forUris(()=>ae),this.b.fill(G);break;case 2:this.c=n.TernarySearchTree.forUris(()=>ae),this.c.fill(G);break}}contains(ue,...ae){return this.d(ue,{includeChildren:!1},...ae)}affects(ue,...ae){return this.d(ue,{includeChildren:!0},...ae)}d(ue,ae,...se){if(!ue)return!1;const Y=se.length>0;return!!((!Y||se.includes(1))&&(this.a?.get(ue)||ae.includeChildren&&this.a?.findSuperstr(ue))||(!Y||se.includes(0))&&(this.b?.get(ue)||ae.includeChildren&&this.b?.findSuperstr(ue))||(!Y||se.includes(2))&&(this.c?.findSubstr(ue)||ae.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=k;function A(re,ue,ae){return!re||!ue||re===ue||ue.length>re.length?!1:(ue.charAt(ue.length-1)!==C.sep&&(ue+=C.sep),ae?(0,D.startsWithIgnoreCase)(re,ue):re.indexOf(ue)===0)}e.isParent=A;class V extends Error{constructor(ue,ae,se){super(ue),this.fileOperationResult=ae,this.options=se}}e.FileOperationError=V;class _ extends V{constructor(ue,ae,se,Y){super(ue,ae,Y),this.fileOperationResult=ae,this.size=se}}e.TooLargeFileOperationError=_;class K extends V{constructor(ue,ae,se){super(ue,2,se),this.stat=ae}}e.NotModifiedSinceFileOperationError=K;var O;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",re[re.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var B;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(B=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function P(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.etag=P;async function F(re,ue){if(!ue.hasProvider(S.URI.from({scheme:re.scheme})))return new Promise(ae=>{const se=ue.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===re.scheme&&Y.added&&(se.dispose(),ae())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(ue){return(0,M.isNumber)(ue)||(ue=0),ue<H.KB?(0,R.localize)(1,null,ue.toFixed(0)):ue<H.MB?(0,R.localize)(2,null,(ue/H.KB).toFixed(2)):ue<H.GB?(0,R.localize)(3,null,(ue/H.MB).toFixed(2)):ue<H.TB?(0,R.localize)(4,null,(ue/H.GB).toFixed(2)):(0,R.localize)(5,null,(ue/H.TB).toFixed(2))}}H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB,e.ByteSize=H;var j;(function(re){re[re.IA32=0]="IA32",re[re.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function de(re){return{maxFileSize:re===0?300*H.MB:16*H.GB,maxHeapSize:re===0?700*H.MB:2*700*H.MB}}e.getPlatformFileLimits=de;function pe(re){const ue=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*H.MB:ue?10*H.MB:T.isWeb?50*H.MB:1024*H.MB}e.getLargeFileConfirmationLimit=pe}),define(Ce[67],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...D){this.a=new Map;for(const[M,S]of D)this.set(M,S)}set(D,M){const S=this.a.get(D);return this.a.set(D,M),S}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=n}),define(Ce[160],ke([1,0,17,12,6,89,158,3,67,161]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const N=!1;class w extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class h{constructor(s=new y.ServiceCollection,l=!1,g,E=N){this.f=s,this.g=l,this.h=g,this.i=E,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=E?g?._globalGraph??new S.Graph(L=>L):void 0}createChild(s){return new h(s,this.g,this,this.i)}invokeFunction(s,...l){const g=m.traceInvocation(this.i,s);let E=!1;try{return s({get:v=>{if(E)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(v,g);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...l)}finally{E=!0,g.stop()}}createInstance(s,...l){let g,E;return s instanceof M.SyncDescriptor?(g=m.traceCreation(this.i,s.ctor),E=this.j(s.ctor,s.staticArguments.concat(l),g)):(g=m.traceCreation(this.i,s),E=this.j(s,l,g)),g.stop(),E}j(s,l=[],g){const E=R._util.getServiceDependencies(s).sort((t,d)=>t.index-d.index),L=[];for(const t of E){const d=this.m(t.id,g);d||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${t.id}.`,!1),L.push(d)}const v=E.length>0?E[0].index:l.length;if(l.length!==v){console.trace(`[createInstance] First service dependency of ${s.name} at position ${v+1} conflicts with ${l.length} static arguments`);const t=v-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,v)}return Reflect.construct(s,l.concat(L))}k(s,l){if(this.f.get(s)instanceof M.SyncDescriptor)this.f.set(s,l);else if(this.h)this.h.k(s,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const l=this.f.get(s);return!l&&this.h?this.h.l(s):l}m(s,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const g=this.l(s);return g instanceof M.SyncDescriptor?this.q(s,g,l.branch(s,!0)):(l.branch(s,!1),g)}q(s,l,g){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,l,g)}finally{this.o.delete(s)}}r(s,l,g){const E=new S.Graph(t=>t.id.toString());let L=0;const v=[{id:s,desc:l,_trace:g}];for(;v.length;){const t=v.pop();if(E.lookupOrInsertNode(t),L++>1e3)throw new w(E);for(const d of R._util.getServiceDependencies(t.desc.ctor)){const r=this.l(d.id);if(r||this.u(`[createInstance] ${s} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),r instanceof M.SyncDescriptor){const u={id:d.id,desc:r,_trace:t._trace.branch(d.id,!0)};E.insertEdge(t,u),v.push(u)}}}for(;;){const t=E.roots();if(t.length===0){if(!E.isEmpty())throw new w(E);break}for(const{data:d}of t){if(this.l(d.id)instanceof M.SyncDescriptor){const u=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,u)}E.removeNode(d)}}return this.l(s)}s(s,l,g=[],E,L){if(this.f.get(s)instanceof M.SyncDescriptor)return this.t(s,l,g,E,L);if(this.h)return this.h.s(s,l,g,E,L);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(s,l,g=[],E,L){if(E){const v=new h(void 0,this.g,this,this.i);v.c=String(s);const t=new Map,d=new n.IdleValue(()=>{const r=v.j(l,g,L);for(const[u,i]of t){const p=r[u];if(typeof p=="function")for(const c of i)p.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,u){if(!d.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let c=t.get(u);return c||(c=new T.LinkedList,t.set(u,c)),(f,k,A)=>{const V=c.push([f,k,A]);return(0,D.toDisposable)(V)}}if(u in r)return r[u];const i=d.value;let p=i[u];return typeof p!="function"||(p=p.bind(i),r[u]=p),p},set(r,u,i){return d.value[u]=i,!0},getPrototypeOf(r){return l.prototype}})}else return this.j(l,g,L)}u(s,l){if(l&&console.warn(s),this.g)throw new Error(s)}}e.InstantiationService=h;var b;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(b||(b={}));class m{static traceInvocation(s,l){return s?new m(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(s,l){return s?new m(1,l.name):m.c}constructor(s,l){this.type=s,this.name=l,this.g=Date.now(),this.h=[]}branch(s,l){const g=new m(3,s.toString());return this.h.push([s,l,g]),g}stop(){const s=Date.now()-this.g;m.f+=s;let l=!1;function g(L,v){const t=[],d=new Array(L+1).join("	");for(const[r,u,i]of v.h)if(u&&i){l=!0,t.push(`${d}CREATES -> ${r}`);const p=g(L+1,i);p&&t.push(p)}else t.push(`${d}uses -> ${r}`);return t.join(`
`)}const E=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(s>2||l)&&m.all.add(E.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(Ce[11],ke([1,0,39,4,6,28,21,9,2,3]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function N(){return new Date().toISOString()}function w(c){return(0,R.isNumber)(c)}e.isLogLevel=w;var h;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function b(c,o,f){switch(o){case h.Trace:c.trace(f);break;case h.Debug:c.debug(f);break;case h.Info:c.info(f);break;case h.Warning:c.warn(f);break;case h.Error:c.error(f);break;case h.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=b;function m(c){let o="";for(let f=0;f<c.length;f++){let k=c[f];if(typeof k=="object")try{k=JSON.stringify(k)}catch{}o+=(f>0?" ":"")+k}return o}e.format=m;class a extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new C.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==h.Off&&this.b<=o}}e.AbstractLogger=a;class s extends a{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...f){this.f(h.Trace)&&this.g(h.Trace,m([o,...f]))}debug(o,...f){this.f(h.Debug)&&this.g(h.Debug,m([o,...f]))}info(o,...f){this.f(h.Info)&&this.g(h.Info,m([o,...f]))}warn(o,...f){this.f(h.Warning)&&this.g(h.Warning,m([o,...f]))}error(o,...f){if(this.f(h.Error))if(o instanceof Error){const k=Array.prototype.slice.call(arguments);k[0]=o.stack,this.g(h.Error,m(k))}else this.g(h.Error,m([o,...f]))}flush(){}}e.AbstractMessageLogger=s;class l extends a{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!S.isWindows}trace(o,...f){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,o,...f):console.log(`[main ${N()}]`,o,...f))}debug(o,...f){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,o,...f):console.log(`[main ${N()}]`,o,...f))}info(o,...f){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${N()}]\x1B[0m`,o,...f):console.log(`[main ${N()}]`,o,...f))}warn(o,...f){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${N()}]\x1B[0m`,o,...f):console.warn(`[main ${N()}]`,o,...f))}error(o,...f){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${N()}]\x1B[0m`,o,...f):console.error(`[main ${N()}]`,o,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=l;class g extends a{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...f){this.f(h.Trace)&&console.log("%cTRACE","color: #888",o,...f)}debug(o,...f){this.f(h.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...f)}info(o,...f){this.f(h.Info)&&console.log("%c INFO","color: #33f",o,...f)}warn(o,...f){this.f(h.Warning)&&console.log("%c WARN","color: #993",o,...f)}error(o,...f){this.f(h.Error)&&console.log("%c  ERR","color: #f33",o,...f)}dispose(){}flush(){}}e.ConsoleLogger=g;class E extends a{constructor(o,f=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(f)}trace(o,...f){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(o),...f])}debug(o,...f){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(o),...f])}info(o,...f){this.f(h.Info)&&this.g.log(h.Info,[this.h(o),...f])}warn(o,...f){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(o),...f])}error(o,...f){this.f(h.Error)&&this.g.log(h.Error,[this.h(o),...f])}h(o){return typeof o=="string"?o:(0,n.toErrorMessage)(o,this.f(h.Trace))}dispose(){}flush(){}}e.AdapterLogger=E;class L extends a{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const f of this.g)f.setLevel(o);super.setLevel(o)}trace(o,...f){for(const k of this.g)k.trace(o,...f)}debug(o,...f){for(const k of this.g)k.debug(o,...f)}info(o,...f){for(const k of this.g)k.info(o,...f)}warn(o,...f){for(const k of this.g)k.warn(o,...f)}error(o,...f){for(const k of this.g)k.error(o,...f)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogger=L;class v extends D.Disposable{constructor(o,f){if(super(),this.j=o,this.b=new M.ResourceMap,this.c=new M.ResourceMap,this.f=this.B(new C.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new C.Emitter),this.onDidChangeVisibility=this.h.event,f)for(const k of f)this.c.set(k.resource,k)}getLogger(o){return this.b.get(o)}createLogger(o,f){let k=this.b.get(o);const A=f?.logLevel==="always"?h.Trace:f?.logLevel;return k||(k=this.k(o,A??this.getLogLevel(o)??this.j,f),this.b.set(o,k)),this.registerLogger({resource:o,id:f?.id??o.toString(),logLevel:A,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId}),k}setLogLevel(o,f){if(y.URI.isUri(o)){const k=o,A=f,V=this.c.get(k);V&&A!==V.logLevel&&(V.logLevel=A===this.j?void 0:A,this.b.get(k)?.setLevel(A),this.c.set(V.resource,V),this.g.fire([k,A]))}else{this.j=o;for(const[k,A]of this.b.entries())this.c.get(k)?.logLevel===void 0&&A.setLevel(this.j);this.g.fire(this.j)}}setVisibility(o,f){const k=this.c.get(o);k&&f!==!k.hidden&&(k.hidden=!f,this.c.set(k.resource,k),this.h.fire([o,f]))}getLogLevel(o){let f;return o&&(f=this.c.get(o)?.logLevel),f??this.j}registerLogger(o){const f=this.c.get(o.resource);f?f.hidden!==o.hidden&&this.setVisibility(o.resource,!o.hidden):(this.c.set(o.resource,o),this.f.fire({added:[o],removed:[]}))}deregisterLogger(o){const f=this.c.get(o);if(f){this.c.delete(o);const k=this.b.get(o);k&&(this.b.delete(o),k.dispose()),this.f.fire({added:[],removed:[f]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(o){return this.c.get(o)}dispose(){this.b.forEach(o=>o.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=v;class t{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(o){}getLevel(){return h.Info}trace(o,...f){}debug(o,...f){}info(o,...f){}warn(o,...f){}error(o,...f){}critical(o,...f){}dispose(){}flush(){}}e.NullLogger=t;class d extends t{}e.NullLogService=d;class r extends v{constructor(){super(h.Info)}k(o,f,k){return new t}}e.NullLoggerService=r;function u(c){if(c.verbose)return h.Trace;if(typeof c.logLevel=="string"){const o=p(c.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function i(c){switch(c){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.LogLevelToString=i;function p(c){switch(c){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.parseLogLevel=p}),define(Ce[162],ke([1,0,6,11]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class D extends n.Disposable{constructor(S,R=[]){super(),this.a=new C.MultiplexLogger([S,...R]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...R){this.a.trace(S,...R)}debug(S,...R){this.a.debug(S,...R)}info(S,...R){this.a.info(S,...R)}warn(S,...R){this.a.warn(S,...R)}error(S,...R){this.a.error(S,...R)}flush(){this.a.flush()}}e.LogService=D}),define(Ce[91],ke([1,0,29,136,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(m,a){return a-m}y.compare=T;const N=Object.create(null);N[y.Error]=(0,C.localize)(0,null),N[y.Warning]=(0,C.localize)(1,null),N[y.Info]=(0,C.localize)(2,null);function w(m){return N[m]||""}y.toString=w;function h(m){switch(m){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=h;function b(m){switch(m){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=b}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var R;(function(y){const T="";function N(h){return w(h,!0)}y.makeKey=N;function w(h,b){const m=[T];return h.source?m.push(h.source.replace("\xA6","\\\xA6")):m.push(T),h.code?typeof h.code=="string"?m.push(h.code.replace("\xA6","\\\xA6")):m.push(h.code.value.replace("\xA6","\\\xA6")):m.push(T),h.severity!==void 0&&h.severity!==null?m.push(S.toString(h.severity)):m.push(T),h.message&&b?m.push(h.message.replace("\xA6","\\\xA6")):m.push(T),h.startLineNumber!==void 0&&h.startLineNumber!==null?m.push(h.startLineNumber.toString()):m.push(T),h.startColumn!==void 0&&h.startColumn!==null?m.push(h.startColumn.toString()):m.push(T),h.endLineNumber!==void 0&&h.endLineNumber!==null?m.push(h.endLineNumber.toString()):m.push(T),h.endColumn!==void 0&&h.endColumn!==null?m.push(h.endColumn.toString()):m.push(T),m.push(T),m.join("\xA6")}y.makeKeyOptionalMessage=w})(R=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(Ce[163],ke([1,0,4,29,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=C.default,e.INotificationService=(0,D.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class R{constructor(){this.progress=new y,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=R;class y{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=y}),define(Ce[92],ke([1,0,10,2,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,D.createDecorator)("openerService");function M(T,N){return C.URI.isUri(T)?(0,n.equalsIgnoreCase)(T.scheme,N):(0,n.startsWithIgnoreCase)(T,N+":")}e.matchesScheme=M;function S(T,...N){return N.some(w=>M(T,w))}e.matchesSomeScheme=S;function R(T,N){return T.with({fragment:`${N.startLineNumber},${N.startColumn}${N.endLineNumber?`-${N.endLineNumber}${N.endColumn?`,${N.endColumn}`:""}`:""}`})}e.withSelection=R;function y(T){let N;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(T.fragment);return w&&(N={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},T=T.with({fragment:""})),{selection:N,uri:T}}e.extractSelection=y}),define(Ce[164],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(te,e,n,C){var D=arguments.length,M=D<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(te,e,n,C);else for(var R=te.length-1;R>=0;R--)(S=te[R])&&(M=(D<3?S(M):D>3?S(e,n,M):S(e,n))||M);return D>3&&M&&Object.defineProperty(e,n,M),M},je=this&&this.__param||function(te,e){return function(n,C){e(n,C,te)}};define(Ce[165],ke([1,0,17,20,6,3]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var S;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}R.None=Object.freeze({report(){}}),e.Progress=R;let y=class extends D.Disposable{constructor(w,h){super(),this.a=new n.DeferredPromise,h.withProgress(w,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,D.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};y=qe([je(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends D.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new D.DisposableStore)}start(w){this.stop();const h=++this.a,b=new C.CancellationTokenSource;return this.f=setTimeout(()=>{h===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,D.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,D.toDisposable)(()=>b.cancel())),this.b.add((0,D.toDisposable)(()=>this.c?this.c.done():void 0)),{id:h,token:b.token,stop:()=>this.h(h),isCurrent:()=>this.a===h}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],ke([1,0,49,9]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(S,R){n.ok(C.isString(S)),n.ok(C.isObject(R)),n.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,R)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new D}),define(Ce[68],ke([1,0,4,30]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class M{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,T){this.a[D(y)]=T,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new M;C.Registry.add(e.Extensions.JSONContribution,S)}),define(Ce[93],ke([1,0,16,4,9,132,41,68,30]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var N;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(R.Extensions.JSONContribution);class h{constructor(){this.h=new Set,this.i=new C.Emitter,this.onDidSchemaChange=this.i.event,this.j=new C.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const r=new Set;this.n(t,d,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const d=new Set;this.o(t,d),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const r=new Set;this.o(d,r),this.n(t,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const r=[];for(const{overrides:u,source:i}of t)for(const p in u)if(d.add(p),e.OVERRIDE_PROPERTY_REGEX.test(p)){const c=this.a.get(p),o=c?.valuesSources??new Map;if(i)for(const V of Object.keys(u[p]))o.set(V,i);const f={...c?.value||{},...u[p]};this.a.set(p,{source:i,value:f,valuesSources:o});const k=(0,S.getLanguageTagSettingPlainKey)(p),A={type:"object",default:f,description:M.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:D.isString(i)?void 0:i,defaultValueSource:i};r.push(...a(p)),this.d[p]=A,this.b.properties[p]=A}else{this.a.set(p,{value:u[p],source:i});const c=this.d[p];c&&(this.w(p,c),this.r(p,c))}this.m(r)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:r,source:u}of t)for(const i in r){const p=this.a.get(i),c=D.isString(u)?u:u?.id,o=D.isString(p?.source)?p?.source:p?.source?.id;if(c===o)if(d.add(i),this.a.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.d[i],delete this.b.properties[i];else{const f=this.d[i];f&&(this.w(i,f),this.r(i,f))}}this.u()}deltaConfiguration(t){let d=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,r){t.forEach(u=>{this.p(u,d,u.extensionInfo,u.restrictedProperties,void 0,r),this.c.push(u),this.q(u)})}o(t,d){const r=u=>{if(u.properties)for(const i in u.properties){d.add(i);const p=this.d[i];p?.policy?.name&&this.e.delete(p.policy.name),delete this.d[i],this.s(i,u.properties[i])}u.allOf?.forEach(i=>r(i))};for(const u of t){r(u);const i=this.c.indexOf(u);i!==-1&&this.c.splice(i,1)}}p(t,d=!0,r,u,i=3,p){i=D.isUndefinedOrNull(t.scope)?i:t.scope;const c=t.properties;if(c)for(const f in c){const k=c[f];if(d&&E(f,k)){delete c[f];continue}if(k.source=r,k.defaultDefaultValue=c[f].default,this.w(f,k),e.OVERRIDE_PROPERTY_REGEX.test(f)?k.scope=void 0:(k.scope=D.isUndefinedOrNull(k.scope)?i:k.scope,k.restricted=D.isUndefinedOrNull(k.restricted)?!!u?.includes(f):k.restricted),c[f].hasOwnProperty("included")&&!c[f].included){this.f[f]=c[f],delete c[f];continue}else this.d[f]=c[f],c[f].policy?.name&&this.e.set(c[f].policy.name,f);!c[f].deprecationMessage&&c[f].markdownDeprecationMessage&&(c[f].deprecationMessage=c[f].markdownDeprecationMessage),p.add(f)}const o=t.allOf;if(o)for(const f of o)this.p(f,d,r,u,i,p)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=r=>{const u=r.properties;if(u)for(const p in u)this.r(p,u[p]);r.allOf?.forEach(d)};d(t)}r(t,d){switch(e.allSettings.properties[t]=d,d.scope){case 1:e.applicationSettings.properties[t]=d;break;case 2:e.machineSettings.properties[t]=d;break;case 6:e.machineOverridableSettings.properties[t]=d;break;case 3:e.windowSettings.properties[t]=d;break;case 4:e.resourceSettings.properties[t]=d;break;case 5:e.resourceSettings.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.allSettings.properties[t],d.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(d,r),e.allSettings.properties[d]=r,e.applicationSettings.properties[d]=r,e.machineSettings.properties[d]=r,e.machineOverridableSettings.properties[d]=r,e.windowSettings.properties[d]=r,e.resourceSettings.properties[d]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,d){const r=this.a.get(t);let u=r?.value,i=r?.source;D.isUndefined(u)&&(u=d.defaultDefaultValue,i=void 0),D.isUndefined(u)&&(u=l(d.type)),d.default=u,d.defaultValueSource=i}}const b="\\[([^\\]]+)\\]",m=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function a(v){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let d=m.exec(v);for(;d?.length;){const r=d[1].trim();r&&t.push(r),d=m.exec(v)}}return(0,n.distinct)(t)}e.overrideIdentifiersFromKey=a;function s(v){return v.reduce((t,d)=>`${t}[${d}]`,"")}e.keyFromOverrideIdentifiers=s;function l(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new h;y.Registry.add(e.Extensions.Configuration,g);function E(v,t){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?M.localize(7,null,v):g.getConfigurationProperties()[v]!==void 0?M.localize(8,null,v):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,v,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function L(){const v=[],t=g.getConfigurationProperties();for(const d of Object.keys(t))v.push([d,t[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=L}),define(Ce[166],ke([1,0,16,4,111,6,28,22,9,2,41,93,30]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function b(d){return Object.isFrozen(d)?d:R.deepFreeze(d)}class m{constructor(r={},u=[],i=[],p){this.b=r,this.c=u,this.d=i,this.raw=p,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(u=>{if(u instanceof m)return u;const i=new a("");return i.parseRaw(u),i.configurationModel});this.f=r.reduce((u,i)=>i===u?i:u.merge(i),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}inspect(r,u){const i=this.rawConfiguration.getValue(r),p=u?this.rawConfiguration.getOverrideValue(r,u):void 0,c=u?this.rawConfiguration.override(u).getValue(r):i;return{value:i,override:p,merged:c}}getOverrideValue(r,u){const i=this.i(u);return i?r?(0,N.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const u=[];for(const i of this.overrides)i.identifiers.includes(r)&&u.push(...i.keys);return n.distinct(u)}getAllOverrideIdentifiers(){const r=[];for(const u of this.overrides)r.push(...u.identifiers);return n.distinct(r)}override(r){let u=this.a.get(r);return u||(u=this.g(r),this.a.set(r,u)),u}merge(...r){const u=R.deepClone(this.contents),i=R.deepClone(this.overrides),p=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const o of r)if(c.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.h(u,o.contents);for(const f of o.overrides){const[k]=i.filter(A=>n.equals(A.identifiers,f.identifiers));k?(this.h(k.contents,f.contents),k.keys.push(...f.keys),k.keys=n.distinct(k.keys)):i.push(R.deepClone(f))}for(const f of o.keys)p.indexOf(f)===-1&&p.push(f)}return new m(u,p,i,c.every(o=>o instanceof m)?void 0:c)}g(r){const u=this.i(r);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const i={};for(const p of n.distinct([...Object.keys(this.contents),...Object.keys(u)])){let c=this.contents[p];const o=u[p];o&&(typeof c=="object"&&typeof o=="object"?(c=R.deepClone(c),this.h(c,o)):c=o),i[p]=c}return new m(i,this.keys,this.overrides)}h(r,u){for(const i of Object.keys(u)){if(i in r&&y.isObject(r[i])&&y.isObject(u[i])){this.h(r[i],u[i]);continue}r[i]=R.deepClone(u[i])}}i(r){let u=null,i=null;const p=c=>{c&&(i?this.h(i,c):i=R.deepClone(c))};for(const c of this.overrides)n.equals(c.identifiers,[r])?u=c.contents:c.identifiers.includes(r)&&p(c.contents);return p(u),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,u){this.j(r,u,!0)}setValue(r,u){this.j(r,u,!1)}removeValue(r){const u=this.keys.indexOf(r);u!==-1&&(this.keys.splice(u,1),(0,N.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(i=>n.equals(i.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,u,i){(0,N.addToValueTree)(this.contents,r,u,p=>console.error(p)),i=i||this.keys.indexOf(r)===-1,i&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,N.toValuesTree)(this.contents[r],p=>console.error(p))})}}e.ConfigurationModel=m;class a{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,u){if(!y.isUndefinedOrNull(r)){const i=this.g(r);this.parseRaw(i,u)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,u){this.a=r;const{contents:i,keys:p,overrides:c,restricted:o,hasExcludedProperties:f}=this.h(r,u);this.b=new m(i,p,c,f?[r]:void 0),this.c=o||[]}g(r){let u={},i=null,p=[];const c=[],o=[];function f(A){Array.isArray(p)?p.push(A):i!==null&&(p[i]=A)}const k={onObjectBegin:()=>{const A={};f(A),c.push(p),p=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{p=c.pop()},onArrayBegin:()=>{const A=[];f(A),c.push(p),p=A,i=null},onArrayEnd:()=>{p=c.pop()},onLiteralValue:f,onError:(A,V,_)=>{o.push({error:A,offset:V,length:_})}};if(r)try{D.visit(r,k),u=p[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return u}h(r,u){const i=h.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),p=this.i(r,i,!0,u);r=p.raw;const c=(0,N.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),o=Object.keys(r),f=this.j(r,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:c,keys:o,overrides:f,restricted:p.restricted,hasExcludedProperties:p.hasExcludedProperties}}i(r,u,i,p){let c=!1;if(!p?.scopes&&!p?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const o={},f=[];for(const k in r)if(w.OVERRIDE_PROPERTY_REGEX.test(k)&&i){const A=this.i(r[k],u,!1,p);o[k]=A.raw,c=c||A.hasExcludedProperties,f.push(...A.restricted)}else{const A=u[k],V=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&f.push(k),(V===void 0||p.scopes===void 0||p.scopes.includes(V))&&!(p.skipRestricted&&A?.restricted)?o[k]=r[k]:c=!0}return{raw:o,restricted:f,hasExcludedProperties:c}}j(r,u){const i=[];for(const p of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(p)){const c={};for(const o in r[p])c[o]=r[p][o];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(p),keys:Object.keys(c),contents:(0,N.toValuesTree)(c,u)})}return i}}e.ConfigurationModelParser=a;class s extends M.Disposable{constructor(r,u,i,p){super(),this.f=r,this.g=u,this.h=p,this.c=this.B(new C.Emitter),this.onDidChange=this.c.event,this.a=new a(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(i.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(C.Event.any(C.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),C.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=s;class l{constructor(r,u,i,p,c,o,f,k,A,V,_,K,O){this.a=r,this.b=u,this.c=i,this.overrideIdentifiers=p,this.d=c,this.f=o,this.g=f,this.h=k,this.i=A,this.j=V,this.k=_,this.l=K,this.m=O}get value(){return b(this.c)}n(r,u,i){const p=r.inspect(u,i);return{get value(){return b(p.value)},get override(){return b(p.override)},get merged(){return b(p.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(r,u,i,p,c=new m,o=new m,f=new S.ResourceMap,k=new m,A=new S.ResourceMap){this.c=r,this.d=u,this.f=i,this.g=p,this.h=c,this.i=o,this.j=f,this.l=k,this.m=A,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(r,u,i){return this.q(r,u,i).getValue(r)}updateValue(r,u,i={}){let p;i.resource?(p=this.m.get(i.resource),p||(p=new m,this.m.set(i.resource,p))):p=this.l,u===void 0?p.removeValue(r):p.setValue(r,u),i.resource||(this.a=null)}inspect(r,u,i){const p=this.q(r,u,i),c=this.u(u.resource,i),o=u.resource?this.m.get(u.resource)||this.l:this.l,f=new Set;for(const k of p.overrides)for(const A of k.identifiers)p.getOverrideValue(r,A)!==void 0&&f.add(A);return new l(r,u,p.getValue(r),f.size?[...f]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,c||void 0,o)}keys(r){const u=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,u){this.j.set(r,u),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,u){const i=[];if(!u){const{added:p,updated:c,removed:o}=v(this.c,r);u=[...p,...c,...o]}for(const p of u)for(const c of(0,w.overrideIdentifiersFromKey)(p)){const o=this.c.getKeysForOverrideIdentifier(c),f=r.getKeysForOverrideIdentifier(c),k=[...f.filter(A=>o.indexOf(A)===-1),...o.filter(A=>f.indexOf(A)===-1),...o.filter(A=>!R.equals(this.c.override(c).getValue(A),r.override(c).getValue(A)))];i.push([c,k])}return this.updateDefaultConfiguration(r),{keys:u,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:u,updated:i,removed:p}=v(this.d,r),c=[...u,...i,...p];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.applicationConfiguration,r),o=[...u,...i,...p];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.localUserConfiguration,r),o=[...u,...i,...p];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.remoteUserConfiguration,r),o=[...u,...i,...p];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:u,updated:i,removed:p,overrides:c}=v(this.workspaceConfiguration,r),o=[...u,...i,...p];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:c}}compareAndUpdateFolderConfiguration(r,u){const i=this.p.get(r),{added:p,updated:c,removed:o,overrides:f}=v(i,u),k=[...p,...c,...o];return(k.length||!i)&&this.updateFolderConfiguration(r,u),{keys:k,overrides:f}}compareAndDeleteFolderConfiguration(r){const u=this.p.get(r);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:p,removed:c,overrides:o}=v(u,void 0);return{keys:[...i,...p,...c],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,u,i){let p=this.r(u,i);return u.overrideIdentifier&&(p=p.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(p=p.merge(this.d)),p}r({resource:r},u){let i=this.s();if(u&&r){const p=u.getFolder(r);p&&(i=this.t(p.uri)||i);const c=this.m.get(r);c&&(i=i.merge(c))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let u=this.b.get(r);if(!u){const i=this.s(),p=this.j.get(r);p?(u=i.merge(p),this.b.set(r,u)):u=i}return u}u(r,u){if(u&&r){const i=u.getFolder(r);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,u)=>{const{contents:i,overrides:p,keys:c}=this.j.get(u);return r.push([u,{contents:i,overrides:p,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(u=>r.add(u)),this.userConfiguration.keys.forEach(u=>r.add(u)),this.i.keys.forEach(u=>r.add(u)),this.j.forEach(u=>u.keys.forEach(i=>r.add(i))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>r.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}w(r){const u=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.i.getKeysForOverrideIdentifier(r).forEach(i=>u.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(p=>u.add(p))),[...u.values()]}static parse(r){const u=this.x(r.defaults),i=this.x(r.policy),p=this.x(r.application),c=this.x(r.user),o=this.x(r.workspace),f=r.folders.reduce((k,A)=>(k.set(T.URI.revive(A[0]),this.x(A[1])),k),new S.ResourceMap);return new g(u,i,p,c,new m,o,f,new m,new S.ResourceMap)}static x(r){return new m(r.contents,r.keys,r.overrides)}}e.Configuration=g;function E(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const r=new Set,u=new Map;for(const p of d)p.keys.forEach(c=>r.add(c)),p.overrides.forEach(([c,o])=>{const f=(0,S.getOrSet)(u,c,new Set);o.forEach(k=>f.add(k))});const i=[];return u.forEach((p,c)=>i.push([c,[...p.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=E;class L{constructor(r,u,i,p){this.change=r,this.f=u,this.g=i,this.h=p,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const o of c)this.affectedKeys.add(o);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(r,u){const i=this.a+r,p=this.d.indexOf(i);if(p<0)return!1;const c=p+i.length;if(c>=this.d.length)return!1;const o=this.d.charCodeAt(c);if(o!==this.b&&o!==this.c)return!1;if(u){const f=this.previousConfiguration?this.previousConfiguration.getValue(r,u,this.f?.workspace):void 0,k=this.g.getValue(r,u,this.h);return!R.equals(f,k)}return!0}}e.ConfigurationChangeEvent=L;function v(d,r){const{added:u,removed:i,updated:p}=t(r?.rawConfiguration,d?.rawConfiguration),c=[],o=d?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const k=f.filter(A=>!o.includes(A));for(const A of k)c.push([A,r.getKeysForOverrideIdentifier(A)])}if(d){const k=o.filter(A=>!f.includes(A));for(const A of k)c.push([A,d.getKeysForOverrideIdentifier(A)])}if(r&&d){for(const k of o)if(f.includes(k)){const A=t({contents:d.getOverrideValue(void 0,k)||{},keys:d.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});c.push([k,[...A.added,...A.removed,...A.updated]])}}return{added:u,removed:i,updated:p,overrides:c}}function t(d,r){const u=d?r?d.keys.filter(c=>r.keys.indexOf(c)===-1):[...d.keys]:[],i=r?d?r.keys.filter(c=>d.keys.indexOf(c)===-1):[...r.keys]:[],p=[];if(d&&r){for(const c of r.keys)if(d.keys.indexOf(c)!==-1){const o=(0,N.getConfigurationValue)(r.contents,c),f=(0,N.getConfigurationValue)(d.contents,c);R.equals(o,f)||p.push(c)}}return{added:u,removed:i,updated:p}}}),define(Ce[94],ke([1,0,12,3]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,C.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends n.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof M&&y._code===D.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof M&&y._code===D.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof M&&y._code===D.NoResolverFound}static isHandled(y){return y instanceof M&&y.isHandled}constructor(y,T=D.Unknown,N){super(y),this._message=y,this._code=T,this._detail=N,this.isHandled=T===D.NotAvailable&&N===!0,Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M;function S(R){const y=R.indexOf("+");return y===-1?R:R.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(Ce[50],ke([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(T){return T.scheme===n.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=C;function D(T){if(!T)return;const N=T.indexOf("+");return N<0?T:T.substr(0,N)}e.getRemoteName=D;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function S(T){const{host:N,port:w}=y(T);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:N,port:w}}e.parseAuthorityWithPort=S;function R(T,N){let{host:w,port:h}=y(T);return typeof h>"u"&&(h=N),{host:w,port:h}}e.parseAuthorityWithOptionalPort=R;function y(T){const N=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(N)return{host:N[1],port:parseInt(N[2],10)};const w=T.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const h=T.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:T,port:void 0}}}),define(Ce[25],ke([1,0,10,3,50]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.getWorkspaceSupportTypeMessage=M,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var R;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,a){if(typeof m>"u"||m===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){const s=typeof m=="string"?m:m.value,l=typeof a=="string"?a:a.value;return n.equalsIgnoreCase(s,l)}return m.c===a.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=y;function T(b){return N(b)}e.isApplicationScopedExtension=T;function N(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.isLanguagePackExtension=N;function w(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=w;function h(b,m){if(m){const a=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return b.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=h,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[167],ke([1,0,21,51,2,34]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(T){if(n.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function R(T,N,w,h,b,m,a,s,l,g){const E=Object.create(null);E["common.machineId"]=a,E.sessionID=(0,M.generateUuid)()+Date.now(),E.commitHash=b,E.version=m,E["common.platformVersion"]=(N||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),E["common.platform"]=(0,n.PlatformToString)(n.platform),E["common.nodePlatform"]=C.platform,E["common.nodeArch"]=h,E["common.product"]=g||"desktop",s&&(E["common.msftInternal"]=s);let L=0;const v=Date.now();Object.defineProperties(E,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>L++,enumerable:!0}}),n.isLinuxSnap&&(E["common.snap"]="true");const t=S(w);t&&(E["common.platformDetail"]=t);try{const d=await T.readFile(D.URI.file(l));E["common.source"]=d.value.toString().slice(0,30)}catch{}return E}e.resolveCommonProperties=R;function y(T){const N=C.env.USERDNSDOMAIN;if(!N)return!1;const w=N.toLowerCase();return T.some(h=>w===h)}e.verifyMicrosoftInternalDomain=y}),define(Ce[168],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Ce[52],ke([1,0,22,9,4,41,50,167,168]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class T{constructor(c){this.value=c}}e.TelemetryTrustedValue=T;class N{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,o){return Promise.resolve(void 0)}publicLog2(c,o){return this.publicLog(c,o)}publicLogError(c,o){return Promise.resolve(void 0)}publicLogError2(c,o){return this.publicLogError(c,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=N,e.NullTelemetryService=new N;class w{async publicLog(c,o,f){}async publicLogError(c,o,f){}}e.NullEndpointTelemetryService=w,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(p,c){return D.Event.debounce(c.onDidChangeConfiguration,(f,k)=>{const A=f?new Set([...f.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:A}},1e3,!0)(f=>{f.source!==7&&p.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(f.source),configurationKeys:L(f.affectedKeys)})})}e.configurationTelemetry=h;function b(p,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!p.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(p,c){return!(c.isBuilt||c.disableTelemetry||p.enableTelemetry&&p.aiConfig?.ariaKey)}e.isLoggingOnly=m;function a(p){const c=p.getValue(y.TELEMETRY_SETTING_ID),o=p.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(p.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=a;function s(p){const c={},o={},f={};E(p,f);for(let k in f){k=k.length>150?k.substr(k.length-149):k;const A=f[k];typeof A=="number"?o[k]=A:typeof A=="boolean"?o[k]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${A.length}`),c[k]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(c[k]=A)}return{properties:c,measurements:o}}e.validateTelemetryData=s;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function g(p){if(!p)return"none";const c=(0,S.getRemoteName)(p);return l.has(c)?c:"other"}e.cleanRemoteAuthority=g;function E(p,c,o=0,f){if(!!p)for(const k of Object.getOwnPropertyNames(p)){const A=p[k],V=f?f+k:k;Array.isArray(A)?c[V]=(0,n.safeStringify)(A):A instanceof Date?c[V]=A.toISOString():(0,C.isObject)(A)?o<2?E(A,c,o+1,V+"."):c[V]=(0,n.safeStringify)(A):c[V]=A}}function L(p){if(!p)return[];const c=[];return v(c,"",p),c}function v(p,c,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(f=>v(p,c?`${c}.${f}`:f,o[f])):p.push(c)}function t(p,c){const o=p.msftInternalDomains||[],f=c.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(o)||f}e.isInternalTelemetry=t;function d(p){return[p.appRoot,p.extensionsPath,p.userHome.fsPath,p.tmpDir.fsPath,p.userDataPath]}e.getPiiPathsFromEnvironment=d;function r(p,c){if(!p||!p.includes("/")&&!p.includes("\\"))return p;let o=p;const f=[];for(const _ of c)for(;;){const K=_.exec(p);if(!K)break;f.push([K.index,_.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let V=0;for(o="";;){const _=A.exec(p);if(!_)break;const K=f.some(([O,B])=>_.index<B&&O<A.lastIndex);!k.test(_[0])&&!K&&(o+=p.substring(V,_.index)+"<REDACTED: user-file-path>",V=A.lastIndex)}return V<p.length&&(o+=p.substr(V)),o}function u(p){if(!p)return p;const c=p.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of o)if(f.regex.test(c))return`<REDACTED: ${f.label}>`;return p}function i(p,c){return(0,n.cloneAndChange)(p,o=>{if(o instanceof T)return o.value;if(typeof o=="string"){let f=o.replaceAll("%20"," ");f=r(f,c);for(const k of c)f=f.replace(k,"");return f=u(f),f}})}e.cleanData=i}),define(Ce[169],ke([1,0,10,90,25,21,2,12,51,52]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function N(r,u){return r.uuid&&u.uuid?r.uuid===u.uuid:r.id===u.id?!0:(0,n.compareIgnoreCase)(r.id,u.id)===0}e.areSameExtensions=N;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(u){const i=u.manifest?u.manifest.version:u.version,p=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new h(u.identifier,i,p)}static parse(u){const i=w.exec(u);return i&&i[1]&&i[2]?new h({id:i[1]},i[2],i[4]||void 0):null}constructor(u,i,p="undefined"){this.version=i,this.targetPlatform=p,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof h?N(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=h;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const u=b.exec(r);return u&&u[1]?[s(u[1]),u[2]]:[s(r),void 0]}e.getIdAndVersion=m;function a(r,u){return`${r}.${u}`}e.getExtensionId=a;function s(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=s;function l(r,u){return s(a(r,u))}e.getGalleryExtensionId=l;function g(r,u){const i=[],p=c=>{for(const o of i)if(o.some(f=>N(u(f),u(c))))return o;return null};for(const c of r){const o=p(c);o?o.push(c):i.push([c])}return i}e.groupByExtension=g;function E(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=E;function L(r){return{id:new T.TelemetryTrustedValue(r.identifier.id),name:new T.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=L,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function v(r,u){const i=[],p=u.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const c=p.shift();if(c&&i.every(o=>!N(o.identifier,{id:c}))){const o=r.filter(f=>N(f.identifier,{id:c}));o.length===1&&(i.push(o[0]),p.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=v;async function t(r,u){if(!M.isLinux)return!1;let i;try{i=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){u.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(r,u){const i=await t(r,u),p=(0,C.getTargetPlatform)(i?"alpine":M.platform,y.arch);return u.debug("ComputeTargetPlatform:",p),p}e.computeTargetPlatform=d}),define(Ce[170],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function n(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=n;function C(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=C;function D(S){return Array.from(S.entries()).map(R=>[R[0],n(R[1].map)])}e.serializeEnvironmentVariableCollections=D;function M(S){return new Map(S.map(R=>[R[0],{map:C(R[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[171],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(D){this.b=D,this.a=new Map}dispose(){for(const D of this.a.values())D.dispose()}startBuffering(D,M,S=5){const R=M(y=>{const T=typeof y=="string"?y:y.data;let N=this.a.get(D);if(N){N.data.push(T);return}const w=setTimeout(()=>this.flushBuffer(D),S);N={data:[T],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(D),R.dispose()}},this.a.set(D,N)});return R}stopBuffering(D){this.a.get(D)?.dispose()}flushBuffer(D){const M=this.a.get(D);M&&(this.a.delete(D),this.b(D,M.data.join("")))}}e.TerminalDataBufferer=n}),define(Ce[172],ke([1,0,17,84,38,4,9,2,137,68,30]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(L){function v(t,d){let r=t.defaults;for(;D.ThemeIcon.isThemeIcon(r);){const u=m.getIcon(r.id);if(!u)return;r=u.defaults}return r}L.getDefinition=v})(w=e.IconContribution||(e.IconContribution={}));var h;(function(L){function v(d){return{weight:d.weight,style:d.style,src:d.src.map(r=>({format:r.format,location:r.location.toString()}))}}L.toJSONObject=v;function t(d){const r=u=>(0,S.isString)(u)?u:void 0;if(d&&Array.isArray(d.src)&&d.src.every(u=>(0,S.isString)(u.format)&&(0,S.isString)(u.location)))return{weight:r(d.weight),style:r(d.style),src:d.src.map(u=>({format:u.format,location:R.URI.parse(u.location)}))}}L.fromJSONObject=t})(h=e.IconFontDefinition||(e.IconFontDefinition={}));class b{constructor(){this.a=new M.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${D.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,t,d,r){const u=this.b[v];if(u){if(d&&!u.description){u.description=d,this.d.properties[v].markdownDescription=`${d} $(${v})`;const c=this.e.enum.indexOf(v);c!==-1&&(this.e.enumDescriptions[c]=d),this.a.fire()}return u}const i={id:v,description:d,defaults:t,deprecationMessage:r};this.b[v]=i;const p={$ref:"#/definitions/icons"};return r&&(p.deprecationMessage=r),d&&(p.markdownDescription=`${d}: $(${v})`),this.d.properties[v]=p,this.e.enum.push(v),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const t=this.e.enum.indexOf(v);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,t){const d=this.f[v];return d||(this.f[v]=t,this.a.fire(),t)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(u,i)=>u.id.localeCompare(i.id),t=u=>{for(;D.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(u=>this.b[u]);for(const u of r.filter(i=>!!i.description).sort(v))d.push(`|<i class="${t(u)}"></i>|${u.id}|${D.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const u of r.filter(i=>!D.ThemeIcon.isThemeIcon(i.defaults)).sort(v))d.push(`|<i class="${t(u)}"></i>|${u.id}|`);return d.join(`
`)}}const m=new b;N.Registry.add(e.Extensions.IconContribution,m);function a(L,v,t,d){return m.registerIcon(L,v,t,d)}e.registerIcon=a;function s(){return m}e.getIconRegistry=s;function l(){const L=(0,C.getCodiconFontCharacters)();for(const v in L){const t="\\"+L[v].toString(16);m.registerIcon(v,{fontCharacter:t})}}l(),e.iconsSchemaId="vscode://schemas/icons";const g=N.Registry.as(T.Extensions.JSONContribution);g.registerSchema(e.iconsSchemaId,m.getIconSchema());const E=new n.RunOnceScheduler(()=>g.notifySchemaChanged(e.iconsSchemaId),200);m.onDidChange(()=>{E.isScheduled()||E.schedule()}),e.widgetClose=a("widget-close",C.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=a("goto-previous-location",C.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=a("goto-next-location",C.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=D.ThemeIcon.modify(C.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(C.Codicon.loading,"spin")}),define(Ce[173],ke([1,0,4,41,3,11]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var S;(function(a){a.Http="http",a.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=w;function h(a,s,l,g){if(l===1)return!1;if(l===2&&w(s)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return a<1024}e.isPortPrivileged=h;class b{constructor(s,l,g){this.remoteAddress=s,this.localAddress=l,this.b=g,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=b;let m=class{constructor(s,l){this.i=s,this.j=l,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],l=Array.from(this.d.values());for(const g of l){const E=Array.from(g.values());for(const L of E){const v=await L.value;v&&s.push(v)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:l}of s.values())await l.then(g=>g?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,l,g,E,L){this.o(s,l,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:l,localAddress:g,privacy:E,protocol:L,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,l){(w(s)||N(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const g=this.q(s,l);if(g)return++g.refcount,g.value}openTunnel(s,l,g,E,L,v=!1,t,d){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${g} on local port ${L}.`),!s)return;if(l||(l="localhost"),E||(E=this.k),this.e&&this.h.has(g)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(s,l,g,E,L,v,t,d);return r?r.then(u=>{if(!u){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,g);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.m(u);return(u.tunnelRemoteHost!==l||u.tunnelRemotePort!==g)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(i),i}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const l=this.d.get(s.tunnelRemoteHost);if(l){const g=l.get(s.tunnelRemotePort);g&&(g.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,g))}}}}async n(s,l,g){if(g.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${l}.`);const E=g.value.then(async L=>{L&&(await L.dispose(!0),this.b.fire({host:L.tunnelRemoteHost,port:L.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(l),E}}async closeTunnel(s,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${l} `);const g=this.d.get(s);if(g&&g.has(l)){const E=g.get(l);E.refcount=0,await this.n(s,l,E)}}o(s,l,g){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(l,{refcount:1,value:g})}async p(s,l){const g=this.d.get(s);g&&(await g.get(l)||g.delete(l),g.size===0&&this.d.delete(s))}q(s,l){const g=[s];N(s)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(s)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(L=>this.d.get(L));for(const L of E){const v=L?.get(l);if(v)return v}}canTunnel(s){return!!T(s)}s(s,l,g,E,L,v,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${g} on local port ${E}.`);const d=g;this.h.add(d);const r=E===void 0?g:E,u={elevationRequired:L?this.isPortPrivileged(r):!1},i={remoteAddress:{host:l,port:g},localAddressPort:E,privacy:v,public:v?v!==R.Private:void 0,protocol:t},p=s.forwardPort(i,u);return p?(this.o(l,g,p),p.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(d)})):this.h.delete(d),p}};m=qe([je(0,M.ILogService),je(1,C.IConfigurationService)],m),e.AbstractTunnelService=m}),define(Ce[174],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var C;(function(D){D[D.Complete=100]="Complete",D[D.Partial=50]="Partial",D[D.None=0]="None"})(C=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(Ce[175],ke([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function C(y){return y.scheme!==n.Schemas.file&&y.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=C;function D(y){if(y.folders.length)return y.folders.every(T=>C(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&C(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=D;function M(y){return D(y)?.scheme}e.getVirtualWorkspaceScheme=M;function S(y){return D(y)?.authority}e.getVirtualWorkspaceAuthority=S;function R(y){return D(y)!==void 0}e.isVirtualWorkspace=R}),define(Ce[53],ke([1,0,138,19,48,24,2,3,15]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function T(r){const u=r;return typeof u?.id=="string"&&S.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=T;function N(r){return typeof r?.id=="string"&&!T(r)&&!h(r)}e.isEmptyWorkspaceIdentifier=N,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(r,u){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,C.basename)(r)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const i=r;return i.configuration?{id:i.id,configPath:i.configuration}:i.folders.length===1?{id:i.id,uri:i.folders[0].uri}:{id:i.id}}e.toWorkspaceIdentifier=w;function h(r){const u=r;return typeof u?.id=="string"&&S.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=h;function b(r){const u=r;if(u?.uri)return{id:u.id,uri:S.URI.revive(u.uri)};const i=r;if(i?.configPath)return{id:i.id,configPath:S.URI.revive(i.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=b;var m;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function a(r){const u=r;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=a;function s(r){const u=r;return!!(u&&typeof u=="object"&&S.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=s;class l{constructor(u,i,p,c,o){this.h=u,this.j=p,this.k=c,this.l=o,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=i}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class g{constructor(u,i){this.raw=i,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,M.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function E(r){return new g({uri:r,index:0,name:(0,M.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=E,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function L(r,u){return M.extUriBiasedIgnorePathCase.isEqualOrParent(r,u.untitledWorkspacesHome)}e.isUntitledWorkspace=L;function v(r){let u;return S.URI.isUri(r)?u=r:u=r.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v;function t(r,u){return!L(r,u)&&!v(r)}e.isSavedWorkspace=t;function d(r){return(typeof r=="string"?(0,C.extname)(r):(0,M.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=d}),define(Ce[54],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(D){this.d=D,this.b=new Map,this.c=1}add(D){const M=this.c++;return this.b.set(M,D),this.e(),M}get(D,M){return this.b.has(D)?this.b.get(D)[M]:void 0}delete(D){this.b.delete(D),this.e()}e(){!n.a||console.log(`${this.d} cache size - ${this.b.size}`)}}n.a=!1,e.Cache=n}),define(Ce[36],ke([1,0,15,24,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new C.ExtUri(R=>{const y=this.b.get(R.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(R,y){y===null?this.b.delete(R.scheme):this.b.set(R.scheme,y)}isFreeScheme(R){return!this.b.has(R)&&!this.a.has(R)}getCapabilities(R){return this.b.get(R)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Ce[176],ke([1,0,11,162,26]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends C.LogService{constructor(R,y){super(R.createLogger(y.logFile,{name:y.logName}))}};M=qe([je(0,n.ILoggerService),je(1,D.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(Ce[177],ke([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class C{constructor(S,R,y){this.h=new Map,this.a=S,this.b=R,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(T=>(this.f=T,this)),this.g=this.c.onDidChangeStorage(T=>{T.shared===this.b&&T.key===this.a&&(this.f=T.value)}),this.i=new n.RunOnceScheduler(()=>{const T=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of T.values())N.complete()}catch(N){for(const w of T.values())w.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,R){let y=this.f[S];return typeof y>"u"&&(y=R),y}update(S,R){this.f[S]=R;const y=this.h.get(S);if(y!==void 0)return y.p;const T=new n.DeferredPromise;return this.h.set(S,T),this.i.isScheduled()||this.i.schedule(),T.p}dispose(){this.g.dispose()}}e.ExtensionMemento=C;class D extends C{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,R){super(S.identifier.value,!0,R),this.j=S}}e.ExtensionGlobalMemento=D}),define(Ce[178],ke([1,0,4,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class D{constructor(S){this.c=S,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,R,y,T){const w=this.c.getNotebookDocument(C.URI.revive(S)).acceptModelChanged(R.value,y,T);this.b.fire(w)}$acceptDirtyStateChanged(S,R){this.c.getNotebookDocument(C.URI.revive(S)).acceptDirty(R)}$acceptModelSaved(S){const R=this.c.getNotebookDocument(C.URI.revive(S));this.a.fire(R.apiNotebook)}}e.ExtHostNotebookDocuments=D}),define(Ce[18],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class C{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[179],ke([1,0,25,4]),function(te,e,n,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(R,y){D.set(this,void 0),this.b=new C.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(R.identifier),Je(this,D,y,"f"),Le(this,D,"f").onDidChangePassword(T=>{T.extensionId===this.a&&this.b.fire({key:T.key})})}get(R){return Le(this,D,"f").get(this.a,R)}store(R,y){return Le(this,D,"f").store(this.a,R,y)}delete(R){return Le(this,D,"f").delete(this.a,R)}}e.ExtensionSecrets=M,D=new WeakMap}),define(Ce[69],ke([1,0,3,173,4,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function T(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?C.TunnelPrivacyId.Public:C.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=T;function N(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==C.TunnelPrivacyId.ConstantPrivate&&w.privacy!==C.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=N})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let R=class{constructor(T){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,N){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,N){return{dispose:()=>{}}}async $providePortAttributes(T,N,w,h,b){return[]}async $forwardPort(T,N){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=qe([je(0,M.IExtHostRpcService)],R),e.ExtHostTunnelService=R}),define(Ce[55],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class C{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=C}),define(Ce[180],ke([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class C{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function D(R,y){if(y.serializeBuffersForPostMessage){const T=new C,N=(b,m)=>{if(m instanceof ArrayBuffer){const a=T.add(m);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(m)){const a=M(m);if(a){const s=T.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:s,view:{type:a,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},w=JSON.stringify(R,N),h=T.buffers.map(b=>{const m=new Uint8Array(b);return n.VSBuffer.wrap(m)});return{message:w,buffers:h}}else return{message:JSON.stringify(R),buffers:[]}}e.serializeWebviewMessage=D;function M(R){switch(R.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(R,y){const T=y.map(h=>{const b=new ArrayBuffer(h.byteLength);return new Uint8Array(b).set(h.buffer),b}),N=y.length?(h,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const m=b,{index:a}=m,s=T[a];if(m.view)switch(m.view.type){case 1:return new Int8Array(s,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return b}:void 0;return{message:JSON.parse(R,N),arrayBuffers:T}}e.deserializeWebviewMessage=S}),define(Ce[95],ke([1,0,147,9,2,6,3,30,43,15,39,124,29]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function a(Y){const G=Y;return!!G&&typeof G.getSelection=="function"&&!!G.onDidChangeSelection}e.isEditorPaneWithSelection=a;function s(Y,G,Z){for(const he of Z.visibleEditorPanes)if(he.group.id===G&&Y.matches(he.input))return he.getViewState()}e.findViewStateForEditor=s;function l(Y){if(o(Y))return!1;const G=Y;return D.URI.isUri(G?.resource)}e.isResourceEditorInput=l;function g(Y){if(o(Y))return!1;const G=Y;return G?.original!==void 0&&G.modified!==void 0}e.isResourceDiffEditorInput=g;function E(Y){if(o(Y)||g(Y))return!1;const G=Y;return G?.primary!==void 0&&G.secondary!==void 0}e.isResourceSideBySideEditorInput=E;function L(Y){if(o(Y))return!1;const G=Y;return G?G.resource===void 0||G.resource.scheme===T.Schemas.untitled||G.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=L;const v=/Untitled-\d+/;function t(Y){return Y.scheme===T.Schemas.untitled&&Y.path.length>1&&!v.test(Y.path)}e.isUntitledWithAssociatedResource=t;function d(Y){if(o(Y))return!1;const G=Y;return D.URI.isUri(G?.base?.resource)&&D.URI.isUri(G?.input1?.resource)&&D.URI.isUri(G?.input2?.resource)&&D.URI.isUri(G?.result?.resource)}e.isResourceMergeEditorInput=d;var r;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var u;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.a=new Map}registerSource(G,Z){let he=this.a.get(G);return he||(he={source:G,label:Z},this.a.set(G,he)),he.source}getSourceLabel(G){return this.a.get(G)?.label??G}}e.SaveSourceRegistry=new i;var p;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors"})(p=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class c extends M.Disposable{}e.AbstractEditorInput=c;function o(Y){return Y instanceof c}e.isEditorInput=o;function f(Y){const G=Y;return D.URI.isUri(G?.preferredResource)}function k(Y){const G=Y;return o(G?.primary)&&o(G?.secondary)}e.isSideBySideEditorInput=k;function A(Y){const G=Y;return o(G?.modified)&&o(G?.original)}e.isDiffEditorInput=A;function V(Y,G,Z,he,Te){return se(he,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const Ne={...Z,limits:{size:Number.MAX_VALUE}};Y.openEditor(G,Ne)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.createTooLargeFileError=V;function _(Y){return o(Y?.editor)}e.isEditorInputWithOptions=_;function K(Y){const G=Y;return _(Y)&&G?.group!==void 0}e.isEditorInputWithOptionsAndGroup=K;function O(Y){const G=Y;return typeof G?.groupId=="number"&&o(G.editor)}e.isEditorIdentifier=O;var B;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(B=e.EditorCloseContext||(e.EditorCloseContext={}));var P;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LOCKED=2]="GROUP_LOCKED",Y[Y.EDITOR_OPEN=3]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=4]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=5]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=7]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=9]="EDITOR_PIN",Y[Y.EDITOR_STICKY=10]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=11]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(P=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var F;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(F=e.SideBySideEditor||(e.SideBySideEditor={}));class H{getOriginalUri(G,Z){if(!G)return;if(d(G))return e.EditorResourceAccessor.getOriginalUri(G.result,Z);if(Z?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(G);if(Te&&Ne){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(Te,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(Ne,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getOriginalUri(Te,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(Ne,{filterByScheme:Z.filterByScheme});G=Z.supportSideBySide===F.PRIMARY?Te:Ne}}if(g(G)||E(G)||d(G))return;const he=f(G)?G.preferredResource:G.resource;return!he||!Z||!Z.filterByScheme?he:this.b(he,Z.filterByScheme)}a(G){return k(G)||E(G)?{primary:G.primary,secondary:G.secondary}:A(G)||g(G)?{primary:G.modified,secondary:G.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(G,Z){if(!G)return;if(d(G))return e.EditorResourceAccessor.getCanonicalUri(G.result,Z);if(Z?.supportSideBySide){const{primary:Te,secondary:Ne}=this.a(G);if(Te&&Ne){if(Z?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(Te,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(Ne,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===F.ANY)return this.getCanonicalUri(Te,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(Ne,{filterByScheme:Z.filterByScheme});G=Z.supportSideBySide===F.PRIMARY?Te:Ne}}if(g(G)||E(G)||d(G))return;const he=G.resource;return!he||!Z||!Z.filterByScheme?he:this.b(he,Z.filterByScheme)}b(G,Z){if(Array.isArray(Z)){if(Z.some(he=>G.scheme===he))return G}else if(Z===G.scheme)return G}}e.EditorResourceAccessor=new H;var j;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(j=e.CloseDirection||(e.CloseDirection={}));class de{constructor(){this.c=new Map,this.d=new Map}start(G){const Z=this.a=G.get(S.IInstantiationService);for(const[he,Te]of this.c)this.e(he,Te,Z);this.c.clear()}e(G,Z,he){const Te=he.createInstance(Z);this.d.set(G,Te)}registerFileEditorFactory(G){if(this.b)throw new Error("Can only register one file editor factory.");this.b=G}getFileEditorFactory(){return(0,C.assertIsDefined)(this.b)}registerEditorSerializer(G,Z){if(this.c.has(G)||this.d.has(G))throw new Error(`A editor serializer with type ID '${G}' was already registered.`);return this.a?this.e(G,Z,this.a):this.c.set(G,Z),(0,M.toDisposable)(()=>{this.c.delete(G),this.d.delete(G)})}getEditorSerializer(G){return this.d.get(typeof G=="string"?G:G.typeId)}}R.Registry.add(e.EditorExtensions.EditorFactory,new de);async function pe(Y,G,Z){return!Y||!Y.length?[]:await Promise.all(Y.map(async he=>{const Te=D.URI.revive(he.fileUri);if(!Te){Z.info("Cannot resolve the path because it is not valid.",he);return}if(!await G.canHandleResource(Te)){Z.info("Cannot resolve the path because it cannot be handled",he);return}let Ke=he.exists,Pe=he.type;if(typeof Ke!="boolean"||typeof Pe!="number")try{Pe=(await G.stat(Te)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ke=!0}catch(Ie){Z.error(Ie),Ke=!1}if(!Ke&&he.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",he);return}if(Pe===y.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",he);return}const Se={...he.options,pinned:!0};return Ke?{resource:Te,options:Se}:{resource:Te,options:Se,forceUntitled:!0}}))}e.pathsToEditors=pe;var re;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(re=e.EditorsOrder||(e.EditorsOrder={}));function ue(Y){const G=Y;if(!G)return!1;const Z=G;if(Z.modified)return ue(Z.modified);const he=G;return!!(he.contributionsState&&he.viewState&&Array.isArray(he.cursorState))}e.isTextEditorViewState=ue;function ae(Y){return(0,N.isErrorWithActions)(Y)}e.isEditorOpenError=ae;function se(Y,G,Z){const he=(0,N.createErrorWithActions)(Y,G);return he.forceMessage=Z?.forceMessage,he.forceSeverity=Z?.forceSeverity,he.allowDialog=Z?.allowDialog,he}e.createEditorOpenError=se}),define(Ce[181],ke([1,0,4,148,3,6,28,30,16,62,22,84,172]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",w.Codicon.window,(0,C.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b=e.Extensions||(e.Extensions={}));var m;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(m=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function a(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=a;class s extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(u,i,p){const c=this.get(u.id);if(c)return c;const o=u;return o.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:o.openCommandActionDescriptor??{id:o.id},(0,S.getOrSet)(this.g,i,[]).push(o),p?.isDefault&&this.h.push(o),this.c.fire({viewContainer:o,viewContainerLocation:i}),o}deregisterViewContainer(u){for(const i of this.g.keys()){const p=this.g.get(i),c=p?.indexOf(u);if(c!==-1){p?.splice(c,1),p.length===0&&this.g.delete(i),this.f.fire({viewContainer:u,viewContainerLocation:i});return}}}get(u){return this.all.filter(i=>i.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(i=>this.getViewContainers(i).filter(p=>p?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(i=>this.getViewContainerLocation(i)===u)}}R.Registry.add(b.ViewContainersRegistry,new s);var l;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function g(r,u){const i=r.group??l.More,p=u.group??l.More;return i!==p?i.localeCompare(p):(r.order??5)-(u.order??5)}class E extends M.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new T.SetMap}registerViews(u,i){this.registerViews2([{views:u,viewContainer:i}])}registerViews2(u){u.forEach(({views:i,viewContainer:p})=>this.l(i,p)),this.c.fire(u)}deregisterViews(u,i){const p=this.m(u,i);p.length&&this.f.fire({views:p,viewContainer:i})}moveViews(u,i){for(const p of this.j.keys())if(p!==i){const c=this.m(u,p);c.length&&(this.l(c,i),this.g.fire({views:c,from:p,to:i}))}}getViews(u){return this.j.get(u)||[]}getView(u){for(const i of this.i){const p=(this.j.get(i)||[]).filter(c=>c.id===u)[0];if(p)return p}return null}getViewContainer(u){for(const i of this.i)if((this.j.get(i)||[]).filter(c=>c.id===u)[0])return i;return null}registerViewWelcomeContent(u,i){return this.k.add(u,i),this.h.fire(u),(0,M.toDisposable)(()=>{this.k.delete(u,i),this.h.fire(u)})}registerViewWelcomeContent2(u,i){const p=new Map;for(const[c,o]of i)this.k.add(u,o),p.set(c,(0,M.toDisposable)(()=>{this.k.delete(u,o),this.h.fire(u)}));return this.h.fire(u),p}getViewWelcomeContent(u){const i=[];return this.k.forEach(u,p=>i.push(p)),i.sort(g)}l(u,i){let p=this.j.get(i);p||(p=[],this.j.set(i,p),this.i.push(i));for(const c of u){if(this.getView(c.id)!==null)throw new Error((0,C.localize)(1,null,c.id));p.push(c)}}m(u,i){const p=this.j.get(i);if(!p)return[];const c=[],o=[];for(const f of p)u.includes(f)?c.push(f):o.push(f);return c.length&&(o.length?this.j.set(i,o):(this.j.delete(i),this.i.splice(this.i.indexOf(i),1))),c}}R.Registry.add(b.ViewsRegistry,new E),e.IViewsService=(0,D.createDecorator)("viewsService"),e.IViewDescriptorService=(0,D.createDecorator)("viewDescriptorService");var L;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(L=e.ViewVisibilityState||(e.ViewVisibilityState={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(u,i){this.c=!1,this.d=!1,(0,N.mixin)(this,u),this.d=!!i,this.resolve=async p=>{if(i&&!this.c){const c=await i(p);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class d extends Error{constructor(u){super((0,C.localize)(2,null,u))}}e.NoTreeViewError=d}),define(Ce[182],ke([1,0,4,17,149]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(R){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=R}onEvent(R){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=R}onRequest(R){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.s("response",R)}sendRequest(R,y,T,N){const w={command:R};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof N=="number"){const h=setTimeout(()=>{clearTimeout(h);const b=this.f.get(w.seq);if(b){this.f.delete(w.seq);const m={type:"response",seq:0,request_seq:w.seq,success:!1,command:R,message:(0,D.localize)(0,null,N,R)};b(m)}},N)}return T&&this.f.set(w.seq,T),w.seq}acceptMessage(R){this.j?this.j(R):(this.k.push(R),this.k.length===1&&this.q())}o(R,y){return R.type!=="event"||y.type!=="event"}async q(){let R;for(;this.k.length;){if((!R||this.o(this.k[0],R))&&await(0,C.timeout)(0),R=this.k.shift(),!R)return;switch(R.type){case"event":this.i?.(R);break;case"request":this.g?.(R);break;case"response":{const y=R,T=this.f.get(y.request_seq);T&&(this.f.delete(y.request_seq),T(y));break}}}}s(R,y){y.type=R,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((y,T)=>R.set(T,y)),await(0,C.timeout)(500),R.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.f.delete(T)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=M}),define(Ce[183],ke([1,0,150,42,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new C.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new C.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new C.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new C.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new C.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new C.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new C.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new C.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new C.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new C.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new C.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new C.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new C.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new C.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new C.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new C.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new C.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new C.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new C.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new C.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new C.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new C.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new C.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new C.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new C.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new C.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new C.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new C.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new C.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new C.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new C.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new C.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new C.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new C.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new C.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new C.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new C.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new C.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new C.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new C.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new C.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new C.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new C.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new C.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new C.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new C.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new C.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new C.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new C.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new C.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new C.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const M=h=>n.localize(51,null,h);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var S;(function(h){h[h.Inactive=0]="Inactive",h[h.Initializing=1]="Initializing",h[h.Stopped=2]="Stopped",h[h.Running=3]="Running"})(S=e.State||(e.State={}));function R(h){switch(h){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=R;var y;(function(h){h[h.Valid=0]="Valid",h[h.Unreadable=1]="Unreadable",h[h.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(h){h[h.Initial=1]="Initial",h[h.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var N;(function(h){h.UnverifiedBreakpoints="unverifiedBreakpoints"})(N=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,D.createDecorator)("debugService");var w;(function(h){h[h.CONDITION=0]="CONDITION",h[h.HIT_COUNT=1]="HIT_COUNT",h[h.LOG_MESSAGE=2]="LOG_MESSAGE"})(w=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[184],ke([1,0,10,2,19,22,15,44,20,16]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const N=/{([^}]+)}/g;function w(c,o,f){return c.replace(N,function(k,A){return o&&A.length>0&&A[0]!=="_"?k:f&&f.hasOwnProperty(A)?f[A]:k})}e.formatPII=w;function h(c){const o={};for(const f of Object.keys(c))f.startsWith("!")||(o[f]=c[f]);return o}e.filterExceptionsFromTelemetry=h;function b(c){return c.configuration.request==="attach"&&!m(c)&&(!c.parentSession||b(c.parentSession))}e.isSessionAttach=b;function m(c){let o=c.configuration.type;if(!!o)return o==="vslsShare"&&(o=c.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(o,"extensionhost")||(0,n.equalsIgnoreCase)(o,"pwa-extensionhost")?c:c.parentSession?m(c.parentSession):void 0}e.getExtensionHostDebugSession=m;function a(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=a;function s(c,o,f){let k,A=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let _=null;for(;_=V.exec(c);){const K=_.index+1,O=K+_[0].length;if(K<=o&&O>=f){k=_[0],A=K;break}}if(k){const K=/\w+/g;let O=null;for(;(O=K.exec(k))&&!(O.index+1+A+O[0].length>=f););O&&(k=k.substring(0,K.lastIndex))}return k?{start:A,end:A+k.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=s;async function l(c,o,f,k){if(c.evaluatableExpressionProvider.has(o)){const A=c.evaluatableExpressionProvider.ordered(o),V=(0,T.coalesce)(await Promise.all(A.map(async _=>{try{return await _.provideEvaluatableExpression(o,f,k??y.CancellationToken.None)}catch{return}})));if(V.length>0){let _=V[0].expression;const K=V[0].range;return _||(_=o.getLineContent(f.lineNumber).substring(K.startColumn-1,K.endColumn-1)),{range:K,matchingExpression:_}}}else{const A=o.getLineContent(f.lineNumber),{start:V,end:_}=s(A,f.column,f.column),K=A.substring(V-1,_);return{matchingExpression:K,range:new R.Range(f.lineNumber,V,f.lineNumber,V+K.length)}}return null}e.getEvaluatableExpressionAtPosition=l;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function E(c){return!!(c&&c.match(g))}e.isUri=E;function L(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(E(c.path))return C.URI.parse(c.path);if((0,D.isAbsolute)(c.path))return C.URI.file(c.path)}return c.path}function v(c){if(typeof c.path=="object"){const o=C.URI.revive(c.path);if(o)return o.scheme===S.Schemas.file?o.fsPath:o.toString()}return c.path}function t(c,o){const f=o?L:v,k=(0,M.deepClone)(c);return r(k,(A,V)=>{A&&V&&(V.path=f(V))}),k}e.convertToDAPaths=t;function d(c,o){const f=o?L:v,k=(0,M.deepClone)(c);return r(k,(A,V)=>{!A&&V&&(V.path=f(V))}),k}e.convertToVSCPaths=d;function r(c,o){switch(c.type){case"event":{const f=c;switch(f.event){case"output":o(!1,f.body.source);break;case"loadedSource":o(!1,f.body.source);break;case"breakpoint":o(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=c;switch(f.command){case"setBreakpoints":o(!0,f.arguments.source);break;case"breakpointLocations":o(!0,f.arguments.source);break;case"source":o(!0,f.arguments.source);break;case"gotoTargets":o(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(k=>o(!1,k));break;default:break}break}case"response":{const f=c;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(k=>o(!1,k.source));break;case"loadedSources":f.body.sources.forEach(k=>o(!1,k));break;case"scopes":f.body.scopes.forEach(k=>o(!1,k.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(k=>o(!1,k.source));break;case"setBreakpoints":f.body.breakpoints.forEach(k=>o(!1,k.source));break;case"disassemble":f.body?.instructions.forEach(A=>o(!1,A.location));break;default:break}break}}}function u(c){return c.filter(o=>!o.presentation?.hidden).sort((o,f)=>o.presentation?f.presentation?o.presentation.group?f.presentation.group?o.presentation.group!==f.presentation.group?o.presentation.group.localeCompare(f.presentation.group):i(o.presentation.order,f.presentation.order):-1:f.presentation.group?1:i(o.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=u;function i(c,o){return typeof c!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:c-o}async function p(c,o){const f=c.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorLanguageId});if(f!=="none"&&(await o.saveAll(),f==="allEditorsInActiveGroup")){const k=o.activeEditorPane;k&&k.input.resource?.scheme===S.Schemas.untitled&&await o.save({editor:k.input,groupId:k.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=p}),define(Ce[70],ke([1,0,23,35,185,64,15,19,21,42]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var N;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(N=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(w=e.NotebookRunState||(e.NotebookRunState={}));var h;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(h=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var b;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(b=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var g;(function(F){F.scheme=S.Schemas.vscodeNotebookCell;const H=["W","X","Y","Z","a","b","c","d","e","f"],j=new RegExp(`^[${H.join("")}]+`),de=7;function pe(G,Z){const he=Z.toString(de),Ne=`${he.length<H.length?H[he.length-1]:"z"}${he}s${(0,n.encodeBase64)(n.VSBuffer.fromString(G.scheme),!0,!0)}`;return G.with({scheme:F.scheme,fragment:Ne})}F.generate=pe;function re(G){if(G.scheme!==F.scheme)return;const Z=G.fragment.indexOf("s");if(Z<0)return;const he=parseInt(G.fragment.substring(0,Z).replace(j,""),de),Te=(0,n.decodeBase64)(G.fragment.substring(Z+1)).toString();if(!isNaN(he))return{handle:he,notebook:G.with({scheme:Te,fragment:null})}}F.parse=re;function ue(G,Z){return G.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${G.scheme!==S.Schemas.file?G.scheme:""}`})}F.generateCellOutputUri=ue;function ae(G){if(G.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(G.fragment);if(!Z)return;const he=Z[1]&&Z[1]!==""?Z[1]:void 0,Te=Z[2];return{outputId:he,notebook:G.with({scheme:Te||S.Schemas.file,fragment:null})}}F.parseCellOutputUri=ae;function se(G,Z,he){return F.generate(G,Z).with({scheme:he})}F.generateCellPropertyUri=se;function Y(G,Z){if(G.scheme===Z)return F.parse(G.with({scheme:F.scheme}))}F.parseCellPropertyUri=Y})(g=e.CellUri||(e.CellUri={}));const E=F=>y.isWindows?F.replace(/\//g,"\\"):F;class L{constructor(H=[],j=e.NOTEBOOK_DISPLAY_ORDER){this.e=j,this.d=[...new Set(H)].map(de=>({pattern:de,matches:C.parse(E(de))}))}sort(H){const j=new Map(D.Iterable.map(H,pe=>[pe,E(pe)]));let de=[];for(const{matches:pe}of this.d)for(const[re,ue]of j)if(pe(ue)){de.push(re),j.delete(re);break}return j.size&&(de=de.concat([...j.keys()].sort((pe,re)=>this.e.indexOf(pe)-this.e.indexOf(re)))),de}prioritize(H,j){const de=this.f(H);if(de===-1){this.d.unshift({pattern:H,matches:C.parse(E(H))});return}const pe=new Set(j.map(ue=>this.f(ue,de)));pe.delete(-1);const re=Array.from(pe).sort();this.d.splice(de+1,0,...re.map(ue=>this.d[ue]));for(let ue=re.length-1;ue>=0;ue--)this.d.splice(re[ue],1)}toArray(){return this.d.map(H=>H.pattern)}f(H,j=this.d.length){const de=E(H);for(let pe=0;pe<j;pe++)if(this.d[pe].matches(de))return pe;return-1}}e.MimeTypeDisplayOrder=L;function v(F,H,j,de=(pe,re)=>pe===re){const pe=[];function re(se,Y,G){if(Y===0&&G.length===0)return;const Z=pe[pe.length-1];Z&&Z.start+Z.deleteCount===se?(Z.deleteCount+=Y,Z.toInsert.push(...G)):pe.push({start:se,deleteCount:Y,toInsert:G})}let ue=0,ae=0;for(;;){if(ue===F.length){re(ue,0,H.slice(ae));break}if(ae===H.length){re(ue,F.length-ue,[]);break}const se=F[ue],Y=H[ae];if(de(se,Y)){ue+=1,ae+=1;continue}j(Y)?(re(ue,1,[]),ue+=1):(re(ue,0,[Y]),ae+=1)}return pe}e.diff=v,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(F){F.default="default",F.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function d(F){const H=F;return!!((typeof H.include=="string"||C.isRelativePattern(H.include))&&(typeof H.exclude=="string"||C.isRelativePattern(H.exclude)))}e.isDocumentExcludePattern=d;function r(F,H,j){if(Array.isArray(F.viewType)&&F.viewType.indexOf(H)>=0||F.viewType===H)return!0;if(F.filenamePattern){const de=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,pe=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(C.match(de,(0,R.basename)(j.fsPath).toLowerCase()))return!(pe&&C.match(pe,(0,R.basename)(j.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var u;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class i{static create(H){return`${i.d}${H}`}static parse(H){if(H.startsWith(i.d))return H.substring(i.d.length)}}i.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=i;function p(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=p;const c=new TextDecoder;function o(F){const H=[];let j=!1;for(const de of F)(H.length===0||j)&&(H.push(de),j=!0);return V(H),P(n.VSBuffer.concat(H.map(de=>n.VSBuffer.wrap(de))))}e.compressOutputItemStreams=o;const f=`${String.fromCharCode(27)}[A`,k=f.split("").map(F=>F.charCodeAt(0)),A=10;function V(F){F.forEach((H,j)=>{if(j===0||H.length<f.length)return;const de=F[j-1],pe=H.subarray(0,f.length);if(pe[0]===k[0]&&pe[1]===k[1]&&pe[2]===k[2]){const re=de.lastIndexOf(A);if(re===-1)return;F[j-1]=de.subarray(0,re),F[j]=H.subarray(f.length)}})}function _(F){let H=F;do F=H,H=F.replace(/[^\n]\x08/gm,"");while(H.length<F.length);return F}function K(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const H=F.match(/^(.*)\r+/m)[1];let j=F.match(/\r+(.*)$/m)[1];j=j+H.slice(j.length,H.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,j)}return F}const O="\b".charCodeAt(0),B="\r".charCodeAt(0);function P(F){return!F.buffer.includes(O)&&!F.buffer.includes(B)?F:n.VSBuffer.fromString(K(_(c.decode(F.buffer))))}}),define(Ce[186],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var C;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState"})(C=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Ce[45],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(M){M.Delimiter="\0"})(n=e.TestIdPathParts||(e.TestIdPathParts={}));var C;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(C=e.TestPosition||(e.TestPosition={}));class D{static fromExtHostTestItem(S,R,y=S.parent){if(S._isRoot)return new D([R]);const T=[S.id];for(let N=y;N&&N.id!==R;N=N.parent)T.push(N.id);return T.push(R),new D(T.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const R=S.indexOf("\0");return R===-1?S:S.slice(0,R)}static fromString(S){return new D(S.split("\0"))}static join(S,R){return new D([...S.path,R])}static joinToString(S,R){return S.toString()+"\0"+R}static parentId(S){const R=S.lastIndexOf("\0");return R===-1?void 0:S.slice(0,R)}static localId(S){const R=S.lastIndexOf("\0");return R===-1?S:S.slice(R+1)}static compare(S,R){return S===R?0:R.startsWith(S+"\0")?2:S.startsWith(R+"\0")?3:1}constructor(S,R=S.length){if(this.path=S,this.d=R,S.length===0||R<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new D(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new D(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new D(this.path,S)}compare(S){if(typeof S=="string")return D.compare(this.toString(),S);for(let R=0;R<S.d&&R<this.d;R++)if(S.path[R]!==this.path[R])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=D}),define(Ce[56],ke([1,0,2,44,45]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var S;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable",c[c.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const R=c=>"runId"in c;e.isStartControllerTests=R;var y;(function(c){c.serialize=o=>({range:o.range.toJSON(),uri:o.uri.toJSON()}),c.deserialize=o=>({range:C.Range.lift(o.range),uri:n.URI.revive(o.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var T;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(T=e.TestMessageType||(e.TestMessageType={}));var N;(function(c){c.serialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,location:o.location&&y.serialize(o.location)}),c.deserialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,location:o.location&&y.deserialize(o.location)})})(N=e.ITestErrorMessage||(e.ITestErrorMessage={}));const w=(c,o)=>`${o?"s":"e"}${c}`;e.getMarkId=w;var h;(function(c){c.serialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&y.serialize(o.location)}),c.deserialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&y.deserialize(o.location)})})(h=e.ITestOutputMessage||(e.ITestOutputMessage={}));var b;(function(c){c.serialize=o=>o.type===0?N.serialize(o):h.serialize(o),c.deserialize=o=>o.type===0?N.deserialize(o):h.deserialize(o)})(b=e.ITestMessage||(e.ITestMessage={}));var m;(function(c){c.serializeWithoutMessages=o=>({state:o.state,duration:o.duration,messages:[]}),c.serialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(b.serialize)}),c.deserialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(b.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const a="\0",s=(c,o)=>c+a+o;e.namespaceTestTag=s;const l=c=>{const o=c.indexOf(a);return{ctrlId:c.slice(0,o),tagId:c.slice(o+1)}};e.denamespaceTestTag=l;var g;(function(c){c.serialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?.toJSON(),range:o.range?.toJSON()||null,description:o.description,error:o.error,sortText:o.sortText}),c.deserialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?n.URI.revive(o.uri):void 0,range:o.range?C.Range.lift(o.range):null,description:o.description,error:o.error,sortText:o.sortText})})(g=e.ITestItem||(e.ITestItem={}));var E;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(E=e.TestItemExpandState||(e.TestItemExpandState={}));var L;(function(c){c.serialize=o=>({expand:o.expand,item:g.serialize(o.item)}),c.deserialize=o=>({controllerId:D.TestId.root(o.item.extId),expand:o.expand,item:g.deserialize(o.item)})})(L=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(c){c.serialize=o=>{let f;return o.item&&(f={},o.item.label!==void 0&&(f.label=o.item.label),o.item.tags!==void 0&&(f.tags=o.item.tags),o.item.busy!==void 0&&(f.busy=o.item.busy),o.item.uri!==void 0&&(f.uri=o.item.uri?.toJSON()),o.item.range!==void 0&&(f.range=o.item.range?.toJSON()),o.item.description!==void 0&&(f.description=o.item.description),o.item.error!==void 0&&(f.error=o.item.error),o.item.sortText!==void 0&&(f.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:f}},c.deserialize=o=>{let f;return o.item&&(f={},o.item.label!==void 0&&(f.label=o.item.label),o.item.tags!==void 0&&(f.tags=o.item.tags),o.item.busy!==void 0&&(f.busy=o.item.busy),o.item.range!==void 0&&(f.range=o.item.range?C.Range.lift(o.item.range):null),o.item.description!==void 0&&(f.description=o.item.description),o.item.error!==void 0&&(f.error=o.item.error),o.item.sortText!==void 0&&(f.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:f}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(c,o)=>{o.expand!==void 0&&(c.expand=o.expand),o.item!==void 0&&(c.item=c.item?Object.assign(c.item,o.item):o.item)};e.applyTestItemUpdate=t;var d;(function(c){c.serializeWithoutMessages=o=>({...L.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(m.serializeWithoutMessages),retired:o.retired}),c.serialize=o=>({...L.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(m.serialize),retired:o.retired}),c.deserialize=o=>({...L.deserialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(m.deserialize),retired:!0})})(d=e.TestResultItem||(e.TestResultItem={}));var r;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var u;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(u=e.TestDiffOpType||(e.TestDiffOpType={}));var i;(function(c){c.deserialize=o=>o.op===0?{op:o.op,item:L.deserialize(o.item)}:o.op===1?{op:o.op,item:v.deserialize(o.item)}:o.op===2?{op:o.op,uri:n.URI.revive(o.uri),docv:o.docv}:o,c.serialize=o=>o.op===0?{op:o.op,item:L.serialize(o.item)}:o.op===1?{op:o.op,item:v.serialize(o.item)}:o})(i=e.TestsDiffOp||(e.TestsDiffOp={}));class p{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(o){const f=this.o();for(const k of o)switch(k.op){case 0:this.j(L.deserialize(k.item),f);break;case 1:this.k(v.deserialize(k.item),f);break;case 3:this.l(k.itemId,f);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}f.complete?.()}j(o,f){const k=D.TestId.parentId(o.item.extId)?.toString();let A;if(!k)A=this.p(o),this.f.add(A),this.d.set(o.item.extId,A);else if(this.d.has(k)){const V=this.d.get(k);V.children.add(o.item.extId),A=this.p(o,V),this.d.set(o.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(o)}`);return}return f.add?.(A),o.expand===2&&this.g++,A}k(o,f){const k=this.d.get(o.extId);if(!!k)return o.expand!==void 0&&(k.expand===2&&this.g--,o.expand===2&&this.g++),(0,e.applyTestItemUpdate)(k,o),f.update?.(k),k}l(o,f){const k=this.d.get(o);if(!k)return;const A=D.TestId.parentId(k.item.extId)?.toString();A?this.d.get(A).children.delete(k.item.extId):this.f.delete(k);const V=[[o]];for(;V.length;)for(const _ of V.pop()){const K=this.d.get(_);K&&(V.push(K.children),this.d.delete(_),f.remove?.(K,K!==k),K.expand===2&&this.g--)}}m(o){}updatePendingRoots(o){this.h+=o}o(){return{}}}e.AbstractIncrementalTestCollection=p}),define(Ce[71],ke([1,0,17,4,6,49,56,45]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(g,E)=>g===E,w=Object.entries({range:(g,E)=>g===E?!0:!g||!E?!1:g.equalsRange(E),busy:T,label:T,description:T,error:T,sortText:T,tags:(g,E)=>!(g.length!==E.length||g.some(L=>!E.includes(L)))}),h=(g,E)=>{let L;for(const[v,t]of w)t(g[v],E[v])||(L?L[v]=E[v]:L={[v]:E[v]});return L};class b extends D.Disposable{get root(){return this.m.root}constructor(E){super(),this.m=E,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new C.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(E){this.h=E;for(const L of this.tree.values())this.G(L)}get resolveHandler(){return this.h}collectDiff(){const E=this.k;return this.k=[],E}pushDiff(E){switch(E.op){case 2:{for(const L of this.k)if(L.op===2&&L.uri===E.uri){L.docv=E.docv;return}break}case 1:{const L=this.k[this.k.length-1];if(L){if(L.op===1&&L.item.extId===E.item.extId){(0,S.applyTestItemUpdate)(L.item,E.item);return}if(L.op===0&&L.item.item.extId===E.item.extId){(0,S.applyTestItemUpdate)(L.item,E.item);return}}break}}this.k.push(E),this.f.isScheduled()||this.f.schedule()}expand(E,L){const v=this.tree.get(E);if(!!v){if((v.expandLevels===void 0||L>v.expandLevels)&&(v.expandLevels=L),v.expand===1){const t=this.I(v);return t.isOpen()?this.H(v,L-1):t.wait().then(()=>this.H(v,L-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,L-1)):this.H(v,L-1)}}dispose(){for(const E of this.tree.values())this.m.getApiFor(E.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(E,L){switch(L.op){case 3:this.L(R.TestId.joinToString(E.fullId,L.id));break;case 0:this.u(L.item,E);break;case 5:for(const v of L.ops)this.p(E,v);break;case 1:this.w(L.new,L.old,E.fullId.toString());break;case 2:this.G(E);break;case 4:this.pushDiff({op:1,item:{extId:E.fullId.toString(),item:L.update}});break;case 6:this.s(E.actual.uri);break;default:(0,M.assertNever)(L)}}s(E){E&&this.pushDiff({op:2,uri:E,docv:this.m.getDocumentVersion(E)})}u(E,L){const v=R.TestId.fromExtHostTestItem(E,this.root.id,L?.actual),t=this.m.getApiFor(E);t.parent&&t.parent!==L?.actual&&this.m.getChildren(t.parent).delete(E.id);let d=this.tree.get(v.toString());if(!d){d={fullId:v,actual:E,expandLevels:L?.expandLevels?L.expandLevels-1:void 0,expand:0},E.tags.forEach(this.y,this),this.tree.set(d.fullId.toString(),d),this.C(E,L),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:d.expand,item:this.m.toITestItem(E)}}),this.F(E,d,L);return}if(d.actual===E){this.D(E,d,L);return}if(d.actual.uri?.toString()!==E.uri?.toString())return this.L(v.toString()),this.u(E,L);const r=this.m.getChildren(d.actual),u=d.actual,i=h(this.m.toITestItem(u),this.m.toITestItem(E));this.m.getApiFor(u).listener=void 0,d.actual=E,d.expand=0,i&&(i.hasOwnProperty("tags")&&(this.w(E.tags,u.tags,v.toString()),delete i.tags),this.p(d,{op:4,update:i})),this.F(E,d,L);for(const[p,c]of r)this.m.getChildren(E).get(c.id)||this.L(R.TestId.joinToString(v,c.id));this.s(d.actual.uri)}w(E,L,v){const t=new Set(L.map(d=>d.id));for(const d of E)t.delete(d.id)||this.y(d);this.pushDiff({op:1,item:{extId:v,item:{tags:E.map(d=>(0,S.namespaceTestTag)(this.m.controllerId,d.id))}}}),t.forEach(this.z,this)}y(E){const L=this.j.get(E.id);L?L.refCount++:(this.j.set(E.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,E.id)}}))}z(E){const L=this.j.get(E);L&&!--L.refCount&&(this.j.delete(E),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,E)}))}C(E,L){this.m.getApiFor(E).parent=L&&L.actual!==this.root?L.actual:void 0}D(E,L,v){this.C(E,v);const t=this.m.getApiFor(E);t.parent=v?.actual,t.listener=d=>this.p(L,d),this.G(L)}F(E,L,v){this.D(E,L,v);for(const[t,d]of this.m.getChildren(E))this.u(d,L)}G(E){let L;this.h?E.resolveBarrier?L=E.resolveBarrier.isOpen()?3:2:L=E.actual.canResolveChildren?1:0:L=0,L!==E.expand&&(E.expand=L,this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:L}}),L===1&&E.expandLevels!==void 0&&this.I(E))}H(E,L){if(L<0)return;const v=[];for(const[t,d]of this.m.getChildren(E.actual)){const r=this.expand(R.TestId.joinToString(E.fullId,d.id),L);(0,n.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}I(E){if(E.resolveBarrier)return E.resolveBarrier;if(!this.h){const d=new n.Barrier;return d.open(),d}E.expand=2,this.J(E);const L=E.resolveBarrier=new n.Barrier,v=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,d)};let t;try{t=this.h(E.actual===this.root?void 0:E.actual)}catch(d){v(d)}return(0,n.isThenable)(t)?t.catch(v).then(()=>{L.open(),this.G(E)}):(L.open(),this.G(E)),E.resolveBarrier}J(E){this.pushDiff({op:1,item:{extId:E.fullId.toString(),expand:E.expand}})}L(E){const L=this.tree.get(E);if(!L)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:E});const v=[L];for(;v.length;){const t=v.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.z(d.id);this.tree.delete(t.fullId.toString());for(const[d,r]of this.m.getChildren(t.actual))v.push(this.tree.get(R.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const E=this.collectDiff();E.length&&this.g.fire(E)}}e.TestItemCollection=b;class m extends Error{constructor(E){super(`Attempted to insert a duplicate test item ID ${E}`)}}e.DuplicateTestItemError=m;class a extends Error{constructor(E){super(`TestItem with ID "${E}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=a;class s extends Error{constructor(E,L,v){super(`TestItem with ID "${E}" is from controller "${L}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=s;const l=(g,E,L)=>{let v=new Map;return{get size(){return v.size},forEach(t,d){for(const r of v.values())t.call(d,r,this)},[Symbol.iterator](){return v.entries()},replace(t){const d=new Map,r=new Set(v.keys()),u={op:5,ops:[]};for(const i of t){if(!(i instanceof L))throw new a(i.id);const p=E(i).controllerId;if(p!==g.controllerId)throw new s(i.id,p,g.controllerId);if(d.has(i.id))throw new m(i.id);d.set(i.id,i),r.delete(i.id),u.ops.push({op:0,item:i})}for(const i of r.keys())u.ops.push({op:3,id:i});g.listener?.(u),v=d},add(t){if(!(t instanceof L))throw new a(t.id);v.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){v.delete(t)&&g.listener?.({op:3,id:t})},get(t){return v.get(t)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=l}),define(Ce[96],ke([1,0,71]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const C=new WeakMap,D=(S,R)=>{const y={controllerId:R};return C.set(S,y),y};e.createPrivateApiFor=D;const M=S=>{const R=C.get(S);if(!R)throw new n.InvalidTestItemError(S?.id||"<unknown>");return R};e.getPrivateApiFor=M}),define(Ce[72],ke([1,0,15,2]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function D(R,y){return R.scheme===n.Schemas.http||R.scheme===n.Schemas.https?R:(y&&y.authority&&y.isRemote&&R.scheme===n.Schemas.file&&(R=C.URI.from({scheme:n.Schemas.vscodeRemote,authority:y.authority,path:R.path})),C.URI.from({scheme:n.Schemas.https,authority:`${R.scheme}+${M(R.authority)}.${e.webviewRootResourceAuthority}`,path:R.path,fragment:R.fragment,query:R.query}))}e.asWebviewUri=D;function M(R){return R.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function S(R){return R.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=S}),define(Ce[187],ke([1,0,4,6,72]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(R,y,T){this.d=R,this.e=y,this.f=T,this.a=0,this.b=new C.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const N=y.getVisibleTextEditors();for(const w of this.c.values())N.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,y,T,N,w){let h;for(const E of this.e.getVisibleTextEditors(!0))if(E.value===R){h=E;break}if(!h)throw new Error("not a visible editor");const b=this,m=this.a++,a=new n.Emitter,s=new n.Emitter,l=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(E){return(0,D.asWebviewUri)(E,b.f)}get cspSource(){return D.webviewGenericCspSource}set options(E){this.b=E,b.d.$setOptions(m,E)}get options(){return this.b}set html(E){this.a=E,b.d.$setHtml(m,E)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(E){return b.d.$postMessage(m,E)}},g=new class{constructor(){this.editor=R,this.line=y,this.height=T,this.webview=l,this.onDidDispose=s.event}dispose(){b.c.has(m)&&(b.c.delete(m),b.d.$disposeEditorInset(m),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(m,h.id,h.value.document.uri,y+1,T,N||{},w.identifier,w.extensionLocation),this.c.set(m,{editor:R,inset:g,onDidReceiveMessage:a}),g}$onDidDispose(R){const y=this.c.get(R);y&&y.inset.dispose()}$onDidReceiveMessage(R,y){this.c.get(R)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(Ce[188],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var C;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(C=e.VariableKind||(e.VariableKind={}));class D extends Error{constructor(S,R){super(R),this.variable=S}}e.VariableError=D}),define(Ce[189],ke([1,0,19,51,9,22,21,87,153,188,10]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(b,m,a,s){this.g=new Map,this.a=b,this.b=m,this.d=a,s&&(this.c=s.then(l=>this.h(l)))}h(b){if(S.isWindows){const m=Object.create(null);return Object.keys(b).forEach(a=>{m[a.toLowerCase()]=b[a]}),m}return b}resolveWithEnvironment(b,m,a){return this.j({env:this.h(b),userHome:void 0},m?m.uri:void 0,a)}async resolveAsync(b,m){const a={env:await this.c,userHome:await this.d};return this.j(a,b?b.uri:void 0,m)}async i(b,m,a,s){const l=M.deepClone(m);S.isWindows&&l.windows?Object.keys(l.windows).forEach(E=>l[E]=l.windows[E]):S.isMacintosh&&l.osx?Object.keys(l.osx).forEach(E=>l[E]=l.osx[E]):S.isLinux&&l.linux&&Object.keys(l.linux).forEach(E=>l[E]=l.linux[E]),delete l.windows,delete l.osx,delete l.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,b?b.uri:void 0,l,a,s)}async resolveAnyAsync(b,m,a){return this.i(b,m,a)}async resolveAnyMap(b,m,a){const s=new Map;return{newConfig:await this.i(b,m,a,s),resolvedVariables:s}}resolveWithInteractionReplace(b,m,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,m,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,m){if(this.g.has(b))throw new Error("Variable "+b+" is contributed twice.");this.g.set(b,m)}async j(b,m,a,s,l){if(D.isString(a))return this.l(b,m,a,s,l);if(Array.isArray(a))return Promise.all(a.map(g=>this.j(b,m,g,s,l)));if(D.isObject(a)){const g=Object.create(null),E=await Promise.all(Object.keys(a).map(async L=>[await this.l(b,m,L,s,l),await this.j(b,m,a[L],s,l)]));for(const[L,v]of E)g[L]=v;return g}return a}l(b,m,a,s,l){return(0,N.replaceAsync)(a,w.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(w.VARIABLE_LHS))return g;let L=await this.n(b,g,E,m,s);return l?.set(E,L),L!==g&&D.isString(L)&&L.match(w.VARIABLE_REGEXP)&&(L=await this.l(b,m,L,s,l)),L})}m(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async n(b,m,a,s,l){let g;const E=a.split(":");E.length>1&&(a=E[0],g=E[1]);const L=d=>{const r=this.a.getFilePath();if(r)return(0,R.normalizeDriveLetter)(r);throw new T.VariableError(d,(0,y.localize)(0,null,m))},v=d=>{const r=L(d);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,R.normalizeDriveLetter)(u)}throw new T.VariableError(d,(0,y.localize)(1,null,m,n.basename(r)))},t=d=>{if(g){const r=this.a.getFolderUri(g);if(r)return r;throw new T.VariableError(d,(0,y.localize)(2,null,m,g))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new T.VariableError(d,(0,y.localize)(3,null,m)):new T.VariableError(d,(0,y.localize)(4,null,m))};switch(a){case"env":if(g){if(b.env){const d=b.env[S.isWindows?g.toLowerCase():g];if(D.isString(d))return d}return""}throw new T.VariableError(T.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(g){const d=this.a.getConfigurationValue(s,g);if(D.isUndefinedOrNull(d))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(6,null,m,g));if(D.isObject(d))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(7,null,m,g));return d}throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(T.VariableKind.Command,m,g,l,"command");case"input":return this.o(T.VariableKind.Input,m,g,l,"input");case"extensionInstallFolder":if(g){const d=await this.a.getExtension(g);if(!d)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,g));return this.m(d.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.normalizeDriveLetter)(this.m(t(T.VariableKind.WorkspaceFolder)));case"cwd":return s||g?(0,R.normalizeDriveLetter)(this.m(t(T.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.normalizeDriveLetter)(n.basename(this.m(t(T.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new T.VariableError(T.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new T.VariableError(T.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return L(T.VariableKind.File);case"fileWorkspaceFolder":return v(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||g?n.relative(this.m(t(T.VariableKind.RelativeFile)),L(T.VariableKind.RelativeFile)):L(T.VariableKind.RelativeFile);case"relativeFileDirname":{const d=n.dirname(L(T.VariableKind.RelativeFileDirname));if(s||g){const r=n.relative(this.m(t(T.VariableKind.RelativeFileDirname)),d);return r.length===0?".":r}return d}case"fileDirname":return n.dirname(L(T.VariableKind.FileDirname));case"fileExtname":return n.extname(L(T.VariableKind.FileExtname));case"fileBasename":return n.basename(L(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=n.basename(L(T.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-n.extname(d).length)}case"fileDirnameBasename":return n.basename(n.dirname(L(T.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||m}case"execInstallFolder":{const d=this.a.getAppRoot();return d||m}case"pathSeparator":return n.sep;default:try{const d=g?`${a}:${g}`:a;return this.o(T.VariableKind.Unknown,m,d,l,void 0)}catch{return m}}}}o(b,m,a,s,l){if(a&&s){const g=l===void 0?s[a]:s[l+":"+a];if(typeof g=="string")return g;throw new T.VariableError(b,(0,y.localize)(14,null,m))}return m}}w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=w}),define(Ce[97],ke([1,0,3,95]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var D;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var R;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(R=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(m){const a=m;return(0,C.isEditorInput)(a?.editor)&&(0,C.isEditorInput)(a?.replacement)}e.isEditorReplacement=T;var N;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function h(m){const a=m;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.isEditorGroup=h;function b(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=b}),define(Ce[190],ke([1,0,3,97]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(M){const S=M;return typeof M=="number"||(0,C.isEditorGroup)(S)}e.isPreferredGroup=D}),define(Ce[191],ke([1,0,3,159]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(C.IEnvironmentService)}),define(Ce[98],ke([1,0,25,4,19]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(w){this.removedDueToLooping=w}}e.DeltaExtensionsResult=M;class S{static isHostExtension(w,h,b){if(h.getExtensionDescription(w))return!1;const m=b.getExtensionDescription(w);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(w){this.c=new C.Emitter,this.onDidChange=this.c.event,this.d=w,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const w of this.d){if(this.e.has(n.ExtensionIdentifier.toKey(w.identifier))){console.error("Extension `"+w.identifier.value+"` is already registered");continue}if(this.e.set(n.ExtensionIdentifier.toKey(w.identifier),w),this.f.push(w),Array.isArray(w.activationEvents))for(let h of w.activationEvents)h==="onUri"&&(h=`onUri:${n.ExtensionIdentifier.toKey(w.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(w)}}set(w){this.d=w,this.h(),this.c.fire(void 0)}deltaExtensions(w,h){this.d=T(this.d,h),this.d=this.d.concat(w);const b=S.j(this.d);return this.d=T(this.d,b.map(m=>m.identifier)),this.h(),this.c.fire(void 0),new M(b)}static j(w){const h=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(l){this.d.has(l)||(this.d.add(l),this.e.push(l))}addArc(l,g){this.addNode(l),this.addNode(g),this.c.has(l)?this.c.get(l).push(g):this.c.set(l,[g])}getArcs(l){return this.c.has(l)?this.c.get(l):[]}hasOnlyGoodArcs(l,g){const E=h.getArcs(l);for(let L=0;L<E.length;L++)if(!g.has(E[L]))return!1;return!0}getNodes(){return this.e}},b=new Map;for(const l of w){const g=n.ExtensionIdentifier.toKey(l.identifier);if(b.set(g,l),l.extensionDependencies)for(const E of l.extensionDependencies){const L=n.ExtensionIdentifier.toKey(E);h.addArc(g,L)}}const m=new Set;h.getNodes().filter(l=>h.getArcs(l).length===0).forEach(l=>m.add(l));const a=h.getNodes().filter(l=>!m.has(l));let s;do{s=!1;for(let l=0;l<a.length;l++){const g=a[l];h.hasOnlyGoodArcs(g,m)&&(a.splice(l,1),l--,m.add(g),s=!0)}}while(s);return a.map(l=>b.get(l))}containsActivationEvent(w){return this.g.has(w)}containsExtension(w){return this.e.has(n.ExtensionIdentifier.toKey(w))}getExtensionDescriptionsForActivationEvent(w){const h=this.g.get(w);return h?h.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(w){const h=this.e.get(n.ExtensionIdentifier.toKey(w));return h||void 0}getExtensionDescriptionByUUID(w){for(const h of this.f)if(h.uuid===w)return h}getExtensionDescriptionByIdOrUUID(w,h){return this.getExtensionDescription(w)??(h?this.getExtensionDescriptionByUUID(h):void 0)}}e.ExtensionDescriptionRegistry=S;var R;(function(N){N[N.Builtin=0]="Builtin",N[N.User=1]="User",N[N.Dev=2]="Dev"})(R||(R={}));function y(N,w){const h=N.isBuiltin?0:N.isUnderDevelopment?2:1,b=w.isBuiltin?0:w.isUnderDevelopment?2:1;if(h!==b)return h-b;const m=D.posix.basename(N.extensionLocation.path),a=D.posix.basename(w.extensionLocation.path);return m<a?-1:m>a?1:0}function T(N,w){const h=new Set;return w.forEach(b=>h.add(n.ExtensionIdentifier.toKey(b))),N.filter(b=>!h.has(n.ExtensionIdentifier.toKey(b.identifier)))}}),define(Ce[73],ke([1,0,23]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var D;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(D=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function S(T){const N=n.VSBuffer.alloc(1);switch(T){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.createMessageOfType=S;function R(T,N){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.isMessageOfType=R;var y;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[74],ke([1,0,3,4,11,26,73,50,52,22,2,6,143]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class extends w.Disposable{constructor(l,g){super(),this.m=l,this.n=g,this.a=this.B(new C.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=N.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,h.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(E=>{(0,D.isLogLevel)(E)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===D.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(l,g,E){const L=this.getTelemetryDetails(),v=new m(g,E,l,this.k,this.i,this.getBuiltInCommonProperties(l),{isUsageEnabled:L.isUsageEnabled,isErrorsEnabled:L.isErrorsEnabled});return this.l.set(l.identifier.value,v),v.apiTelemetryLogger}$initializeTelemetryLevel(l,g,E){this.f=l,this.g=g,this.c=E??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(l){const g={};switch(g["common.extname"]=`${l.publisher}.${l.name}`,g["common.extversion"]=l.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=a(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case S.UIKind.Web:g["common.uikind"]="web";break;case S.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,R.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const g=this.getTelemetryDetails();this.l.forEach(E=>{E.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(l,g){const E=this.l.get(l.value);return!E||E.ignoreUnhandledExtHostErrors?!1:(E.logError(g),!0)}};b=qe([je(0,M.IExtHostInitDataService),je(1,D.ILoggerService)],b),e.ExtHostTelemetry=b;class m{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,g,E,L,v,t,d){this.g=E,this.h=L,this.i=v,this.j=t,this.b=new C.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.c=g?.ignoreBuiltInCommonProperties??!1,this.d=g?.additionalCommonProperties,this.a=l,this.e={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(l,g){this.f&&(this.e={isUsageEnabled:l,isErrorsEnabled:g},this.b.fire(this.f))}mixInCommonPropsAndCleanData(l){let g=l.properties??l;return g=(0,y.cleanData)(g,[]),this.d&&(g=(0,T.mixin)(g,this.d)),this.c||(g=(0,T.mixin)(g,this.j)),l.properties?l.properties=g:l=g,l}k(l,g){this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.a.sendEventData(l,g),this.h.trace(l,g)}logUsage(l,g){!this.e.isUsageEnabled||this.k(l,g)}logError(l,g){!this.e.isErrorsEnabled||(typeof l=="string"?this.k(l,g):this.a.sendErrorData(l,g))}get apiTelemetryLogger(){if(!this.f){const l=this,g={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.e.isUsageEnabled},get isErrorsEnabled(){return l.e.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.b.event.bind(l)};this.f=Object.freeze(g)}return this.f}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=m;function a(s){const l=Date.now()-new Date(s).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.isNewAppInstall=a,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Ce[27],ke([1,0,4,2,3,25,169]),function(te,e,n,C,D,M,S){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class y{constructor(p){this.affinity=p,this.kind=1}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class T{constructor(p){this.affinity=p,this.kind=2}equals(p){return this.kind===p.kind&&this.affinity===p.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class N{constructor(){this.kind=3,this.affinity=0}equals(p){return this.kind===p.kind}asString(){return"Remote"}}e.RemoteRunningLocation=N;class w{constructor(p){this.dependency=p}}e.MissingExtensionDependency=w;var h;(function(i){i[i.LocalProcess=1]="LocalProcess",i[i.LocalWebWorker=2]="LocalWebWorker",i[i.Remote=3]="Remote"})(h=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(i){if(i===null)return"None";switch(i){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=b;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(p,c){const o=[],f=[],k=[],A=[],V=l(this.c),_=l(p),K=(F,H)=>F.extensionLocation.toString()===H.extensionLocation.toString()||F.isBuiltin===H.isBuiltin||F.isUserBuiltin===H.isUserBuiltin||F.isUnderDevelopment===H.isUnderDevelopment;for(const F of this.c){const H=_.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){o.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}if(!K(F,H)){o.push(F.identifier),V.delete(M.ExtensionIdentifier.toKey(F.identifier));continue}}for(const F of p){const H=V.get(M.ExtensionIdentifier.toKey(F.identifier));if(!H){f.push(F);continue}if(!K(H,F)){o.push(H.identifier),V.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const O=s(this.d),B=s(c);for(const F of this.d)B.has(M.ExtensionIdentifier.toKey(F))||k.push(F);for(const F of c)O.has(M.ExtensionIdentifier.toKey(F))||A.push(F);const P={toRemove:o,toAdd:f,myToRemove:k,myToAdd:A};return this.delta(P),P}delta(p){const{toRemove:c,toAdd:o,myToRemove:f,myToAdd:k}=p,A=s(c),V=s(f);for(let _=0;_<this.c.length;_++)A.has(M.ExtensionIdentifier.toKey(this.c[_].identifier))&&(this.c.splice(_,1),_--);for(let _=0;_<this.d.length;_++)V.has(M.ExtensionIdentifier.toKey(this.d[_]))&&(this.d.splice(_,1),_--);for(const _ of o)this.c.push(_);for(const _ of k)this.d.push(_)}containsExtension(p){for(const c of this.d)if(M.ExtensionIdentifier.equals(c,p))return!0;return!1}}e.ExtensionHostExtensions=m;class a{constructor(p){if(this[R]="ExtensionIdentifierSet",this.c=new Map,this.d=M.ExtensionIdentifier.toKey,p)for(const c of p)this.add(c)}get size(){return this.c.size}add(p){return this.c.set(this.d(p),p),this}clear(){this.c.clear()}delete(p){return this.c.delete(this.d(p))}has(p){return this.c.has(this.d(p))}forEach(p,c){this.c.forEach(o=>p.call(c,o,o,this))}*entries(){for(const[p,c]of this.c)yield[c,c]}keys(){return this.c.values()}values(){return this.c.values()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=a;function s(i){const p=new Set;for(const c of i)p.add(M.ExtensionIdentifier.toKey(c));return p}e.extensionIdentifiersArrayToSet=s;function l(i){const p=new Map;for(const c of i)p.set(M.ExtensionIdentifier.toKey(c.identifier),c);return p}function g(i,p){return i.enabledApiProposals?i.enabledApiProposals.includes(p):!1}e.isProposedApiEnabled=g;function E(i,p){if(!g(i,p))throw new Error(`Extension '${i.identifier.value}' CANNOT use API proposal: ${p}.
Its package.json#enabledApiProposals-property declares: ${i.enabledApiProposals?.join(", ")??"[]"} but NOT ${p}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${i.identifier.value}`)}e.checkProposedApiEnabled=E;class L{constructor(p,c,o,f){this.codeLoadingTime=p,this.activateCallTime=c,this.activateResolvedTime=o,this.activationReason=f}}e.ActivationTimes=L;class v{constructor(p,c){this.description=p,this.value=c}}e.ExtensionPointContribution=v,e.ExtensionHostLogFileName="exthost";var t;(function(i){i[i.Normal=0]="Normal",i[i.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function d(i){return{type:i.isBuiltin?0:1,isBuiltin:i.isBuiltin||i.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(i.publisher,i.name),uuid:i.uuid},manifest:i,location:i.extensionLocation,targetPlatform:i.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function r(i,p){return{identifier:new M.ExtensionIdentifier((0,S.getExtensionId)(i.manifest.publisher,i.manifest.name)),isBuiltin:i.type===0,isUserBuiltin:i.type===1&&i.isBuiltin,isUnderDevelopment:!!p,extensionLocation:i.location,...i.manifest,uuid:i.identifier.uuid,targetPlatform:i.targetPlatform,browserNlsBundleUris:i.browserNlsBundleUris}}e.toExtensionDescription=r;class u{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.extensions=[]}activateByEvent(p){return Promise.resolve(void 0)}activationEventIsDone(p){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p,c){return Promise.resolve(0)}getInspectPorts(p,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(Ce[192],ke([1,0,12,98,25,27,11,17]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(l,g,E,L){this.startup=l,this.codeLoadingTime=g,this.activateCallTime=E,this.activateResolvedTime=L}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class T{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,g){return l===-1||g===-1?-1:g-l}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=T;class N{constructor(l,g,E,L,v,t){this.activationFailed=l,this.activationFailedError=g,this.activationTimes=E,this.module=L,this.exports=v,this.subscriptions=t}}e.ActivatedExtension=N;class w extends N{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class h extends N{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=h;class b extends N{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(l,g,E,L){this.g=L,this.a=l,this.b=g,this.c=E,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[l,g]of this.d)g.dispose()}isActivated(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));return Boolean(g&&g.value)}getActivatedExtension(l){const g=this.d.get(D.ExtensionIdentifier.toKey(l));if(!g||!g.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return g.value}async activateByEvent(l,g){if(this.f[l])return;const E=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(E.map(L=>({id:L.identifier,reason:{startup:g,extensionId:L.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,g){const E=this.a.getExtensionDescription(l);if(!E)throw new Error(`Extension '${l}' is not known`);return this.h([{id:E.identifier,reason:g}])}async h(l){const g=l.filter(E=>!this.isActivated(E.id)).map(E=>this.j(E));await Promise.all(g.map(E=>E.wait()))}j(l){if(this.d.has(D.ExtensionIdentifier.toKey(l.id)))return this.d.get(D.ExtensionIdentifier.toKey(l.id));if(this.l(l.id))return this.k(l,null,[],null);const g=this.a.getExtensionDescription(l.id);if(!g){const v=new Error(`Cannot activate unknown extension '${l.id.value}'`),t=this.k(l,null,[],new b(v));return this.c.onExtensionActivationError(l.id,v,new M.MissingExtensionDependency(l.id.value)),t}const E=[],L=typeof g.extensionDependencies>"u"?[]:g.extensionDependencies;for(const v of L){if(this.m(v))continue;const t=this.d.get(D.ExtensionIdentifier.toKey(v));if(t){E.push(t);continue}if(this.l(v)){E.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:l.reason}));continue}const d=this.a.getExtensionDescription(v);if(d){if(!d.main&&!d.browser)continue;E.push(this.j({id:d.identifier,reason:l.reason}));continue}const r=g.displayName||g.identifier.value,u=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),i=this.k(l,g.displayName,[],new b(u));return this.c.onExtensionActivationError(g.identifier,u,new M.MissingExtensionDependency(v)),i}return this.k(l,g.displayName,E,null)}k(l,g,E,L){const v=new a(l.id,g,l.reason,E,L,this.c,this.g);return this.d.set(D.ExtensionIdentifier.toKey(l.id),v),v}l(l){return C.ExtensionDescriptionRegistry.isHostExtension(l,this.a,this.b)}m(l){const g=this.b.getExtensionDescription(l);return g?!g.main&&!g.browser:!1}};m=qe([je(3,S.ILogService)],m),e.ExtensionsActivator=m;let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,g,E,L,v,t,d){this.c=l,this.d=g,this.f=E,this.g=L,this.h=v,this.j=t,this.k=d,this.a=new R.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const g=this.g[l];if(g.value&&!g.value.activationFailed){this.g.splice(l,1),l--;continue}if(g.value&&g.value.activationFailed){const E=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${g.friendlyName}' failed to activate`);E.detail=g.value.activationFailedError,this.h=new b(E),this.j.onExtensionActivationError(this.c,E,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const g=new Error;if(l&&l.name&&(g.name=l.name),l&&l.message?g.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:g.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(g.stack=l.stack),this.h=new b(g),this.b&&n.isCancellationError(l))return;this.j.onExtensionActivationError(this.c,g,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};a=qe([je(6,S.ILogService)],a)});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[7],ke([1,0,16,12,86,28,64,10,9,2,34,43,94,70,27]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m){"use strict";var a,s,l,g,E,L,v,t,d,r,u,i,p,c,o,f,k,A,V,_,K,O,B;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(z){return Object.assign(z,{apply:function(){const ie=arguments.length===1?[]:arguments[1];return Reflect.construct(z,ie,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[ie,...we]=arguments;return Reflect.construct(z,we,ie.constructor)}}})}var F;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(F=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var H;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(H=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let j=L=class{static from(...U){let ie=U;return new L(function(){if(ie){for(const we of ie)we&&typeof we.dispose=="function"&&we.dispose();ie=void 0}})}constructor(U){a.set(this,void 0),Je(this,a,U,"f")}dispose(){typeof Le(this,a,"f")=="function"&&(Le(this,a,"f").call(this),Je(this,a,void 0,"f"))}};a=new WeakMap,j=L=qe([P],j),e.Disposable=j;let de=v=class{static Min(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isBefore(ie)&&(ie=xe)}return ie}static Max(...U){if(U.length===0)throw new TypeError;let ie=U[0];for(let we=1;we<U.length;we++){const xe=U[we];xe.isAfter(ie)&&(ie=xe)}return ie}static isPosition(U){if(!U)return!1;if(U instanceof v)return!0;const{line:ie,character:we}=U;return typeof ie=="number"&&typeof we=="number"}static of(U){if(U instanceof v)return U;if(this.isPosition(U))return new v(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("line must be non-negative");if(ie<0)throw(0,C.illegalArgument)("character must be non-negative");this.c=U,this.e=ie}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,ie=0){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ie=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ie===0?this:new v(this.line+we,this.character+ie)}with(U,ie=this.character){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return typeof U>"u"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ie=typeof U.character=="number"?U.character:this.character),we===this.line&&ie===this.character?this:new v(we,ie)}toJSON(){return{line:this.line,character:this.character}}};de=v=qe([P],de),e.Position=de;let pe=t=class{static isRange(U){return U instanceof t?!0:U?de.isPosition(U.start)&&de.isPosition(U.end):!1}static of(U){if(U instanceof t)return U;if(this.isRange(U))return new t(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,ie,we,xe){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof xe=="number"?(_e=new de(U,ie),at=new de(we,xe)):de.isPosition(U)&&de.isPosition(ie)&&(_e=de.of(U),at=de.of(ie)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(U){return t.isRange(U)?this.contains(U.start)&&this.contains(U.end):de.isPosition(U)?!(de.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const ie=de.Max(U.start,this.c),we=de.Min(U.end,this.e);if(!ie.isAfter(we))return new t(ie,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ie=de.Min(U.start,this.c),we=de.Max(U.end,this.end);return new t(ie,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,ie=this.end){if(U===null||ie===null)throw(0,C.illegalArgument)();let we;return U?de.isPosition(U)?we=U:(we=U.start||this.start,ie=U.end||this.end):we=this.start,we.isEqual(this.c)&&ie.isEqual(this.end)?this:new t(we,ie)}toJSON(){return[this.start,this.end]}};pe=t=qe([P],pe),e.Range=pe;let re=d=class extends pe{static isSelection(U){return U instanceof d?!0:U?pe.isRange(U)&&de.isPosition(U.anchor)&&de.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,ie,we,xe){let _e,at;if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof xe=="number"?(_e=new de(U,ie),at=new de(we,xe)):de.isPosition(U)&&de.isPosition(ie)&&(_e=de.of(U),at=de.of(ie)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};re=d=qe([P],re),e.Selection=re;class ue{constructor(U,ie,we){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.illegalArgument)("port");if(typeof we<"u"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z_\-]+$/.test(we)))throw(0,C.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ie),this.connectionToken=we}}e.ResolvedAuthority=ue;class ae extends Error{static NotAvailable(U,ie){return new ae(U,h.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(U){return new ae(U,h.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,ie=h.RemoteAuthorityResolverErrorCode.Unknown,we){super(U),this._message=U,this._code=ie,this._detail=we,Object.setPrototypeOf(this,ae.prototype)}}e.RemoteAuthorityResolverError=ae;var se;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(se=e.EndOfLine||(e.EndOfLine={}));var Y;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(Y=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=r=class{static isTextEdit(U){return U instanceof r?!0:U?pe.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ie){return new r(U,ie)}static insert(U,ie){return r.replace(new pe(U,U),ie)}static delete(U){return r.replace(U,"")}static setEndOfLine(U){const ie=new r(new pe(new de(0,0),new de(0,0)),"");return ie.newEol=U,ie}get range(){return this.c}set range(U){if(U&&!pe.isRange(U))throw(0,C.illegalArgument)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,C.illegalArgument)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,C.illegalArgument)("newEol");this.f=U}constructor(U,ie){this.c=U,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};G=r=qe([P],G),e.TextEdit=G;let Z=u=class{static isNotebookCellEdit(U){return U instanceof u?!0:U?Kt.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,ie){return new u(U,ie)}static insertCells(U,ie){return new u(new Kt(U,U),ie)}static deleteCells(U){return new u(U,[])}static updateCellMetadata(U,ie){const we=new u(new Kt(U,U),[]);return we.newCellMetadata=ie,we}static updateNotebookMetadata(U){const ie=new u(new Kt(0,0),[]);return ie.newNotebookMetadata=U,ie}constructor(U,ie){this.range=U,this.newCells=ie}};Z=u=qe([P],Z),e.NotebookEdit=Z;class he{static isSnippetTextEdit(U){return U instanceof he?!0:U?pe.isRange(U.range)&&Ke.isSnippetString(U.snippet):!1}static replace(U,ie){return new he(U,ie)}static insert(U,ie){return he.replace(new pe(U,U),ie)}constructor(U,ie){this.range=U,this.snippet=ie}}e.SnippetTextEdit=he;var Te;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Te=e.FileEditType||(e.FileEditType={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,ie,we,xe){this.c.push({_type:1,from:U,to:ie,options:we,metadata:xe})}createFile(U,ie,we){this.c.push({_type:1,from:void 0,to:U,options:ie,metadata:we})}deleteFile(U,ie,we){this.c.push({_type:1,from:U,to:void 0,options:ie,metadata:we})}e(U,ie,we){this.c.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(U,ie,we,xe){const _e=ie.start,at=ie.end;(_e!==at||we.length>0)&&this.c.push({_type:5,uri:U,index:_e,count:at-_e,cells:we,metadata:xe})}g(U,ie,we,xe){this.c.push({_type:3,metadata:xe,uri:U,edit:{editType:8,index:ie,metadata:we}})}replace(U,ie,we,xe){this.c.push({_type:2,uri:U,edit:new G(ie,we),metadata:xe})}insert(U,ie,we,xe){this.replace(U,new pe(ie,ie),we,xe)}delete(U,ie,we){this.replace(U,ie,"",we)}has(U){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===U.toString())}set(U,ie){if(ie)for(const we of ie){if(!we)continue;let xe,_e;Array.isArray(we)?(xe=we[0],_e=we[1]):xe=we,Z.isNotebookCellEdit(xe)?xe.newCellMetadata?this.g(U,xe.range.start,xe.newCellMetadata,_e):xe.newNotebookMetadata?this.e(U,xe.newNotebookMetadata,_e):this.f(U,xe.range,xe.newCells,_e):he.isSnippetTextEdit(xe)?this.c.push({_type:6,uri:U,range:xe.range,edit:xe.snippet,metadata:_e}):this.c.push({_type:2,uri:U,edit:xe,metadata:_e})}else{for(let we=0;we<this.c.length;we++){const xe=this.c[we];switch(xe._type){case 2:case 6:case 3:case 5:xe.uri.toString()===U.toString()&&(this.c[we]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(U){const ie=[];for(const we of this.c)we._type===2&&we.uri.toString()===U.toString()&&ie.push(we.edit);return ie}entries(){const U=new M.ResourceMap;for(const ie of this.c)if(ie._type===2){let we=U.get(ie.uri);we||(we=[ie.uri,[]],U.set(ie.uri,we)),we[1].push(ie.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ne=qe([P],Ne),e.WorkspaceEdit=Ne;let Ke=i=class{static isSnippetString(U){return U instanceof i?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=i.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ie=this.e++){if(typeof U=="function"){const we=new i;we.e=this.e,U(we),this.e=we.e,U=we.value}else U=i.c(U);return this.value+="${",this.value+=ie,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ie=this.e++){const we=U.map(xe=>xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ie){if(typeof ie=="function"){const we=new i;we.e=this.e,ie(we),this.e=we.e,ie=we.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};Ke=i=qe([P],Ke),e.SnippetString=Ke;var Pe;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(Pe=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Ie=p=class{static isLocation(U){return U instanceof p?!0:U?pe.isRange(U.range)&&T.URI.isUri(U.uri):!1}constructor(U,ie){if(this.uri=U,ie)if(pe.isRange(ie))this.range=pe.of(ie);else if(de.isPosition(ie))this.range=new pe(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Ie=p=qe([P],Ie),e.Location=Ie;let oe=class{static is(U){return U?typeof U.message=="string"&&U.location&&pe.isRange(U.location.range)&&T.URI.isUri(U.location.uri):!1}constructor(U,ie){this.location=U,this.message=ie}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.location.range.isEqual(ie.location.range)&&U.location.uri.toString()===ie.location.uri.toString()}};oe=qe([P],oe),e.DiagnosticRelatedInformation=oe;let le=class{constructor(U,ie,we=Se.Error){if(!pe.isRange(U))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=U,this.message=ie,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ie){return U===ie?!0:!U||!ie?!1:U.message===ie.message&&U.severity===ie.severity&&U.code===ie.code&&U.severity===ie.severity&&U.source===ie.source&&U.range.isEqual(ie.range)&&(0,n.equals)(U.tags,ie.tags)&&(0,n.equals)(U.relatedInformation,ie.relatedInformation,oe.isEqual)}};le=qe([P],le),e.Diagnostic=le;let J=class{constructor(U,ie){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ie}};J=qe([P],J),e.Hover=J;var I;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(I=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let $=class{constructor(U,ie=I.Text){this.range=U,this.kind=ie}toJSON(){return{range:this.range,kind:I[this.kind]}}};$=qe([P],$),e.DocumentHighlight=$;var W;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(W=e.SymbolKind||(e.SymbolKind={}));var q;(function(z){z[z.Deprecated=1]="Deprecated"})(q=e.SymbolTag||(e.SymbolTag={}));let ee=c=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,ie,we,xe,_e){this.name=U,this.kind=ie,this.containerName=_e,typeof we=="string"&&(this.containerName=we),xe instanceof Ie?this.location=xe:we instanceof pe&&(this.location=new Ie(xe,we)),c.validate(this)}toJSON(){return{name:this.name,kind:W[this.kind],location:this.location,containerName:this.containerName}}};ee=c=qe([P],ee),e.SymbolInformation=ee;let me=o=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(o.validate)}constructor(U,ie,we,xe,_e){this.name=U,this.detail=ie,this.kind=we,this.range=xe,this.selectionRange=_e,this.children=[],o.validate(this)}};me=o=qe([P],me),e.DocumentSymbol=me;var ye;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(ye=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ce=class{constructor(U,ie){this.title=U,this.kind=ie}};ce=qe([P],ce),e.CodeAction=ce;let be=f=class{constructor(U){this.value=U}append(U){return new f(this.value?this.value+f.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+f.c)}};be.c=".",be=f=qe([P],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let Ee=class{constructor(U,ie){if(this.range=U,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([P],Ee),e.SelectionRange=Ee;class We{constructor(U,ie,we,xe,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=xe,this.range=_e,this.selectionRange=at}}e.CallHierarchyItem=We;class Ve{constructor(U,ie){this.fromRanges=ie,this.from=U}}e.CallHierarchyIncomingCall=Ve;class tt{constructor(U,ie){this.fromRanges=ie,this.to=U}}e.CallHierarchyOutgoingCall=tt;var Xe;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(Xe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(U,ie){this.range=U,this.command=ie}get isResolved(){return!!this.command}};et=qe([P],et),e.CodeLens=et;let it=k=class{static isMarkdownString(U){return U instanceof k?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,ie=!1){s.set(this,void 0),Je(this,s,new D.MarkdownString(U,{supportThemeIcons:ie}),"f")}get value(){return Le(this,s,"f").value}set value(U){Le(this,s,"f").value=U}get isTrusted(){return Le(this,s,"f").isTrusted}set isTrusted(U){Le(this,s,"f").isTrusted=U}get supportThemeIcons(){return Le(this,s,"f").supportThemeIcons}set supportThemeIcons(U){Le(this,s,"f").supportThemeIcons=U}get supportHtml(){return Le(this,s,"f").supportHtml}set supportHtml(U){Le(this,s,"f").supportHtml=U}get baseUri(){return Le(this,s,"f").baseUri}set baseUri(U){Le(this,s,"f").baseUri=U}appendText(U){return Le(this,s,"f").appendText(U),this}appendMarkdown(U){return Le(this,s,"f").appendMarkdown(U),this}appendCodeblock(U,ie){return Le(this,s,"f").appendCodeblock(ie??"",U),this}};s=new WeakMap,it=k=qe([P],it),e.MarkdownString=it;let dt=class{constructor(U,ie){this.label=U,this.documentation=ie}};dt=qe([P],dt),e.ParameterInformation=dt;let Fe=class{constructor(U,ie){this.label=U,this.documentation=ie,this.parameters=[]}};Fe=qe([P],Fe),e.SignatureInformation=Fe;let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ot=qe([P],ot),e.SignatureHelp=ot;var Q;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Q=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var X;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(X=e.InlayHintKind||(e.InlayHintKind={}));let ve=class{constructor(U){this.value=U}};ve=qe([P],ve),e.InlayHintLabelPart=ve;let Me=class{constructor(U,ie,we){this.position=U,this.label=ie,this.kind=we}};Me=qe([P],Me),e.InlayHint=Me;var ze;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(He=e.CompletionItemKind||(e.CompletionItemKind={}));var Ye;(function(z){z[z.Deprecated=1]="Deprecated"})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));let nt=class{constructor(U,ie){this.label=U,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};nt=qe([P],nt),e.CompletionItem=nt;let vt=class{constructor(U=[],ie=!1){this.items=U,this.isIncomplete=ie}};vt=qe([P],vt),e.CompletionList=vt;let wt=class{constructor(U,ie,we){this.insertText=U,this.range=ie,this.command=we}};wt=qe([P],wt),e.InlineSuggestion=wt;let Ct=class{constructor(U){this.commands=void 0,this.items=U}};Ct=qe([P],Ct),e.InlineSuggestionList=Ct;var jt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(jt=e.ViewColumn||(e.ViewColumn={}));var rt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var mt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(mt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ft;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Ft=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Gt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Gt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Pt;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var kt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(kt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(z){function U(ie){switch(ie){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=U}(Pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let $t=class{constructor(U,ie){if(ie&&!T.URI.isUri(ie))throw(0,C.illegalArgument)("target");if(!pe.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.target=ie}};$t=qe([P],$t),e.DocumentLink=$t;let Ot=class{constructor(U,ie,we,xe){this.red=U,this.green=ie,this.blue=we,this.alpha=xe}};Ot=qe([P],Ot),e.Color=Ot;let Ge=class{constructor(U,ie){if(ie&&!(ie instanceof Ot))throw(0,C.illegalArgument)("color");if(!pe.isRange(U)||U.isEmpty)throw(0,C.illegalArgument)("range");this.range=U,this.color=ie}};Ge=qe([P],Ge),e.ColorInformation=Ge;let Nt=class{constructor(U){if(!U||typeof U!="string")throw(0,C.illegalArgument)("label");this.label=U}};Nt=qe([P],Nt),e.ColorPresentation=Nt;var Mt;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var zt;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(zt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ft;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(ft=e.TerminalExitReason||(e.TerminalExitReason={}));class De{constructor(U,ie,we){if(this.startIndex=U,this.length=ie,this.tooltip=we,typeof U!="number"||U<0)throw(0,C.illegalArgument)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,C.illegalArgument)("tooltip")}}e.TerminalLink=De;class Ae{constructor(U){this.uri=U}}e.TerminalQuickFixOpener=Ae;class ge{constructor(U){this.terminalCommand=U}}e.TerminalQuickFixCommand=ge;var x;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(x=e.TerminalLocation||(e.TerminalLocation={}));class Re{constructor(U){if(this.options=U,typeof U!="object")throw(0,C.illegalArgument)("options")}}e.TerminalProfile=Re;var $e;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=A=class{static from(U){switch(U){case"clean":return A.Clean;case"build":return A.Build;case"rebuild":return A.Rebuild;case"test":return A.Test;default:return}}constructor(U,ie){if(this.label=ie,typeof U!="string"||typeof ie!="string")throw(0,C.illegalArgument)("name");this.c=U}get id(){return this.c}};Be.Clean=new A("clean","Clean"),Be.Build=new A("build","Build"),Be.Rebuild=new A("rebuild","Rebuild"),Be.Test=new A("test","Test"),Be=A=qe([P],Be),e.TaskGroup=Be;function Ze(z){let U="";for(let ie=0;ie<z.length;ie++)U+=z[ie].replace(/,/g,",,")+",";return U}let ct=class{constructor(U,ie,we){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.e=[],this.c=U,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=we):this.f=ie)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,C.illegalArgument)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)U.push(ie);return Ze(U)}};ct=qe([P],ct),e.ProcessExecution=ct;let Tt=class{constructor(U,ie,we){if(this.f=[],Array.isArray(ie)){if(!U)throw(0,C.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U,this.f=ie,this.g=we}else{if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U,this.g=ie}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,C.illegalArgument)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,C.illegalArgument)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)U.push(typeof ie=="string"?ie:ie.value);return Ze(U)}};Tt=qe([P],Tt),e.ShellExecution=Tt;var bt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class It{constructor(U){this.c=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this.c=U}get callback(){return this.c}}e.CustomExecution=It;let St=V=class{constructor(U,ie,we,xe,_e,at){this.j=!1,this.k=this.definition=U;let lt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=we,this.execution=xe,lt=_e,this.j=!0):ie===Et.Global||ie===Et.Workspace?(this.target=ie,this.m=this.name=we,this.t=this.source=xe,this.execution=_e,lt=at):(this.target=ie,this.m=this.name=we,this.t=this.source=xe,this.execution=_e,lt=at),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ct?this.k={type:V.e,id:this.n.computeId()}:this.n instanceof Tt?this.k={type:V.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:V.c,id:this.n.computeId()}:this.k={type:V.g,id:(0,N.generateUuid)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,C.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=U}get scope(){return this.l}set target(U){this.y(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,C.illegalArgument)("name");this.y(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.y(),this.n=U;const ie=this.k.type;(V.g===ie||V.e===ie||V.f===ie||V.c===ie)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.y(),this.o=U,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.y(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,C.illegalArgument)("source must be a string of length > 0");this.y(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.y(),this.u=U}get detail(){return this.x}set detail(U){U===null&&(U=void 0),this.x=U}get presentationOptions(){return this.v}set presentationOptions(U){U==null&&(U=Object.create(null)),this.y(),this.v=U}get runOptions(){return this.w}set runOptions(U){U==null&&(U=Object.create(null)),this.y(),this.w=U}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=V=qe([P],St),e.Task=St;var yt;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var qt;(function(z){function U(ie){const we=ie;return(0,y.isNumber)(we.value)?we.tooltip&&!(0,y.isString)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}z.isViewBadge=U})(qt=e.ViewBadge||(e.ViewBadge={}));let Jt=_=class{static isTreeItem(U,ie){if(U instanceof _)return!0;const we=U;if(we.label!==void 0&&!(0,y.isString)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,y.isString)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,y.isString)(we.iconPath)&&!T.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,y.isString)(we.iconPath.id))){const xe=we.iconPath;if(!xe||!(0,y.isString)(xe.light)&&!T.URI.isUri(xe.light)&&!(0,y.isString)(xe.dark)&&!T.URI.isUri(xe.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}if(we.description!==void 0&&!(0,y.isString)(we.description)&&typeof we.description!="boolean")return console.log("INVALID tree item, invalid description",we.description),!1;if(we.resourceUri!==void 0&&!T.URI.isUri(we.resourceUri))return console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1;if(we.tooltip!==void 0&&!(0,y.isString)(we.tooltip)&&!(we.tooltip instanceof it))return console.log("INVALID tree item, invalid tooltip",we.tooltip),!1;if(we.command!==void 0&&!we.command.command)return console.log("INVALID tree item, invalid command",we.command),!1;if(we.collapsibleState!==void 0&&we.collapsibleState<pt.None&&we.collapsibleState>pt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1;if(we.contextValue!==void 0&&!(0,y.isString)(we.contextValue))return console.log("INVALID tree item, invalid contextValue",we.contextValue),!1;if(we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1;if(we.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(ie,"treeItemCheckbox");const xe=(0,y.isNumber)(we.checkboxState)?we.checkboxState:(0,y.isObject)(we.checkboxState)&&(0,y.isNumber)(we.checkboxState.state)?we.checkboxState.state:void 0,_e=!(0,y.isNumber)(we.checkboxState)&&(0,y.isObject)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(xe===void 0||xe!==si.Checked&&xe!==si.Unchecked||_e!==void 0&&!(0,y.isString)(_e))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}return!0}constructor(U,ie=pt.None){this.collapsibleState=ie,T.URI.isUri(U)?this.resourceUri=U:this.label=U}};Jt=_=qe([P],Jt),e.TreeItem=Jt;var pt;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U,ie){this.value=U,this.id=ie??(0,N.generateUuid)()}};oi=qe([P],oi),e.DataTransferItem=oi;let Zt=class{constructor(U){l.set(this,new Map);for(const[ie,we]of U??[]){const xe=Le(this,l,"f").get(ie);xe?xe.push(we):Le(this,l,"f").set(ie,[we])}}get(U){return Le(this,l,"f").get(U)?.[0]}set(U,ie){Le(this,l,"f").set(U,[ie])}forEach(U,ie){for(const[we,xe]of Le(this,l,"f"))for(const _e of xe)U.call(ie,_e,we,this)}*[(l=new WeakMap,Symbol.iterator)](){for(const[U,ie]of Le(this,l,"f"))for(const we of ie)yield[U,we]}};Zt=qe([P],Zt),e.DataTransfer=Zt;let vi=class{constructor(U){this.insertText=U}};vi=qe([P],vi),e.DocumentDropEdit=vi;let At=class{constructor(U){this.insertText=U}};At=qe([P],At),e.DocumentPasteEdit=At;let Wt=class{constructor(U,ie){this.id=U,this.color=ie}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};Wt=qe([P],Wt),e.ThemeIcon=Wt,Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let bi=class{constructor(U){this.id=U}};bi=qe([P],bi),e.ThemeColor=bi;var ai;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ei=class{get base(){return this.c}set base(U){this.c=U,this.e=T.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,ie){if(typeof U!="string"&&(!U||!T.URI.isUri(U)&&!T.URI.isUri(U.uri)))throw(0,C.illegalArgument)("base");if(typeof ie!="string")throw(0,C.illegalArgument)("pattern");typeof U=="string"?this.baseUri=T.URI.file(U):T.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ei=qe([P],ei),e.RelativePattern=ei;const ut=new WeakMap;function $i(z,U){ut.set(z,U)}e.setBreakpointId=$i;let Ut=class{constructor(U,ie,we,xe){this.enabled=typeof U=="boolean"?U:!0,typeof ie=="string"&&(this.condition=ie),typeof we=="string"&&(this.hitCondition=we),typeof xe=="string"&&(this.logMessage=xe)}get id(){return this.c||(this.c=ut.get(this)??(0,N.generateUuid)()),this.c}};Ut=qe([P],Ut),e.Breakpoint=Ut;let Qt=class extends Ut{constructor(U,ie,we,xe,_e){if(super(ie,we,xe,_e),U===null)throw(0,C.illegalArgument)("location");this.location=U}};Qt=qe([P],Qt),e.SourceBreakpoint=Qt;let ci=class extends Ut{constructor(U,ie,we,xe,_e){super(ie,we,xe,_e),this.functionName=U}};ci=qe([P],ci),e.FunctionBreakpoint=ci;let Ei=class extends Ut{constructor(U,ie,we,xe,_e,at,lt){if(super(xe,_e,at,lt),!ie)throw(0,C.illegalArgument)("dataId");this.label=U,this.dataId=ie,this.canPersist=we}};Ei=qe([P],Ei),e.DataBreakpoint=Ei;let wi=class{constructor(U,ie,we){this.command=U,this.args=ie||[],this.options=we}};wi=qe([P],wi),e.DebugAdapterExecutable=wi;let ui=class{constructor(U,ie){this.port=U,this.host=ie}};ui=qe([P],ui),e.DebugAdapterServer=ui;let Si=class{constructor(U){this.path=U}};Si=qe([P],Si),e.DebugAdapterNamedPipeServer=Si;let li=class{constructor(U){this.implementation=U}};li=qe([P],li),e.DebugAdapterInlineImplementation=li;let ti=class{constructor(U,ie){this.range=U,this.expression=ie}};ti=qe([P],ti),e.EvaluatableExpression=ti;var Bi;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ii=class{constructor(U,ie){this.range=U,this.text=ie}};ii=qe([P],ii),e.InlineValueText=ii;let ni=class{constructor(U,ie,we=!0){this.range=U,this.variableName=ie,this.caseSensitiveLookup=we}};ni=qe([P],ni),e.InlineValueVariableLookup=ni;let yi=class{constructor(U,ie){this.range=U,this.expression=ie}};yi=qe([P],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(U,ie){this.frameId=U,this.stoppedLocation=ie}};Di=qe([P],Di),e.InlineValueContext=Di;var ri;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ri=e.FileChangeType||(e.FileChangeType={}));let Ii=K=class extends Error{static FileExists(U){return new K(U,w.FileSystemProviderErrorCode.FileExists,K.FileExists)}static FileNotFound(U){return new K(U,w.FileSystemProviderErrorCode.FileNotFound,K.FileNotFound)}static FileNotADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileNotADirectory,K.FileNotADirectory)}static FileIsADirectory(U){return new K(U,w.FileSystemProviderErrorCode.FileIsADirectory,K.FileIsADirectory)}static NoPermissions(U){return new K(U,w.FileSystemProviderErrorCode.NoPermissions,K.NoPermissions)}static Unavailable(U){return new K(U,w.FileSystemProviderErrorCode.Unavailable,K.Unavailable)}constructor(U,ie=w.FileSystemProviderErrorCode.Unknown,we){super(T.URI.isUri(U)?U.toString(!0):U),this.code=we?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,ie),Object.setPrototypeOf(this,K.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};Ii=K=qe([P],Ii),e.FileSystemError=Ii;let Ci=class{constructor(U,ie,we){this.start=U,this.end=ie,this.kind=we}};Ci=qe([P],Ci),e.FoldingRange=Ci;var zi;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(U,ie=[]){this.tokenTypes=U,this.tokenModifiers=ie}}e.SemanticTokensLegend=Ri;function Oi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Ue{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let ie=0,we=U.tokenTypes.length;ie<we;ie++)this.j.set(U.tokenTypes[ie],ie);for(let ie=0,we=U.tokenModifiers.length;ie<we;ie++)this.k.set(U.tokenModifiers[ie],ie)}}push(U,ie,we,xe,_e){if(typeof U=="number"&&typeof ie=="number"&&typeof we=="number"&&typeof xe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(U,ie,we,xe,_e);if(pe.isRange(U)&&typeof ie=="string"&&Oi(we))return this.m(U,ie,we);throw(0,C.illegalArgument)()}m(U,ie,we){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const xe=U.start.line,_e=U.start.character,at=U.end.character-U.start.character,lt=this.j.get(ie);let Lt=0;if(we)for(const Vt of we){if(!this.k.has(Vt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Vt);Lt|=1<<xt>>>0}this.n(xe,_e,at,lt,Lt)}n(U,ie,we,xe,_e){if(this.f&&(U<this.c||U===this.c&&ie<this.e)){this.f=!1;const Lt=this.g.length/5|0;let Vt=0,xt=0;for(let Xt=0;Xt<Lt;Xt++){let Yt=this.g[5*Xt],Pi=this.g[5*Xt+1];Yt===0?(Yt=Vt,Pi+=xt):Yt+=Vt,this.g[5*Xt]=Yt,this.g[5*Xt+1]=Pi,Vt=Yt,xt=Pi}}let at=U,lt=ie;this.f&&this.h>0&&(at-=this.c,at===0&&(lt-=this.e)),this.g[this.h++]=at,this.g[this.h++]=lt,this.g[this.h++]=we,this.g[this.h++]=xe,this.g[this.h++]=_e,this.c=U,this.e=ie}static o(U){const ie=[],we=U.length/5|0;for(let lt=0;lt<we;lt++)ie[lt]=lt;ie.sort((lt,Lt)=>{const Vt=U[5*lt],xt=U[5*Lt];if(Vt===xt){const Xt=U[5*lt+1],Yt=U[5*Lt+1];return Xt-Yt}return Vt-xt});const xe=new Uint32Array(U.length);let _e=0,at=0;for(let lt=0;lt<we;lt++){const Lt=5*ie[lt],Vt=U[Lt+0],xt=U[Lt+1],Xt=U[Lt+2],Yt=U[Lt+3],Pi=U[Lt+4],sn=Vt-_e,Rn=sn===0?xt-at:xt,Ai=5*lt;xe[Ai+0]=sn,xe[Ai+1]=Rn,xe[Ai+2]=Xt,xe[Ai+3]=Yt,xe[Ai+4]=Pi,_e=Vt,at=xt}return xe}build(U){return this.f?new Ht(new Uint32Array(this.g),U):new Ht(Ue.o(this.g),U)}}e.SemanticTokensBuilder=Ue;class Ht{constructor(U,ie){this.resultId=ie,this.data=U}}e.SemanticTokens=Ht;class Li{constructor(U,ie,we){this.start=U,this.deleteCount=ie,this.data=we}}e.SemanticTokensEdit=Li;class gt{constructor(U,ie){this.resultId=ie,this.edits=U}}e.SemanticTokensEdits=gt;var Vi;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new Wt("arrow-left")},di=qe([P],di),e.QuickInputButtons=di;var Fi;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Fi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ji;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})(ji=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class qi{static validate(U){if(typeof U.badge=="string"){let ie=(0,R.nextCharLength)(U.badge,0);if(ie<U.badge.length&&(ie+=(0,R.nextCharLength)(U.badge,ie)),U.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Wt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,ie,we){this.badge=U,this.tooltip=ie,this.color=we}}e.FileDecoration=qi;let Ti=class{constructor(U){this.kind=U}};Ti=qe([P],Ti),e.ColorTheme=Ti;var Ki;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Ki=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{static isNotebookRange(U){return U instanceof Kt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,ie){if(U<0)throw(0,C.illegalArgument)("start must be positive");if(ie<0)throw(0,C.illegalArgument)("end must be positive");U<=ie?(this.c=U,this.e=ie):(this.c=ie,this.e=U)}with(U){let ie=this.c,we=this.e;return U.start!==void 0&&(ie=U.start),U.end!==void 0&&(we=U.end),ie===this.c&&we===this.e?this:new Kt(ie,we)}}e.NotebookRange=Kt;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ie=>fi.isNotebookCellData(ie))}static isNotebookCellData(U){return!0}constructor(U,ie,we,xe,_e,at,lt){this.kind=U,this.value=ie,this.languageId=we,this.mime=xe,this.outputs=_e??[],this.metadata=at,this.executionSummary=lt,fi.validate(this)}}e.NotebookCellData=fi;class xi{constructor(U){this.cells=U}}e.NotebookData=xi;class Bt{static isNotebookCellOutputItem(U){return U instanceof Bt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ie={name:U.name,message:U.message,stack:U.stack};return Bt.json(ie,"application/vnd.code.notebook.error")}static stdout(U){return Bt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Bt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ie="application/octet-stream"){return new Bt(U,ie)}static text(U,ie=S.Mimes.text){const we=Le(Bt,g,"f",E).encode(String(U));return new Bt(we,ie)}static json(U,ie="text/x-json"){const we=JSON.stringify(U,void 0,"	");return Bt.text(we,ie)}constructor(U,ie){this.data=U,this.mime=ie;const we=(0,S.normalizeMimeType)(ie,!0);if(!we)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}g=Bt,E={value:new TextEncoder},e.NotebookCellOutputItem=Bt;class mi{static isNotebookCellOutput(U){return U instanceof mi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,ie=!1){const we=new Set,xe=new Set;for(let _e=0;_e<U.length;_e++){const at=U[_e],lt=(0,S.normalizeMimeType)(at.mime);if(!we.has(lt)||(0,b.isTextStreamMime)(lt)){we.add(lt);continue}xe.add(_e),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return xe.size===0?U:U.filter((_e,at)=>!xe.has(at))}constructor(U,ie,we){this.items=mi.ensureUniqueMimeTypes(U,!0),typeof ie=="string"?(this.id=ie,this.metadata=we):(this.id=(0,N.generateUuid)(),this.metadata=ie??we)}}e.NotebookCellOutput=mi;var Gi;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(Gi=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ne;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(ne=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var fe;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(fe=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Oe{constructor(U,ie){this.text=U,this.alignment=ie}}e.NotebookCellStatusBarItem=Oe;var st;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(st=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var Dt;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Dt=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Rt{constructor(U,ie=[]){this.uri=U,this.provides=(0,n.asArray)(ie)}}e.NotebookRendererScript=Rt;class un{constructor(U){this.label=U}}e.NotebookKernelSourceAction=un;let Qi=class{constructor(U,ie){this.label=U,this.timestamp=ie}};Qi=qe([P],Qi),e.TimelineItem=Qi;var ln;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(ln=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(U,ie){this.ranges=U,this.wordPattern=ie}}e.LinkedEditingRanges=fn;class mn{constructor(U,ie){this.c=U,this.e=ie}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Ni=class{constructor(U=void 0,ie=void 0,we=void 0){this.include=U,this.exclude=ie,this.profile=we}};Ni=qe([P],Ni),e.TestRunRequest=Ni;let Yi=class extends Ni{constructor(U=void 0,ie=void 0,we=void 0,xe=!1){super(U,ie,we),this.continuous=xe}};Yi=qe([P],Yi),e.TestRunRequest2=Yi;let _i=O=class{static diff(U,ie,we){const xe=new O(U);return xe.expectedOutput=ie,xe.actualOutput=we,xe}constructor(U){this.message=U}};_i=O=qe([P],_i),e.TestMessage=_i;let Ji=class{constructor(U){this.id=U}};Ji=qe([P],Ji),e.TestTag=Ji;let gi=class{constructor(U,ie){this.covered=U,this.total=ie}};gi=qe([P],gi),e.CoveredCount=gi;let Zi=B=class{static fromDetails(U,ie){const we=new gi(0,0),xe=new gi(0,0),_e=new gi(0,0);for(const lt of ie)if("branches"in lt){we.total+=1,we.covered+=lt.executionCount>0?1:0;for(const Lt of lt.branches)xe.total+=1,xe.covered+=Lt.executionCount>0?1:0}else _e.total+=1,_e.covered+=lt.executionCount>0?1:0;const at=new B(U,we,xe.total>0?xe:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ie,at}constructor(U,ie,we,xe){this.uri=U,this.statementCoverage=ie,this.branchCoverage=we,this.functionCoverage=xe}};Zi=B=qe([P],Zi),e.FileCoverage=Zi;let en=class{constructor(U,ie,we=[]){this.executionCount=U,this.location=ie,this.branches=we}};en=qe([P],en),e.StatementCoverage=en;let tn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};tn=qe([P],tn),e.BranchCoverage=tn;let nn=class{constructor(U,ie){this.executionCount=U,this.location=ie}};nn=qe([P],nn),e.FunctionCoverage=nn;var vn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(bn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var En;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(En=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class wn{constructor(U,ie,we,xe,_e,at){this.kind=U,this.name=ie,this.detail=we,this.uri=xe,this.range=_e,this.selectionRange=at}}e.TypeHierarchyItem=wn;class Sn{constructor(U){this.uri=U}}e.TextTabInput=Sn;class yn{constructor(U,ie){this.original=U,this.modified=ie}}e.TextDiffTabInput=yn;class Dn{constructor(U,ie,we,xe){this.base=U,this.input1=ie,this.input2=we,this.result=xe}}e.TextMergeTabInput=Dn;class In{constructor(U,ie){this.uri=U,this.viewType=ie}}e.CustomEditorTabInput=In;class Cn{constructor(U){this.viewType=U}}e.WebviewEditorTabInput=Cn;class kn{constructor(U,ie){this.uri=U,this.notebookType=ie}}e.NotebookEditorTabInput=kn;class Tn{constructor(U,ie,we){this.original=U,this.modified=ie,this.notebookType=we}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(U,ie){this.uri=U,this.inputBoxUri=ie}}e.InteractiveWindowInput=An}),define(Ce[99],ke([1,0,49,15,10,258,131,7,16]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function N(m,a){a?T.set(m,a):T.delete(m)}e.setWordDefinitionFor=N;function w(m){return T.get(m)}class h extends M.MirrorTextModel{constructor(a,s,l,g,E,L,v,t){super(s,l,g,E),this.m=a,this.p=L,this.q=v,this.notebook=t,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,y.equals)(this.d,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.c},get fileName(){return a.c.fsPath},get isUntitled(){return a.c.scheme===C.Schemas.untitled},get languageId(){return a.p},get version(){return a.g},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.f===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a.d.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,l){return a.y(s,l)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,n.ok)(!this.b),this.p=a}_acceptIsDirty(a){(0,n.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.d[s.start.line].substring(s.start.character,s.end.character);const l=this.f,g=s.start.line,E=s.end.line,L=[];L.push(this.d[g].substring(s.start.character));for(let v=g+1;v<E;v++)L.push(this.d[v]);return L.push(this.d[E].substring(0,s.end.character)),L.join(l)}t(a){let s;if(a instanceof R.Position?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.d.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new b(s,this.d[s],s===this.d.length-1)}u(a){return a=this.x(a),this.k(),this.h.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.k();const s=this.h.getIndexOf(a),l=this.d[s.index].length;return new R.Position(s.index,Math.min(s.remainder,l))}w(a){if(!(a instanceof R.Range))throw new Error("Invalid argument");const s=this.x(a.start),l=this.x(a.end);return s===a.start&&l===a.end?a:new R.Range(s.line,s.character,l.line,l.character)}x(a){if(!(a instanceof R.Position))throw new Error("Invalid argument");if(this.d.length===0)return a.with(0,0);let{line:s,character:l}=a,g=!1;if(s<0)s=0,l=0,g=!0;else if(s>=this.d.length)s=this.d.length-1,l=this.d[s].length,g=!0;else{const E=this.d[s].length;l<0?(l=0,g=!0):l>E&&(l=E,g=!0)}return g?new R.Position(s,l):a}y(a,s){const l=this.x(a);if(!s)s=w(this.p);else if((0,D.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const g=(0,S.getWordAtText)(l.character+1,(0,S.ensureValidWordDefinition)(s),this.d[l.line],0);if(g)return new R.Range(l.line,g.startColumn-1,l.line,g.endColumn-1)}}e.ExtHostDocumentData=h;class b{constructor(a,s,l){this.a=a,this.b=s,this.c=l}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=b}),define(Ce[193],ke([1,0,7,18,4]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(R){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new D.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(R){let y;switch(R){case"light":y=n.ColorThemeKind.Light;break;case"hcDark":y=n.ColorThemeKind.HighContrast;break;case"hcLight":y=n.ColorThemeKind.HighContrastLight;break;default:y=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};M=qe([je(0,C.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[8],ke([1,0,16,23,116,194,86,28,112,65,64,22,9,2,44,75,91,96,95,70,45,56,190,7]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(De){function Ae(x){const{selectionStartLineNumber:Re,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Be}=x,Ze=new d.Position(Re-1,$e-1),ct=new d.Position(Qe-1,Be-1);return new d.Selection(Ze,ct)}De.to=Ae;function ge(x){const{anchor:Re,active:$e}=x;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}De.from=ge})(r=e.Selection||(e.Selection={}));var u;(function(De){function Ae(x){if(!x)return;const{start:Re,end:$e}=x;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}De.from=Ae;function ge(x){if(!x)return;const{startLineNumber:Re,startColumn:$e,endLineNumber:Qe,endColumn:Be}=x;return new d.Range(Re-1,$e-1,Qe-1,Be-1)}De.to=ge})(u=e.Range||(e.Range={}));var i;(function(De){function Ae(ge){switch(ge){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}De.to=Ae})(i=e.TokenType||(e.TokenType={}));var p;(function(De){function Ae(x){return new d.Position(x.lineNumber-1,x.column-1)}De.to=Ae;function ge(x){return{lineNumber:x.line+1,column:x.character+1}}De.from=ge})(p=e.Position||(e.Position={}));var c;(function(De){function Ae(Re,$e){return(0,n.coalesce)((0,n.asArray)(Re).map(Qe=>ge(Qe,$e)))}De.from=Ae;function ge(Re,$e){if(typeof Re=="string")return{$serialized:!0,language:Re};if(Re)return{$serialized:!0,language:Re.language,scheme:x(Re.scheme,$e),pattern:X.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType}}function x(Re,$e){return $e&&typeof Re=="string"?$e.transformOutgoingScheme(Re):Re}})(c=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(De){function Ae(x){switch(x){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}De.from=Ae;function ge(x){switch(x){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}De.to=ge})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(De){function Ae(x){let Re;return x.code&&((0,h.isString)(x.code)||(0,h.isNumber)(x.code)?Re=String(x.code):Re={value:String(x.code.value),target:x.code.target}),{...u.from(x.range),message:x.message,source:x.source,code:Re,severity:A.from(x.severity),relatedInformation:x.relatedInformation&&x.relatedInformation.map(k.from),tags:Array.isArray(x.tags)?(0,n.coalesce)(x.tags.map(o.from)):void 0}}De.from=Ae;function ge(x){const Re=new d.Diagnostic(u.to(x),x.message,A.to(x.severity));return Re.source=x.source,Re.code=(0,h.isString)(x.code)?x.code:x.code?.value,Re.relatedInformation=x.relatedInformation&&x.relatedInformation.map(k.to),Re.tags=x.tags&&(0,n.coalesce)(x.tags.map(o.to)),Re}De.to=ge})(f=e.Diagnostic||(e.Diagnostic={}));var k;(function(De){function Ae(x){return{...u.from(x.location.range),message:x.message,resource:x.location.uri}}De.from=Ae;function ge(x){return new d.DiagnosticRelatedInformation(new d.Location(x.resource,u.to(x)),x.message)}De.to=ge})(k=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var A;(function(De){function Ae(x){switch(x){case d.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}De.from=Ae;function ge(x){switch(x){case s.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}De.to=ge})(A=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var V;(function(De){function Ae(x){return typeof x=="number"&&x>=d.ViewColumn.One?x-1:x===d.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}De.from=Ae;function ge(x){if(typeof x=="number"&&x>=0)return x+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=ge})(V=e.ViewColumn||(e.ViewColumn={}));function _(De){return typeof De.range<"u"}function K(De){return De.length===0?!0:!!_(De[0])}e.isDecorationOptionsArr=K;var O;(function(De){function Ae(Be){return Be.map(De.from)}De.fromMany=Ae;function ge(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function x(Be){let Ze;if(ge(Be)){const{language:Et,value:It}=Be;Ze={value:"```"+Et+`
`+It+"\n```\n"}}else d.MarkdownString.isMarkdownString(Be)?Ze={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?Ze={value:Be}:Ze={value:""};const ct=Object.create(null);Ze.uris=ct;const Tt=Et=>{try{let It=b.URI.parse(Et,!0);It=It.with({query:Re(It.query,ct)}),ct[Et]=It}catch{}return""},bt=new y.marked.Renderer;return bt.link=Tt,bt.image=Et=>typeof Et=="string"?Tt(S.parseHrefAndDimensions(Et).href):"",(0,y.marked)(Ze.value,{renderer:bt}),Ze}De.from=x;function Re(Be,Ze){if(!Be)return Be;let ct;try{ct=(0,T.parse)(Be)}catch{}if(!ct)return Be;let Tt=!1;return ct=(0,w.cloneAndChange)(ct,bt=>{if(b.URI.isUri(bt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ze[Et]=bt,Tt=!0,Et}else return}),Tt?JSON.stringify(ct):Be}function $e(Be){const Ze=new d.MarkdownString(Be.value,Be.supportThemeIcons);return Ze.isTrusted=Be.isTrusted,Ze.supportHtml=Be.supportHtml,Ze.baseUri=Be.baseUri?b.URI.from(Be.baseUri):void 0,Ze}De.to=$e;function Qe(Be){if(!!Be)return typeof Be=="string"?Be:De.from(Be)}De.fromStrict=Qe})(O=e.MarkdownString||(e.MarkdownString={}));function B(De){return K(De)?De.map(Ae=>({range:u.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?O.fromMany(Ae.hoverMessage):Ae.hoverMessage?O.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):De.map(Ae=>({range:u.from(Ae)}))}e.fromRangeOrRangeWithMessage=B;function P(De){return typeof De>"u"?De:typeof De=="string"?b.URI.file(De):De}e.pathOrURIToURI=P;var F;(function(De){function Ae(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?P(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}De.from=Ae})(F=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(De){function Ae(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var j;(function(De){function Ae(ge){if(typeof ge>"u")return ge;switch(ge){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Ae})(j=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var de;(function(De){function Ae(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?j.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?H.from(ge.light):void 0,dark:ge.dark?H.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?P(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?F.from(ge.before):void 0,after:ge.after?F.from(ge.after):void 0}}De.from=Ae})(de=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var pe;(function(De){function Ae(x){return{text:x.newText,eol:x.newEol&&it.from(x.newEol),range:u.from(x.range)}}De.from=Ae;function ge(x){const Re=new d.TextEdit(u.to(x.range),x.text);return Re.newEol=typeof x.eol>"u"?void 0:it.to(x.eol),Re}De.to=ge})(pe=e.TextEdit||(e.TextEdit={}));var re;(function(De){function Ae(x,Re){const $e={edits:[]};if(x instanceof d.WorkspaceEdit){const Qe=new R.ResourceSet;for(const Be of x._allEntries())Be._type===1&&b.URI.isUri(Be.to)&&Be.from===void 0&&Qe.add(Be.to);for(const Be of x._allEntries())Be._type===1?$e.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,C.encodeBase64)(C.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?$e.edits.push({resource:Be.uri,textEdit:pe.from(Be.edit),versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?$e.edits.push({resource:Be.uri,textEdit:{range:u.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:Qe.has(Be.uri)?void 0:Re?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?$e.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&$e.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(vt.from)}})}return $e}De.from=Ae;function ge(x){const Re=new d.WorkspaceEdit;for(const $e of x.edits)$e.textEdit?Re.replace(b.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Re.renameFile(b.URI.revive($e.oldResource),b.URI.revive($e.newResource),$e.options);return Re}De.to=ge})(re=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(De){const Ae=Object.create(null);Ae[d.SymbolKind.File]=0,Ae[d.SymbolKind.Module]=1,Ae[d.SymbolKind.Namespace]=2,Ae[d.SymbolKind.Package]=3,Ae[d.SymbolKind.Class]=4,Ae[d.SymbolKind.Method]=5,Ae[d.SymbolKind.Property]=6,Ae[d.SymbolKind.Field]=7,Ae[d.SymbolKind.Constructor]=8,Ae[d.SymbolKind.Enum]=9,Ae[d.SymbolKind.Interface]=10,Ae[d.SymbolKind.Function]=11,Ae[d.SymbolKind.Variable]=12,Ae[d.SymbolKind.Constant]=13,Ae[d.SymbolKind.String]=14,Ae[d.SymbolKind.Number]=15,Ae[d.SymbolKind.Boolean]=16,Ae[d.SymbolKind.Array]=17,Ae[d.SymbolKind.Object]=18,Ae[d.SymbolKind.Key]=19,Ae[d.SymbolKind.Null]=20,Ae[d.SymbolKind.EnumMember]=21,Ae[d.SymbolKind.Struct]=22,Ae[d.SymbolKind.Event]=23,Ae[d.SymbolKind.Operator]=24,Ae[d.SymbolKind.TypeParameter]=25;function ge(Re){return typeof Ae[Re]=="number"?Ae[Re]:6}De.from=ge;function x(Re){for(const $e in Ae)if(Ae[$e]===Re)return Number($e);return d.SymbolKind.Property}De.to=x})(ue=e.SymbolKind||(e.SymbolKind={}));var ae;(function(De){function Ae(x){switch(x){case d.SymbolTag.Deprecated:return 1}}De.from=Ae;function ge(x){switch(x){case 1:return d.SymbolTag.Deprecated}}De.to=ge})(ae=e.SymbolTag||(e.SymbolTag={}));var se;(function(De){function Ae(x){return{name:x.name,kind:ue.from(x.kind),tags:x.tags&&x.tags.map(ae.from),containerName:x.containerName,location:Te.from(x.location)}}De.from=Ae;function ge(x){const Re=new d.SymbolInformation(x.name,ue.to(x.kind),x.containerName,Te.to(x.location));return Re.tags=x.tags&&x.tags.map(ae.to),Re}De.to=ge})(se=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(De){function Ae(x){const Re={name:x.name||"!!MISSING: name!!",detail:x.detail,range:u.from(x.range),selectionRange:u.from(x.selectionRange),kind:ue.from(x.kind),tags:x.tags?.map(ae.from)??[]};return x.children&&(Re.children=x.children.map(Ae)),Re}De.from=Ae;function ge(x){const Re=new d.DocumentSymbol(x.name,x.detail,ue.to(x.kind),u.to(x.range),u.to(x.selectionRange));return(0,n.isNonEmptyArray)(x.tags)&&(Re.tags=x.tags.map(ae.to)),x.children&&(Re.children=x.children.map(ge)),Re}De.to=ge})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(De){function Ae(x){const Re=new d.CallHierarchyItem(ue.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),u.to(x.range),u.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}De.to=Ae;function ge(x,Re,$e){if(Re=Re??x._sessionId,$e=$e??x._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,name:x.name,detail:x.detail,kind:ue.from(x.kind),uri:x.uri,range:u.from(x.range),selectionRange:u.from(x.selectionRange),tags:x.tags?.map(ae.from)}}De.from=ge})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var Z;(function(De){function Ae(ge){return new d.CallHierarchyIncomingCall(G.to(ge.from),ge.fromRanges.map(x=>u.to(x)))}De.to=Ae})(Z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(De){function Ae(ge){return new d.CallHierarchyOutgoingCall(G.to(ge.to),ge.fromRanges.map(x=>u.to(x)))}De.to=Ae})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Te;(function(De){function Ae(x){return{range:x.range&&u.from(x.range),uri:x.uri}}De.from=Ae;function ge(x){return new d.Location(b.URI.revive(x.uri),u.to(x.range))}De.to=ge})(Te=e.location||(e.location={}));var Ne;(function(De){function Ae(x){const Re=x,$e=x;return{originSelectionRange:Re.originSelectionRange?u.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:$e.uri,range:u.from(Re.targetRange?Re.targetRange:$e.range),targetSelectionRange:Re.targetSelectionRange?u.from(Re.targetSelectionRange):void 0}}De.from=Ae;function ge(x){return{targetUri:b.URI.revive(x.uri),targetRange:u.to(x.range),targetSelectionRange:x.targetSelectionRange?u.to(x.targetSelectionRange):void 0,originSelectionRange:x.originSelectionRange?u.to(x.originSelectionRange):void 0}}De.to=ge})(Ne=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(De){function Ae(x){return{range:u.from(x.range),contents:O.fromMany(x.contents)}}De.from=Ae;function ge(x){return new d.Hover(x.contents.map(O.to),u.to(x.range))}De.to=ge})(Ke=e.Hover||(e.Hover={}));var Pe;(function(De){function Ae(x){return{range:u.from(x.range),expression:x.expression}}De.from=Ae;function ge(x){return new d.EvaluatableExpression(u.to(x.range),x.expression)}De.to=ge})(Pe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Se;(function(De){function Ae(x){if(x instanceof d.InlineValueText)return{type:"text",range:u.from(x.range),text:x.text};if(x instanceof d.InlineValueVariableLookup)return{type:"variable",range:u.from(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};if(x instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(x.range),expression:x.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Ae;function ge(x){switch(x.type){case"text":return{range:u.to(x.range),text:x.text};case"variable":return{range:u.to(x.range),variableName:x.variableName,caseSensitiveLookup:x.caseSensitiveLookup};case"expression":return{range:u.to(x.range),expression:x.expression}}}De.to=ge})(Se=e.InlineValue||(e.InlineValue={}));var Ie;(function(De){function Ae(x){return{frameId:x.frameId,stoppedLocation:u.from(x.stoppedLocation)}}De.from=Ae;function ge(x){return new d.InlineValueContext(x.frameId,u.to(x.stoppedLocation))}De.to=ge})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var oe;(function(De){function Ae(x){return{range:u.from(x.range),kind:x.kind}}De.from=Ae;function ge(x){return new d.DocumentHighlight(u.to(x.range),x.kind)}De.to=ge})(oe=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(De){function Ae(ge){switch(ge){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}De.to=Ae})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(De){function Ae(ge){return{triggerKind:le.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}De.to=Ae})(J=e.CompletionContext||(e.CompletionContext={}));var I;(function(De){function Ae(x){switch(x){case d.CompletionItemTag.Deprecated:return 1}}De.from=Ae;function ge(x){switch(x){case 1:return d.CompletionItemTag.Deprecated}}De.to=ge})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var $;(function(De){const Ae=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ge($e){return Ae.get($e)??9}De.from=ge;const x=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Re($e){return x.get($e)??d.CompletionItemKind.Property}De.to=Re})($=e.CompletionItemKind||(e.CompletionItemKind={}));var W;(function(De){function Ae(ge,x){const Re=new d.CompletionItem(ge.label);return Re.insertText=ge.insertText,Re.kind=$.to(ge.kind),Re.tags=ge.tags?.map(I.to),Re.detail=ge.detail,Re.documentation=S.isMarkdownString(ge.documentation)?O.to(ge.documentation):ge.documentation,Re.sortText=ge.sortText,Re.filterText=ge.filterText,Re.preselect=ge.preselect,Re.commitCharacters=ge.commitCharacters,m.Range.isIRange(ge.range)?Re.range=u.to(ge.range):typeof ge.range=="object"&&(Re.range={inserting:u.to(ge.range.insert),replacing:u.to(ge.range.replace)}),Re.keepWhitespace=typeof ge.insertTextRules>"u"?!1:Boolean(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Re.insertText=new d.SnippetString(ge.insertText):(Re.insertText=ge.insertText,Re.textEdit=Re.range instanceof d.Range?new d.TextEdit(Re.range,Re.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Re.additionalTextEdits=ge.additionalTextEdits.map($e=>pe.to($e))),Re.command=x&&ge.command?x.fromInternal(ge.command):void 0,Re}De.to=Ae})(W=e.CompletionItem||(e.CompletionItem={}));var q;(function(De){function Ae(x){if(typeof x.label!="string"&&!Array.isArray(x.label))throw new TypeError("Invalid label");return{label:x.label,documentation:O.fromStrict(x.documentation)}}De.from=Ae;function ge(x){return{label:x.label,documentation:S.isMarkdownString(x.documentation)?O.to(x.documentation):x.documentation}}De.to=ge})(q=e.ParameterInformation||(e.ParameterInformation={}));var ee;(function(De){function Ae(x){return{label:x.label,documentation:O.fromStrict(x.documentation),parameters:Array.isArray(x.parameters)?x.parameters.map(q.from):[],activeParameter:x.activeParameter}}De.from=Ae;function ge(x){return{label:x.label,documentation:S.isMarkdownString(x.documentation)?O.to(x.documentation):x.documentation,parameters:Array.isArray(x.parameters)?x.parameters.map(q.to):[],activeParameter:x.activeParameter}}De.to=ge})(ee=e.SignatureInformation||(e.SignatureInformation={}));var me;(function(De){function Ae(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.from):[]}}De.from=Ae;function ge(x){return{activeSignature:x.activeSignature,activeParameter:x.activeParameter,signatures:Array.isArray(x.signatures)?x.signatures.map(ee.to):[]}}De.to=ge})(me=e.SignatureHelp||(e.SignatureHelp={}));var ye;(function(De){function Ae(ge,x){const Re=new d.InlayHint(p.to(x.position),typeof x.label=="string"?x.label:x.label.map(ce.to.bind(void 0,ge)),x.kind&&be.to(x.kind));return Re.textEdits=x.textEdits&&x.textEdits.map(pe.to),Re.tooltip=S.isMarkdownString(x.tooltip)?O.to(x.tooltip):x.tooltip,Re.paddingLeft=x.paddingLeft,Re.paddingRight=x.paddingRight,Re}De.to=Ae})(ye=e.InlayHint||(e.InlayHint={}));var ce;(function(De){function Ae(ge,x){const Re=new d.InlayHintLabelPart(x.label);return Re.tooltip=S.isMarkdownString(x.tooltip)?O.to(x.tooltip):x.tooltip,a.Command.is(x.command)&&(Re.command=ge.fromInternal(x.command)),x.location&&(Re.location=Te.to(x.location)),Re}De.to=Ae})(ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(De){function Ae(x){return x}De.from=Ae;function ge(x){return x}De.to=ge})(be=e.InlayHintKind||(e.InlayHintKind={}));var Ee;(function(De){function Ae(x){return{range:u.from(x.range),url:x.target,tooltip:x.tooltip}}De.from=Ae;function ge(x){let Re;if(x.url)try{Re=typeof x.url=="string"?b.URI.parse(x.url,!0):b.URI.revive(x.url)}catch{}return new d.DocumentLink(u.to(x.range),Re)}De.to=ge})(Ee=e.DocumentLink||(e.DocumentLink={}));var We;(function(De){function Ae(x){const Re=new d.ColorPresentation(x.label);return x.textEdit&&(Re.textEdit=pe.to(x.textEdit)),x.additionalTextEdits&&(Re.additionalTextEdits=x.additionalTextEdits.map($e=>pe.to($e))),Re}De.to=Ae;function ge(x){return{label:x.label,textEdit:x.textEdit?pe.from(x.textEdit):void 0,additionalTextEdits:x.additionalTextEdits?x.additionalTextEdits.map(Re=>pe.from(Re)):void 0}}De.from=ge})(We=e.ColorPresentation||(e.ColorPresentation={}));var Ve;(function(De){function Ae(x){return new d.Color(x[0],x[1],x[2],x[3])}De.to=Ae;function ge(x){return[x.red,x.green,x.blue,x.alpha]}De.from=ge})(Ve=e.Color||(e.Color={}));var tt;(function(De){function Ae(x){return{range:u.from(x.range)}}De.from=Ae;function ge(x){return new d.SelectionRange(u.to(x.range))}De.to=ge})(tt=e.SelectionRange||(e.SelectionRange={}));var Xe;(function(De){function Ae(ge){switch(ge){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}De.to=Ae})(Xe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(De){function Ae(x){switch(x){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Ae;function ge(x){switch(x){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}De.to=ge})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var it;(function(De){function Ae(x){if(x===d.EndOfLine.CRLF)return 1;if(x===d.EndOfLine.LF)return 0}De.from=Ae;function ge(x){if(x===1)return d.EndOfLine.CRLF;if(x===0)return d.EndOfLine.LF}De.to=ge})(it=e.EndOfLine||(e.EndOfLine={}));var dt;(function(De){function Ae(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Ae})(dt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(De){function Ae(x){const Re={start:x.start+1,end:x.end+1};return x.kind&&(Re.kind=ot.from(x.kind)),Re}De.from=Ae;function ge(x){const Re={start:x.start-1,end:x.end-1};return x.kind&&(Re.kind=ot.to(x.kind)),Re}De.to=ge})(Fe=e.FoldingRange||(e.FoldingRange={}));var ot;(function(De){function Ae(x){if(x)switch(x){case d.FoldingRangeKind.Comment:return a.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return a.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return a.FoldingRangeKind.Region}}De.from=Ae;function ge(x){if(x)switch(x.value){case a.FoldingRangeKind.Comment.value:return d.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports.value:return d.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region.value:return d.FoldingRangeKind.Region}}De.to=ge})(ot=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(De){function Ae(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?u.from(ge.selection):void 0,override:typeof ge.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}De.from=Ae})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var X;(function(De){function Ae($e){return $e instanceof d.RelativePattern?$e.toJSON():typeof $e=="string"?$e:ge($e)||x($e)?new d.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}De.from=Ae;function ge($e){const Qe=$e;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function x($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Re($e){return typeof $e=="string"?$e:new d.RelativePattern(b.URI.revive($e.baseUri),$e.pattern)}De.to=Re})(X=e.GlobPattern||(e.GlobPattern={}));var ve;(function(De){function Ae(ge){if(ge){if(Array.isArray(ge))return ge.map(Ae);if(typeof ge=="string")return ge;{const x=ge;return{language:x.language,scheme:x.scheme,pattern:X.from(x.pattern),exclusive:x.exclusive,notebookType:x.notebookType}}}else return}De.from=Ae})(ve=e.LanguageSelector||(e.LanguageSelector={}));var Me;(function(De){function Ae(x){return{start:x.start,end:x.end}}De.from=Ae;function ge(x){return new d.NotebookRange(x.start,x.end)}De.to=ge})(Me=e.NotebookRange||(e.NotebookRange={}));var ze;(function(De){function Ae(x){return{timing:typeof x.runStartTime=="number"&&typeof x.runEndTime=="number"?{startTime:x.runStartTime,endTime:x.runEndTime}:void 0,executionOrder:x.executionOrder,success:x.lastRunSuccess}}De.to=Ae;function ge(x){return{lastRunSuccess:x.success,runStartTime:x.timing?.startTime,runEndTime:x.timing?.endTime,executionOrder:x.executionOrder}}De.from=ge})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var He;(function(De){function Ae(ge){if(ge===E.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(ge===E.NotebookCellExecutionState.Pending)return;if(ge===E.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}De.to=Ae})(He=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(De){function Ae(x){switch(x){case d.NotebookCellKind.Markup:return E.CellKind.Markup;case d.NotebookCellKind.Code:default:return E.CellKind.Code}}De.from=Ae;function ge(x){switch(x){case E.CellKind.Markup:return d.NotebookCellKind.Markup;case E.CellKind.Code:default:return d.NotebookCellKind.Code}}De.to=ge})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var nt;(function(De){function Ae(x){const Re={metadata:x.metadata??Object.create(null),cells:[]};for(const $e of x.cells)d.NotebookCellData.validate($e),Re.cells.push(vt.from($e));return Re}De.from=Ae;function ge(x){const Re=new d.NotebookData(x.cells.map(vt.to));return(0,h.isEmptyObject)(x.metadata)||(Re.metadata=x.metadata),Re}De.to=ge})(nt=e.NotebookData||(e.NotebookData={}));var vt;(function(De){function Ae(x){return{cellKind:Ye.from(x.kind),language:x.languageId,mime:x.mime,source:x.value,metadata:x.metadata,internalMetadata:ze.from(x.executionSummary??{}),outputs:x.outputs?x.outputs.map(Ct.from):[]}}De.from=Ae;function ge(x){return new d.NotebookCellData(Ye.to(x.cellKind),x.source,x.language,x.mime,x.outputs?x.outputs.map(Ct.to):void 0,x.metadata,x.internalMetadata?ze.to(x.internalMetadata):void 0)}De.to=ge})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(De){function Ae(x){return{mime:x.mime,valueBytes:C.VSBuffer.wrap(x.data)}}De.from=Ae;function ge(x){return new d.NotebookCellOutputItem(x.valueBytes.buffer,x.mime)}De.to=ge})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(De){function Ae(x){return{outputId:x.id,items:x.items.map(wt.from),metadata:x.metadata}}De.from=Ae;function ge(x){const Re=x.items.map(wt.to);return new d.NotebookCellOutput(Re,x.outputId,x.metadata)}De.to=ge})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var jt;(function(De){function Ae(Re){return x(Re)?{include:(0,h.withNullAsUndefined)(X.from(Re.include)),exclude:(0,h.withNullAsUndefined)(X.from(Re.exclude))}:(0,h.withNullAsUndefined)(X.from(Re))}De.from=Ae;function ge(Re){return x(Re)?{include:X.to(Re.include),exclude:X.to(Re.exclude)}:X.to(Re)}De.to=ge;function x(Re){const $e=Re;return $e?!(0,h.isUndefinedOrNull)($e.include)&&!(0,h.isUndefinedOrNull)($e.exclude):!1}})(jt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(De){function Ae(ge,x,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:x.toInternal($e,Re),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}De.from=Ae})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var mt;(function(De){function Ae(ge,x,Re){const $e=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:x.toInternal($e,Re),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}De.from=Ae})(mt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ft;(function(De){function Ae(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}De.from=Ae})(Ft=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Gt;(function(De){function Ae(x){return{uri:x.uri,provides:x.provides}}De.from=Ae;function ge(x){return new d.NotebookRendererScript(b.URI.revive(x.uri),x.provides)}De.to=ge})(Gt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Pt;(function(De){function Ae(x){return{message:O.fromStrict(x.message)||"",type:0,expected:x.expectedOutput,actual:x.actualOutput,location:x.location&&{range:u.from(x.location.range),uri:x.location.uri}}}De.from=Ae;function ge(x){const Re=new d.TestMessage(typeof x.message=="string"?x.message:O.to(x.message));return Re.actualOutput=x.actual,Re.expectedOutput=x.expected,Re.location=x.location?Te.to(x.location):void 0,Re}De.to=ge})(Pt=e.TestMessage||(e.TestMessage={}));var ht;(function(De){De.namespace=v.namespaceTestTag,De.denamespace=v.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var kt;(function(De){function Ae(x){const Re=(0,l.getPrivateApiFor)(x).controllerId;return{extId:L.TestId.fromExtHostTestItem(x,Re).toString(),label:x.label,uri:b.URI.revive(x.uri),busy:x.busy,tags:x.tags.map($e=>ht.namespace(Re,$e.id)),range:m.Range.lift(u.from(x.range)),description:x.description||null,sortText:x.sortText||null,error:x.error&&O.fromStrict(x.error)||null}}De.from=Ae;function ge(x){return{parent:void 0,error:void 0,id:L.TestId.fromString(x.extId).localId,label:x.label,uri:b.URI.revive(x.uri),tags:(x.tags||[]).map(Re=>{const{tagId:$e}=ht.denamespace(Re);return new d.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(x.range||void 0),canResolveChildren:!1,busy:x.busy,description:x.description||void 0,sortText:x.sortText||void 0}}De.toPlain=ge})(kt=e.TestItem||(e.TestItem={})),function(De){function Ae(x){return{id:x.id}}De.from=Ae;function ge(x){return new d.TestTag(x.id)}De.to=ge}(ht=e.TestTag||(e.TestTag={}));var $t;(function(De){const Ae=(x,Re)=>{const $e=[];for(const[Be,Ze]of Re)L.TestId.compare(Ze.item.extId,Be)===2&&(Re.delete(Be),$e.push(Ze));const Qe={...kt.toPlain(x.item),parent:void 0,taskStates:x.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(Ze=>Ze.type===0).map(Pt.to)})),children:$e.map(Be=>Ae(Be,Re))};for(const Be of Qe.children)Be.parent=Qe;return Qe};function ge(x){const Re=[],$e=new Map;for(const Qe of x.items){$e.set(Qe.item.extId,Qe);const Be=L.TestId.root(Qe.item.extId);x.request.targets.some(Ze=>Ze.controllerId===Be&&Ze.testIds.includes(Qe.item.extId))&&Re.push(Qe)}return{completedAt:x.completedAt,results:Re.map(Qe=>Ae(Qe,$e))}}De.to=ge})($t=e.TestResults||(e.TestResults={}));var Ot;(function(De){function Ae($e){return{covered:$e.covered,total:$e.covered}}function ge($e){return"line"in $e?p.from($e):u.from($e)}function x($e){return"branches"in $e?{count:$e.executionCount,location:ge($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&ge(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:ge($e.location)}}De.fromDetailed=x;function Re($e){return{uri:$e.uri,statement:Ae($e.statementCoverage),branch:$e.branchCoverage&&Ae($e.branchCoverage),function:$e.functionCoverage&&Ae($e.functionCoverage),details:$e.detailedCoverage?.map(x)}}De.fromFile=Re})(Ot=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(De){function Ae(ge){switch(ge){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}De.to=Ae})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(De){function Ae(x){const Re=new d.TypeHierarchyItem(ue.to(x.kind),x.name,x.detail||"",b.URI.revive(x.uri),u.to(x.range),u.to(x.selectionRange));return Re._sessionId=x._sessionId,Re._itemId=x._itemId,Re}De.to=Ae;function ge(x,Re,$e){if(Re=Re??x._sessionId,$e=$e??x._itemId,Re===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:$e,kind:ue.from(x.kind),name:x.name,detail:x.detail??"",uri:x.uri,range:u.from(x.range),selectionRange:u.from(x.selectionRange),tags:x.tags?.map(ae.from)}}De.from=ge})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(De){function Ae(ge){if(!!ge)return{value:ge.value,tooltip:ge.tooltip}}De.from=Ae})(Mt=e.ViewBadge||(e.ViewBadge={}));var zt;(function(De){function Ae($e,Qe,Be){const Ze=Qe.fileData;return Ze?new class extends d.DataTransferItem{asFile(){return{name:Ze.name,uri:b.URI.revive(Ze.uri),data:(0,M.once)(()=>Be())}}}("",Qe.id):$e===N.Mimes.uriList&&Qe.uriListData?new d.DataTransferItem(Re(Qe.uriListData)):new d.DataTransferItem(Qe.asString)}De.to=Ae;async function ge($e,Qe){const Be=await Qe.asString();if($e===N.Mimes.uriList)return{id:Qe.id,asString:Be,fileData:void 0,uriListData:x(Be)};const Ze=Qe.asFile();return{id:Qe.id,asString:Be,fileData:Ze?{name:Ze.name,uri:Ze.uri}:void 0}}De.from=ge;function x($e){return D.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Re($e){return D.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(zt=e.DataTransferItem||(e.DataTransferItem={}));var ft;(function(De){function Ae(x,Re){const $e=x.items.map(([Qe,Be])=>[Qe,zt.to(Qe,Be,()=>Re(Be.id))]);return new d.DataTransfer($e)}De.toDataTransfer=Ae;async function ge(x){const Re={items:[]},$e=[];return x.forEach((Qe,Be)=>{$e.push((async()=>{Re.items.push([Be,await zt.from(Be,Qe)])})())}),await Promise.all($e),Re}De.toDataTransferDTO=ge})(ft=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[195],ke([1,0,2,12,7,8,161]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class R{constructor(T,N,w,h={timeout:1500,errors:3}){this.c=T,this.d=N,this.f=w,this.g=h,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(N,w,h)=>{const m={dispose:this.a.push([N,w,T])};return Array.isArray(h)&&h.push(m),m}}async $participateInSave(T,N){const w=n.URI.revive(T);let h=!1;const b=setTimeout(()=>h=!0,this.g.timeout),m=[];try{for(const a of[...this.a]){if(h)break;const s=this.d.getDocument(w),l=await this.h(a,{document:s,reason:M.TextDocumentSaveReason.to(N)});m.push(l)}}finally{clearTimeout(b)}return m}h([T,N,w],h){const b=this.b.get(T);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(w,T,N,h).then(()=>!0,m=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const a=this.b.get(T);this.b.set(T,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,N,w,h){const b=[],m=Date.now(),{document:a,reason:s}=h,{version:l}=a,g=Object.freeze({document:a,reason:s,waitUntil(E){if(Object.isFrozen(b))throw(0,C.illegalState)("waitUntil can not be called async");b.push(Promise.resolve(E))}});try{N.apply(w,[g])}catch(E){return Promise.reject(E)}return Object.freeze(b),new Promise((E,L)=>{const v=setTimeout(()=>L(new Error("timeout")),this.g.timeout);return Promise.all(b).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(v),E(t)}).catch(t=>{clearTimeout(v),L(t)})}).then(E=>{const L={edits:[]};for(const v of E)if(Array.isArray(v)&&v.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:d,range:r}of v)L.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:t,eol:d&&M.EndOfLine.from(d)}});if(L.edits.length!==0)return l===a.version?this.f.$tryApplyWorkspaceEdit(L):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=R}),define(Ce[196],ke([1,0,15,2,8,7,70]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class R{constructor(w,h,b,m){this.start=w,this.deletedCount=h,this.deletedItems=b,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,h,b){this.notebook=w,this.h=h,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(D.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(D.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:D.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return w.g},set mime(m){w.g=m},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(b)}return this.f}setOutputs(w){this.a=w.map(D.NotebookCellOutput.to)}setOutputItems(w,h,b){const m=b.map(D.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===w);if(a&&(h||(a.items.length=0),a.items.push(...m),a.items.length>1&&a.items.every(s=>S.isTextStreamMime(s.mime)))){const s=new Map,l=[];a.items.forEach(g=>{let E;s.has(g.mime)?E=s.get(g.mime):(E=[],s.set(g.mime,E),l.push(g.mime)),E.push(g.data)}),a.items.length=0,l.forEach(g=>{const E=S.compressOutputItemStreams(s.get(g));a.items.push({mime:g,data:E.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(D.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class T{constructor(w,h,b,m,a){this.k=w,this.l=h,this.m=b,this.uri=m,this.handle=T.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,h={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(b){return b=w.n(b),w.b[b].apiCell},getCells(b){return(b?w.p(b):w.b).map(a=>a.apiCell)},save(){return w.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,h,b){this.g=w.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:b});const m={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},a=[];for(const l of w.rawEvents)l.kind===S.NotebookCellsChangeType.ModelChange?this.r(l.changes,!1,m.contentChanges):l.kind===S.NotebookCellsChangeType.Move?this.s(l.index,l.length,l.newIdx,m.contentChanges):l.kind===S.NotebookCellsChangeType.Output?(this.t(l.index,l.outputs),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.OutputItem?(this.u(l.index,l.outputId,l.append,l.outputItems),a.push({cell:this.b[l.index].apiCell,outputs:this.b[l.index].apiCell.outputs})):l.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(l.index,l.language),a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document})):l.kind===S.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[l.index].apiCell,document:this.b[l.index].apiCell.document}):l.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(l.index,l.mime):l.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(l.index,l.metadata),a.push({cell:this.b[l.index].apiCell,metadata:this.b[l.index].apiCell.metadata})):l.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(l.index,l.internalMetadata),a.push({cell:this.b[l.index].apiCell,executionSummary:this.b[l.index].apiCell.executionSummary}));const s=new Map;for(let l=0;l<a.length;l++){const g=a[l],E=s.get(g.cell);if(E===void 0){const L=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});s.set(g.cell,L-1)}else m.cellChanges[E]={...m.cellChanges[E],...g}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let h=w.start|0,b=w.end|0;return h<0&&(h=0),b>this.b.length&&(b=this.b.length),w.with({start:h,end:b})}p(w){w=this.o(w);const h=[];for(let b=w.start;b<w.end;b++)h.push(this.b[b]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,h,b){if(this.j)return;const m=[],a=[],s=[];if(w.reverse().forEach(l=>{const E=l[2].map(t=>{const d=new y(this,this.l,t);return h||a.push(y.asModelAddData(this.apiNotebook,t)),d}),L=new R(l[0],l[1],[],E),v=this.b.splice(l[0],l[1],...E);for(const t of v)s.push(t.uri),L.deletedItems.push(t.apiCell);m.push(L)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),b)for(const l of m)b.push(l.asApiEvent())}s(w,h,b,m){const a=this.b.splice(w,h);this.b.splice(b,0,...a);const s=[new R(w,h,a.map(l=>l.apiCell),[]),new R(b,0,[],a)];for(const l of s)m.push(l.asApiEvent())}t(w,h){this.b[w].setOutputs(h)}u(w,h,b,m){this.b[w].setOutputItems(h,b,m)}v(w,h){const b=this.b[w];b.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(b.uri,h)}w(w,h){const b=this.b[w];b.apiCell.mime=h}x(w,h){this.b[w].setMetadata(h)}y(w,h){this.b[w].setInternalMetadata(h)}getCellFromApiCell(w){return this.b.find(h=>h.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(h=>h.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}T.a=0,e.ExtHostNotebookDocument=T}),define(Ce[100],ke([1,0,12,8,7]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(R,y,T,N,w,h){this.id=R,this.f=y,this.notebookData=T,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=N,this.c=h}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(y){this.selections=[y]},get selections(){return R.a},set selections(y){if(!Array.isArray(y)||!y.every(D.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");R.a=y,R.g(y)},get visibleRanges(){return R.b},revealRange(y,T){R.f.$tryRevealRange(R.id,C.NotebookRange.from(y),T??D.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(C.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}M.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=M}),define(Ce[197],ke([1,0,4,11,8]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(R,y){this.c=R,this.d=y,this.a=new n.Emitter,this.b=new n.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,y);const T=this.d.getEditorById(R);y.visibleRanges&&T._acceptVisibleRanges(y.visibleRanges.ranges.map(D.NotebookRange.to)),y.selections&&T._acceptSelections(y.selections.selections.map(D.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const y in R)this.d.getEditorById(y)._acceptViewColumn(D.ViewColumn.to(R[y]))}};M=qe([je(0,C.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[198],ke([1,0,8,165,141,20,63,12]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(h){this.b=0,this.c=new Map,this.a=h}async withProgress(h,b,m){const a=this.b++,{title:s,location:l,cancellable:g}=b,E={label:(0,D.localize)(0,null,h.displayName||h.name),id:h.identifier.value};return this.a.$startProgress(a,{location:n.ProgressLocation.from(l),title:s,source:E,cancellable:g},h.isUnderDevelopment?void 0:h.identifier.value).catch(R.onUnexpectedExternalError),this.d(a,m,!!g)}d(h,b,m){let a;m&&(a=new M.CancellationTokenSource,this.c.set(h,a));const s=g=>{this.a.$progressEnd(g),this.c.delete(g),a?.dispose()};let l;try{l=b(new N(this.a,h),m&&a?a.token:M.CancellationToken.None)}catch(g){throw s(h),g}return l.then(g=>s(h),g=>s(h)),l}$acceptProgressCanceled(h){const b=this.c.get(h);b&&(b.cancel(),this.c.delete(h))}}e.ExtHostProgress=y;function T(w,h){return w.message=h.message,typeof h.increment=="number"&&(typeof w.increment=="number"?w.increment+=h.increment:w.increment=h.increment),w}class N extends C.Progress{constructor(h,b){super(m=>this.throttledReport(m)),this.c=h,this.d=b}throttledReport(h){this.c.$progressReport(this.d,h)}}qe([(0,S.throttle)(100,(w,h)=>T(w,h),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(Ce[101],ke([1,0,44,96,45,71,56,8,2]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(E,L,v,t)=>{let d=L;return{enumerable:!0,configurable:!1,get(){return d},set(r){if(!v(d,r)){const u=d;d=r,E.listener?.(t(r,u))}}}},N=(E,L)=>E===L,w={range:(E,L)=>E===L?!0:!E||!L?!1:E.isEqual(L),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(E,L)=>!(E.length!==L.length||E.some(v=>!L.find(t=>v.id===t.id)))},h=E=>L=>({op:4,update:E(L)}),b=(E,L)=>({range:(()=>{let v;const t=h(d=>({range:n.Range.lift(R.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return v},set(d){E.listener?.({op:6}),w.range(v,d)||(v=d,E.listener?.(t(d)))}}})(),label:T(E,L,w.label,h(v=>({label:v}))),description:T(E,void 0,w.description,h(v=>({description:v}))),sortText:T(E,void 0,w.sortText,h(v=>({sortText:v}))),canResolveChildren:T(E,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:T(E,!1,w.busy,h(v=>({busy:v}))),error:T(E,void 0,w.error,h(v=>({error:R.MarkdownString.fromStrict(v)||null}))),tags:T(E,[],w.tags,(v,t)=>({op:1,new:v.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),m=E=>{const L=D.TestId.fromString(E.extId),v=new s(L.controllerId,L.localId,E.label,y.URI.revive(E.uri)||void 0);return v.range=R.Range.to(E.range||void 0),v.description=E.description||void 0,v.sortText=E.sortText||void 0,v.tags=E.tags.map(t=>R.TestTag.to({id:(0,S.denamespaceTestTag)(t).tagId})),v},a=E=>{let L;for(const v of E.tests){const t=m(v.item);(0,C.getPrivateApiFor)(t).parent=L,L=t}return L};e.toItemFromContext=a;class s{constructor(L,v,t,d){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,C.createPrivateApiFor)(this,L);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof l?void 0:r.parent}},children:{value:(0,M.createTestItemChildren)(r,C.getPrivateApiFor,s),enumerable:!0,writable:!1},...b(r,t)})}}e.TestItemImpl=s;class l extends s{constructor(L,v){super(L,L,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=l;class g extends M.TestItemCollection{constructor(L,v,t){super({controllerId:L,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:C.getPrivateApiFor,getChildren:d=>d.children,root:new l(L,v),toITestItem:R.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[102],ke([1,0,49,12,83,8,7]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class R{constructor(h,b,m){const a=R.c.nextId();h.$registerTextEditorDecorationType(b.identifier,a,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:a,dispose(){h.$removeTextEditorDecorationType(a)}})}}R.c=new D.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=R;class y{constructor(h,b){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,b){this.k();let m=null;if(h instanceof S.Position)m=new S.Range(h,h);else if(h instanceof S.Range)m=h;else throw new Error("Unrecognized location");this.l(m,b,!1)}insert(h,b){this.k(),this.l(new S.Range(h,h),b,!0)}delete(h){this.k();let b=null;if(h instanceof S.Range)b=h;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(h,b,m){const a=this.c.validateRange(h);this.g.push({range:a,text:b,forceMoveMarkers:m})}setEndOfLine(h){if(this.k(),h!==S.EndOfLine.LF&&h!==S.EndOfLine.CRLF)throw(0,C.illegalArgument)("endOfLine");this.h=h}}class T{constructor(h,b,m,a){this.c=h,this.d=b,this._accept(m),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(l){s.m(l)},get indentSize(){return s.g},set indentSize(l){s.o(l)},get insertSpaces(){return s.h},set insertSpaces(l){s.q(l)},get cursorStyle(){return s.j},set cursorStyle(l){s.s(l)},get lineNumbers(){return s.k},set lineNumbers(l){s.t(l)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.insertSpaces,this.j=h.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(h.lineNumbers)}l(h){if(h==="auto")return"auto";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}m(h){const b=this.l(h);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const b=Math.floor(h);return b>0?b:null}if(typeof h=="string"){const b=parseInt(h,10);return isNaN(b)?null:b>0?b:null}return null}o(h){const b=this.n(h);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}q(h){const b=this.p(h);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(h){this.j!==h&&(this.j=h,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}t(h){this.k!==h&&(this.k=h,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(h)})))}assign(h){const b={};let m=!1;if(typeof h.tabSize<"u"){const a=this.l(h.tabSize);a==="auto"?(m=!0,b.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,m=!0,b.tabSize=a)}if(typeof h.indentSize<"u"){const a=this.n(h.indentSize);a==="tabSize"?(m=!0,b.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,m=!0,b.indentSize=a)}if(typeof h.insertSpaces<"u"){const a=this.p(h.insertSpaces);a==="auto"?(m=!0,b.insertSpaces=a):this.h!==a&&(this.h=a,m=!0,b.insertSpaces=a)}typeof h.cursorStyle<"u"&&this.j!==h.cursorStyle&&(this.j=h.cursorStyle,m=!0,b.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.k!==h.lineNumbers&&(this.k=h.lineNumbers,m=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(h.lineNumbers)),m&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(h,b){b.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(m)})}}e.ExtHostTextEditorOptions=T;class N{constructor(h,b,m,a,s,l,g,E){this.id=h,this.j=b,this.k=m,this.g=!1,this.h=new Set,this.c=s,this.d=new T(this.j,this.id,l,m),this.e=g,this.f=E;const L=this;this.value=Object.freeze({get document(){return a.value},set document(v){throw(0,C.readonly)("document")},get selection(){return L.c&&L.c[0]},set selection(v){if(!(v instanceof S.Selection))throw(0,C.illegalArgument)("selection");L.c=[v],L.l()},get selections(){return L.c},set selections(v){if(!Array.isArray(v)||v.some(t=>!(t instanceof S.Selection)))throw(0,C.illegalArgument)("selections");L.c=v,L.l()},get visibleRanges(){return L.e},set visibleRanges(v){throw(0,C.readonly)("visibleRanges")},get options(){return L.d.value},set options(v){L.g||L.d.assign(v)},get viewColumn(){return L.f},set viewColumn(v){throw(0,C.readonly)("viewColumn")},edit(v,t={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new y(a.value,t);return v(d),L.m(d)},insertSnippet(v,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(L.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=L.c.map(u=>M.Range.from(u));else if(t instanceof S.Position){const{lineNumber:u,column:i}=M.Position.from(t);r=[{startLineNumber:u,startColumn:i,endLineNumber:u,endColumn:i}]}else if(t instanceof S.Range)r=[M.Range.from(t)];else{r=[];for(const u of t)if(u instanceof S.Range)r.push(M.Range.from(u));else{const{lineNumber:i,column:p}=M.Position.from(u);r.push({startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p})}}return b.$tryInsertSnippet(h,a.value.version,v.value,r,d)},setDecorations(v,t){const d=t.length===0;d&&!L.h.has(v.key)||(d?L.h.delete(v.key):L.h.add(v.key),L.n(()=>{if(M.isDecorationOptionsArr(t))return b.$trySetDecorations(h,v.key,M.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let u=0,i=t.length;u<i;u++){const p=t[u];r[4*u]=p.start.line+1,r[4*u+1]=p.start.character+1,r[4*u+2]=p.end.line+1,r[4*u+3]=p.end.character+1}return b.$trySetDecorationsFast(h,v.key,r)}}))},revealRange(v,t){L.n(()=>b.$tryRevealRange(h,M.Range.from(v),t||S.TextEditorRevealType.Default))},show(v){b.$tryShowEditor(h,M.ViewColumn.from(v))},hide(){b.$tryHideEditor(h)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,n.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,n.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,n.ok)(!this.g),this.f=h}_acceptSelections(h){(0,n.ok)(!this.g),this.c=h}async l(){const h=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const b=h.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const m=b.edits.map(s=>s.range);m.sort((s,l)=>s.end.line===l.end.line?s.end.character===l.end.character?s.start.line===l.start.line?s.start.character-l.start.character:s.start.line-l.start.line:s.end.character-l.end.character:s.end.line-l.end.line);for(let s=0,l=m.length-1;s<l;s++){const g=m[s].end;if(m[s+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=b.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,a,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.ExtHostTextEditor=N}),define(Ce[199],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[200],ke([1,0,154,12,29,90,68,30,25,199,164,156]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const h=R.Registry.as(S.Extensions.JSONContribution);class b{constructor(v,t,d){this.a=v,this.b=t,this.c=d}d(v,t){this.a({type:v,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(D.default.Error,v)}warn(v){this.d(D.default.Warning,v)}info(v){this.d(D.default.Info,v)}}e.ExtensionMessageCollector=b;class m{static a(v){const t=new Set;for(let d=0,r=v.length;d<r;d++)t.add(y.ExtensionIdentifier.toKey(v[d].description.identifier));return t}static compute(v,t){if(!v||!v.length)return new m(t,[]);if(!t||!t.length)return new m([],v);const d=this.a(v),r=this.a(t),u=t.filter(p=>!d.has(y.ExtensionIdentifier.toKey(p.description.identifier))),i=v.filter(p=>!r.has(y.ExtensionIdentifier.toKey(p.description.identifier)));return new m(u,i)}constructor(v,t){this.added=v,this.removed=t}}e.ExtensionPointUserDelta=m;class a{constructor(v,t){this.name=v,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=m.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,C.onUnexpectedError)(v)}}}e.ExtensionPoint=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},l="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class g{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const t=new a(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,t),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,h.registerSchema(l,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=g;const E={ExtensionsRegistry:"ExtensionsRegistry"};R.Registry.add(E.ExtensionsRegistry,new g),e.ExtensionsRegistry=R.Registry.as(E.ExtensionsRegistry),h.registerSchema(l,e.schema),h.registerSchema(N.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(Ce[201],ke([1,0,151,9,22,200,42,4]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var T;(function(h){function b(m,a,s){if(!m)return;const l=C.isString(m.type)?m.type:void 0;if(!l||l.length===0){s.error(n.localize(3,null));return}const g=[];if(Array.isArray(m.required))for(const E of m.required)C.isString(E)&&g.push(E);return{extensionId:a.value,taskType:l,required:g,properties:m.properties?D.deepClone(m.properties):{},when:m.when?S.ContextKeyExpr.deserialize(m.when):void 0}}h.from=b})(T||(T={}));const N=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,b)=>{for(const m of h)m.type&&b.push(`onTaskType:${m.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new R.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,m)=>{N.setHandler((a,s)=>{this.c=void 0;try{for(const l of s.removed){const g=l.value;for(const E of g)this.a&&E.type&&this.a[E.type]&&delete this.a[E.type]}for(const l of s.added){const g=l.value;for(const E of g){const L=T.from(E,l.description.identifier,l.collector);L&&(this.a[L.taskType]=L)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const m of this.all()){const a={type:"object",additionalProperties:!1};m.required.length>0&&(a.required=m.required.slice(0)),m.properties!==void 0?a.properties=D.deepClone(m.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[m.taskType]},b.push(a)}this.c={oneOf:b}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Ce[202],ke([1,0,152,9,24,22,42,201]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var y;(function(P){P[P.Escape=1]="Escape",P[P.Strong=2]="Strong",P[P.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(P){function F(H){if(!H)return P.Strong;switch(H.toLowerCase()){case"escape":return P.Escape;case"strong":return P.Strong;case"weak":return P.Weak;default:return P.Strong}}P.from=F}(y=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(P){P.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var N;(function(P){P[P.Always=1]="Always",P[P.Silent=2]="Silent",P[P.Never=3]="Never"})(N=e.RevealKind||(e.RevealKind={})),function(P){function F(H){switch(H.toLowerCase()){case"always":return P.Always;case"silent":return P.Silent;case"never":return P.Never;default:return P.Always}}P.fromString=F}(N=e.RevealKind||(e.RevealKind={}));var w;(function(P){P[P.Never=1]="Never",P[P.OnProblem=2]="OnProblem",P[P.Always=3]="Always"})(w=e.RevealProblemKind||(e.RevealProblemKind={})),function(P){function F(H){switch(H.toLowerCase()){case"always":return P.Always;case"never":return P.Never;case"onproblem":return P.OnProblem;default:return P.OnProblem}}P.fromString=F}(w=e.RevealProblemKind||(e.RevealProblemKind={}));var h;(function(P){P[P.Shared=1]="Shared",P[P.Dedicated=2]="Dedicated",P[P.New=3]="New"})(h=e.PanelKind||(e.PanelKind={})),function(P){function F(H){switch(H.toLowerCase()){case"shared":return P.Shared;case"dedicated":return P.Dedicated;case"new":return P.New;default:return P.Shared}}P.fromString=F}(h=e.PanelKind||(e.PanelKind={}));var b;(function(P){P.defaults={echo:!0,reveal:N.Always,revealProblems:w.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(b=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(P){P[P.Shell=1]="Shell",P[P.Process=2]="Process",P[P.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(P){function F(j){switch(j.toLowerCase()){case"shell":return P.Shell;case"process":return P.Process;case"customExecution":return P.CustomExecution;default:return P.Process}}P.fromString=F;function H(j){switch(j){case P.Shell:return"shell";case P.Process:return"process";case P.CustomExecution:return"customExecution";default:return"process"}}P.toString=H}(m=e.RuntimeType||(e.RuntimeType={}));var a;(function(P){function F(H){return C.isString(H)?H:H.value}P.value=F})(a=e.CommandString||(e.CommandString={}));var s;(function(P){P.Clean={_id:"clean",isDefault:!1},P.Build={_id:"build",isDefault:!1},P.Rebuild={_id:"rebuild",isDefault:!1},P.Test={_id:"test",isDefault:!1};function F(j){return j===P.Clean._id||j===P.Build._id||j===P.Rebuild._id||j===P.Test._id}P.is=F;function H(j){if(j!==void 0)return C.isString(j)?F(j)?{_id:j,isDefault:!1}:void 0:j}P.from=H})(s=e.TaskGroup||(e.TaskGroup={}));var l;(function(P){P[P.Global=1]="Global",P[P.Workspace=2]="Workspace",P[P.Folder=3]="Folder"})(l=e.TaskScope||(e.TaskScope={}));var g;(function(P){P.Workspace="workspace",P.Extension="extension",P.InMemory="inMemory",P.WorkspaceFile="workspaceFile",P.User="user";function F(H){switch(H){case P.User:return 2;case P.WorkspaceFile:return 5;default:return 6}}P.toConfigurationTarget=F})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(P){P.parallel="parallel",P.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var L;(function(P){P[P.default=1]="default",P[P.folderOpen=2]="folderOpen"})(L=e.RunOnOptions||(e.RunOnOptions={}));var v;(function(P){P.defaults={reevaluateOnRerun:!0,runOn:L.default,instanceLimit:1}})(v=e.RunOptions||(e.RunOptions={}));class t{constructor(F,H,j,de,pe,re){this._label="",this._id=F,H&&(this._label=H),j&&(this.type=j),this.runOptions=de,this.configurationProperties=pe,this._source=re}getDefinition(F){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,H=!1){if(F===void 0)return!1;if(C.isString(F))return F===this._label||F===this.configurationProperties.identifier||H&&F===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class d extends t{constructor(F,H,j,de,pe,re,ue,ae){super(F,j,void 0,ue,ae,H),this.command={},this._source=H,this.hasDefinedMatchers=re,pe&&(this.command=pe)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case m.Shell:H="shell";break;case m.Process:H="process";break;case m.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.CustomTask=d;class r extends t{constructor(F,H,j,de,pe,re,ue){super(F,j,de,re,ue,H),this._source=H,this.configures=pe}static is(F){return F instanceof r}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?D.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const F=this.d();if(!F)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:F,id:H};return JSON.stringify(j)}}e.ConfiguringTask=r;class u extends t{constructor(F,H,j,de,pe,re,ue,ae,se){super(F,j,de,ae,se,H),this.defines=pe,this.hasDefinedMatchers=ue,this.command=re,this.icon=se.icon,this.hide=se.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.ContributedTask=u;class i extends t{constructor(F,H,j,de,pe,re){super(F,j,de,pe,re,H),this._source=H}clone(){return new i(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof i}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new i(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.InMemoryTask=i;var p;(function(P){P[P.Process=1]="Process",P[P.Terminal=2]="Terminal"})(p=e.ExecutionEngine||(e.ExecutionEngine={})),function(P){P._default=P.Terminal}(p=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(P){P[P.V0_1_0=1]="V0_1_0",P[P.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class o{constructor(F){this.c=new Map;for(let H=0;H<F.length;H++)this.c.set(F[H].uri.toString(),H)}compare(F,H){const j=F.getWorkspaceFolder(),de=H.getWorkspaceFolder();if(j&&de){let pe=this.c.get(j.uri.toString());pe=pe===void 0?0:pe+1;let re=this.c.get(de.uri.toString());return re=re===void 0?0:re+1,pe===re?F._label.localeCompare(H._label):pe-re}else return!j&&de?-1:j&&!de?1:0}}e.TaskSorter=o;var f;(function(P){P.DependsOnStarted="dependsOnStarted",P.AcquiredInput="acquiredInput",P.Start="start",P.ProcessStarted="processStarted",P.Active="active",P.Inactive="inactive",P.Changed="changed",P.Terminated="terminated",P.ProcessEnded="processEnded",P.End="end"})(f=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(P){P.SingleRun="singleRun",P.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var A;(function(P){P[P.System=0]="System",P[P.User=1]="User",P[P.FolderOpen=2]="FolderOpen",P[P.ConfigurationChange=3]="ConfigurationChange",P[P.Reconnect=4]="Reconnect"})(A=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(P){function F(H,j,de,pe){if(j){const re={kind:H,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:de,__task:j};return H==="start"?re.resolvedVariables=pe:H==="processStarted"?re.processId=pe:H==="processEnded"&&(re.exitCode=pe),Object.freeze(re)}else return Object.freeze({kind:"changed"})}P.create=F})(V=e.TaskEvent||(e.TaskEvent={}));var _;(function(P){function F(j){const de=Object.keys(j).sort();let pe="";for(const re of de){let ue=j[re];ue instanceof Object?ue=F(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),pe+=re+","+ue+","}return pe}function H(j){const pe={_key:F(j),type:j.taskType};return Object.assign(pe,j),pe}P.create=H})(_=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var K;(function(P){P.AutoDetect="task.autoDetect",P.SaveBeforeRun="task.saveBeforeRun",P.ShowDecorations="task.showDecorations",P.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",P.SlowProviderWarning="task.slowProviderWarning",P.QuickOpenHistory="task.quickOpen.history",P.QuickOpenDetail="task.quickOpen.detail",P.QuickOpenSkip="task.quickOpen.skip",P.QuickOpenShowAll="task.quickOpen.showAll",P.AllowAutomaticTasks="task.allowAutomaticTasks",P.Reconnection="task.reconnection"})(K=e.TaskSettingId||(e.TaskSettingId={}));var O;(function(P){P.Tasks="tasks",P.SuppressTaskName="tasks.suppressTaskName",P.Windows="tasks.windows",P.Osx="tasks.osx",P.Linux="tasks.linux",P.ShowOutput="tasks.showOutput",P.IsShellCommand="tasks.isShellCommand",P.ServiceTestSetting="tasks.service.testSetting"})(O=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(P){function F(H,j){const de=R.TaskDefinitionRegistry.get(H.type);if(de===void 0){const ae=M.deepClone(H);return delete ae._key,_.create(ae)}const pe=Object.create(null);pe.type=de.taskType;const re=new Set;de.required.forEach(ae=>re.add(ae));const ue=de.properties;for(const ae of Object.keys(ue)){const se=H[ae];if(se!=null)pe[ae]=se;else if(re.has(ae)){const Y=ue[ae];if(Y.default!==void 0)pe[ae]=M.deepClone(Y.default);else switch(Y.type){case"boolean":pe[ae]=!1;break;case"number":case"integer":pe[ae]=0;break;case"string":pe[ae]="";break;default:j.error(n.localize(2,null,JSON.stringify(H,void 0,0),ae));return}}}return _.create(pe)}P.createTaskIdentifier=F})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[203],ke([1,0,12]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,R)=>{this.b=S,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,n.onUnexpectedError)(S))}then(S,R){return this.j().then(S,R)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=C;class D extends C{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=D}),define(Ce[46],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}n.count=0,e.ProxyIdentifier=n;const C=[];function D(R){const y=new n(R);return C[y.nid]=y,y}e.createProxyIdentifier=D;function M(R){return C[R].sid}e.getStringIdentifierForProxy=M;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(Ce[5],ke([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(D=e.TabInputKind||(e.TabInputKind={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var N;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(N=e.CandidatePortSource||(e.CandidatePortSource={}));class w{static mixin(s){return s._id=w.a++,s}}w.a=0,e.IdObject=w;var h;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var b;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(b=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization")}}),define(Ce[76],ke([1,0,3,11,5,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,T){this.c=T,this.a=new Set,this.b=y.getProxy(D.MainContext.MainThreadTelemetry)}report(y,T,N){const w=this.d(y,T);this.a.has(w)||(this.a.add(w),T.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}d(y,T){return`${y}-${T.identifier.value}`}};S=qe([je(0,M.IExtHostRpcService),je(1,C.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(R,y,T){}})}),define(Ce[204],ke([1,0,4,5,7,25]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(C.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,T,N,w={}){const h=M.ExtensionIdentifier.toKey(y.identifier),b=this.f.get(h)||[],m=[...N].sort().join(" ");let a=b.find(s=>s.providerId===T&&s.scopes===m);if(a)return a.result;{const s=this.g(y,h,T,N,w);a={providerId:T,scopes:m,result:s},b.push(a),this.f.set(h,b);try{await s}finally{const l=b.findIndex(g=>g.providerId===T&&g.scopes===m);l>-1&&(b.splice(l),this.f.set(h,b))}return s}}async g(y,T,N,w,h={}){await this.a.$ensureProvider(N);const b=y.displayName||y.name;return this.a.$getSession(N,w,T,b,h)}async removeSession(y,T){const N=this.b.get(y);return N?N.provider.removeSession(T):this.a.$removeSession(y,T)}registerAuthenticationProvider(y,T,N,w){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:T,provider:N,options:w??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===y)||this.c.push({id:y,label:T});const h=N.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(y,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(y,T,w?.supportsMultipleAccounts??!1),new D.Disposable(()=>{h.dispose(),this.b.delete(y);const b=this.c.findIndex(m=>m.id===y);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const N=this.b.get(y);if(N)return Promise.resolve(N.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this.d.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ce[205],ke([1,0,5,18,8]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(R,y){this.a=R.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(R,y,T){const N=D.WorkspaceEdit.from(R,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,T?.isRefactoring??!1)}};M=qe([je(0,C.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(Ce[206],ke([1,0,5]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class C{constructor(M){const S=M.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(R){return S.$writeText(R)}})}}e.ExtHostClipboard=C});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[37],ke([1,0,9,7,8,22,5,16,11,65,44,259,2,6,3,18,101,23,46,39,77,52]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(f,k){t.set(this,void 0),this.b=new Map,this.c=new Map,d.set(this,void 0),Je(this,t,f.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=k,Je(this,d,f.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,A=>{const V=this.c.get(A);return V?.result===p.Void?V:void 0},k),this.f=[{processArgument(A){return(0,T.revive)(A)}},{processArgument(A){return(0,M.cloneAndChange)(A,function(V){if(N.Range.isIRange(V))return D.Range.to(V);if(w.Position.isIPosition(V))return D.Position.to(V);if(N.Range.isIRange(V.range)&&h.URI.isUri(V.uri))return D.location.to(V);if(V instanceof l.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const k=this.registerCommand(!1,f.id,async(...A)=>{const V=f.args.map((K,O)=>{if(!K.validate(A[O]))throw new Error(`Invalid argument '${K.name}' when running '${f.id}', received: ${A[O]}`);return K.convert(A[O])}),_=await this.executeCommand(f.internalId,...V);return f.result.convert(_,A,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new C.Disposable(()=>{k.dispose(),this.c.delete(f.id)})}registerCommand(f,k,A,V,_,K){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:A,thisArg:V,description:_,extension:K}),f&&Le(this,t,"f").$registerCommand(k),new C.Disposable(()=>{this.b.delete(k)&&f&&Le(this,t,"f").$unregisterCommand(k)})}executeCommand(f,...k){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,k,!0)}async g(f,k,A){if(this.b.has(f))return Le(this,t,"f").$fireCommandActivationEvent(f),this.h(f,k,!1);{let V=!1;const _=(0,M.cloneAndChange)(k,function(K){if(K instanceof C.Position)return D.Position.from(K);if(K instanceof C.Range)return D.Range.from(K);if(K instanceof C.Location)return D.location.from(K);if(C.NotebookRange.isNotebookRange(K))return D.NotebookRange.from(K);if(K instanceof ArrayBuffer)return V=!0,l.VSBuffer.wrap(new Uint8Array(K));if(K instanceof Uint8Array)return V=!0,l.VSBuffer.wrap(K);if(K instanceof l.VSBuffer)return V=!0,K;if(!Array.isArray(K))return K});try{const K=await Le(this,t,"f").$executeCommand(f,V?new g.SerializableObjectWithBuffers(_):_,A);return(0,T.revive)(K)}catch(K){if(K instanceof Error&&K.message==="$executeCommand:retry")return this.g(f,k,!1);throw K}}}async h(f,k,A){const V=this.b.get(f);if(!V)throw new Error("Unknown command");const{callback:_,thisArg:K,description:O}=V;if(O)for(let P=0;P<O.args.length;P++)try{(0,n.validateConstraint)(k[P],O.args[P].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${O.args[P].name}' - ${O.args[P].description}`)}const B=L.StopWatch.create();try{return await _.apply(K,k)}catch(P){if(f===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(f=F.command)}throw this.d.error(P,f,V.extension?.identifier),A?new class extends Error{constructor(){super((0,E.toErrorMessage)(P)),this.id=f,this.source=V.extension?.displayName??V.extension?.name}}:P}finally{this.j(V,f,B.elapsed())}}j(f,k,A){!f.extension||Le(this,d,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new v.TelemetryTrustedValue(k),duration:A})}$executeContributedCommand(f,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const A=this.b.get(f);return A?(k=k.map(V=>this.f.reduce((_,K)=>K.processArgument(_,A.extension?.identifier),V)),this.h(f,k,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Le(this,t,"f").$getCommands().then(k=>(f&&(k=k.filter(A=>A[0]!=="_")),k))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[k,A]of this.b){const{description:V}=A;V&&(f[k]=V)}return Promise.resolve(f)}};t=new WeakMap,d=new WeakMap,r=qe([je(0,a.IExtHostRpcService),je(1,y.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class u{constructor(f,k,A){this.d=f,this.f=k,this.g=A,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,k){if(!f)return;const A={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return A;const V=this.f(f.command);if(V)A.id=V.internalId,A.arguments=V.args.map((_,K)=>_.convert(f.arguments&&f.arguments[K]));else if((0,R.isNonEmptyArray)(f.arguments)){const _=`${f.command}/${++this.c}`;this.b.set(_,f),k.add((0,b.toDisposable)(()=>{this.b.delete(_),this.g.trace("CommandsConverter#DISPOSE",_)})),A.$ident=_,A.id=this.delegatingCommandId,A.arguments=[_],this.g.trace("CommandsConverter#CREATE",f.command,_)}return A}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const k=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=u;class i{constructor(f,k,A,V){this.name=f,this.description=k,this.validate=A,this.convert=V}optional(){return new i(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,k){return new i(f??this.name,k??this.description,this.validate,this.convert)}}i.Uri=new i("uri","Uri of a text document",o=>h.URI.isUri(o),o=>o),i.Position=new i("position","A position in a text document",o=>C.Position.isPosition(o),D.Position.from),i.Range=new i("range","A range in a text document",o=>C.Range.isRange(o),D.Range.from),i.Selection=new i("selection","A selection in a text document",o=>C.Selection.isSelection(o),D.Selection.from),i.Number=new i("number","",o=>typeof o=="number",o=>o),i.String=new i("string","",o=>typeof o=="string",o=>o),i.CallHierarchyItem=new i("item","A call hierarchy item",o=>o instanceof C.CallHierarchyItem,D.CallHierarchyItem.from),i.TypeHierarchyItem=new i("item","A type hierarchy item",o=>o instanceof C.TypeHierarchyItem,D.TypeHierarchyItem.from),i.TestItem=new i("testItem","A VS Code TestItem",o=>o instanceof s.TestItemImpl,D.TestItem.from),e.ApiCommandArgument=i;class p{constructor(f,k){this.description=f,this.convert=k}}p.Void=new p("no result",o=>o),e.ApiCommandResult=p;class c{constructor(f,k,A,V,_){this.id=f,this.internalId=k,this.description=A,this.args=V,this.result=_}}e.ApiCommand=c}),define(Ce[207],ke([1,0,2,8,7,75,37,16,88,92,15]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const w=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",b(C.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,R.isFalsyOrEmpty)(a))return;class l extends D.SymbolInformation{static to(E){const L=new l(E.name,C.SymbolKind.to(E.kind),E.containerName||"",new D.Location(s[0],C.Range.to(E.range)));return L.detail=E.detail,L.range=L.location.range,L.selectionRange=C.Range.to(E.selectionRange),L.children=E.children?E.children.map(l.to):[],L}}return a.map(l.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",a=>typeof a=="string",a=>a),new S.ApiCommandArgument("options","Formatting options",a=>!0,a=>a)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",b(C.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",b(C.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",b(C.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>D.Position.isPosition(s)),a=>a.map(C.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",a=>a.map(s=>{let l;for(const g of s.reverse())l=new D.SelectionRange(C.Range.to(g),l);return l}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(C.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(C.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(C.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(C.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",a=>{if(!!a)return{range:C.Range.to(a.range),placeholder:a.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",a=>{if(!!a){if(a.rejectReason)throw new Error(a.rejectReason);return C.WorkspaceEdit.to(a)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(C.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,y.decodeSemanticTokensDto)(a);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",a=>{if(!!a)return new D.SemanticTokensLegend(a.tokenTypes,a.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,y.decodeSemanticTokensDto)(a);if(s.type==="full")return new D.SemanticTokens(s.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(a,s,l)=>{if(!a)return new D.CompletionList([]);const g=a.suggestions.map(E=>C.CompletionItem.to(E,l));return new D.CompletionList(g,a.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",a=>{if(a)return C.SignatureHelp.to(a)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(a,s,l)=>b(g=>new D.CodeLens(C.Range.to(g.range),g.command&&l.fromInternal(g.command)))(a))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>D.Range.isRange(a),a=>D.Selection.isSelection(a)?C.Selection.from(a):C.Range.from(a)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(a,s,l)=>b(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(g.command)}else{const E=new D.CodeAction(g.title,g.kind?new D.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=C.WorkspaceEdit.to(g.edit)),g.command&&(E.command=l.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(a))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new D.ColorInformation(C.Range.to(s.range),C.Color.to(s.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",a=>a instanceof D.Color,C.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:C.Range.from(a.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(C.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(a,s,l)=>a.map(C.InlayHint.to.bind(void 0,l)))),new S.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(C.FoldingRange.to)})),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",b(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>C.NotebookExclusiveDocumentPattern.to(s))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",a=>a.map(C.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",a=>n.URI.isUri(a)||typeof a=="string"&&(0,T.matchesSomeScheme)(a,N.Schemas.http,N.Schemas.https),a=>a),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[C.ViewColumn.from(a),void 0]:[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[C.ViewColumn.from(a.viewColumn),C.TextEditorOpenOptions.from(a)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(C.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,a=>a)],S.ApiCommandResult.Void)];class h{static register(s){w.forEach(s.registerApiCommand,s)}}e.ExtHostApiCommands=h;function b(a){return s=>{if(Array.isArray(s))return s.map(a)}}function m(a){if(!Array.isArray(a))return;const s=[];for(const l of a)M.isLocationLink(l)?s.push(C.DefinitionLink.to(l)):s.push(C.location.to(l));return s}}),define(Ce[208],ke([1,0,17,63,4,6,2,75,25,8,7,5]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function h(b,m,a){const s=b.getProxy(w.MainContext.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new Map,m.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this.b.get(i.handle);return p?p.value:i}else if(i&&i.$mid===7){const p=this.b.get(i.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.commentThreadHandle);return c?c.value:i}else if(i&&(i.$mid===9||i.$mid===8)){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);return c?i.$mid===8?c.value:{thread:c.value,text:i.text}:i}else if(i&&i.$mid===10){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const o=i.commentUniqueId,f=c.getCommentByUniqueId(o);return f||i}else if(i&&i.$mid===11){const p=this.b.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;const o=i.text,f=i.commentUniqueId,k=c.getCommentByUniqueId(f);return k?(typeof k.body=="string"?k.body=o:k.body=new N.MarkdownString(o),k):i}return i}})}createCommentController(i,p,c){const o=l.a++,f=new E(i,o,p,c);this.b.set(f.handle,f);const k=this.c.get(y.ExtensionIdentifier.toKey(i.identifier))||[];return k.push(f),this.c.set(y.ExtensionIdentifier.toKey(i.identifier),k),f.value}$createCommentThreadTemplate(i,p,c){const o=this.b.get(i);!o||o.$createCommentThreadTemplate(p,c)}async $updateCommentThreadTemplate(i,p,c){const o=this.b.get(i);!o||o.$updateCommentThreadTemplate(p,c)}$deleteCommentThread(i,p){this.b.get(i)?.$deleteCommentThread(p)}$provideCommentingRanges(i,p,c){const o=this.b.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const f=a.getDocument(S.URI.revive(p));return(0,n.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(f,c)).then(k=>k?k.map(A=>T.Range.from(A)):void 0)}$toggleReaction(i,p,c,o,f){const k=this.b.get(i);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const A=k.getCommentThread(p);if(A){const V=A.getCommentByUniqueId(o.uniqueIdInThread);if(k!==void 0&&V&&k.reactionHandler)return k.reactionHandler(V,t(f))}return Promise.resolve(void 0)})}dispose(){}}l.a=0;class g{set threadId(i){this.n=i}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(i){i.isEqual(this.p)||(this.p=i,this.b.range=i,this.c.fire())}get range(){return this.p}set canReply(i){this.d!==i&&(this.d=i,this.b.canReply=i,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(i){this.e=i,this.b.label=i,this.c.fire()}get contextValue(){return this.f}set contextValue(i){this.f=i,this.b.contextValue=i,this.c.fire()}get comments(){return this.q}set comments(i){this.q=i,this.b.comments=i,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(i){this.g=i,this.b.collapsibleState=i,this.c.fire()}get state(){return this.h}set state(i){this.h=i,this.b.state=i,this.c.fire()}get isDisposed(){return this.j}constructor(i,p,c,o,f,k,A,V){this.m=p,this.n=c,this.o=o,this.p=f,this.q=k,this.extensionDescription=A,this.r=V,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new D.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.MutableDisposable,this.l.value=new M.DisposableStore,this.n===void 0&&(this.n=`${i}.${this.handle}`),s.$createCommentThread(p,this.handle,this.n,this.o,T.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{s.$deleteCommentThread(p,this.handle)}});const _=this;this.value={get uri(){return _.uri},get range(){return _.range},set range(K){_.range=K},get comments(){return _.comments},set comments(K){_.comments=K},get collapsibleState(){return _.collapsibleState},set collapsibleState(K){_.collapsibleState=K},get canReply(){return _.canReply},set canReply(K){_.canReply=K},get contextValue(){return _.contextValue},set contextValue(K){_.contextValue=K},get label(){return _.label},set label(K){_.label=K},get state(){return _.state},set state(K){_.state=K},dispose:()=>{_.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.b,c),p={};i("range")&&(p.range=T.Range.from(this.p)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this.q.map(c=>L(this,c,this.k))),i("collapsibleState")&&(p.collapseState=d(this.g)),i("canReply")&&(p.canReply=this.canReply),i("state")&&(p.state=r(this.h)),i("isTemplate")&&(p.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(i){for(const p of this.k){const c=p[0],o=p[1];if(i===o)return c}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(i=>i.dispose())}}g.a=0,qe([(0,C.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(i){this.b=i,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(i){this.c=i,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this.d}set options(i){this.d=i,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(i,p,c,o){this.f=i,this.g=p,this.h=c,this.i=o,this.a=new Map,s.$registerCommentController(this.handle,c,o);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(k){f.options=k},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(k){f.commentingRangeProvider=k},get reactionHandler(){return f.reactionHandler},set reactionHandler(k){f.reactionHandler=k},createCommentThread(k,A,V){return f.createCommentThread(k,A,V).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(i,p,c,o){if(typeof i=="string"){const f=new g(this.id,this.handle,i,p,c,o,this.f,!1);return this.a.set(f.handle,f),f}else{const f=new g(this.id,this.handle,void 0,i,p,c,this.f,!1);return this.a.set(f.handle,f),f}}$createCommentThreadTemplate(i,p){const c=new g(this.id,this.handle,void 0,S.URI.revive(i),T.Range.to(p),[],this.f,!0);return c.collapsibleState=R.CommentThreadCollapsibleState.Expanded,this.a.set(c.handle,c),c}$updateCommentThreadTemplate(i,p){const c=this.a.get(i);c&&(c.range=T.Range.to(p))}$deleteCommentThread(i){this.a.get(i)?.dispose(),this.a.delete(i)}getCommentThread(i){return this.a.get(i)}dispose(){this.a.forEach(i=>{i.dispose()}),this.e.forEach(i=>i.dispose())}}function L(u,i,p){let c=p.get(i);c||(c=++u.commentHandle,p.set(i,c));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:typeof i.body=="string"?i.body:T.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(f=>v(f)):void 0,timestamp:i.timestamp?.toJSON()}}function v(u){return{label:u.label,iconPath:u.iconPath?T.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function t(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?S.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function d(u){if(u!==void 0)switch(u){case N.CommentThreadCollapsibleState.Expanded:return R.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return R.CommentThreadCollapsibleState.Collapsed}return R.CommentThreadCollapsibleState.Collapsed}function r(u){if(u!==void 0)switch(u){case N.CommentThreadState.Unresolved:return R.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return R.CommentThreadState.Resolved}return R.CommentThreadState.Unresolved}return new l}e.createExtHostComments=h}),define(Ce[209],ke([1,0,22,5,26,18]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(N,w){this.a=N.getProxy(C.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(N,w){const h=this,b=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){h.e(N,w,b,arguments)}})}e(N,w,h,b){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(b,this.b)}),this.c&&this.f(N,h,b)}};S=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const R=1e5;function y(T,N){const w=[];if(T.length)for(let h=0;h<T.length;h++){let b=T[h];if(typeof b>"u")b="undefined";else if(b instanceof Error){const m=b;m.stack?b=m.stack:b=m.toString()}w.push(b)}if(N){const h=new Error().stack;h&&w.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,n.safeStringify)(w);return h.length>R?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Ce[103],ke([1,0,2,5,7,3,18,11,16,10,19,27]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let h=class Mi{constructor(m,a){this.h=a,this.f=new Map,this.g=m.getProxy(C.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const s=Mi.c++;this.f.set(s,{provider:m,extensionDescription:a}),this.g.$registerDecorationProvider(s,a.identifier.value);const l=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(s,null);return}const E=(0,y.asArray)(g);if(E.length<=Mi.d){this.g.$onDidChange(s,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,E.length);const L=E.map(d=>({uri:d,rank:(0,T.count)(d.path,"/")})),v=(0,y.groupBy)(L,(d,r)=>d.rank-r.rank||(0,T.compare)(d.uri.path,r.uri.path)),t=[];e:for(const d of v){let r;for(const u of d){const i=(0,N.dirname)(u.uri.path);if(r!==i&&(r=i,t.push(u.uri)>=Mi.d))break e}}this.g.$onDidChange(s,t)});return new D.Disposable(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(m,a,s){if(!this.f.has(m))return Object.create(null);const l=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(m);return await Promise.all(a.map(async L=>{try{const{uri:v,id:t}=L,d=await Promise.resolve(g.provideFileDecoration(n.URI.revive(v),s));if(!d)return;try{D.FileDecoration.validate(d),d.badge&&typeof d.badge!="string"&&(0,w.checkProposedApiEnabled)(E,"codiconDecoration"),l[t]=[d.propagate,d.tooltip,d.badge,d.color]}catch(r){this.h.warn(`INVALID decoration from extension '${E}': ${r}`)}}catch(v){this.h.error(v)}})),l}};h.c=0,h.d=250,h=qe([je(0,S.IExtHostRpcService),je(1,R.ILogService)],h),e.ExtHostDecorations=h,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[210],ke([1,0,139,91,2,5,7,8,4,11,28,36]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";var h,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class a{constructor(g,E,L,v,t,d,r){this.d=g,this.e=E,this.f=L,this.g=v,h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),this.c=!1,Je(this,m,new N.ResourceMap(u=>t.getComparisonKey(u)),"f"),Je(this,h,d,"f"),Je(this,b,r,"f")}dispose(){this.c||(Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,h,"f")?.$clear(this.e),Le(this,m,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(g,E){if(!g){this.clear();return}this.h();let L=[];if(D.URI.isUri(g)){if(!E){this.delete(g);return}Le(this,m,"f").set(g,E.slice()),L=[g]}else if(Array.isArray(g)){L=[];let t;g=[...g].sort(a.j);for(const d of g){const[r,u]=d;if((!t||r.toString()!==t.toString())&&(t&&Le(this,m,"f").get(t).length===0&&Le(this,m,"f").delete(t),t=r,L.push(r),Le(this,m,"f").set(r,[])),u)Le(this,m,"f").get(r)?.push(...u);else{const i=Le(this,m,"f").get(r);i&&(i.length=0)}}}if(Le(this,b,"f").fire(L),!Le(this,h,"f"))return;const v=[];for(const t of L){let d=[];const r=Le(this,m,"f").get(t);if(r)if(r.length>this.f){d=[];const u=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(const p of r)if(p.severity===u[i]&&d.push({...R.Diagnostic.from(p),modelVersionId:this.g(t)})===this.f)break e;d.push({severity:C.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=r.map(u=>({...R.Diagnostic.from(u),modelVersionId:this.g(t)}));v.push([t,d])}Le(this,h,"f").$changeMany(this.e,v)}delete(g){this.h(),Le(this,b,"f").fire([g]),Le(this,m,"f").delete(g),Le(this,h,"f")?.$changeMany(this.e,[[g,void 0]])}clear(){this.h(),Le(this,b,"f").fire([...Le(this,m,"f").keys()]),Le(this,m,"f").clear(),Le(this,h,"f")?.$clear(this.e)}forEach(g,E){this.h();for(const[L,v]of this)g.call(E,L,v,this)}*[(h=new WeakMap,b=new WeakMap,m=new WeakMap,Symbol.iterator)](){this.h();for(const g of Le(this,m,"f").keys())yield[g,this.get(g)]}get(g){this.h();const E=Le(this,m,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this.h(),Array.isArray(Le(this,m,"f").get(g))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=a;let s=class pi{static _mapper(g){const E=new N.ResourceMap;for(const L of g)E.set(L,L);return{uris:Object.freeze(Array.from(E.values()))}}constructor(g,E,L,v){this.h=E,this.j=L,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=g.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(g,E){const{f:L,e:v,g:t,h:d,j:r,k:u}=this,i=new class{$changeMany(o,f){v.$changeMany(o,f),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,o,f.length===0?"CLEARING":f)}$clear(o){v.$clear(o),d.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,o)}dispose(){v.dispose()}};let p;if(!E)E="_generated_diagnostic_collection_name_#"+pi.c++,p=E;else if(!L.has(E))p=E;else{this.h.warn(`DiagnosticCollection with name '${E}' does already exist.`);do p=E+pi.c++;while(L.has(p))}return new class extends a{constructor(){super(E,p,pi.d,o=>u.getDocument(o)?.version,r.extUri,i,t),L.set(p,this)}dispose(){super.dispose(),L.delete(p)}}}getDiagnostics(g){if(g)return this.l(g);{const E=new Map,L=[];for(const v of this.f.values())v.forEach((t,d)=>{let r=E.get(t.toString());typeof r>"u"&&(r=L.length,E.set(t.toString(),r),L.push([t,[]])),L[r][1]=L[r][1].concat(...d)});return L}}l(g){let E=[];for(const L of this.f.values())L.has(g)&&(E=E.concat(L.get(g)));return E}$acceptMarkersChange(g){if(!this.m){const E="_generated_mirror",L=new a(E,E,pi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(E,L),this.m=L}for(const[E,L]of g)this.m.set(D.URI.revive(E),L.map(R.Diagnostic.to))}};s.c=0,s.d=1e3,s=qe([je(1,T.ILogService),je(2,w.IExtHostFileSystemInfo)],s),e.ExtHostDiagnostics=s}),define(Ce[211],ke([1,0,2,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(S){this.a=S.getProxy(C.MainContext.MainThreadDialogs)}showOpenDialog(S){return this.a.$showOpenDialog(S).then(R=>R?R.map(y=>n.URI.revive(y)):void 0)}showSaveDialog(S){return this.a.$showSaveDialog(S).then(R=>R?n.URI.revive(R):void 0)}}e.ExtHostDialogs=D}),define(Ce[212],ke([1,0,12,2,7,5,15,20,10]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(w,h,b){this.d=h,this.e=b,this.b=new Map,this.c=w.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,h){if(Object.keys(S.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const b=T.a++;this.b.set(b,h),this.c.$registerTextContentProvider(b,w);let m;return typeof h.onDidChange=="function"&&(m=h.onDidChange(a=>{if(a.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent(b,a).then(s=>{if(!s&&typeof s!="string")return;const l=this.d.getDocument(a);if(!l)return;const g=(0,y.splitLines)(s);if(!l.equalLines(g))return this.c.$onVirtualDocumentChange(a,s)},n.onUnexpectedError)})),new D.Disposable(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(w,h){const b=this.b.get(w);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(h),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}T.a=0,e.ExtHostDocumentContentProvider=T}),define(Ce[213],ke([1,0,4,6,2,5,99,8,9,22,7]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(b,m){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.DisposableStore,this.h=new Map,this.f=b.getProxy(M.MainContext.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(a=>{for(const s of a)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const s of a)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const m=this.g.getDocument(b);if(m)return m}getDocument(b){const m=this.getDocumentData(b);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return m.document}ensureDocumentData(b){const m=this.g.getDocument(b);if(m)return Promise.resolve(m);let a=this.h.get(b.toString());return a||(a=this.f.$tryOpenDocument(b).then(s=>{this.h.delete(b.toString());const l=D.URI.revive(s);return(0,y.assertIsDefined)(this.g.getDocument(l))},s=>(this.h.delete(b.toString()),Promise.reject(s))),this.h.set(b.toString(),a)),a}createDocumentData(b){return this.f.$tryCreateDocument(b).then(m=>D.URI.revive(m))}$acceptModelLanguageChanged(b,m){const a=D.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(m),this.a.fire(s.document)}$acceptModelSaved(b){const m=D.URI.revive(b),a=this.g.getDocument(m);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(b,m){const a=D.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,m,a){const s=D.URI.revive(b),l=this.g.getDocument(s);if(!l)throw new Error("unknown document");l._acceptIsDirty(a),l.onEvents(m);let g;m.isUndoing?g=N.TextDocumentChangeReason.Undo:m.isRedoing&&(g=N.TextDocumentChangeReason.Redo),this.c.fire((0,T.deepFreeze)({document:l.document,contentChanges:m.changes.map(E=>({range:R.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(b,m){(0,S.setWordDefinitionFor)(b,m)}}e.ExtHostDocuments=w}),define(Ce[57],ke([1,0,49,4,6,2,3,5,99,18,102,8,11,28,15,185,85]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class l{constructor(L){this.value=L,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let g=class{constructor(L,v){this.h=L,this.i=v,this.a=null,this.b=new Map,this.c=new b.ResourceMap,this.d=new C.Emitter,this.e=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(L){this.acceptDocumentsAndEditorsDelta(L)}acceptDocumentsAndEditorsDelta(L){const v=[],t=[],d=[];if(L.removedDocuments)for(const r of L.removedDocuments){const u=M.URI.revive(r),i=this.c.get(u);i?.unref()&&(this.c.delete(u),v.push(i.value))}if(L.addedDocuments)for(const r of L.addedDocuments){const u=M.URI.revive(r.uri);let i=this.c.get(u);if(i&&u.scheme!==m.Schemas.vscodeNotebookCell&&u.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);i||(i=new l(new y.ExtHostDocumentData(this.h.getProxy(R.MainContext.MainThreadDocuments),u,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(u,i),t.push(i.value)),i.ref()}if(L.removedEditors)for(const r of L.removedEditors){const u=this.b.get(r);this.b.delete(r),u&&d.push(u)}if(L.addedEditors)for(const r of L.addedEditors){const u=M.URI.revive(r.documentUri);n.ok(this.c.has(u),`document '${u}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const i=this.c.get(u).value,p=new N.ExtHostTextEditor(r.id,this.h.getProxy(R.MainContext.MainThreadTextEditors),this.i,new s.Lazy(()=>i.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,p)}L.newActiveEditor!==void 0&&(n.ok(L.newActiveEditor===null||this.b.has(L.newActiveEditor),`active editor '${L.newActiveEditor}' does not exist`),this.a=L.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(d),L.removedDocuments&&this.e.fire(v),L.addedDocuments&&this.d.fire(t),(L.removedEditors||L.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),L.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(L){return this.c.get(L)?.value}allDocuments(){return a.Iterable.map(this.c.values(),L=>L.value)}getEditor(L){return this.b.get(L)}activeEditor(L){if(!this.a)return;const v=this.b.get(this.a);return L?v:v?.value}allEditors(){return[...this.b.values()]}};g=qe([je(0,T.IExtHostRpcService),je(1,h.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[58],ke([1,0,8,5,2,4,3,7,18,9,62]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class w{constructor(s,l,g){this.e=g,this.d=l,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,l={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(l)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.TextTabInput(D.URI.revive(this.b.input.uri));case 2:return new R.TextDiffTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified));case 3:return new R.TextMergeTabInput(D.URI.revive(this.b.input.base),D.URI.revive(this.b.input.input1),D.URI.revive(this.b.input.input2),D.URI.revive(this.b.input.result));case 6:return new R.CustomEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.WebviewEditorTabInput(this.b.input.viewType);case 4:return new R.NotebookEditorTabInput(D.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.NotebookDiffEditorTabInput(D.URI.revive(this.b.input.original),D.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.TerminalEditorTabInput;case 9:return new R.InteractiveWindowInput(D.URI.revive(this.b.input.uri),D.URI.revive(this.b.input.inputBoxUri));default:return}}}class h{constructor(s,l){this.c=[],this.d="",this.b=s,this.e=l;for(const g of s.tabs)g.isActive&&(this.d=g.id),this.c.push(new w(g,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,l={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return n.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(g=>g.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(g=>g.apiObject))}};this.a=Object.freeze(l)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const g=new w(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,g),s.tabDto.isActive&&(this.d=g.tabId),g}else if(s.kind===1){const g=this.c.splice(s.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return g.tabId===this.d&&(this.d=""),g}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this.c.splice(s.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,g),g}const l=this.c.find(g=>g.tabId===s.tabDto.id);if(!l)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),l.acceptDtoUpdate(s.tabDto),l}activeTabId(){return this.d}}let b=class{constructor(s){this.b=new M.Emitter,this.c=new M.Emitter,this.e=[],this.a=s.getProxy(C.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,l={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(g=>g.apiObject))},get activeTabGroup(){const g=s.d;return(0,T.assertIsDefined)(s.e.find(L=>L.groupId===g)?.apiObject)},close:async(g,E)=>{const L=Array.isArray(g)?g:[g];return L.length?m(L[0])?this.j(L,E):this.i(L,E):!0}};this.f=Object.freeze(l)}return this.f}$acceptEditorTabModel(s){const l=new Set(this.e.map(r=>r.groupId)),g=new Set(s.map(r=>r.groupId)),E=(0,N.diffSets)(l,g),L=this.e.filter(r=>E.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],t=[];this.e=s.map(r=>{const u=new h(r,()=>this.d);return E.added.includes(u.groupId)?v.push(u.apiObject):t.push(u.apiObject),u});const d=(0,T.assertIsDefined)(s.find(r=>r.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:v,closed:L,changed:t}))}$acceptTabGroupUpdate(s){const l=this.e.find(g=>g.groupId===s.groupId);if(!l)throw new Error("Update Group IPC call received before group creation.");l.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[l.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const l=this.e.find(E=>E.groupId===s.groupId);if(!l)throw new Error("Update Tabs IPC call received before group creation.");const g=l.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}g(s){for(const l of this.e)for(const g of l.tabs)if(g.apiObject===s)return g}h(s){return this.e.find(l=>l.apiObject===s)}async i(s,l){const g=[];for(const E of s){const L=this.g(E);if(!L)throw new Error("Tab close: Invalid tab not found!");g.push(L.tabId)}return this.a.$closeTab(g,l)}async j(s,l){const g=[];for(const E of s){const L=this.h(E);if(!L)throw new Error("Group close: Invalid group not found!");g.push(L.groupId)}return this.a.$closeGroup(g,l)}};b=qe([je(0,y.IExtHostRpcService)],b),e.ExtHostEditorTabs=b;function m(a){return a.tabs!==void 0}}),define(Ce[214],ke([1,0,2,5,6,7,8,260,10,23,27]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const a=this.a.indexOf(m);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),a=[];let s,l,g=14,E=14;for(const L of m){let v=s?(0,y.commonPrefixLength)(s,L):0;for(v===0?l=1:l=E;v<L.length;v++)v+1===L.length?(g=E,E=9):E+=1,a.push([l,L.toUpperCase().charCodeAt(v),E]),a.push([l,L.toLowerCase().charCodeAt(v),E]),l=E;s=L,E=g}a.push([9,58,10]),a.push([10,47,12]),this.b=new R.StateMachine(a)}}provideDocumentLinks(m){this.c();const a=[],s=R.LinkComputer.computeLinks({getLineContent(l){return m.lineAt(l-1).text},getLineCount(){return m.lineCount}},this.b);for(const l of s){const g=S.DocumentLink.to(l);g.target&&a.push(g)}return a}}class h{constructor(m,a){this.i=a,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(C.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,a,s,l={}){if(this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const g=this.h++;this.b.add(a),this.d.add(a),this.c.set(g,s);let E=2;l.isCaseSensitive&&(E+=1024),l.isReadonly&&(E+=2048),typeof s.copy=="function"&&(E+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,N.checkProposedApiEnabled)(m,"fsChunks"),E+=4),this.a.$registerFileSystemProvider(g,a,E).catch(v=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${a}`),console.error(v)});const L=s.onDidChangeFile(v=>{const t=[];for(const d of v){const{uri:r,type:u}=d;if(r.scheme!==a)continue;let i;switch(u){case M.FileChangeType.Changed:i=0;break;case M.FileChangeType.Created:i=1;break;case M.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:i})}this.a.$onFileSystemChange(g,t)});return(0,D.toDisposable)(()=>{L.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(m){const{type:a,ctime:s,mtime:l,size:g,permissions:E}=m;return{type:a,ctime:s,mtime:l,size:g,permissions:E}}$stat(m,a){return Promise.resolve(this.k(m).stat(n.URI.revive(a))).then(s=>h.j(s))}$readdir(m,a){return Promise.resolve(this.k(m).readDirectory(n.URI.revive(a)))}$readFile(m,a){return Promise.resolve(this.k(m).readFile(n.URI.revive(a))).then(s=>T.VSBuffer.wrap(s))}$writeFile(m,a,s,l){return Promise.resolve(this.k(m).writeFile(n.URI.revive(a),s.buffer,l))}$delete(m,a,s){return Promise.resolve(this.k(m).delete(n.URI.revive(a),s))}$rename(m,a,s,l){return Promise.resolve(this.k(m).rename(n.URI.revive(a),n.URI.revive(s),l))}$copy(m,a,s,l){const g=this.k(m);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(n.URI.revive(a),n.URI.revive(s),l))}$mkdir(m,a){return Promise.resolve(this.k(m).createDirectory(n.URI.revive(a)))}$watch(m,a,s,l){const g=this.k(m).watch(n.URI.revive(s),l);this.f.set(a,g)}$unwatch(m,a){const s=this.f.get(a);s&&(s.dispose(),this.f.delete(a))}$open(m,a,s){const l=this.k(m);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(n.URI.revive(a),s))}$close(m,a){const s=this.k(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(a))}$read(m,a,s,l){const g=this.k(m);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=T.VSBuffer.alloc(l);return Promise.resolve(g.read(a,s,E.buffer,0,l)).then(L=>E.slice(0,L))}$write(m,a,s,l){const g=this.k(m);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(a,s,l.buffer,0,l.byteLength))}k(m){const a=this.c.get(m);if(!a){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return a}}e.ExtHostFileSystem=h}),define(Ce[59],ke([1,0,5,43,7,23,3,18,36,6]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class _t{constructor(h,b){this.b=new Map,this.a=h.getProxy(n.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(a){try{const s=m.b.get(a.scheme);if(!s)return await m.a.$stat(a);await m.a.$ensureActivation(a.scheme);const l=await s.stat(a);return{type:l.type,ctime:l.ctime,mtime:l.mtime,size:l.size,permissions:l.permissions}}catch(s){_t.c(s)}},async readDirectory(a){try{const s=m.b.get(a.scheme);return s?(await m.a.$ensureActivation(a.scheme),(await s.readDirectory(a)).slice()):await m.a.$readdir(a)}catch(s){return _t.c(s)}},async createDirectory(a){try{return await m.a.$mkdir(a)}catch(s){return _t.c(s)}},async readFile(a){try{const s=m.b.get(a.scheme);return s?(await m.a.$ensureActivation(a.scheme),(await s.readFile(a)).slice()):(await m.a.$readFile(a)).buffer}catch(s){return _t.c(s)}},async writeFile(a,s){try{return await m.a.$writeFile(a,M.VSBuffer.wrap(s))}catch(l){return _t.c(l)}},async delete(a,s){try{const l=m.b.get(a.scheme);return l?(await m.a.$ensureActivation(a.scheme),await l.delete(a,{recursive:!1,...s})):await m.a.$delete(a,{recursive:!1,useTrash:!1,...s})}catch(l){return _t.c(l)}},async rename(a,s,l){try{return await m.a.$rename(a,s,{overwrite:!1,...l})}catch(g){return _t.c(g)}},async copy(a,s,l){try{return await m.a.$copy(a,s,{overwrite:!1,...l})}catch(g){return _t.c(g)}},isWritableFileSystem(a){const s=b.getCapabilities(a);if(typeof s=="number")return!(s&2048)}})}static c(h){if(h instanceof D.FileSystemError)throw h;if(!(h instanceof Error))throw new D.FileSystemError(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw D.FileSystemError.Unavailable(h.message);switch(h.name){case C.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(h.message);case C.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(h.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(h.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(h.message);case C.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(h.message);case C.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(h.message);default:throw new D.FileSystemError(h.message,h.name)}}addFileSystemProvider(h,b){return this.b.set(h,b),(0,T.toDisposable)(()=>this.b.delete(h))}};N=qe([je(0,R.IExtHostRpcService),je(1,y.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[215],ke([1,0,4,35,2,5,8,7]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(w,h,b,m,a,s,l,g){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const E=this.h(w,b,a);this.g=0,s&&(this.g+=1),l&&(this.g+=2),g&&(this.g+=4);const L=(0,C.parse)(a),v=typeof a=="string",t=m(d=>{if(!s)for(const r of d.created){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.a.fire(u)}if(!l)for(const r of d.changed){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.b.fire(u)}if(!g)for(const r of d.deleted){const u=D.URI.revive(r);L(u.fsPath)&&(!v||h.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=R.Disposable.from(E,this.a,this.b,this.c,t)}h(w,h,b){const m=R.Disposable.from();if(typeof b=="string")return m;const a=w.getProxy(M.MainContext.MainThreadFileSystem);let s=!1;(b.pattern.includes(C.GLOBSTAR)||b.pattern.includes(C.GLOB_SPLIT))&&(s=!0);const l=Math.random();return a.$watch(h.identifier.value,l,b.baseUri,{recursive:s,excludes:[]}),R.Disposable.from({dispose:()=>a.$unwatch(l)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class T{constructor(w,h,b){this.j=w,this.k=h,this.l=b,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,h,b,m,a,s){return new y(this.j,w,h,this.a.event,S.GlobPattern.from(b),m,a,s)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,h){switch(w){case 2:this.b.fire(Object.freeze({files:h.map(b=>({oldUri:D.URI.revive(b.source),newUri:D.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:h.map(b=>D.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:h.map(b=>D.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,h){return(b,m,a)=>{const s=function(g){b.call(m,g)};return s.extension=w,h.event(s,void 0,a)}}async $onWillRunFileOperation(w,h,b,m){switch(w){case 2:return await this.n(this.g,{files:h.map(a=>({oldUri:D.URI.revive(a.source),newUri:D.URI.revive(a.target)}))},b,m);case 1:return await this.n(this.i,{files:h.map(a=>D.URI.revive(a.target))},b,m);case 0:case 3:return await this.n(this.h,{files:h.map(a=>D.URI.revive(a.target))},b,m)}}async n(w,h,b,m){const a=new Set,s=[];if(await w.fireAsync(h,m,async(g,E)=>{const L=Date.now(),v=await Promise.resolve(g);v instanceof R.WorkspaceEdit&&(s.push([E.extension,v]),a.add(E.extension.displayName??E.extension.identifier.value)),Date.now()-L>b&&this.k.warn("SLOW file-participant",E.extension.identifier)}),m.isCancellationRequested||s.length===0)return;const l={edits:[]};for(const[,g]of s){const{edits:E}=S.WorkspaceEdit.from(g,{getTextDocumentVersion:L=>this.l.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}});l.edits=l.edits.concat(E)}return{edit:l,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=T}),define(Ce[216],ke([1,0,2,37]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(S,R,y,T,N){this.a=R,this.b=y,this.c=T;const w=new C.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.ApiCommandArgument("showOptions","Show Options",h=>!0,h=>h),new C.ApiCommandArgument("resource","Interactive resource Uri",h=>!0,h=>h),new C.ApiCommandArgument("controllerId","Notebook controller Id",h=>!0,h=>h),new C.ApiCommandArgument("title","Interactive editor title",h=>!0,h=>h)],new C.ApiCommandResult("Notebook and input URI",h=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const b=this.a.getEditorById(h.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri),notebookEditor:b.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:n.URI.revive(h.notebookUri),inputUri:n.URI.revive(h.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(S,R,y,T){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=D}),define(Ce[217],ke([1,0,6,5]),function(te,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(S){this.b=0,this.a=S.getProxy(C.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,S),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.ExtHostLabelService=D}),define(Ce[218],ke([1,0,2,22,8,7,75,5,10,44,16,9,261,20,6,88,83,54,77,12,17,27]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class t{constructor(I,$){this.d=I,this.e=$}async provideDocumentSymbols(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentSymbols(W,$);if(!(0,N.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(D.DocumentSymbol.from):t.f(q)}static f(I){I=I.slice(0).sort((q,ee)=>{let me=q.location.range.start.compareTo(ee.location.range.start);return me===0&&(me=ee.location.range.end.compareTo(q.location.range.end)),me});const $=[],W=[];for(const q of I){const ee={name:q.name||"!!MISSING: name!!",kind:D.SymbolKind.from(q.kind),tags:q.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:D.Range.from(q.location.range),selectionRange:D.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),$.push(ee);break}const me=W[W.length-1];if(T.Range.containsRange(me.range,ee.range)&&!T.Range.equalsRange(me.range,ee.range)){me.children?.push(ee),W.push(ee);break}W.pop()}}return $}}class d{constructor(I,$,W){this.g=I,this.h=$,this.j=W,this.e=new l.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(I,$){const W=this.g.getDocument(I),q=await this.j.provideCodeLenses(W,$);if(!q||$.isCancellationRequested)return;const ee=this.e.add(q),me=new m.DisposableStore;this.f.set(ee,me);const ye={cacheId:ee,lenses:[]};for(let ce=0;ce<q.length;ce++)ye.lenses.push({cacheId:[ee,ce],range:D.Range.from(q[ce].range),command:this.h.toInternal(q[ce].command,me)});return ye}async resolveCodeLens(I,$){const W=I.cacheId&&this.e.get(...I.cacheId);if(!W)return;let q;if(typeof this.j.resolveCodeLens!="function"||W.isResolved?q=W:q=await this.j.resolveCodeLens(W,$),q||(q=W),$.isCancellationRequested)return;const ee=I.cacheId&&this.f.get(I.cacheId[0]);if(!!ee)return I.command=this.h.toInternal(q.command??d.d,ee),I}releaseCodeLenses(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}}d.d={command:"missing",title:"!!MISSING: command!!"};function r(J){return Array.isArray(J)?J.map(D.DefinitionLink.from):J?[D.DefinitionLink.from(J)]:[]}class u{constructor(I,$){this.d=I,this.e=$}async provideDefinition(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideDefinition(q,ee,W);return r(me)}}class i{constructor(I,$){this.d=I,this.e=$}async provideDeclaration(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideDeclaration(q,ee,W);return r(me)}}class p{constructor(I,$){this.d=I,this.e=$}async provideImplementation(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideImplementation(q,ee,W);return r(me)}}class c{constructor(I,$){this.d=I,this.e=$}async provideTypeDefinition(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideTypeDefinition(q,ee,W);return r(me)}}class o{constructor(I,$){this.d=I,this.e=$}async provideHover(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideHover(q,ee,W);if(!(!me||(0,N.isFalsyOrEmpty)(me.contents)))return me.range||(me.range=q.getWordRangeAtPosition(ee)),me.range||(me.range=new M.Range(ee,ee)),D.Hover.from(me)}}class f{constructor(I,$){this.d=I,this.e=$}async provideEvaluatableExpression(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideEvaluatableExpression(q,ee,W);if(me)return D.EvaluatableExpression.from(me)}}class k{constructor(I,$){this.d=I,this.e=$}async provideInlineValues(I,$,W,q){const ee=this.d.getDocument(I),me=await this.e.provideInlineValues(ee,D.Range.to($),D.InlineValueContext.to(W),q);if(Array.isArray(me))return me.map(ye=>D.InlineValue.from(ye))}}class A{constructor(I,$){this.d=I,this.e=$}async provideDocumentHighlights(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideDocumentHighlights(q,ee,W);if(Array.isArray(me))return me.map(D.DocumentHighlight.from)}}class V{constructor(I,$){this.d=I,this.e=$}async provideLinkedEditingRanges(I,$,W){const q=this.d.getDocument(I),ee=D.Position.to($),me=await this.e.provideLinkedEditingRanges(q,ee,W);if(me&&Array.isArray(me.ranges))return{ranges:(0,N.coalesce)(me.ranges.map(D.Range.from)),wordPattern:me.wordPattern}}}class _{constructor(I,$){this.d=I,this.e=$}async provideReferences(I,$,W,q){const ee=this.d.getDocument(I),me=D.Position.to($),ye=await this.e.provideReferences(ee,me,W,q);if(Array.isArray(ye))return ye.map(D.location.from)}}class K{constructor(I,$,W,q,ee,me,ye){this.g=I,this.h=$,this.j=W,this.k=q,this.l=ee,this.m=me,this.n=ye,this.e=new l.Cache("CodeAction"),this.f=new Map}async provideCodeActions(I,$,W,q){const ee=this.g.getDocument(I),me=h.Selection.isISelection($)?D.Selection.to($):D.Range.to($),ye=[];for(const tt of this.j.getDiagnostics(I))if(me.intersection(tt.range)&&ye.push(tt)>K.d)break;const ce={diagnostics:ye,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:D.CodeActionTriggerKind.to(W.trigger)},be=await this.k.provideCodeActions(ee,me,ce,q);if(!(0,N.isNonEmptyArray)(be)||q.isCancellationRequested)return;const Ee=this.e.add(be),We=new m.DisposableStore;this.f.set(Ee,We);const Ve=[];for(let tt=0;tt<be.length;tt++){const Xe=be[tt];!Xe||(K.o(Xe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ve.push({_isSynthetic:!0,title:Xe.title,command:this.h.toInternal(Xe,We)})):(ce.only&&(Xe.kind?ce.only.contains(Xe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ce.only.value} 'requested but returned code action is of kind '${Xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ve.push({cacheId:[Ee,tt],title:Xe.title,command:Xe.command&&this.h.toInternal(Xe.command,We),diagnostics:Xe.diagnostics&&Xe.diagnostics.map(D.Diagnostic.from),edit:Xe.edit&&D.WorkspaceEdit.from(Xe.edit,void 0),kind:Xe.kind&&Xe.kind.value,isPreferred:Xe.isPreferred,disabled:Xe.disabled?.reason})))}return{cacheId:Ee,actions:Ve}}async resolveCodeAction(I,$){const[W,q]=I,ee=this.e.get(W,q);if(!ee||K.o(ee)||!this.k.resolveCodeAction)return;const me=await this.k.resolveCodeAction(ee,$)??ee;return me?.edit?D.WorkspaceEdit.from(me.edit,void 0):void 0}releaseCodeActions(I){this.f.get(I)?.dispose(),this.f.delete(I),this.e.delete(I)}static o(I){return typeof I.command=="string"&&typeof I.title=="string"}}K.d=1e3;class O{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async prepareDocumentPaste(I,$,W,q){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(I),me=$.map(ce=>D.Range.to(ce)),ye=D.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this.f.prepareDocumentPaste(ee,me,ye,q),D.DataTransfer.toDataTransferDTO(ye)}async providePasteEdits(I,$,W,q,ee){const me=this.e.getDocument($),ye=W.map(Ee=>D.Range.to(Ee)),ce=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolvePasteFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentPasteEdits(me,ye,ce,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class B{constructor(I,$){this.d=I,this.e=$}async provideDocumentFormattingEdits(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentFormattingEdits(q,$,W);if(Array.isArray(ee))return ee.map(D.TextEdit.from)}}class P{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeFormattingEdits(I,$,W,q){const ee=this.d.getDocument(I),me=D.Range.to($),ye=await this.e.provideDocumentRangeFormattingEdits(ee,me,W,q);if(Array.isArray(ye))return ye.map(D.TextEdit.from)}}class F{constructor(I,$){this.d=I,this.e=$,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,$,W,q,ee){const me=this.d.getDocument(I),ye=D.Position.to($),ce=await this.e.provideOnTypeFormattingEdits(me,ye,W,q,ee);if(Array.isArray(ce))return ce.map(D.TextEdit.from)}}class H{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,$){const W=await this.e.provideWorkspaceSymbols(I,$);if(!(0,N.isNonEmptyArray)(W))return{symbols:[]};const q=this.d.add(W),ee={cacheId:q,symbols:[]};for(let me=0;me<W.length;me++){const ye=W[me];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...D.WorkspaceSymbol.from(ye),cacheId:[q,me]})}return ee}async resolveWorkspaceSymbol(I,$){if(typeof this.e.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this.d.get(...I.cacheId);if(W){const q=await this.e.resolveWorkspaceSymbol(W,$);return q&&(0,C.mixin)(I,D.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(I){this.d.delete(I)}}class j{static supportsResolving(I){return typeof I.prepareRename=="function"}constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideRenameEdits(I,$,W,q){const ee=this.d.getDocument(I),me=D.Position.to($);try{const ye=await this.e.provideRenameEdits(ee,me,W,q);return ye?D.WorkspaceEdit.from(ye):void 0}catch(ye){const ce=j.g(ye);return ce?{rejectReason:ce,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(I,$,W){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(I),ee=D.Position.to($);try{const me=await this.e.prepareRename(q,ee,W);let ye,ce;if(M.Range.isRange(me)?(ye=me,ce=q.getText(me)):(0,w.isObject)(me)&&(ye=me.range,ce=me.placeholder),!ye||!ce)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(ye),text:ce}}catch(me){const ye=j.g(me);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(me)}}static g(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class de{constructor(I,$){this.resultId=I,this.tokens=$}}class pe{constructor(I,$){this.f=I,this.g=$,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(I,$,W){const q=this.f.getDocument(I),ee=$!==0?this.d.get($):null;let me=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ee.resultId,W):await this.g.provideDocumentSemanticTokens(q,W);return ee&&this.d.delete($),me?(me=pe.h(me),this.o(pe.n(ee,me),me)):null}async releaseDocumentSemanticColoring(I){this.d.delete(I)}static h(I){return pe.j(I)?pe.k(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):pe.l(I)?pe.m(I)?I:new M.SemanticTokensEdits(I.edits.map($=>new M.SemanticTokensEdit($.start,$.deleteCount,$.data?new Uint32Array($.data):$.data)),I.resultId):I}static j(I){return I&&!!I.data}static k(I){return I.data instanceof Uint32Array}static l(I){return I&&Array.isArray(I.edits)}static m(I){for(const $ of I.edits)if(!($.data instanceof Uint32Array))return!1;return!0}static n(I,$){if(!pe.j($)||!I||!I.tokens)return $;const W=I.tokens,q=W.length,ee=$.data,me=ee.length;let ye=0;const ce=Math.min(q,me);for(;ye<ce&&W[ye]===ee[ye];)ye++;if(ye===q&&ye===me)return new M.SemanticTokensEdits([],$.resultId);let be=0;const Ee=ce-ye;for(;be<Ee&&W[q-be-1]===ee[me-be-1];)be++;return new M.SemanticTokensEdits([{start:ye,deleteCount:q-ye-be,data:ee.subarray(ye,me-be)}],$.resultId)}o(I,$){if(pe.j(I)){const W=this.e++;return this.d.set(W,new de(I.resultId,I.data)),(0,a.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(pe.l(I)){const W=this.e++;return pe.j($)?this.d.set(W,new de($.resultId,$.data)):this.d.set(W,new de(I.resultId)),(0,a.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class re{constructor(I,$){this.d=I,this.e=$}async provideDocumentRangeSemanticTokens(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideDocumentRangeSemanticTokens(q,D.Range.to($),W);return ee?this.f(ee):null}f(I){return(0,a.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}class ue{static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}constructor(I,$,W,q,ee){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ee,this.d=new l.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(I,$,W,q){const ee=this.f.getDocument(I),me=D.Position.to($),ye=ee.getWordRangeAtPosition(me)||new M.Range(me,me),ce=ye.with({end:me}),be=new g.StopWatch(!0),Ee=await this.h.provideCompletionItems(ee,me,q,D.CompletionContext.to(W));if(!Ee||q.isCancellationRequested)return;const We=Array.isArray(Ee)?new M.CompletionList(Ee):Ee,Ve=ue.supportsResolving(this.h)?this.d.add(We.items):this.d.add([]),tt=new m.DisposableStore;this.e.set(Ve,tt);const Xe=[],et={x:Ve,b:Xe,a:{replace:D.Range.from(ye),insert:D.Range.from(ce)},c:We.isIncomplete||void 0,d:be.elapsed()};for(let it=0;it<We.items.length;it++){const dt=We.items[it],Fe=this.l(dt,[Ve,it],ce,ye);Xe.push(Fe)}return et}async resolveCompletionItem(I,$){if(typeof this.h.resolveCompletionItem!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveCompletionItem(W,$);if(!!q)return this.l(q,I)}releaseCompletionItems(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$,W,q){const ee=this.e.get($[0]);if(!ee)throw Error("DisposableStore is missing...");const me=this.g.toInternal(I.command,ee),ye={x:$,a:I.label,b:I.kind!==void 0?D.CompletionItemKind.from(I.kind):void 0,m:I.tags&&I.tags.map(D.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:D.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters?.join(""),l:I.additionalTextEdits&&I.additionalTextEdits.map(D.TextEdit.from),n:me?.$ident,o:me?.id,p:me?.$ident?void 0:me?.arguments};I.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=I.textEdit.newText):typeof I.insertText=="string"?ye.h=I.insertText:I.insertText instanceof M.SnippetString&&(ye.h=I.insertText.value,ye.i|=4);let ce;return I.textEdit?ce=I.textEdit.range:I.range&&(ce=I.range),M.Range.isRange(ce)?ye.j=D.Range.from(ce):ce&&(!W?.isEqual(ce.inserting)||!q?.isEqual(ce.replacing))&&(ye.j={insert:D.Range.from(ce.inserting),replace:D.Range.from(ce.replacing)}),ye}}class ae{async provideInlineCompletions(I,$,W,q){}disposeCompletions(I){}handleDidShowCompletionItem(I,$){}handlePartialAccept(I,$,W){}}class se extends ae{constructor(I,$,W,q){super(),this.f=I,this.g=$,this.h=W,this.j=q,this.d=new Y,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(I,$,W,q){const ee=this.g.getDocument(I),me=D.Position.to($),ye=await this.h.provideInlineCompletionItems(ee,me,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:D.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[W.triggerKind]},q);if(!ye||q.isCancellationRequested)return;const ce=Array.isArray(ye)?ye:ye.items,be=this.e?Array.isArray(ye)?[]:ye.commands||[]:[];let Ee;return{pid:this.d.createReferenceId({dispose(){Ee?.dispose()},items:ce}),items:ce.map((Ve,tt)=>{let Xe;Ve.command&&(Ee||(Ee=new m.DisposableStore),Xe=this.j.toInternal(Ve.command,Ee));const et=Ve.insertText;return{insertText:typeof et=="string"?et:{snippet:et.value},filterText:Ve.filterText,range:Ve.range?D.Range.from(Ve.range):void 0,command:Xe,idx:tt,completeBracketPairs:this.e?Ve.completeBracketPairs:!1}}),commands:be.map(Ve=>(Ee||(Ee=new m.DisposableStore),this.j.toInternal(Ve,Ee)))}}disposeCompletions(I){this.d.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,$){const W=this.d.get(I)?.items[$];W&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(W)}handlePartialAccept(I,$,W){const q=this.d.get(I)?.items[$];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,W)}}class Y{constructor(){this.d=new Map,this.e=1}createReferenceId(I){const $=this.e++;return this.d.set($,I),$}disposeReferenceId(I){const $=this.d.get(I);return this.d.delete(I),$}get(I){return this.d.get(I)}}class G{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("SignatureHelp")}async provideSignatureHelp(I,$,W,q){const ee=this.e.getDocument(I),me=D.Position.to($),ye=this.g(W),ce=await this.f.provideSignatureHelp(ee,me,q,ye);if(ce){const be=this.d.add([ce]);return{...D.SignatureHelp.from(ce),id:be}}}g(I){let $;if(I.activeSignatureHelp){const W=D.SignatureHelp.to(I.activeSignatureHelp),q=this.d.get(I.activeSignatureHelp.id,0);q?($=q,$.activeSignature=W.activeSignature,$.activeParameter=W.activeParameter):$=W}return{...I,activeSignatureHelp:$}}releaseSignatureHelp(I){this.d.delete(I)}}class Z{constructor(I,$,W,q,ee){this.f=I,this.g=$,this.h=W,this.j=q,this.k=ee,this.d=new l.Cache("InlayHints"),this.e=new Map}async provideInlayHints(I,$,W){const q=this.f.getDocument(I),ee=D.Range.to($),me=await this.h.provideInlayHints(q,ee,W);if(!Array.isArray(me)||me.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${$}`);return}if(W.isCancellationRequested)return;const ye=this.d.add(me);this.e.set(ye,new m.DisposableStore);const ce={hints:[],cacheId:ye};for(let be=0;be<me.length;be++)this.l(me[be],ee)&&ce.hints.push(this.m(me[be],[ye,be]));return this.j.trace(`[InlayHints] ${ce.hints.length} inlay hints from '${this.k.identifier.value}' for ${$}`),ce}async resolveInlayHint(I,$){if(typeof this.h.resolveInlayHint!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.h.resolveInlayHint(W,$);if(!!q&&!!this.l(q))return this.m(q,I)}releaseHints(I){this.e.get(I)?.dispose(),this.e.delete(I),this.d.delete(I)}l(I,$){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!($&&!$.contains(I.position))}m(I,$){const W=this.e.get($[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:$,tooltip:D.MarkdownString.fromStrict(I.tooltip),position:D.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(D.TextEdit.from),kind:I.kind&&D.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?q.label=I.label:q.label=I.label.map(ee=>{const me={label:ee.value};return me.tooltip=D.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(me.location=D.location.from(ee.location)),ee.command&&(me.command=this.g.toInternal(ee.command,W)),me}),q}}class he{constructor(I,$){this.e=I,this.f=$,this.d=new l.Cache("DocumentLink")}async provideLinks(I,$){const W=this.e.getDocument(I),q=await this.f.provideDocumentLinks(W,$);if(!(!Array.isArray(q)||q.length===0)&&!$.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(he.g).map(D.DocumentLink.from)};{const ee=this.d.add(q),me={links:[],cacheId:ee};for(let ye=0;ye<q.length;ye++){if(!he.g(q[ye]))continue;const ce=D.DocumentLink.from(q[ye]);ce.cacheId=[ee,ye],me.links.push(ce)}return me}}}static g(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,$){if(typeof this.f.resolveDocumentLink!="function")return;const W=this.d.get(...I);if(!W)return;const q=await this.f.resolveDocumentLink(W,$);if(!(!q||!he.g(q)))return D.DocumentLink.from(q)}releaseLinks(I){this.d.delete(I)}}class Te{constructor(I,$){this.d=I,this.e=$}async provideColors(I,$){const W=this.d.getDocument(I),q=await this.e.provideDocumentColors(W,$);return Array.isArray(q)?q.map(me=>({color:D.Color.from(me.color),range:D.Range.from(me.range)})):[]}async provideColorPresentations(I,$,W){const q=this.d.getDocument(I),ee=D.Range.to($.range),me=D.Color.to($.color),ye=await this.e.provideColorPresentations(me,{document:q,range:ee},W);if(!!Array.isArray(ye))return ye.map(D.ColorPresentation.from)}}class Ne{constructor(I,$){this.d=I,this.e=$}async provideFoldingRanges(I,$,W){const q=this.d.getDocument(I),ee=await this.e.provideFoldingRanges(q,$,W);if(!!Array.isArray(ee))return ee.map(D.FoldingRange.from)}}class Ke{constructor(I,$,W){this.d=I,this.e=$,this.f=W}async provideSelectionRanges(I,$,W){const q=this.d.getDocument(I),ee=$.map(D.Position.to),me=await this.e.provideSelectionRanges(q,ee,W);if(!(0,N.isNonEmptyArray)(me))return[];if(me.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ce=0;ce<ee.length;ce++){const be=[];ye.push(be);let Ee=ee[ce],We=me[ce];for(;;){if(!We.range.contains(Ee))throw new Error("INVALID selection range, must contain the previous range");if(be.push(D.SelectionRange.from(We)),!We.parent)break;Ee=We.range,We=We.parent}}return ye}}class Pe{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ee=D.Position.to($),me=await this.g.prepareCallHierarchy(q,ee,W);if(!me)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(me)?me.map(ce=>this.h(ye,ce)):[this.h(ye,me)]}async provideCallsTo(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(q,W);if(!!ee)return ee.map(me=>({from:this.h(I,me.from),fromRanges:me.fromRanges.map(ye=>D.Range.from(ye))}))}async provideCallsFrom(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(q,W);if(!!ee)return ee.map(me=>({to:this.h(I,me.to),fromRanges:me.fromRanges.map(ye=>D.Range.from(ye))}))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.CallHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Se{constructor(I,$){this.f=I,this.g=$,this.d=new s.IdGenerator(""),this.e=new Map}async prepareSession(I,$,W){const q=this.f.getDocument(I),ee=D.Position.to($),me=await this.g.prepareTypeHierarchy(q,ee,W);if(!me)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(me)?me.map(ce=>this.h(ye,ce)):[this.h(ye,me)]}async provideSupertypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(q,W);if(!!ee)return ee.map(me=>this.h(I,me))}async provideSubtypes(I,$,W){const q=this.j(I,$);if(!q)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(q,W);if(!!ee)return ee.map(me=>this.h(I,me))}releaseSession(I){this.e.delete(I)}h(I,$){const W=this.e.get(I),q=D.TypeHierarchyItem.from($,I,W.size.toString(36));return W.set(q._itemId,$),q}j(I,$){return this.e.get(I)?.get($)}}class Ie{constructor(I,$,W,q){this.d=I,this.e=$,this.f=W,this.g=q}async provideDocumentOnDropEdits(I,$,W,q,ee){const me=this.e.getDocument($),ye=D.Position.to(W),ce=D.DataTransfer.toDataTransfer(q,async Ee=>(await this.d.$resolveDocumentOnDropFileData(this.g,I,Ee)).buffer),be=await this.f.provideDocumentDropEdits(me,ye,ce,ee);if(!!be)return{insertText:typeof be.insertText=="string"?be.insertText:{snippet:be.insertText.value},additionalEdit:be.additionalEdit?D.WorkspaceEdit.from(be.additionalEdit,void 0):void 0}}}class oe{constructor(I,$){this.adapter=I,this.extension=$}}class le{constructor(I,$,W,q,ee,me,ye,ce){this.g=$,this.h=W,this.j=q,this.k=ee,this.l=me,this.m=ye,this.n=ce,this.f=new Map,this.e=I.getProxy(R.MainContext.MainThreadLanguageFeatures)}o(I){return D.DocumentSelector.from(I,this.g)}p(I){return new M.Disposable(()=>{this.f.delete(I),this.e.$unregister(I)})}q(){return le.d++}async s(I,$,W,q,ee,me=!1){const ye=this.f.get(I);if(!ye||!(ye.adapter instanceof $))return q;const ce=Date.now();me||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const be=W(ye.adapter,ye.extension);return Promise.resolve(be).catch(Ee=>{(0,E.isCancellationError)(Ee)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(Ee),this.n.onExtensionError(ye.extension.identifier,Ee))}).finally(()=>{me||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ce}ms`)}),b.CancellationToken.isCancellationToken(ee)?(0,L.raceCancellationError)(be,ee):be}t(I,$){const W=this.q();return this.f.set(W,new oe(I,$)),W}static u(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,$,W,q){const ee=this.t(new t(this.h,W),I),me=q&&q.label||le.u(I);return this.e.$registerDocumentSymbolProvider(ee,this.o($),me),this.p(ee)}$provideDocumentSymbols(I,$,W){return this.s(I,t,q=>q.provideDocumentSymbols(n.URI.revive($),W),void 0,W)}registerCodeLensProvider(I,$,W){const q=this.q(),ee=typeof W.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new oe(new d(this.h,this.j.converter,W),I)),this.e.$registerCodeLensSupport(q,this.o($),ee);let me=this.p(q);if(ee!==void 0){const ye=W.onDidChangeCodeLenses(ce=>this.e.$emitCodeLensEvent(ee));me=M.Disposable.from(me,ye)}return me}$provideCodeLenses(I,$,W){return this.s(I,d,q=>q.provideCodeLenses(n.URI.revive($),W),void 0,W)}$resolveCodeLens(I,$,W){return this.s(I,d,q=>q.resolveCodeLens($,W),void 0,void 0)}$releaseCodeLenses(I,$){this.s(I,d,W=>Promise.resolve(W.releaseCodeLenses($)),void 0,void 0)}registerDefinitionProvider(I,$,W){const q=this.t(new u(this.h,W),I);return this.e.$registerDefinitionSupport(q,this.o($)),this.p(q)}$provideDefinition(I,$,W,q){return this.s(I,u,ee=>ee.provideDefinition(n.URI.revive($),W,q),[],q)}registerDeclarationProvider(I,$,W){const q=this.t(new i(this.h,W),I);return this.e.$registerDeclarationSupport(q,this.o($)),this.p(q)}$provideDeclaration(I,$,W,q){return this.s(I,i,ee=>ee.provideDeclaration(n.URI.revive($),W,q),[],q)}registerImplementationProvider(I,$,W){const q=this.t(new p(this.h,W),I);return this.e.$registerImplementationSupport(q,this.o($)),this.p(q)}$provideImplementation(I,$,W,q){return this.s(I,p,ee=>ee.provideImplementation(n.URI.revive($),W,q),[],q)}registerTypeDefinitionProvider(I,$,W){const q=this.t(new c(this.h,W),I);return this.e.$registerTypeDefinitionSupport(q,this.o($)),this.p(q)}$provideTypeDefinition(I,$,W,q){return this.s(I,c,ee=>ee.provideTypeDefinition(n.URI.revive($),W,q),[],q)}registerHoverProvider(I,$,W,q){const ee=this.t(new o(this.h,W),I);return this.e.$registerHoverProvider(ee,this.o($)),this.p(ee)}$provideHover(I,$,W,q){return this.s(I,o,ee=>ee.provideHover(n.URI.revive($),W,q),void 0,q)}registerEvaluatableExpressionProvider(I,$,W,q){const ee=this.t(new f(this.h,W),I);return this.e.$registerEvaluatableExpressionProvider(ee,this.o($)),this.p(ee)}$provideEvaluatableExpression(I,$,W,q){return this.s(I,f,ee=>ee.provideEvaluatableExpression(n.URI.revive($),W,q),void 0,q)}registerInlineValuesProvider(I,$,W,q){const ee=typeof W.onDidChangeInlineValues=="function"?this.q():void 0,me=this.t(new k(this.h,W),I);this.e.$registerInlineValuesProvider(me,this.o($),ee);let ye=this.p(me);if(ee!==void 0){const ce=W.onDidChangeInlineValues(be=>this.e.$emitInlineValuesEvent(ee));ye=M.Disposable.from(ye,ce)}return ye}$provideInlineValues(I,$,W,q,ee){return this.s(I,k,me=>me.provideInlineValues(n.URI.revive($),W,q,ee),void 0,ee)}registerDocumentHighlightProvider(I,$,W){const q=this.t(new A(this.h,W),I);return this.e.$registerDocumentHighlightProvider(q,this.o($)),this.p(q)}$provideDocumentHighlights(I,$,W,q){return this.s(I,A,ee=>ee.provideDocumentHighlights(n.URI.revive($),W,q),void 0,q)}registerLinkedEditingRangeProvider(I,$,W){const q=this.t(new V(this.h,W),I);return this.e.$registerLinkedEditingRangeProvider(q,this.o($)),this.p(q)}$provideLinkedEditingRanges(I,$,W,q){return this.s(I,V,async ee=>{const me=await ee.provideLinkedEditingRanges(n.URI.revive($),W,q);if(me)return{ranges:me.ranges,wordPattern:me.wordPattern?le.w(me.wordPattern):void 0}},void 0,q)}registerReferenceProvider(I,$,W){const q=this.t(new _(this.h,W),I);return this.e.$registerReferenceSupport(q,this.o($)),this.p(q)}$provideReferences(I,$,W,q,ee){return this.s(I,_,me=>me.provideReferences(n.URI.revive($),W,q,ee),void 0,ee)}registerCodeActionProvider(I,$,W,q){const ee=new m.DisposableStore,me=this.t(new K(this.h,this.j.converter,this.k,W,this.l,I,this.m),I);return this.e.$registerQuickFixSupport(me,this.o($),{providedKinds:q?.providedCodeActionKinds?.map(ye=>ye.value),documentation:q?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},le.u(I),Boolean(W.resolveCodeAction)),ee.add(this.p(me)),ee}$provideCodeActions(I,$,W,q,ee){return this.s(I,K,me=>me.provideCodeActions(n.URI.revive($),W,q,ee),void 0,ee)}$resolveCodeAction(I,$,W){return this.s(I,K,q=>q.resolveCodeAction($,W),void 0,void 0)}$releaseCodeActions(I,$){this.s(I,K,W=>Promise.resolve(W.releaseCodeActions($)),void 0,void 0)}registerDocumentFormattingEditProvider(I,$,W){const q=this.t(new B(this.h,W),I);return this.e.$registerDocumentFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentFormattingEdits(I,$,W,q){return this.s(I,B,ee=>ee.provideDocumentFormattingEdits(n.URI.revive($),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(I,$,W){const q=this.t(new P(this.h,W),I);return this.e.$registerRangeFormattingSupport(q,this.o($),I.identifier,I.displayName||I.name),this.p(q)}$provideDocumentRangeFormattingEdits(I,$,W,q,ee){return this.s(I,P,me=>me.provideDocumentRangeFormattingEdits(n.URI.revive($),W,q,ee),void 0,ee)}registerOnTypeFormattingEditProvider(I,$,W,q){const ee=this.t(new F(this.h,W),I);return this.e.$registerOnTypeFormattingSupport(ee,this.o($),q,I.identifier),this.p(ee)}$provideOnTypeFormattingEdits(I,$,W,q,ee,me){return this.s(I,F,ye=>ye.provideOnTypeFormattingEdits(n.URI.revive($),W,q,ee,me),void 0,me)}registerWorkspaceSymbolProvider(I,$){const W=this.t(new H($,this.l),I);return this.e.$registerNavigateTypeSupport(W,typeof $.resolveWorkspaceSymbol=="function"),this.p(W)}$provideWorkspaceSymbols(I,$,W){return this.s(I,H,q=>q.provideWorkspaceSymbols($,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,$,W){return this.s(I,H,q=>q.resolveWorkspaceSymbol($,W),void 0,void 0)}$releaseWorkspaceSymbols(I,$){this.s(I,H,W=>W.releaseWorkspaceSymbols($),void 0,void 0)}registerRenameProvider(I,$,W){const q=this.t(new j(this.h,W,this.l),I);return this.e.$registerRenameSupport(q,this.o($),j.supportsResolving(W)),this.p(q)}$provideRenameEdits(I,$,W,q,ee){return this.s(I,j,me=>me.provideRenameEdits(n.URI.revive($),W,q,ee),void 0,ee)}$resolveRenameLocation(I,$,W,q){return this.s(I,j,ee=>ee.resolveRenameLocation(n.URI.revive($),W,q),void 0,q)}registerDocumentSemanticTokensProvider(I,$,W,q){const ee=this.t(new pe(this.h,W),I),me=typeof W.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o($),q,me);let ye=this.p(ee);if(me){const ce=W.onDidChangeSemanticTokens(be=>this.e.$emitDocumentSemanticTokensEvent(me));ye=M.Disposable.from(ye,ce)}return ye}$provideDocumentSemanticTokens(I,$,W,q){return this.s(I,pe,ee=>ee.provideDocumentSemanticTokens(n.URI.revive($),W,q),null,q)}$releaseDocumentSemanticTokens(I,$){this.s(I,pe,W=>W.releaseDocumentSemanticColoring($),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,$,W,q){const ee=this.t(new re(this.h,W),I);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o($),q),this.p(ee)}$provideDocumentRangeSemanticTokens(I,$,W,q){return this.s(I,re,ee=>ee.provideDocumentRangeSemanticTokens(n.URI.revive($),W,q),null,q)}registerCompletionItemProvider(I,$,W,q){const ee=this.t(new ue(this.h,this.j.converter,W,this.m,I),I);return this.e.$registerCompletionsProvider(ee,this.o($),q,ue.supportsResolving(W),`${I.identifier.value}(${q.join("")})`),this.p(ee)}$provideCompletionItems(I,$,W,q,ee){return this.s(I,ue,me=>me.provideCompletionItems(n.URI.revive($),W,q,ee),void 0,ee)}$resolveCompletionItem(I,$,W){return this.s(I,ue,q=>q.resolveCompletionItem($,W),void 0,W)}$releaseCompletionItems(I,$){this.s(I,ue,W=>W.releaseCompletionItems($),void 0,void 0)}registerInlineCompletionsProvider(I,$,W){const q=new se(I,this.h,W,this.j.converter),ee=this.t(q,I);return this.e.$registerInlineCompletionsSupport(ee,this.o($),q.supportsHandleEvents),this.p(ee)}$provideInlineCompletions(I,$,W,q,ee){return this.s(I,ae,me=>me.provideInlineCompletions(n.URI.revive($),W,q,ee),void 0,ee)}$handleInlineCompletionDidShow(I,$,W){this.s(I,ae,async q=>{q.handleDidShowCompletionItem($,W)},void 0,void 0)}$handleInlineCompletionPartialAccept(I,$,W,q){this.s(I,ae,async ee=>{ee.handlePartialAccept($,W,q)},void 0,void 0)}$freeInlineCompletionsList(I,$){this.s(I,ae,async W=>{W.disposeCompletions($)},void 0,void 0)}registerSignatureHelpProvider(I,$,W,q){const ee=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,me=this.t(new G(this.h,W),I);return this.e.$registerSignatureHelpProvider(me,this.o($),ee),this.p(me)}$provideSignatureHelp(I,$,W,q,ee){return this.s(I,G,me=>me.provideSignatureHelp(n.URI.revive($),W,q,ee),void 0,ee)}$releaseSignatureHelp(I,$){this.s(I,G,W=>W.releaseSignatureHelp($),void 0,void 0)}registerInlayHintsProvider(I,$,W){const q=typeof W.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Z(this.h,this.j.converter,W,this.l,I),I);this.e.$registerInlayHintsProvider(ee,this.o($),typeof W.resolveInlayHint=="function",q,le.u(I));let me=this.p(ee);if(q!==void 0){const ye=W.onDidChangeInlayHints(ce=>this.e.$emitInlayHintsEvent(q));me=M.Disposable.from(me,ye)}return me}$provideInlayHints(I,$,W,q){return this.s(I,Z,ee=>ee.provideInlayHints(n.URI.revive($),W,q),void 0,q)}$resolveInlayHint(I,$,W){return this.s(I,Z,q=>q.resolveInlayHint($,W),void 0,W)}$releaseInlayHints(I,$){this.s(I,Z,W=>W.releaseHints($),void 0,void 0)}registerDocumentLinkProvider(I,$,W){const q=this.t(new he(this.h,W),I);return this.e.$registerDocumentLinkProvider(q,this.o($),typeof W.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(I,$,W){return this.s(I,he,q=>q.provideLinks(n.URI.revive($),W),void 0,W,$.scheme==="output")}$resolveDocumentLink(I,$,W){return this.s(I,he,q=>q.resolveLink($,W),void 0,void 0,!0)}$releaseDocumentLinks(I,$){this.s(I,he,W=>W.releaseLinks($),void 0,void 0,!0)}registerColorProvider(I,$,W){const q=this.t(new Te(this.h,W),I);return this.e.$registerDocumentColorProvider(q,this.o($)),this.p(q)}$provideDocumentColors(I,$,W){return this.s(I,Te,q=>q.provideColors(n.URI.revive($),W),[],W)}$provideColorPresentations(I,$,W,q){return this.s(I,Te,ee=>ee.provideColorPresentations(n.URI.revive($),W,q),void 0,q)}registerFoldingRangeProvider(I,$,W){const q=this.q(),ee=typeof W.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new oe(new Ne(this.h,W),I)),this.e.$registerFoldingRangeProvider(q,this.o($),I.identifier,ee);let me=this.p(q);if(ee!==void 0){const ye=W.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));me=M.Disposable.from(me,ye)}return me}$provideFoldingRanges(I,$,W,q){return this.s(I,Ne,ee=>ee.provideFoldingRanges(n.URI.revive($),W,q),void 0,q)}registerSelectionRangeProvider(I,$,W){const q=this.t(new Ke(this.h,W,this.l),I);return this.e.$registerSelectionRangeProvider(q,this.o($)),this.p(q)}$provideSelectionRanges(I,$,W,q){return this.s(I,Ke,ee=>ee.provideSelectionRanges(n.URI.revive($),W,q),[],q)}registerCallHierarchyProvider(I,$,W){const q=this.t(new Pe(this.h,W),I);return this.e.$registerCallHierarchyProvider(q,this.o($)),this.p(q)}$prepareCallHierarchy(I,$,W,q){return this.s(I,Pe,ee=>Promise.resolve(ee.prepareSession(n.URI.revive($),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(I,$,W,q){return this.s(I,Pe,ee=>ee.provideCallsTo($,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(I,$,W,q){return this.s(I,Pe,ee=>ee.provideCallsFrom($,W,q),void 0,q)}$releaseCallHierarchy(I,$){this.s(I,Pe,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerTypeHierarchyProvider(I,$,W){const q=this.t(new Se(this.h,W),I);return this.e.$registerTypeHierarchyProvider(q,this.o($)),this.p(q)}$prepareTypeHierarchy(I,$,W,q){return this.s(I,Se,ee=>Promise.resolve(ee.prepareSession(n.URI.revive($),W,q)),void 0,q)}$provideTypeHierarchySupertypes(I,$,W,q){return this.s(I,Se,ee=>ee.provideSupertypes($,W,q),void 0,q)}$provideTypeHierarchySubtypes(I,$,W,q){return this.s(I,Se,ee=>ee.provideSubtypes($,W,q),void 0,q)}$releaseTypeHierarchy(I,$){this.s(I,Se,W=>Promise.resolve(W.releaseSession($)),void 0,void 0)}registerDocumentOnDropEditProvider(I,$,W){const q=this.q();return this.f.set(q,new oe(new Ie(this.e,this.h,W,q),I)),this.e.$registerDocumentOnDropEditProvider(q,this.o($)),this.p(q)}$provideDocumentOnDropEdits(I,$,W,q,ee,me){return this.s(I,Ie,ye=>Promise.resolve(ye.provideDocumentOnDropEdits($,n.URI.revive(W),q,ee,me)),void 0,void 0)}registerDocumentPasteEditProvider(I,$,W,q){const ee=this.q();return this.f.set(ee,new oe(new O(this.e,this.h,W,ee),I)),this.e.$registerPasteEditProvider(ee,this.o($),!!W.prepareDocumentPaste,q.pasteMimeTypes),this.p(ee)}$prepareDocumentPaste(I,$,W,q,ee){return this.s(I,O,me=>me.prepareDocumentPaste(n.URI.revive($),W,q,ee),void 0,ee)}$providePasteEdits(I,$,W,q,ee,me){return this.s(I,O,ye=>ye.providePasteEdits($,n.URI.revive(W),q,ee,me),void 0,me)}static w(I){return{pattern:I.source,flags:(0,y.regExpFlags)(I)}}static y(I){return{decreaseIndentPattern:le.w(I.decreaseIndentPattern),increaseIndentPattern:le.w(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?le.w(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?le.w(I.unIndentedLinePattern):void 0}}static z(I){return{beforeText:le.w(I.beforeText),afterText:I.afterText?le.w(I.afterText):void 0,previousLineText:I.previousLineText?le.w(I.previousLineText):void 0,action:I.action}}static B(I){return I.map(le.z)}setLanguageConfiguration(I,$,W){const{wordPattern:q}=W;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor($,q):this.h.setWordDefinitionFor($,void 0),W.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const ee=this.q(),me={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?le.w(W.wordPattern):void 0,indentationRules:W.indentationRules?le.y(W.indentationRules):void 0,onEnterRules:W.onEnterRules?le.B(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this.e.$setLanguageConfiguration(ee,$,me),this.p(ee)}$setWordDefinitions(I){for(const $ of I)this.h.setWordDefinitionFor($.languageId,new RegExp($.regexSource,$.regexFlags))}}le.d=0,e.ExtHostLanguageFeatures=le}),define(Ce[219],ke([1,0,5,8,7,29,17,6]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(N,w,h,b){this.c=w,this.d=h,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=N.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this.b=N}async getLanguages(){return this.b.slice(0)}async changeLanguage(N,w){await this.a.$changeLanguage(N,w);const h=this.c.getDocumentData(N);if(!h)throw new Error(`document '${N.toString()}' NOT found`);return h.document}async tokenAtPosition(N,w){const h=N.version,b=C.Position.from(w),m=await this.a.$tokensAtPosition(N.uri,b),a={type:D.StandardTokenType.Other,range:N.getWordRangeAtPosition(w)??new D.Range(w.line,w.character,w.line,w.character)};if(!m)return a;const s={range:C.Range.to(m.range),type:C.TokenType.to(m.type)};return!s.range.contains(w)||h!==N.version?a:s}createLanguageStatusItem(N,w,h){const b=this.f++,m=this.a,a=this.g,s=`${N.identifier.value}/${w}`;if(a.has(s))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);a.add(s);const l={selector:h,id:w,name:N.displayName??N.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new R.DisposableStore,L=()=>{g?.dispose(),g=(0,S.disposableTimeout)(()=>{E.clear(),this.a.$setLanguageStatus(b,{id:s,name:l.name??N.displayName??N.name,source:N.displayName??N.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===D.LanguageStatusSeverity.Error?M.default.Error:l.severity===D.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:l.command&&this.d.toInternal(l.command,E),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},v={dispose(){E.dispose(),g?.dispose(),m.$removeLanguageStatus(b),a.delete(s)},get id(){return l.id},get name(){return l.name},set name(t){l.name=t,L()},get selector(){return l.selector},set selector(t){l.selector=t,L()},get text(){return l.text},set text(t){l.text=t,L()},get detail(){return l.detail},set detail(t){l.detail=t,L()},get severity(){return l.severity},set severity(t){l.severity=t,L()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(t){l.accessibilityInformation=t,L()},get command(){return l.command},set command(t){l.command=t,L()},get busy(){return l.busy},set busy(t){l.busy=t,L()}};return L(),v}}e.ExtHostLanguages=y}),define(Ce[78],ke([1,0,21,10,2,3,11,5,26,18]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let N=class{constructor(h,b,m){this.f=m,this.d=new Map,this.a=b.getProxy(R.MainContext.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(h,b){const{message:m,args:a,comment:s}=b;if(this.c)return(0,C.format2)(m,a??{});let l=m;s&&s.length>0&&(l+=`/${Array.isArray(s)?s.join(""):s}`);const g=this.d.get(h)?.contents[l];return g||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${l}`),(0,C.format2)(g??m,a??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let b;const m=await this.g(h);if(!m){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(m),s=JSON.parse(a);b=h.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${h.identifier.value} from ${m}: ${a.message}`);return}b&&this.d.set(h.identifier.value,{contents:b,uri:m})}async g(h){if(h.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(h.identifier.value);return D.URI.revive(b)}return h.l10n?D.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};N=qe([je(0,y.IExtHostInitDataService),je(1,T.IExtHostRpcService),je(2,S.ILogService)],N),e.ExtHostLocalizationService=N,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(Ce[220],ke([1,0,11,5,26,18,2,65]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends n.AbstractLoggerService{constructor(w,h){super(h.logLevel,h.loggers.map(b=>(0,R.revive)(b))),this.l=w.getProxy(C.MainContext.MainThreadLogger)}$setLogLevel(w,h){h?this.setLogLevel(S.URI.revive(h),w):this.setLogLevel(w)}setVisibility(w,h){super.setVisibility(w,h),this.l.$setVisibility(w,h)}k(w,h,b){return new T(this.l,w,h,b)}};y=qe([je(0,M.IExtHostRpcService),je(1,D.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class T extends n.AbstractMessageLogger{constructor(w,h,b,m){super(m?.logLevel==="always"),this.m=w,this.n=h,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(h,m).then(()=>{this.r(this.l),this.k=!0})}g(w,h){const b=[[w,h]];this.k?this.r(b):this.l.push(...b)}r(w){this.m.$log(this.n,w)}}}),define(Ce[221],ke([1,0,5,11,27]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(R){return R&&R.title}let S=class{constructor(y,T){this.b=T,this.a=y.getProxy(n.MainContext.MainThreadMessageService)}showMessage(y,T,N,w,h){const b={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof w=="string"||M(w)?m=[w,...h]:(b.modal=w?.modal,b.useCustom=w?.useCustom,b.detail=w?.detail,m=h),b.useCustom&&(0,D.checkProposedApiEnabled)(y,"resolvers");const a=[];for(let s=0;s<m.length;s++){const l=m[s];if(typeof l=="string")a.push({title:l,handle:s,isCloseAffordance:!1});else if(typeof l=="object"){const{title:g,isCloseAffordance:E}=l;a.push({title:g,isCloseAffordance:!!E,handle:s})}else this.b.warn("Invalid message item:",l)}return this.a.$showMessage(T,N,b,a).then(s=>{if(typeof s=="number")return m[s]})}};S=qe([je(1,C.ILogService)],S),e.ExtHostMessageService=S}),define(Ce[222],ke([1,0,23,4,6,28,10,9,2,54,5,37,8,7,46,196,100]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class l{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,L,v,t){this.q=v,this.r=t,this.f=new Map,this.g=new M.ResourceMap,this.h=new Map,this.j=new C.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new C.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new C.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new T.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=E.getProxy(N.MainContext.MainThreadNotebook),this.c=E.getProxy(N.MainContext.MainThreadNotebookDocuments),this.d=E.getProxy(N.MainContext.MainThreadNotebookEditors),this.i=L.converter,L.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const r=d.notebookEditor?.notebookUri,u=d.cell.handle,p=this.g.get(r)?.getCell(u);if(p)return p.apiCell}if(d&&d.$mid===14){const r=d.uri,u=this.g.get(r);if(u)return u.apiNotebook}return d}}),l.x(L)}getEditorById(E){const L=this.h.get(E);if(!L)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return L}getIdByEditor(E){for(const[L,v]of this.h)if(v.apiEditor===E)return L}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,L){const v=this.g.get(E);if(!v&&!L)throw new Error(`NO notebook document for '${E}'`);return v}static s(E,L){if(!L)return;const v=L.filenamePattern.map(t=>h.NotebookExclusiveDocumentPattern.from(t)).filter(t=>t!==void 0);if(L.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${L.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:L.displayName,filenamePattern:v,exclusive:L.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,L,v){const t=l.a++,d=typeof v.onDidChangeCellStatusBarItems=="function"?l.a++:void 0;this.f.set(t,v),this.b.$registerNotebookCellStatusBarItemProvider(t,d,L);let r;return d!==void 0&&(r=v.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(d))),new b.Disposable(()=>{this.f.delete(t),this.b.$unregisterNotebookCellStatusBarItemProvider(t,d),r?.dispose()})}async createNotebookDocument(E){const L=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&h.NotebookData.from(E.content)});return y.URI.revive(L)}async openNotebookDocument(E){const L=this.g.get(E);if(L)return L.apiNotebook;const v=await this.c.$tryOpenNotebook(E),t=this.g.get(y.URI.revive(v));return(0,R.assertIsDefined)(t?.apiNotebook)}async showNotebookDocument(E,L){y.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let v;typeof L=="object"?v={position:h.ViewColumn.from(L.viewColumn),preserveFocus:L.preserveFocus,selections:L.selections&&L.selections.map(h.NotebookRange.from),pinned:typeof L.preview=="boolean"?!L.preview:void 0}:v={preserveFocus:!1};const t=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,v),d=t&&this.h.get(t)?.apiEditor;if(d)return d;throw t?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,L,v,t){const d=this.f.get(E),r=y.URI.revive(L),u=this.g.get(r);if(!u||!d)return;const i=u.getCellFromIndex(v);if(!i)return;const p=await d.provideCellStatusBarItems(i.apiCell,t);if(!p)return;const c=new D.DisposableStore,o=this.p.add([c]),k=(Array.isArray(p)?p:[p]).map(A=>h.NotebookStatusBarItem.from(A,this.i,c));return{cacheId:o,items:k}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,L,v,t,d){if((0,S.isFalsyOrWhitespace)(L))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,v),this.b.$registerNotebookSerializer(r,{id:E.identifier,location:E.extensionLocation},L,h.NotebookDocumentContentOptions.from(t),l.s(E,d)),(0,D.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(E,L,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.deserializeNotebook(L.buffer,v);return new m.SerializableObjectWithBuffers(h.NotebookData.from(d))}async $notebookToData(E,L,v){const t=this.u.get(E);if(!t)throw new Error("NO serializer found");const d=await t.serializeNotebook(h.NotebookData.to(L.value),v);return n.VSBuffer.wrap(d)}w(E,L,v){if(this.h.has(L))throw new Error(`editor with id ALREADY EXSIST: ${L}`);const t=new s.ExtHostNotebookEditor(L,this.d,E,v.visibleRanges.map(h.NotebookRange.to),v.selections.map(h.NotebookRange.to),typeof v.viewColumn=="number"?h.ViewColumn.to(v.viewColumn):void 0);this.h.set(L,t)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const v of E.value.removedDocuments){const t=y.URI.revive(v),d=this.g.get(t);d&&(d.dispose(),this.g.delete(t),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(d.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===t.toString()&&this.h.delete(r.id)}if(E.value.addedDocuments){const v=[];for(const t of E.value.addedDocuments){const d=y.URI.revive(t.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const r=new a.ExtHostNotebookDocument(this.c,this.q,this.r,d,t);v.push(...t.cells.map(u=>a.ExtHostCell.asModelAddData(r.apiNotebook,u))),this.g.get(d)?.dispose(),this.g.set(d,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(r.apiNotebook)}}if(E.value.addedEditors)for(const v of E.value.addedEditors){if(this.h.has(v.id))return;const t=y.URI.revive(v.documentUri),d=this.g.get(t);d&&this.w(d,v.id,v)}const L=[];if(E.value.removedEditors)for(const v of E.value.removedEditors){const t=this.h.get(v);t&&(this.h.delete(v),this.k?.id===t.id&&(this.k=void 0),L.push(t))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(t=>this.h.get(t)).filter(t=>!!t);const v=new Set;this.l.forEach(t=>v.add(t.id));for(const t of this.h.values()){const d=v.has(t.id);t._acceptVisibility(d)}this.l=[...this.h.values()].map(t=>t).filter(t=>t.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(E){const L=w.ApiCommandArgument.String.with("notebookType","A notebook type"),v=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[L,new w.ApiCommandArgument("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>n.VSBuffer.wrap(d))],new w.ApiCommandResult("Notebook Data",d=>h.NotebookData.to(d.value))),t=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[L,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new m.SerializableObjectWithBuffers(h.NotebookData.from(d)))],new w.ApiCommandResult("Bytes",d=>d.buffer));E.registerApiCommand(v),E.registerApiCommand(t)}}l.a=0,e.ExtHostNotebookController=l}),define(Ce[223],ke([1,0,16,17,20,4,6,28,2,25,11,54,5,37,8,7,72,186,27,46]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let L=class{constructor(i,p,c,o,f){this.k=p,this.l=c,this.m=o,this.n=f,this.b=new R.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new w.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=i.getProxy(h.MainContext.MainThreadNotebookKernels);const k=new b.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.ApiCommandArgument("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const V=this.l.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:V}}else if(A&&"notebookEditor"in A){const V=this.l.getIdByEditor(A.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return A})],b.ApiCommandResult.Void);this.m.registerApiCommand(k)}createNotebookController(i,p,c,o,f,k){for(const ae of this.h.values())if(ae.controller.id===p&&T.ExtensionIdentifier.equals(i.identifier,ae.extensionId))throw new Error(`notebook controller with id '${p}' ALREADY exist`);const A=this.i++,V=this;this.n.trace(`NotebookController[${A}], CREATED by ${i.identifier.value}, ${p}`);const _=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${i.identifier}'`);let K=!1;const O=new S.DisposableStore,B=new M.Emitter,P=new M.Emitter,F={id:r(i.identifier,p),notebookType:c,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:k?k.map(m.NotebookRendererScript.from):[]};let H=f??_,j;this.a.$addKernel(A,F).catch(ae=>{console.log(ae),K=!0});let de=0;const pe=()=>{if(K)return;const ae=++de;Promise.resolve().then(()=>{ae===de&&this.a.$updateKernel(A,F)})},re=new R.ResourceMap,ue={get id(){return p},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return F.label},set label(ae){F.label=ae??i.displayName??i.name,pe()},get detail(){return F.detail??""},set detail(ae){F.detail=ae,pe()},get description(){return F.description??""},set description(ae){F.description=ae,pe()},get kind(){return(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind??""},set kind(ae){(0,g.checkProposedApiEnabled)(i,"notebookControllerKind"),F.kind=ae,pe()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ae){F.supportedLanguages=ae,pe()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){F.supportsExecutionOrder=ae,pe()},get rendererScripts(){return F.preloads?F.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return H},set executeHandler(ae){H=ae??_},get interruptHandler(){return j},set interruptHandler(ae){j=ae,F.supportsInterrupt=Boolean(ae),pe()},createNotebookCellExecution(ae){if(K)throw new Error("notebook controller is DISPOSED");if(!re.has(ae.notebook.uri))throw V.n.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return V._createNotebookCellExecution(ae,r(i.identifier,this.id))},dispose:()=>{K||(this.n.trace(`NotebookController[${A}], DISPOSED`),K=!0,this.h.delete(A),O.dispose(),B.dispose(),P.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(ae,se){se===a.NotebookControllerAffinity2.Hidden&&(0,g.checkProposedApiEnabled)(i,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(A,ae.uri,se)},onDidReceiveMessage:P.event,postMessage(ae,se){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),V.a.$postMessage(A,se&&V.l.getIdByEditor(se),ae)},asWebviewUri(ae){return(0,g.checkProposedApiEnabled)(i,"notebookMessaging"),(0,s.asWebviewUri)(ae,V.k.remote)}};return this.h.set(A,{extensionId:i.identifier,controller:ue,onDidReceiveMessage:P,onDidChangeSelection:B,associatedNotebooks:re}),ue}getIdByController(i){for(const[p,c]of this.h)if(c.controller===i)return r(c.extensionId,i.id);return null}createNotebookControllerDetectionTask(i,p){const c=this.d++,o=this;this.n.trace(`NotebookControllerDetectionTask[${c}], CREATED by ${i.identifier.value}`),this.a.$addKernelDetectionTask(c,p);const f={dispose:()=>{this.c.delete(c),o.a.$removeKernelDetectionTask(c)}};return this.c.set(c,f),f}registerKernelSourceActionProvider(i,p,c){const o=this.f++,f=typeof c.onDidChangeNotebookKernelSourceActions=="function"?o:void 0,k=this;this.e.set(o,c),this.n.trace(`NotebookKernelSourceActionProvider[${o}], CREATED by ${i.identifier.value}`),this.a.$addKernelSourceActionProvider(o,o,p);let A;return f!==void 0&&(A=c.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.e.delete(o),k.a.$removeKernelSourceActionProvider(o,o),A?.dispose()}}}async $provideKernelSourceActions(i,p){const c=this.e.get(i);if(c){const o=new S.DisposableStore;return this.g.add([o]),(await c.provideNotebookKernelSourceActions(p)??[]).map(k=>m.NotebookKernelSourceAction.from(k,this.m.converter,o))}return[]}$acceptNotebookAssociation(i,p,c){const o=this.h.get(i);if(o){const f=this.l.getNotebookDocument(y.URI.revive(p));c?o.associatedNotebooks.set(f.uri,!0):o.associatedNotebooks.delete(f.uri),this.n.trace(`NotebookController[${i}] ASSOCIATE notebook`,f.uri.toString(),c),o.onDidChangeSelection.fire({selected:c,notebook:f.apiNotebook})}}async $executeCells(i,p,c){const o=this.h.get(i);if(!o)return;const f=this.l.getNotebookDocument(y.URI.revive(p)),k=[];for(const A of c){const V=f.getCell(A);V&&k.push(V.apiCell)}try{this.n.trace(`NotebookController[${i}] EXECUTE cells`,f.uri.toString(),k.length),await o.controller.executeHandler.call(o.controller,k,f.apiNotebook,o.controller)}catch(A){this.n.error(`NotebookController[${i}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(i,p,c){const o=this.h.get(i);if(!o)return;const f=this.l.getNotebookDocument(y.URI.revive(p));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,f.apiNotebook);else for(const k of c){const A=f.getCell(k);A&&this.b.get(A.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,p,c){const o=this.h.get(i);if(!o)return;const f=this.l.getEditorById(p);o.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:c}))}$cellExecutionChanged(i,p,c){const f=this.l.getNotebookDocument(y.URI.revive(i)).getCell(p);if(f){const k=c?m.NotebookCellExecutionState.to(c):a.NotebookCellExecutionState.Idle;k!==void 0&&this.j.fire({cell:f.apiCell,state:k})}}_createNotebookCellExecution(i,p){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this.l.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this.b.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new t(p,o,this.a);this.b.set(o.uri,f);const k=f.onDidChangeState(()=>{f.state===v.Resolved&&(f.dispose(),k.dispose(),this.b.delete(o.uri))});return f.asApiObject()}};L=qe([je(4,N.ILogService)],L),e.ExtHostNotebookKernels=L;var v;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(v||(v={}));class t extends S.Disposable{get state(){return this.f}constructor(i,p,c){super(),this.j=p,this.k=c,this.b=t.a++,this.c=new M.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new D.CancellationTokenSource),this.h=new d(10,o=>this.m(o)),this.i=p.internalMetadata.executionOrder,this.k.$createExecution(this.b,i,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(i){await this.h.addItem(i)}async m(i){const p=Array.isArray(i)?i:[i];return this.k.$updateExecution(this.b,new E.SerializableObjectWithBuffers(p))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(i){let p=this.j;if(i&&(p=this.j.notebook.getCellFromApiCell(i)),!p)throw new Error("INVALID cell");return p.handle}s(i){return i.map(p=>{const c=a.NotebookCellOutput.ensureUniqueMimeTypes(p.items,!0);return c===p.items?m.NotebookCellOutput.from(p):m.NotebookCellOutput.from({items:c,id:p.id,metadata:p.metadata})})}async t(i,p,c){const o=this.r(p),f=this.s((0,n.asArray)(i));return this.l({editType:l.CellExecutionUpdateType.Output,cellHandle:o,append:c,outputs:f})}async w(i,p,c){return i=a.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(i),!0),this.l({editType:l.CellExecutionUpdateType.OutputItems,items:i.map(m.NotebookCellOutputItem.from),outputId:p.id,append:c})}asApiObject(){const i=this;return Object.freeze({get token(){return i.g.token},get cell(){return i.j.apiCell},get executionOrder(){return i.i},set executionOrder(c){i.i=c,i.m([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:i.i}])},start(c){if(i.f===v.Resolved||i.f===v.Started)throw new Error("Cannot call start again");i.f=v.Started,i.c.fire(),i.m({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:c})},end(c,o){if(i.f===v.Resolved)throw new Error("Cannot call resolve twice");i.f=v.Resolved,i.c.fire(),i.h.flush(),i.k.$completeExecution(i.b,new E.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:c}))},clearOutput(c){return i.n(),i.t([],c,!1)},appendOutput(c,o){return i.n(),i.t(c,o,!0)},replaceOutput(c,o){return i.n(),i.t(c,o,!1)},appendOutputItems(c,o){return i.n(),i.w(c,o,!0)},replaceOutputItems(c,o){return i.n(),i.w(c,o,!1)}})}}t.a=0;class d{constructor(i,p){this.d=i,this.e=p,this.a=[],this.b=Date.now()}addItem(i){return this.a.push(i),this.c||(this.c=new C.DeferredPromise,this.b=Date.now(),(0,C.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const i=this.c;this.c=void 0;const p=this.a;return this.a=[],this.e(p).finally(()=>i.complete())}}function r(u,i){return`${u.value}/${i}`}e.createKernelId=r}),define(Ce[224],ke([1,0,4,5,100]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(R,y){this.c=y,this.a=new Map,this.b=R.getProxy(C.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(R,y,T){const N=this.c.getEditorById(R);this.a.get(y)?.fire({editor:N.apiEditor,message:T})}createRendererMessaging(R,y){if(!R.contributes?.notebookRenderer?.some(N=>N.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(N,w,h)=>this.d(y).event(N,w,h),postMessage:(N,w)=>{D.ExtHostNotebookEditor.apiEditorsToExtHost.has(N)&&([N,w]=[w,N]);const h=w&&D.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(h?.id,y,N)}}}d(R){let y=this.a.get(R);return y||(y=new n.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(R)}}),this.a.set(R,y),y)}}e.ExtHostNotebookRenderers=M}),define(Ce[225],ke([1,0,6,9,2,27,5]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class R{constructor(T){this.b=new Map,this.a=T.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(T,N,w){if((0,M.checkProposedApiEnabled)(T,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,w),this.a.$registerProfileContentHandler(N,w.name,w.description,T.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(T,N,w,h){const b=this.b.get(T);if(!b)throw new Error(`Unknown handler with id: ${T}`);return b.saveProfile(N,w,h)}async $readProfile(T,N,w){const h=this.b.get(T);if(!h)throw new Error(`Unknown handler with id: ${T}`);return h.readProfile((0,C.isString)(N)?N:D.URI.revive(N),w)}}e.ExtHostProfileContentHandlers=R}),define(Ce[226],ke([1,0,2,5,17,8]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(y,T){this.d=T,this.c=new Map,this.b=y.getProxy(C.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,T,N){const w=n.URI.revive(T),h=this.c.get(y);return h?(0,D.asPromise)(()=>h.provideOriginalResource(w,N)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(y,T,N,w){const h=S.a++;return this.c.set(h,T),this.b.$registerQuickDiffProvider(h,M.DocumentSelector.from(y,this.d),N,w),{dispose:()=>this.c.delete(h)}}}S.a=0,e.ExtHostQuickDiff=S}),define(Ce[227],ke([1,0,20,4,6,5,2,7,12,16,29,38]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(b,m,a){const s=b.getProxy(M.MainContext.MainThreadQuickOpen);class l{constructor(i,p){this.e=new Map,this.f=0,this.a=i,this.b=p}showQuickPick(i,p,c=n.CancellationToken.None){this.c=void 0;const o=Promise.resolve(i),f=++this.f,k=s.$show(f,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},c),A={},V=k.then(()=>A);return Promise.race([V,o]).then(_=>{if(_!==A)return o.then(K=>{const O=[];for(let B=0;B<K.length;B++){const P=K[B];typeof P=="string"?O.push({label:P,handle:B}):P.kind===R.QuickPickItemKind.Separator?O.push({type:"separator",label:P.label}):O.push({label:P.label,description:P.description,detail:P.detail,picked:P.picked,alwaysShow:P.alwaysShow,handle:B})}return p&&typeof p.onDidSelectItem=="function"&&(this.c=B=>{p.onDidSelectItem(K[B])}),s.$setItems(f,O),k.then(B=>{if(typeof B=="number")return K[B];if(Array.isArray(B))return B.map(P=>K[P])})})}).then(void 0,_=>{if(!(0,y.isCancellationError)(_))return s.$setError(f,_),Promise.reject(_)})}$onItemSelected(i){this.c?.(i)}showInput(i,p=n.CancellationToken.None){return this.d=i?.validateInput,s.$input(i,typeof this.d=="function",p).then(void 0,c=>{if(!(0,y.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(i){if(!this.d)return;const p=await this.d(i);if(!p||typeof p=="string")return p;let c;switch(p.severity){case R.InputBoxValidationSeverity.Info:c=N.default.Info;break;case R.InputBoxValidationSeverity.Warning:c=N.default.Warning;break;case R.InputBoxValidationSeverity.Error:c=N.default.Error;break;default:c=p.message?N.default.Error:N.default.Ignore;break}return{content:p.message,severity:c}}async showWorkspaceFolderPick(i,p=n.CancellationToken.None){const c=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!c)return;const o=await this.a.getWorkspaceFolders2();if(!!o)return o.find(f=>f.uri.toString()===c.uri.toString())}createQuickPick(i){const p=new d(i,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}createInputBox(i){const p=new r(i,()=>this.e.delete(p._id));return this.e.set(p._id,p),p}$onDidChangeValue(i,p){this.e.get(i)?._fireDidChangeValue(p)}$onDidAccept(i){this.e.get(i)?._fireDidAccept()}$onDidChangeActive(i,p){const c=this.e.get(i);c instanceof d&&c._fireDidChangeActive(p)}$onDidChangeSelection(i,p){const c=this.e.get(i);c instanceof d&&c._fireDidChangeSelection(p)}$onDidTriggerButton(i,p){this.e.get(i)?._fireDidTriggerButton(p)}$onDidTriggerItemButton(i,p,c){const o=this.e.get(i);o instanceof d&&o._fireDidTriggerItemButton(p,c)}$onDidHide(i){this.e.get(i)?._fireDidHide()}}class g{constructor(i,p){this.x=i,this.y=p,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.Emitter,this.q=new C.Emitter,this.r=new C.Emitter,this.s=new C.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(i){this.b=i,this.z({title:i})}get step(){return this.c}set step(i){this.c=i,this.z({step:i})}get totalSteps(){return this.d}set totalSteps(i){this.d=i,this.z({totalSteps:i})}get enabled(){return this.g}set enabled(i){this.g=i,this.z({enabled:i})}get busy(){return this.j}set busy(i){this.j=i,this.z({busy:i})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(i){this.k=i,this.z({ignoreFocusOut:i})}get value(){return this.l}set value(i){this.l=i,this.z({value:i})}get placeholder(){return this.m}set placeholder(i){this.m=i,this.z({placeholder:i})}get buttons(){return this.n}set buttons(i){this.n=i.slice(),this.o.clear(),i.forEach((p,c)=>{const o=p===R.QuickInputButtons.Back?-1:c;this.o.set(o,p)}),this.z({buttons:i.map((p,c)=>({...t(p),tooltip:p.tooltip,handle:p===R.QuickInputButtons.Back?-1:c}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(i){this.l=i,this.q.fire(i)}_fireDidTriggerButton(i){const p=this.o.get(i);p&&this.r.fire(p)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,D.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),s.$dispose(this._id))}z(i){if(!this.v){for(const p of Object.keys(i)){const c=i[p];this.u[p]=c===void 0?null:c}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){s.$createOrUpdate(this.u),this.u={id:this._id}}}g.a=1;function E(u){if(u instanceof R.ThemeIcon)return{id:u.id};const i=v(u),p=L(u);return{dark:typeof i=="string"?S.URI.file(i):i,light:typeof p=="string"?S.URI.file(p):p}}function L(u){return typeof u=="object"&&"light"in u?u.light:u}function v(u){return typeof u=="object"&&"dark"in u?u.dark:u}function t(u){const i=E(u.iconPath);let p,c;return"id"in i?c=w.ThemeIcon.asClassName(i):p=i,{iconPath:p,iconClass:c}}class d extends g{constructor(i,p){super(i.identifier,p),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.Emitter,this.L=[],this.M=new C.Emitter,this.N=new C.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(i){this.B=i.slice(),this.C.clear(),this.D.clear(),i.forEach((c,o)=>{this.C.set(o,c),this.D.set(c,o)});const p=[];for(let c=0;c<i.length;c++){const o=i[c];o.kind===R.QuickPickItemKind.Separator?p.push({type:"separator",label:o.label}):p.push({handle:c,label:o.label,description:o.description,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow,buttons:o.buttons?.map((f,k)=>({...t(f),tooltip:f.tooltip,handle:k}))})}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(i){this.E=i,this.z({canSelectMany:i})}get matchOnDescription(){return this.F}set matchOnDescription(i){this.F=i,this.z({matchOnDescription:i})}get matchOnDetail(){return this.G}set matchOnDetail(i){this.G=i,this.z({matchOnDetail:i})}get sortByLabel(){return this.H}set sortByLabel(i){this.H=i,this.z({sortByLabel:i})}get keepScrollPosition(){return this.I}set keepScrollPosition(i){this.I=i,this.z({keepScrollPosition:i})}get activeItems(){return this.J}set activeItems(i){this.J=i.filter(p=>this.D.has(p)),this.z({activeItems:this.J.map(p=>this.D.get(p))})}get selectedItems(){return this.L}set selectedItems(i){this.L=i.filter(p=>this.D.has(p)),this.z({selectedItems:this.L.map(p=>this.D.get(p))})}_fireDidChangeActive(i){const p=(0,T.coalesce)(i.map(c=>this.C.get(c)));this.J=p,this.K.fire(p)}_fireDidChangeSelection(i){const p=(0,T.coalesce)(i.map(c=>this.C.get(c)));this.L=p,this.M.fire(p)}_fireDidTriggerItemButton(i,p){const c=this.C.get(i);if(!c||!c.buttons||!c.buttons.length)return;const o=c.buttons[p];o&&this.N.fire({button:o,item:c})}}class r extends g{constructor(i,p){super(i.identifier,p),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(i){this.B=i,this.z({password:i})}get prompt(){return this.C}set prompt(i){this.C=i,this.z({prompt:i})}get valueSelection(){return this.D}set valueSelection(i){this.D=i,this.z({valueSelection:i})}get validationMessage(){return this.E}set validationMessage(i){this.E=i,i?typeof i=="string"?this.z({validationMessage:i,severity:N.default.Error}):this.z({validationMessage:i.message,severity:i.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new l(m,a)}e.createExtHostQuickOpen=h});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ce[228],ke([1,0,2,4,63,6,17,5,16,123,11,25,38,8,27]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m){"use strict";var a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(o){if(o)return typeof o.iconPath=="string"?n.URI.file(o.iconPath):n.URI.isUri(o.iconPath)||h.ThemeIcon.isThemeIcon(o.iconPath)?o.iconPath:void 0}function g(o,f){if(!o.iconPath&&!f.iconPath)return 0;if(o.iconPath){if(!f.iconPath)return 1}else return-1;const k=typeof o.iconPath=="string"?o.iconPath:n.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id,A=typeof f.iconPath=="string"?f.iconPath:n.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,T.comparePaths)(k,A)}function E(o,f){let k=0;if(o.strikeThrough!==f.strikeThrough)return o.strikeThrough?1:-1;if(o.faded!==f.faded)return o.faded?1:-1;if(o.tooltip!==f.tooltip)return(o.tooltip||"").localeCompare(f.tooltip||"");if(k=g(o,f),k!==0)return k;if(o.light&&f.light)k=g(o.light,f.light);else{if(o.light)return 1;if(f.light)return-1}if(k!==0)return k;if(o.dark&&f.dark)k=g(o.dark,f.dark);else{if(o.dark)return 1;if(f.dark)return-1}return k}function L(o,f){if(o.command!==f.command)return o.command<f.command?-1:1;if(o.title!==f.title)return o.title<f.title?-1:1;if(o.tooltip!==f.tooltip){if(o.tooltip!==void 0&&f.tooltip!==void 0)return o.tooltip<f.tooltip?-1:1;if(o.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(o.arguments===f.arguments)return 0;if(o.arguments)if(f.arguments){if(o.arguments.length!==f.arguments.length)return o.arguments.length-f.arguments.length}else return 1;else return-1;for(let k=0;k<o.arguments.length;k++){const A=o.arguments[k],V=f.arguments[k];if(A!==V)return A<V?-1:1}return 0}function v(o,f){let k=(0,T.comparePaths)(o.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(k!==0)return k;if(o.command&&f.command)k=L(o.command,f.command);else{if(o.command)return 1;if(f.command)return-1}if(k!==0)return k;if(o.decorations&&f.decorations)k=E(o.decorations,f.decorations);else{if(o.decorations)return 1;if(f.decorations)return-1}return k}function t(o,f){for(let k=0;k<o.length;k++)if(o[k]!==f[k])return!1;return!0}function d(o,f){return o.command===f.command&&o.title===f.title&&o.tooltip===f.tooltip&&(o.arguments&&f.arguments?t(o.arguments,f.arguments):o.arguments===f.arguments)}function r(o,f){return(0,y.equals)(o,f,d)}class u{get value(){return this.d}set value(f){f=f??"",Le(this,a,"f").$setInputBoxValue(this.l,f),this.m(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Le(this,a,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,m.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Le(this,a,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Le(this,a,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Le(this,a,"f").$setInputBoxVisibility(this.l,f))}constructor(f,k,A){this.k=f,this.l=A,a.set(this,void 0),this.d="",this.e=new C.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,a,k,"f")}showValidationMessage(f,k){(0,m.checkProposedApiEnabled)(this.k,"scmValidation"),Le(this,a,"f").$showValidationMessage(this.l,f,k)}$onInputBoxValueChange(f){this.m(f)}m(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=u,a=new WeakMap;class i{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,k,A,V,_){this.q=f,this.s=k,this.t=A,this.u=V,this.v=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=i.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,k){const A=this.h.get(f);return A?(0,S.asPromise)(()=>this.s.executeCommand(A.command,...A.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(v),A=(0,y.sortedDiff)(this.o,f,v).map(K=>{const O=K.toInsert.map(B=>{const P=this.e++;this.g.set(P,B);const F=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const Z=new M.DisposableStore;H=this.s.converter.toInternal(B.command,Z),this.j.set(P,Z)}else this.h.set(P,B.command);const j=l(B.decorations),de=B.decorations&&l(B.decorations.light)||j,pe=B.decorations&&l(B.decorations.dark)||j,re=[de,pe],ue=B.decorations&&B.decorations.tooltip||"",ae=B.decorations&&!!B.decorations.strikeThrough,se=B.decorations&&!!B.decorations.faded,Y=B.contextValue||"";return{rawResource:[P,F,re,ue,ae,se,Y,H],handle:P}});return{start:K.start,deleteCount:K.deleteCount,toInsert:O}}),V=A.map(({start:K,deleteCount:O,toInsert:B})=>[K,O,B.map(P=>P.rawResource)]),_=A.reverse();for(const{start:K,deleteCount:O,toInsert:B}of _){const P=B.map(H=>H.handle),F=this.n.splice(K,O,...P);for(const H of F)this.g.delete(H),this.h.delete(H),this.j.get(H)?.dispose(),this.j.delete(H)}return this.o=f,V}dispose(){this.l=!0,this.m.fire()}}i.d=0;class p{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Le(this,s,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f,Le(this,s,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Le(this,s,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new M.DisposableStore,this.l=f;const k=this.v.converter.toInternal(f,this.k.value);Le(this,s,"f").$updateSourceControl(this.t,{acceptInputCommand:k})}get actionButton(){return(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,m.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new M.DisposableStore,this.n=f;const k=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(A=>A.map(V=>this.v.converter.toInternal(V,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Le(this,s,"f").$updateSourceControl(this.t,{actionButton:k??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&r(this.p,f))return;this.o.value=new M.DisposableStore,this.p=f;const k=(f||[]).map(A=>this.v.converter.toInternal(A,this.o.value));Le(this,s,"f").$updateSourceControl(this.t,{statusBarCommands:k})}get selected(){return this.q}constructor(f,k,A,V,_,K){this.u=f,this.v=A,this.w=V,this.x=_,this.y=K,s.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.MutableDisposable,this.l=void 0,this.m=new M.MutableDisposable,this.o=new M.MutableDisposable,this.p=void 0,this.q=!1,this.s=new C.Emitter,this.onDidChangeSelection=this.s.event,this.t=p.d++,this.z=new Map,this.A=new Set,Je(this,s,k,"f"),this.f=new u(f,Le(this,s,"f"),this.t),Le(this,s,"f").$registerSourceControl(this.t,V,_,K)}createResourceGroup(f,k){const A=new i(Le(this,s,"f"),this.v,this.t,f,k),V=C.Event.once(A.onDidDispose)(()=>this.z.delete(A));return this.z.set(A,V),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const f=[],k=[];for(const[A,V]of this.z){V.dispose();const _=A.onDidUpdateResourceStates(()=>{this.A.add(A),this.eventuallyUpdateResourceStates()});C.Event.once(A.onDidDispose)(()=>{this.A.delete(A),_.dispose(),this.e.delete(A.handle),Le(this,s,"f").$unregisterGroup(this.t,A.handle)}),f.push([A.handle,A.id,A.label,A.features]);const K=A._takeResourceStateSnapshot();K.length>0&&k.push([A.handle,K]),this.e.set(A.handle,A)}Le(this,s,"f").$registerGroups(this.t,f,k),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(k=>{const A=k._takeResourceStateSnapshot();A.length!==0&&f.push([k.handle,A])}),f.length>0&&Le(this,s,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Le(this,s,"f").$unregisterSourceControl(this.t)}}s=new WeakMap,p.d=0,qe([(0,D.debounce)(100)],p.prototype,"eventuallyAddResourceGroups",null),qe([(0,D.debounce)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let c=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(f,k,A){this.l=k,this.m=A,this.g=new Map,this.h=new Map,this.j=new C.Emitter,this.e=f.getProxy(R.MainContext.MainThreadSCM),this.f=f.getProxy(R.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const _=this.g.get(V.sourceControlHandle);if(!_)return V;const K=_.getResourceGroup(V.groupHandle);return K?K.getResourceState(V.handle):V}else if(V&&V.$mid===4){const _=this.g.get(V.sourceControlHandle);return _?_.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const _=this.g.get(V.handle);return _||V}return V}})}createSourceControl(f,k,A,V){this.m.trace("ExtHostSCM#createSourceControl",f.identifier.value,k,A,V),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const _=on.d++,K=new p(f,this.e,this.l,k,A,V);this.g.set(_,K);const O=this.h.get(w.ExtensionIdentifier.toKey(f.identifier))||[];return O.push(K),this.h.set(w.ExtensionIdentifier.toKey(f.identifier),O),K}getLastInputBox(f){this.m.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const k=this.h.get(w.ExtensionIdentifier.toKey(f.identifier)),A=k&&k[k.length-1];return A&&A.inputBox}$provideOriginalResource(f,k,A){const V=n.URI.revive(k);this.m.trace("ExtHostSCM#$provideOriginalResource",f,V.toString());const _=this.g.get(f);return!_||!_.quickDiffProvider||!_.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>_.quickDiffProvider.provideOriginalResource(V,A)).then(K=>K||null)}$onInputBoxValueChange(f,k){this.m.trace("ExtHostSCM#$onInputBoxValueChange",f);const A=this.g.get(f);return A&&A.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(f,k,A,V){this.m.trace("ExtHostSCM#$executeResourceCommand",f,k,A);const _=this.g.get(f);if(!_)return Promise.resolve(void 0);const K=_.getResourceGroup(k);return K?K.$executeResourceCommand(A,V):Promise.resolve(void 0)}$validateInput(f,k,A){this.m.trace("ExtHostSCM#$validateInput",f);const V=this.g.get(f);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>V.inputBox.validateInput(k,A)).then(_=>{if(!_)return Promise.resolve(void 0);const K=b.MarkdownString.fromStrict(_.message);return K?Promise.resolve([K,_.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};c.d=0,c=qe([je(2,N.ILogService)],c),e.ExtHostSCM=c}),define(Ce[79],ke([1,0,5,4,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(R){this.b=new C.Emitter,this.onDidChangePassword=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,y){return this.a.$getPassword(R,y)}store(R,y,T){return this.a.$setPassword(R,y,T)}delete(R,y){return this.a.$deletePassword(R,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[229],ke([1,0,7,5,142,6,8,9]),function(te,e,n,C,D,M,S,R){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(m,a,s,l,g=n.StatusBarAlignment.Left,E){y.set(this,void 0),T.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new M.DisposableStore,Je(this,y,m,"f"),Je(this,T,a,"f"),this.c=N.a++,this.e=s,this.f=l,this.g=g,this.h=this.u(E)}u(m){if(!!(0,R.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!N.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new M.DisposableStore,typeof m=="string"?this.r={fromApi:m,internal:Le(this,T,"f").toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:Le(this,T,"f").toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Le(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let a;this.m?a=this.m:a=(0,D.localize)(0,null,this.e.displayName||this.e.name);let s=this.n;this.o&&(s=N.b.get(this.o.id));const l=S.MarkdownString.fromStrict(this.l);Le(this,y,"f").$setEntry(this.c,m,a,this.k,l,this.r?.internal,s,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,T=new WeakMap,N.a=0,N.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=N;class w{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,D.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const a={message:m};return this.b.unshift(a),this.c(),new n.Disposable(()=>{const s=this.b.indexOf(a);s>=0&&(this.b.splice(s,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class h{constructor(m,a){this.a=m.getProxy(C.MainContext.MainThreadStatusBar),this.b=a,this.c=new w(this)}createStatusBarEntry(m,a,s,l){return new N(this.a,this.b,m,a,s,l)}setStatusBarMessage(m,a){const s=this.c.setMessage(m);let l;return typeof a=="number"?l=setTimeout(()=>s.dispose(),a):typeof a<"u"&&a.then(()=>s.dispose(),()=>s.dispose()),new n.Disposable(()=>{s.dispose(),clearTimeout(l)})}}e.ExtHostStatusBar=h}),define(Ce[80],ke([1,0,5,4,3]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(R,y){this.c=y,this.b=new C.Emitter,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(R,y){this.a.$registerExtensionStorageKeysToSync(R,y)}async initializeExtensionStorage(R,y,T){const N=await this.a.$initializeExtensionStorage(R,y);let w;return N&&(w=this.d(R,y,N)),w||T}setValue(R,y,T){return this.a.$setValue(R,y,T)}$acceptValue(R,y,T){const N=this.d(R,y,T);N&&this.b.fire({shared:R,key:y,value:N})}d(R,y,T){try{return JSON.parse(T)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${R}): ${N}`)}}}e.ExtHostStorage=M,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(Ce[81],ke([1,0,3,26,11,59,2]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let R=class{constructor(T,N,w){this.d=N,this.f=w,this.a=T.workspace??void 0,this.b=T.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(T){return S.URI.joinPath(this.b.workspaceStorageHome,T)}async h(){if(!this.a)return Promise.resolve(void 0);const T=this.a.id,N=await this.g(T);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(S.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(T){if(this.c)return S.URI.joinPath(this.c,T.identifier.value)}globalValue(T){return S.URI.joinPath(this.b.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};R=qe([je(0,C.IExtHostInitDataService),je(1,D.ILogService),je(2,M.IExtHostConsumerFileSystem)],R),e.ExtensionStoragePaths=R}),define(Ce[60],ke([1,0,4,5,3,2,18,6,7,144,12,170,20,34,171,38,9,17,8]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class E{constructor(c,o,f,k){this.k=c,this._id=o,this.l=f,this.m=k,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const A=this;this.value={get name(){return A.m||""},get processId(){return A.b},get creationOptions(){return A.l},get exitStatus(){return A.h},get state(){return A.j},sendText(V,_=!0){A.o(),A.k.$sendText(A._id,V,_)},show(V){A.o(),A.k.$show(A._id,V)},hide(){A.o(),A.k.$hide(A._id)},dispose(){A.a||(A.a=!0,A.k.$dispose(A._id))},get dimensions(){if(!(A.d===void 0||A.g===void 0))return{columns:A.d,rows:A.g}}}}async create(c,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:c.name,shellPath:(0,s.withNullAsUndefined)(c.shellPath),shellArgs:(0,s.withNullAsUndefined)(c.shellArgs),cwd:(0,s.withNullAsUndefined)(c.cwd),env:(0,s.withNullAsUndefined)(c.env),icon:(0,s.withNullAsUndefined)(u(c.iconPath)),color:a.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,s.withNullAsUndefined)(c.message),strictEnv:(0,s.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,s.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,s.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,s.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this.n(c.location,o?.resolvedExtHostIdentifier),isTransient:(0,s.withNullAsUndefined)(c.isTransient)})}async createExtensionTerminal(c,o,f,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:a.ThemeColor.isThemeColor(k)?k.id:void 0,location:this.n(c,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(c,o){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in c?{viewColumn:g.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus}:void 0:c}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(c){this.m=c}setExitStatus(c,o){this.h=Object.freeze({code:c,reason:o})}setDimensions(c,o){return c===this.d&&o===this.g||c===0||o===0?!1:(this.d=c,this.g=o,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(c){this.f?(this.f(c),this.f=void 0):this.b.then(o=>{o!==c&&(this.b=Promise.resolve(c))})}}e.ExtHostTerminal=E;class L{get onProcessReady(){return this.b.event}constructor(c){this.g=c,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${o}`)}async start(){}shutdown(){this.g.close()}input(c){this.g.handleInput?.(c)}resize(c,o){this.g.setDimensions?.({columns:c,rows:o})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this.g.onDidWrite(o=>this.a.fire(o)),this.g.onDidClose?.((o=void 0)=>{this.f.fire(o===void 0?void 0:o)}),this.g.onDidOverrideDimensions?.(o=>{o&&this.d.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this.g.onDidChangeName?.(o=>{this.d.fire({type:"title",value:o})}),this.g.open(c||void 0),c&&this.g.setDimensions?.(c),this.b.fire({pid:-1,cwd:""})}}let v=1,t=class extends R.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(c=>c.value)}get onDidWriteTerminalData(){return this.I.event}constructor(c,o){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=o.getProxy(C.MainContext.MainThreadTerminalService),this.s=new m.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(c),this.B({dispose:()=>{for(const[f,k]of this.g)k.shutdown(!0)}})}getDefaultShell(c){return(c?this.n:this.m)?.path||""}getDefaultShellArgs(c){return(c?this.n:this.m)?.args||[]}createExtensionTerminal(c,o){const f=new E(this.a,(0,b.generateUuid)(),c,c.name),k=new L(c.pty);return f.createExtensionTerminal(c.location,this.L(c,o).resolvedExtHostIdentifier,u(c.iconPath),i(c.color)).then(A=>{const V=this.M(A,k);this.h[A]=V}),this.f.push(f),f.value}L(c,o){if(o=o||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const f=c.location.parentTerminal;if(f){const k=this.f.find(A=>A.value===f);k&&(o.resolvedExtHostIdentifier=k._id)}}else c.location&&typeof c.location!="object"?o.location=c.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(c,o){if(!this.O(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const k=new L(o),A=this.M(c,k);this.h[c]=A}async $acceptActiveTerminalChanged(c){const o=this.b;if(c===null){this.b=void 0,o!==this.b&&this.F.fire(this.b);return}const f=this.O(c);f&&(this.b=f,o!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(c,o){const f=this.O(c);f&&this.I.fire({terminal:f.value,data:o})}async $acceptTerminalDimensions(c,o,f){const k=this.O(c);k&&k.setDimensions(o,f)&&this.G.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(c,o,f){this.g.get(c)?.resize(o,f)}async $acceptTerminalTitleChange(c,o){const f=this.O(c);f&&(f.name=o)}async $acceptTerminalClosed(c,o,f){const k=this.Q(this.f,c);if(k!==null){const A=this.f.splice(k,1)[0];A.setExitStatus(o,f),this.C.fire(A.value)}}$acceptTerminalOpened(c,o,f,k){if(o){const _=this.Q(this.f,o);if(_!==null){this.f[_]._id=c,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const A={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:M.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},V=new E(this.a,c,A,f);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(c,o){this.O(c)?._setProcessId(o)}async $startExtensionTerminal(c,o){const f=this.O(c);if(!f)return{message:(0,T.localize)(0,null,c)};f.isOpen||await new Promise(A=>{const V=this.onDidOpenTerminal(async _=>{_===f.value&&(V.dispose(),A())})});const k=this.g.get(c);k?k.startSendingEvents(o):this.j[c]={initialDimensions:o}}M(c,o){const f=new R.DisposableStore;f.add(o.onProcessReady(A=>this.a.$sendProcessReady(c,A.pid,A.cwd))),f.add(o.onDidChangeProperty(A=>this.a.$sendProcessProperty(c,A))),this.s.startBuffering(c,o.onProcessData),f.add(o.onProcessExit(A=>this.N(c,A))),this.g.set(c,o);const k=this.j[c];return k&&o instanceof L&&(o.startSendingEvents(k.initialDimensions),delete this.j[c]),f}$acceptProcessAckDataEvent(c,o){this.g.get(c)?.acknowledgeDataEvent(o)}$acceptProcessInput(c,o){this.g.get(c)?.input(o)}$acceptTerminalInteraction(c){const o=this.O(c);o?.setInteractedWith()&&this.H.fire(o.value)}$acceptProcessResize(c,o,f){try{this.g.get(c)?.resize(o,f)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(c,o){this.g.get(c)?.shutdown(o)}$acceptProcessRequestInitialCwd(c){this.g.get(c)?.getInitialCwd().then(o=>this.a.$sendProcessProperty(c,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(c){this.g.get(c)?.getCwd().then(o=>this.a.$sendProcessProperty(c,{type:"cwd",value:o}))}$acceptProcessRequestLatency(c){return Promise.resolve(c)}registerLinkProvider(c){return this.u.add(c),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(c),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(c,o,f){if(this.v.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this.v.set(o,f),this.a.$registerProfileProvider(o,c.identifier.value),new y.Disposable(()=>{this.v.delete(o),this.a.$unregisterProfileProvider(o)})}registerTerminalQuickFixProvider(c,o,f){if(this.w.has(c))throw new Error(`Terminal quick fix provider "${c}" is already registered`);return this.w.set(c,f),this.a.$registerQuickFixProvider(c,o),new y.Disposable(()=>{this.w.delete(c),this.a.$unregisterQuickFixProvider(c)})}async $provideTerminalQuickFixes(c,o){const f=new h.CancellationTokenSource().token;if(f.isCancellationRequested)return;const k=this.w.get(c);if(!k)return;const A=await k.provideTerminalQuickFixes(o,f);if(A!==null)return A}async $createContributedProfileTerminal(c,o){const f=new h.CancellationTokenSource().token;let k=await this.v.get(c)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,o);return}this.createTerminalFromOptions(k.options,o)}}async $provideLinks(c,o){const f=this.O(c);if(!f)return[];this.y.delete(c),this.z.get(c)?.dispose(!0);const A=new h.CancellationTokenSource;this.z.set(c,A);const V=[],_={terminal:f.value,line:o},K=[];for(const P of this.u)K.push(l.Promises.withAsyncBody(async F=>{A.token.onCancellationRequested(()=>F({provider:P,links:[]}));const H=await P.provideTerminalLinks(_,A.token)||[];A.token.isCancellationRequested||F({provider:P,links:H})}));const O=await Promise.all(K);if(A.token.isCancellationRequested)return[];const B=new Map;for(const P of O)P&&P.links.length>0&&V.push(...P.links.map(F=>{const H={id:v++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return B.set(H.id,{provider:P.provider,link:F}),H}));return this.y.set(c,B),V}$activateLink(c,o){const f=this.y.get(c)?.get(o);!f||f.provider.handleTerminalLink(f.link)}N(c,o){this.s.stopBuffering(c),this.g.delete(c),delete this.j[c];const f=this.h[c];f&&(f.dispose(),delete this.h[c]),this.a.$sendProcessExit(c,o)}O(c){return this.P(this.f,c)}P(c,o){const f=this.Q(c,o);return f!==null?c[f]:null}Q(c,o){let f=null;return c.some((k,A)=>k._id===o?(f=A,!0):!1),f}getEnvironmentVariableCollection(c){let o=this.l.get(c.identifier.value);return o||(o=new d,this.S(c.identifier.value,o)),o}R(c,o){const f=(0,w.serializeEnvironmentVariableCollection)(o.map);this.a.$setEnvironmentVariableCollection(c,o.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(c){c.forEach(o=>{const f=o[0],k=new d(o[1]);this.S(f,k)})}$acceptDefaultProfile(c,o){const f=this.m;this.m=c,this.n=o,f?.path!==c.path&&this.J.fire(c.path)}S(c,o){this.l.set(c,o),o.onDidChangeCollection(()=>{this.R(c,o)})}};t=qe([je(1,S.IExtHostRpcService)],t),e.BaseExtHostTerminalService=t;class d{get persistent(){return this.a}set persistent(c){this.a=c,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(c){this.map=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(c)}get size(){return this.map.size}replace(c,o){this.d(c,{value:o,type:y.EnvironmentVariableMutatorType.Replace})}append(c,o){this.d(c,{value:o,type:y.EnvironmentVariableMutatorType.Append})}prepend(c,o){this.d(c,{value:o,type:y.EnvironmentVariableMutatorType.Prepend})}d(c,o){const f=this.map.get(c);(!f||f.value!==o.value||f.type!==o.type)&&(this.map.set(c,o),this.b.fire())}get(c){return this.map.get(c)}forEach(c,o){this.map.forEach((f,k)=>c.call(o,k,f,this))}[Symbol.iterator](){return this.map.entries()}delete(c){this.map.delete(c),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends t{constructor(c){super(!1,c)}createTerminal(c,o,f){throw new N.NotSupportedError}createTerminalFromOptions(c,o){throw new N.NotSupportedError}};r=qe([je(0,S.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function u(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return a.ThemeColor.isThemeColor(p)?p:void 0}});var Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n};define(Ce[230],ke([1,0,16,17,23,20,4,194,231,6,22,9,34,5,18,101,8,7,45,71,56,27]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v){"use strict";var t,d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(P,F,H){this.j=H,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=P.getProxy(b.MainContext.MainThreadTesting),this.h=new _(this.f),this.g=new c(this.f),F.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const de=j,pe=de.tests[de.tests.length-1].item.extId;return this.d.get(g.TestId.root(pe))?.collection.tree.get(pe)?.actual??(0,a.toItemFromContext)(j)}})}createTestController(P,F,H,j){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const de=new T.DisposableStore,pe=de.add(new a.ExtHostTestItemCollection(F,H,this.j));pe.root.label=H;const re=new Map,ue=this.f,ae={items:pe.root.children,get label(){return H},set label(Y){H=Y,pe.root.label=Y,ue.$updateController(F,{label:H})},get refreshHandler(){return j},set refreshHandler(Y){j=Y,ue.$updateController(F,{canRefresh:!!Y})},get id(){return F},createRunProfile:(Y,G,Z,he,Te,Ne)=>{let Ke=(0,y.hash)(Y);for(;re.has(Ke);)Ke++;return Ne!==void 0&&(0,v.checkProposedApiEnabled)(P,"testContinuousRun"),new K(this.f,re,F,Ke,Y,G,Z,he,Te,Ne)},createTestItem(Y,G,Z){return new a.TestItemImpl(F,Y,G,Z)},createTestRun:(Y,G,Z=!0)=>this.g.createTestRun(F,pe,Y,G,Z),set resolveHandler(Y){pe.resolveHandler=Y},get resolveHandler(){return pe.resolveHandler},dispose:()=>{de.dispose()}};ue.$registerTestController(F,H,!!j),de.add((0,T.toDisposable)(()=>ue.$unregisterTestController(F)));const se={controller:ae,collection:pe,profiles:re};return this.d.set(F,se),de.add((0,T.toDisposable)(()=>this.d.delete(F))),de.add(pe.onDidGenerateDiff(Y=>ue.$publishDiff(F,Y.map(L.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.h.checkout()}async runTests(P,F=M.CancellationToken.None){const H=o(P);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(H.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:P.include?.map(de=>g.TestId.fromExtHostTestItem(de,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:O[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:P.exclude?.map(de=>de.id)},F)}$syncTests(){for(const{collection:P}of this.d.values())P.flushDiff();return Promise.resolve()}$provideFileCoverage(P,F,H){return(0,n.mapFind)(this.g.trackers,de=>de.id===P?de.getCoverage(F):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(P,F,H,j){return(0,n.mapFind)(this.g.trackers,pe=>pe.id===P?pe.getCoverage(F):void 0)?.resolveFileCoverage(H,j)??Promise.resolve([])}$configureRunProfile(P,F){this.d.get(P)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(P,F){await this.d.get(P)?.controller.refreshHandler?.(F)}$publishTestResults(P){this.results=Object.freeze(P.map(F=>(0,N.deepFreeze)(s.TestResults.to(F))).concat(this.results).sort((F,H)=>H.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(P,F){const H=this.d.get(g.TestId.fromString(P).controllerId)?.collection;H&&(await H.expand(P,F<0?1/0:F),H.flushDiff())}$acceptDiff(P){this.h.applyDiff(P.map(L.TestsDiffOp.deserialize))}async $runControllerTests(P,F){return Promise.all(P.map(H=>this.k(H,!1,F)))}async $startContinuousRun(P,F){const H=new M.CancellationTokenSource(F),j=await Promise.all(P.map(de=>this.k(de,!0,H.token)));return!F.isCancellationRequested&&!j.some(de=>de.error)&&await new Promise(de=>F.onCancellationRequested(de)),H.dispose(!0),j}async k(P,F,H){const j=this.d.get(P.controllerId);if(!j)return{};const{collection:de,profiles:pe}=j,re=pe.get(P.profileId);if(!re)return{};const ue=P.testIds.map(G=>de.tree.get(G)).filter(w.isDefined),ae=P.excludeExtIds.map(G=>j.collection.tree.get(G)).filter(w.isDefined).filter(G=>ue.some(Z=>Z.fullId.compare(G.fullId)===2));if(!ue.length)return{};const se=new l.TestRunRequest2(ue.some(G=>G.actual instanceof a.TestItemRootImpl)?void 0:ue.map(G=>G.actual),ae.map(G=>G.actual),re,F),Y=(0,L.isStartControllerTests)(P)&&this.g.prepareForMainThreadTestRun(se,f.fromInternal(P,j.collection),H);try{return await re.runHandler(se,H),{}}catch(G){return{error:String(G)}}finally{Y&&(Y.hasRunningTasks&&!H.isCancellationRequested&&await S.Event.toPromise(Y.onEnd),Y.dispose())}}$cancelExtensionTestRun(P){P===void 0?this.g.cancelAllRuns():this.g.cancelRunById(P)}};r=qe([je(0,m.IExtHostRpcService)],r),e.ExtHostTesting=r;const u=1e4;var i;(function(B){B[B.Running=0]="Running",B[B.Cancelling=1]="Cancelling",B[B.Ended=2]="Ended"})(i||(i={}));class p extends T.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(P,F,H){super(),this.k=P,this.l=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new M.CancellationTokenSource(H));const j=this.B(new C.RunOnceScheduler(()=>this.m(),u));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(P){return this.f.get(P)?.coverage}createRun(P){const F=this.k.id,H=this.k.controllerId,j=(0,h.generateUuid)(),de=new k(this.l,F,j),pe=se=>(Y,...G)=>{if(ue){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(Y)||(this.s(Y),se(Y,...G))},re=(se,Y)=>{const G=Y instanceof Array?Y.map(s.TestMessage.from):[s.TestMessage.from(Y)];if(se.uri&&se.range){const Z={range:s.Range.from(se.range),uri:se.uri};for(const he of G)he.location=he.location||Z}this.l.$appendTestMessagesInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),G)};let ue=!1;const ae={isPersisted:this.k.isPersisted,token:this.h.token,name:P,get coverageProvider(){return de.coverageProvider},set coverageProvider(se){de.coverageProvider=se},enqueued:pe(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),1)}),skipped:pe(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),5)}),started:pe(se=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),2)}),errored:pe((se,Y,G)=>{re(se,Y),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),6,G)}),failed:pe((se,Y,G)=>{re(se,Y),this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,H).toString(),4,G)}),passed:pe((se,Y)=>{this.l.$updateTestStateInRun(F,j,g.TestId.fromExtHostTestItem(se,this.k.controllerId).toString(),3,Y)}),appendOutput:(se,Y,G)=>{ue||(G&&(this.k.isIncluded(G)?this.s(G):G=void 0),this.l.$appendOutputToRun(F,j,D.VSBuffer.fromString(se),Y&&s.location.from(Y),G&&g.TestId.fromExtHostTestItem(G,H).toString()))},end:()=>{ue||(ue=!0,this.l.$finishedTestRunTask(F,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ae,coverage:de}),this.l.$startedTestRunTask(F,{id:j,name:P,running:!0}),ae}m(){for(const{run:P}of this.f.values())P.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(P){if(!(P instanceof a.TestItemImpl))throw new E.InvalidTestItemError(P.id);if(this.g.has(g.TestId.fromExtHostTestItem(P,this.k.controllerId).toString()))return;const F=[],H=this.k.colllection.root;for(;;){const j=s.TestItem.from(P);if(F.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),P===H))break;P=P.parent||H}this.l.$addTestsToRun(this.k.controllerId,this.k.id,F)}}class c{get trackers(){return this.c.values()}constructor(P){this.d=P,this.c=new Map}prepareForMainThreadTestRun(P,F,H){return this.f(P,F,H)}cancelRunById(P){for(const F of this.c.values())if(F.id===P){F.cancel();return}}cancelAllRuns(){for(const P of this.c.values())P.cancel()}createTestRun(P,F,H,j,de){const pe=this.c.get(H);if(pe)return pe.createRun(j);const re=f.fromPublic(P,F,H,de),ue=o(H);this.d.$startedExtensionTestRun({controllerId:P,continuous:!!H.continuous,profile:ue&&{group:O[ue.kind],id:ue.profileId},exclude:H.exclude?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[],id:re.id,include:H.include?.map(se=>g.TestId.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:de});const ae=this.f(H,re);return ae.onEnd(()=>{this.d.$finishedExtensionTestRun(re.id),ae.dispose()}),ae.createRun(j)}f(P,F,H){const j=new p(F,this.d,H);return this.c.set(P,j),j.onEnd(()=>this.c.delete(P)),j}}e.TestRunCoordinator=c;const o=B=>{if(!!B.profile){if(!(B.profile instanceof K))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return B.profile}};class f{static fromPublic(P,F,H,j){return new f(P,(0,h.generateUuid)(),H.include?.map(de=>g.TestId.fromExtHostTestItem(de,P).toString())??[P],H.exclude?.map(de=>g.TestId.fromExtHostTestItem(de,P).toString())??[],j,F)}static fromInternal(P,F){return new f(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,F)}constructor(P,F,H,j,de,pe){this.controllerId=P,this.id=F,this.isPersisted=de,this.colllection=pe,this.c=H.map(re=>re+"\0"),this.d=j.map(re=>re+"\0")}isIncluded(P){const F=g.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const H of this.d)if(F===H||F.startsWith(H))return!1;for(const H of this.c)if(F===H||F.startsWith(H))return!0;return!1}}e.TestRunDto=f;class k{set coverageProvider(P){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this.c=P,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(P,F,H){this.f=P,this.g=F,this.h=H}async provideFileCoverage(P){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(P))());try{return(await this.d)?.map(s.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(P,F){const H=await this.d;let j=H?.[P];return!this.c||!H||!j?[]:(j.detailedCoverage||(j=H[P]=await this.c.resolveFileCoverage?.(j,F)??j),j.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class A{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(P){this.h=P,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(P){this.c.add(P)}update(P){Object.assign(P.revived,s.TestItem.toPlain(P.item)),this.c.has(P)||this.d.add(P)}remove(P){if(this.c.has(P)){this.c.delete(P);return}this.d.delete(P);const F=g.TestId.parentId(P.item.extId);if(F&&this.g.has(F.toString())){this.g.add(P.item.extId);return}this.f.add(P)}getChangeEvent(){const{c:P,d:F,f:H}=this;return{get added(){return[...P].map(j=>j.revived)},get updated(){return[...F].map(j=>j.revived)},get removed(){return[...H].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class V extends L.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(P){return this.d.get(P)}getMirroredTestDataByReference(P){return this.d.get(P.id)}p(P,F){return{...P,revived:s.TestItem.toPlain(P.item),depth:F?F.depth+1:0,children:new Set}}o(){return new A(this.q)}}class _{constructor(P){this.d=P}checkout(){this.c||(this.c=this.f());const P=this.c;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(F=>F.revived)},dispose:(0,R.once)(()=>{--P.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(P){return this.c?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.c?.tests.apply(P)}f(){const P=new V;return this.d.$subscribeToDiffs(),{observers:0,tests:P}}}class K{get label(){return this.d}set label(P){P!==this.d&&(this.d=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(P){P!==this.g&&(this.g=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:P}))}get isDefault(){return this.f}set isDefault(P){P!==this.f&&(this.f=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?s.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this.c}set configureHandler(P){P!==this.c&&(this.c=P,Le(this,t,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}constructor(P,F,H,j,de,pe,re,ue=!1,ae=void 0,se=!1){this.controllerId=H,this.profileId=j,this.d=de,this.kind=pe,this.runHandler=re,this.f=ue,this._tag=ae,this.g=se,t.set(this,void 0),d.set(this,void 0),Je(this,t,P,"f"),Je(this,d,F,"f"),F.set(j,this);const Y=O[pe];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${pe}`);Le(this,t,"f").$publishTestRunProfile({profileId:j,controllerId:H,tag:ae?s.TestTag.namespace(this.controllerId,ae.id):null,label:de,group:Y,isDefault:ue,hasConfigurationHandler:!1,supportsContinuousRun:se})}dispose(){Le(this,d,"f")?.delete(this.profileId)&&(Je(this,d,void 0,"f"),Le(this,t,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=K,t=new WeakMap,d=new WeakMap;const O={[l.TestRunProfileKind.Coverage]:8,[l.TestRunProfileKind.Debug]:4,[l.TestRunProfileKind.Run]:2}}),define(Ce[232],ke([1,0,16,4,5,102,8,7]),function(te,e,n,C,D,M,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(N,w){this.i=w,this.a=new C.Emitter,this.b=new C.Emitter,this.c=new C.Emitter,this.d=new C.Emitter,this.f=new C.Emitter,this.g=new C.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(D.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const w=this.i.allEditors();return N?w:w.map(h=>h.value)}async showTextDocument(N,w,h){let b;typeof w=="number"?b={position:S.ViewColumn.from(w),preserveFocus:h}:typeof w=="object"?b={position:S.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?S.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:b={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(N.uri,b),a=m&&this.i.getEditor(m);if(a)return a.value;throw m?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,w){return new M.TextEditorDecorationType(this.h,N,w).value}$acceptEditorPropertiesChanged(N,w){const h=this.i.getEditor(N);if(!h)throw new Error("unknown text editor");if(w.options&&h._acceptOptions(w.options),w.selections){const b=w.selections.selections.map(S.Selection.to);h._acceptSelections(b)}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(S.Range.to));h._acceptVisibleRanges(b)}if(w.options&&this.b.fire({textEditor:h.value,options:{...w.options,lineNumbers:S.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const b=R.TextEditorSelectionChangeKind.fromValue(w.selections.source),m=w.selections.selections.map(S.Selection.to);this.a.fire({textEditor:h.value,selections:m,kind:b})}if(w.visibleRanges){const b=n.coalesce(w.visibleRanges.map(S.Range.to));this.c.fire({textEditor:h.value,visibleRanges:b})}}$acceptEditorPositionData(N){for(const w in N){const h=this.i.getEditor(w);if(!h)throw new Error("Unknown text editor");const b=S.ViewColumn.to(N[w]);h.value.viewColumn!==b&&(h._acceptViewColumn(b),this.d.fire({textEditor:h.value,viewColumn:b}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.ExtHostEditors=y}),define(Ce[233],ke([1,0,2,3,5,6,7,8,25,9]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,C.createDecorator)("IExtHostTimeline");class N{constructor(b,m){this.b=new Map,this.c=new Map,this.a=b.getProxy(D.MainContext.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&y.ExtensionIdentifier.equals(s,this.b.get(a.source)?.extension)){const l=a.uri===void 0?void 0:n.URI.revive(a.uri);return this.c.get(a.source)?.get(w(l))?.get(a.handle)}else return;return a}})}async $getTimeline(b,m,a,s){return this.b.get(b)?.provider.provideTimeline(n.URI.revive(m),a,s)}registerTimelineProvider(b,m,a,s){const l=new M.DisposableStore,g=this.d(m.id,s,l).bind(this);let E;m.onDidChange&&(E=m.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:m.id}),this));const L=this.c;return this.f({...m,scheme:b,onDidChange:void 0,async provideTimeline(v,t,d){t?.resetCache&&(l.clear(),L.get(m.id)?.clear());const r=await m.provideTimeline(v,t,d);if(r==null)return;const u=g(v,t);return{...r,source:m.id,items:r.items.map(u)}},dispose(){for(const v of L.values())v.get(m.id)?.clear();E?.dispose(),l.dispose()}},a)}d(b,m,a){return(s,l)=>{let g;if(l?.cacheResults){let E=this.c.get(b);E===void 0&&(E=new Map,this.c.set(b,E));const L=w(s);g=E.get(L),g===void 0&&(g=new Map,E.set(L,g))}return E=>{const{iconPath:L,...v}=E,t=`${b}|${E.id??E.timestamp}`;g?.set(t,E);let d,r,u;E.iconPath&&(L instanceof S.ThemeIcon?u={id:L.id,color:L.color}:n.URI.isUri(L)?(d=L,r=L):{light:d,dark:r}=L);let i;return S.MarkdownString.isMarkdownString(v.tooltip)?i=R.MarkdownString.from(v.tooltip):(0,T.isString)(v.tooltip)?i=v.tooltip:S.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=R.MarkdownString.from(v.detail)):(0,T.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=v.detail),{...v,id:v.id??void 0,handle:t,source:b,command:E.command?m.toInternal(E.command,a):void 0,icon:d,iconDark:r,themeIcon:u,tooltip:i,accessibilityInformation:E.accessibilityInformation}}}}f(b,m){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:m}),(0,M.toDisposable)(()=>{for(const s of this.c.values())s.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.ExtHostTimeline=N;function w(h){return h?.toString()}}),define(Ce[234],ke([1,0,6,15,2,5]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,N,w){if(this.c.has(T))throw new Error(`Opener with id '${T}' already registered`);const h=w.schemes.find(b=>!S.a.has(b));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(T,N),this.b.$registerUriOpener(T,w.schemes,y,w.label),(0,n.toDisposable)(()=>{this.c.delete(T),this.b.$unregisterUriOpener(T)})}async $canOpenUri(y,T,N){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const h=D.URI.revive(T);return w.canOpenExternalUri(h,N)}async $openUri(y,T,N){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(D.URI.revive(T.resolvedUri),{sourceUri:D.URI.revive(T.sourceUri)},N)}}S.a=new Set([C.Schemas.http,C.Schemas.https]),e.ExtHostUriOpeners=S}),define(Ce[235],ke([1,0,5,2,6,12,25]),function(te,e,n,C,D,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class R{constructor(T){this.c=new Set,this.d=new Map,this.b=T.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(T,N){if(this.c.has(S.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const w=R.a++;return this.c.add(S.ExtensionIdentifier.toKey(T)),this.d.set(w,N),this.b.$registerUriHandler(w,T),(0,D.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(T)),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(T,N){const w=this.d.get(T);if(!w)return Promise.resolve(void 0);try{w.handleUri(C.URI.revive(N))}catch(h){(0,M.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(T){return C.URI.revive(await this.b.$createAppUri(T))}}R.a=0,e.ExtHostUrls=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[61],ke([1,0,4,15,22,2,157,180,72,5]),function(te,e,n,C,D,M,S,R,y,T){"use strict";var N,w,h,b,m,a,s,l,g,E,L,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(A,V,_,K,O,B,P){N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),s.set(this,""),l.set(this,void 0),g.set(this,!1),E.set(this,!1),L.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new n.Emitter),this._onDidDispose=Le(this,t,"f").event,Je(this,N,A,"f"),Je(this,w,V,"f"),Je(this,l,_,"f"),Je(this,b,K,"f"),Je(this,m,O,"f"),Je(this,a,B,"f"),Je(this,L,r(B),"f"),Je(this,v,u(B),"f"),Je(this,h,P,"f")}dispose(){Je(this,g,!0,"f"),Le(this,t,"f").fire(),Le(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(A){return Je(this,E,!0,"f"),(0,y.asWebviewUri)(A,Le(this,b,"f"))}get cspSource(){const A=Le(this,a,"f").extensionLocation;if(A.scheme===C.Schemas.https||A.scheme===C.Schemas.http){let V=A.toString();return V.endsWith("/")||(V+="/"),V+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Le(this,s,"f")}set html(A){this.a(),Le(this,s,"f")!==A&&(Je(this,s,A,"f"),Le(this,v,"f")&&!Le(this,E,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(A)&&(Je(this,E,!0,"f"),Le(this,h,"f").report("Webview vscode-resource: uris",Le(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Le(this,w,"f").$setHtml(Le(this,N,"f"),this.b(A)))}get options(){return this.a(),Le(this,l,"f")}set options(A){this.a(),D.equals(Le(this,l,"f"),A)||Le(this,w,"f").$setOptions(Le(this,N,"f"),c(Le(this,a,"f"),Le(this,m,"f"),A)),Je(this,l,A,"f")}async postMessage(A){if(Le(this,g,"f"))return!1;const V=(0,R.serializeWebviewMessage)(A,{serializeBuffersForPostMessage:Le(this,L,"f")});return Le(this,w,"f").$postMessage(Le(this,N,"f"),V.message,...V.buffers)}a(){if(Le(this,g,"f"))throw new Error("Webview is disposed")}b(A){if(!Le(this,v,"f"))return A;const V=Le(this,a,"f").extensionLocation?.scheme===C.Schemas.vscodeRemote,_=Le(this,a,"f").extensionLocation.scheme===C.Schemas.vscodeRemote?Le(this,a,"f").extensionLocation.authority:void 0;return A.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,O,B,P,F,H)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),de=(0,y.asWebviewUri)(j,{isRemote:V,authority:_}).toString();return`${O}${de}${H}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(K,O,B,P,F,H)=>{const j=M.URI.from({scheme:P||"file",path:decodeURIComponent(F)}),de=(0,y.asWebviewUri)(j,{isRemote:V,authority:_}).toString();return`${O}${de}${H}`})}}e.ExtHostWebview=d,N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,v=new WeakMap,t=new WeakMap;function r(k){try{const A=(0,S.normalizeVersion)((0,S.parseVersion)(k.engines.vscode));return!!A&&A.majorBase>=1&&A.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function u(k){try{const A=(0,S.normalizeVersion)((0,S.parseVersion)(k.engines.vscode));return A?A.majorBase<1||A.majorBase===1&&A.minorBase<60:!1}catch{return!1}}class i{constructor(A,V,_,K,O){this.c=V,this.d=_,this.e=K,this.f=O,this.b=new Map,this.a=A.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(A,V,_){const K=this.g(A);if(K){const{message:O}=(0,R.deserializeWebviewMessage)(V,_.value);K._onMessageEmitter.fire(O)}}$onMissingCsp(A,V){this.e.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(A,V,_){const K=new d(A,this.a,o(V),this.c,this.d,_,this.f);return this.b.set(A,K),K._onDidDispose(()=>{this.b.delete(A)}),K}deleteWebview(A){this.b.delete(A)}g(A){return this.b.get(A)}}e.ExtHostWebviews=i;function p(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=p;function c(k,A,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||f(k,A)}}e.serializeWebviewOptions=c;function o(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(A=>M.URI.from(A))}}function f(k,A){return[...(A?.getWorkspaceFolders()||[]).map(V=>V.uri),k.extensionLocation]}}),define(Ce[236],ke([1,0,20,231,6,15,24,2,8,61,54,5,7]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class b{constructor(d,r){this.document=d,this.b=r,this.a=1,this.c=new N.Cache("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,r){await this.f(d).undo(),r||this.disposeBackup()}async redo(d,r){await this.f(d).redo(),r||this.disposeBackup()}disposeEdits(d){for(const r of d)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=v(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const r=this.c.get(d,0);if(!r)throw new Error("No edit found");return r}}class m{constructor(){this.a=new Map}get(d,r){return this.a.get(this.b(d,r))}add(d,r,u){const i=this.b(d,r.uri);if(this.a.has(i))throw new Error(`Document already exists for viewType:${d} resource:${r.uri}`);const p=new b(r,u);return this.a.set(i,p),p}delete(d,r){const u=this.b(d,r.uri);this.a.delete(u)}b(d,r){return`${d}@@@${r}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(d,r,u){return this.b(0,d,r,u)}addCustomProvider(d,r,u){return this.b(1,d,r,u)}get(d){return this.a.get(d)}b(d,r,u,i){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:d,extension:u,provider:i}),new h.Disposable(()=>this.a.delete(r))}}class l{constructor(d,r,u,i,p){this.d=r,this.f=u,this.g=i,this.h=p,this.b=new s,this.c=new m,this.a=d.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(d,r,u,i){const p=new D.DisposableStore;return E(u)?(p.add(this.b.addTextProvider(r,d,u)),this.a.$registerTextEditorProvider((0,T.toExtensionData)(d),r,i.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(d))):(p.add(this.b.addCustomProvider(r,d,u)),g(u)&&p.add(u.onDidChangeCustomDocument(c=>{const o=this.i(r,c.document.uri);if(L(c)){const f=o.addEdit(c);this.a.$onDidEdit(c.document.uri,r,f,c.label)}else this.a.$onContentChange(c.document.uri,r)})),this.a.$registerCustomEditorProvider((0,T.toExtensionData)(d),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(d))),h.Disposable.from(p,new h.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(d,r,u,i,p){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const o=R.URI.revive(d),f=await c.provider.openCustomDocument(o,{backupId:u,untitledDocumentData:i?.buffer},p);let k;return g(c.provider)&&this.f&&(k=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(r,f,k),{editable:g(c.provider)}}async $disposeCustomDocument(d,r){const u=this.b.get(r);if(!u)throw new Error(`No provider found for '${r}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=R.URI.revive(d),{document:p}=this.i(r,i);this.c.delete(r,p),p.dispose()}async $resolveCustomEditor(d,r,u,i,p,c){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);const f=y.ViewColumn.to(p),k=this.g.createNewWebview(r,i.contentOptions,o.extension),A=this.h.createNewWebviewPanel(r,u,i.title,f,i.options,k,!0),V=R.URI.revive(d);switch(o.type){case 1:{const{document:_}=this.i(u,V);return o.provider.resolveCustomEditor(_,A,c)}case 0:{const _=this.d.getDocument(V);return o.provider.resolveCustomTextEditor(_,A,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,r,u){this.i(r,d).disposeEdits(u)}async $onMoveCustomEditor(d,r,u){const i=this.b.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const p=this.h.getWebviewPanel(d);if(!p)throw new Error("No webview found");const c=R.URI.revive(r),o=this.d.getDocument(c);await i.provider.moveCustomTextEditor(o,p,n.CancellationToken.None)}async $undo(d,r,u,i){return this.i(r,d).undo(u,i)}async $redo(d,r,u,i){return this.i(r,d).redo(u,i)}async $revert(d,r,u){const i=this.i(r,d);await this.j(r).revertCustomDocument(i.document,u),i.disposeBackup()}async $onSave(d,r,u){const i=this.i(r,d);await this.j(r).saveCustomDocument(i.document,u),i.disposeBackup()}async $onSaveAs(d,r,u,i){const p=this.i(r,d);return this.j(r).saveCustomDocumentAs(p.document,R.URI.revive(u),i)}async $backup(d,r,u){const i=this.i(r,d),c=await this.j(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},u);return i.updateBackup(c),c.id}i(d,r){const u=this.c.get(d,R.URI.revive(r));if(!u)throw new Error("No custom document found");return u}j(d){const u=this.b.get(d)?.provider;if(!u||!g(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=l;function g(t){return!!t.onDidChangeCustomDocument}function E(t){return typeof t.resolveCustomTextEditor=="function"}function L(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function v(t){const d=t.scheme===M.Schemas.file||t.scheme===M.Schemas.untitled?t.fsPath:t.toString();return(0,C.hash)(d)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[237],ke([1,0,4,6,2,34,8,61,5,7]),function(te,e,n,C,D,M,S,R,y,T){"use strict";var N,w,h,b,m,a,s,l,g,E,L,v,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class d extends C.Disposable{constructor(p,c,o,f){super(),N.set(this,void 0),w.set(this,void 0),h.set(this,void 0),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),s.set(this,void 0),l.set(this,void 0),g.set(this,!0),E.set(this,void 0),L.set(this,!1),v.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,v,"f").event,t.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Le(this,t,"f").event,Je(this,N,p,"f"),Je(this,w,c,"f"),Je(this,b,o,"f"),Je(this,h,f.viewType,"f"),Je(this,m,f.panelOptions,"f"),Je(this,l,f.viewColumn,"f"),Je(this,a,f.title,"f"),Je(this,E,f.active,"f")}dispose(){Le(this,L,"f")||(Je(this,L,!0,"f"),Le(this,v,"f").fire(),Le(this,w,"f").$disposeWebview(Le(this,N,"f")),Le(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Le(this,b,"f")}get viewType(){return this.c(),Le(this,h,"f")}get title(){return this.c(),Le(this,a,"f")}set title(p){this.c(),Le(this,a,"f")!==p&&(Je(this,a,p,"f"),Le(this,w,"f").$setTitle(Le(this,N,"f"),p))}get iconPath(){return this.c(),Le(this,s,"f")}set iconPath(p){this.c(),Le(this,s,"f")!==p&&(Je(this,s,p,"f"),Le(this,w,"f").$setIconPath(Le(this,N,"f"),D.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Le(this,m,"f")}get viewColumn(){if(this.c(),!(typeof Le(this,l,"f")=="number"&&Le(this,l,"f")<0))return Le(this,l,"f")}get active(){return this.c(),Le(this,E,"f")}get visible(){return this.c(),Le(this,g,"f")}_updateViewState(p){Le(this,L,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(Je(this,E,p.active,"f"),Je(this,g,p.visible,"f"),Je(this,l,p.viewColumn,"f"),Le(this,t,"f").fire({webviewPanel:this}))}reveal(p,c){this.c(),Le(this,w,"f").$reveal(Le(this,N,"f"),{viewColumn:typeof p>"u"?void 0:S.ViewColumn.from(p),preserveFocus:!!c})}c(){if(Le(this,L,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap,E=new WeakMap,L=new WeakMap,v=new WeakMap,t=new WeakMap;class r{static c(){return(0,M.generateUuid)()}constructor(p,c,o){this.g=c,this.h=o,this.e=new Map,this.f=new Map,this.d=p.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(p,c,o,f,k={}){const A=typeof f=="object"?f.viewColumn:f,V={viewColumn:S.ViewColumn.from(A),preserveFocus:typeof f=="object"&&!!f.preserveFocus},_=(0,R.shouldSerializeBuffersForPostMessage)(p),K=r.c();this.d.$createWebviewPanel((0,R.toExtensionData)(p),K,c,{title:o,panelOptions:u(k),webviewOptions:(0,R.serializeWebviewOptions)(p,this.h,k),serializeBuffersForPostMessage:_},V);const O=this.g.createNewWebview(K,k,p);return this.createNewWebviewPanel(K,c,o,A,k,O,!0)}$onDidChangeWebviewPanelViewStates(p){const c=Object.keys(p);c.sort((o,f)=>{const k=p[o],A=p[f];return k.active?1:A.active?-1:+k.visible-+A.visible});for(const o of c){const f=this.getWebviewPanel(o);if(!f)continue;const k=p[o];f._updateViewState({active:k.active,visible:k.visible,viewColumn:S.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.e.delete(p),this.g.deleteWebview(p)}registerWebviewPanelSerializer(p,c,o){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:o,extension:p}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,R.shouldSerializeBuffersForPostMessage)(p)}),new T.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(p,c,o,f){const k=this.f.get(c);if(!k)throw new Error(`No serializer found for '${c}'`);const{serializer:A,extension:V}=k,_=this.g.createNewWebview(p,o.webviewOptions,V),K=this.createNewWebviewPanel(p,c,o.title,f,o.panelOptions,_,o.active);await A.deserializeWebviewPanel(K,o.state)}createNewWebviewPanel(p,c,o,f,k,A,V){const _=new d(p,this.d,A,{viewType:c,title:o,viewColumn:f,panelOptions:k,active:V});return this.e.set(p,_),_}getWebviewPanel(p){return this.e.get(p)}}e.ExtHostWebviewPanels=r;function u(i){return{enableFindWidget:i.enableFindWidget,retainContextWhenHidden:i.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[238],ke([1,0,4,6,61,8,5,7]),function(te,e,n,C,D,M,S,R){"use strict";var y,T,N,w,h,b,m,a,s,l,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends C.Disposable{constructor(t,d,r,u,i,p){super(),y.set(this,void 0),T.set(this,void 0),N.set(this,void 0),w.set(this,void 0),h.set(this,!1),b.set(this,void 0),m.set(this,void 0),a.set(this,void 0),s.set(this,void 0),l.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Le(this,l,"f").event,g.set(this,this.B(new n.Emitter)),this.onDidDispose=Le(this,g,"f").event,Je(this,N,r,"f"),Je(this,m,u,"f"),Je(this,y,t,"f"),Je(this,T,d,"f"),Je(this,w,i,"f"),Je(this,b,p,"f")}dispose(){Le(this,h,"f")||(Je(this,h,!0,"f"),Le(this,g,"f").fire(),Le(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Le(this,m,"f")}set title(t){this.a(),Le(this,m,"f")!==t&&(Je(this,m,t,"f"),Le(this,T,"f").$setWebviewViewTitle(Le(this,y,"f"),t))}get description(){return this.a(),Le(this,a,"f")}set description(t){this.a(),Le(this,a,"f")!==t&&(Je(this,a,t,"f"),Le(this,T,"f").$setWebviewViewDescription(Le(this,y,"f"),t))}get visible(){return Le(this,b,"f")}get webview(){return Le(this,w,"f")}get viewType(){return Le(this,N,"f")}_setVisible(t){t===Le(this,b,"f")||Le(this,h,"f")||(Je(this,b,t,"f"),Le(this,l,"f").fire())}get badge(){return this.a(),Le(this,s,"f")}set badge(t){this.a(),!(t?.value===Le(this,s,"f")?.value&&t?.tooltip===Le(this,s,"f")?.tooltip)&&(Je(this,s,M.ViewBadge.from(t),"f"),Le(this,T,"f").$setWebviewViewBadge(Le(this,y,"f"),t))}show(t){this.a(),Le(this,T,"f").$show(Le(this,y,"f"),!!t)}a(){if(Le(this,h,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,T=new WeakMap,N=new WeakMap,w=new WeakMap,h=new WeakMap,b=new WeakMap,m=new WeakMap,a=new WeakMap,s=new WeakMap,l=new WeakMap,g=new WeakMap;class L{constructor(t,d){this.d=d,this.b=new Map,this.c=new Map,this.a=t.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,d,r,u){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,D.toExtensionData)(t),d,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(t,d,r,u,i){const p=this.b.get(d);if(!p)throw new Error(`No view provider found for '${d}'`);const{provider:c,extension:o}=p,f=this.d.createNewWebview(t,{},o),k=new E(t,this.a,d,r,f,!0);this.c.set(t,k),await c.resolveWebviewView(k,{state:u},i)}async $onDidChangeWebviewViewVisibility(t,d){this.e(t)._setVisible(d)}async $disposeWebviewView(t){const d=this.e(t);this.c.delete(t),d.dispose(),this.d.deleteWebview(t)}e(t){const d=this.c.get(t);if(!d)throw new Error("No webview found");return d}}e.ExtHostWebviewViews=L}),define(Ce[104],ke([1,0,4,5,2,15,10,3,18]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class an{get state(){return this.d}constructor(w){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=w.getProxy(C.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,h){let b;if(typeof w=="string"){b=w;try{w=D.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,S.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,b,h)}async asExternalUri(w,h){if((0,S.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(w,h);return D.URI.from(b)}};T.a={focused:!0},T=qe([je(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,R.createDecorator)("IExtHostWindow")}),define(Ce[239],ke([1,0,209,26,18]),function(te,e,n,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends n.AbstractExtHostConsoleForwarder{constructor(R,y){super(R,y)}f(R,y,T){y.apply(console,T)}};M=qe([je(0,D.IExtHostRpcService),je(1,C.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[240],ke([1,0,17,23,20,12,4,6,127,203,46]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function h(k,A){try{return JSON.stringify(k,A)}catch{return"null"}}const b="$$ref$$",m={[b]:-1};class a{constructor(A,V){this.jsonString=A,this.referencedBuffers=V}}function s(k,A=null,V=!1){const _=[];return{jsonString:(V?h:JSON.stringify)(k,(O,B)=>{if(typeof B>"u")return m;if(typeof B=="object"){if(B instanceof C.VSBuffer){const P=_.push(B)-1;return{[b]:P}}if(A)return A(O,B)}return B}),referencedBuffers:_}}e.stringifyJsonWithBufferRefs=s;function l(k,A,V){return JSON.parse(k,(_,K)=>{if(K){const O=K[b];if(typeof O=="number")return A[O];if(V&&K.$mid===1)return V.transformIncoming(K)}return K})}e.parseJsonAndRestoreBufferRefs=l;function g(k,A){return JSON.stringify(k,A)}function E(k){return k?(A,V)=>V&&V.$mid===1?k.transformOutgoing(V):V:null}var L;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(L=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const t=()=>{},d=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class u extends R.Disposable{constructor(A,V=null,_=null){super(),this[w]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=V,this.g=_,this.h=E(this.g),this.j=!1,this.k=[],this.l=[];for(let K=0,O=N.ProxyIdentifier.count;K<O;K++)this.k[K]=null,this.l[K]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(K=>this.G(K))}dispose(){this.j=!0,Object.keys(this.s).forEach(A=>{this.s[A].resolveErr(M.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(A){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(A){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(A){this.t!==A&&(this.t=A,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(A){return this.g?(0,y.transformIncomingURIs)(A,this.g):A}getProxy(A){const{nid:V,sid:_}=A;return this.l[V]||(this.l[V]=this.F(V,_)),this.l[V]}F(A,V){const _={get:(K,O)=>(typeof O=="string"&&!K[O]&&O.charCodeAt(0)===36&&(K[O]=(...B)=>this.O(A,O,B)),O===r?V:K[O])};return new Proxy(Object.create(null),_)}set(A,V){return this.k[A.nid]=V,V}assertRegistered(A){for(let V=0,_=A.length;V<_;V++){const K=A[V];if(!this.k[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}G(A){if(this.j)return;const V=A.byteLength,_=i.read(A,0),K=_.readUInt8(),O=_.readUInt32();switch(K){case 1:case 2:{let{rpcId:B,method:P,args:F}=c.deserializeRequestJSONArgs(_);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(V,O,B,P,F,K===2);break}case 3:case 4:{let{rpcId:B,method:P,args:F}=c.deserializeRequestMixedArgs(_);this.g&&(F=(0,y.transformIncomingURIs)(F,this.g)),this.H(V,O,B,P,F,K===4);break}case 5:{this.f?.logIncoming(V,O,0,"ack"),this.z(O);break}case 6:{this.I(V,O);break}case 7:{this.J(V,O,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(_);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.J(V,O,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(_,this.g);this.J(V,O,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(_);this.J(V,O,B);break}case 11:{let B=c.deserializeReplyErrError(_);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.L(V,O,B);break}case 12:{this.L(V,O,void 0);break}default:console.error("received unexpected message"),console.error(A)}}H(A,V,_,K,O,B){this.f?.logIncoming(A,V,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(_)}.${K}(`,O);const P=String(V);let F,H;if(B){const de=new D.CancellationTokenSource;O.push(de.token),F=this.M(_,K,O),H=()=>de.cancel()}else F=this.M(_,K,O),H=t;this.p[P]=H;const j=c.serializeAcknowledged(V);this.f?.logOutgoing(j.byteLength,V,1,"ack"),this.c.send(j),F.then(de=>{delete this.p[P];const pe=c.serializeReplyOK(V,de,this.h);this.f?.logOutgoing(pe.byteLength,V,1,"reply:",de),this.c.send(pe)},de=>{delete this.p[P];const pe=c.serializeReplyErr(V,de);this.f?.logOutgoing(pe.byteLength,V,1,"replyErr:",de),this.c.send(pe)})}I(A,V){this.f?.logIncoming(A,V,1,"receiveCancel");const _=String(V);this.p[_]?.()}J(A,V,_){this.f?.logIncoming(A,V,0,"receiveReply:",_);const K=String(V);if(!this.s.hasOwnProperty(K))return;const O=this.s[K];delete this.s[K],O.resolveOk(_)}L(A,V,_){this.f?.logIncoming(A,V,0,"receiveReplyErr:",_);const K=String(V);if(!this.s.hasOwnProperty(K))return;const O=this.s[K];delete this.s[K];let B;_&&(_.$isError?(B=new Error,B.name=_.name,B.message=_.message,B.stack=_.stack):B=_),O.resolveErr(B)}M(A,V,_){try{return Promise.resolve(this.N(A,V,_))}catch(K){return Promise.reject(K)}}N(A,V,_){const K=this.k[A];if(!K)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(A));const O=K[V];if(typeof O!="function")throw new Error("Unknown method "+V+" on actor "+(0,N.getStringIdentifierForProxy)(A));return O.apply(K,_)}O(A,V,_){if(this.j)return new T.CanceledLazyPromise;let K=null;if(_.length>0&&D.CancellationToken.isCancellationToken(_[_.length-1])&&(K=_.pop()),K&&K.isCancellationRequested)return Promise.reject(M.canceled());const O=c.serializeRequestArguments(_,this.h),B=++this.m,P=String(B),F=new T.LazyPromise;K&&K.onCancellationRequested(()=>{const j=c.serializeCancel(B);this.f?.logOutgoing(j.byteLength,B,0,"cancel"),this.c.send(c.serializeCancel(B))}),this.s[P]=F,this.y(B);const H=c.serializeRequest(B,A,V,O,!!K);return this.f?.logOutgoing(H.byteLength,B,0,`request: ${(0,N.getStringIdentifierForProxy)(A)}.${V}(`,_),this.c.send(H),F}}w=d,u.a=3*1e3,e.RPCProtocol=u;class i{static alloc(A,V,_){const K=new i(C.VSBuffer.alloc(_+1+4),0);return K.writeUInt8(A),K.writeUInt32(V),K}static read(A,V){return new i(A,V)}get buffer(){return this.a}constructor(A,V){this.a=A,this.b=V}static sizeUInt8(){return 1}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const _=this.a.slice(this.b,this.b+A).toString();return this.b+=A,_}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const _=this.a.slice(this.b,this.b+A).toString();return this.b+=A,_}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+A);return this.b+=A,V}static sizeMixedArray(A){let V=0;V+=1;for(let _=0,K=A.length;_<K;_++){const O=A[_];switch(V+=1,O.type){case 1:V+=this.sizeLongString(O.value);break;case 2:V+=this.sizeVSBuffer(O.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(O.value);for(let B=0;B<O.buffers.length;++B)V+=this.sizeVSBuffer(O.buffers[B]);break;case 4:break}}return V}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let V=0,_=A.length;V<_;V++){const K=A[V];switch(K.type){case 1:this.writeUInt8(1),this.writeLongString(K.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(K.value);break;case 3:this.writeUInt8(3),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let O=0;O<K.buffers.length;++O)this.writeBuffer(K.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const V=new Array(A);for(let _=0;_<A;_++)switch(this.readUInt8()){case 1:V[_]=this.readLongString();break;case 2:V[_]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),B=this.readLongString(),P=[];for(let F=0;F<O;++F)P.push(this.readVSBuffer());V[_]=new N.SerializableObjectWithBuffers(l(B,P,null));break}case 4:V[_]=void 0;break}return V}}i.sizeUInt32=4;var p;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(p||(p={}));class c{static a(A){for(let V=0,_=A.length;V<_;V++)if(A[V]instanceof C.VSBuffer||A[V]instanceof N.SerializableObjectWithBuffers||typeof A[V]>"u")return!0;return!1}static serializeRequestArguments(A,V){if(this.a(A)){const _=[];for(let K=0,O=A.length;K<O;K++){const B=A[K];if(B instanceof C.VSBuffer)_[K]={type:2,value:B};else if(typeof B>"u")_[K]={type:4};else if(B instanceof N.SerializableObjectWithBuffers){const{jsonString:P,referencedBuffers:F}=s(B.value,V);_[K]={type:3,value:C.VSBuffer.fromString(P),buffers:F}}else _[K]={type:1,value:C.VSBuffer.fromString(g(B,V))}}return{type:1,args:_}}return{type:0,args:g(A,V)}}static serializeRequest(A,V,_,K,O){switch(K.type){case 0:return this.b(A,V,_,K.args,O);case 1:return this.c(A,V,_,K.args,O)}}static b(A,V,_,K,O){const B=C.VSBuffer.fromString(_),P=C.VSBuffer.fromString(K);let F=0;F+=i.sizeUInt8(),F+=i.sizeShortString(B),F+=i.sizeLongString(P);const H=i.alloc(O?2:1,A,F);return H.writeUInt8(V),H.writeShortString(B),H.writeLongString(P),H.buffer}static deserializeRequestJSONArgs(A){const V=A.readUInt8(),_=A.readShortString(),K=A.readLongString();return{rpcId:V,method:_,args:JSON.parse(K)}}static c(A,V,_,K,O){const B=C.VSBuffer.fromString(_);let P=0;P+=i.sizeUInt8(),P+=i.sizeShortString(B),P+=i.sizeMixedArray(K);const F=i.alloc(O?4:3,A,P);return F.writeUInt8(V),F.writeShortString(B),F.writeMixedArray(K),F.buffer}static deserializeRequestMixedArgs(A){const V=A.readUInt8(),_=A.readShortString(),K=A.readMixedArray(),O=new Array(K.length);for(let B=0,P=K.length;B<P;B++){const F=K[B];typeof F=="string"?O[B]=JSON.parse(F):O[B]=F}return{rpcId:V,method:_,args:O}}static serializeAcknowledged(A){return i.alloc(5,A,0).buffer}static serializeCancel(A){return i.alloc(6,A,0).buffer}static serializeReplyOK(A,V,_){if(typeof V>"u")return this.d(A);if(V instanceof C.VSBuffer)return this.e(A,V);if(V instanceof N.SerializableObjectWithBuffers){const{jsonString:K,referencedBuffers:O}=s(V.value,_,!0);return this.g(A,K,O)}else return this.f(A,h(V,_))}static d(A){return i.alloc(7,A,0).buffer}static e(A,V){let _=0;_+=i.sizeVSBuffer(V);const K=i.alloc(8,A,_);return K.writeVSBuffer(V),K.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,V){const _=C.VSBuffer.fromString(V);let K=0;K+=i.sizeLongString(_);const O=i.alloc(9,A,K);return O.writeLongString(_),O.buffer}static g(A,V,_){const K=C.VSBuffer.fromString(V);let O=0;O+=i.sizeUInt32,O+=i.sizeLongString(K);for(const P of _)O+=i.sizeVSBuffer(P);const B=i.alloc(10,A,O);B.writeUInt32(_.length),B.writeLongString(K);for(const P of _)B.writeBuffer(P);return B.buffer}static deserializeReplyOKJSON(A){const V=A.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(A,V){const _=A.readUInt32(),K=A.readLongString(),O=[];for(let B=0;B<_;++B)O.push(A.readVSBuffer());return new N.SerializableObjectWithBuffers(l(K,O,V))}static serializeReplyErr(A,V){const _=V?h(M.transformErrorForSerialization(V),null):void 0;if(typeof _!="string")return this.h(A);const K=C.VSBuffer.fromString(_);let O=0;O+=i.sizeLongString(K);const B=i.alloc(11,A,O);return B.writeLongString(K),B.buffer}static deserializeReplyErrError(A){const V=A.readLongString();return JSON.parse(V)}static h(A){return i.alloc(12,A,0).buffer}}var o;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(o||(o={}));var f;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(f||(f={}))}),define(Ce[241],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(M){const S=R=>{self.removeEventListener("message",S);const y=R.data;Object.defineProperties(self,{postMessage:{value(T,N){y.postMessage(T,N)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",S)}.toString();class C extends EventTarget{constructor(M,S,R){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${n})('${S}'))`,T=new Blob([y],{type:"application/javascript"}),N=URL.createObjectURL(T),w=new MessageChannel,h=N,b={type:"_newWorker",id:h,port:w.port2,url:N,options:R};M(b,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{M({type:"_terminateWorker",id:h}),URL.revokeObjectURL(N),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(m){w.port1.onmessage=m}},onmessageerror:{get(){return w.port1.onmessageerror},set(m){w.port1.onmessageerror=m}}}),w.port1.addEventListener("messageerror",m=>{const a=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(a)}),w.port1.addEventListener("message",m=>{const a=new MessageEvent("message",{data:m.data});this.dispatchEvent(a)}),w.port1.start()}}e.NestedWorker=C}),define(Ce[242],ke([1,0,4,30,42,3]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new D.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new D.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new D.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)("outputService");var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(T){this.a.has(T.id)||(this.a.set(T.id,T),this.b.fire(T.id))}getChannels(){const T=[];return this.a.forEach(N=>T.push(N)),T}getChannel(T){return this.a.get(T)}removeChannel(T){this.a.delete(T),this.c.fire(T)}}C.Registry.add(e.Extensions.OutputChannels,new R),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new D.RawContextKey("activeOutputChannel","")}),define(Ce[105],ke([1,0,5,3,18,25,11,242,59,26,36,121,23,9,43,4,6]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class l extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(v,t,d,r,u){super(),this.id=v,this.name=t,this.m=d,this.n=r,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(i=>this.setLevel(i)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Clear,v)}replace(v){const t=this.k;this.info(v),this.n.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(v,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:t))}hide(){this.n.$close(this.id)}g(v,t){this.k+=h.VSBuffer.fromString(t).byteLength,(0,S.log)(this.m,v,t),this.visible&&(this.m.flush(),this.n.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class g extends l{appendLine(v){this.append(v)}}let E=class{constructor(v,t,d,r,u,i){this.i=t,this.j=d,this.k=r,this.l=u,this.m=i,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(v,t,d){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,u=(0,b.isString)(t)?t:void 0;if((0,b.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let i;const p=this.i.environment.extensionLogLevel?.find(([o])=>M.ExtensionIdentifier.equals(d.identifier,o))?.[1];p&&(i=(0,S.parseLogLevel)(p));const c=r?this.o(v,i,d):this.n(v,u,d);return c.then(o=>{this.g.set(o.id,o),o.visible=o.id===this.h}),r?this.r(v,i??this.m.getLevel(),c):this.q(v,c)}async n(v,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,u=this.k.extUri.joinPath(r,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),p=await this.a.$register(v,u,t,d.identifier.value);return new l(p,v,i,this.a,d)}async o(v,t,d){const r=await this.p(d),u=this.k.extUri.joinPath(r,`${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=u.toString(),p=this.l.createLogger(u,{id:i,name:v,logLevel:t,extensionId:d.identifier.value});return new g(i,v,p,this.a,d)}p(v){let t=this.d.get(v.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}return d})())}return t}q(v,t){let d=!1;const r=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return v},append(u){r(),t.then(i=>i.append(u))},appendLine(u){r(),t.then(i=>i.appendLine(u))},clear(){r(),t.then(u=>u.clear())},replace(u){r(),t.then(i=>i.replace(u))},show(u,i){r(),t.then(p=>p.show(u,i))},hide(){r(),t.then(u=>u.hide())},dispose(){d=!0,t.then(u=>u.dispose())}}}r(v,t,d){const r=new s.DisposableStore,u=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},i=r.add(new a.Emitter);function p(c){t=c,i.fire(c)}return d.then(c=>{r.add(c),c.logLevel!==t&&p(c.logLevel),r.add(c.onDidChangeLogLevel(o=>p(o)))}),{...this.q(v,d),get logLevel(){return t},onDidChangeLogLevel:i.event,trace(c,...o){u(),d.then(f=>f.trace(c,...o))},debug(c,...o){u(),d.then(f=>f.debug(c,...o))},info(c,...o){u(),d.then(f=>f.info(c,...o))},warn(c,...o){u(),d.then(f=>f.warn(c,...o))},error(c,...o){u(),d.then(f=>f.error(c,...o))},dispose(){r.dispose()}}}};E=qe([je(0,D.IExtHostRpcService),je(1,T.IExtHostInitDataService),je(2,y.IExtHostConsumerFileSystem),je(3,N.IExtHostFileSystemInfo),je(4,S.ILoggerService),je(5,S.ILogService)],E),e.ExtHostOutputService=E,e.IExtHostOutputService=(0,C.createDecorator)("IExtHostOutputService")}),define(Ce[243],ke([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Ce[244],ke([1,0,40,15,19,21,24,2,3,175,53,191,243]),function(te,e,n,C,D,M,S,R,y,T,N,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let b=class cn{constructor(a,s,l,g){this.d=a,this.e=s,this.f=l,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??a})()}hasValidBasename(a,s,l){return typeof s=="string"||typeof s>"u"?this.a.then(g=>this.h(a,g,s)):this.h(a,s,l)}h(a,s,l){return a.scheme===C.Schemas.file||a.scheme===C.Schemas.vscodeRemote?(0,n.isValidBasename)(l??(0,S.basename)(a),s===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,s){if(a.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,T.getVirtualWorkspaceScheme)(s.getWorkspace());if(l)return l;const g=s.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=s.getWorkspace().configuration;return E?E.scheme:C.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?D.win32:D.posix)}async fileURI(a){let s="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const g=a.indexOf("/",2);g===-1?(s=a.substring(2),a="/"):(s=a.substring(2,g),a=a.substring(g)||"/")}return R.URI.from({scheme:C.Schemas.file,authority:s,path:a,query:"",fragment:""})}};b=qe([je(1,h.IRemoteAgentService),je(2,w.IWorkbenchEnvironmentService),je(3,N.IWorkspaceContextService)],b),e.AbstractPathService=b}),define(Ce[106],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(S,R){this.line=S,this.character=R}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,R){return new n(0,0)}with(S){return new n(0,0)}}e.Position=n;class C{constructor(S,R,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(S,R),this.end=new n(y,T)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new C(0,0,0,0)}with(S){return new C(0,0,0,0)}}e.Range=C;var D;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[47],ke([1,0,16,35,22,40,10,3,19,12,106,17]),function(te,e,n,C,D,M,S,R,y,T,N,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const h="\u27EA ",b=" characters skipped \u27EB",m=(h.length+b.length+5)*2;e.ISearchService=(0,R.createDecorator)("searchService");var a;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function l(ue){return!!ue.preview}e.resultIsMatch=l;function g(ue){return!!ue.resource}e.isFileMatch=g;function E(ue){return!!ue.message}e.isProgressMessage=E;var L;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(L=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(ae){this.resource=ae,this.results=[]}}e.FileMatch=v;class t{constructor(ae,se,Y){this.ranges=se;const G=Array.isArray(se)?se:[se];if(Y&&Y.matchLines===1&&d(G)){ae=(0,S.getNLines)(ae,Y.matchLines);let Z="",he=0,Te=0;const Ne=Math.floor(Y.charsPerLine/5),Ke=[];for(const Pe of G){const Se=Math.max(Pe.startColumn-Ne,0),Ie=Pe.startColumn+Y.charsPerLine;if(Se>Te+Ne+m){const oe=h+(Se-Te)+b;Z+=oe+ae.slice(Se,Ie),he+=Se-(Te+oe.length)}else Z+=ae.slice(Te,Ie);Ke.push(new u(0,Pe.startColumn-he,Pe.endColumn-he)),Te=Ie}this.preview={text:Z,matches:Array.isArray(this.ranges)?Ke:Ke[0]}}else{const Z=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ae,matches:(0,n.mapArrayOrNot)(se,he=>new r(he.startLineNumber-Z,he.startColumn,he.endLineNumber-Z,he.endColumn))}}}}e.TextSearchMatch=t;function d(ue){const ae=ue[0].startLineNumber;for(const se of ue)if(se.startLineNumber!==ae||se.endLineNumber!==ae)return!1;return!0}class r{constructor(ae,se,Y,G){this.startLineNumber=ae,this.startColumn=se,this.endLineNumber=Y,this.endColumn=G}}e.SearchRange=r;class u extends r{constructor(ae,se,Y){super(ae,se,ae,Y)}}e.OneLineRange=u;var i;(function(ue){ue.List="list",ue.Tree="tree"})(i=e.ViewMode||(e.ViewMode={}));var p;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function c(ue,ae=!0){const se=ue&&ue.files&&ue.files.exclude,Y=ae&&ue&&ue.search&&ue.search.exclude;if(!se&&!Y)return;if(!se||!Y)return se||Y;let G=Object.create(null);return G=D.mixin(G,D.deepClone(se)),G=D.mixin(G,D.deepClone(Y),!0),G}e.getExcludes=c;function o(ue,ae){return ue.excludePattern&&C.match(ue.excludePattern,ae)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&C.match(ue.includePattern,ae)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(se=>{const Y=se.folder.fsPath;if(M.isEqualOrParent(ae,Y)){const G=y.relative(Y,ae);return!se.includePattern||!!C.match(se.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var f;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(ae,se){super(ae),this.code=se}}e.SearchError=k;function A(ue){const ae=ue.message;if((0,T.isCancellationError)(ue))return new k(ae,f.canceled);try{const se=JSON.parse(ae);return new k(se.message,se.code)}catch{return new k(ae,f.other)}}e.deserializeSearchError=A;function V(ue){const ae={message:ue.message,code:ue.code};return new Error(JSON.stringify(ae))}e.serializeSearchError=V;function _(ue){return ue.type==="error"?!0:ue.type==="success"}e.isSerializedSearchComplete=_;function K(ue){return ue.type==="success"}e.isSerializedSearchSuccess=K;function O(ue){return!!ue.path}e.isSerializedFileMatch=O;function B(ue,ae){const se=ue.searchPath?ue.searchPath:ue.relativePath;return(0,S.fuzzyContains)(se,ae)}e.isFilePatternMatch=B;class P{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=P;function F(ue,ae){const se={...ue||{},...ae||{}};return Object.keys(se).filter(Y=>{const G=se[Y];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=F;class H{constructor(ae,se){this.c=null,this.a={...ae.excludePattern||{},...se.excludePattern||{}},this.b=C.parse(this.a);let Y=ae.includePattern;se.includePattern&&(Y?Y={...Y,...se.includePattern}:Y=se.includePattern),Y&&(this.c=C.parse(Y))}matchesExcludesSync(ae,se,Y){return!!(this.b&&this.b(ae,se,Y))}includedInQuerySync(ae,se,Y){return!(this.b&&this.b(ae,se,Y)||this.c&&!this.c(ae,se,Y))}includedInQuery(ae,se,Y){const G=this.b(ae,se,Y),Z=()=>this.c?!!this.c(ae,se,Y):!0;return(0,w.isThenable)(G)?G.then(he=>he?!1:Z()):Z()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=H;function j(ue){for(const ae in ue)if(typeof ue[ae]!="boolean")return!0;return!1}function de(ue){if(!ue)return;let ae;return se=>(ae||(ae=(ue()||Promise.resolve([])).then(Y=>Y?re(Y):{})),ae.then(Y=>!!Y[se]))}e.hasSiblingPromiseFn=de;function pe(ue){if(!ue)return;let ae;return se=>{if(!ae){const Y=ue();ae=Y?re(Y):{}}return!!ae[se]}}e.hasSiblingFn=pe;function re(ue){const ae={};for(const se of ue)ae[se]=!0;return ae}}),define(Ce[31],ke([1,0,16,17,20,4,6,48,15,113,24,10,9,2,146,3,11,163,53,36,26,18,8,7,55,47,5]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v,t,d,r,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function p(K,O,B){return new N.ExtUri(P=>k(P,B)).isEqual(K,O)}function c(K,O,B){return p(K.uri,O.uri,B)?0:(0,w.compare)(K.uri.toString(),O.uri.toString())}function o(K,O,B){return K.index!==O.index?K.index<O.index?-1:1:p(K.uri,O.uri,B)?(0,w.compare)(K.name,O.name):(0,w.compare)(K.uri.toString(),O.uri.toString())}function f(K,O,B,P){const F=K.slice(0).sort((j,de)=>B(j,de,P)),H=O.slice(0).sort((j,de)=>B(j,de,P));return(0,n.delta)(F,H,(j,de)=>B(j,de,P))}function k(K,O){const B=O.getCapabilities(K.scheme);return!(B&&B&1024)}class A extends g.Workspace{static toExtHostWorkspace(O,B,P,F){if(!O)return{workspace:null,added:[],removed:[]};const{id:H,name:j,folders:de,configuration:pe,transient:re,isUntitled:ue}=O,ae=[],se=B;B?de.forEach((he,Te)=>{const Ne=b.URI.revive(he.uri),Ke=A.o(P||B,Ne,F);Ke?(Ke.name=he.name,Ke.index=he.index,ae.push(Ke)):ae.push({uri:Ne,name:he.name,index:Te})}):ae.push(...de.map(({uri:he,name:Te,index:Ne})=>({uri:b.URI.revive(he),name:Te,index:Ne}))),ae.sort((he,Te)=>he.index<Te.index?-1:1);const Y=new A(H,j,ae,!!re,pe?b.URI.revive(pe):null,!!ue,he=>k(he,F)),{added:G,removed:Z}=f(se?se.workspaceFolders:[],Y.workspaceFolders,c,F);return{workspace:Y,added:G,removed:Z}}static o(O,B,P){for(let F=0;F<O.folders.length;F++){const H=O.workspaceFolders[F];if(p(H.uri,B,P))return H}}constructor(O,B,P,F,H,j,de){super(O,P.map(pe=>new g.WorkspaceFolder(pe)),F,H,de),this.t=B,this.u=j,this.q=[],this.s=R.TernarySearchTree.forUris(de),P.forEach(pe=>{this.q.push(pe),this.s.set(pe.uri,pe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,B){return B&&this.s.get(O)&&(O=(0,N.dirname)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let V=class{constructor(O,B,P,F,H){this.c=new M.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new M.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.AsyncEmitter,this.h=F,this.s=P,this.t=H,this.j=new T.Counter,this.k=new C.Barrier,this.o=O.getProxy(i.MainContext.MainThreadWorkspace),this.q=O.getProxy(i.MainContext.MainThreadMessageService);const j=B.workspace;this.l=j?new A(j.id,j.name,[],!!j.transient,j.configuration?b.URI.revive(j.configuration):null,!!j.isUntitled,de=>k(de,P)):void 0}$initializeWorkspace(O,B){this.v=B,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?b.URI.from({scheme:y.Schemas.untitled,path:(0,N.basename)((0,N.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,B,P,...F){const H=[];if(Array.isArray(F)&&F.forEach(ue=>{b.URI.isUri(ue.uri)&&!H.some(ae=>p(ae.uri,ue.uri,this.s))&&H.push({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri)})}),this.n||[B,P].some(ue=>typeof ue!="number"||ue<0)||P===0&&H.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if(B+P>j.length)return!1;const de=j.slice(0);de.splice(B,P,...H.map(ue=>({uri:ue.uri,name:ue.name||(0,N.basenameOrAuthority)(ue.uri),index:void 0})));for(let ue=0;ue<de.length;ue++){const ae=de[ue];if(de.some((se,Y)=>Y!==ue&&p(ae.uri,se.uri,this.s)))return!1}de.forEach((ue,ae)=>ue.index=ae);const{added:pe,removed:re}=f(j,de,o,this.s);if(pe.length===0&&re.length===0)return!1;if(this.o){const ue=O.displayName||O.name;this.o.$updateWorkspaceFolders(ue,B,P,H).then(void 0,ae=>{this.n=void 0;const se={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(l.Severity.Error,(0,m.localize)(0,null,ue,ae.toString()),se,[])})}return this.y(de),!0}getWorkspaceFolder(O,B){if(!!this.x)return this.x.getWorkspaceFolder(O,B)}async getWorkspaceFolder2(O,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,B)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,B){let P,F="";if(typeof O=="string"?(P=b.URI.file(O),F=O):typeof O<"u"&&(P=O,F=O.fsPath),!P)return F;const H=this.getWorkspaceFolder(P,!0);if(!H)return F;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let j=(0,N.relativePath)(H.uri,P);return B&&H.name&&(j=`${H.name}/${j}`),j}y(O){this.x&&(this.n=A.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:B,added:P,removed:F}=A.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:P,removed:F}))}findFiles(O,B,P,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let j;if(B===null?j=!1:B&&(typeof B=="string"?j=B:j=B.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:de,folder:pe}=_(t.GlobPattern.from(O));return this.o.$startFileSearch((0,h.withUndefinedAsNull)(de),(0,h.withUndefinedAsNull)(pe),(0,h.withUndefinedAsNull)(j),(0,h.withUndefinedAsNull)(P),H).then(re=>Array.isArray(re)?re.map(ue=>b.URI.revive(ue)):[])}async findTextInFiles(O,B,P,F,H=D.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),de=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:pe,folder:re}=_(t.GlobPattern.from(B.include)),ue=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,ae={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:de,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:pe,excludePattern:ue},se=!1;if(this.u[j]=Y=>{if(se)return;const G=b.URI.revive(Y.resource);Y.results.forEach(Z=>{(0,u.resultIsMatch)(Z)?P({uri:G,preview:{text:Z.preview.text,matches:(0,n.mapArrayOrNot)(Z.preview.matches,he=>new d.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,n.mapArrayOrNot)(Z.ranges,he=>new d.Range(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):P({uri:G,text:Z.text,lineNumber:Z.lineNumber})})},H.isCancellationRequested)return{};try{const Y=await this.o.$startTextSearch(O,(0,h.withUndefinedAsNull)(re),ae,j,H);return delete this.u[j],Y||{}}catch(Y){throw delete this.u[j],Y}}$handleTextSearchResult(O,B){this.u[B]?.(O)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,B){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,B);const P=this.t.transformOutgoingScheme(O),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,P),(0,S.toDisposable)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(O,B){this.h.info("Getting edit session identifier for workspaceFolder",O);const P=await this.resolveWorkspaceFolder(b.URI.revive(O));if(!P){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",P);const F=this.w.get(P.uri.scheme);if(this.h.info(`Provider for scheme ${P.uri.scheme} is defined: `,!!F),!F)return;const H=await F.provideEditSessionIdentity(P,B);if(this.h.info("Provider returned edit session identifier: ",H),!!H)return H}async $provideEditSessionIdentityMatch(O,B,P,F){this.h.info("Getting edit session identifier for workspaceFolder",O);const H=await this.resolveWorkspaceFolder(b.URI.revive(O));if(!H){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",H);const j=this.w.get(H.uri.scheme);if(this.h.info(`Provider for scheme ${H.uri.scheme} is defined: `,!!j),!j)return;const de=await j.provideEditSessionIdentityMatch?.(B,P,F);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(O){return(B,P,F)=>{const H=function(de){B.call(P,de)};return H.extension=O,this.A.event(H,void 0,F)}}async $onWillCreateEditSessionIdentity(O,B,P){const F=await this.resolveWorkspaceFolder(b.URI.revive(O));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},B,async(H,j)=>{const de=Date.now();await Promise.resolve(H),Date.now()-de>P&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),B.isCancellationRequested}};V=qe([je(0,v.IExtHostRpcService),je(1,L.IExtHostInitDataService),je(2,E.IExtHostFileSystemInfo),je(3,s.ILogService),je(4,r.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function _(K){let O,B;return K&&(typeof K=="string"?O=K:(O=K.pattern,B=b.URI.revive(K.baseUri))),{includePattern:O,folder:B}}}),define(Ce[32],ke([1,0,22,4,31,5,7,166,93,9,17,3,18,11,2]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(d,r){if(r){const u=r.split(".");let i=d;for(let p=0;i&&p<u.length;p++)i=i[u[p]];return i}}function s(d){return d instanceof m.URI}function l(d){return d&&d.uri instanceof m.URI&&d.languageId&&typeof d.languageId=="string"}function g(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function E(d){return d&&d.uri instanceof m.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function L(d){if(s(d))return{resource:d};if(l(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(g(d))return{overrideIdentifier:d.languageId};if(E(d))return{resource:d.uri};if(d===null)return{resource:null}}let v=class{constructor(r,u,i){this.a=r.getProxy(M.MainContext.MainThreadConfiguration),this.c=u,this.b=i,this.d=new N.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,u){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(r,u))}};v=qe([je(0,h.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,b.ILogService)],v),e.ExtHostConfiguration=v;class t{constructor(r,u,i,p){this.a=new C.Emitter,this.b=r,this.f=p,this.c=u,this.e=R.Configuration.parse(i),this.d=this.k(i.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,u){const i={data:this.e.toData(),workspace:this.c.workspace};this.e=R.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(u,i))}getConfiguration(r,u,i){const p=L(u)||{},c=this.g(r?a(this.e.getValue(void 0,p,this.c.workspace),r):this.e.getValue(void 0,p,this.c.workspace));r&&this.h(r,p,i?.identifier);function o(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(k){return typeof a(c,k)<"u"},get:(k,A)=>{this.h(r?`${r}.${k}`:k,p,i?.identifier);let V=a(c,k);if(typeof V>"u")V=A;else{let _;const K=(O,B)=>{let P;const F=()=>{_=_||(0,n.deepClone)(c),P=P||a(_,B)};return(0,T.isObject)(O)?new Proxy(O,{get:(H,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return F(),()=>P;if(_)return P=P||a(_,B),P[j];const de=H[j];return typeof j=="string"?K(de,`${B}.${j}`):de},set:(H,j,de)=>(F(),P&&(P[j]=de),!0),deleteProperty:(H,j)=>(F(),P&&delete P[j],!0),defineProperty:(H,j,de)=>(F(),P&&Object.defineProperty(P,j,de),!0)}):O};V=K(V,k)}return V},update:(k,A,V,_)=>{k=r?`${r}.${k}`:k;const K=o(V);return A!==void 0?this.b.$updateConfigurationOption(K,k,A,p,_):this.b.$removeConfigurationOption(K,k,p,_)},inspect:k=>{k=r?`${r}.${k}`:k;const A=this.e.inspect(k,p,this.c.workspace);if(A)return{key:k,defaultValue:(0,n.deepClone)(A.policy?.value??A.default?.value),globalValue:(0,n.deepClone)(A.user?.value??A.application?.value),workspaceValue:(0,n.deepClone)(A.workspace?.value),workspaceFolderValue:(0,n.deepClone)(A.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(A.default?.override),globalLanguageValue:(0,n.deepClone)(A.user?.override??A.application?.override),workspaceLanguageValue:(0,n.deepClone)(A.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(A.workspaceFolder?.override),languageIds:(0,n.deepClone)(A.overrideIdentifiers)}}};return typeof c=="object"&&(0,n.mixin)(f,c,!1),Object.freeze(f)}g(r){const u=i=>(0,T.isObject)(i)?new Proxy(i,{get:(p,c)=>u(p[c]),set:(p,c,o)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(p,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(p,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):i;return u(r)}h(r,u,i){const p=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),c=i?`[${i.value}] `:"";if(p===4){typeof u?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){u?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,u){const i=new R.ConfigurationChangeEvent(r,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(p,c)=>i.affectsConfiguration(p,L(c))})}k(r){return r.reduce((u,i)=>(u.set(i[0],i[1]),u),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[107],ke([1,0,2,17,4,5,7,31,57,32,20,60,18,26,3,15,21,11,76,202,12]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(O){function B(F){if(F!=null)return F}O.from=B;function P(F){if(F!=null)return F}O.to=P})(t||(t={}));var d;(function(O){function B(F){if(F!=null)return F}O.from=B;function P(F){if(F!=null)return F}O.to=P})(d||(d={}));var r;(function(O){function B(F){if(F!=null)return F}O.from=B;function P(F){if(F!=null)return F}O.to=P})(r||(r={}));var u;(function(O){function B(H){if(H){const j=H;return j&&!!j.process}else return!1}O.is=B;function P(H){if(H==null)return;const j={process:H.process,args:H.args};return H.options&&(j.options=r.from(H.options)),j}O.from=P;function F(H){if(H!=null)return new S.ProcessExecution(H.process,H.args,H.options)}O.to=F})(u||(u={}));var i;(function(O){function B(F){if(F!=null)return F}O.from=B;function P(F){if(F!=null)return F}O.to=P})(i||(i={}));var p;(function(O){function B(H){if(H){const j=H;return j&&(!!j.commandLine||!!j.command)}else return!1}O.is=B;function P(H){if(H==null)return;const j={};return H.commandLine!==void 0?j.commandLine=H.commandLine:(j.command=H.command,j.args=H.args),H.options&&(j.options=i.from(H.options)),j}O.from=P;function F(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new S.ShellExecution(H.commandLine,H.options):new S.ShellExecution(H.command,H.args?H.args:[],H.options)}O.to=F})(p||(p={}));var c;(function(O){function B(H){if(H){const j=H;return j&&j.customExecution==="customExecution"}else return!1}O.is=B;function P(H){return{customExecution:"customExecution"}}O.from=P;function F(H,j){return j.get(H)}O.to=F})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var o;(function(O){function B(P,F){let H;return P.scope!==void 0&&typeof P.scope!="number"?H=P.scope.uri:P.scope!==void 0&&typeof P.scope=="number"&&(P.scope===S.TaskScope.Workspace&&F&&F.workspaceFile?H=F.workspaceFile:H=E.USER_TASKS_GROUP_KEY),{id:P._id,workspaceFolder:H}}O.from=B})(o=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(O){function B(P){if(P!=null)return{_id:P.id,isDefault:P.isDefault}}O.from=B})(f||(f={}));var k;(function(O){function B(H,j){if(H==null)return[];const de=[];for(const pe of H){const re=P(pe,j);re&&de.push(re)}return de}O.fromMany=B;function P(H,j){if(H==null)return;let de;H.execution instanceof S.ProcessExecution?de=u.from(H.execution):H.execution instanceof S.ShellExecution?de=p.from(H.execution):H.execution&&H.execution instanceof S.CustomExecution&&(de=c.from(H.execution));const pe=t.from(H.definition);let re;return H.scope?typeof H.scope=="number"?re=H.scope:re=H.scope.uri:re=S.TaskScope.Workspace,!pe||!re?void 0:{_id:H._id,definition:pe,name:H.name,source:{extensionId:j.identifier.value,label:H.source,scope:re},execution:de,isBackground:H.isBackground,group:f.from(H.group),presentationOptions:d.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}O.from=P;async function F(H,j,de){if(H==null)return;let pe;u.is(H.execution)?pe=u.to(H.execution):p.is(H.execution)?pe=p.to(H.execution):c.is(H.execution)&&(pe=c.to(H._id,de));const re=t.to(H.definition);let ue;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?ue=H.source.scope:ue=await j.resolveWorkspaceFolder(n.URI.revive(H.source.scope)):ue=S.TaskScope.Workspace),!re||!ue)return;const ae=new S.Task(re,ue,H.name,H.source.label,pe,H.problemMatchers);return H.isBackground!==void 0&&(ae.isBackground=H.isBackground),H.group!==void 0&&(ae.group=S.TaskGroup.from(H.group._id),ae.group&&H.group.isDefault&&(ae.group=new S.TaskGroup(ae.group.id,ae.group.label),H.group.isDefault===!0&&(ae.group.isDefault=H.group.isDefault))),H.presentationOptions&&(ae.presentationOptions=d.to(H.presentationOptions)),H._id&&(ae._id=H._id),H.detail&&(ae.detail=H.detail),ae}O.to=F})(k=e.TaskDTO||(e.TaskDTO={}));var A;(function(O){function B(F){return F}O.from=B;function P(F){if(!!F)return Object.assign(Object.create(null),F)}O.to=P})(A||(A={}));class V{constructor(B,P,F){this._id=P,this.a=F,v.set(this,void 0),Je(this,v,B,"f")}get task(){return this.a}terminate(){Le(this,v,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}v=new WeakMap;let _=class{constructor(B,P,F,H,j,de,pe,re){this.q=new D.Emitter,this.r=new D.Emitter,this.s=new D.Emitter,this.t=new D.Emitter,this.a=B.getProxy(M.MainContext.MainThreadTask),this.b=F,this.c=H,this.d=j,this.e=de,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=pe,this.g=re,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,P,F){if(!F)return new S.Disposable(()=>{});const H=this.w();return this.j.set(H,{type:P,provider:F,extension:B}),this.a.$registerTaskProvider(H,P),new S.Disposable(()=>{this.j.delete(H),this.a.$unregisterTaskProvider(H)})}registerTaskSystem(B,P){this.a.$registerTaskSystem(B,P)}fetchTasks(B){return this.a.$fetchTasks(A.from(B)).then(async P=>{const F=[];for(const H of P){const j=await k.to(H,this.b,this.m);j&&F.push(j)}return F})}get taskExecutions(){const B=[];return this.k.forEach(P=>B.push(P)),B}terminateTask(B){if(!(B instanceof V))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,P,F){const H=this.m.get(B.id);H&&(this.o.set(B.id,H),this.e.attachPtyToTerminal(P,await H.callback(F))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const P=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:P})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const P=await this.y(B.id);this.s.fire({execution:P,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const P=await this.y(B.id);this.t.fire({execution:P,exitCode:B.exitCode})}$provideTasks(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));const H=[],j=(0,C.asPromise)(()=>F.provider.provideTasks(N.CancellationToken.None)).then(de=>this.u(P,H,F,de));return new Promise(de=>{j.then(pe=>{Promise.all(H).then(()=>{de(pe)})})})}async $resolveTask(B,P){const F=this.j.get(B);if(!F)return Promise.reject(new Error("no handler found"));if(P.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${P.definition.type}] cannot be resolved by provider of type [${F.type}].`);const H=await k.to(P,this.b,this.m);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const j=await F.provider.resolveTask(H,N.CancellationToken.None);if(!j)return;this.z(j,F);const de=k.from(j,F.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(de.execution)&&await this.x(de,j,!0),await this.v(de)}w(){return this.h++}async x(B,P,F){const H=await this.a.$createTaskId(B);!F&&!this.m.has(H)&&(this.n.add(H),this.o.set(H,P.execution)),this.m.set(H,P.execution)}async y(B,P){if(typeof B=="string"){const j=this.l.get(B);if(!j)throw new L.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const F=this.l.get(B.id);if(F)return F;const H=new Promise((j,de)=>{function pe(re,ue,ae){ae?j(new V(re,ue.id,ae)):de("Unexpected: Task does not exist.")}P?pe(this,B,P):k.to(B.task,this.b,this.m).then(re=>pe(this,B,re))});return this.l.set(B.id,H),H.then(j=>(this.k.set(B.id,j),j),j=>Promise.reject(j))}z(B,P){B._deprecated&&this.g.report("Task.constructor",P.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const F=this.n.values();let H=F.next();for(;!H.done;)!this.o.has(H.value)&&this.p!==H.value&&(this.m.delete(H.value),this.n.delete(H.value)),H=F.next()}};_=qe([je(0,h.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],_),e.ExtHostTaskBase=_;let K=class extends _{constructor(B,P,F,H,j,de,pe,re){super(B,P,F,H,j,de,pe,re),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(B,P){if(!P.execution)throw new Error("Tasks to execute must include an execution");const F=k.from(P,B);if(F===void 0)throw new Error("Task is not valid");if(c.is(F.execution))await this.x(F,P,!1);else throw new L.NotSupportedError;const H=await this.y(await this.a.$getTaskExecution(F),P);return this.a.$executeTask(F).catch(j=>{throw new Error(j)}),H}u(B,P,F,H){const j=[];if(H)for(const de of H){this.z(de,F),(!de.definition||!B[de.definition.type])&&this.f.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=k.from(de,F.extension);pe&&c.is(pe.execution)?(j.push(pe),P.push(this.x(pe,de,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:F.extension}}async v(B){if(c.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,P){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,P,F){}};K=qe([je(0,h.IExtHostRpcService),je(1,b.IExtHostInitDataService),je(2,R.IExtHostWorkspace),je(3,y.IExtHostDocumentsAndEditors),je(4,T.IExtHostConfiguration),je(5,w.IExtHostTerminalService),je(6,l.ILogService),je(7,g.IExtHostApiDeprecationService)],K),e.WorkerExtHostTask=K,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(Ce[245],ke([1,0,19,20,39,35,24,77,47]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(h,b,m){this.k=h,this.l=b,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&M.parse(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&M.parse(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const b=this.k.folderQueries||[];return new Promise((m,a)=>{const s=l=>{this.f++,h(l)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(l=>{const g=l.toString(),E=n.basename(g);this.j&&this.j(g,E)||this.v(s,{base:l,basename:E})}),Promise.all(b.map(l=>this.p(l,s))).then(l=>{m({limitHit:this.e,stats:l[0]||void 0})},l=>{a(new Error((0,D.toErrorMessage)(l)))})})}async p(h,b){const m=new C.CancellationTokenSource,a=this.q(h),s=this.r(),l=new y.QueryGlobTester(this.k,h),g=!l.hasSiblingExcludeClauses();let E;try{this.h.add(m),E=R.StopWatch.create();const L=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,m.token),v=E.elapsed(),t=R.StopWatch.create();return this.g&&!this.e||(L&&L.forEach(d=>{const r=n.posix.relative(h.folder.path,d.path);if(g){const u=n.basename(d.path);this.v(b,{base:h.folder,relativePath:r,basename:u});return}this.s(s,h.folder,r,b)}),this.g&&!this.e)?null:(this.u(s,l,b),{providerTime:v,postProcessTime:t.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(h){const b=(0,y.resolvePatternsForProvider)(this.k.includePattern,h.includePattern),m=(0,y.resolvePatternsForProvider)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:m,includes:b,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},b,m,a){if(m===this.a){const l=n.basename(this.a);this.v(a,{base:b,relativePath:this.a,basename:l})}function s(l){const g=n.basename(l),E=n.dirname(l);let L=h[E];L||(L=h[E]=[],s(E)),L.push({base:b,relativePath:l,basename:g})}s(m)}u({rootEntries:h,pathToEntries:b},m,a){const s=this,l=this.a;function g(E){const L=(0,y.hasSiblingFn)(()=>E.map(v=>v.basename));for(let v=0,t=E.length;v<t;v++){const d=E[v],{relativePath:r,basename:u}=d;if(m.matchesExcludesSync(r,u,l!==u?L:void 0))continue;const i=b[r];if(i)g(i);else{if(r===l)continue;s.v(a,d)}if(s.e)break}}g(h)}v(h,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(b))}}class N{constructor(){this.b=new Map}fileSearch(h,b,m,a){const s=this.c(h.cacheKey),l=new T(h,b,s&&s.token);let g=0;const E=L=>{g+=L.length,m(L.map(v=>this.d(v)))};return this.e(l,N.a,E,a).then(L=>({limitHit:L.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:L.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(!!h)return this.b.has(h)||this.b.set(h,new C.CancellationTokenSource),this.b.get(h)}d(h){return h.relativePath?{resource:S.joinPath(h.base,h.relativePath)}:{resource:h.base}}e(h,b,m,a){a.onCancellationRequested(()=>{h.cancel()});const s=g=>{g&&(l.push(g),b>0&&l.length>=b&&(m(l),l=[]))};let l=[];return h.search(s).then(g=>(l.length&&m(l),g),g=>(l.length&&m(l),Promise.reject(g)))}}N.a=512,e.FileSearchManager=N}),define(Ce[246],ke([1,0,16,62,35,87,28,15,19,24,10,9,2,262,155,41,11,53,97,244,47]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=class{constructor(k,A,V,_,K){this.a=k,this.b=A,this.c=V,this.d=_,this.e=K}text(k,A,V={}){k=this.f(k,V);const _=this.a.getValue(),K=A&&A.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(A?.map(l.toWorkspaceFolder),V),type:2,contentPattern:k,previewOptions:V.previewOptions,maxFileSize:V.maxFileSize,usePCRE2:_.search.usePCRE2||K||!1,beforeContext:V.beforeContext,afterContext:V.afterContext,userDisabledExcludesAndIgnoreFiles:V.disregardExcludeSettings&&V.disregardIgnoreFiles}}f(k,A){const V=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const _={...k,wordSeparators:V.editor.wordSeparators};return this.j(k,A)&&(_.isCaseSensitive=!0),this.k(k)&&(_.isMultiline=!0),_}file(k,A={}){return{...this.h(k,A),type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey}}g(k,A){return k?(k=Array.isArray(k)?k.map(i):i(k),A?this.parseSearchPaths(k):{pattern:d(...Array.isArray(k)?k:[k])}):{}}h(k=[],A={}){const V=this.g(A.includePattern,A.expandPatterns),_=this.g(A.excludePattern,A.expandPatterns),K=k.length>1,O=(V.searchPaths&&V.searchPaths.length?V.searchPaths.map(F=>this.q(F,A,_)):k.map(F=>this.r(F,A,_,K))).filter(F=>!!F),B={_reason:A._reason,folderQueries:O,usingSearchPaths:!!(V.searchPaths&&V.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:_.pattern,includePattern:V.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const F=n.coalesce(n.flatten(this.c.groups.map(de=>de.editors.map(pe=>pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const H=F.filter(de=>(0,L.pathIncludedInQuery)(B,de.fsPath)),j=this.i(H);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...B,...j}}const P=A.extraFileResources&&A.extraFileResources.filter(F=>(0,L.pathIncludedInQuery)(B,F.fsPath));return B.extraFileResources=P&&P.length?P:void 0,B}i(k){const A=[],V=new S.ResourceMap,_={};let K=!1;return k.forEach(O=>{if(O.scheme===R.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(O)){const P=this.b.getWorkspaceFolder(O)?.uri??O.with({path:y.dirname(O.fsPath)});let F=V.get(P);F||(K=!0,F={folder:P,includePattern:{}},A.push(F),V.set(P,F));const H=y.relative(P.fsPath,O.fsPath);(0,w.assertIsDefined)(F.includePattern)[H.replace(/\\/g,"/")]=!0}else O.fsPath&&(K=!0,_[O.fsPath]=!0)}),{folderQueries:A,includePattern:_,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(k,A){if(A.isSmartCase){if(k.isRegExp){if(N.containsUppercaseCharacter(k.pattern,!0))return!0}else if(N.containsUppercaseCharacter(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,b.isMultilineRegexSource)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const A=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),_=(Array.isArray(k)?k:r(k)).map(j=>{const de=this.e.resolvedUserHome;return de?(0,M.untildify)(j,de.scheme===R.Schemas.file?de.fsPath:de.path):j}),K=C.groupBy(_,j=>A(j)?"searchPaths":"exprSegments"),O=(K.exprSegments||[]).map(j=>N.rtrim(j,"/")).map(j=>N.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),u(j))),B={},P=this.m(K.searchPaths||[]);P&&P.length&&(B.searchPaths=P);const F=n.flatten(O),H=d(...F);return H&&(B.pattern=H),B}l(k,A){return A.disregardExcludeSettings?void 0:(0,L.getExcludes)(k,!A.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const A=k.flatMap(_=>{let{pathPortion:K,globPortion:O}=t(_);return O&&(O=p(O)),this.n(K).flatMap(P=>this.o(P,O))}),V=new Map;return A.forEach(_=>{const K=_.searchPath.toString(),O=V.get(K);O?_.pattern&&(O.pattern=O.pattern||{},O.pattern[_.pattern]=!0):V.set(K,{searchPath:_.searchPath,pattern:_.pattern?d(_.pattern):void 0})}),Array.from(V.values())}n(k){if(y.isAbsolute(k)){const A=this.b.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==R.Schemas.file?[{searchPath:A[0].uri.with({path:k})}]:[{searchPath:h.URI.file(y.normalize(k))}]}if(this.b.getWorkbenchState()===2){const A=this.b.getWorkspace().folders[0].uri;if(k=i(k),k.startsWith("../")||k===".."){const _=y.posix.resolve(A.path,k);return[{searchPath:A.with({path:_})}]}const V=p(k);return[{searchPath:A,pattern:V}]}else{if(k==="./"||k===".\\")return[];{const A=k.replace(/^\.[\/\\]/,""),_=this.b.getWorkspace().folders.map(K=>{const O=A.match(new RegExp(`^${N.escapeRegExpCharacters(K.name)}(?:/(.*)|$)`));return O?{match:O,folder:K}:null}).filter(w.isDefined);if(_.length)return _.map(K=>{const O=K.match[1];return{searchPath:K.folder.uri,pattern:O&&p(O)}});{const K=k.match(/\.[\/\\](.+)[\/\\]?/),O=K?K[1]:k,B=m.localize(0,null,O);throw new Error(B)}}}}o(k,A){const V=k.pattern&&A?`${k.pattern}/${A}`:k.pattern||A,_=[{searchPath:k.searchPath,pattern:V}];return V&&!V.endsWith("**")&&_.push({searchPath:k.searchPath,pattern:V+"/**"}),_}q(k,A,V){const _=this.r((0,l.toWorkspaceFolder)(k.searchPath),A,V,!1);return _?{..._,includePattern:k.pattern}:null}r(k,A,V,_){let K;const O=h.URI.isUri(k)?k:k.uri;if(V.searchPaths){const j=V.searchPaths.filter(de=>(0,T.isEqual)(de.searchPath,O))[0];if(j&&!j.pattern)return null;j&&(K=j.pattern)}const B=this.a.getValue({resource:O}),F={...this.l(B,A)||{},...K||{}},H=h.URI.isUri(k)?(0,T.basename)(k):k.name;return{folder:O,folderName:_?H:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof A.disregardParentIgnoreFiles=="boolean"?A.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!B.search.followSymlinks}}};v=qe([je(0,a.IConfigurationService),je(1,l.IWorkspaceContextService),je(2,g.IEditorGroupsService),je(3,s.ILogService),je(4,E.IPathService)],v),e.QueryBuilder=v;function t(f){const k=f.match(/[\*\{\}\(\)\[\]\?]/);if(k){const A=k.index,V=f.substr(0,A).match(/[/|\\][^/\\]*$/);if(V){let _=f.substr(0,V.index);return _.match(/[/\\]/)||(_+="/"),{pathPortion:_,globPortion:f.substr((V.index||0)+1)}}}return{pathPortion:f}}function d(...f){return f.length?f.reduce((k,A)=>(k[A]=!0,k),Object.create(null)):void 0}function r(f){return D.splitGlobAware(f,",").map(k=>k.trim()).filter(k=>!!k.length)}function u(f){return[`**/${f}/**`,`**/${f}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function i(f){return f.replace(/\\/g,"/")}function p(f){return i(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(f){return f.replace(/([?*[\]])/g,"[$1]")}function o(f,k){f=n.distinct(f,_=>_.toString());const A=[],V=k.getWorkspace();return f&&f.forEach(_=>{let K;if(k.getWorkbenchState()===2)K=(0,T.relativePath)(V.folders[0].uri,_),K&&K!=="."&&(K="./"+K);else{const O=k.getWorkspaceFolder(_);if(O){const B=O.name;if(V.folders.filter(F=>F.name===B).length===1){const F=(0,T.relativePath)(O.uri,_);F===""?K=`./${O.name}`:K=`./${O.name}/${F}`}else K=_.fsPath}}K&&A.push(c(K))}),A}e.resolveResourcesForSearchIncludes=o}),define(Ce[247],ke([1,0,24,2,20,12,3,246,47,53]),function(te,e,n,C,D,M,S,R,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function w(a,s){const l=s.activationEvents;if(!l)return Promise.resolve(void 0);const g=[],E=[];for(const u of l)if(/^workspaceContains:/.test(u)){const i=u.substr(18);i.indexOf("*")>=0||i.indexOf("?")>=0||a.forceUsingSearch?E.push(i):g.push(i)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let L;const v=new Promise((u,i)=>{L=u}),t=u=>L({activationEvent:u}),d=Promise.all(g.map(u=>h(a,u,t))).then(()=>{}),r=b(a,s.identifier,E,t);return Promise.all([d,r]).then(()=>{L(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function h(a,s,l){for(const g of a.folders)if(await a.exists(n.joinPath(C.URI.revive(g),s))){l(`workspaceContains:${s}`);return}}async function b(a,s,l,g){if(l.length===0)return Promise.resolve(void 0);const E=new D.CancellationTokenSource,L=a.checkExists(a.folders,l,E.token),v=setTimeout(async()=>{E.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},N);let t=!1;try{t=await L}catch(d){M.isCancellationError(d)||M.onUnexpectedError(d)}E.dispose(),clearTimeout(v),t&&g(`workspaceContains:${l.join(",")}`)}function m(a,s,l,g){const E=a.get(S.IInstantiationService),L=a.get(y.ISearchService),t=E.createInstance(R.QueryBuilder).file(s.map(d=>(0,T.toWorkspaceFolder)(C.URI.revive(d))),{_reason:"checkExists",includePattern:l,exists:!0});return L.fileSearch(t,g).then(d=>!!d.limitHit,d=>M.isCancellationError(d)?!1:Promise.reject(d))}e.checkGlobFileExists=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,n,C,D){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!D:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?D.call(te,n):D?D.value=n:e.set(te,n),n},Le=this&&this.__classPrivateFieldGet||function(te,e,n,C){if(n==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!C:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?C:n==="a"?C.call(te):C?C.value:e.get(te)};define(Ce[33],ke([1,0,140,19,82,24,17,6,48,2,11,5,32,192,80,31,27,98,12,25,23,177,7,94,3,26,81,18,67,69,60,4,247,79,179,15,78,77]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v,t,d,r,u,i,p,c,o,f,k,A,V,_,K,O,B){"use strict";var P,F,H;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let j=class Ui extends R.Disposable{constructor(se,Y,G,Z,he,Te,Ne,Ke,Pe,Se,Ie){super(),this.a=this.B(new k.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=Y,this.g=G,this.f=Ne,this.j=Z,this.k=he,this.l=Te,this.m=Pe,this.p=Se,this.s=Ie,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new l.ExtensionDescriptionRegistry(this.f.allExtensions);const oe=(0,s.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new l.ExtensionDescriptionRegistry(re(this.F,oe)),this.G=new m.ExtHostStorage(this.g,this.l),this.H=new V.ExtHostSecretState(this.g),this.I=Ke,this.h=se.createChild(new c.ServiceCollection([m.IExtHostStorage,this.G],[V.IExtHostSecretState,this.H])),this.J=this.B(new b.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(le,J,I)=>{this.v.$onExtensionActivationError(le,g.transformErrorForSerialization(J),I)},actualActivateExtension:async(le,J)=>{if(l.ExtensionDescriptionRegistry.isHostExtension(le,this.D,this.F))return await this.v.$activateExtension(le,J),new b.HostExtension;const I=this.D.getExtensionDescription(le);return this.Y(I,J)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),D.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(se){g.onUnexpectedError(se)}}async Q(){this.I.onWillDeactivateAll();let se=[];try{se=this.D.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.X(he))}catch{}await Promise.all(se)}terminate(se,Y=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${se}`),this.l.flush(),this.p.dispose(),this.J.dispose(),g.setUnexpectedErrorHandler(Z=>{this.l.error(Z)}),this.g.dispose();const G=this.Q();Promise.race([(0,S.timeout)(5e3),G]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${Y}`):this.l.info(`Extension host exiting with code ${Y}`),this.l.flush(),this.l.dispose(),this.c.exit(Y)})}isActivated(se){return this.z.isOpen()?this.J.isActivated(se):!1}async getExtension(se){const Y=await this.v.$getExtension(se);let G;if(Y?.browserNlsBundleUris){G={};for(const Z of Object.keys(Y.browserNlsBundleUris))G[Z]=T.URI.revive(Y.browserNlsBundleUris[Z])}return Y&&{...Y,identifier:new E.ExtensionIdentifier(Y.identifier.value),extensionLocation:T.URI.revive(Y.extensionLocation),browserNlsBundleUris:G}}R(se,Y){return this.J.activateByEvent(se,Y)}S(se,Y){return this.J.activateById(se,Y)}activateByIdWithErrors(se,Y){return this.S(se,Y).then(()=>{const G=this.J.getActivatedExtension(se);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(se=>this.D)}getExtensionExports(se){return this.z.isOpen()?this.J.getActivatedExtension(se).exports:null}async U(se){if(se.scheme!==K.Schemas.file)return se;const Y=await this.c.realpath(se.fsPath);return T.URI.file(Y)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(se=>new ue(se))),this.L}async W(se){const Y=y.TernarySearchTree.forUris(G=>M.extUriBiasedIgnorePathCase.ignorePathCasing(G));return await Promise.all(se.map(async G=>{if(this.ob(G)){const Z=await this.U(G.extensionLocation);Y.set(Z,G)}})),Y}X(se){let Y=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(se))return Y;const G=this.J.getActivatedExtension(se);if(!G)return Y;try{typeof G.module.deactivate=="function"&&(Y=Promise.resolve(G.module.deactivate()).then(void 0,Z=>(this.l.error(Z),Promise.resolve(void 0))))}catch(Z){this.l.error(`An error occurred when deactivating the extension '${se.value}':`),this.l.error(Z)}try{(0,R.dispose)(G.subscriptions)}catch(Z){this.l.error(`An error occurred when deactivating the subscriptions for extension '${se.value}':`),this.l.error(Z)}return Y}async Y(se,Y){return this.f.remote.isRemote?this.v.$onWillActivateExtension(se.identifier):await this.v.$onWillActivateExtension(se.identifier),this.ab(se,Y).then(G=>{const Z=G.activationTimes;return this.v.$onDidActivateExtension(se.identifier,Z.codeLoadingTime,Z.activateCallTime,Z.activateResolvedTime,Y),this.Z(se,Y,"success",Z),G},G=>{throw this.Z(se,Y,"failure"),G})}Z(se,Y,G,Z){const he=de(se,Y);this.u.$publicLog2("extensionActivationTimes",{...he,...Z||{},outcome:G})}ab(se,Y){const G=de(se,Y);this.u.$publicLog2("activatePlugin",G);const Z=this.ob(se);if(!Z)return Promise.resolve(new b.EmptyExtension(b.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${se.identifier.value}, startup: ${Y.startup}, activationEvent: '${Y.activationEvent}'${se.identifier.value!==Y.extensionId.value?`, root cause: ${Y.extensionId.value}`:""}`),this.l.flush();const he=new b.ExtensionActivationTimesBuilder(Y.startup);return Promise.all([this.pb(se,(0,M.joinPath)(se.extensionLocation,Z),he),this.bb(se)]).then(Te=>(D.mark(`code/extHost/willActivateExtension/${se.identifier.value}`),Ui.cb(this.l,se.identifier,Te[0],Te[1],he))).then(Te=>(D.mark(`code/extHost/didActivateExtension/${se.identifier.value}`),Te))}bb(se){const Y=new v.ExtensionGlobalMemento(se,this.G),G=new v.ExtensionMemento(se.identifier.value,!1,this.G),Z=new _.ExtensionSecrets(se,this.H),he=se.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Te=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${se.identifier.value}`),Promise.all([Y.whenReady,G.whenReady,this.I.whenReady]).then(()=>{const Ne=this;let Ke,Pe;const Se=(0,s.isProposedApiEnabled)(se,"ipc")?this.f.messagePorts?.get(E.ExtensionIdentifier.toKey(se.identifier)):void 0;return Object.freeze({globalState:Y,workspaceState:G,secrets:Z,subscriptions:[],get extensionUri(){return se.extensionLocation},get extensionPath(){return se.extensionLocation.fsPath},asAbsolutePath(Ie){return C.join(se.extensionLocation.fsPath,Ie)},get storagePath(){return Ne.I.workspaceValue(se)?.fsPath},get globalStoragePath(){return Ne.I.globalValue(se).fsPath},get logPath(){return C.join(Ne.f.logsLocation.fsPath,se.identifier.value)},get logUri(){return T.URI.joinPath(Ne.f.logsLocation,se.identifier.value)},get storageUri(){return Ne.I.workspaceValue(se)},get globalStorageUri(){return Ne.I.globalValue(se)},get extensionMode(){return he},get extension(){return Ke===void 0&&(Ke=new pe(Ne,se.identifier,se,Te,!1)),Ke},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(se,"extensionRuntime"),Ne.extensionRuntime},get environmentVariableCollection(){return Ne.p.getEnvironmentVariableCollection(se)},get messagePassingProtocol(){if(!Pe){if(!Se)return;const Ie=k.Event.buffer(k.Event.fromDOMEventEmitter(Se,"message",oe=>oe.data));Se.start(),Pe={onDidReceiveMessage:Ie,postMessage:Se.postMessage.bind(Se)}}return Pe}})})}static cb(se,Y,G,Z,he){return G=G||{activate:void 0,deactivate:void 0},this.db(se,Y,G,Z,he).then(Te=>new b.ActivatedExtension(!1,null,he.build(),G,Te,Z.subscriptions))}static db(se,Y,G,Z,he){if(typeof G.activate=="function")try{he.activateCallStart(),se.trace(`ExtensionService#_callActivateOptional ${Y.value}`);const Te=typeof global=="object"?global:self,Ne=G.activate.apply(Te,[Z]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(Ne).then(Ke=>(he.activateResolveStop(),Ke))}catch(Te){return Promise.reject(Te)}else return Promise.resolve(G)}eb(se,Y){this.S(se.identifier,{startup:!1,extensionId:se.identifier,activationEvent:Y}).then(void 0,G=>{this.l.error(G)})}fb(){this.v.$setPerformanceMarks(D.getMarks());for(const se of this.D.getAllExtensionDescriptions())if(se.activationEvents)for(const Y of se.activationEvents)Y==="onStartupFinished"&&this.eb(se,Y)}gb(){const se=this.R("*",!0).then(void 0,he=>{this.l.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.hb(he.added)));const Y=this.j.workspace?this.j.workspace.folders:[],G=this.hb(Y),Z=Promise.all([se,G]).then(()=>{});return Promise.race([Z,(0,S.timeout)(1e4)]).then(()=>{this.fb()}),Z}hb(se){return se.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(Y=>this.ib(se,Y))).then(()=>{})}async ib(se,Y){if(this.isActivated(Y.identifier))return;const G=!this.f.remote.isRemote&&!!this.f.remote.authority,Z={logService:this.l,folders:se.map(Te=>Te.uri),forceUsingSearch:G,exists:Te=>this.c.exists(Te.fsPath),checkExists:(Te,Ne,Ke)=>this.t.$checkExists(Te,Ne,Ke)},he=await(0,A.checkActivateWorkspaceContainsExtension)(Z,Y);if(!!he)return this.S(Y.identifier,{startup:!0,extensionId:Y.identifier,activationEvent:he.activationEvent}).then(void 0,Te=>this.l.error(Te))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(se){throw console.error(se),se}}async jb(){const{extensionDevelopmentLocationURI:se,extensionTestsLocationURI:Y}=this.f.environment;if(!se||!Y)throw new Error(n.localize(0,null));const G=await this.pb(null,Y,new b.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(n.localize(1,null,Y.toString()));return new Promise((Z,he)=>{const Te=(Pe,Se)=>{Pe?he(Pe):Z(typeof Se=="number"&&Se>0?1:0)},Ne=(0,M.originalFSPath)(Y),Ke=G.run(Ne,Te);Ke&&Ke.then&&Ke.then(()=>{Z(0)}).catch(Pe=>{he(Pe instanceof Error&&Pe.stack?Pe.stack:String(Pe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(se,Y){return this.M[se]=Y,(0,R.toDisposable)(()=>{delete this.M[se]})}async lb(se){const Y=se.indexOf("+");if(Y===-1)throw new Error("Not an authority that can be resolved!");const G=se.substr(0,Y);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${G}`,!1),{authorityPrefix:G,resolver:this.M[G]}}async $resolveAuthority(se,Y){const G=B.StopWatch.create(!1),Z=()=>`[resolveAuthority(${(0,d.getRemoteAuthorityPrefix)(se)},${Y})][${G.elapsed()}ms] `,he=Se=>this.l.info(`${Z()}${Se}`),Te=(Se,Ie=void 0)=>this.l.error(`${Z()}${Se}`,Ie);he("activating resolver...");const{authorityPrefix:Ne,resolver:Ke}=await this.lb(se);if(!Ke)return Te("no resolver"),{type:"error",error:{code:d.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Ne}.`,detail:void 0}};const Pe=new S.IntervalTimer;try{he("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Ke)),Pe.cancelAndSet(()=>he("waiting..."),1e3),he("invoking resolve()..."),D.mark(`code/extHost/willResolveAuthority/${Ne}`);const Se=await Ke.resolve(se,{resolveAttempt:Y});D.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),Pe.dispose(),he(`returned ${Se.host}:${Se.port}`);const Ie={authority:se,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},oe={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ie,options:oe,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(D.mark(`code/extHost/didResolveAuthorityError/${Ne}`),Pe.dispose(),Te("returned an error",Se),Se instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(se,Y){this.l.info(`$getCanonicalURI invoked for authority (${(0,d.getRemoteAuthorityPrefix)(se)})`);const{resolver:G}=await this.lb(se);if(!G)return null;const Z=T.URI.revive(Y);if(typeof G.getCanonicalURI>"u")return Z;const he=await(0,S.asPromise)(()=>G.getCanonicalURI(Z));return he||Z}static mb(se,Y,G){const Z=new l.ExtensionDescriptionRegistry(se.getAllExtensionDescriptions());Z.deltaExtensions(G.toAdd,G.toRemove);const he=(0,s.extensionIdentifiersArrayToSet)(Y.getAllExtensionDescriptions().map(Ne=>Ne.identifier));for(const Ne of G.myToRemove)he.delete(E.ExtensionIdentifier.toKey(Ne));for(const Ne of G.myToAdd)he.add(E.ExtensionIdentifier.toKey(Ne));const Te=re(Z,he);return{globalRegistry:Z,myExtensions:Te}}$startExtensionHost(se){se.toAdd.forEach(Z=>Z.extensionLocation=T.URI.revive(Z.extensionLocation));const{globalRegistry:Y,myExtensions:G}=Ui.mb(this.F,this.D,se);return this.F.set(Y.getAllExtensionDescriptions()),this.D.set(G),this.kb()}$activateByEvent(se,Y){return Y===1?this.R(se,!1):this.z.wait().then(G=>this.R(se,!1))}async $activate(se,Y){return await this.z.wait(),this.D.getExtensionDescription(se)?(await this.S(se,Y),!0):!1}async $deltaExtensions(se){se.toAdd.forEach(Te=>Te.extensionLocation=T.URI.revive(Te.extensionLocation));const{globalRegistry:Y,myExtensions:G}=Ui.mb(this.F,this.D,se),Z=await this.W(G);return(await this.getExtensionPathIndex()).setSearchTree(Z),this.F.set(Y.getAllExtensionDescriptions()),this.D.set(G),Promise.resolve(void 0)}async $test_latency(se){return se}async $test_up(se){return se.byteLength}async $test_down(se){const Y=L.VSBuffer.alloc(se),G=Math.random()%256;for(let Z=0;Z<se;Z++)Y.writeUInt8(G,Z);return Y}async $updateRemoteConnectionData(se){this.P=se,this.a.fire()}};j=qe([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,p.IExtHostRpcService),je(3,a.IExtHostWorkspace),je(4,h.IExtHostConfiguration),je(5,N.ILogService),je(6,u.IExtHostInitDataService),je(7,i.IExtensionStoragePaths),je(8,o.IExtHostTunnelService),je(9,f.IExtHostTerminalService),je(10,O.IExtHostLocalizationService)],j),e.AbstractExtHostExtensionService=j;function de(ae,se){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:se.activationEvent,reasonId:se.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class pe{constructor(se,Y,G,Z,he){P.set(this,void 0),F.set(this,void 0),H.set(this,void 0),Je(this,P,se,"f"),Je(this,F,Y,"f"),Je(this,H,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=C.normalize((0,M.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=Z,this.isFromDifferentExtensionHost=he}get isActive(){return Le(this,P,"f").isActivated(Le(this,H,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Le(this,P,"f").getExtensionExports(Le(this,H,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Le(this,P,"f").activateByIdWithErrors(Le(this,H,"f"),{startup:!1,extensionId:Le(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=pe,P=new WeakMap,F=new WeakMap,H=new WeakMap;function re(ae,se){return ae.getAllExtensionDescriptions().filter(Y=>se.has(E.ExtensionIdentifier.toKey(Y.identifier)))}class ue{constructor(se){this.a=se}setSearchTree(se){this.a=se}findSubstr(se){return this.a.findSubstr(se)}forEach(se){return this.a.forEach(se)}}e.ExtensionPaths=ue}),define(Ce[248],ke([1,0,82,2,5,32,27,25,18,26,3,33,51,11,10]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(v,t,d,r,u,i,p){this.c=v,this.d=t,this.e=d,this.f=r,this.g=u,this.h=i,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new l(this.c,t,this.d,v,this.i)),this.register(this.e.createInstance(g,t)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(E,t,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const t of v.nodeModuleName)this.a.set(t,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(t=>v.alternativeModuleName(t))}};a=qe([je(2,N.IInstantiationService),je(3,M.IExtHostConfiguration),je(4,w.IExtHostExtensionService),je(5,T.IExtHostInitDataService),je(6,b.ILogService)],a),e.RequireInterceptor=a;let s=class rn{constructor(v){if(v.environment.appRoot&&rn.a.size){const t=(0,m.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),d="[a-z0-9_.-]",r=`@${d}+\\/${d}+|${d}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const t=this.b.exec(this.c(v));if(!t)return;const[,d,r,u]=t,i=rn.a.get(r);if(i!==void 0)return console.warn(`${r} as been renamed to ${i}, please update your imports`),d+i+u}c(v){return v.replace(/\\/g,"/")}};s.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=qe([je(0,T.IExtHostInitDataService)],s);class l{constructor(v,t,d,r,u){this.c=v,this.d=t,this.e=d,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(v,t){const d=this.d.findSubstr(t);if(d){let r=this.a.get(R.ExtensionIdentifier.toKey(d.identifier));return r||(r=this.c(d,this.e,this.f),this.a.set(R.ExtensionIdentifier.toKey(d.identifier),r)),r}if(!this.b){let r="";this.d.forEach((u,i)=>r+=`	${i} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let g=class{constructor(v,t,d){this.d=v,this.nodeModuleName="keytar",this.a=t.getProxy(D.MainContext.MainThreadTelemetry);const{environment:r}=d,u=t.getProxy(D.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;h.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.b=new Set,this.b.add(`${i}/node_modules.asar/keytar`),this.b.add(`${i}/node_modules/keytar`)}this.c={getPassword:(i,p)=>u.$getPassword(i,p),setPassword:(i,p,c)=>u.$setPassword(i,p,c),deletePassword:(i,p)=>u.$deletePassword(i,p),findPassword:i=>u.$findPassword(i),findCredentials(i){return u.$findCredentials(i)}}}load(v,t){const d=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:d?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const t=v.length;if(t<=7||!this.b)return;const d=t-7;if((v.charAt(d)==="/"||v.charAt(d)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};g=qe([je(1,y.IExtHostRpcService),je(2,T.IExtHostInitDataService)],g);let E=class{constructor(v,t,d){this.e=v,this.f=t,this.nodeModuleName=["open","opn"],this.d=d.getProxy(D.MainContext.MainThreadTelemetry);const r=d.getProxy(D.MainContext.MainThreadWindow);this.c=(u,i)=>{const p=C.URI.parse(u);return i?this.g(u,i):p.scheme==="http"||p.scheme==="https"?r.$openUri(p,u,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?r.$openUri(p,u,{}):this.g(u,i)}}load(v,t,d){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=d(v),this.c}g(v,t){return this.i(),this.b(v,t)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};E=qe([je(2,y.IExtHostRpcService)],E)}),define(Ce[108],ke([1,0,85,6,19,51,3,57,58,33,7,31,189,32]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class m extends h.AbstractVariableResolverService{constructor(l,g,E,L,v,t,d){function r(){if(E){const u=E.activeEditor();if(u)return u.document.uri;const i=L.tabGroups.all.find(p=>p.isActive)?.activeTab;if(i!==void 0){if(i.input instanceof N.TextDiffTabInput||i.input instanceof N.NotebookDiffEditorTabInput)return i.input.modified;if(i.input instanceof N.TextTabInput||i.input instanceof N.NotebookEditorTabInput||i.input instanceof N.CustomEditorTabInput)return i.input.uri}}}super({getFolderUri:u=>{const i=t.folders.filter(p=>p.name===u);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,i)=>v.getConfiguration(void 0,u).get(i),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=r();if(u)return D.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const u=r();if(u){const i=g.getWorkspaceFolder(u);if(i)return D.normalize(i.uri.fsPath)}}},getSelectedText:()=>{if(E){const u=E.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(E){const u=E.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>l.getExtension(u)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(M.env))}}let a=class extends C.Disposable{constructor(l,g,E,L,v){super(),this.b=l,this.c=g,this.g=E,this.h=L,this.i=v,this.a=new n.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};a=qe([je(0,T.IExtHostExtensionService),je(1,w.IExtHostWorkspace),je(2,R.IExtHostDocumentsAndEditors),je(3,b.IExtHostConfiguration),je(4,y.IExtHostEditorTabs)],a),e.ExtHostVariableResolverProviderService=a}),define(Ce[109],ke([1,0,17,4,9,2,3,5,58,33,18,7,31,182,184,32,108]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,i,p,c,o){this.D=u,this.E=i,this.F=p,this.G=c,this.H=o,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new C.Emitter,this.n=new C.Emitter,this.o=new C.Emitter,this.u=new C.Emitter,this.k=r.getProxy(R.MainContext.MainThreadDebugService),this.z=new C.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new E(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(f=>{f.onDidChange(k=>{this.I(f)}),this.I(f)})}asDebugSourceUri(r,u){const i=r;if(typeof i.sourceReference=="number"&&i.sourceReference>0){let p=`debug:${encodeURIComponent(i.path||"")}`,c="?";return u&&(p+=`${c}session=${encodeURIComponent(u.id)}`,c="&"),p+=`${c}ref=${i.sourceReference}`,M.URI.parse(p)}else{if(i.path)return M.URI.file(i.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const u=[];for(const i of r.getAllExtensionDescriptions())if(i.contributes){const p=i.contributes.debuggers;if(p&&p.length>0)for(const c of p)(0,m.isDebuggerMainContribution)(c)&&u.push(c.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){this.T();const u=r.filter(c=>{const o=c.id;return this.w.has(o)?!1:(this.w.set(o,c),!0)});this.U(u,[],[]);const i=[],p=new Map;for(const c of u)if(c instanceof w.SourceBreakpoint){let o=p.get(c.location.uri.toString());o||(o={type:"sourceMulti",uri:c.location.uri,lines:[]},p.set(c.location.uri.toString(),o),i.push(o)),o.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof w.FunctionBreakpoint&&i.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(i)}removeBreakpoints(r){this.T();const u=r.filter(o=>this.w.delete(o.id));this.U([],u,[]);const i=u.filter(o=>o instanceof w.SourceBreakpoint).map(o=>o.id),p=u.filter(o=>o instanceof w.FunctionBreakpoint).map(o=>o.id),c=u.filter(o=>o instanceof w.DataBreakpoint).map(o=>o.id);return this.k.$unregisterBreakpoints(i,p,c)}startDebugging(r,u,i){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:i.parentSession?i.parentSession.id:void 0,lifecycleManagedByParent:i.lifecycleManagedByParent,repl:i.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:i.noDebug,compact:i.compact,suppressSaveBeforeStart:i.suppressSaveBeforeStart,suppressDebugStatusbar:i.suppressDebugStatusbar??i.debugUI?.simple,suppressDebugToolbar:i.suppressDebugToolbar??i.debugUI?.simple,suppressDebugView:i.suppressDebugView??i.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,i){if(!u)return new w.Disposable(()=>{});const p=this.d++;return this.f.push({type:r,handle:p,provider:u}),this.k.$registerDebugConfigurationProvider(r,i,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,p),new w.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==u),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(r,u,i){if(!i)return new w.Disposable(()=>{});if(!this.P(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:u,handle:p,factory:i}),this.k.$registerDebugAdapterDescriptorFactory(u,p),new w.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==i),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new w.Disposable(()=>{});const i=this.i++;return this.j.push({type:r,handle:i,factory:u}),new w.Disposable(()=>{this.j=this.j.filter(p=>p.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let i;const p=await this.W(r);return p&&(i={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(i,u)}J(r,u){if(r.type==="implementation")return new v(r.implementation)}K(){}async $startDASession(r,u){const i=this,p=await this.V(u);return this.R(this.M(p.type),p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const o=this.L(c),f=this.J(o,p);if(!f)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const k=f;return this.A.set(r,k),this.Q(p).then(A=>(A&&this.B.set(r,A),k.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const _=V,K={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const O=await this.C.sign(_.arguments.value);K.body={signature:O},k.sendResponse(K)}else throw new Error("no signer")}catch(O){K.success=!1,K.message=O.message,k.sendResponse(K)}}else A&&A.onDidSendMessage&&A.onDidSendMessage(V),V=(0,m.convertToVSCPaths)(V,!0),i.k.$acceptDAMessage(r,V)}),k.onError(V=>{A&&A.onError&&A.onError(V),this.k.$acceptDAError(r,V.name,V.message,V.stack)}),k.onExit(V=>{A&&A.onExit&&A.onExit((0,D.withNullAsUndefined)(V),void 0),this.k.$acceptDAExit(r,(0,D.withNullAsUndefined)(V),void 0)}),A&&A.onWillStartSession&&A.onWillStartSession(),k.startSession()))})}$sendDAMessage(r,u){u=(0,m.convertToDAPaths)(u,!1);const i=this.B.get(r);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(u),this.A.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.B.get(r);this.B.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const i=this.A.get(r);return this.A.delete(r),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],i=[],p=[];if(r.added)for(const c of r.added){const o=c.id;if(o&&!this.w.has(o)){let f;if(c.type==="function")f=new w.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")f=new w.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const k=M.URI.revive(c.uri);f=new w.SourceBreakpoint(new w.Location(k,new w.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,w.setBreakpointId)(f,o),this.w.set(o,f),u.push(f)}}if(r.removed)for(const c of r.removed){const o=this.w.get(c);o&&(this.w.delete(c),i.push(o))}if(r.changed){for(const c of r.changed)if(c.id){const o=this.w.get(c.id);if(o){if(o instanceof w.FunctionBreakpoint&&c.type==="function"){const f=o;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.functionName=c.functionName}else if(o instanceof w.SourceBreakpoint&&c.type==="source"){const f=o;f.enabled=c.enabled,f.condition=c.condition,f.hitCondition=c.hitCondition,f.logMessage=c.logMessage,f.location=new w.Location(M.URI.revive(c.uri),new w.Position(c.line,c.character))}p.push(o)}}}this.U(u,i,p)}$provideDebugConfigurations(r,u,i){return(0,n.asPromise)(async()=>{const p=this.O(r);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.W(u);return p.provideDebugConfigurations(c,i)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(r,u,i,p){return(0,n.asPromise)(async()=>{const c=this.O(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const o=await this.W(u);return c.resolveDebugConfiguration(o,i,p)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,i,p){return(0,n.asPromise)(async()=>{const c=this.O(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const o=await this.W(u);return c.resolveDebugConfigurationWithSubstitutedVariables(o,i,p)})}async $provideDebugAdapter(r,u){const i=this.N(r);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(u);return this.R(i,p).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.L(c)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const p={session:await this.V(r),event:u.event,body:u.body};this.u.fire(p)}L(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const u=this.h.filter(i=>i.type===r);if(u.length>0)return u[0].factory}N(r){const u=this.h.filter(i=>i.handle===r);if(u.length>0)return u[0].factory}O(r){const u=this.f.filter(i=>i.handle===r);if(u.length>0)return u[0].provider}P(r,u){if(r.contributes){const i=r.contributes.debuggers;if(i&&i.length>0){for(const p of i)if(p.label&&p.type&&p.type===u)return!0}}return!1}Q(r){const i=r.configuration.type,p=this.j.filter(c=>c.type===i||c.type==="*").map(c=>(0,n.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(o=>o,o=>null));return Promise.race([Promise.all(p).then(c=>{const o=c.filter(f=>!!f);if(o.length>0)return new L(o)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async R(r,u){const i=u.configuration.debugServer;if(typeof i=="number")return Promise.resolve(new w.DebugAdapterServer(i));if(r){const c=await this.E.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(u,this.S(u,c))).then(o=>{if(o)return o})}const p=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,p))}S(r,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,u,i){(r.length>0||u.length>0||i.length>0)&&this.z.fire(Object.freeze({added:r,removed:u,changed:i}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const i=await this.W(r.folderUri),p=r.parent?this.l.get(r.parent):void 0;u=new g(this.k,r.id,r.type,r.name,i,r.configuration,p),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=M.URI.revive(r);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};l=qe([je(0,N.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],l),e.ExtHostDebugServiceBase=l;class g{constructor(r,u,i,p,c,o,f){this.d=r,this.f=u,this.g=i,this.h=p,this.i=c,this.j=o,this.k=f}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=g;class E{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=E;class L{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(i=>i.onExit?i.onExit(r,u):void 0)}}class v extends b.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=class extends l{constructor(r,u,i,p,c,o){super(r,u,i,p,c,o)}};t=qe([je(0,N.IExtHostRpcService),je(1,h.IExtHostWorkspace),je(2,T.IExtHostExtensionService),je(3,a.IExtHostConfiguration),je(4,y.IExtHostEditorTabs),je(5,s.IExtHostVariableResolverProvider)],t),e.WorkerExtHostDebugService=t}),define(Ce[249],ke([1,0,12,82,2,5,240,11,66,67,26,160,18,55,33,74]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class s{static async installEarlyHandler(E){const L=E.get(R.ILogService),t=E.get(h.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(d=>{L.error(d);const r=n.transformErrorForSerialization(d);t.$onUnexpectedError(r)})}static async installFullHandler(E){const L=E.get(R.ILogService),v=E.get(h.IExtHostRpcService),t=E.get(m.IExtHostExtensionService),d=E.get(a.IExtHostTelemetry),r=v.getProxy(M.MainContext.MainThreadExtensionService),u=v.getProxy(M.MainContext.MainThreadErrors),i=await t.getExtensionPathIndex(),p=new WeakMap;Error.prepareStackTrace=(c,o)=>{let f="",k,A;for(const V of o)f+=`
	at ${V.toString()}`,A=V.getFileName(),!k&&A&&(k=i.findSubstr(D.URI.file(A)));return p.set(c,k?.identifier),`${c.name||"Error"}: ${c.message||""}${f}`},n.setUnexpectedErrorHandler(c=>{L.error(c);const o=n.transformErrorForSerialization(c),f=p.get(c);if(!f){u.$onUnexpectedError(o);return}r.$onExtensionRuntimeError(f,o);const k=d.onExtensionError(f,c);L.trace("forwarded error to extension?",k,f)})}}Error.stackTraceLimit=100;class l{constructor(E,L,v,t,d){this.a=v,this.b=new S.RPCProtocol(E,null,t),L=l.e(L,this.b);const r=new T.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(N.IExtHostInitDataService,{_serviceBrand:void 0,...L,messagePorts:d}),r.set(h.IExtHostRpcService,new h.ExtHostRpcService(this.b)),r.set(b.IURITransformerService,new b.URITransformerService(t)),r.set(m.IHostUtils,v);const u=new w.InstantiationService(r,!0);u.invokeFunction(s.installEarlyHandler),this.d=u.invokeFunction(i=>i.get(R.ILogService)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",L),this.c=u.invokeFunction(i=>i.get(m.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(s.installFullHandler)}async asBrowserUri(E){const L=this.b.getProxy(M.MainContext.MainThreadExtensionService);return D.URI.revive(await L.$asBrowserUri(E))}terminate(E){this.c.terminate(E)}static e(E,L){E.allExtensions.forEach(t=>{t.extensionLocation=D.URI.revive(L.transformIncomingURIs(t.extensionLocation));const d={};t.browserNlsBundleUris&&(Object.keys(t.browserNlsBundleUris).forEach(r=>d[r]=D.URI.revive(L.transformIncomingURIs(t.browserNlsBundleUris[r]))),t.browserNlsBundleUris=d)}),E.environment.appRoot=D.URI.revive(L.transformIncomingURIs(E.environment.appRoot));const v=E.environment.extensionDevelopmentLocationURI;return v&&(E.environment.extensionDevelopmentLocationURI=v.map(t=>D.URI.revive(L.transformIncomingURIs(t)))),E.environment.extensionTestsLocationURI=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTestsLocationURI)),E.environment.globalStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.globalStorageHome)),E.environment.workspaceStorageHome=D.URI.revive(L.transformIncomingURIs(E.environment.workspaceStorageHome)),E.environment.extensionTelemetryLogResource=D.URI.revive(L.transformIncomingURIs(E.environment.extensionTelemetryLogResource)),E.nlsBaseUrl=D.URI.revive(L.transformIncomingURIs(E.nlsBaseUrl)),E.logsLocation=D.URI.revive(L.transformIncomingURIs(E.logsLocation)),E.logFile=D.URI.revive(L.transformIncomingURIs(E.logFile)),E.workspace=L.transformIncomingURIs(E.workspace),E}}e.ExtensionHostMain=l}),define(Ce[250],ke([1,0,16,17,20,39,15,19,24,2,47]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(g,E,L,v){this.d=g,this.e=E,this.f=L,this.g=v,this.a=null,this.b=!1,this.c=0}search(g,E){const L=this.d.folderQueries||[],v=new D.CancellationTokenSource;return E.onCancellationRequested(()=>v.cancel()),new Promise((t,d)=>{this.a=new b(g);let r=!1;const u=(i,p)=>{if(!r&&!this.b){const c=this.h(i);a(i)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,r=!0,v.cancel(),i=this.j(i,this.d.maxResults-this.c));const o=this.h(i);this.c+=o,(o>0||!a(i))&&this.a.add(i,p)}};Promise.all(L.map((i,p)=>this.k(i,c=>u(c,p),v.token))).then(i=>{v.dispose(),this.a.flush();const p=i.some(c=>!!c&&!!c.limitHit);t({limitHit:this.b||p,messages:(0,n.flatten)(i.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},i=>{v.dispose();const p=(0,M.toErrorMessage)(i);d(new Error(p))})})}h(g){return a(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}j(g,E){const L=Array.isArray(g.ranges)?g.ranges:[g.ranges],v=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:L.slice(0,E),preview:{matches:v.slice(0,E),text:g.preview.text},uri:g.uri}}async k(g,E,L){const v=new N.QueryGlobTester(this.d,g),t=[],d={report:i=>{if(!this.l(i))return;const p=g.folder.scheme===S.Schemas.file?(0,N.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(i.uri))):void 0,c=y.relativePath(g.folder,i.uri);if(c){const o=v.includedInQuery(c,R.basename(c),p);(0,C.isThenable)(o)?t.push(o.then(f=>{f&&E(i)})):o&&E(i)}}},r=this.n(g),u=await this.e.provideTextSearchResults(h(this.d.contentPattern),r,d,L);return t.length&&await Promise.all(t),u}l(g){if(a(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(g){const E=(0,N.resolvePatternsForProvider)(this.d.includePattern,g.includePattern),L=(0,N.resolvePatternsForProvider)(this.d.excludePattern,g.excludePattern),v={folder:T.URI.from(g.folder),excludes:L,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.f.toCanonicalName(g.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function h(l){return{isCaseSensitive:l.isCaseSensitive||!1,isRegExp:l.isRegExp||!1,isWordMatch:l.isWordMatch||!1,isMultiline:l.isMultiline||!1,pattern:l.pattern}}class b{constructor(g){this.e=g,this.b=-1,this.d=null,this.a=new s(512,E=>this.g(E))}add(g,E){this.d&&(this.b!==E||!y.isEqual(this.c,g.uri))&&(this.f(),this.d=null),this.d||(this.b=E,this.d={resource:g.uri,results:[]}),this.d.results.push(m(g))}f(){const g=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,g)}flush(){this.f(),this.a.flush()}g(g){this.e(g)}}e.TextSearchResultsCollector=b;function m(l){return a(l)?{preview:{matches:(0,n.mapArrayOrNot)(l.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:l.preview.text},ranges:(0,n.mapArrayOrNot)(l.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:l.text,lineNumber:l.lineNumber}}function a(l){return!!l.preview}e.extensionResultIsMatch=a;class s{constructor(g,E){this.g=g,this.h=E,this.c=0,this.d=[],this.e=0}addItem(g,E){!g||this.j(g,E)}addItems(g,E){!g||this.k(g,E)}j(g,E){this.d.push(g),this.e+=E,this.l()}k(g,E){this.d=this.d.concat(g),this.e+=E,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}s.a=4e3,s.b=50,e.BatchedCollector=s}),define(Ce[110],ke([1,0,6,5,3,245,18,55,11,2,250]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let w=class{constructor(a,s,l){this.k=a,this.l=s,this.n=l,this.c=this.k.getProxy(C.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.FileSearchManager}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const l=this.d++;return this.e.set(l,s),this.c.$registerTextSearchProvider(l,this.o(a)),(0,n.toDisposable)(()=>{this.g.delete(a),this.e.delete(l),this.c.$unregisterProvider(l)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const l=this.d++;return this.h.set(l,s),this.c.$registerFileSearchProvider(l,this.o(a)),(0,n.toDisposable)(()=>{this.i.delete(a),this.h.delete(l),this.c.$unregisterProvider(l)})}$provideFileSearchResults(a,s,l,g){const E=h(l),L=this.h.get(a);if(L)return this.j.fileSearch(E,L,v=>{this.c.$handleFileMatch(a,s,v.map(t=>t.resource))},g);throw new Error("unknown provider: "+a)}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,l,g){const E=this.e.get(a);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const L=h(l);return this.q(L,E).search(t=>this.c.$handleTextMatch(a,s,t),g)}$enableExtensionHostSearch(){}q(a,s){return new N.TextSearchManager(a,s,{readdir:l=>Promise.resolve([]),toCanonicalName:l=>l},"textSearchProvider")}};w=qe([je(0,S.IExtHostRpcService),je(1,R.IURITransformerService),je(2,y.ILogService)],w),e.ExtHostSearch=w;function h(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(b),extraFileResources:m.extraFileResources&&m.extraFileResources.map(a=>T.URI.revive(a))}}e.reviveQuery=h;function b(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(Ce[251],ke([1,0,66,105,31,103,32,37,57,60,107,109,110,80,69,76,104,59,36,79,74,58,220,11,176,108,78]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v,t,d,r,u,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(i.IExtHostLocalizationService,i.ExtHostLocalizationService,1),(0,n.registerSingleton)(d.ILoggerService,t.ExtHostLoggerService,1),(0,n.registerSingleton)(d.ILogService,r.ExtHostLogService,1),(0,n.registerSingleton)(a.IExtHostApiDeprecationService,a.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(R.IExtHostCommands,R.ExtHostCommands,0),(0,n.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,n.registerSingleton)(l.IExtHostConsumerFileSystem,l.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,n.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(C.IExtHostOutputService,C.ExtHostOutputService,1),(0,n.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch,0),(0,n.registerSingleton)(b.IExtHostStorage,b.ExtHostStorage,0),(0,n.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask,0),(0,n.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,n.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,n.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace,0),(0,n.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,0),(0,n.registerSingleton)(L.IExtHostTelemetry,L.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(Ce[252],ke([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class n{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(D){if(D&&this.a.has(D)){const M=this.a.get(D);return this.a.delete(D),M}}addDragOperationTransfer(D,M){this.a.set(D,M)}getRenderedTreeElement(D){if(this.b.has(D))return this.b.get(D)}addRenderedTreeItemElement(D,M){this.b.set(D,M)}removeRenderedTreeItemElement(D){this.b.has(D)&&this.b.delete(D)}}e.TreeviewsService=n}),define(Ce[253],ke([1,0,145,7,24,2,4,6,181,17,7,9,16,8,20,252,27]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(L,v){if((0,w.isString)(L))return{label:L};if(L&&typeof L=="object"&&typeof L.label=="string"){let t;return Array.isArray(L.highlights)&&(t=L.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:L.label,highlights:t}}}class g{constructor(v,t,d){this.d=v,this.e=t,this.f=d,this.a=new Map,this.b=new a.TreeviewsService;function r(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>r(u)?this.i(u):Array.isArray(u)&&u.length>0?u.map(i=>r(i)?this.i(i):i):u})}registerTreeDataProvider(v,t,d){const r=this.createTreeView(v,{treeDataProvider:t},d);return{dispose:()=>r.dispose()}}createTreeView(v,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],i=!!t.dragAndDropController?.handleDrag,p=!!t.dragAndDropController?.handleDrop,c=this.h(v,t,d),o=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:u,hasHandleDrag:i,hasHandleDrop:p});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,s.checkProposedApiEnabled)(d,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(f){c.message=f},get title(){return c.title},set title(f){c.title=f},get description(){return c.description},set description(f){c.description=f},get badge(){return c.badge},set badge(f){f!==void 0&&N.ViewBadge.isViewBadge(f)?c.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(c.badge=void 0)},reveal:(f,k)=>c.reveal(f,k),dispose:async()=>{await o,this.a.delete(v),c.dispose()}}}$getChildren(v,t){const d=this.a.get(v);return d?d.getChildren(t):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,t,d,r,u,i,p,c){const o=this.a.get(v);if(!o)return Promise.reject(new y.NoTreeViewError(v));const f=b.DataTransfer.toDataTransfer(d,async k=>(await this.d.$resolveDropFileData(v,t,k)).buffer);return p===v&&c&&await this.g(f,o,c,u,i),o.onDrop(f,r,u)}async g(v,t,d,r,u){const i=this.b.removeDragOperationTransfer(u);if(i)(await i)?.forEach((p,c)=>{p&&v.set(c,p)});else if(u&&t.handleDrag){const p=t.handleDrag(d,v,r);this.b.addDragOperationTransfer(u,p),await p}return v}async $handleDrag(v,t,d,r){const u=this.a.get(v);if(!u)return Promise.reject(new y.NoTreeViewError(v));const i=await this.g(new C.DataTransfer,u,t,r,d);if(!!i)return b.DataTransfer.toDataTransferDTO(i)}async $hasResolve(v){const t=this.a.get(v);if(!t)throw new y.NoTreeViewError(v);return t.hasResolve}$resolve(v,t,d){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);return r.resolveTreeItem(t,d)}$setExpanded(v,t,d){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);r.setExpanded(t,d)}$setSelection(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setSelection(t)}$setFocus(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setFocus(t)}$setVisible(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setVisible(t)}$changeCheckboxState(v,t){const d=this.a.get(v);if(!d)throw new y.NoTreeViewError(v);d.setCheckboxState(t)}h(v,t,d){const r=new E(v,t,this.d,this.e.converter,this.f,d);return this.a.set(v,r),r}i(v){const t=this.a.get(v.$treeViewId);return t&&"$treeItemHandle"in v?t.getExtensionElement(v.$treeItemHandle):t&&"$focusedTreeItem"in v&&v.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=g;class E extends R.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,t,d,r,u,i){if(super(),this.C=v,this.D=d,this.F=r,this.G=u,this.H=i,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new m.CancellationTokenSource,i.contributes&&i.contributes.views)for(const o in i.contributes.views)for(const f of i.contributes.views[o])f.id===v&&(this.J=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(o=>this.w.fire({message:!1,element:o})));let p,c;this.B(S.Event.debounce(this.w.event,(o,f)=>(o||(o={message:!1,elements:[]}),f.element!==!1&&(p||(p=new Promise(k=>c=k),this.y=this.y.then(()=>p)),Array.isArray(f.element)?o.elements.push(...f.element):o.elements.push(f.element)),f.message&&(o.message=!0),o),200,!0)(({message:o,elements:f})=>{f.length&&(this.z=this.z.then(()=>{const k=c;return p=null,this.U(f).then(()=>k())})),o&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const t=v?this.getExtensionElement(v):void 0;if(v&&!t)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let d=this.Q(v);return d||(d=await this.R(t)),d?d.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,t){t=t||{select:!0,focus:!1};const d=(0,w.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,w.isUndefinedOrNull)(t.focus)?!1:t.focus,u=(0,w.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(i=>this.P(v,i[i.length-1]).then(p=>this.D.$reveal(this.C,{item:p.item,parentChain:i.map(c=>c.item)},{select:d,focus:r,expand:u})),i=>this.G.error(i)):this.D.$reveal(this.C,void 0,{select:d,focus:r,expand:u})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=b.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,t){const d=this.getExtensionElement(v);d&&(t?this.r.fire(Object.freeze({element:d})):this.s.fire(Object.freeze({element:d})))}setSelection(v){(0,h.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const t=(await Promise.all(v.map(async d=>{const r=this.getExtensionElement(d.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?N.TreeItemCheckboxState.Checked:N.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(v,t,d){const r=[];for(const u of v){const i=this.getExtensionElement(u);i&&r.push(i)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,t,d){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,T.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,t){if(!this.f.resolveTreeItem)return;const d=this.i.get(v);if(d){const r=this.j.get(d);if(r){const u=await this.f.resolveTreeItem(r.extensionItem,d,t)??r.extensionItem;return this.db(u),r.item.tooltip=this.ab(u.tooltip),r.item.command=this.bb(r.disposableStore,u.command),r.item}}}N(v){return this.O(v).then(t=>t?this.N(t).then(d=>this.P(t,d[d.length-1]).then(r=>(d.push(r),d))):Promise.resolve([]))}O(v){const t=this.j.get(v);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,T.asPromise)(()=>this.f.getParent(v))}P(v,t){const d=this.j.get(v);return d?Promise.resolve(d):(0,T.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(r);if(u){const i=this.j.get(u);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let t;if(typeof v=="string"){const d=this.getExtensionElement(v);t=d?this.j.get(d):void 0}else t=v;return t&&t.children||void 0}return this.h}async R(v){this.nb(v);const t=new m.CancellationTokenSource(this.S.token);try{const d=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,h.coalesce)(r||[]).map(async i=>{const p=await this.f.getTreeItem(i);return p&&!t.token.isCancellationRequested?this.Z(i,p,d):null}));return t.token.isCancellationRequested?void 0:(0,h.coalesce)(u)}finally{t.dispose()}}U(v){if(v.some(d=>!d))return this.S.dispose(!0),this.S=new m.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const d=this.W(v);if(d.length)return this.X(d)}return Promise.resolve(void 0)}W(v){const t=new Set,d=v.map(u=>this.j.get(u));for(const u of d)if(u&&!t.has(u.item.handle)){let i=u;for(;i&&i.parent&&d.findIndex(p=>i&&i.parent&&p&&p.item.handle===i.parent.item.handle)===-1;){const p=this.i.get(i.parent.item.handle);i=p?this.j.get(p):void 0}i&&!i.parent&&t.add(u.item.handle)}const r=[];return t.forEach(u=>{const i=this.i.get(u);if(i){const p=this.j.get(i);p&&(!p.parent||!t.has(p.parent.item.handle))&&r.push(u)}}),r}X(v){const t={};return Promise.all(v.map(d=>this.Y(d).then(r=>{r&&(t[d]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(v){const t=this.getExtensionElement(v);if(t){const d=this.j.get(t);if(d)return this.nb(t),(0,T.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const u=this.eb(t,r,d.parent);return this.lb(t,u,d,d.parent),d.dispose(),u}return null})}return Promise.resolve(null)}Z(v,t,d){const r=this.eb(v,t,d);if(t.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,t.id));return this.kb(v,r),this.mb(r,d),r}ab(v){return N.MarkdownString.isMarkdownString(v)?b.MarkdownString.from(v):v}bb(v,t){return t?{...this.F.toInternal(t,v),originalId:t.command}:void 0}cb(v){if(!v.checkboxState)return;let t,d;return typeof v.checkboxState=="number"?t=v.checkboxState:(t=v.checkboxState.state,d=v.checkboxState.tooltip),{isChecked:t===N.TreeItemCheckboxState.Checked,tooltip:d}}db(v){if(!N.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,t,d){this.db(t);const r=new R.DisposableStore,u=this.gb(v,t,d),i=this.hb(t);return{item:{handle:u,parentHandle:d?d.item.handle:void 0,label:l(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:i,iconDark:this.ib(t)||i,themeIcon:this.fb(t),collapsibleState:(0,w.isUndefinedOrNull)(t.collapsibleState)?N.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof N.ThemeIcon?v.iconPath:void 0}gb(v,{id:t,label:d,resourceUri:r},u,i){if(t)return`${E.b}/${t}`;const p=l(d,this.H),c=u?u.item.handle:E.a;let o=p?p.label:r?(0,D.basename)(r):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const f=this.j.has(v)?this.j.get(v).item.handle:void 0,k=this.Q(u)||[];let A,V=0;do{if(A=`${c}/${V}:${o}`,i||!this.i.has(A)||f===A)break;V++}while(V<=k.length);return A}hb(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon))return typeof v.iconPath=="string"||M.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof N.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return M.URI.isUri(v)?v:M.URI.file(v)}kb(v,t){this.i.set(t.item.handle,v),this.j.set(v,t)}lb(v,t,d,r){this.i.delete(t.item.handle),this.j.delete(v),t.item.handle!==d.item.handle&&this.i.delete(d.item.handle),this.kb(v,t);const u=this.Q(r)||[],i=u.filter(p=>p.item.handle===d.item.handle)[0];i&&u.splice(u.indexOf(i),1,t)}mb(v,t){t?(t.children||(t.children=[]),t.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(v){const t=this.j.get(v);if(t){if(t.children)for(const d of t.children){const r=this.i.get(d.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}E.a="0",E.b="1"}),define(Ce[254],ke([1,0,20,12,4,29,2,130,263,118,128,43,5,73,207,206,37,208,32,210,211,212,195,213,57,33,214,215,218,219,221,105,198,227,228,229,80,60,232,253,8,7,52,235,61,104,31,187,217,50,103,107,109,110,11,55,18,26,222,193,69,76,204,233,81,59,238,236,237,205,36,230,234,79,58,74,223,106,224,15,92,197,178,216,6,27,183,78,174,225,226]),function(te,e,n,C,D,M,S,R,y,T,N,w,h,b,m,a,s,l,g,E,L,v,t,d,r,u,i,p,c,o,f,k,A,V,_,K,O,B,P,F,H,j,de,pe,re,ue,ae,se,Y,G,Z,he,Te,Ne,Ke,Pe,Se,Ie,oe,le,J,I,$,W,q,ee,me,ye,ce,be,Ee,We,Ve,tt,Xe,et,it,dt,Fe,ot,Q,X,ve,Me,ze,He,Ye,nt,vt,wt,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function jt(rt){const mt=rt.get(Ie.IExtHostInitDataService),Ft=rt.get(Ee.IExtHostFileSystemInfo),Gt=rt.get(ee.IExtHostConsumerFileSystem),Pt=rt.get(u.IExtHostExtensionService),ht=rt.get(ae.IExtHostWorkspace),kt=rt.get(et.IExtHostTelemetry),$t=rt.get(g.IExtHostConfiguration),Ot=rt.get(Pe.IURITransformerService),Ge=rt.get(Se.IExtHostRpcService),Nt=rt.get(O.IExtHostStorage),Mt=rt.get(q.IExtensionStoragePaths),zt=rt.get(Ke.ILoggerService),ft=rt.get(Ke.ILogService),De=rt.get(J.IExtHostTunnelService),Ae=rt.get(I.IExtHostApiDeprecationService),ge=rt.get(ue.IExtHostWindow),x=rt.get(tt.IExtHostSecretState),Re=rt.get(Xe.IExtHostEditorTabs);Ge.set(h.ExtHostContext.ExtHostFileSystemInfo,Ft),Ge.set(h.ExtHostContext.ExtHostLogLevelServiceShape,zt),Ge.set(h.ExtHostContext.ExtHostWorkspace,ht),Ge.set(h.ExtHostContext.ExtHostConfiguration,$t),Ge.set(h.ExtHostContext.ExtHostExtensionService,Pt),Ge.set(h.ExtHostContext.ExtHostStorage,Nt),Ge.set(h.ExtHostContext.ExtHostTunnelService,De),Ge.set(h.ExtHostContext.ExtHostWindow,ge),Ge.set(h.ExtHostContext.ExtHostSecretState,x),Ge.set(h.ExtHostContext.ExtHostTelemetry,kt),Ge.set(h.ExtHostContext.ExtHostEditorTabs,Re);const $e=Ge.set(h.ExtHostContext.ExtHostDecorations,rt.get(Z.IExtHostDecorations)),Qe=Ge.set(h.ExtHostContext.ExtHostDocumentsAndEditors,rt.get(r.IExtHostDocumentsAndEditors)),Be=Ge.set(h.ExtHostContext.ExtHostCommands,rt.get(s.IExtHostCommands)),Ze=Ge.set(h.ExtHostContext.ExtHostTerminalService,rt.get(B.IExtHostTerminalService)),ct=Ge.set(h.ExtHostContext.ExtHostDebugService,rt.get(Te.IExtHostDebugService)),Tt=Ge.set(h.ExtHostContext.ExtHostSearch,rt.get(Ne.IExtHostSearch)),bt=Ge.set(h.ExtHostContext.ExtHostTask,rt.get(he.IExtHostTask)),Et=Ge.set(h.ExtHostContext.ExtHostOutputService,rt.get(k.IExtHostOutputService)),It=Ge.set(h.ExtHostContext.ExtHostLocalization,rt.get(nt.IExtHostLocalizationService)),St=Ge.set(h.ExtHostContext.ExtHostUrls,new pe.ExtHostUrls(Ge)),yt=Ge.set(h.ExtHostContext.ExtHostDocuments,new d.ExtHostDocuments(Ge,Qe)),qt=Ge.set(h.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ge,Qe,ft)),Jt=Ge.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(ft,yt,Ge.getProxy(h.MainContext.MainThreadBulkEdits))),pt=Ge.set(h.ExtHostContext.ExtHostNotebook,new oe.ExtHostNotebookController(Ge,Be,Qe,yt)),si=Ge.set(h.ExtHostContext.ExtHostNotebookDocuments,new ve.ExtHostNotebookDocuments(pt)),oi=Ge.set(h.ExtHostContext.ExtHostNotebookEditors,new X.ExtHostNotebookEditors(ft,pt)),Zt=Ge.set(h.ExtHostContext.ExtHostNotebookKernels,new it.ExtHostNotebookKernels(Ge,mt,pt,Be,ft)),vi=Ge.set(h.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Ge,pt)),At=Ge.set(h.ExtHostContext.ExtHostEditors,new P.ExtHostEditors(Ge,Qe)),Wt=Ge.set(h.ExtHostContext.ExtHostTreeViews,new F.ExtHostTreeViews(Ge.getProxy(h.MainContext.MainThreadTreeViews),Be,ft)),bi=Ge.set(h.ExtHostContext.ExtHostEditorInsets,new se.ExtHostEditorInsets(Ge.getProxy(h.MainContext.MainThreadEditorInsets),At,mt.remote)),ai=Ge.set(h.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ge,ft,Ft,Qe)),ei=Ge.set(h.ExtHostContext.ExtHostLanguages,new o.ExtHostLanguages(Ge,yt,Be.converter,Ot)),ut=Ge.set(h.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ge,Ot,yt,Be,ai,ft,Ae,kt)),$i=Ge.set(h.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Ge,ut)),Ut=Ge.set(h.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Ge,ft,Qe)),Qt=Ge.set(h.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ge,ht,Be)),ci=Ge.set(h.ExtHostContext.ExtHostSCM,new _.ExtHostSCM(Ge,Be,ft)),Ei=Ge.set(h.ExtHostContext.ExtHostQuickDiff,new Ct.ExtHostQuickDiff(Ge,Ot)),wi=Ge.set(h.ExtHostContext.ExtHostComments,(0,l.createExtHostComments)(Ge,Be,yt)),ui=Ge.set(h.ExtHostContext.ExtHostProgress,new A.ExtHostProgress(Ge.getProxy(h.MainContext.MainThreadProgress))),Si=Ge.set(h.ExtHostContext.ExtHosLabelService,new Y.ExtHostLabelService(Ge)),li=Ge.set(h.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Ge)),ti=Ge.set(h.ExtHostContext.ExtHostAuthentication,new $.ExtHostAuthentication(Ge)),Bi=Ge.set(h.ExtHostContext.ExtHostTimeline,new W.ExtHostTimeline(Ge,Be)),ii=Ge.set(h.ExtHostContext.ExtHostWebviews,new re.ExtHostWebviews(Ge,mt.remote,ht,ft,Ae)),ni=Ge.set(h.ExtHostContext.ExtHostWebviewPanels,new ce.ExtHostWebviewPanels(Ge,ii,ht)),yi=Ge.set(h.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(Ge,yt,Mt,ii,ni)),Di=Ge.set(h.ExtHostContext.ExtHostWebviewViews,new me.ExtHostWebviewViews(Ge,ii)),ri=Ge.set(h.ExtHostContext.ExtHostTesting,new We.ExtHostTesting(Ge,Be,Qe)),Ii=Ge.set(h.ExtHostContext.ExtHostUriOpeners,new Ve.ExtHostUriOpeners(Ge)),Ci=Ge.set(h.ExtHostContext.ExtHostProfileContentHandlers,new wt.ExtHostProfileContentHandlers(Ge));Ge.set(h.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Ge,pt,Qe,Be,ft));const zi=Object.values(h.ExtHostContext);Ge.assertRegistered(zi);const Wi=new be.ExtHostBulkEdits(Ge,Qe),Hi=new a.ExtHostClipboard(Ge),ki=new f.ExtHostMessageService(Ge,ft),Ri=new L.ExtHostDialogs(Ge),Oi=new K.ExtHostStatusBar(Ge,Be.converter);return m.ExtHostApiCommands.register(Be),function(Ue,Ht,Li){const gt=function(){let ne=!Ue.isUnderDevelopment;function fe(){ne||(ft.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")fe();else{const Dt=st;typeof Dt.scheme>"u"&&fe(),typeof Dt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return st}}(),Vi={getSession(ne,fe,Oe){return ti.getSession(Ue,ne,fe,Oe)},async hasSession(ne,fe){return(0,He.checkProposedApiEnabled)(Ue,"authSession"),!!await ti.getSession(Ue,ne,fe,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(ne,fe,Oe,st){return ti.registerAuthenticationProvider(ne,fe,Oe,st)}},di={registerCommand(ne,fe,Oe){return Be.registerCommand(!0,ne,fe,Oe,void 0,Ue)},registerTextEditorCommand(ne,fe,Oe){return Be.registerCommand(!0,ne,(...st)=>{const Dt=At.getActiveTextEditor();if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}return Dt.edit(Rt=>{fe.apply(Oe,[Dt,Rt,...st])}).then(Rt=>{Rt||ft.warn("Edits from command "+ne+" were not applied.")},Rt=>{ft.warn("An error occurred while running command "+ne,Rt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ue,"diffCommand"),Be.registerCommand(!0,ne,async(...st)=>{const Dt=Qe.activeEditor(!0);if(!Dt){ft.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Dt.id);fe.apply(Oe,[Rt,...st])},void 0,void 0,Ue)),executeCommand(ne,...fe){return Be.executeCommand(ne,...fe)},getCommands(ne=!1){return Be.getCommands(ne)}},Fi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return Ze.getDefaultShell(!1)},get onDidChangeShell(){return(0,He.checkProposedApiEnabled)(Ue,"envShellEvent"),Ze.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ue,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Ue,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,et.isNewAppInstall)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne){return et.ExtHostTelemetryLogger.validateSender(ne),kt.instantiateLogger(Ue,ne)},openExternal(ne,fe){return ge.openUri(ne,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===mt.environment.appUriScheme)return St.createAppUri(ne);try{return await ge.asExternalUri(ne,{allowTunneling:!!mt.remote.authority})}catch(fe){if((0,Q.matchesScheme)(ne,ot.Schemas.http)||(0,Q.matchesScheme)(ne,ot.Schemas.https))return ne;throw fe}},get remoteName(){return(0,G.getRemoteName)(mt.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel}};mt.environment.extensionTestsLocationURI||Object.freeze(Fi);const ji={createTestController(ne,fe,Oe){return ri.createTestController(Ue,ne,fe,Oe)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ri.createTestObserver()},runTests(ne){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ri.runTests(ne)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ri.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Ue,"testObserver"),ri.results}},hi=mt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,qi={getExtension(ne,fe){(0,He.isProposedApiEnabled)(Ue,"extensionsAny")||(fe=!1);const Oe=Ht.mine.getExtensionDescription(ne);if(Oe)return new u.Extension(Pt,Ue.identifier,Oe,hi,!1);if(fe){const st=Ht.all.getExtensionDescription(ne);if(st)return new u.Extension(Pt,Ue.identifier,st,hi,!0)}},get all(){const ne=[];for(const fe of Ht.mine.getAllExtensionDescriptions())ne.push(new u.Extension(Pt,Ue.identifier,fe,hi,!1));return ne},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Ue,"extensionsAny");const ne=new He.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),fe=[];for(const Oe of Ht.all.getAllExtensionDescriptions()){const st=!ne.has(Oe.identifier);fe.push(new u.Extension(Pt,Ue.identifier,Oe,hi,st))}return fe},get onDidChange(){return(0,He.isProposedApiEnabled)(Ue,"extensionsAny")?D.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Ti={createDiagnosticCollection(ne){return ai.createDiagnosticCollection(Ue.identifier,ne)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ne=>ai.getDiagnostics(ne),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(ne,fe){return ei.changeLanguage(ne.uri,fe)},match(ne,fe){const Oe=yt.getDocumentData(fe.uri)?.notebook;return(0,N.score)(H.LanguageSelector.from(ne),fe.uri,fe.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ne,fe,Oe){return ut.registerCodeActionProvider(Ue,gt(ne),fe,Oe)},registerDocumentPasteEditProvider(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ue,"documentPaste"),ut.registerDocumentPasteEditProvider(Ue,gt(ne),fe,Oe)},registerCodeLensProvider(ne,fe){return ut.registerCodeLensProvider(Ue,gt(ne),fe)},registerDefinitionProvider(ne,fe){return ut.registerDefinitionProvider(Ue,gt(ne),fe)},registerDeclarationProvider(ne,fe){return ut.registerDeclarationProvider(Ue,gt(ne),fe)},registerImplementationProvider(ne,fe){return ut.registerImplementationProvider(Ue,gt(ne),fe)},registerTypeDefinitionProvider(ne,fe){return ut.registerTypeDefinitionProvider(Ue,gt(ne),fe)},registerHoverProvider(ne,fe){return ut.registerHoverProvider(Ue,gt(ne),fe,Ue.identifier)},registerEvaluatableExpressionProvider(ne,fe){return ut.registerEvaluatableExpressionProvider(Ue,gt(ne),fe,Ue.identifier)},registerInlineValuesProvider(ne,fe){return ut.registerInlineValuesProvider(Ue,gt(ne),fe,Ue.identifier)},registerDocumentHighlightProvider(ne,fe){return ut.registerDocumentHighlightProvider(Ue,gt(ne),fe)},registerLinkedEditingRangeProvider(ne,fe){return ut.registerLinkedEditingRangeProvider(Ue,gt(ne),fe)},registerReferenceProvider(ne,fe){return ut.registerReferenceProvider(Ue,gt(ne),fe)},registerRenameProvider(ne,fe){return ut.registerRenameProvider(Ue,gt(ne),fe)},registerDocumentSymbolProvider(ne,fe,Oe){return ut.registerDocumentSymbolProvider(Ue,gt(ne),fe,Oe)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ue,ne)},registerDocumentFormattingEditProvider(ne,fe){return ut.registerDocumentFormattingEditProvider(Ue,gt(ne),fe)},registerDocumentRangeFormattingEditProvider(ne,fe){return ut.registerDocumentRangeFormattingEditProvider(Ue,gt(ne),fe)},registerOnTypeFormattingEditProvider(ne,fe,Oe,...st){return ut.registerOnTypeFormattingEditProvider(Ue,gt(ne),fe,[Oe].concat(st))},registerDocumentSemanticTokensProvider(ne,fe,Oe){return ut.registerDocumentSemanticTokensProvider(Ue,gt(ne),fe,Oe)},registerDocumentRangeSemanticTokensProvider(ne,fe,Oe){return ut.registerDocumentRangeSemanticTokensProvider(Ue,gt(ne),fe,Oe)},registerSignatureHelpProvider(ne,fe,Oe,...st){return typeof Oe=="object"?ut.registerSignatureHelpProvider(Ue,gt(ne),fe,Oe):ut.registerSignatureHelpProvider(Ue,gt(ne),fe,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(ne,fe,...Oe){return ut.registerCompletionItemProvider(Ue,gt(ne),fe,Oe)},registerInlineCompletionItemProvider(ne,fe){return fe.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,He.checkProposedApiEnabled)(Ue,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Ue,gt(ne),fe)},registerDocumentLinkProvider(ne,fe){return ut.registerDocumentLinkProvider(Ue,gt(ne),fe)},registerColorProvider(ne,fe){return ut.registerColorProvider(Ue,gt(ne),fe)},registerFoldingRangeProvider(ne,fe){return ut.registerFoldingRangeProvider(Ue,gt(ne),fe)},registerSelectionRangeProvider(ne,fe){return ut.registerSelectionRangeProvider(Ue,ne,fe)},registerCallHierarchyProvider(ne,fe){return ut.registerCallHierarchyProvider(Ue,ne,fe)},registerTypeHierarchyProvider(ne,fe){return ut.registerTypeHierarchyProvider(Ue,ne,fe)},setLanguageConfiguration:(ne,fe)=>ut.setLanguageConfiguration(Ue,ne,fe),getTokenInformationAtPosition(ne,fe){return(0,He.checkProposedApiEnabled)(Ue,"tokenInformation"),ei.tokenAtPosition(ne,fe)},registerInlayHintsProvider(ne,fe){return ut.registerInlayHintsProvider(Ue,ne,fe)},createLanguageStatusItem(ne,fe){return ei.createLanguageStatusItem(Ue,ne,fe)},registerDocumentDropEditProvider(ne,fe){return ut.registerDocumentOnDropEditProvider(Ue,ne,fe)}},Ki={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ze.activeTerminal},get terminals(){return Ze.terminals},async showTextDocument(ne,fe,Oe){const st=await(S.URI.isUri(ne)?Promise.resolve(Kt.openTextDocument(ne)):Promise.resolve(ne));return At.showTextDocument(st,fe,Oe)},createTextEditorDecorationType(ne){return At.createTextEditorDecorationType(Ue,ne)},onDidChangeActiveTextEditor(ne,fe,Oe){return At.onDidChangeActiveTextEditor(ne,fe,Oe)},onDidChangeVisibleTextEditors(ne,fe,Oe){return At.onDidChangeVisibleTextEditors(ne,fe,Oe)},onDidChangeTextEditorSelection(ne,fe,Oe){return At.onDidChangeTextEditorSelection(ne,fe,Oe)},onDidChangeTextEditorOptions(ne,fe,Oe){return At.onDidChangeTextEditorOptions(ne,fe,Oe)},onDidChangeTextEditorVisibleRanges(ne,fe,Oe){return At.onDidChangeTextEditorVisibleRanges(ne,fe,Oe)},onDidChangeTextEditorViewColumn(ne,fe,Oe){return At.onDidChangeTextEditorViewColumn(ne,fe,Oe)},onDidCloseTerminal(ne,fe,Oe){return Ze.onDidCloseTerminal(ne,fe,Oe)},onDidOpenTerminal(ne,fe,Oe){return Ze.onDidOpenTerminal(ne,fe,Oe)},onDidChangeActiveTerminal(ne,fe,Oe){return Ze.onDidChangeActiveTerminal(ne,fe,Oe)},onDidChangeTerminalDimensions(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ue,"terminalDimensions"),Ze.onDidChangeTerminalDimensions(ne,fe,Oe)},onDidChangeTerminalState(ne,fe,Oe){return Ze.onDidChangeTerminalState(ne,fe,Oe)},onDidWriteTerminalData(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),Ze.onDidWriteTerminalData(ne,fe,Oe)},get state(){return ge.state},onDidChangeWindowState(ne,fe,Oe){return ge.onDidChangeWindowState(ne,fe,Oe)},showInformationMessage(ne,...fe){return ki.showMessage(Ue,M.default.Info,ne,fe[0],fe.slice(1))},showWarningMessage(ne,...fe){return ki.showMessage(Ue,M.default.Warning,ne,fe[0],fe.slice(1))},showErrorMessage(ne,...fe){return ki.showMessage(Ue,M.default.Error,ne,fe[0],fe.slice(1))},showQuickPick(ne,fe,Oe){return Qt.showQuickPick(ne,fe,Oe)},showWorkspaceFolderPick(ne){return Qt.showWorkspaceFolderPick(ne)},showInputBox(ne,fe){return Qt.showInput(ne,fe)},showOpenDialog(ne){return Ri.showOpenDialog(ne)},showSaveDialog(ne){return Ri.showSaveDialog(ne)},createStatusBarItem(ne,fe,Oe){let st,Dt,Rt;return typeof ne=="string"?(st=ne,Dt=fe,Rt=Oe):(Dt=ne,Rt=fe),Oi.createStatusBarEntry(Ue,st,Dt,Rt)},setStatusBarMessage(ne,fe){return Oi.setStatusBarMessage(ne,fe)},withScmProgress(ne){return Ae.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ui.withProgress(Ue,{location:j.ProgressLocation.SourceControl},(fe,Oe)=>ne({report(st){}}))},withProgress(ne,fe){return ui.withProgress(Ue,ne,fe)},createOutputChannel(ne,fe){return Et.createOutputChannel(ne,fe,Ue)},createWebviewPanel(ne,fe,Oe,st){return ni.createWebviewPanel(Ue,ne,fe,Oe,st)},createWebviewTextEditorInset(ne,fe,Oe,st){return(0,He.checkProposedApiEnabled)(Ue,"editorInsets"),bi.createWebviewEditorInset(ne,fe,Oe,st,Ue)},createTerminal(ne,fe,Oe){return typeof ne=="object"?"pty"in ne?Ze.createExtensionTerminal(ne):Ze.createTerminalFromOptions(ne):Ze.createTerminal(ne,fe,Oe)},registerTerminalLinkProvider(ne){return Ze.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,fe){return Ze.registerProfileProvider(Ue,ne,fe)},registerTerminalQuickFixProvider(ne,fe){return(0,He.checkProposedApiEnabled)(Ue,"terminalQuickFixProvider"),Ze.registerTerminalQuickFixProvider(ne,Ue.identifier.value,fe)},registerTreeDataProvider(ne,fe){return Wt.registerTreeDataProvider(ne,fe,Ue)},createTreeView(ne,fe){return Wt.createTreeView(ne,fe,Ue)},registerWebviewPanelSerializer:(ne,fe)=>ni.registerWebviewPanelSerializer(Ue,ne,fe),registerCustomEditorProvider:(ne,fe,Oe={})=>yi.registerCustomEditorProvider(Ue,ne,fe,Oe),registerFileDecorationProvider(ne){return $e.registerFileDecorationProvider(ne,Ue)},registerUriHandler(ne){return St.registerUriHandler(Ue.identifier,ne)},createQuickPick(){return Qt.createQuickPick(Ue)},createInputBox(){return Qt.createInputBox(Ue)},get activeColorTheme(){return li.activeColorTheme},onDidChangeActiveColorTheme(ne,fe,Oe){return li.onDidChangeActiveColorTheme(ne,fe,Oe)},registerWebviewViewProvider(ne,fe,Oe){return Di.registerWebviewViewProvider(Ue,ne,fe,Oe?.webviewOptions)},get activeNotebookEditor(){return pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,fe,Oe){return pt.onDidChangeActiveNotebookEditor(ne,fe,Oe)},get visibleNotebookEditors(){return pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,fe,Oe){return oi.onDidChangeNotebookEditorSelection(ne,fe,Oe)},onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe){return oi.onDidChangeNotebookEditorVisibleRanges(ne,fe,Oe)},showNotebookDocument(ne,fe){return pt.showNotebookDocument(ne,fe)},registerExternalUriOpener(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ue,"externalUriOpener"),Ii.registerExternalUriOpener(Ue.identifier,ne,fe,Oe)},registerProfileContentHandler(ne,fe){return(0,He.checkProposedApiEnabled)(Ue,"profileContentHandlers"),Ci.registrProfileContentHandler(Ue,ne,fe)},registerQuickDiffProvider(ne,fe,Oe,st){return(0,He.checkProposedApiEnabled)(Ue,"quickDiffProvider"),Ei.registerQuickDiffProvider(gt(ne),fe,Oe,st)},get tabGroups(){return Re.tabGroups}},Kt={get rootPath(){return Ae.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(ne){throw C.readonly()},getWorkspaceFolder(ne){return ht.getWorkspaceFolder(ne)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(ne){throw C.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(ne){throw C.readonly()},updateWorkspaceFolders:(ne,fe,...Oe)=>ht.updateWorkspaceFolders(Ue,ne,fe||0,...Oe),onDidChangeWorkspaceFolders:function(ne,fe,Oe){return ht.onDidChangeWorkspace(ne,fe,Oe)},asRelativePath:(ne,fe)=>ht.getRelativePath(ne,fe),findFiles:(ne,fe,Oe,st)=>ht.findFiles(ne,fe,Oe,Ue.identifier,st),findTextInFiles:(ne,fe,Oe,st)=>{(0,He.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Rt;return typeof fe=="object"?(Dt=fe,Rt=Oe):(Dt={},Rt=fe,st=Oe),ht.findTextInFiles(ne,Dt||{},Rt,Ue.identifier,st)},saveAll:ne=>ht.saveAll(ne),applyEdit(ne,fe){return Wi.applyWorkspaceEdit(ne,Ue,fe)},createFileSystemWatcher:(ne,fe,Oe,st)=>Ut.createFileSystemWatcher(ht,Ue,ne,fe,Oe,st),get textDocuments(){return yt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw C.readonly()},openTextDocument(ne){let fe;const Oe=ne;if(typeof ne=="string")fe=Promise.resolve(S.URI.file(ne));else if(S.URI.isUri(ne))fe=Promise.resolve(ne);else if(!Oe||typeof Oe=="object")fe=yt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(st=>yt.ensureDocumentData(st).then(Dt=>Dt.document))},onDidOpenTextDocument:(ne,fe,Oe)=>yt.onDidAddDocument(ne,fe,Oe),onDidCloseTextDocument:(ne,fe,Oe)=>yt.onDidRemoveDocument(ne,fe,Oe),onDidChangeTextDocument:(ne,fe,Oe)=>yt.onDidChangeDocument(ne,fe,Oe),onDidSaveTextDocument:(ne,fe,Oe)=>yt.onDidSaveDocument(ne,fe,Oe),onWillSaveTextDocument:(ne,fe,Oe)=>Jt.getOnWillSaveTextDocumentEvent(Ue)(ne,fe,Oe),get notebookDocuments(){return pt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,fe){let Oe;if(S.URI.isUri(ne))Oe=ne,await pt.openNotebookDocument(ne);else if(typeof ne=="string")Oe=S.URI.revive(await pt.createNotebookDocument({viewType:ne,content:fe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ne,fe,Oe){return si.onDidSaveNotebookDocument(ne,fe,Oe)},onDidChangeNotebookDocument(ne,fe,Oe){return si.onDidChangeNotebookDocument(ne,fe,Oe)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ne,fe,Oe,st){return pt.registerNotebookSerializer(Ue,ne,fe,Oe,(0,He.isProposedApiEnabled)(Ue,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(ne,fe,Oe)=>Li.onDidChangeConfiguration(ne,fe,Oe),getConfiguration(ne,fe){return fe=arguments.length===1?void 0:fe,Li.getConfiguration(ne,fe,Ue)},registerTextDocumentContentProvider(ne,fe){return qt.registerTextDocumentContentProvider(ne,fe)},registerTaskProvider:(ne,fe)=>(Ae.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Ue,ne,fe)),registerFileSystemProvider(ne,fe,Oe){return(0,ze.combinedDisposable)($i.registerFileSystemProvider(Ue,ne,fe,Oe),Gt.addFileSystemProvider(ne,fe))},get fs(){return Gt.value},registerFileSearchProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Tt.registerFileSearchProvider(ne,fe)),registerTextSearchProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"textSearchProvider"),Tt.registerTextSearchProvider(ne,fe)),registerRemoteAuthorityResolver:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"resolvers"),Pt.registerRemoteAuthorityResolver(ne,fe)),registerResourceLabelFormatter:ne=>((0,He.checkProposedApiEnabled)(Ue,"resolvers"),Si.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,fe,Oe)=>Ut.onDidCreateFile(ne,fe,Oe),onDidDeleteFiles:(ne,fe,Oe)=>Ut.onDidDeleteFile(ne,fe,Oe),onDidRenameFiles:(ne,fe,Oe)=>Ut.onDidRenameFile(ne,fe,Oe),onWillCreateFiles:(ne,fe,Oe)=>Ut.getOnWillCreateFileEvent(Ue)(ne,fe,Oe),onWillDeleteFiles:(ne,fe,Oe)=>Ut.getOnWillDeleteFileEvent(Ue)(ne,fe,Oe),onWillRenameFiles:(ne,fe,Oe)=>Ut.getOnWillRenameFileEvent(Ue)(ne,fe,Oe),openTunnel:ne=>((0,He.checkProposedApiEnabled)(Ue,"tunnels"),De.openTunnel(Ue,ne).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,He.checkProposedApiEnabled)(Ue,"tunnels"),De.getTunnels()},onDidChangeTunnels:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ue,"tunnels"),De.onDidChangeTunnels(ne,fe,Oe)),registerPortAttributesProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"portsAttributes"),De.registerPortsAttributesProvider(ne,fe)),registerTimelineProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"timeline"),Bi.registerTimelineProvider(ne,fe,Ue.identifier,Be.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:ne=>((0,He.checkProposedApiEnabled)(Ue,"workspaceTrust"),ht.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,fe,Oe)=>ht.onDidGrantWorkspaceTrust(ne,fe,Oe),registerEditSessionIdentityProvider:(ne,fe)=>((0,He.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(ne,fe)),onWillCreateEditSessionIdentity:(ne,fe,Oe)=>((0,He.checkProposedApiEnabled)(Ue,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Ue)(ne,fe,Oe))},fi={get inputBox(){return Ae.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox(Ue)},createSourceControl(ne,fe,Oe){return ci.createSourceControl(Ue,ne,fe,Oe)}},xi={createCommentController(ne,fe){return wi.createCommentController(Ue,ne,fe)}},Bt={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(ne,fe,Oe){return ct.onDidStartDebugSession(ne,fe,Oe)},onDidTerminateDebugSession(ne,fe,Oe){return ct.onDidTerminateDebugSession(ne,fe,Oe)},onDidChangeActiveDebugSession(ne,fe,Oe){return ct.onDidChangeActiveDebugSession(ne,fe,Oe)},onDidReceiveDebugSessionCustomEvent(ne,fe,Oe){return ct.onDidReceiveDebugSessionCustomEvent(ne,fe,Oe)},onDidChangeBreakpoints(ne,fe,Oe){return ct.onDidChangeBreakpoints(ne,fe,Oe)},registerDebugConfigurationProvider(ne,fe,Oe){return ct.registerDebugConfigurationProvider(ne,fe,Oe||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,fe){return ct.registerDebugAdapterDescriptorFactory(Ue,ne,fe)},registerDebugAdapterTrackerFactory(ne,fe){return ct.registerDebugAdapterTrackerFactory(ne,fe)},startDebugging(ne,fe,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ct.startDebugging(ne,fe,{parentSession:Oe}):ct.startDebugging(ne,fe,Oe||{})},stopDebugging(ne){return ct.stopDebugging(ne)},addBreakpoints(ne){return ct.addBreakpoints(ne)},removeBreakpoints(ne){return ct.removeBreakpoints(ne)},asDebugSourceUri(ne,fe){return ct.asDebugSourceUri(ne,fe)}},mi={registerTaskProvider:(ne,fe)=>bt.registerTaskProvider(Ue,ne,fe),fetchTasks:ne=>bt.fetchTasks(ne),executeTask:ne=>bt.executeTask(Ue,ne),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(ne,fe,Oe)=>bt.onDidStartTask(ne,fe,Oe),onDidEndTask:(ne,fe,Oe)=>bt.onDidEndTask(ne,fe,Oe),onDidStartTaskProcess:(ne,fe,Oe)=>bt.onDidStartTaskProcess(ne,fe,Oe),onDidEndTaskProcess:(ne,fe,Oe)=>bt.onDidEndTaskProcess(ne,fe,Oe)},Gi={createNotebookController(ne,fe,Oe,st,Dt){return Zt.createNotebookController(Ue,ne,fe,Oe,st,(0,He.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,fe)=>pt.registerNotebookCellStatusBarItemProvider(Ue,ne,fe),createRendererMessaging(ne){return vi.createRendererMessaging(Ue,ne)},createNotebookControllerDetectionTask(ne){return(0,He.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.createNotebookControllerDetectionTask(Ue,ne)},registerKernelSourceActionProvider(ne,fe){return(0,He.checkProposedApiEnabled)(Ue,"notebookKernelSource"),Zt.registerKernelSourceActionProvider(Ue,ne,fe)},onDidChangeNotebookCellExecutionState(ne,fe,Oe){return(0,He.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),Zt.onDidChangeNotebookCellExecutionState(ne,fe,Oe)}},Xi={t(...ne){if(typeof ne[0]=="string"){const fe=ne.shift(),Oe=!ne||typeof ne[0]!="object"?ne:ne[0];return It.getMessage(Ue.identifier.value,{message:fe,args:Oe})}return It.getMessage(Ue.identifier.value,ne[0])},get bundle(){return It.getBundle(Ue.identifier.value)},get uri(){return It.getBundleUri(Ue.identifier.value)}};return{version:mt.version,authentication:Vi,commands:di,comments:xi,debug:Bt,env:Fi,extensions:qi,l10n:Xi,languages:Ti,notebooks:Gi,scm:fi,tasks:mi,tests:ji,window:Ki,workspace:Kt,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:C.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:T.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:R.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:b.UIKind,Uri:S.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:dt.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:de.TelemetryTrustedValue,LogLevel:Ke.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=jt}),define(Ce[255],ke([1,0,254,33,2,248,7,17,239]),function(te,e,n,C,D,M,S,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends M.RequireInterceptor{j(){}getModule(b,m){for(const a of this.b){const s=a(b);if(s){b=s;break}}if(this.a.has(b))return this.a.get(b).load(b,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends C.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=S.ExtensionRuntime.Webworker}async nb(){this.h.createInstance(y.ExtHostConsoleForwarder);const b=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(T,b,{mine:this.D,all:this.F}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.tb()}ob(b){return b.browser}async pb(b,m,a){m=m.with({path:w(m.path,".js")});const s=b?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const l=D.URI.revive(await this.v.$asBrowserUri(m)),g=await fetch(l.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),g.status!==200)throw new Error(g.statusText);const E=await g.text(),L=`${m.toString(!0)}#vscode-extension`,v=`${E}
//# sourceURL=${L}`;let t;try{t=new Function("module","exports","require",v)}catch(i){throw console.error(s?`Loading code for extension ${s} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${m.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}b&&await this.s.initializeLocalizedMessages(b);const d={},r={exports:d},u=i=>{const p=this.r.getModule(i,m);if(p===void 0)throw new Error(`Cannot load module '${i}'`);return p};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),t(r,d,u),r.exports!==d?r.exports:d}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment(b){}async tb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+b;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=N;function w(h,b){return h.endsWith(b)?h:h+b}}),define(Ce[256],ke([1,0,66,33,81,255]),function(te,e,n,C,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(C.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,n.registerSingleton)(D.IExtensionStoragePaths,D.ExtensionStoragePaths,0)}),define(Ce[264],ke([1,0,23,4,73,249,241,19,82,15,2,251,256]),function(te,e,n,C,D,M,S,R,y,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(t){return/^(file|vscode-remote):/i.test(t)}const m=fetch.bind(self);function a(t){self.fetch=async function(d,r){return d instanceof Request||b(String(d))&&(d=(await t(N.URI.parse(String(d)))).toString(!0)),m(d,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(d,r,u,i,p){(async()=>(b(r.toString())&&(r=(await t(N.URI.parse(r.toString()))).toString(!0)),super.open(d,r,u??!0,i,p)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(d,r){if(/^file:/i.test(d.toString()))d=T.FileAccess.uriToBrowserUri(N.URI.parse(d.toString())).toString(!0);else if(/^vscode-remote:/i.test(d.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const i=`(${function(f){function k(_){return typeof _=="string"||_ instanceof URL?String(_).replace(/^file:\/\//i,"vscode-file://vscode-app"):_}const A=fetch.bind(self);self.fetch=function(_,K){return _ instanceof Request?A(_,K):A(k(_),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(_,K,O,B,P){return super.open(_,k(K),O??!0,B,P)}};const V=importScripts.bind(self);self.importScripts=(..._)=>{V(..._.map(k))},V(f)}.toString()}('${d}'))`;r=r||{},r.name=r.name||R.basename(d.toString());const p=new Blob([i],{type:"application/javascript"}),c=URL.createObjectURL(p);return new t(c,r)}}else self.Worker=class extends S.NestedWorker{constructor(t,d){super(h,t,{name:R.basename(t.toString()),...d})}};const s=new class{constructor(){this.pid=void 0}exit(t){w()}async exists(t){return!0}async realpath(t){return t}};class l{constructor(){const d=new MessageChannel,r=new C.Emitter;let u=!1;h(d.port2,[d.port2]),d.port1.onmessage=i=>{const{data:p}=i;if(!(p instanceof ArrayBuffer)){console.warn("UNKNOWN data received",p);return}const c=n.VSBuffer.wrap(new Uint8Array(p,0,p.byteLength));if((0,D.isMessageOfType)(c,2)){u=!0,E("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:i=>{if(!u){const p=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);d.port1.postMessage(p,[p])}}}}}function g(t){return new Promise(d=>{const r=t.onMessage(u=>{r.dispose();const i=JSON.parse(u.toString());t.send((0,D.createMessageOfType)(0)),d({protocol:t,initData:i})});t.send((0,D.createMessageOfType)(1))})}let E=t=>w();function L(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const t=new l;return{onmessage(d){!L(d)||g(t.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const u=new M.ExtensionHostMain(r.protocol,r.initData,s,null,d.data);a(i=>u.asBrowserUri(i)),E=i=>u.terminate(i)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/18db596fd684939b60ae47f4068d74ffc42ad729/core/vs/workbench/api/worker/extensionHostWorker.js.map
